<?php
class AlertsViewController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation');
	var $layout='';
	function index($type=null)
	{
		if(!isset($type)){
			$css = "/lv/css/text.css";
		}else{
			$css = "../../css/text.css";
		}
		$this->set('css',$css);
		//xinw start 20080703
		if(!empty($this->data['date']['time'])){
			$this->set('showtime',$this->data['date']['time']);
		}else{			
			if(!empty($_POST['param'])){
				$this->set('showtime',date("Y/m/d H:i:s"));
				session_unregister('alert_viewtime');
				$_SESSION['alert_viewtime'] = date("Y/m/d H:i:s");
			}else{
				$this->set('showtime',$_SESSION['alert_viewtime']);
			}
		}
		//xinw end 20080703
		//$string = $_SERVER['QUERY_STRING'];

		//$flag = trim(str_replace('%20',' ',substr($string,17,1)));
		if(isset($_POST['param']) && $_POST['param']){
			session_unregister('tm');
			session_unregister('url');
			//$sql_str = str_replace('%20',' ',substr($string,17));
		}
		$sql_str = trim($_POST['param']);
		$gp = trim($_POST['param1']);

		$glist = array();
		for($i=1;$i<=60;$i++){
			$glist[]=$i;
		}
		//$glist = array('60000'=>'1','120000'=>'2','180000'=>'3','240000'=>'4','300000'=>'5','360000'=>'6','420000'=>'7','480000'=>'8','540000'=>'9','600000'=>'10','660000'=>'11','180000'=>'12','180000'=>'3','180000'=>'3','180000'=>'3','180000'=>'3','180000'=>'3','180000'=>'3','180000'=>'3','180000'=>'3','180000'=>'3');
		$this->set('glist',$glist);
		if(isset($this->data['User']['ReloadTime']) && $_SESSION['tm']!=($this->data['User']['ReloadTime']+1)*60000){
			$_SESSION['tm'] = ($this->data['User']['ReloadTime']+1)*60000;
		}
		//echo $_SESSION['tm'].'---------'.($this->data['User']['ReloadTime']+1)*60000;
		if(!empty($sql_str) && $_SESSION['url']!=$sql_str){
			//echo '11111111';
			$_SESSION['url'] = $sql_str;
			$_SESSION['gp'] = $gp;
		}

		$asso = array('Host : hosts' => array('Hstalt.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'));

		$order = 'Hstalt.alert_time DESC';
		$gpid_arr = $this->Grpauth->getChildren($_SESSION['gp']);
		$gpid = "";
		foreach ($gpid_arr as $va){
			$gpid .= $va['Child']['id'].' ';
		}
		$gpid = str_replace(' ',',',trim($gpid));
		$criteria = array();
		$criteria[] = "Group.id in (".$gpid.")";
		$criteria[] = $_SESSION['url'];
		//xinw start 20080703
		$criteria[] = "alert_time >= '".$_SESSION['alert_viewtime']."'";
		//xinw end 20080703
		$data = $this->Hstalt->findByAsso($criteria, array('Hstalt.alert_time', 'Group.group_name','Host.host_name', 'Hstalt.alert_type_id','Hstalt.alert_content'), $order, 100, null, $asso);

		$this->set('data',$data);
		$this->set('sql',$sql_str);

	}
}
?>