<?php
/*********************************************************************
*@filename assets_apps_controller.php
*@description
*@note
*@histories  rivision	author		date		comment
*			 1.0		xinw	    2008/11/05  modify for LV20R1-176
*		2.0		sunhy	    2009/07/07  added for LV20R1-192
********************************************************************/
class AssetsAppsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Group', 'Host','Rlthstgrp','Rltgrpapp','Grpapp','Installation','Grpauth','Configure','Astsfw','Validation');
	var $layout='assets';

	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function _getUserGroup_id(){
		//return 2;
		return $this->_getUserGroup();
	}
	function index()
	{
		$title = __('menu_assets',$return = true)."/".__('app_point',$return = true);
		$this->pageTitle = $title;
		$group_id = $this->_getUserGroup_id();
		$glist = $this->Group->getChildrenByParent($group_id);
		//ksort($glist);
		$this->set('glist',$glist);

		$glist_grpapp = $this->Grpapp->generateList( array('group_id' =>$group_id) , null, null, '{n}.Grpapp.id', '{n}.Grpapp.app_name');
		$glist_grpapp[0] =  __('whole',$return = true);
		ksort($glist_grpapp);

		$this->set('glist_grpapp',$glist_grpapp);
		//$contro= $this->requestAction('/assets_apps/contro',array('return'));
		//$this->set('contro',$contro);

	}

	function csvdown($array_app=null,$array_install=null,$data_group_host=null,$array_install_null=null,$array_install_id=null,$type)
	{
		require_once( 'csv/DlFactory.php' );
		//debug($array_install);
		if($type == 1) {
			//debug($array_app);
			//debug($array_install);
			//debug($data_group_host);


			$this_groups =$this->data["Astsfw"]["group"];
			$this->data["Astsfw"]["group"] = $this->groupName($this_groups);
			$this_app =$this->data["Grpapp"]["group_grp"];
			if($this_app != 0){
				$this->data["Grpapp"]["group_grp"] = $this->_getGrpappName($this_app);
			}else{
				$this->data["Grpapp"]["group_grp"] = __('whole',$return = true);
			}


			$csv = DlFactory::create("assets_apps");
			//debug($csv);

			$array = array(
			"Group/group_name"  =>__('group name',$return = true),
			"Host/host_name" => __('client',$return = true),
			);
			foreach ($array_install as $key => $output){
				//list($name,$id) = explode(",", $key);
				$id =$array_install_id[$key];
				$n = "Grpapp/app_name_".$id;
				$array[$n]=$key;
			}
			if(!empty($array_install_null)){
				foreach ($array_install_null as $key1 => $output1){
					$n = "Grpapp/app_name_".$key1;
					$array[$n]=$output1;
				}
			}
			// debug($array);
			$csv->special_cols=$array;
			// debug($csv->special_cols);

			$i = 0;
			$result_app =  array();
			foreach ($data_group_host as $key1 => $data_group_host1){
				$result_app[$i]["Group"]["group_name"] = $data_group_host1["Group"]["group_name"];
				$result_app[$i]["Host"]["host_name"] = $data_group_host1["Host"]["host_name"];
				if(!empty($array_install)){ //debug($array_install);
					foreach ($array_install as $key2 => $output){
						$id =$array_install_id[$key2];
						$n = "app_name_".$id;
						$m = 0;
						foreach ($output as $key3 => $output1){//debug($output1);
							if(($output1[2] == '*')&&($output1[3] == '*')){//echo "check 11<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									foreach ($app_res as $key => $v){
										if($output1[1] == $v[1] ){
											$m++ ;
										}
									}
								}
							}elseif(($output1[2] == '*')&&($output1[3] != '*')){ //echo "check 11  33<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[3] == $v[3])){
											$m++ ;
										}
									}
								}
							}elseif(($output1[2] != '*')&&($output1[3] == '*')){ //echo "check 11  22<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[2] == $v[2])){
											$m++ ;
										}
									}
								}
							}else{
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[3] == $v[3])&&($output1[2] == $v[2])){
											$m++ ;
										}
									}
								}

							}

						}
						if($m > 0){
							$result_app[$i]["Grpapp"][$n] ="○";
						}else{
							$result_app[$i]["Grpapp"][$n]=null;
						}
					}
				}
				if(!empty($array_install_null)){
					foreach ($array_install_null as $key3 => $output3){
						$m = "app_name_".$key3;
						$out=null;
						$result_app[$i]["Grpapp"][$m] = $out;
					}
				}
				$i++;
			}
			//debug($result_app);
			$csv->sendCSVFile($result_app,$this->data,__('app_point_show',$return = true));
		}elseif($type == 2){
			//debug($array_app);
			//debug($array_install);
			//debug($data_group_host);

			$this_groups =$this->data["Astsfw"]["group"];
			$this->data["Astsfw"]["group"] = $this->groupName($this_groups);
			$this_app =$this->data["Grpapp"]["group_grp"];
			if($this_app != 0){
				$this->data["Grpapp"]["group_grp"] = $this->_getGrpappName($this_app);
			}else{
				$this->data["Grpapp"]["group_grp"] =__('whole',$return = true);
			}


			$csv = DlFactory::create("assets_app_twos");
			//debug($csv);

			$array = array(
			"Group/group_name"  => __('group name',$return = true),
			"Host/host_name" => __('client',$return = true),
			);
			foreach ($array_install as $key => $output){
				//debug($output);
				foreach ($output as $key1=>$v){
					$n = "Grpapp/app_name_".$key1;
					$array[$n]=$v[0];
				}
			}
			//debug($array);
			$csv->special_cols=$array;
			//debug($csv->special_cols);

			$i = 0;
			$result_app =  array();
			if(!empty($data_group_host)){
				foreach ($data_group_host as $key1 => $data_group_host1){
					$result_app[$i]["Group"]["group_name"] = $data_group_host1["Group"]["group_name"];
					$result_app[$i]["Host"]["host_name"] = $data_group_host1["Host"]["host_name"];
					if(!empty($array_install)){ //debug($array_install);
						foreach ($array_install as $key2 => $output){
							//debug($output);
							foreach ($output as $key3 => $output1){
								$n = "app_name_".$key3;
								$m = 0;//echo $i."<br>";
								if(($output1[2] == '*')&&($output1[3] == '*')){
									//xinw start 20081105
									//modify for LV20R1-176
									//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
									if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
										//xinw end 20081105
										//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
										foreach ($app_res as $key => $v){
											if($output1[1] == $v[1] ){
												$m++ ;
											}
										}
										if($m > 0) {
											$out="○";
											$result_app[$i]["Grpapp"][$n] = $out;
										}else{
											$out=null;
											$result_app[$i]["Grpapp"][$n] = $out;
										}
									}else{
										$out=null;
										$result_app[$i]["Grpapp"][$n] = $out;
									}
								}elseif(($output1[2] == '*')&&($output1[3] != '*')){ //echo "check 11  33<br>";
									//xinw start 20081105
									//modify for LV20R1-176
									//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
									if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
										//xinw end 20081105
										//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
										foreach ($app_res as $key => $v){
											if(($output1[1] == $v[1])&&($output1[3] == $v[3])){
												$m++ ;
											}
										}
										if($m > 0) {
											$out="○";
											$result_app[$i]["Grpapp"][$n] = $out;
										}else{
											$out=null;
											$result_app[$i]["Grpapp"][$n] = $out;
										}
									}else{
										$out=null;
										$result_app[$i]["Grpapp"][$n] = $out;
									}
								}elseif(($output1[2] != '*')&&($output1[3] == '*')){ //echo "check 11  22<br>";
									//xinw start 20081105
									//modify for LV20R1-176
									//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
									if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
										//xinw end 20081105
										//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
										foreach ($app_res as $key => $v){
											if(($output1[1] == $v[1])&&($output1[2] == $v[2])){
												$m++ ;
											}
										}
										if($m > 0) {
											$out="○";
											$result_app[$i]["Grpapp"][$n] = $out;
										}else{
											$out=null;
											$result_app[$i]["Grpapp"][$n] = $out;
										}
									}else{
										$out=null;
										$result_app[$i]["Grpapp"][$n] = $out;
									}
								}else{
									//xinw start 20081105
									//modify for LV20R1-176
									//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
									if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
										//xinw end 20081105
										//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
										foreach ($app_res as $key => $v){
											if(($output1[1] == $v[1])&&($output1[3] == $v[3])&&($output1[2] == $v[2])){
												$m++ ;
											}
										}
										if($m > 0) {
											$out="○";
											$result_app[$i]["Grpapp"][$n] = $out;
										}else{
											$out=null;
											$result_app[$i]["Grpapp"][$n] = $out;
										}
									}else{
										$out=null;
										$result_app[$i]["Grpapp"][$n] = $out;
									}
								}

							}
						}


					}$i++;
				}
			}

			//debug($result_app);

			$csv->sendCSVFile($result_app,$this->data, __('app_point_show',$return = true));
			exit;
		}



	}

	function contro($url=null,$search=null,$type=null)
	{
		$this->layout='ajax';
		$criteria = array();
		// $by_kw = $this->Lv->operSearch();
		if(!isset($this->data['Host']['hostname'])){
			$this->data['Host']['hostname']="";
		}
		if(isset($this->data['Host']['hostname_ck'])){
			$hostname_ck = $this->data['Host']['hostname_ck'];
		}
		if(isset($this->data['Host']['hostname'])){
			$hostname = $this->data['Host']['hostname'];
		}
		if(isset($this->data['Host']['hostname_all'])){
			$hostname_all = $this->data['Host']['hostname_all'];
		}
		$hostname_empty = $this->Lv->is_empty($hostname);

		if(isset($hostname_ck)&&($hostname_ck == 1)){
			if($this->Lv->is_empty($hostname)){
				$errorMessage['computer'][] = "E-00100";//未入力

			}
			if(!$this->Validation->maxLength($hostname,40)){
				$errorMessage['computer'][] = 'E-00300';
			}
			if(!$this->Check->checkAllHalf($hostname)){
				$errorMessage['computer'][] = 'E-00400';
			}
			if(empty($errorMessage)){
				if($hostname_all==1){
					//wangs start 20080202
					//$criteria[]="Host.host_name like '%".trim($hostname)."%' ";
					$criteria[]="lower(Host.host_name) like '%".strtolower(trim($this->Lv->spec_char_like($hostname)))."%' ";
					//wangs end 20080202
				}
				else{
					//wangs start 20080202
					//$criteria[]="Host.host_name='".trim($hostname)."'";
					$criteria[]="lower(Host.host_name)='".strtolower(trim($this->Lv->spec_char_dbm($hostname)))."'";
					//wangs end 20080202
				}
			}
		}else{
			$criteria=array("1=1");
		}
		if(!empty($errorMessage['computer']))
		{
			empty($errorMessage['computer']) ? null : $this->set('hostname_error',$errorMessage);
			$this->render();
			exit();
		}

		if((empty($_POST['btn1'])||(!empty($_POST['btn1'])&&($this->data["Grpapp"]["group_grp"] ==0)))&&($url!=1))
		{
			$this->search($criteria,$type);
		}
		elseif((!empty($_POST['btn1'])&&($this->data["Grpapp"]["group_grp"] !=0))&&($url!=1))
		{
			//debug($criteria,true);
			$this->detail($criteria,true,$type);
		}
		elseif($url ==1){
			$url=='1'? $criteria1['id']=$search: null;
			$criteria1['url'] =1;
			$this->detail($criteria,$criteria1,$type);
		}

	}


	function search(& $criteria,$type=null)
	{//echo "type=".$type."<br>";
		//echo "search"."<br>";
		$this->layout='ajax';

		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			//$this->set('forHideVar', 'data%5BAstsfw%5D%5Bgroup%5D=2&data%5BGrpapp%5D%5Bgroup_grp%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
		}
		$this->set('criteria',$criteria);

		//debug($criteria);

		$this_groups =0;
		$group_id = $this->_getUserGroup_id();
		if(!isset($this->data["Astsfw"]["group"])){
			$this_groups =$group_id;
		}else {
			$this_groups =$this->data["Astsfw"]["group"];
		}
		//$this->set('groupid',$this_groups);

		/*
		* アプリケーション運用情報の捜索
		*/

		$glist = $this->Grpauth->getChildrenByParent($this_groups);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		$criteria3 = $criteria;
		//sunhy start 2009/07/07 added for LVR1-192
		$criteria3[]=" Astsfw.log_time = (select max(log_time) from astsfws as c where c.host_id = Astsfw.host_id)  ";
		//sunhy end 2009/07/07 added for LVR1-192
		$asso_app = array('Host : hosts' => array('Astsfw.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		//$criteria3['GROUP BY']="Astsfw.software_name,Astsfw.version,Astsfw.maker,Host.host_name,Group.id,Group.group_name";
		//$data_app = $this->Astsfw->findByAsso($criteria, array('Astsfw.id', 'Astsfw.software_name','Host.host_name','Host.id','Group.id','Group.group_name'),'Group.group_name', $limit=null, $page=1, $asso_app);
		//xinw start 20081105
		//modify for LV20R1-176
		//$data_app = $this->Astsfw->findByAsso($criteria3, array('Astsfw.software_name','Astsfw.version','Astsfw.maker','Host.host_name','Group.id','Group.group_name'),'Host.host_name', $limit=null, $page=1, $asso_app);
		$data_app = $this->Astsfw->findByAsso($criteria3, array('Astsfw.software_name','Astsfw.version','Astsfw.maker','Host.host_name','Group.id','Group.group_name','Host.id'),'Host.host_name', $limit=null, $page=1, $asso_app);
		//xinw end 20081105
		/*		echo "<pre>";
		var_dump($data_app);*/
		//debug($data_app,true);


		/*
		* 指定アプリケーションの捜索
		*/
		//$criteria2=array(" Grpapp.group_id=2 ");
		$criteria2[]=" Grpapp.group_id=".$group_id;
		$asso_install= array(
		'Installation : installations' => array('Installation.app_id = Grpapp.id'),
		);
		//$data_install = $this->Grpapp->findByAsso($criteria2, array('Grpapp.id AS Grpapp__id', 'Grpapp.app_name','Installation.id','Installation.disp_name AS Installation__disp_name'), $order = null, $limit=null, $page=1, $asso_install);
		$data_install = $this->Grpapp->findByAsso($criteria2, array('Grpapp.id AS Grpapp__id', 'Grpapp.app_name','Installation.app_id','Installation.id','Installation.disp_name AS Installation__disp_name','Installation.program_name','Installation.version','Installation.vendor'), $order = null, $limit=null, $page=1, $asso_install);
		//debug($data_install,true);
		//var_dump($data_install);



		/*
		* アプリケーション運用情報arrayの形成


		*/
		$array_app = array();
		$count_app=count($data_app);
		$j =0;
		$m =0;
		for($i=0;$i<$count_app;$i++){

			$array_app_host_name=$data_app[$i]["Host"]["host_name"];
			$array_software_name=$data_app[$i]["Astsfw"]["software_name"];
			//xinw start 20081105
			//modify for LV20R1-176
			$array_app_host_id=$data_app[$i]["Host"]["id"];
			//xinw end 20081105
			//xinw start 20081105
			//modify for LV20R1-176
			/*			if(!array_key_exists($array_app_host_name,$array_app)){
			$array_app[$array_app_host_name][$j]=array();
			$array_app[$array_app_host_name][$j][1]=$array_software_name;
			$array_app[$array_app_host_name][$j][2]=$data_app[$i]["Astsfw"]["version"];
			$array_app[$array_app_host_name][$j][3]=$data_app[$i]["Astsfw"]["maker"];*/
			//xinw end 20081105

			//xinw start 20081105
			//modify for LV20R1-176
			if(!array_key_exists($array_app_host_id,$array_app)){
				$array_app[$array_app_host_id][$j]=array();
				$array_app[$array_app_host_id][$j][1]=$array_software_name;
				$array_app[$array_app_host_id][$j][2]=$data_app[$i]["Astsfw"]["version"];
				$array_app[$array_app_host_id][$j][3]=$data_app[$i]["Astsfw"]["maker"];
				$array_app[$array_app_host_id][$j][4]=$array_app_host_name;
				//xinw end 20081105
				$m = $j;
				//xinw start 20081105
				//modify for LV20R1-176
				/*			}elseif(array_key_exists($array_app_host_name,$array_app)){
				$m++;
				$array_app[$array_app_host_name][$m][1]=$array_software_name;
				$array_app[$array_app_host_name][$m][2]=$data_app[$i]["Astsfw"]["version"];
				$array_app[$array_app_host_name][$m][3]=$data_app[$i]["Astsfw"]["maker"];*/
				//xinw start 20081105
				//modify for LV20R1-176
			}elseif(array_key_exists($array_app_host_id,$array_app)){
				$m++;
				$array_app[$array_app_host_id][$m][1]=$array_software_name;
				$array_app[$array_app_host_id][$m][2]=$data_app[$i]["Astsfw"]["version"];
				$array_app[$array_app_host_id][$m][3]=$data_app[$i]["Astsfw"]["maker"];
				//xinw start 20081105
				//modify for LV20R1-176
				$array_app[$array_app_host_id][$m][4]=$array_app_host_name;
				//xinw end 20081105
			}
		}
		// debug($array_app,true);


		/*
		　* 指定アプリケーションarrayの形成


		　　　 */ //$data_install
		$glist_grpapp = $this->Grpapp->generateList( array('group_id' =>$group_id) , null, null, '{n}.Grpapp.id', '{n}.Grpapp.app_name');
		//debug($glist_grpapp);
		$array_install_null = array();
		if(!empty($glist_grpapp)){
			foreach($glist_grpapp as $key=>$value){
				//debug($key);
				$con = array("Installation.app_id" => $this->Lv->spec_char_dbm($key));
				$result =$this->Installation->findAll($con,null,null,null,null,null);
				if(count($result)!=0){
					$array_install = array();
					$count_install=count($data_install);
					$k=0;
					$f=0;
					for($i=0;$i<$count_install;$i++){
						$array_app_name=$data_install[$i]["Grpapp"]["app_name"];
						$array_disp_name=$data_install[$i]["Installation"]["disp_name"];
						if(!array_key_exists($array_app_name,$array_install)){
							$array_install[$array_app_name][$k]=array();
							$array_install[$array_app_name][$k][1]=$data_install[$i]["Installation"]["program_name"];
							$array_install[$array_app_name][$k][2]=$data_install[$i]["Installation"]["version"];
							$array_install[$array_app_name][$k][3]=$data_install[$i]["Installation"]["vendor"];
							$array_install_id[$array_app_name] =$data_install[$i]["Grpapp"]["id"];
							$f = $j;
						}elseif (array_key_exists($array_app_name,$array_install)){
							$f++;
							$array_install[$array_app_name][$f][1]=$data_install[$i]["Installation"]["program_name"];
							$array_install[$array_app_name][$f][2]=$data_install[$i]["Installation"]["version"];
							$array_install[$array_app_name][$f][3]=$data_install[$i]["Installation"]["vendor"];

						}
					}
				}else{
					$array_install_null[$key] = $value;
				}
				empty($array_install_null)?($array_install_null =array()):($this->set('array_install_null',$array_install_null));
				empty($array_install_id)?($array_install_id =array()):($this->set('array_install_id',$array_install_id));
			}
		}
		//		   debug($array_install);
		//		   debug($array_install_id);
		//		   debug($array_install_null);


		/*
		* 開始ページの表示
		*/

		$asso_group= array(
		'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/assets_apps/contro', 'modelClass'=>'Host','queryType' => array('function' => 'findByAsso', 'asso' => $asso_group),'sortBy' => $this->Lv->sortBy('Group.group_name')));
		$data_group_host= $this->Host->findByAsso($criteria, array('Group.group_name','Host.host_name','Host.id'),$order, $limit, $page, $asso_group);
		$data_group_host_whole= $this->Host->findByAsso($criteria, array('Group.group_name','Host.host_name','Host.id'),$order, $limit=null, $page=null, $asso_group);
		(!empty($array_app))?($this->set('array_app',$array_app)):null;
		(!empty($array_install))?($this->set('array_install',$array_install)):null;
		(!empty($data_group_host))?($this->set('data_group_host',$data_group_host)):null;

		if(!empty($data_group_host)){
			foreach ($data_group_host as $key1 => $data_group_host1){
				if(!empty($array_install)){ //debug($array_install);
					foreach ($array_install as $key2 => $output){
						$c =count($array_install);
						$m = 0;
						foreach ($output as $key3 => $output1){//debug($output1);
							if(($output1[2] == '*')&&($output1[3] == '*')){//echo "check 11<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									foreach ($app_res as $key => $v){
										if($output1[1] == $v[1] ){
											//echo "11=".$output1[1]."--".$v[1]."<br>";
											//echo "11111111111111111111111111111111111111111111111111<br>";
											$m++ ;
										}
									}
								}
							}elseif(($output1[2] == '*')&&($output1[3] != '*')){ //echo "check 11  33<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[3] == $v[3])){
											//echo "222222222222222222222222222222222222222222222222222222<br>";
											//echo "11=".$output1[1]."--".$v[1]."==".$output1[3]."--".$v[3]."<br>";
											$m++ ;
										}
									}
								}
							}elseif(($output1[2] != '*')&&($output1[3] == '*')){ //echo "check 11  22<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[2] == $v[2])){
											//echo "33333333333333333333333333333333333333333333333<Br>";
											//echo "11=".$output1[1]."--".$v[1]."==".$output1[2]."--".$v[2]."<br>";
											$m++ ;
										}
									}
								}
							}else{
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[3] == $v[3])&&($output1[2] == $v[2])){
											//echo "4444444444444444444444444444444444444444444444444444<Br>";
											//echo "11=".$output1[1]."--".$v[1]."==".$output1[3]."--".$v[3]."==".$output1[2]."--".$v[2]."<br>";
											$m++ ;
										}
									}
								}

							}

						}
						if($m > 0){
							$array_data[$key1][$key2]="○";
						}else{
							$array_data[$key1][$key2]=null;
						}
						//$array_data[$key1][$key2] =$m;
						//echo "mmmmmmmmmmmmmmmmmmmmmmmmmmmmm=".$m."<br>";
					}

				}else{//echo "yangyang<br>";
					$array_data = array();
				}
			}
		}else{
			$array_data = array();
		}
		$this->set('array_data',$array_data);
		//debug($array_data);
		if($type =='csv1'){
			//debug($array_data);
			$this->csvdown($array_app,$array_install,$data_group_host_whole,$array_install_null,$array_install_id,1);exit();
		}
		$this->render('search');

	}

	function detail(& $criteria1 =null,$criteria2 =null,$type=null)
	{   //echo "type=".$type."<br>";
		$this->layout='ajax';
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			//$this->set('forHideVar', 'data%5BAstsfw%5D%5Bgroup%5D=2&data%5Bgrpapp%5D%5Bgroup_grp%5D=0');
		}
		$this->set('criteria1',$criteria1);
		$this->set('criteria2',$criteria2);
		if($criteria2['url'] == 1){
			$this->set('forHideVar', $_POST['forHideVar']."&data%5Bgrpapp%5D%5Bgroup_grp%5D=".$criteria2['id']);
		}
		//debug($criteria1);
		//debug($criteria2);
		$criteria[] = $criteria1[0];

		$this_groups =0;
		$group_id = $this->_getUserGroup_id();
		if(!isset($this->data["Astsfw"]["group"])){

			$this_groups =$group_id;
		}else {
			$this_groups =$this->data["Astsfw"]["group"];
		}
		$glist = $this->Grpauth->getChildrenByParent($this_groups);
		/*
		* アプリケーション運用情報の捜索
		*/
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		//$criteria=array(" Group.id in (".$condition.") ");
		$criteria[]=" Group.id in (".$condition.") ";
		$asso_app = array('Host : hosts' => array('Astsfw.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		$criteria3 =$criteria;
		//sunhy start 2009/07/07 added for LVR1-192
		$criteria3[]=" Astsfw.log_time = (select max(log_time) from astsfws as c where c.host_id = Astsfw.host_id)  ";
		//sunhy end 2009/07/07 added for LVR1-192
		//$criteria3['GROUP BY']="Astsfw.software_name,Astsfw.version,Astsfw.maker,Host.host_name,Group.id,Group.group_name";
		//$criteria['GROUP BY']="Host.host_name,Astsfw.software_name,Astsfw.version,Astsfw.maker";
		//$data_app = $this->Astsfw->findByAsso($criteria, array('Astsfw.id', 'Astsfw.software_name','Astsfw.version','Astsfw.maker','Host.host_name','Host.id','Group.id','Group.group_name'),'Group.group_name', $limit=null, $page=1, $asso_app);
		//xinw start 20081105
		//modify for LV20R1-176
		//$data_app = $this->Astsfw->findByAsso($criteria3, array('Astsfw.software_name','Astsfw.version','Astsfw.maker','Host.host_name','Group.id','Group.group_name'),'Host.host_name', $limit=null, $page=1, $asso_app);
		$data_app = $this->Astsfw->findByAsso($criteria3, array('Astsfw.software_name','Astsfw.version','Astsfw.maker','Host.host_name','Group.id','Group.group_name','Host.id'),'Host.host_name', $limit=null, $page=1, $asso_app);
		//xinw end 20081105
		//debug($data_app,true);


		/*
		* 指定アプリケーションの捜索
		*/
		if((!isset($criteria2['url']))||($criteria2['url'] !=1)){
			$criteria2=array(" Grpapp.id=".$this->data["Grpapp"]["group_grp"]." ");
		}
		else{
			$criteria2=array(" Grpapp.id=".$criteria2['id']." ");
		}
		$asso_install= array(
		'Installation : installations' => array('Installation.app_id = Grpapp.id'),
		);
		//$data_install = $this->Grpapp->findByAsso($criteria2, array('Grpapp.id AS Grpapp__id', 'Grpapp.app_name','Installation.id','Installation.disp_name AS Installation__disp_name'), $order = null, $limit=null, $page=1, $asso_install);
		$data_install = $this->Grpapp->findByAsso($criteria2, array('Grpapp.id AS Grpapp__id', 'Grpapp.app_name','Installation.app_id','Installation.id','Installation.disp_name AS Installation__disp_name','Installation.program_name','Installation.version','Installation.vendor'), $order = null, $limit=null, $page=1, $asso_install);
		//debug($data_install,true);
		/*
		* アプリケーション運用情報arrayの形成


		*/
		$array_app = array();
		$count_app=count($data_app);
		//echo "count=".$count_app;
		$j =0;
		$m =0;
		for($i=0;$i<$count_app;$i++){

			$array_app_host_name=$data_app[$i]["Host"]["host_name"];
			$array_software_name=$data_app[$i]["Astsfw"]["software_name"];
			//xinw start 20081105
			//modify for LV20R1-176
			$array_app_host_id=$data_app[$i]["Host"]["id"];
			//xinw end 20081105
			//xinw start 20081105
			//modify for LV20R1-176
			/*			if(!array_key_exists($array_app_host_name,$array_app)){
			$array_app[$array_app_host_name][$j]=array();
			$array_app[$array_app_host_name][$j][1]=$array_software_name;
			$array_app[$array_app_host_name][$j][2]=$data_app[$i]["Astsfw"]["version"];
			$array_app[$array_app_host_name][$j][3]=$data_app[$i]["Astsfw"]["maker"];*/
			//xinw end 20081105

			//xinw start 20081105
			//modify for LV20R1-176
			if(!array_key_exists($array_app_host_id,$array_app)){
				$array_app[$array_app_host_id][$j]=array();
				$array_app[$array_app_host_id][$j][1]=$array_software_name;
				$array_app[$array_app_host_id][$j][2]=$data_app[$i]["Astsfw"]["version"];
				$array_app[$array_app_host_id][$j][3]=$data_app[$i]["Astsfw"]["maker"];
				$array_app[$array_app_host_id][$j][4]=$array_app_host_name;
				//xinw end 20081105
				$m = $j;
				//xinw start 20081105
				//modify for LV20R1-176
				/*			}elseif(array_key_exists($array_app_host_name,$array_app)){
				$m++;
				$array_app[$array_app_host_name][$m][1]=$array_software_name;
				$array_app[$array_app_host_name][$m][2]=$data_app[$i]["Astsfw"]["version"];
				$array_app[$array_app_host_name][$m][3]=$data_app[$i]["Astsfw"]["maker"];*/
				//xinw start 20081105
				//modify for LV20R1-176
			}elseif(array_key_exists($array_app_host_id,$array_app)){
				$m++;
				$array_app[$array_app_host_id][$m][1]=$array_software_name;
				$array_app[$array_app_host_id][$m][2]=$data_app[$i]["Astsfw"]["version"];
				$array_app[$array_app_host_id][$m][3]=$data_app[$i]["Astsfw"]["maker"];
				//xinw start 20081105
				//modify for LV20R1-176
				$array_app[$array_app_host_id][$m][4]=$array_app_host_name;
				//xinw end 20081105
			}
		}
		//debug($array_app,true);

		/*
		　* 指定アプリケーションarrayの形成


		　　　 */ //$data_install
		$array_install = array();
		$count_install=count($data_install);
		$i=0;
		for($i=0;$i<$count_install;$i++){
			$array_app_name=$data_install[$i]["Grpapp"]["app_name"];
			$array_disp_name=$data_install[$i]["Installation"]["disp_name"];
			$array_install[$array_app_name][$i]=array();
			if(array_key_exists($array_app_name,$array_install)){
				$array_install[$array_app_name][$i][0] =$array_disp_name;
				$array_install[$array_app_name][$i][1]=$data_install[$i]["Installation"]["program_name"];
				$array_install[$array_app_name][$i][2]=$data_install[$i]["Installation"]["version"];
				$array_install[$array_app_name][$i][3]=$data_install[$i]["Installation"]["vendor"];
			}
		}
		//debug($array_install,true);


		/*
		* 開始ページの表示
		*/
		//debug($criteria);
		$asso_group= array(
		'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/assets_apps/contro','modelClass'=>'Host','queryType' => array('function' => 'findByAsso', 'asso' => $asso_group),'sortBy' => $this->Lv->sortBy('Group.group_name')));
		$data_group_host= $this->Host->findByAsso($criteria, array('Group.group_name','Host.host_name','Host.id'),$order, $limit, $page, $asso_group);
		$data_group_host_whole= $this->Host->findByAsso($criteria, array('Group.group_name','Host.host_name','Host.id'),$order, $limit=null,$page=null, $asso_group);
		$c_data_group_host =count($data_group_host_whole);
		if($c_data_group_host != 0){
			$this->set('c_data_group_host',$c_data_group_host);
		}else{
			$this->set('c_data_group_host',0);
		}
		$this->set('array_app',$array_app);
		$this->set('array_install',$array_install);
		$this->set('data_group_host',$data_group_host);


		if(!empty($data_group_host)){
			foreach ($data_group_host as $key1 => $data_group_host1){
				if(!empty($array_install)){ //debug($array_install);
					foreach ($array_install as $key2 => $output){
						//debug($output);
						$i=1;
						foreach ($output as $key3 => $output1){//debug($output1);
							$m = 0;//echo $i."<br>";
							if(($output1[2] == '*')&&($output1[3] == '*')){//echo "check 11<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									foreach ($app_res as $key => $v){
										if($output1[1] == $v[1] ){
											//echo "11=".$output1[1]."--".$v[1]."<br>";
											//echo "11111111111111111111111111111111111111111111111111<br>";
											$m++ ;
										}
									}
									if($m > 0) {//echo "111<br>";
										$out="○";
										$haha = 1;
									}else{//echo "222<br>";
										$out=null;
										$haha = 0;
									}
								}else{//echo "333<br>";
									$out=null;
									$haha = 0;
								}
							}elseif(($output1[2] == '*')&&($output1[3] != '*')){ //echo "check 11  33<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[3] == $v[3])){
											//echo "222222222222222222222222222222222222222222222222222222<br>";
											//echo "11=".$output1[1]."--".$v[1]."==".$output1[3]."--".$v[3]."<br>";
											$m++ ;
										}
									}
									if($m > 0) { //echo "111<br>";
										$out="○";
										$haha = 1;
									}else{//echo "222<br>";
										$out=null;
										$haha = 0;
									}
								}else{//echo "333<br>";
									$out=null;
									$haha = 0;
								}
							}elseif(($output1[2] != '*')&&($output1[3] == '*')){ //echo "check 11  22<br>";
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[2] == $v[2])){
											//echo "33333333333333333333333333333333333333333333333<Br>";
											//echo "11=".$output1[1]."--".$v[1]."==".$output1[2]."--".$v[2]."<br>";
											$m++ ;
										}
									}
									if($m > 0) { //echo "111<br>";
										$out="○";
										$haha = 1;
									}else{//echo "222<br>";
										$out=null;
										$haha = 0;
									}
								}else{//echo "333<br>";
									$out=null;
									$haha = 0;
								}
							}else{
								//xinw start 20081105
								//modify for LV20R1-176
								//if (array_key_exists($data_group_host1["Host"]["host_name"],$array_app)) {
								if (array_key_exists($data_group_host1["Host"]["id"],$array_app)) {
									//xinw end 20081105
									//xinw start 20081105
									//modify for LV20R1-176
									//$app_res = $array_app[$data_group_host1["Host"]["host_name"]];
									$app_res = $array_app[$data_group_host1["Host"]["id"]];
									//xinw end 20081105
									//debug($app_res);
									foreach ($app_res as $key => $v){
										if(($output1[1] == $v[1])&&($output1[3] == $v[3])&&($output1[2] == $v[2])){
											//echo "4444444444444444444444444444444444444444444444444444<Br>";
											//echo "11=".$output1[1]."--".$v[1]."==".$output1[3]."--".$v[3]."==".$output1[2]."--".$v[2]."<br>";
											$m++ ;
										}
									}
									if($m > 0) { //echo "111<br>";
										$out="○";
										$haha = 1;
									}else{//echo "222<br>";
										$out=null;
										$haha = 0;
									}
								}else{//echo "333<br>";
									$out=null;
									$haha = 0;
								}
							}

							$array_data[$key1][$key2][$key3] =$out;
							//echo "m=".$m."<br>";
							//echo "haha=".$haha."<br>";
							//echo "<br><br><br><br><br><br><br><br><br><br>";
						}
					}

				}else{//echo "yangyang<br>";
					$array_data = array();
				}
			}
		}else{//echo "jingjing";
			$array_data = array();
		}
		$this->set('array_data',$array_data);
		//debug($array_data);

		if($type =='csv2'){
			$this->csvdown($array_app,$array_install,$data_group_host_whole,null,null,2);exit();
		}
		$this->render('detail');
	}


	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;

	}
	function _getGrpappName($app_id)
	{
		$criteria=array("Grpapp.id" => $this->Lv->spec_char_dbm($app_id));
		$app_n= $this->Grpapp->findAll($criteria);
		$app_name = $app_n[0]["Grpapp"]["app_name"];
		return $app_name;

	}
}
?>