﻿<?php
/*********************************************************************
*@filename Csvuseapp.php
*@description
*@note
*@histories  rivision	author		date		comment
*            2.0        xht         2009/04/28  modify for LogvillageChinese
*            2.0	    sunhy         2009/05/06  modify for  LV20R1-257
*            2.0        xushanning  2009/06/05 mofify for LogvillageChinese
*            2.0        yzl		  2009/07/14   mofify for LV20R1-228
*            2.0        yaozl	   2009/09/01   modify for LV20R1-280
*            2.0        yaozl	   2009/09/07   modify for LV20R1-280再
********************************************************************/
class AssetsMngHdwsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Host','Asthrd','Hrdcpu','Hrddrv','Hrdmem','Hrdmnt','Hrdnic',
	'Astose','Astact','Grpauth','Configure','Group','Hrdphydsk','Hrdlogdsk','Astsfw','Addition','Hstadt','Hstalthrd','Hstloghead',
	'Logonuser','Updateprogram','Registrydata','Getregistry');
	var $layout='assets';
	function beforeFilter()
	{
		parent::beforeFilter();

		$assets_111=__('assets_111',$retrun=true);
		$pc_111=__('pc_111',$retrun=true);
		$hdw=__('hdw',$retrun=true);
		$this->pageTitle =$assets_111."/".$pc_111."/".$hdw;
		//xushanning start 2009/05/26  modify for LogvillageChinese
		//$this->Configure->write('debug',2);
		//xushanning end 2009/05/26  modify for LogvillageChinese
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function detail($id = null,$type = null){	
		$this->set('id',$id);
		$this->layout='ajax';
		$asso = array(
		'Host : hosts' => array('Asthrd.host_id = Host.id '),
		'Astose : astoses' => array('Astose.host_id = Host.id '),
		) ;

		$fields_Host = array(
		'Host.id',
		'Host.host_name',
		'Asthrd.id'
		);

		$fields_Astose = array(
		'Astose.os_name',
		'Astose.servicepack',
		'Astose.product_id',
		'Astose.install_time',
		'Astose.activation',
		'Astose.user_name',
		'Astose.organization',
		'Astose.description',
		'Astose.domain_name',
		'Astose.version',
		);

		$Hosts= $this->Host->find(array("Host.id" => $this->Lv->spec_char_dbm($id)), 'Host.host_name, Host.id', null,1,null,-1);
		$host_name = $Hosts['Host']['host_name'];

		$this->set('Hosts',$Hosts);
		!empty($Hosts)?$this->set('Hosts',$Hosts):$this->set('Hosts',"");

		$criteria_hostId = array("Asthrd.host_id" => $this->Lv->spec_char_dbm($id));
		$Asthrd_id = $this->Asthrd->find($criteria_hostId,'Asthrd.id');
		///================= asthrd id----------
		$condition = array("Asthrd.id" => $Asthrd_id['Asthrd']['id']);
		$condition['GROUP BY']="Asthrd.id,Asthrd.machine,Asthrd.maker,Asthrd.serialno";
		$fields_Asthrd = array(
		'Asthrd.id',
		'Asthrd.machine',
		'Asthrd.maker',
		'Asthrd.serialno',
		'Asthrd.UUID',
		'Asthrd.log_time');
		$Asthrds = $this->Asthrd->find($condition, $fields_Asthrd, 'Asthrd.id',null,null, -1);
		!empty($Asthrds)?$this->set('Asthrds',$Asthrds):$this->set('Asthrds',"");
		///----------------------------------------------------------------------------
		$criteria_Astoses=array("Astose.hardware_id" => $Asthrds['Asthrd']['id']);
		$Astoses = $this->Astose->find($criteria_Astoses, $fields_Astose, 'Astose.id', null, null,null);

		!empty($Astoses)?$this->set('Astoses',$Astoses):$this->set('Astoses',"");

		//logonuser
		$logonuser = $this->Logonuser->find(array("Logonuser.host_id" => $this->Lv->spec_char_dbm($id)));
		!empty($logonuser)?$this->set('logonuser',$logonuser):$this->set('logonuser',"");
		
		//WSUS,SecureDoc
		$fldreg = array(
			'Getregistry.name',
			'Registrydata.regdword', 
			'Registrydata.regsz'
		);
		$assoreg = array(
			"Registrydata : registrydata : left" => array('Registrydata.name = Getregistry.name', 'Registrydata.host_id ='.$this->Lv->spec_char_dbm($id))
		);
		$registry = $this->Getregistry->findByAsso(array("1=1"), $fldreg, null, null, null, $assoreg);
		if(!empty($registry)){
			$keys = Set::extract($registry, '{n}.Getregistry.name');
			$vals = Set::extract($registry, '{n}.Registrydata');
			$registry = array_combine($keys, $vals);
		}
		$this->set('registry',$registry);
		//var_dump($registry);	
		
		$Hrddrvs_fields = array(
				'Hrddrv.driver_name',
				'Hrddrv.driver'
				);
		$Hrddrvs = $this->Hrddrv->findAll("Hrddrv.hardware_id=".$Asthrds['Asthrd']['id'], $Hrddrvs_fields, null, null, null, null);//2007-11-27 変更zhaoli
		//			$Hrddrvs = $this->Hrddrv->findAll("Hrddrv.hardware_id=".$Asthrds['Asthrd']['id'], 'driver_name,driver', null, null, null, null);
		!empty($Hrddrvs)?$this->set('Hrddrv',$Hrddrvs):$this->set('Hrddrv',"");

		$fields1 = array(
		'Astsfw.id',
		'Astsfw.software_name',
		'Astsfw.maker',
		'Astsfw.version',
		'Astsfw.licence_code',
		);
		// $Host_criteria=array("Host.status!= 0 and Grpauth.org_grp_id=".$groupid,"GROUP BY" => $groupBy,);

		$criteria_Astsfws=array('Astsfw.host_id' => $this->Lv->spec_char_dbm($id),"GROUP BY"=>"Astsfw.host_id");
		$Astsfw_logTime = $this->Astsfw->find($criteria_Astsfws, 'MAX(Astsfw.log_time) AS Astsfw_logtime', null, null, null, -1);
		//debug($Astsfw_logTime,true);

		//--------------------------

		if(!empty($Astsfw_logTime[0]['Astsfw_logtime'])){
			$criteria_Astsfws1=array("(Astsfw.host_id =".$id.") and Astsfw.log_time = "."'".$Astsfw_logTime[0]['Astsfw_logtime']."'","GROUP BY"=>"Astsfw.id,Astsfw.software_name,Astsfw.maker,Astsfw.version,Astsfw.licence_code");
			$criteria_Astsfws1[]="Astsfw.syscomp != True";
			//xinw start 20080221
			$order1="Astsfw.software_name";
			//xinw end 20080221
			//debug($criteria_Astsfws1,true);
			//xinw start 20080221
			$Astsfws = $this->Astsfw->findByAsso($criteria_Astsfws1,$fields1,$order1, null, null, null);}
			//xinw end 20080221
			//	--------------------------

			//$criteria_Astsfws1=array("Astsfw.host_id =".$id,"GROUP BY"=>"Astsfw.id,Astsfw.software_name,Astsfw.maker,Astsfw.version,Astsfw.licence_code");
			//$Astsfws = $this->Astsfw->findAll($criteria_Astsfws1,$fields1, null, null, null, null);

			if(!empty($Astsfws))
			{
				foreach ($Astsfws as $key=>$as)
				{
					if(
					(
					//xinw start 20080221
					strtolower($as['Astsfw']['maker'])=='microsoft corporation'&&(substr(strtolower($as['Astsfw']['software_name']),0,6)=="office"||substr(strtolower($as['Astsfw']['software_name']),0,16)=="microsoft office")
					//xinw end 20080221
					)
					||substr($as['Astsfw']['maker'],0,5)=="Adobe"
					|| $as['Astsfw']['maker'] != ''
					)

					{
						$Astsfws[$key]['Astsfw']['licence_code']=$Astsfws[$key]['Astsfw']['licence_code'];
					}
					else
					{
						$Astsfws[$key]['Astsfw']['licence_code']="";
					}
				}
			}
			//add by WQ  0910
			!empty($Astsfws)?$this->set('Astsfw',$Astsfws):$this->set('Astsfw',"");

			$asso_Astacts = array(
			'Astose : astoses' => array('Astact.os_id = Astose.id'),
			) ;
			$criteria_ast[]="Astose.hardware_id=".$Asthrds['Asthrd']['id'];

			$criteria_ast['GROUP BY']="Astose.hardware_id,Astact.account_name";

			$Astacts = $this->Astact->findByAsso($criteria_ast,array('Astact.account_name'), null, null, null, $asso_Astacts);

			!empty($Astacts)?$this->set('Astact',$Astacts):$this->set('Astact',"");

			// wangs start 20080219
			// $Hrdcpus = $this->Hrdcpu->findAll("Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id'],array('cpu_name'), null, null, null, -1);
			// !empty($Hrdcpus)?$this->set('Hrdcpu',$Hrdcpus):$this->set('Hrdcpu',"");
			$criteria_cpu[]="Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id'];
			$criteria_cpu['GROUP BY']="Hrdcpu.cpu_name";
			$Hrdcpus = $this->Hrdcpu->findAll($criteria_cpu,array('count(cpu_name) as cpu_num,cpu_name,clock,cores'), 'Hrdcpu.id', 1, null, -1);
			!empty($Hrdcpus)?$this->set('Hrdcpu',$Hrdcpus):$this->set('Hrdcpu',"");
			// wangs end 20080219

			//wangs start 20080219
			$this->set('Hrdcpunum',count($Hrdcpus));
			//wangs end 20080219
			
			

			$Hrdmems = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('capacity'), null, null, null, -1);

			!empty($Hrdmems)?$this->set('Hrdmem',$Hrdmems):$this->set('Hrdmem',"");

			$Hrdmems1 = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(capacity) as Hrdmem__capacity'), null, null, null, -1);
			!empty($Hrdmems1)?$this->set('Hrdmem1',$Hrdmems1):$this->set('Hrdmem1',"");
//物理ディスク
			$Hrdphydsks = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('allspace','type'), null, null, null, -1);
			!empty($Hrdphydsks)?$this->set('Hrdphydsk',$Hrdphydsks):$this->set('Hrdphydsk',"");

			$Hrdphydsks1 = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(allspace) as Hrdphydsk__allspace'), null, null, null, -1);
			!empty($Hrdphydsks1)?$this->set('Hrdphydsk1',$Hrdphydsks1):$this->set('Hrdphydsk1',"");
//論理ディスク
			$Hrdlogdsk_fields =array(
			'Hrdlogdsk.name',
			'Hrdlogdsk.size',
			'Hrdlogdsk.freespace',
			'Hrdlogdsk.drivetype',
			'Hrdlogdsk.filesystem',
			'Hrdlogdsk.protection'
			);
			$cond=array();
			$cond[] = "Hrdlogdsk.hardware_id =". $Asthrds['Asthrd']['id'];
			$Hrdlogdsks = $this->Hrdlogdsk->findByAsso($cond, $Hrdlogdsk_fields, "Hrdlogdsk.name", null, null, null);
			///$Hrdlogdsks = $this->Hrdlogdsk->findAll(array("Hrdlogdsk.hardware_id" => $Asthrds['Asthrd']['id']),$Hrdlogdsk_fields, "Hrdlogdsk.name", null, null, -1);
			!empty($Hrdlogdsks)?$this->set('Hrdlogdsk',$Hrdlogdsks):$this->set('Hrdlogdsk',"");

			$Hrdlogdsks1 = $this->Hrdlogdsk->findAll(array("Hrdlogdsk.hardware_id" => $Asthrds['Asthrd']['id'], "Hrdlogdsk.drivetype != 4"),array('SUM(freespace) as Hrdlogdsk__freespace'), null, null, null, -1);
			!empty($Hrdlogdsks1)?$this->set('Hrdlogdsks1',$Hrdlogdsks1):$this->set('$Hrdlogdsks1',"");
//モニタ
			$Hrdmnts = $this->Hrdmnt->findAll(array("Hrdmnt.hardware_id" => $Asthrds['Asthrd']['id']),array('monitor_name','adapterram','horizontal','vertical','bits'), null, null,null,-1);
			!empty($Hrdmnts)?$this->set('Hrdmnt',$Hrdmnts):$this->set('Hrdmnt',"");

			$criteria_Hrdnics=array("Hrdnic.hardware_id" => $Asthrds['Asthrd']['id']);
			$Hrdnic_fields =array(
			'Hrdnic.nic_name',
			'Hrdnic.enableflg',
			'Hrdnic.mac_address',
			'Hrdnic.ip_address',
			'Hrdnic.gateway',
			'Hrdnic.dns_primary',
			'Hrdnic.dns_secondary',
			'Hrdnic.dhcp_address',
			'Hrdnic.dhcp_enabled',
			'Hrdnic.wlan'
			);
			$Hrdnics = $this->Hrdnic->findAll($criteria_Hrdnics,$Hrdnic_fields, null, null, null,-1);
			$this->set('Hrdnic',$Hrdnics);
			$Addition = $this->Addition->findAll(null,null,'id ASC','0',null,null);

			!empty($Addition)?$this->set('Addition',$Addition):$this->set('Addition',"");

			$Hstadt_asso = array(
			'Hstadt : hstadts' =>array('Hstadt.host_id =Host.id'),
			);

			$Hstadt_fields=array('Host.id',
			'Hstadt.id',
			'Hstadt.option1',
			'Hstadt.option2',
			'Hstadt.option3',
			'Hstadt.option4',
			'Hstadt.option5',
			'Hstadt.option6',
			'Hstadt.option7',
			'Hstadt.option8',
			'Hstadt.option9',
			'Hstadt.option10');

			$criteria_Hstadt=array("Hstadt.host_id=".$id);

			$result_Hstadt = $this->Host->findByAsso($criteria_Hstadt,$Hstadt_fields , null, null, null, $Hstadt_asso);
			!empty($result_Hstadt)?$this->set('result_Hstadt',$result_Hstadt):$this->set('result_Hstadt',"");

//--csv--  array
			//
			$csv_result=array();
			!empty($Hosts['Host']['host_name'])?$csv_result['Host']['host_name']=$Hosts['Host']['host_name']:$csv_result['Host']['host_name'] =null;
			!empty($Hosts['Host']['id'])?$csv_result['Host']['id']=$Hosts['Host']['id']:$csv_result['Host']['id'] =null;
			!empty($Asthrds['Asthrd']['machine'])?$csv_result['Asthrd']['machine']=$Asthrds['Asthrd']['machine']:$csv_result['Asthrd']['machine'] =null;
			!empty($Asthrds['Asthrd']['maker'])?$csv_result['Asthrd']['maker']= $Asthrds['Asthrd']['maker']:$csv_result['Asthrd']['maker'] =null;
			!empty($Asthrds['Asthrd']['serialno'])?$csv_result['Asthrd']['serialno']= $Asthrds['Asthrd']['serialno']:$csv_result['Asthrd']['serialno'] =null;
			!empty($Asthrds['Asthrd']['UUID'])?$csv_result['Asthrd']['UUID']= $Asthrds['Asthrd']['UUID']:$csv_result['Asthrd']['UUID'] =null;
			!empty($Asthrds['Asthrd']['log_time'])?$csv_result['Asthrd']['log_time']= $Asthrds['Asthrd']['log_time']:$csv_result['Asthrd']['log_time'] =null;


			$cpu_total = null;
			$Hrdcpus_num1 = $this->Hrdcpu->findAll(array("Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id']),'count(*) as count',null,null,null ,0);
			if(isset($Hrdcpus_num1)&&$Hrdcpus_num1[0][0]['count']!=0){
				$cpu_total = $Hrdcpus_num1[0][0]['count'];
				$this->set('Hrdcputotal', $cpu_total);
			}
			else{
				$this->set('Hrdcputotal', "");
			}
			for($i=0;$i<count($Hrdcpus);$i++){

				$f='cpu_name'.$i;
				//xinw start 20080221
				//!empty($Hrdcpus[$i]['cpu_name'])?$csv_result['Hrdcpu'][$f]=$Hrdcpus[$i]['cpu_name']:$csv_result['Hrdcpu'][$f] =null;
			//	!empty($Hrdcpus[$i])?$csv_result['Hrdcpu'][$f]=$Hrdcpus[$i][0]['cpu_name']:$csv_result['Hrdcpu'][$f] =null;
				//xinw end 20080221
				!empty($Hrdcpus[$i])?$csv_result['Hrdcpu'][$f]=$Hrdcpus[$i][0]['cpu_name']." ".__('CPU_no_start',true).$cpu_total.__('CPU_no_end',true):$csv_result['Hrdcpu'][$f] =null;
			}

			if(!empty($Hrdcpus)){
				$csv_result['Hrdcpu']['cpu_name']=$Hrdcpus[0][0]['cpu_name'];
				$csv_result['Hrdcpu']['cpu_num']=$Hrdcpus[0][0]['cpu_num'];
				$csv_result['Hrdcpu']['cores']=$Hrdcpus[0][0]['cores'];
				$csv_result['Hrdcpu']['clock']=sprintf("%.2fGHz", $Hrdcpus[0][0]['clock']/1000);
			}else{
				$csv_result['Hrdcpu']['cpu_name'] =null;
				$csv_result['Hrdcpu']['cpu_num'] =null;
				$csv_result['Hrdcpu']['cores'] =null;
				$csv_result['Hrdcpu']['clock'] =null;
			}

			!empty($Hrdmems1[0]['Hrdmem']['capacity'])?$csv_result['Hrdmem']['capacity']=round($Hrdmems1[0]['Hrdmem']['capacity']/1024,1).'MB':$csv_result['Hrdmem']['capacity']=null;

			!empty($Asthrds['Asthrd']['maker'])?$csv_result['Asthrd']['maker']= $Asthrds['Asthrd']['maker']:$csv_result['Asthrd']['maker'] =null;

			for($i=0;$i<count($Hrdmems);$i++){
				$f='capacity'.$i;
				$capacity_1 = round($Hrdmems[$i]['Hrdmem']['capacity']/1024,1).'MB';
				!empty($Hrdmems[$i]['Hrdmem']['capacity'])?$csv_result['Hrdmem'][$f]=$capacity_1: $csv_result['Hrdmem'][$f]=null;
			}
			//round($Hrdphydsks[0]['Hrdphydsk']['allspace']/1024/1024,1)
			// yzl start 2009/07/14 modify for LV20R1-228
			//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024,1).'GB/':$allspace_0 =null;
			//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024,1).'GB':$freespace_0 =null;
			!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB/':$allspace_0 =null;
			!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024/1024,1).'GB':$freespace_0 =null;
			// yzl end 2009/07/14 modify for LV20R1-228
			$csv_result['Hrdphydsk']['allspace_freespace']=$allspace_0.$freespace_0;


			for($i=0;$i<count($Hrdphydsks);$i++){
				$f='allspace'.$i;
				// yzl start 2009/07/14 modify for LV20R1-228
				//!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024,1).'GB':$csv_result['Hrdphydsk'][$f]=null;
				!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB':$csv_result['Hrdphydsk'][$f]=null;
				// yzl end 2009/07/14 modify for LV20R1-228
			}


			/*if(count($Hrddrvs)==1){
				//!empty($Hrddrvs[0]['Hrddrv']['driver_name'])? $csv_result['Hrddrv']['driver_name']= $Hrddrvs[0]['Hrddrv']['driver_name']: $csv_result['Hrddrv']['driver_name']=null;
				if(!empty($Hrddrvs[0]['Hrddrv']['driver_name']))
					$csv_result['Hrddrv']['driver_name']= $Hrddrvs[0]['Hrddrv']['driver_name'].'('.$Hrddrvs[0]['Hrddrv']['driver'].')';
				else
					$csv_result['Hrddrv']['driver_name']=null;
			}
			else*/{
				for($i=0;$i<count($Hrddrvs);$i++){
					$f='driver_name'.$i;
					//!empty($Hrddrvs[$i]['Hrddrv']['driver_name'])? $csv_result['Hrddrv'][$f] =$Hrddrvs[$i]['Hrddrv']['driver_name']:$csv_result['Hrddrv'][$f]=null;
						
					if(!empty($Hrddrvs[$i]['Hrddrv']['driver_name']))
						$csv_result['Hrddrv'][$f]= $Hrddrvs[$i]['Hrddrv']['driver_name'].'('.$Hrddrvs[$i]['Hrddrv']['driver'].')';
					else
						$csv_result['Hrddrv'][$f]=null;
				}
			}


			for($i=0;$i<count($Hrdmnts);$i++){
				$f='monitor_name'.$i;
				$g='adapterram'.$i;
				$h='horizontal.vertical.bits'.$i;
				$adapterram_0 =round($Hrdmnts[$i] ['Hrdmnt']['adapterram']/1024,1);

				!empty($Hrdmnts[$i]['Hrdmnt']['monitor_name'])? $csv_result['Hrdmnt'][$f]=$Hrdmnts[$i]['Hrdmnt']['monitor_name']:$csv_result['Hrdmnt'][$f]=null;
				!empty($Hrdmnts[$i]['Hrdmnt']['adapterram'])? $csv_result['Hrdmnt'][$g]=round($Hrdmnts[$i]['Hrdmnt']['adapterram']/1024,1).'MB':$csv_result['Hrdmnt'][$g]=null;
				!empty($Hrdmnts[$i]['Hrdmnt']['horizontal'])? $csv_result['Hrdmnt'][$h]=$Hrdmnts[$i]['Hrdmnt']['horizontal'].'*'.$Hrdmnts[$i]['Hrdmnt']['vertical'].'('.$Hrdmnts[$i]['Hrdmnt']['bits'].'bit'.')':$csv_result['Hrdmnt'][$h]=null;
			}


			for($i=0;$i<count($Hrdnics);$i++){
				$f ='nic_name'.$i;
				$g ='mac_address'.$i;
				$h ='ip_address'.$i;
				$j ='gateway'.$i;
				$k ='dns_primary'.$i;
				$l ='dhcp_address'.$i;
				$n ='dhcp_enabled'.$i;
				$o ='wlan'.$i;
				if($Hrdnics[$i]['Hrdnic']['enableflg']==0){
					$enable=__('nouse',true);
				}
				else{ $enable=__('use',true);}
				!empty($Hrdnics[$i]['Hrdnic']['nic_name']) ?$csv_result['Hrdnic'][$f] = $Hrdnics[$i]['Hrdnic']['nic_name'].'('.$enable.')':$csv_result['Hrdnic'][$f]=null;
				!empty($Hrdnics[$i]['Hrdnic']['mac_address']) ?$csv_result['Hrdnic'][$g] = $Hrdnics[$i]['Hrdnic']['mac_address']:$csv_result['Hrdnic'][$g]=null;
				!empty($Hrdnics[$i]['Hrdnic']['ip_address']) ? $csv_result['Hrdnic'][$h] = $Hrdnics[$i]['Hrdnic']['ip_address']:$csv_result['Hrdnic'][$h]=null;
				!empty($Hrdnics[$i]['Hrdnic']['gateway']) ? $csv_result['Hrdnic'][$j] = $Hrdnics[$i]['Hrdnic']['gateway']:$csv_result['Hrdnic'][$j]=null;
				!empty($Hrdnics[$i]['Hrdnic']['dns_primary']) ? $csv_result['Hrdnic'][$k] = $Hrdnics[$i]['Hrdnic']['dns_primary']:$csv_result['Hrdnic'][$k]=null;
				if(!empty($Hrdnics[$i]['Hrdnic']['dns_secondary']))
					$csv_result['Hrdnic'][$k] .= "; ".$Hrdnics[$i]['Hrdnic']['dns_secondary'];
				!empty($Hrdnics[$i]['Hrdnic']['dhcp_address']) ? $csv_result['Hrdnic'][$l] = $Hrdnics[$i]['Hrdnic']['dhcp_address']:$csv_result['Hrdnic'][$l]=null;
				if(!empty($Hrdnics[$i]['Hrdnic']['dhcp_enabled']) && $Hrdnics[$i]['Hrdnic']['dhcp_enabled'] == 1)
					$csv_result['Hrdnic'][$n] = __('dhcp_enabled',true);
				else if(!empty($Hrdnics[$i]['Hrdnic']['ip_address']) && empty($Hrdnics[$i]['Hrdnic']['dhcp_address']))
					$csv_result['Hrdnic'][$n] = __('dhcp_disabled',true);
				else
					$csv_result['Hrdnic'][$n] = __('dhcp_enabled',true);
				
				if(!empty($Hrdnics[$i]['Hrdnic']['wlan']) && $Hrdnics[$i]['Hrdnic']['wlan'] == 1)
					$csv_result['Hrdnic'][$o] = __('is_wlan',true);
				else
					$csv_result['Hrdnic'][$o] = __('isnot_wlan',true);
				
			}
			!empty($Astoses['Astose']['domain_name'])?$csv_result['Astose']['domain_name']=$Astoses['Astose']['domain_name']:$csv_result['Astose']['domain_name'] =null;

			!empty($Astoses['Astose']['os_name'])?$csv_result['Astose']['os_name']= $Astoses['Astose']['os_name']:$csv_result['Astose']['os_name'] =null;
			!empty($Astoses['Astose']['product_id'])?$csv_result['Astose']['product_id']= $Astoses['Astose']['product_id']:$csv_result['Astose']['product_id'] =null;
			!empty($Astoses['Astose']['install_time'])?$csv_result['Astose']['install_time']= $Astoses['Astose']['install_time']:$csv_result['Astose']['install_time'] =null;
			!empty($Astoses['Astose']['version'])?$csv_result['Astose']['version']= $Astoses['Astose']['version']:$csv_result['Astose']['version'] =null;
			isset($Astoses['Astose']['activation'])?$Astose_activation= $Astoses['Astose']['activation'] :$Astose_activation =null;

			//xinw start 20080217
			//xushanning start 2009/06/05 mofify for LogvillageChinese
			// yaozl start 2009/09/01 modify for LV20R1-280
			//if ($Astose_activation == '0') {
			//if ($Astose_activation == '1') {
			if ($Astose_activation == '0') {
			// yaozl end 2009/09/01 modify for LV20R1-280				
			//xushanning end 2009/06/05 mofify for LogvillageChinese
				$Astose_activation='○';
			}
			//xushanning start 2009/06/05 mofify for LogvillageChinese
			// yaozl start 2009/09/01 modify for LV20R1-280
			//if($Astose_activation=='1'){
			//if($Astose_activation=='0'){
			if($Astose_activation=='1'){
			// yaozl end 2009/09/01 modify for LV20R1-280				
			//xushanning end 2009/06/05 mofify for LogvillageChinese
				$Astose_activation='×';
			}
			// yaozl start 2009/09/01 modify for LV20R1-280
			if (strpos($Astoses['Astose']['os_name'],"2000")) {
				$Astose_activation = "-";
			}
			// yaozl end 2009/09/01 modify for LV20R1-280
			//xinw end 20080217
			$this->set('Astose_activation',$Astose_activation);

			isset($Astoses['Astose']['activation'])?$csv_result['Astose']['activation']= $Astose_activation :$csv_result['Astose']['activation'] =null;
			//			 $this->set('Astose_activation',$Astose_activation);

			!empty($Astoses)?$csv_result['Astose']['user_name']= $Astoses['Astose']['user_name']:$csv_result['Astose']['user_name'] =null;
			!empty($Astoses)?$csv_result['Astose']['organization']= $Astoses['Astose']['organization']:$csv_result['Astose']['organization'] =null;
			!empty($Astoses)?$csv_result['Astose']['description']= $Astoses['Astose']['description']:$csv_result['Astose']['description'] =null;

			$result_Astacts="";

			for($i=0;$i<count($Astacts);$i++){
				$f=$Astacts[$i]['Astact']['account_name'].' , ';
				!empty($Astacts[$i]['Astact']['account_name'])?$result_Astacts=$result_Astacts.$f:$result_Astacts=null;
			}

			$result_Astacts = substr($result_Astacts, 0, strlen($result_Astacts)-2);

			!empty($result_Astacts)?$csv_result['Astact']['account_name'] = $result_Astacts:$csv_result['Astact']['account_name']=null;

			!empty($logonuser)?$csv_result['Logonuser']['account_name'] = $logonuser['Logonuser']['account_name']:$csv_result['Logonuser']['account_name']=null;
			!empty($logonuser)?$csv_result['Logonuser']['last_logon'] = $logonuser['Logonuser']['last_logon']:$csv_result['Logonuser']['last_logon']=null;

			$bitlocker = "";
			if(!empty($Hrdlogdsks)){
				$i=0;
				foreach ($Hrdlogdsks as $b)
				{
					if($b['Hrdlogdsk']['drivetype'] == 3){
						$bitlocker .= $b['Hrdlogdsk']['name'];
						if($b['Hrdlogdsk']['protection'] == 0)
							$bitlocker .=  __('bl_status_0',$return = true);
						else if($b['Hrdlogdsk']['protection'] == 1)
							$bitlocker .=  __('bl_status_1',$return = true);
						else if($b['Hrdlogdsk']['protection'] == 2)
							$bitlocker .=  __('bl_status_2',$return = true);
						else 
							$bitlocker .= __('bl_status_',$return = true);
						$bitlocker .= ", ";
					}
					
					$dtype = $b['Hrdlogdsk']['drivetype'];
					$typestr = "CD-ROM ディスク";
					if($dtype == 2)  
						$typestr = "リムーバブルディスク";
					else if($dtype == 3)  
						$typestr = "ローカル固定ディスク";
					else if($dtype == 4)  
						$typestr = "ネットワークドライブ";
					else if($dtype == 5)  
						$typestr = "CD-ROM ディスク";
					else if($dtype == 6)  
						$typestr = "RAMディスク";
					
					if($b['Hrdlogdsk']['size'] < 0)
						$size = "-";
					else
						$size = number_format($b['Hrdlogdsk']['size']/1024/1024).'MB';
					
					if($b['Hrdlogdsk']['freespace'] < 0)
						$free = "-";
					else
						$free = number_format($b['Hrdlogdsk']['freespace']/1024/1024).'MB';
					
					$csv_result['Hrdlogdsk']['data'.$i] = sprintf("%s[%s]  |  （%s）%s  （%s）%s", 
						$b['Hrdlogdsk']['name'],$typestr,
						__('lgdsk_size',$return = true),$size, 
						__('lgdsk_free',$return = true),$free
						);
					$i++;
				}
				$bitlocker = substr($bitlocker, 0, strlen($bitlocker)-2);
			}
			$csv_result['Bitlocker']['status'] = $bitlocker;
			
			
			if(!empty($Addition)&&!empty($result_Hstadt)){

				foreach ($Addition as $v){
					$f =$v['Addition']['addition_name'];
					// zhangs start 20080218
					// !empty( $csv_result['Hstadt'][$f])? $csv_result['Hstadt'][$f] =  $csv_result['Hstadt'][$f]: $csv_result['Hstadt'][$f] =NULL;}
					!empty($f)? $csv_result['Hstadt'][$f] =  $result_Hstadt[0]['Hstadt'][$f]: $csv_result['Hstadt'][$f] =NULL;}
					// zhangs end 20080218
			}
			//
			//			            echo"<pre>";
			//			            var_dump($csv_result);
			//--end csv array--
			//         debug($csv_result,true);exit;
			if($type =='csv1')
			{
				$this->csvdown1($Asthrds['Asthrd']['id'],$Astsfws,$csv_result);exit;
			}

	}

	function index2($sf1=null,$sf4=null)
	{
		//echo '@@@@@@@@@@@@@@@@@@@@@@@@@@'.$sf1.'#####'.$sf4;
		$this->index($sf1, null, null,$sf4);
		$this->render("index");
	}
	function index($sf1=null,$sf2=null,$sf3=null,$sf4=null,$sf5=null,$hoststatus=null,$updateprogram=null){
		if(!empty($sf1)||!empty($sf2)||!empty($sf3)||!empty($sf4)||!empty($sf5)){
$this->data['Group']['groupname'] = $sf1;//echo $sf2;
			$this->set('sf1', $sf1);//グループ
			$this->set('sf2', $sf2);//ソフト名
			$this->set('sf3', $sf3);//version
			$this->set('sf4', $sf4);//メーカー
			$this->set('sf5', $sf5);//ライセンスコードor更新プログラムの親
		}
		//    	 echo "==============1==================";
		$group = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('group',$group);
		if(isset($sf1))
		{
			$this->set('sf1',$sf1);

		}
		//SW台帳から飛んできたとき
		if(!is_null($hoststatus))
			$this->data['Host']['status'] = $hoststatus;
		/*echo $sf1."<br/>";
		echo $sf2."<br/>";
		echo $sf3."<br/>";
		echo $sf4."<br/>";
		echo $sf5."<br/>";
		echo $updateprogram."<br/>";*/
		if(!is_null($updateprogram))
			$this->set('updateprogram',$updateprogram);
	}

	function search($type = null){
		  //debug($_POST, true);
		  $this->layout="ajax";	
//var_dump($type);
//var_dump(is_null($this->data['Asthrd']['search_by_date']));

		 $date_criteria = "";
		 $hdwslist = array();
		if($type != 'back' && !is_null($this->data['Asthrd']['search_by_date']) ){

			if($this->data['Asthrd']['search_by_date'] != 0 ){
				$error = array();
				if(false == checkdate($this->data['dt_check']['start_month'], $this->data['dt_check']['start_day'], $this->data['dt_check']['start_year'])){
					//$this->layout='ajax';
					$error[] = __("E-01100", true);
					$this->set('err', $error);
					$this->render('empty');
					exit;
				}
				$start_time = $this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day'];
				if(false == checkdate($this->data['dt_check']['end_month'], $this->data['dt_check']['end_day'], $this->data['dt_check']['end_year'])){
					//$this->layout='ajax';
					$error[] = __("E-01100", true);
					$this->set('err', $error);
					$this->render('empty');
					exit;
				}
				$end_time = $this->data['dt_check']['end_year']."-".$this->data['dt_check']['end_month']."-".$this->data['dt_check']['end_day'];
				if($start_time > $end_time){
					//$this->layout='ajax';
					$error[] = __("error_date", true);
					$this->set('err', $error);
					$this->render('empty');
					exit;
				}
				$datefield = "";
				if($this->data['Asthrd']['search_by_date'] == 1 )
					$datefield = "Asthrd.log_time";
				else if($this->data['Asthrd']['search_by_date'] == 2 )
					$datefield = "Host.regist_time";
				else if($this->data['Asthrd']['search_by_date'] == 3 )
					$datefield = "Host.update_time";
				 $date_criteria = $datefield ." BETWEEN '".$start_time."' and '".$end_time."' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND" ;
			//echo $date_criteria;
				$this->data['dt_check']['criteria'] = $date_criteria;
				
				$hdwslist['date_criteria']=$date_criteria;
			}
			
			$hdwslist['groupname']=$this->data['Group']['groupname'];
				$hdwslist['input_keyword']=$this->data['Asthrd']['input_keyword'];
				$hdwslist['host_name']=$this->data['Host']['host_name'];
				
				$hdwslist['sf1']=$this->data['Astsfw']['sf1'];
				$hdwslist['sf2']=$this->data['Astsfw']['sf2'];
				$hdwslist['sf3']=$this->data['Astsfw']['sf3'];
				$hdwslist['sf4']=$this->data['Astsfw']['sf4'];
				$hdwslist['sf5']=$this->data['Astsfw']['sf5'];
				$hdwslist['updateprogram']=$this->data['Astsfw']['updateprogram'];
				
				$hdwslist['count']=$this->data['Asthrd']['count'];
				
				$this->Session->write('hdwslist', $hdwslist);
				//echo "write";
			//debug($hdwslist);
		}elseif($type == 'back')
		{//詳細から戻ってきた場合,項目値をクリックした場合
			$hdwslist = $this->Session->read('hdwslist');
			$this->data['dt_check']['criteria'] =$hdwslist['date_criteria'];
			$this->data['Group']['groupname'] = $hdwslist['groupname'];
			$this->data['Asthrd']['input_keyword']=	$hdwslist['input_keyword'];
			$this->data['Host']['host_name']=$hdwslist['host_name'];
			
				$this->data['Astsfw']['sf1'] = $hdwslist['sf1'];
				$this->data['Astsfw']['sf2'] = $hdwslist['sf2'];
				$this->data['Astsfw']['sf3'] = $hdwslist['sf3'];
				$this->data['Astsfw']['sf4'] = $hdwslist['sf4'];
				$this->data['Astsfw']['sf5'] = $hdwslist['sf5'];
				$this->data['Astsfw']['updateprogram'] = $hdwslist['updateprogram'];
				
				$this->data['Asthrd']['count']=$hdwslist['count'];
				//echo "read";
		//debug($hdwslist);	
		}
		  
		$csv_result1=array();
		if(!empty($this->data['Group']['groupname'])){
			$group_id = $this->data['Group']['groupname'];
			$groupname_csv=$this->Group->find(array("Group.id" => $this->Lv->spec_char_dbm($group_id)),'Group.group_name',null,null,null,-1);  
		}
			
			!empty($groupname_csv['Group']['group_name'])?$csv_result1['Group']['groupname']=$groupname_csv['Group']['group_name']:$csv_result1['Group']['groupname']=null;
			if(!empty($this->data['Asthrd']['input_keyword'])){
				$input_keyword=$this->data['Asthrd']['input_keyword'] ;
				!empty($input_keyword)?$csv_result1['Asthrd']['input_keyword']=$input_keyword:$csv_result1['Asthrd']['input_keyword']=null;
			}
			if(!empty($this->data['Host']['host_name'])){
				$input_host_name=$this->data['Host']['host_name'] ;
				!empty($input_host_name)?$csv_result1['Host']['host_name']=$input_host_name:$csv_result1['Host']['host_name']=null;
			}

				$this->addModel("Temp");
				$this->Temp->useTable = "temppsoptusers";
				$this->lists();
				
				//$link_keyword= $this->Lv->url_param_decode2($this->data['host']['link_keyword']);
				$link_keyword= urldecode($this->data['host']['link_keyword']);
				//$link_title_mun=$this->Lv->url_param_decode2($this->data['host']['link_title_mun']) ;
				$link_title_mun= urldecode($this->data['host']['link_title_mun']) ;
				//echo $link_keyword." ".$link_title_mun;return;
				$input_keyword=$this->data['Asthrd']['input_keyword'] ;
				$input_host_name=$this->data['Host']['host_name'] ;
				$groupid = $this->data['Group']['groupname'] ;

				$count = $this->data['Asthrd']['count'];
				if(!is_numeric($count))
					$count = 10;
				$this->set('countperpage',$count);	
				
				$Addition = $this->Addition->findAll(null,null,'id ASC','0',null,null);
				$this->set('Addition',$Addition);

				$Hstalthrd = $this->Hstalthrd->find();

				$this->set('Hstalthrd',$Hstalthrd['Hstalthrd']['low']);
				//--laug
				$sear=__('sear',true);
				$mmachine=__('machine',true);
				$mmaker=__('maker',true);
				$mCPU=__('CPU',true);
				$mos=__('OS',true);
				$mSP=__('SP',true);
				//laug
				//xinw start 20080217
				if($link_title_mun==1){
					$this->set('t',$mmachine.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==2){
					$this->set('t',$mmaker.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==3){
					$this->set('t',$mCPU.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==4){
					$this->set('t',$mos.' 「'.$link_keyword.'」 '.$sear);
				}
				else if($link_title_mun==5){
					$this->set('t',$mSP.' 「'.$link_keyword.'」 '.$sear);
				}
				else if(!empty($link_title_mun)){
					$this->set('t', htmlspecialchars($link_title_mun)." 「".htmlspecialchars($link_keyword)."」 ".$sear);
				}
				//xinw end 20080217

				if($type==1){
					$this->data['Astsfw']['sf1']='';
					$this->data['Astsfw']['sf2']='';
					$this->data['Astsfw']['sf3']='';
					$this->data['Astsfw']['sf4']='';
					$this->data['Astsfw']['sf5']='';
					//    	$this->data['Astsfw']['sf1']='';
					//    	unset($this->data['Astsfw']['sf2']);
					//    	unset($this->data['Astsfw']['sf3']);
					//    	unset($this->data['Astsfw']['sf4']);
					//    	unset($this->data['Astsfw']['sf5']);
					$this->data['Astsfw']['updateprogram']='';
				}		
				
				$search_update = false;
				$search_updateinstalled = true;
				if($type!='1'&&empty($link_keyword)&&empty($input_keyword)&&empty($input_host_name))
				{
					if(isset($this->data['Astsfw']['sf1'])){
						$sf_group=$this->data['Astsfw']['sf1'] ;
					}

					if(isset($this->data['Astsfw']['sf2'])){
						$sf_soft=$this->Lv->url_param_decode2($this->data['Astsfw']['sf2']);
					}//	2007/11/28 zhaoli 変更

					if(isset($this->data['Astsfw']['sf3'])){
						$sf_version=$this->Lv->url_param_decode2($this->data['Astsfw']['sf3']);
					}

					if(isset($this->data['Astsfw']['sf4'])){
						$sf_maker=$this->Lv->url_param_decode2($this->data['Astsfw']['sf4']);
					}//	2007/11/28 zhaoli 変更

					if(isset($this->data['Astsfw']['sf5'])) {
						$sf_license=$this->Lv->url_param_decode2($this->data['Astsfw']['sf5']);
					}
					
					//更新プログラムから遷移
					if(isset($this->data['Astsfw']['updateprogram'])) {
						if($this->data['Astsfw']['updateprogram'] === 'update'){
							$search_update = true;
							$search_updateinstalled = true;
						}else if($this->data['Astsfw']['updateprogram'] === 'notupdate'){
							$search_update = true;
							$search_updateinstalled = false;
						}
						/*echo $sf_group;
						echo $sf_soft;
						echo $sf_version;
						echo $sf_maker;
						echo $sf_license;
						echo $this->data['Astsfw']['updateprogram'];*/
					}
										//							  debug($this->data,true);
				}
				$condition_tem=array("1=1");
				//-------------更新プログラム------------
				if($search_update &&
					(!empty($sf_group)||!empty($sf_soft)||!empty($sf_version)||!empty($sf_maker)||!empty($sf_license))
					&&(empty($type) || $type=='csv' || $type = 'back')){
					$asso = array( 'Rlthstgrp : rlthstgrps : LEFT' => array('Updateprogram.host_id = Rlthstgrp.host_id'),
					'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
					'Grpauth : grpauths' => array('Group.id = Grpauth.group_id')
					);

					$hcount=array("1=1");
					if(!empty($sf_group)){
						$hcount[]="Grpauth.org_grp_id =".$sf_group."";
						$fg=1;$this->set('fg',$fg);
					}
					if(!empty($sf_soft)){
						$hcount[]="Updateprogram.name ='".$this->Lv->spec_char_dbm($sf_soft)."'";//	2007/11/28 zhaoli 変更
					}

					if($sf_version =="empty"){
						$hcount[]="Updateprogram.version = ''";
					}elseif($sf_version!="null" && $sf_version!=null){
						$hcount[]="Updateprogram.version = '".$this->Lv->spec_char_dbm($sf_version)."'";
					}

					if($sf_maker!="null"&&$sf_maker!=null)  {
						$hcount[]="Updateprogram.maker = '".$this->Lv->spec_char_dbm($sf_maker)."'";	//	2007/11/28 zhaoli 変更
					}

					if(!empty($sf_license)&& $sf_license!="null"){
						$hcount[]="Updateprogram.parent_name = '".$this->Lv->spec_char_dbm($sf_license)."'";	//	2007/11/28 zhaoli 変更
					}

					$assoSS = array( 'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
					'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
					'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
					);

					$Astsfw = $this->Updateprogram->findByAsso($hcount, array('distinct(Updateprogram.host_id) as Updateprogram__host_ids'), null, null, null, $asso);
					if(!empty($Astsfw)){
						$Temp_host_id = "";
						foreach ($Astsfw as $v){
							$f =$v['Updateprogram']['host_ids'];
							$Temp_host_id =$Temp_host_id.$f.',';
						}
						$Temp_host_id = substr($Temp_host_id, 0, strlen($Temp_host_id)-1);

						if($search_updateinstalled){
							if(count($Astsfw) == 1){
								$condition_tem =array( "Temp.host_id =".$Temp_host_id);
							}
							else{ 
								$condition_tem =array( "Temp.host_id in (".$Temp_host_id.")");
							}
						}else{
							if(count($Astsfw) == 1){
								$condition_tem =array( "Temp.host_id !=".$Temp_host_id);
							}
							else{ 
								$condition_tem =array( "Temp.host_id not in (".$Temp_host_id.")");
							}
						}
						$condition_tem[] = "Temp.ostype = 1";
					}
					else{
						$asso_tem = array();

						$tem_crit = "Temp.host_name as Temp__host_name,
							Temp.host_id as Temp__host_id,
							Temp.hardware_id as Temp__hardware_id,
							Temp.machine as Temp__machine,
							Temp.maker as Temp__maker,
							Temp.serialno as Temp__serialno,
							Temp.cpu_name as Temp__cpu_name,
							Temp.cpu_number as Temp__cpu_number,
							Temp.hrdmem_capacity as Temp__hrdmem_capacity,
							Temp.hrdphydsk_allspace as Temp__hrdphydsk_allspace,
							Temp.hrdphydsk_freespace as Temp__hrdphydsk_freespace,
							Temp.hrdphydsk_late as Temp__hrdphydsk_late,
							Temp.os_name as Temp__os_name,
							Temp.servicepack as Temp__servicepack,
							Temp.product_id as Temp__product_id,
							Temp.activation as Temp__activation,
							Temp.description as Temp__description";		

						foreach ($Addition as $v){
							$f =$v['Addition']['addition_name'];
							$a =','.'Temp.'.$f.' as Temp__'.$f;
							$tem_crit = $tem_crit.$a;
						}
						$tem_criteria =	array($tem_crit);
						//		         $condition_tem1 = array("Grpauth.org_grp_id = ". $this->_getUserGroup());
						$condition_tem1 = array("1=1");
						$data1= $this->Temp->findByAsso($condition_tem1, $tem_criteria,'Temp.host_name',null,null,$asso_tem);
						$data_sum = count($data1);
						$this->set( 'data',"");
						$this->set( 'data_sum',$data_sum);
						$this->set( 'data_search',"");

						$this->render('search');
					}
				}
				//-------------sfws------------
				else if((!empty($sf_group)||!empty($sf_soft)||!empty($sf_version)||!empty($sf_maker)||!empty($sf_license))
					&&(empty($type) || $type=='csv' || $type = 'back')){
					$asso = array( 'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
					'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
					'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
					'C : (select host_id, max(log_time) as log_time from astsfws group by host_id)' 
						=> array('C.host_id = Astsfw.host_id and C.log_time = Astsfw.log_time')
					);

					$hcount=array("1=1");
					if(!empty($sf_group)){
						$hcount[]="Grpauth.org_grp_id =".$sf_group."";
						$fg=1;$this->set('fg',$fg);
					}
					if(!empty($sf_soft)){

						$hcount[]="Astsfw.software_name ='".$this->Lv->spec_char_dbm($sf_soft)."'";//	2007/11/28 zhaoli 変更

					}

					if($sf_version =="empty"){
						$hcount[]="Astsfw.version = ''";
					}elseif($sf_version!="null"&&$sf_version!=null){
						$hcount[]="Astsfw.version = '".$this->Lv->spec_char_dbm($sf_version)."'";
					}
					elseif($sf_version =="null"){
						$hcount[] = '1=1';
					}

					if($sf_maker!="null"&&$sf_maker!=null)  {
						$hcount[]="Astsfw.maker = '".$this->Lv->spec_char_dbm($sf_maker)."'";	//	2007/11/28 zhaoli 変更
					}
					elseif($sf_maker=="null"){
						if(!empty($sf_license)){
							$hcount[] = '1=1';
						}else{
							$hcount[]="(Astsfw.maker = '' or Astsfw.maker is NULL)";
						}
					}

					//----------------------------// 2007/11/21 zhaoli 変更
					$check_office = strrpos($sf_soft, "Office");
					if($check_office === false){
						if(!empty($sf_license)&& $sf_license!="null"){
							//xinw start 20080221
							$hcount[] = "Astsfw.licence_code like '%".$this->Lv->spec_char_like($sf_license)."%'";// 2007/09/25 zhaoli 変更
							//xinw end 20080221
						}

						if($sf_license=="null"){
							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";// 2007/09/25 zhaoli 変更
						}
						//zhangs start 20080723
						if(empty($sf_license)){
							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";
						}
						//zhangs end 20080723
					}else{

						if(!empty($sf_license)&& $sf_license!="null"){
							$hcount[] = "lower(Astsfw.software_name) like '%office%' and LEFT(Astsfw.licence_code,17)  = '".$sf_license."'";
						}
						if( $sf_license=="null"){
							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";
						}
						
						//zhangs start 20080723
						if(empty($sf_license)){

							$hcount[] = "(trim(Astsfw.licence_code) = '' or Astsfw.licence_code is null)";

						}
					}
					$assoSS = array( 'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
					'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
					'Grpauth : grpauths' => array('Group.id = Grpauth.group_id'),
					);

					$Astsfw = $this->Astsfw->findByAsso($hcount, array('distinct(Astsfw.host_id) as Astsfw__host_ids'), null, null, null, $asso);



					if(!empty($Astsfw)){
						$Temp_host_id = "";
						foreach ($Astsfw as $v){
							$f =$v['Astsfw']['host_ids'];
							$Temp_host_id =$Temp_host_id.$f.',';
						}
						$Temp_host_id = substr($Temp_host_id, 0, strlen($Temp_host_id)-1);

						if(count($Astsfw) == 1){
							$condition_tem =array( "Temp.host_id =".$Temp_host_id);
						}
						else{ $condition_tem =array( "Temp.host_id in (".$Temp_host_id.")");}

					}
					else{
						$asso_tem = array(

						);

						$tem_crit = "Temp.host_name as Temp__host_name,
							Temp.host_id as Temp__host_id,
							Temp.hardware_id as Temp__hardware_id,
							Temp.machine as Temp__machine,
							Temp.maker as Temp__maker,
							Temp.serialno as Temp__serialno,
							Temp.cpu_name as Temp__cpu_name,
							Temp.cpu_number as Temp__cpu_number,
							Temp.hrdmem_capacity as Temp__hrdmem_capacity,
							Temp.hrdphydsk_allspace as Temp__hrdphydsk_allspace,
							Temp.hrdphydsk_freespace as Temp__hrdphydsk_freespace,
							Temp.hrdphydsk_late as Temp__hrdphydsk_late,
							Temp.os_name as Temp__os_name,
							Temp.servicepack as Temp__servicepack,
							Temp.product_id as Temp__product_id,
							Temp.activation as Temp__activation,
							Temp.description as Temp__description";		

						foreach ($Addition as $v){

							$f =$v['Addition']['addition_name'];
							$a =','.'Temp.'.$f.' as Temp__'.$f;
							$tem_crit = $tem_crit.$a;
						}
						$tem_criteria =	array($tem_crit);
						//		         $condition_tem1 = array("Grpauth.org_grp_id = ". $this->_getUserGroup());
						$condition_tem1 = array("1=1");
						$data1= $this->Temp->findByAsso($condition_tem1, $tem_criteria,'Temp.host_name',null,null,$asso_tem);
						$data_sum = count($data1);
						$this->set( 'data',"");
						$this->set( 'data_sum',$data_sum);
						$this->set( 'data_search',"");

						$this->render('search');
					}
				}

				if(!empty($input_host_name)){
					$keyword = $this->Lv->spec_char_dbm($input_host_name);
					//$keyword_like = $this->Lv->spec_char_like($input_host_name);

					//$condition_tem[] = "lower(Temp.host_name) like '%".strtolower($keyword_like)."%'";
					$condition_tem[] = "lower(Temp.host_name) = '".strtolower($keyword)."'" ;
				}
				if(!empty($input_keyword)){
					$keyword = $this->Lv->spec_char_dbm($input_keyword);
					$keyword_like = $this->Lv->spec_char_like($input_keyword);

					$str_host = array();

					$str_host[] = "lower(Temp.host_name) = '".strtolower($keyword)."'" ;
					$str_host[] = "lower(Temp.host_name) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.machine) = '".strtolower($keyword)."'" ;
					$str_host[] = "lower(Temp.machine) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.maker) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.maker) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.serialno) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.serialno) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.product_id) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.product_id) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.os_name) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.os_name) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.servicepack) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.servicepack) like '%".strtolower($keyword_like)."%'";

					$str_host[] = "lower(Temp.cpu_name) = '".strtolower($keyword)."'";
					$str_host[] = "lower(Temp.cpu_name) like '%".strtolower($keyword_like)."%'";
					//wangs end 20080202

					//	        $str_host = implode(' or ', $str_host);

					foreach ($Addition as $v){

						$f =$v['Addition']['addition_name'];
						$str_host[] ="Temp.".$f." ='".$keyword."'";

					}
					foreach ($Addition as $v){

						$f =$v['Addition']['addition_name'];
						$str_host[] ="Temp.".$f." like '%".$keyword_like."%'";

					}
					$str_host = implode(' or ', $str_host);
					$condition_tem[] = "(" . $str_host. ")";

				}

				if($link_keyword != "")
				{
					$keyword = $this->Lv->spec_char_dbm($link_keyword);

					$str_host = array();
					$str_host[] = "Temp.machine = '".$keyword."'" ;
					$str_host[] = "Temp.maker = '".$keyword."'";
					$str_host[] = "Temp.os_name = '".$keyword."'";
					$str_host[] = "Temp.servicepack = '".$keyword."'";
					$str_host[] = "Temp.cpu_name = '".$keyword."'";

					foreach ($Addition as $v){
						$f =$v['Addition']['addition_name'];
						$str_host[] ="Temp.".$f." ='".$keyword."'";
					}
					$str_host = implode(' or ', $str_host);

					$condition_tem[] = "(" . $str_host. ")";
				}

				$asso_tem = array(	);
				$tem_crit = "	Temp.host_name as Temp__host_name,
							Temp.host_id as Temp__host_id,
							Temp.hardware_id as Temp__hardware_id,
							Temp.ip_address as Temp__ip_address,
							Temp.domain_name as Temp__domain_name,
							Temp.machine as Temp__machine,
							Temp.maker as Temp__maker,
							Temp.serialno as Temp__serialno,
							Temp.cpu_name as Temp__cpu_name,
							Temp.cpu_number as Temp__cpu_number,
							Temp.hrdmem_capacity as Temp__hrdmem_capacity,
							Temp.hrdphydsk_allspace as Temp__hrdphydsk_allspace,
							Temp.hrdphydsk_freespace as Temp__hrdphydsk_freespace,
							Temp.hrdphydsk_late as Temp__hrdphydsk_late,
							Temp.os_name as Temp__os_name,
							Temp.servicepack as Temp__servicepack,
							Temp.log_time as Temp__log_time,
							Temp.product_id as Temp__product_id,
							Temp.activation as Temp__activation,
							Temp.description as Temp__description";		



				foreach ($Addition as $v){

					$f =$v['Addition']['addition_name'];
					$a =','.'Temp.'.$f.' as Temp__'.$f;
					$tem_crit = $tem_crit.$a;
				}
				$tem_criteria =	array($tem_crit);
				
				$this->Pagination->show = $count;
				list($order,$limit,$page) = $this->Pagination->init($condition_tem, null, array('ajaxDivUpdate'=>'view', 'url'=>'/assets_mng_hdws/search', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso_tem), 'sortBy' => $this->Lv->sortBy('Temp.host_name')));

				if($type =='csv' || $type=='csv2'){
					$data_csv= $this->Temp->findByAsso($condition_tem, $tem_criteria,$order,null,null,$asso_tem);
				
					for($i=0;$i<count($data_csv);$i++){
						$data_csv[$i]['Temp']['hrdphydsk_allspace'] = round($data_csv[$i]['Temp']['hrdphydsk_allspace']/1024/1024/1024,1);
						$data_csv[$i]['Temp']['hrdphydsk_freespace'] = round($data_csv[$i]['Temp']['hrdphydsk_freespace']/1024/1024/1024,1);
						$data_csv[$i]['Temp']['hrdmem_capacity'] = round($data_csv[$i]['Temp']['hrdmem_capacity']/1024,1);
					}
					if($type =='csv')
					{
						$this->csvdown($data_csv,$csv_result1);exit;
					}
					if($type=='csv2'){
						$this->csvdown2($data_csv,$csv_result1);exit;
					}
				}else{
					$data = $this->Temp->findByAsso($condition_tem, $tem_criteria,$order,$limit,$page,$asso_tem);

					$condition_tem1 = array("1=1" );
					$data1= $this->Temp->findByAsso($condition_tem1, $tem_criteria,$order,null,null,$asso_tem);

					$data_sum = count($data1);
					$data_search = count($data);
					if(!empty($sf_group)&&isset($Astsfw)){
						$data_sum = count($data1);
						$data_search = count($Astsfw);
					}

					//		 	debug($data,true);
					empty($data)? $data=array():$data;
					$this->set('data',$data);
					$this->set('data_sum',$data_sum);
					$this->set('data_search',$data_search);
					for($i=0;$i<count($data);$i++){
						$csvAS =round($data[$i]['Temp']['hrdphydsk_allspace']/1024/1024/1024,1);
						$csvFR=round($data[$i]['Temp']['hrdphydsk_freespace']/1024/1024/1024,1);
						$csvCP =round($data[$i]['Temp']['hrdmem_capacity']/1024,1);

						$data[$i]['Temp']['hrdphydsk_allspace']!==null&&$data[$i]['Temp']['hrdphydsk_allspace']!==""?$data[$i]['Temp']['hrdphydsk_allspace']=$csvAS:$data[$i]['Temp']['hrdphydsk_allspace']=null;
						$data[$i]['Temp']['hrdphydsk_freespace']!==null&&$data[$i]['Temp']['hrdphydsk_freespace']!==""?$data[$i]['Temp']['hrdphydsk_freespace']=$csvFR:$data[$i]['Temp']['hrdphydsk_freespace']=null;
						$data[$i]['Temp']['hrdmem_capacity']!==null&&$data[$i]['Temp']['hrdmem_capacity']!==""?$data[$i]['Temp']['hrdmem_capacity']=$csvCP:$data[$i]['Temp']['hrdmem_capacity']=null;
					}
				}
				


	}// end search
	
	function strOrnull($str){
		return is_null($str) ? 'NULL' : "'".$this->Lv->spec_char_dbm($str)."'";
	}
	function numOrnull($num){
		return is_null($num) ? 'NULL' : $num;
	}
	
	function lists(){
		//debug($this->data);
		$hostname = "";
		if(!empty($this->data)){
			$groupid = $this->data['Group']['groupname'] ;
			if(!empty($this->data['Host']['host_name']))
				$hostname = $this->Lv->spec_char_dbm($this->data['Host']['host_name']);
		}
		else{
			$groupid =$this->_getUserGroup();
		}

			$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);

			$feld="        		 id serial,
						         host_id integer,
						         hardware_id integer NULL,
						         host_name varchar(40),
								 ostype integer,
								 ip_address varchar(40) NULL,
								 domain_name varchar(256) NULL,
						         machine varchar(256) NULL,
						         maker varchar(256) NULL,
						         serialno varchar(256) NULL,
						         cpu_name varchar(127) NULL,
						         cpu_number integer NULL,
						         hrdmem_capacity integer NULL,
						         hrdphydsk_allspace DECIMAL(38,0) NULL,
						         hrdphydsk_freespace DECIMAL(38,0) NULL,
						         hrdphydsk_late integer NULL,
						         os_name varchar(128) NULL,
						         servicepack varchar(200) NULL,
								 log_time DATETIME default NULL,
						         product_id varchar(100) NULL,
						         activation smallint NULL,
								 description varchar(256) NULL";			
			// yzl end 2009/07/14 modify for LV20R1-228

			foreach ($Addition as $v){

				$f =$v['Addition']['addition_name'];
				$a =','.$f.' varchar(200) NULL';
				$feld = $feld.$a;

			}

			$result = $this->Host->query('CREATE TEMPORARY TABLE temppsoptusers ('.$feld.')');


			if($result === false){
				debug("CREATE TEMPORARY TABLE failed!", true);
			}
			$group_0=$this->_getUserGroup();
			$this->set('group_0',$group_0);
			$this->layout='ajax';

			$this->set('Addition',$Addition);
			//-------------sfws--end-------//

			//2007-09-20 zhaoli 16:22
			$Hostasso = array(
			'Asthrd : asthrds : left' => array('Host.id = Asthrd.host_id'),
			'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id '),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id '),
			'Grpauth : grpauths : left' => array('Grpauth.group_id = Group.id '),
			);
			$groupBy =" Host.id,Asthrd.id" ;

			//	del by wq 	 $Host_criteria=array("Host.status!= 0 and Grpauth.org_grp_id=".$groupid,"GROUP BY" => $groupBy,);
			$Host_criteria=array();
			$Host_criteria[]= "Host.status in (".$this->data['Host']['status'].")" ;
			if($hostname != "")
				$Host_criteria[]= "Host.host_name = '".$hostname."'";
			//$Host_criteria[]= "Host.status != 1" ;
			$Host_criteria[]= "Grpauth.org_grp_id = ".$groupid;
			if(isset($this->data['dt_check']['criteria']))
				$Host_criteria[]= $this->data['dt_check']['criteria'];
			$Host_criteria["GROUP BY"] = $groupBy;



			$Dataasso = array(
				'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id '),
				'Group : groups' => array('Group.id = Rlthstgrp.group_id '),
				'Grpauth : grpauths : left' => array('Grpauth.group_id = Group.id '),
				'Asthrd : asthrds : left' => array('Host.id = Asthrd.host_id'),
				'Hrdcpu : hrdcpus : left' => array('Asthrd.id = Hrdcpu.hardware_id'),
				'Hrdcpu2 : (select hardware_id, count(cpu_name) as cpu_num from hrdcpus group by hardware_id) : left' => array('Asthrd.id = Hrdcpu2.hardware_id'),
				//'Hrdmem : hrdmems : left' => array('Asthrd.id = Hrdmem.hardware_id'),
				'Hrdmem2 : (select hardware_id, sum(capacity) as capacitys from hrdmems group by hardware_id) : left' => array('Asthrd.id = Hrdmem2.hardware_id'),
				//'Hrdphydsk : hrdphydsks : left' => array('Asthrd.id = Hrdphydsk.hardware_id'),
				'Hrdphydsk2 : (select hardware_id, sum(allspace) as allspace from hrdphydsks group by hardware_id) : left' => array('Asthrd.id = Hrdphydsk2.hardware_id'),
				//'Hrdlogdsk : hrdlogdsks : left' => array('Asthrd.id = Hrdlogdsk.hardware_id', "Hrdlogdsk.drivetype != 4"),
				'Hrdlogdsk2 : (select hardware_id, sum(freespace) as freespace from hrdlogdsks where drivetype != 4 group by hardware_id) : left' => array('Asthrd.id = Hrdlogdsk2.hardware_id'),
				'Hrdnic : hrdnics : left' => array('Asthrd.id = Hrdnic.hardware_id',"Hrdnic.enableflg =1","Hrdnic.ip_address != ''"),
				'Astose : astoses : left' => array('Asthrd.id = Astose.hardware_id'),
				'Hstadt : hstadts : left' => array('Host.id = Hstadt.host_id')
			);
			$Data_fields = array(
				'Host.id',
				'Host.host_name',
				'Asthrd.id',
				'Asthrd.log_time',
				'Host.status',
				'Host.ostype',
				'Hrdcpu.cpu_name',
				//'count(Hrdcpu.cpu_name) as Hrdcpu__cpu_num',
				'Hrdcpu2.cpu_num as Hrdcpu__cpu_num',
				//'sum(Hrdmem.capacity) AS Hrdmem__capacitys',
				'Hrdmem2.capacitys AS Hrdmem__capacitys',
				//'sum(Hrdphydsk.allspace) AS Hrdphydsk__allspace',
				'Hrdphydsk2.allspace AS Hrdphydsk__allspace',
				//'sum(Hrdlogdsk.freespace) AS Hrdlogdsk__freespace',
				'Hrdlogdsk2.freespace AS Hrdlogdsk__freespace',
				'Hrdnic.ip_address',
				'Asthrd.machine',
				'Asthrd.maker',
				'Asthrd.serialno',
				'Astose.domain_name',
				'Astose.os_name',
				'Astose.servicepack',
				'Astose.product_id',
				'Astose.activation',
				'Astose.description',
				'Hstadt.option1',
				'Hstadt.option2',
				'Hstadt.option3',
				'Hstadt.option4',
				'Hstadt.option5',
				'Hstadt.option6',
				'Hstadt.option7',
				'Hstadt.option8',
				'Hstadt.option9',
				'Hstadt.option10'
			);
			
			$data = $this->Host->findByAsso($Host_criteria, $Data_fields, 'Host.id', null, null, $Dataasso);

//var_dump($data);

			foreach($data as $d){
				$a = $d['Hrdphydsk']['allspace'];
				$b = $d['Hrdlogdsk']['freespace'];
				if($a > $b){
					$hrdphydsk_late = round($b / $a * 100, 1)."";
				}
				else{
					$hrdphydsk_late='null';
				}
				
				$activation = isset($d['Astose']['activation']) ? $d['Astose']['activation'] : 'null';
				if (strpos($d['Astose']['os_name'],"2000")) {
					$activation = "2";
				}
				$adt = "";
				foreach ($Addition as $v){
					$f =$v['Addition']['addition_name'];
					$adt = $adt.",".$this->strOrnull($d['Hstadt'][$f]);
				}
				
				$insert = sprintf("insert into temppsoptusers values (null, %d,%d,%s,%d,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s,%s, %s,%s,%s,%s,%s,%s %s)",
					$d['Host']['id'],
					$d['Asthrd']['id'],
					"'".$this->Lv->spec_char_dbm($d['Host']['host_name'])."'",
					$d['Host']['ostype'],
					$this->strOrnull($d['Hrdnic']['ip_address']),
					$this->strOrnull($d['Astose']['domain_name']),
					$this->strOrnull($d['Asthrd']['machine']),
					$this->strOrnull($d['Asthrd']['maker']),
					$this->strOrnull($d['Asthrd']['serialno']),
					$this->strOrnull($d['Hrdcpu']['cpu_name']),
					$this->numOrnull($d['Hrdcpu']['cpu_num']),
					$this->numOrnull($d['Hrdmem']['capacitys']),
					$this->numOrnull($d['Hrdphydsk']['allspace']),
					$this->numOrnull($d['Hrdlogdsk']['freespace']),
					$this->numOrnull($hrdphydsk_late),
					$this->strOrnull($d['Astose']['os_name']),
					$this->strOrnull($d['Astose']['servicepack']),
					$this->strOrnull($d['Asthrd']['log_time']),
					$this->strOrnull($d['Astose']['product_id']),
					$activation,
					$this->strOrnull($d['Astose']['description']),

					$adt
					
				);
				

				$this->Host->query($insert);
			}


/*

			$Host_fields = array(
			'Host.id',
			'Asthrd.id',
			'Host.status',
			'Host.ostype',
			);

			$hosts = $this->Host->findByAsso($Host_criteria, $Host_fields, 'Host.id',null,null, $Hostasso);

			foreach ($hosts as $A_ID)
			{  //start foreach

				$asthrd_id = $A_ID['Asthrd']['id'];
				$host_id=$A_ID['Host']['id'];
				//------------host -----------------------
				if(empty($asthrd_id)) {
					$asthrd_id=0;
				}
				$Host_criteria=array("Asthrd.id  = $asthrd_id");

				$Host_fields = array(
				'Asthrd.id',
				'Asthrd.host_id',
				'Asthrd.machine',
				'Asthrd.maker',
				'Asthrd.serialno',
				'Asthrd.UUID',
				'Asthrd.log_time'
				);


				$host_name= $this->Host->find(array("Host.id" => $this->Lv->spec_char_dbm($host_id)), 'Host.host_name', null,1,null,-1);
				$host_name = $host_name['Host']['host_name'];

				$Hosts= $this->Asthrd->findAll($Host_criteria, $Host_fields, null,1,null,-1);

				isset($Hosts[0]['Asthrd']['id'])?$Hosts[0]['Asthrd']['id'] = $Hosts[0]['Asthrd']['id'] : $Hosts[0]['Asthrd']['id'] = 'NULL';
				isset($Hosts[0]['Asthrd']['machine'])?$Hosts[0]['Asthrd']['machine'] = "'{$Hosts[0]['Asthrd']['machine']}'" : $Hosts[0]['Asthrd']['machine'] ='NULL';
				isset($Hosts[0]['Asthrd']['maker'])?$Hosts[0]['Asthrd']['maker'] = "'{$Hosts[0]['Asthrd']['maker']}'" : $Hosts[0]['Asthrd']['maker'] ='NULL';
				isset($Hosts[0]['Asthrd']['serialno'])?$Hosts[0]['Asthrd']['serialno'] = "'{$Hosts[0]['Asthrd']['serialno']}'" : $Hosts[0]['Asthrd']['serialno'] ='NULL';
				isset($Hosts[0]['Asthrd']['log_time'])?$Hosts[0]['Asthrd']['log_time'] = "'{$Hosts[0]['Asthrd']['log_time']}'" : $Hosts[0]['Asthrd']['log_time'] ='NULL';

				//---------------- hrdcpu -----------------
			
				$Hrdcpu_fields = array(
				//                      'Asthrd.id',
				'Hrdcpu.id',
				'Hrdcpu.cpu_name',
				'count(Hrdcpu.cpu_name) as Hrdcpu__cpu_num'
				);
				$cpu_crit = array();
				$cpu_crit[]="Hrdcpu.hardware_id =$asthrd_id";
				$cpu_crit['GROUP BY']="Hrdcpu.cpu_name";
				$Hrdcpus = $this->Hrdcpu->findAll($cpu_crit,  $Hrdcpu_fields, 'Hrdcpu.id', 1, null, -1);
				isset($Hrdcpus[0]['Hrdcpu']['cpu_name'])?$Hrdcpus[0]['Hrdcpu']['cpu_name'] = "'{$Hrdcpus[0]['Hrdcpu']['cpu_name']}'":$Hrdcpus[0]['Hrdcpu']['cpu_name'] ='NULL';
				$Hrdcpus_num1 = $this->Hrdcpu->findAll(array("Hrdcpu.hardware_id = $asthrd_id"),'count(*) as count',null,null,null ,0);
				isset($Hrdcpus_num1)&&$Hrdcpus_num1[0][0]['count']!=0?$Hrdcpus_num = $Hrdcpus_num1[0][0]['count'] :$Hrdcpus_num ='NULL';
				//---------------- hrdmem  -----------------

				$Hrdmem_fields = array(
				//                      'Asthrd.id',
				'sum(Hrdmem.capacity) AS Hrdmem__capacitys'
				);
				$Hrdmems = $this->Hrdmem->findByAsso(array("Hrdmem.hardware_id =$asthrd_id",'GROUP BY'=>'Hrdmem.hardware_id'), $Hrdmem_fields, null, null, null, array());

				isset($Hrdmems[0]['Hrdmem']['capacitys'])?$Hrdmems_capacitys = $Hrdmems[0]['Hrdmem']['capacitys']: $Hrdmems_capacitys = 'null';
				//-----------------hrdphydsk-------------

				$Hrdphydsk_fields = array(
				'sum(Hrdphydsk.allspace) AS Hrdphydsk__allspace',

				);
				$Hrdlogdsk_fields = array(
				'sum(Hrdlogdsk.freespace) AS Hrdlogdsk__freespace'
				);
				$Hrdphydsks = $this->Hrdphydsk->findByAsso(array("Hrdphydsk.hardware_id =$asthrd_id",'GROUP BY'=>'Hrdphydsk.hardware_id'), $Hrdphydsk_fields, null,null, null, array());
				$Hrdlogdsks = $this->Hrdlogdsk->findByAsso(array("Hrdlogdsk.hardware_id =$asthrd_id","Hrdlogdsk.drivetype != 4",'GROUP BY'=>'Hrdlogdsk.hardware_id'), $Hrdlogdsk_fields, null,null, null, array());

				isset($Hrdphydsks[0]['Hrdphydsk']['allspace']) ? $Hrdphydsks_allspace = $Hrdphydsks[0]['Hrdphydsk']['allspace'] :$Hrdphydsks_allspace ='null';
				isset($Hrdlogdsks[0]['Hrdlogdsk']['freespace']) ? $Hrdlogdsks_freespace = $Hrdlogdsks[0]['Hrdlogdsk']['freespace'] :$Hrdlogdsks_freespace ='null';

				$a=$Hrdphydsks_allspace;
				$b=$Hrdlogdsks_freespace;


				if(($a>$b)){
					$hrdphydsk_late=round(($b)/$a*100,1);

				}
				else{$hrdphydsk_late='null';}

				//nic
				$Hrdnic_fields = array(
				'Hrdnic.ip_address'
				);
				$Hrdnics = $this->Hrdnic->findByAsso(array("Hrdnic.hardware_id =$asthrd_id","Hrdnic.enableflg =1","Hrdnic.ip_address != ''",'GROUP BY'=>'Hrdnic.hardware_id'), $Hrdnic_fields, null,null, null, array());

				isset($Hrdnics[0]['Hrdnic']['ip_address']) ? $Hrdnic_ipaddr = $Hrdnics[0]['Hrdnic']['ip_address'] :$Hrdnic_ipaddr ='';

				//astoses--
				$os_name = $this->Astose->find(array("Astose.hardware_id"=>$asthrd_id),null,null,null,null,-1);
				$domain_name= $os_name['Astose']['domain_name'];
				$osname= $os_name['Astose']['os_name'];
				$servicepack= $os_name['Astose']['servicepack'];
				$product_id= $os_name['Astose']['product_id'];
				//$activation= $os_name['Astose']['activation'];
				isset($os_name['Astose']['activation']) ? $activation = "'{$os_name['Astose']['activation']}'":$activation ='null';
				// yaozl start 2009/09/01 modify for LV20R1-280
				if (strpos($osname,"2000")) {
					$activation = "2";
				}
				$description= $this->Lv->spec_char_dbm($os_name['Astose']['description']);
				// yaozl end 2009/09/01 modify for LV20R1-280
				//hstadt-
				$Hstadt_asso = array(
				'Host : hosts' =>array('Hstadt.host_id =Host.id')
				);

				$Hstadt_fields=array('Host.id',
				'Hstadt.id',
				'Hstadt.option1',
				'Hstadt.option2',
				'Hstadt.option3',
				'Hstadt.option4',
				'Hstadt.option5',
				'Hstadt.option6',
				'Hstadt.option7',
				'Hstadt.option8',
				'Hstadt.option9',
				'Hstadt.option10');
				$criteria_Hstadt=array("Hstadt.host_id=".$host_id);

				$result_Hstadt = $this->Hstadt->findByAsso($criteria_Hstadt,$Hstadt_fields , null, 1, null, $Hstadt_asso);

				$insert = "INSERT INTO temppsoptusers VALUES(null,
		 {$A_ID['Host']['id']},
		 {$Hosts[0]['Asthrd']['id']},  
		 '{$this->Lv->spec_char_dbm($host_name)}', 
		{$A_ID['Host']['ostype']},
		 '{$Hrdnic_ipaddr}',
		 '{$domain_name}',
		 {$Hosts[0]['Asthrd']['machine']}, 
	     {$Hosts[0]['Asthrd']['maker']},
		 {$Hosts[0]['Asthrd']['serialno']},
		 {$Hrdcpus[0]['Hrdcpu']['cpu_name']},
		 {$Hrdcpus_num},
		 {$Hrdmems_capacitys},
		 {$Hrdphydsks_allspace},
		 {$Hrdlogdsks_freespace},
         {$hrdphydsk_late},
		 '{$osname}',
		 '{$servicepack}',
		 {$Hosts[0]['Asthrd']['log_time']},
		 '{$product_id}',
		 {$activation},
		 '{$description}'";

				foreach ($Addition as $v){
					$f =$v['Addition']['addition_name'];
					if(!empty($result_Hstadt[0]['Hstadt'][$f]))
					$insert = $insert.",'".$this->Lv->spec_char_dbm($result_Hstadt[0]['Hstadt'][$f])."'";
					else
					$insert = $insert.", null";
				}
				$insert = $insert.');';

				$this->Host->query($insert);
			}//end foreach
*/
	} //end lists
	
	//PC一台
	function csvdown1($c = nul,$A=null,$csv_result){
		$Astsfws =$A;
		$Asthrds_id=$c;
		$criteria_hdw[] = "Asthrd.id=".$Asthrds_id;

		//wangs start 20080222
		$criteria_cpu[]="Hrdcpu.hardware_id = ".$Asthrds_id;
		$criteria_cpu['GROUP BY']="Hrdcpu.cpu_name";
		$Hrdcpus = $this->Hrdcpu->findAll($criteria_cpu,array('count(cpu_name) as cpu_num,cpu_name'), "Hrdcpu.id", 1, null, -1);
		//wangs end 20080222

		$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);

		$asso3 = array(
		'Hrdcpu : hrdcpus' => array('Hrdcpu.hardware_id = Asthrd.id '),
		) ;
		//		$Hrdcpus = $this->Asthrd->findByAsso($criteria_hdw,array('cpu_name'), null, null, null, $asso3);
		$this->set('Hrdcpu',$Hrdcpus);

		$asso4 = array(
		'Hrdmem : hrdmems' => array('Hrdmem.hardware_id = Asthrd.id '),
		) ;
		$Hrdmems = $this->Asthrd->findByAsso($criteria_hdw,array('capacity'), null, null, null, $asso4);
		$this->set('Hrdmem',$Hrdmems);

		$asso5 = array(
		'Hrdphydsk : hrdphydsks' => array('Hrdphydsk.hardware_id = Asthrd.id '),
		) ;
		$Hrdphydsks = $this->Asthrd->findByAsso($criteria_hdw,array('allspace','type'), null, null, null, $asso5);
		$this->set('Hrdphydsk',$Hrdphydsks);

		$asso55 = array(
		'Hrdlogdsk : hrdlogdsks' => array('Hrdlogdsk.hardware_id = Asthrd.id '),
		) ;
		$Hrdlogdsks = $this->Asthrd->findByAsso($criteria_hdw,array('name'), null, null, null, $asso55);
		
		$asso6 = array(
		'Hrdmnt : hrdmnts' => array('Hrdmnt.hardware_id = Asthrd.id '),
		) ;
		$Hrdmnts = $this->Asthrd->findByAsso($criteria_hdw,array('monitor_name','adapterram','horizontal','vertical','bits'), null, null, null, $asso6);
		$this->set('Hrdmnt',$Hrdmnts);

		$asso7 = array(
		'Hrdnic : hrdnics' => array('Hrdnic.hardware_id = Asthrd.id '),
		) ;
		$Hrdnics = $this->Asthrd->findByAsso($criteria_hdw,array('Hrdnic.nic_name','Hrdnic.enableflg','Hrdnic.mac_address','Hrdnic.ip_address'), null, null, null, $asso7);
		$this->set('Hrdnic',$Hrdnics);

		$asso8 = array(
		'Hrddrv : hrddrvs' => array('Hrddrv.hardware_id = Asthrd.id '),
		) ;
		$Hrddrvs_fields = array(
				'Hrddrv.driver_name',
				'Hrddrv.driver'
				);
		//        $Hrddrvs = $this->Asthrd->findByAsso($criteria_hdw, "Hrddrv.driver_name||'('||Hrddrv.driver||')' AS Hrddrv__driver_name", null, null, null, $asso8);//2007-11-27 変更zhaoli
		$Hrddrvs = $this->Asthrd->findByAsso($criteria_hdw, $Hrddrvs_fields, null, null, null, $asso8);//2007-11-27 変更zhaoli
		for($i=0;$i<count($Hrddrvs);$i++){
			if(!empty($Hrddrvs[$i]['driver_name']))
				$Hrddrvs[$i]['driver_name']= $Hrddrvs[$i]['driver_name'].'('.$Hrddrvs[$i]['driver'].')';
		}
		
		$this->set('Hrddrv',$Hrddrvs);
		// 		debug($Hrddrvs,true);
		// 		debug($Hrdnics,true);

		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_hdws");

		$array = array(	  "",
		""=>__('hdw_00',true),//□ ハードウェア台帳
		//									"□ ハードウェア情報",
		"Host/id"=>__('host_id',true),
		"Host/host_name"=>__('computer_name',true),//"コンピューター",
		"Astose/domain_name"=>__('domain_name',true),//"ドメイン",
		"Asthrd/machine"=>__('machine',true),//"機種",
		"Asthrd/maker"=>__('maker',true),//"メーカー",
		"Asthrd/serialno"=>__('serialnumber',true),//"シリアルナンバー");
		"Asthrd/UUID"=>__('UUID',true)
		);
		/*if(!empty($Hrdcpus)){
			$f=array();
			for($i=0;$i<count($Hrdcpus);$i++){
				$array['Hrdcpu/cpu_name'.$i] = __('CPU', true);
			}
		}*/
		$array['Hrdcpu/cpu_name'] =__('CPU',true);//
		$array['Hrdcpu/cpu_num'] =__('CPU_no',true);//
		$array['Hrdcpu/cores'] =__('CPU_cores',true);//
		$array['Hrdcpu/clock'] =__('CPU_clock',true);//
		
		$array['Hrdmem/capacity'] =__('Hrdmem',true);//"メモリ総容量";

		if(!empty($Hrdmems)){
			$f=array();
			for($i=0;$i<count($Hrdmems);$i++){
				$a='Hrdmem/capacity'.$i;
				$f='DIMM '.$i;
				$array[$a] =$f;
			}
		}
		$array['Hrdphydsk/allspace_freespace'] = __('HDD_03',true);//"HDD(総容量/空き容量)";

		if(!empty($Hrdphydsks)){
			$f=array();
			for($i=0;$i<count($Hrdphydsks);$i++){
				$a='Hrdphydsk/allspace'.$i;
				$f=__('drive',true).$i;
				$array[$a] =$f;
			}
		}

		//$array['Hrddrv/driver_name'] = __('scannerdrive',true).'('.__('type',true).')';//"光学ドライブ(型番)";

		if(!empty($Hrddrvs)){
			$f=array();
			for($i=0;$i<count($Hrddrvs);$i++){
				$a='Hrddrv/driver_name'.$i;
				$f=__('scannerdrive',true).$i;
				$array[$a] =$f;
			}
		}
		
		if(!empty($Hrdmnts)){
			$f=array();
			for($i=0;$i<count($Hrdmnts);$i++){
				$a='Hrdmnt/monitor_name'.$i;
				$b='Hrdmnt/adapterram'.$i;
				$c='Hrdmnt/horizontal.vertical.bits'.$i;

				//							    $f='ビデオコントローラ'.$i;
				//							    $g='VRAMサイズ ID'.$i;
				//							    $h='画面の解析度'.$i;
				$f=__('videocontroller',true).$i;
				$g=__('vram_size',true).$i;
				$h=__('Analyticallevelofscreen',true).$i;
				$array[$a] =$f;
				$array[$b] =$g;
				$array[$c] =$h;
			}
		}

		if(!empty($Hrdnics)){
			$f=array();
			for($i=0;$i<count($Hrdnics);$i++){
				$array['Hrdnic/nic_name'.$i] = __('Networkinterfacecard',true).$i;
				$array['Hrdnic/mac_address'.$i] = __('Address_00',true).$i;
				$array['Hrdnic/ip_address'.$i] = __('ip_Address',true).$i;
				$array['Hrdnic/gateway'.$i] = __('nic_gateway',true).$i;
				$array['Hrdnic/dns_primary'.$i] = __('nic_dns1',true).$i;
				if(!empty($Hrdnics[$i]['Hrdnic']['ip_address'])){
					$array['Hrdnic/dhcp_enabled'.$i] = __('nic_dhcp',true).$i;
					$array['Hrdnic/dhcp_address'.$i] = __('nic_dhcp_srv',true).$i;
					$array['Hrdnic/wlan'.$i] = __('nic_wlan',true).$i;
				}
			}
		}
		$array[] ='';
		$array[] ='□ '.__('logdisks_info',true);
		if(!empty($Hrdlogdsks)){
			for($i=0;$i<count($Hrdlogdsks);$i++){
				$array['Hrdlogdsk/data'.$i] = __('logdisks',true).$i;
			}
		}
		
		$array[] ='';
		$array[] ='□ '.__('OSinfo',true);//'□ オペレーティングシステム情報';
		$array['Astose/os_name'] =__('OS',true).'('.__('SP',true).')';
		$array['Astose/version'] =__('OS_version',true);
		$array['Astose/product_id'] =__('Product ID',true);//"Product ID";
		$array['Astose/install_time'] =__('Installationdate',true);//"インストール日時";
		$array['Astose/activation'] =__('ActiItionexecution',true);//"アクティべイション実施";
		$array['Astose/user_name'] =__('HardUser',true);//"使用者";
		$array['Astose/organization'] =__('Organizationname',true);//"組織名";
		$array['Astose/description'] =__('Descriptionname',true);//"コンピューターの説明";
		$array['Astact/account_name'] =__('Accountlist',true);//"アカウント一覧";
		
		$array['Logonuser/account_name'] =__('lastlogon',true);
		$array['Logonuser/last_logon'] =__('lastlogontime',true);
		$array['Bitlocker/status'] =__('Bitlocker',true);
		
		$array['Asthrd/log_time'] =__('Logtime',true);
		$array[] ='';

		$array[] ='□ '.__('assetsinfo',true);//'□ 任意設定情報';
		if(!empty($Addition)){
			foreach ($Addition as $key => $output){
				/*		   */
				$diplay = decbin($output['Addition']['display']);
				if(strlen($diplay)==2){
					$flag=0;
				}
				elseif(strlen($diplay)==3){
					if(substr($diplay, 0,1)==1){
						$flag=1;   }
				}

				if($flag==1){
					/*		   */
					$a= $output['Addition']['addition_name'];
					$b = $output['Addition']['addition_content'];
					$f = "Hstadt/".$a;
					$array[$f]=$b;
					/*		   */
				}
				/*		   */
			}
		}
		$array[] ='';
		$array[] ='□ '.__('Installationsoftwarelist',true);//'□ インストールソフトウェアリスト';
		//
		$array_cols = array(
		//		              ""=> "□ インストールソフトウェアリスト",
		"Astsfw/software_name"=>__('Softwarename',true),//"ソフトウェア名",
		"Astsfw/version"=>__('version',true),//"バージョン",
		"Astsfw/maker"=>__('maker',true),//"メーカー",
		"Astsfw/licence_code"=>__('Licenseinfo',true));//"ライセンス情報");// 変更

		$csv->special_search_title=$array;
		$csv->special_cols=$array_cols;
		$csv->sendCSVFile($Astsfws,$csv_result,__('hardwareinfo',true));

	}

	//CSVダウンロード(詳細）     yuanxiaojun start 20080410　
	function csvdown2($data,$csv_result1){
		$Addition = $this->Addition->findAll(null,null,'id ASC','0',null,null);

		$csv_result=array();
		$j =0;
		for($m=0;$m<count($data);$m++){
			$id=$data[$j]['Temp']['host_id'];
			$Hosts= $this->Host->find(array("Host.id"=> $id), 'Host.host_name, Host.id', null,1,null,-1);
			$criteria_hostId = array("Asthrd.host_id" => $id);
			$Asthrd_id = $this->Asthrd->find($criteria_hostId,'Asthrd.id');
			///================= asthrd id----------

			$Hstadt_asso = array(
			'Hstadt : hstadts' =>array('Hstadt.host_id =Host.id'),
			);

			$Hstadt_fields=array('Host.id',
			'Hstadt.id',
			'Hstadt.option1',
			'Hstadt.option2',
			'Hstadt.option3',
			'Hstadt.option4',
			'Hstadt.option5',
			'Hstadt.option6',
			'Hstadt.option7',
			'Hstadt.option8',
			'Hstadt.option9',
			'Hstadt.option10');

			$criteria_Hstadt=array("Hstadt.host_id=".$id);

			$result_Hstadt = $this->Host->findByAsso($criteria_Hstadt,$Hstadt_fields , null, null, null, $Hstadt_asso);
			!empty($result_Hstadt)?$this->set('result_Hstadt',$result_Hstadt):$this->set('result_Hstadt',"");
			!empty($result_Hstadt[0]['Hstadt']['option1'])?$result_Hstadt[0]['Hstadt']['option1'] = $result_Hstadt[0]['Hstadt']['option1']:$result_Hstadt[0]['Hstadt']['option1'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option2'])?$result_Hstadt[0]['Hstadt']['option2'] = $result_Hstadt[0]['Hstadt']['option2']:$result_Hstadt[0]['Hstadt']['option2'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option3'])?$result_Hstadt[0]['Hstadt']['option3'] = $result_Hstadt[0]['Hstadt']['option3']:$result_Hstadt[0]['Hstadt']['option3'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option4'])?$result_Hstadt[0]['Hstadt']['option4'] = $result_Hstadt[0]['Hstadt']['option4']:$result_Hstadt[0]['Hstadt']['option4'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option5'])?$result_Hstadt[0]['Hstadt']['option5'] = $result_Hstadt[0]['Hstadt']['option5']:$result_Hstadt[0]['Hstadt']['option5'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option6'])?$result_Hstadt[0]['Hstadt']['option6'] = $result_Hstadt[0]['Hstadt']['option6']:$result_Hstadt[0]['Hstadt']['option6'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option7'])?$result_Hstadt[0]['Hstadt']['option7'] = $result_Hstadt[0]['Hstadt']['option7']:$result_Hstadt[0]['Hstadt']['option7'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option8'])?$result_Hstadt[0]['Hstadt']['option8'] = $result_Hstadt[0]['Hstadt']['option8']:$result_Hstadt[0]['Hstadt']['option8'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option9'])?$result_Hstadt[0]['Hstadt']['option9'] = $result_Hstadt[0]['Hstadt']['option9']:$result_Hstadt[0]['Hstadt']['option9'] =NULL;
			!empty($result_Hstadt[0]['Hstadt']['option10'])?$result_Hstadt[0]['Hstadt']['option10'] = $result_Hstadt[0]['Hstadt']['option10']:$result_Hstadt[0]['Hstadt']['option10'] =NULL;

			if($Asthrd_id['Asthrd']['id']){
				$condition = array("Asthrd.id" => $Asthrd_id['Asthrd']['id']);
				

				$condition['GROUP BY']="Asthrd.id,Asthrd.machine,Asthrd.maker,Asthrd.serialno";
				$fields_Asthrd = array(
				'Asthrd.id',
				'Asthrd.machine',
				'Asthrd.maker',
				'Asthrd.serialno',
				'Asthrd.UUID',
				'Asthrd.log_time');
				$Asthrds = $this->Asthrd->find($condition, $fields_Asthrd, 'Asthrd.id',null,null, -1);
				$Hrddrvs_fields = array(
				'Hrddrv.driver_name',
				'Hrddrv.driver'
				);
				$Hrddrvs = $this->Hrddrv->findAll(array("Hrddrv.hardware_id" => $Asthrds['Asthrd']['id']), $Hrddrvs_fields, null, null, null, null);//2007-11-27 変更 ?zhaoli
				$asso_Astacts = array( 'Astose : astoses' => array('Astact.os_id = Astose.id'), ) ;
				$criteria_ast=array();
				$criteria_ast[]="Astose.hardware_id=".$Asthrds['Asthrd']['id'];
				$criteria_ast['GROUP BY']="Astose.hardware_id,Astact.account_name";

				$Astacts = $this->Astact->findByAsso($criteria_ast,array('Astact.account_name'), null, null, null, $asso_Astacts);
				$fields_Astose = array(
				'Astose.os_name',
				'Astose.servicepack',
				'Astose.version',
				'Astose.product_id',
				'Astose.install_time',
				'Astose.activation',
				'Astose.user_name',
				'Astose.organization',
				'Astose.description',
				'Astose.domain_name',
				);
				$criteria_Astoses=array("Astose.hardware_id" => $Asthrds['Asthrd']['id']);
				$Astoses = $this->Astose->find($criteria_Astoses, $fields_Astose, 'Astose.id', null, null,null);

				$criteria_cpu=array();
				$criteria_cpu[]="Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id'];
				$criteria_cpu['GROUP BY']="Hrdcpu.cpu_name";
				$Hrdcpus = $this->Hrdcpu->findAll($criteria_cpu,array('cpu_name,cores,clock'), "Hrdcpu.id", 1, null, -1);

				$Hrdmems = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('capacity'), null, null, null, -1);
				$Hrdmems1 = $this->Hrdmem->findAll(array("Hrdmem.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(capacity) as Hrdmem__capacity'), null, null, null, -1);
				$Hrdphydsks = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('allspace','type'), null, null, null, -1);
				$Hrdphydsks1 = $this->Hrdphydsk->findAll(array("Hrdphydsk.hardware_id" => $Asthrds['Asthrd']['id']),array('SUM(allspace) as Hrdphydsk__allspace'), null, null, null, -1);
				
				$Hrdlogdsk_fields =array(
				'Hrdlogdsk.name',
				'Hrdlogdsk.size',
				'Hrdlogdsk.freespace',
				'Hrdlogdsk.drivetype',
				'Hrdlogdsk.filesystem',
				'Hrdlogdsk.protection'
				);
				$Hrdlogdsks = $this->Hrdlogdsk->findAll(array("Hrdlogdsk.hardware_id" =>$Asthrds['Asthrd']['id']), $Hrdlogdsk_fields, null, null, null, -1);

				$Hrdlogdsks1 = $this->Hrdlogdsk->findAll(array("Hrdlogdsk.hardware_id" =>$Asthrds['Asthrd']['id'],"Hrdlogdsk.drivetype != 4"),array('SUM(freespace) as Hrdlogdsk__freespace'), null, null, null, -1);
				$Hrdmnts = $this->Hrdmnt->findAll(array("Hrdmnt.hardware_id" => $Asthrds['Asthrd']['id']),array('monitor_name','adapterram','horizontal','vertical','bits'), null, null,null,-1);

				$criteria_Hrdnics=array("Hrdnic.hardware_id" => $Asthrds['Asthrd']['id'], "Hrdnic.enableflg = 1");
				$fld_Hrdnics=array(
					'Hrdnic.nic_name',
					'Hrdnic.enableflg',
					'Hrdnic.mac_address',
					'Hrdnic.ip_address',
					'Hrdnic.gateway',
					'Hrdnic.dns_primary',
					'Hrdnic.dns_secondary',
					'Hrdnic.dhcp_address',
					'Hrdnic.dhcp_enabled',
					'Hrdnic.wlan');
				$Hrdnics = $this->Hrdnic->findAll($criteria_Hrdnics, $fld_Hrdnics, null, null, null,-1);

				//--csv--  array
				//コンピュータ名"
				!empty($Hosts['Host']['id'])?$csv_result[$j]['Host']['id']=$Hosts['Host']['id']:$csv_result[$j]['Host']['id'] =null;
				!empty($Hosts['Host']['host_name'])?$csv_result[$j]['Host']['host_name']=$Hosts['Host']['host_name']:$csv_result[$j]['Host']['host_name'] =null;
				//機種名
				!empty($Asthrds['Asthrd']['machine'])?$csv_result[$j]['Asthrd']['machine']=$Asthrds['Asthrd']['machine']:$csv_result[$j]['Asthrd']['machine'] =null;
				//メーカー名
				!empty($Asthrds['Asthrd']['maker'])?$csv_result[$j]['Asthrd']['maker']= $Asthrds['Asthrd']['maker']:$csv_result[$j]['Asthrd']['maker'] =null;
				//シリアルナンバー
				!empty($Asthrds['Asthrd']['serialno'])?$csv_result[$j]['Asthrd']['serialno']= $Asthrds['Asthrd']['serialno']:$csv_result[$j]['Asthrd']['serialno'] =null;
				!empty($Asthrds['Asthrd']['UUID'])?$csv_result[$j]['Asthrd']['UUID']= $Asthrds['Asthrd']['UUID']:$csv_result[$j]['Asthrd']['UUID'] =null;
				!empty($Asthrds['Asthrd']['log_time'])?$csv_result[$j]['Asthrd']['log_time']= $Asthrds['Asthrd']['log_time']:$csv_result[$j]['Asthrd']['log_time'] =null;
				//cpu
				if(empty($Hrdcpus)){
					//$csv_result[$j]['Hrdcpu']['cpu_name.cpu_num0']=null;
					$csv_result[$j]['Hrdcpu']['cpu_name']=null;
					$csv_result[$j]['Hrdcpu']['cpu_total']=null;
					$csv_result[$j]['Hrdcpu']['cores']=null;
					$csv_result[$j]['Hrdcpu']['clock']=null;
				}else{
					$csv_result[$j]['Hrdcpu']['cpu_name']=$Hrdcpus[0][0]['cpu_name'];
					$csv_result[$j]['Hrdcpu']['cpu_total']=null;
					$csv_result[$j]['Hrdcpu']['cores']=$Hrdcpus[0][0]['cores'];
					$csv_result[$j]['Hrdcpu']['clock']=sprintf("%.2fGHz", $Hrdcpus[0][0]['clock']/1000);
				/*	for($i=0;$i<count($Hrdcpus);$i++){
						$f='cpu_name.cpu_num'.$i;
						!empty($Hrdcpus[$i])?$csv_result[$j]['Hrdcpu'][$f]=$Hrdcpus[$i][0]['cpu_name'].'×'.$Hrdcpus[$i][0]['cpu_num']:$csv_result[$j]['Hrdcpu'][$f] =null;
					}*/
				}
				$Hrdcpus_num1 = $this->Hrdcpu->findAll(array("Hrdcpu.hardware_id = ".$Asthrds['Asthrd']['id']),'count(*) as count',null,null,null ,0);
				if(empty($Hrdcpus_num1))
					$csv_result[$j]['Hrdcpu']['cpu_total'] = "";
				else
					$csv_result[$j]['Hrdcpu']['cpu_total'] = $Hrdcpus_num1[0][0]['count'];
				
				//メモリ（総容量）
				!empty($Hrdmems1[0]['Hrdmem']['capacity'])?$csv_result[$j]['Hrdmem']['capacity']=round($Hrdmems1[0]['Hrdmem']['capacity']/1024,1).'MB':$csv_result[$j]['Hrdmem']['capacity']=null;
				//DIMM
				for($i=0;$i<count($Hrdmems);$i++){
					$f='capacity'.$i;
					$capacity_1 = round($Hrdmems[$i]['Hrdmem']['capacity']/1024,1).'MB';
					!empty($Hrdmems[$i]['Hrdmem']['capacity'])?$csv_result[$j]['Hrdmem'][$f]=$capacity_1: $csv_result[$j]['Hrdmem'][$f]=null;
				}
				$HrdmemsStart=MEMORY_NAME;
				if(count($Hrdmems)<$HrdmemsStart){
					for($i=count($Hrdmems);$i<$HrdmemsStart;$i++){
						$f='capacity'.$i;
						$capacity_1 = null;
						$csv_result[$j]['Hrdmem'][$f]=$capacity_1;
					}
				}
				// yzl start 2009/07/14 modify for LV20R1-228
				//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024,1).'GB/':$allspace_0 =null;
				//!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024,1).'GB':$freespace_0 =null;
				!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$allspace_0=round($Hrdphydsks1[0]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB/':$allspace_0 =null;
				!empty($Hrdphydsks1[0]['Hrdphydsk']['allspace'])?$freespace_0=round($Hrdlogdsks1[0]['Hrdlogdsk']['freespace']/1024/1024/1024,1).'GB':$freespace_0 =null;
				// yzl end 2009/07/14 modify for LV20R1-228
				//HDD(総容量/空き容量)
				$csv_result[$j]['Hrdphydsk']['allspace_freespace']=$allspace_0.$freespace_0;
				//ドライブ
				for($i=0;$i<count($Hrdphydsks);$i++){
					$f='allspace'.$i;
					// yzl start 2009/07/14 modify for LV20R1-228
					//!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result[$j]['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024,1).'GB':$csv_result[$j]['Hrdphydsk'][$f]=null;
					!empty($Hrdphydsks[$i]['Hrdphydsk']['allspace'])?$csv_result[$j]['Hrdphydsk'][$f] =round($Hrdphydsks[$i]['Hrdphydsk']['allspace']/1024/1024/1024,1).'GB':$csv_result[$j]['Hrdphydsk'][$f]=null;
					// yzl end 2009/07/14 modify for LV20R1-228
				}
				$HrdphydsksStart=ALLSPACE;
				if(count($Hrdphydsks)<$HrdphydsksStart){
					for($i=count($Hrdphydsks);$i<$HrdphydsksStart;$i++){
						$f='allspace'.$i;
						$allspace_1 = null;
						$csv_result[$j]['Hrdphydsk'][$f]=$allspace_1;
					}
				}
				//光学ドライブ(型番)

				if(!empty($Hrddrvs[0]['Hrddrv']['driver_name']))
					$csv_result[$j]['Hrddrv']['driver_name']= $Hrddrvs[0]['Hrddrv']['driver_name'].'('.$Hrddrvs[0]['Hrddrv']['driver'].')';
				else
					$csv_result[$j]['Hrddrv']['driver_name']=null;

				$HrddrvsStart=DRIVER_NAME;
				for($i=0;$i<count($Hrddrvs);$i++){
					$f='driver_name'.$i;
					if(!empty($Hrddrvs[$i]['Hrddrv']['driver_name']))
						$csv_result[$j]['Hrddrv'][$f]= $Hrddrvs[$i]['Hrddrv']['driver_name'].'('.$Hrddrvs[$i]['Hrddrv']['driver'].')';
					else
						$csv_result[$j]['Hrddrv'][$f]=null;

				}
				if(count($Hrddrvs)<$HrddrvsStart){
					for($i=count($Hrddrvs);$i<$HrddrvsStart;$i++){
						$f='driver_name'.$i;
						$driver_name_1 = null;
						$csv_result[$j]['Hrddrv'][$f]=$driver_name_1;
					}
				}
				//ビデオコントローラ,VRAMサイズ , 画面の解析度
				for($i=0;$i<count($Hrdmnts);$i++){
					$f='monitor_name'.$i;
					$g='adapterram'.$i;
					$h='horizontal.vertical.bits'.$i;
					$adapterram_0 =round($Hrdmnts[$i] ['Hrdmnt']['adapterram']/1024,1);

					!empty($Hrdmnts[$i]['Hrdmnt']['monitor_name'])? $csv_result[$j]['Hrdmnt'][$f]=$Hrdmnts[$i]['Hrdmnt']['monitor_name']:$csv_result[$j]['Hrdmnt'][$f]=null;
					!empty($Hrdmnts[$i]['Hrdmnt']['adapterram'])? $csv_result[$j]['Hrdmnt'][$g]=round($Hrdmnts[$i]['Hrdmnt']['adapterram']/1024,1).'MB':$csv_result[$j]['Hrdmnt'][$g]=null;

					($Hrdmnts[$i]['Hrdmnt']['horizontal']) !=null? $csv_result[$j]['Hrdmnt'][$h]=$Hrdmnts[$i]['Hrdmnt']['horizontal'].'*'.$Hrdmnts[$i]['Hrdmnt']['vertical'].'('.$Hrdmnts[$i]['Hrdmnt']['bits'].'bit'.')':$csv_result[$j]['Hrdmnt'][$h]=null;

				}
				$HrdmntsStart=MONITOR_NAME;
				if(count($Hrdmnts)<$HrdmntsStart){
					for($i=count($Hrdmnts);$i<$HrdmntsStart;$i++){
						$f='monitor_name'.$i;
						$g='adapterram'.$i;
						$h='horizontal.vertical.bits'.$i;

						$csv_result[$j]['Hrdmnt'][$f]=null;
						$csv_result[$j]['Hrdmnt'][$g]=null;
						$csv_result[$j]['Hrdmnt'][$h]=null;
					}
				}

				//ネットワークインタフェースカード,MACアドレス,IPアドレス
				for($i=0;$i<count($Hrdnics);$i++){
					$f='nic_name'.$i;
					$g='mac_address'.$i;
					$h='ip_address'.$i;
					$jj='gateway'.$i;
					$k='dns_primary'.$i;
					$l='dhcp_address'.$i;
					$n='dhcp_enabled'.$i;
					$o='wlan'.$i;
					if($Hrdnics[$i]['Hrdnic']['enableflg']==0){
						$enable=__('nouse',true);
					}else{
						$enable=__('use',true);
					}
					!empty($Hrdnics[$i]['Hrdnic']['nic_name']) ?$csv_result[$j]['Hrdnic'][$f] = $Hrdnics[$i]['Hrdnic']['nic_name'].'('.$enable.')':$csv_result[$j]['Hrdnic'][$f]=null;
					!empty($Hrdnics[$i]['Hrdnic']['mac_address']) ?$csv_result[$j]['Hrdnic'][$g] = $Hrdnics[$i]['Hrdnic']['mac_address']:$csv_result[$j]['Hrdnic'][$g]=null;
					!empty($Hrdnics[$i]['Hrdnic']['ip_address']) ? $csv_result[$j]['Hrdnic'][$h] = $Hrdnics[$i]['Hrdnic']['ip_address']:$csv_result[$j]['Hrdnic'][$h]=null;

					!empty($Hrdnics[$i]['Hrdnic']['gateway']) ? $csv_result[$j]['Hrdnic'][$jj] = $Hrdnics[$i]['Hrdnic']['gateway']:$csv_result[$j]['Hrdnic'][$jj]=null;
					!empty($Hrdnics[$i]['Hrdnic']['dns_primary']) ? $csv_result[$j]['Hrdnic'][$k] = $Hrdnics[$i]['Hrdnic']['dns_primary']:$csv_result[$j]['Hrdnic'][$k]=null;
					if(!empty($Hrdnics[$i]['Hrdnic']['dns_secondary']))
						$csv_result[$j]['Hrdnic'][$k] .= "; ".$Hrdnics[$i]['Hrdnic']['dns_secondary'];
					
					if(!empty($Hrdnics[$i]['Hrdnic']['ip_address'])){
						!empty($Hrdnics[$i]['Hrdnic']['dhcp_address']) ? $csv_result[$j]['Hrdnic'][$l] = $Hrdnics[$i]['Hrdnic']['dhcp_address']:$csv_result[$j]['Hrdnic'][$l]=null;
						if(!empty($Hrdnics[$i]['Hrdnic']['dhcp_enabled']) && $Hrdnics[$i]['Hrdnic']['dhcp_enabled'] == 1)
							$csv_result[$j]['Hrdnic'][$n] = __('dhcp_enabled',true);
						else if(!empty($Hrdnics[$i]['Hrdnic']['ip_address']) && empty($Hrdnics[$i]['Hrdnic']['dhcp_address']))
							$csv_result[$j]['Hrdnic'][$n] = __('dhcp_disabled',true);
						else
							$csv_result[$j]['Hrdnic'][$n] = __('dhcp_enabled',true);
						
						if(!empty($Hrdnics[$i]['Hrdnic']['wlan']) && $Hrdnics[$i]['Hrdnic']['wlan'] == 1)
							$csv_result[$j]['Hrdnic'][$o] = __('is_wlan',true);
						else
							$csv_result[$j]['Hrdnic'][$o] = __('isnot_wlan',true);
					}else{
						$csv_result[$j]['Hrdnic'][$l] = null;
						$csv_result[$j]['Hrdnic'][$n] = null;
						$csv_result[$j]['Hrdnic'][$o] = null;
					}
				}
				$HrdnicsStart=NIC_NAME;
				if(count($Hrdnics)<$HrdnicsStart){
					for($i=count($Hrdnics);$i<$HrdnicsStart;$i++){
						$csv_result[$j]['Hrdnic']['nic_name'.$i]= null;
						$csv_result[$j]['Hrdnic']['mac_address'.$i]= null;
						$csv_result[$j]['Hrdnic']['ip_address'.$i]= null;
						$csv_result[$j]['Hrdnic']['gateway'.$i]= null;
						$csv_result[$j]['Hrdnic']['dns_primary'.$i]= null;
						$csv_result[$j]['Hrdnic']['dhcp_address'.$i]= null;
						$csv_result[$j]['Hrdnic']['dhcp_enabled'.$i]= null;
						$csv_result[$j]['Hrdnic']['wlan'.$i]= null;
					}
				}

				for($i=0;$i<count($Hrdlogdsks);$i++){
					$f='name'.$i;
					$g='drivetype'.$i;
					$h='size'.$i;
					$jj='freespace'.$i;
					$dtype = $Hrdlogdsks[$i]['Hrdlogdsk']['drivetype'];
					$typestr = null;
					if($dtype == 2)  
						$typestr = "リムーバブルディスク";
					else if($dtype == 3)  
						$typestr = "ローカル固定ディスク";
					else if($dtype == 4)  
						$typestr = "ネットワークドライブ";
					else if($dtype == 5)  
						$typestr = "CD-ROM ディスク";
					else if($dtype == 6)  
						$typestr = "RAMディスク";
					else if($dtype == 0)  
						$typestr = "CD-ROM ディスク";

					!empty($Hrdlogdsks[$i]['Hrdlogdsk']['name']) ?$csv_result[$j]['Hrdlogdsk'][$f] = $Hrdlogdsks[$i]['Hrdlogdsk']['name']:$csv_result[$j]['Hrdlogdsk'][$f]=null;
					$csv_result[$j]['Hrdlogdsk'][$g] = $typestr;
					!empty($Hrdlogdsks[$i]['Hrdlogdsk']['size']) ? $csv_result[$j]['Hrdlogdsk'][$h] = number_format($Hrdlogdsks[$i]['Hrdlogdsk']['size']/1024/1024).'MB':$csv_result[$j]['Hrdlogdsk'][$h]=null;
					!empty($Hrdlogdsks[$i]['Hrdlogdsk']['freespace']) ? $csv_result[$j]['Hrdlogdsk'][$jj] = number_format($Hrdlogdsks[$i]['Hrdlogdsk']['freespace']/1024/1024).'MB':$csv_result[$j]['Hrdlogdsk'][$jj]=null;
				}
				$HrdlogdsksStart=10;
				if(defined("LOGDISK_NAME"))
					$HrdlogdsksStart=LOGDISK_NAME;
				if(count($Hrdlogdsks)<$HrdlogdsksStart){
					for($i=count($Hrdlogdsks);$i<$HrdlogdsksStart;$i++){
						$csv_result[$j]['Hrdlogdsk']['name'.$i]= null;
						$csv_result[$j]['Hrdlogdsk']['drivetype'.$i]= null;
						$csv_result[$j]['Hrdlogdsk']['size'.$i]= null;
						$csv_result[$j]['Hrdlogdsk']['freespace'.$i]= null;
					}
				}

				$bitlocker = "";
				if(!empty($Hrdlogdsks)){
					foreach ($Hrdlogdsks as $b)
					{
						if($b['Hrdlogdsk']['drivetype'] == 3){
							$bitlocker .= $b['Hrdlogdsk']['name'];
							if($b['Hrdlogdsk']['protection'] == 0)
								$bitlocker .=  __('bl_status_0',$return = true);
							else if($b['Hrdlogdsk']['protection'] == 1)
								$bitlocker .=  __('bl_status_1',$return = true);
							else if($b['Hrdlogdsk']['protection'] == 2)
								$bitlocker .=  __('bl_status_2',$return = true);
							else 
								$bitlocker .= __('bl_status_',$return = true);
							$bitlocker .= ", ";
						}
					}
					$bitlocker = substr($bitlocker, 0, strlen($bitlocker)-2);
				}
				$csv_result[$j]['Bitlocker']['status'] = $bitlocker;
				
				!empty($Astoses['Astose']['domain_name'])?$csv_result[$j]['Astose']['domain_name']=$Astoses['Astose']['domain_name']:$csv_result[$j]['Astose']['domain_name'] =null;
				//OS（SP),インストール日時
				if(!empty($Astoses['Astose']['os_name'])){
					if(!empty($Astoses['Astose']['servicepack']))
						$csv_result[$j]['Astose']['os_name']= $Astoses['Astose']['os_name'].'('.$Astoses['Astose']['servicepack'].')';
					else
						$csv_result[$j]['Astose']['os_name']= $Astoses['Astose']['os_name'];
				}else
					$csv_result[$j]['Astose']['os_name'] =null;
				
				!empty($Astoses['Astose']['version'])?$csv_result[$j]['Astose']['version']= $Astoses['Astose']['version']:$csv_result[$j]['Astose']['version'] =null;
				!empty($Astoses['Astose']['product_id'])?$csv_result[$j]['Astose']['product_id']= $Astoses['Astose']['product_id']:$csv_result[$j]['Astose']['product_id'] =null;
				!empty($Astoses['Astose']['install_time'])?$csv_result[$j]['Astose']['install_time']= $Astoses['Astose']['install_time']:$csv_result[$j]['Astose']['install_time'] =null;
				isset($Astoses['Astose']['activation'])?$Astose_activation= $Astoses['Astose']['activation'] :$Astose_activation =null;

				//アクティべイション実施			
				if ($Astose_activation == '0') {
					$Astose_activation='○';
				}
				if($Astose_activation=='1'){
					$Astose_activation='×';
				}
				if (strpos($Astoses['Astose']['os_name'],"2000")) {
					$Astose_activation = "-";
				}
				// yaozl end 2009/09/01 modify for LV20R1-280
				//sunhy end 2009/05/06 modify for LV20R1-257

				$this->set('Astose_activation',$Astose_activation);

				isset($Astoses['Astose']['activation'])?$csv_result[$j]['Astose']['activation']= $Astose_activation :$csv_result[$j]['Astose']['activation'] =null;
				
				//使用者
				!empty($Astoses)?$csv_result[$j]['Astose']['user_name']= $Astoses['Astose']['user_name']:$csv_result[$j]['Astose']['user_name'] =null;
				!empty($Astoses)?$csv_result[$j]['Astose']['organization']= $Astoses['Astose']['organization']:$csv_result[$j]['Astose']['organization'] =null;
				!empty($Astoses)?$csv_result[$j]['Astose']['description']= $Astoses['Astose']['description']:$csv_result[$j]['Astose']['description'] =null;

				$result_Astacts="";
				//アカウント一覧
				for($i=0;$i<count($Astacts);$i++){
					$f=$Astacts[$i]['Astact']['account_name'].'; ';
					!empty($Astacts[$i]['Astact']['account_name'])?$result_Astacts=$result_Astacts.$f:$result_Astacts=null;
				}

				$result_Astacts = substr($result_Astacts, 0, strlen($result_Astacts)-2);

				!empty($result_Astacts)?$csv_result[$j]['Astact']['account_name'] = $result_Astacts:$csv_result[$j]['Astact']['account_name']=null;

				if(!empty($Addition)&&!empty($result_Hstadt)){

					foreach ($Addition as  $key =>$v){
						$f =$v['Addition']['addition_name'];
						$b =$v['Addition']['addition_content'];

						!empty($f)? $csv_result[$j]['Hstadt'][$f] =  $result_Hstadt[0]['Hstadt'][$f]: $csv_result[$j]['Hstadt'][$f] =NULL;}

				}
				
				$logonuser = $this->Logonuser->find(array("Logonuser.host_id" => $this->Lv->spec_char_dbm($id)));
		
				!empty($logonuser)?$csv_result[$j]['Logonuser']['account_name'] = $logonuser['Logonuser']['account_name']:$csv_result[$j]['Logonuser']['account_name']=null;
				!empty($logonuser)?$csv_result[$j]['Logonuser']['last_logon'] = $logonuser['Logonuser']['last_logon']:$csv_result[$j]['Logonuser']['last_logon']=null;


			}
			//yzl start  2009/09/07 modify for LV20R1-280再
			else{//ハードウェア台帳にログの上がっていないPCの場合
				$csv_result[$j]['Host']['id'] = $id;
				$csv_result[$j]['Host']['host_name'] = $data[$j]['Temp']['host_name'];
				$csv_result[$j]['Astose']['domain_name'] =null;
				$csv_result[$j]['Asthrd']['machine'] = null;
				$csv_result[$j]['Asthrd']['maker'] = null;
				$csv_result[$j]['Asthrd']['serialno'] = null;
				$csv_result[$j]['Asthrd']['UUID'] = null;
				//$csv_result[$j]['Hrdcpu']['cpu_name.cpu_num0'] = null;
				$csv_result[$j]['Hrdcpu']['cpu_name'] = null;
				$csv_result[$j]['Hrdcpu']['cpu_total'] = null;
				$csv_result[$j]['Hrdcpu']['cores'] = null;
				$csv_result[$j]['Hrdcpu']['clock'] = null;
				$csv_result[$j]['Hrdmem']['capacity'] = "0MB";
				for($i = 0 ; $i < MEMORY_NAME; $i ++){
					$csv_result[$j]['Hrdmem']['capacity'.$i] = null;
				}
				$csv_result[$j]['Hrdphydsk']['allspace_freespace'] = "0GB/0GB";
				for($i = 0 ; $i < ALLSPACE; $i ++){
					$csv_result[$j]['Hrdphydsk']['allspace'.$i] = null;
				}
				$csv_result[$j]['Hrddrv']['driver_name']= null;
				for($i = 0 ; $i < DRIVER_NAME; $i ++){
					$csv_result[$j]['Hrddrv']['driver_name'.$i]= null;
				}
				$csv_result[$j]['Hrdmnt']['monitor_name0']= null;
				$csv_result[$j]['Hrdmnt']['monitor_name1']= null;
				$csv_result[$j]['Hrdmnt']['adapterram0']= null;
				$csv_result[$j]['Hrdmnt']['adapterram1']= null;
				$csv_result[$j]['Hrdmnt']['horizontal.vertical.bits0']= null;
				$csv_result[$j]['Hrdmnt']['horizontal.vertical.bits1']= null;
				for($i = 0 ; $i < NIC_NAME; $i ++){
					$csv_result[$j]['Hrdnic']['nic_name'.$i]= null;
					$csv_result[$j]['Hrdnic']['mac_address'.$i]= null;
					$csv_result[$j]['Hrdnic']['ip_address'.$i]= null;
					$csv_result[$j]['Hrdnic']['gateway'.$i]= null;
					$csv_result[$j]['Hrdnic']['dns_primary'.$i]= null;
					$csv_result[$j]['Hrdnic']['dhcp_address'.$i]= null;
					$csv_result[$j]['Hrdnic']['dhcp_enabled'.$i]= null;
					$csv_result[$j]['Hrdnic']['wlan'.$i]= null;
				}
				$HrdlogdsksStart=10;
				if(defined("LOGDISK_NAME"))
					$HrdlogdsksStart=LOGDISK_NAME;
				for($i=0;$i<$HrdlogdsksStart;$i++){
					$csv_result[$j]['Hrdlogdsk']['name'.$i] = null;
					$csv_result[$j]['Hrdlogdsk']['drivetype'.$i] = null;
					$csv_result[$j]['Hrdlogdsk']['size'.$i] = null;
					$csv_result[$j]['Hrdlogdsk']['freespace'.$i] = null;
				}
				$csv_result[$j]['Astose']['os_name'] = null;
				$csv_result[$j]['Astose']['version'] = null;
				$csv_result[$j]['Astose']['product_id'] = null;
				$csv_result[$j]['Astose']['install_time'] = null;
				$csv_result[$j]['Astose']['activation'] = null;
				$csv_result[$j]['Astose']['user_name'] = null;
				$csv_result[$j]['Astose']['organization'] = null;
				$csv_result[$j]['Astose']['description'] = null;
				
				$csv_result[$j]['Astact']['account_name']= null;
				
				$csv_result[$j]['Logonuser']['account_name'] = null;
				$csv_result[$j]['Logonuser']['last_logon'] = null;
				$csv_result[$j]['Bitlocker']['status'] = null;
		
				$csv_result[$j]['Asthrd']['log_time']= null;
				//拡張資産項目
				if(!empty($Addition)&&!empty($result_Hstadt)){
					foreach ($Addition as  $key =>$v){
						$f =$v['Addition']['addition_name'];
						$b =$v['Addition']['addition_content'];

						!empty($f)? $csv_result[$j]['Hstadt'][$f] =  $result_Hstadt[0]['Hstadt'][$f]: $csv_result[$j]['Hstadt'][$f] =NULL;
					}
				}

			}
			//yzl end  2009/09/07 modify for LV20R1-280再
			$j++;
		}

		$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);
		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_hdws");
		$array_cols = array();
//CSVヘッダの設定
		$array['Host/id'] =__('host_id',true);//hostid
		$array['Host/host_name'] =__('computer_name',true);//コンピュータ名
		$array['Astose/domain_name'] =__('domain_name',true);//ドメイン
		$array['Asthrd/machine'] =__('machine',true);//機種名
		$array['Asthrd/maker'] =__('makername',true);//メーカー名
		$array['Asthrd/serialno'] =__('serialnumber',true);//シリアルナンバー
		$array['Asthrd/UUID'] =__('UUID',true);//シリアルナンバー
		//$array['Hrdcpu/cpu_name.cpu_num0'] =__('CPU',true);//cpu
		$array['Hrdcpu/cpu_name'] =__('CPU',true);//cpu
		$array['Hrdcpu/cpu_total'] =__('CPU_no',true);//cpu
		$array['Hrdcpu/cores'] =__('CPU_cores',true);//cpu
		$array['Hrdcpu/clock'] =__('CPU_clock',true);//cpu
		$array['Hrdmem/capacity'] =__('Hrdmem_00',true);//メモリ（総容量)
		//DIMM
		$f=array();
		for($i=0;$i<$HrdmemsStart;$i++){
			$a='Hrdmem/capacity'.$i;
			$f='DIMM '.$i;
			$array[$a] =$f;
		}
		$array['Hrdphydsk/allspace_freespace'] =__('HDD_03',true);//HDD(総容量/空き容量)
		//ドライブ
		$f=array();
		for($i=0;$i<$HrdphydsksStart;$i++){
			$a='Hrdphydsk/allspace'.$i;
			$f=__('drive',true).$i;
			$array[$a] =$f;
		}
		//光学ドライブ(型番)
		$f=array();
		for($i=0;$i<$HrddrvsStart;$i++){
			$a='Hrddrv/driver_name'.$i;
			$f=__('scannerdrive',true).$i;
			$array[$a] =$f;
		}
		//ビデオコントローラ
		$f=array();
		for($i=0;$i<$HrdmntsStart;$i++){
			$a='Hrdmnt/monitor_name'.$i;
			$b='Hrdmnt/adapterram'.$i;
			$c='Hrdmnt/horizontal.vertical.bits'.$i;

			$f=__('videocontroller',true).$i;
			$g=__('vram_size',true).$i;
			$h=__('Analyticallevelofscreen',true).$i;
			$array[$a] =$f;
			$array[$b] =$g;
			$array[$c] =$h;
		}
		//ネットワークインタフェースカード
		$f=array();
		for($i=0;$i<$HrdnicsStart;$i++){
			$array['Hrdnic/nic_name'.$i] = __('Networkinterfacecard',true).$i;
			$array['Hrdnic/mac_address'.$i] = __('Address_00',true).$i;
			$array['Hrdnic/ip_address'.$i] = __('ip_Address',true).$i;
			$array['Hrdnic/gateway'.$i] = __('nic_gateway',true).$i;
			$array['Hrdnic/dns_primary'.$i] = __('nic_dns1',true).$i;
			$array['Hrdnic/dhcp_enabled'.$i] = __('nic_dhcp',true).$i;
			$array['Hrdnic/dhcp_address'.$i] = __('nic_dhcp_srv',true).$i;
			$array['Hrdnic/wlan'.$i] = __('nic_wlan',true).$i;
		}
		
		for($i=0;$i<$HrdlogdsksStart;$i++){
			$array['Hrdlogdsk/name'.$i] = __('lgdsk_name',true).$i;
			$array['Hrdlogdsk/drivetype'.$i] = __('lgdsk_type',true).$i;
			$array['Hrdlogdsk/size'.$i] = __('lgdsk_size',true).$i;
			$array['Hrdlogdsk/freespace'.$i] = __('lgdsk_free',true).$i;
		}

		$array['Astose/os_name'] =__('OS',true).'('.__('SP',true).')';//OS(SP)
		$array['Astose/version'] =__('OS_version',true);//version
		$array['Astose/product_id'] =__('Product ID',true);//Product ID
		$array['Astose/install_time'] =__('Installationdate',true);//インストール日時

		$array['Astose/activation'] =__('ActiItionexecution',true);//アクティべイション実施
		$array['Astose/user_name'] =__('HardUser',true);//使用者

		$array['Astose/organization'] =__('Organizationname',true);//織名
		$array['Astose/description'] =__('Descriptionname',true);//織名
		$array['Astact/account_name'] =__('Accountlist',true);//アカウント一覧

		$array['Logonuser/account_name'] =__('lastlogon',true);
		$array['Logonuser/last_logon'] =__('lastlogontime',true);
		
		$array['Bitlocker/status'] =__('Bitlocker',true);
		$array['Asthrd/log_time'] =__('Logtime',true);
		
		if(!empty($Addition)){
			foreach ($Addition as $key => $output){
				$diplaydata = $output['Addition']['display'];
				$diplay = decbin($output['Addition']['display']);

				if(($diplaydata==2)||$diplaydata==6){

					$flag=1;
				}
				else{
					$flag=0;
				}
				if(strlen($diplay)==3){
					if(substr($diplay, 0,1)==1){
						$flag=1;   }
				}

				if($flag==1){
					$a= $output['Addition']['addition_name'];
					$b = $output['Addition']['addition_content'];
					$f = "Hstadt/".$a;

					$array[$f]=$b;
				}

			}
		}


		$array_title[] =__('hdw_00',true);
		//xht start 2009/04/28 modify for LogvillageChinese
		$array_title[]='CSV_detail';
		//xht end 2009/04/28 modify for LogvillageChinese
		$csv->special_search_title=$array_title;
		$csv->special_cols=$array;
		$csv->sendCSVFile($csv_result,null,__('hardwareinfodetail',$retrun=true));

	}
	//yuanxiaojun end 20080410
	//CSVダウンロード(通常）
	function csvdown($data=nul,$uu){
		$csv_result1=$uu;
		$Addition=$this->Addition->findAll(null,null,'id ASC','0',null,null);

		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_hdws");

		$array = array(
		""=>__('hdw_00',true),//□ ハードウェア台帳
		"Temp/host_name"=>__('computer_name',true),//"コンピュータ名",
		"Temp/domain_name"=>__('domain_name',true),//"ドメイン名",
		"Temp/machine"=>__('machine',true),//"機種",
		"Temp/maker"=>__('makername',true),//"メーカー",
		"Temp/serialno"=>__('S/N',true),//"S/N",
		"Temp/cpu_name"=>__('CPU',true),//"CPU",
		"Temp/cpu_number"=>__('CPU_no',true),//"CPU数",
		"Temp/hrdmem_capacity"=>__('Hrdmem_00',true),//"メモリー総容量）MB",
		"Temp/hrdphydsk_allspace"=>__('HDD_00',true),//"HDD総容量）GB",
		"Temp/hrdphydsk_freespace"=>__('HDD_01',true),//"HDD空き容量）GB",
		"Temp/hrdphydsk_late"=>__('HDD_02',true),//"HDD残容量",
		"Temp/os_name"=>__('OS',true),//"OS",
		"Temp/servicepack"=>__('SP',true),//"SP",
		"Temp/product_id"=>__('Product ID',true),//"Product ID",
		"Temp/activation"=>__('activation',true),//"アクティベーション"
		"Temp/log_time"=>__('Logtime',true),//最終取得日時
		"Temp/description"=>__('description',true),
		);
		foreach ($Addition as $key => $output)
		{

			/*		   */
			$diplay = $output['Addition']['display'];


			if(($diplay==2)||$diplay==6){
				$flag=1;
			}
			else{
				$flag=0;
			}
			if($flag==1){
				/*		   */
				$a= $output['Addition']['addition_name'];
				$b = $output['Addition']['addition_content'];
				$f = "Temp/".$a;
				$array[$f]=$b;
				/*		   */
			}
			/*		   */
		}
		$csv->special_cols=$array;

		$csv->sendCSVFile($data,$csv_result1,__('hdw',$retrun=true));

	}

}//end class
?>