<?php
/*********************************************************************
*@filename system_mng_sfws_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0          zhangs     2008/12/04    modify for timeout
*            2.0         yzl        2009/05/05    modify for LV20R1-256
*            2.0         kitazume        2010/04/27    ライセンス超過
********************************************************************/
class AssetsMngSfwsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Astsfw','Grpauth','Hstloghead','Host','Rlthstgrp','Rltastsfw','Group');
	var $layout='assets';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('sfw title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index($lk=null,$sc=null,$hid=null,$errorMessage=null)
	{

		if(!empty($lk)&&!empty($sc))
		{
			$this->set('lk',$lk);
			$this->set('sc',$sc);
			$this->set('hid',$hid);
		}

		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	function lists($link=null,$search=null,$group_id=null,$version=null,$maker=null,$pag=null)
	{
		$this->set('link',$link);
		if(isset($this->data['license']['loginin'])&&$this->data['license']['loginin']==1){
			$this->set('license_loginin',1);
		}

		$data_detail=null;
		if($this->data['license']['check']==1 && $this->data['version']['check']==1){
			$this->index('null','null','null',1);
			exit();
		}
		$this->layout="ajax";
		if(isset($search))
		{
			$search=$this->Lv->url_param_decode2($search);
		}
		if(isset($maker))
		{
			$maker=$this->Lv->url_param_decode2($maker);
		}
		if(isset($version))
		{
			$version=$this->Lv->url_param_decode2($version);
		}
		$err=null;

		$searchE=rawurlencode(rawurlencode($search));
		$makerE=rawurlencode(rawurlencode($maker));
		$versionE=rawurlencode(rawurlencode($version));	
		if($link=="hs"||$link=="hm")
		{
			!empty($search)? $this->set('forHideVar', $_POST['forHideVar1']."&data%5BAstsfw%5D%5Bsearc%5D=$searchE&data%5BAstsfw%5D%5Bgroup_name%5D=$group_id&data%5BAstsfw%5D%5Bversion%5D=$versionE&data%5BAstsfw%5D%5Bmaker%5D=$makerE&data%5BAstsfw%5D%5Blink%5D=$link")  : null;
		}
		elseif($link!="hs"&&$link!="hm")
		{
			!empty($search)&&$this->data['Astsfw']['searc']!=$search? $this->set('forHideVar',  $_POST['forHideVar']."&data%5BAstsfw%5D%5Bsearc%5D=$searchE&data%5BAstsfw%5D%5Bgroup_name%5D=$group_id&data%5BAstsfw%5D%5Bversion%5D=$versionE&data%5BAstsfw%5D%5Bmaker%5D=$makerE&data%5BAstsfw%5D%5Blink%5D=$link")  : null;
			if($link=="pg")
			{
				$this->set('forHideVar',  $_POST['forHideVar']."&data%5BAstsfw%5D%5Bsearc%5D=&data%5BAstsfw%5D%5Bgroup_name%5D=&data%5BAstsfw%5D%5Bversion%5D=$versionE&data%5BAstsfw%5D%5Bmaker%5D=$makerE&data%5BAstsfw%5D%5Blink%5D=$link");
			}	
				
		}

		if(empty($search)&&!empty($link))
		{
		}
		if(!empty($this->data['Astsfw']['group_name'] )&&!empty($this->data['Astsfw']['version'])&&!empty($this->data['Astsfw']['maker'])&&!empty($this->data['Astsfw']['link']))
		{			
			if(empty($search)){
				empty($this->data['Astsfw']['searc'])?   $search= $this->data['Astsfw']['sinput'] : $search= $this->data['Astsfw']['searc'];
			}
			empty($group_id)? $group_id=$this->data['Astsfw']['group_name']  : null;
			empty($version)? $version=$this->data['Astsfw']['version']  : null;
			empty($maker)? $maker=$this->data['Astsfw']['maker'] : null;
			empty($link)? $link=$this->data['Astsfw']['link'] : null;
		}
		//==========================
		if(!empty($this->data['Astsfw']['group_name'] ))
		{
			empty($group_id)? $group_id=$this->data['Astsfw']['group_name']  : null;
		}
		if(!empty($this->data['Astsfw']['version']))
		{
			empty($version)? $version=$this->data['Astsfw']['version']  : null;
		}
		if(!empty($this->data['Astsfw']['maker']))
		{
			empty($maker)? $maker=$this->data['Astsfw']['maker'] : null;
		}
		if(!empty($this->data['Astsfw']['link']))
		{
			empty($link)? $link=$this->data['Astsfw']['link'] : null;
		}
		if(!empty($this->data['Astsfw']['searc']))
		{
			empty($search)?   $search= $this->data['Astsfw']['searc'] : null;
		}
		//==========================

		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);

		$this->set('search','');
		$this->set('search_h','');
		$conditions=array('1=1');
		
		if($this->data['syscomp']['check']!=1){
			$conditions[]=" Astsfw.syscomp != True";
		}

		if(isset($search)&&($link=='hm'))
		{
			$conditions[]=" lower(Astsfw.maker) = '".strtolower($this->Lv->spec_char_dbm($search))."'";
		}
		if(isset($search)&&($link=='hs'))
		{
			$conditions[]=" lower(Astsfw.software_name) = '".strtolower($this->Lv->spec_char_dbm($search))."' and  Astsfw.host_id= ".$group_id."";
		}
		//#####################################

		if(!empty($this->data['Astsfw']['sinput']))
		{
			$sinput=$this->data['Astsfw']['sinput'];

			$conditions[]=" (lower(Astsfw.software_name) like '%".strtolower($this->Lv->spec_char_like($sinput))."%' OR  lower(Astsfw.maker) like '%".strtolower($this->Lv->spec_char_like($sinput))."%'  OR  lower(Astsfw.version) like '%".strtolower($this->Lv->spec_char_like($sinput))."%' )    ";
			$this->set('search',__('key left',true).$sinput.__('key right',true));
			$this->set('search_h',$sinput);
		}
		if(isset($search)&&($link=='1'||$link=='csv'))
		{
			$this->set('search_h',$search);
			$conditions[]=" lower(Astsfw.maker) = '".strtolower($this->Lv->spec_char_dbm($search))."'  ";
			$this->set('search',__('make right',true).$search.__('key right',true));
		}
		elseif (isset($search)&&($link=='2'||$link=='csv1'))
		{
			if($version=="null")
			{

				$version=null;
			}else if($version=="empty")
				$version="";

			if($maker=="null")
			{

				$maker="";
			}
			if($search == null){
				$conditions[] = '1=1';
			}else{
				$conditions[] = "lower(Astsfw.software_name) = '".strtolower($this->Lv->spec_char_dbm($search))."'";
			}
			if(is_null($version)){
				$conditions[] = '1=1';
			}else{//echo "<br>".$version;
				$conditions[] = "Astsfw.version = '".$this->Lv->spec_char_dbm($version)."'";
			}
			if($maker == null){
				$conditions[] = '1=1';
			}else{
				$conditions[] = "lower(Astsfw.maker) = '".strtolower($this->Lv->spec_char_dbm($maker))."'";
			}
			if(!empty($this->data['Astsfw']['sinput']))
			{
				$this->set('sfname',$this->data['Astsfw']['sinput']);
			}
			else
			{
				$this->set('sfname',$search);
			}
		}
		elseif (isset($search)&&$link=='1_maker')
		{
			$this->set('search_h',$search);
			$conditions[]=" lower(Astsfw.maker) = '".strtolower($this->Lv->spec_char_dbm($search))."'  ";

			$this->set('search',__('make right',true).$search.__('key right',true));
		}

		if(!empty($group_id)&&($link!="hs"&&$link!="hm"))
		{
			$glist = $this->Grpauth->getChildrenByParent($group_id);
			$cond="";
			foreach($glist as $key => $value){
				$cond.=$key.",";
			}
			$cond = substr($cond,0,-1);
		}
		if(!empty($this->data['Group']['group_name']))
		{
			$glist = $this->Grpauth->getChildrenByParent($this->data['Group']['group_name']);
			$cond="";
			foreach($glist as $key => $value){
				$cond.=$key.",";
			}
			$cond = substr($cond,0,-1);

			$group_id=$this->data['Group']['group_name'];
		}
		$asso = array( // 'Host : hosts : LEFT' => array('Astsfw.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Astsfw.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		);
		
			$asso_timeout = array(
		'Rlthstgrp : rlthstgrps' => array('Astsfw.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		'T1 : (select c.host_id as tt,max(c.log_time) as log_time
 from astsfws as c group by c.host_id)' => array('Astsfw.host_id = T1.tt and Astsfw.log_time =
T1.log_time')
		);
		$conditions[] = "Host.status in (".$this->data['Host']['status'].")";
		$this->set('host_status',$this->data['Host']['status']);
		if(isset($cond))
		$conditions[] = "Group.id in (".$cond.")";

		if(!empty($group_id))
		{
			$grp_in=$group_id;
		}
		elseif(!empty($this->data['Group']['group_name']))
		{
			$grp_in=$this->data['Group']['group_name'];
		}
		else
		{
			$grp_in=$this->_getUserGroup();
		}
		$grpin=$this->Grpauth->getChildrenByParent($grp_in);
		$condition="";
		foreach($grpin as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);

		if($this->data['version']['check']==1){
			$conditions_lis=array_merge($conditions,array('GROUP BY'=>'Astsfw.software_name,Astsfw.maker,Astsfw.version'));
			$field_lis = array('Astsfw.software_name','Astsfw.maker','Astsfw.version','count(distinct(Astsfw.host_id)) as Astsfw__host_ids','count(distinct(Astsfw.licence_code)) as Astsfw__ids');
		}else{
			$conditions_lis=array_merge($conditions,array('GROUP BY'=>'Astsfw.software_name,Astsfw.maker'));
			$field_lis = array('Astsfw.software_name','Astsfw.maker','count(distinct(Astsfw.host_id)) as Astsfw__host_ids','count(Astsfw.licence_code) as Astsfw__ids');
		}
		$hcount= $conditions ;

		$data_p_conditons = array_merge($conditions,array('GROUP BY'=>'Astsfw.software_name,Astsfw.maker,Astsfw.version '));
		if($this->data['license']['check']==1){
			$conditions[] = "Astsfw.licence_code != ''";
			$conditions=array_merge($conditions,array('GROUP BY'=>'Astsfw.software_name,Astsfw.maker'));
			$get = array('Astsfw.software_name','Astsfw.maker','count(distinct(Astsfw.host_id)) as Astsfw__host_ids');
		}else{
			if($this->data['version']['check']==1){
				$conditions=array_merge($conditions,array('GROUP BY'=>'Astsfw.software_name,Astsfw.maker,Astsfw.version '));
				$get = array('Astsfw.software_name','Astsfw.maker','Astsfw.version','count(distinct(Astsfw.host_id)) as Astsfw__host_ids');
			}else{
				$conditions=array_merge($conditions,array('GROUP BY'=>'Astsfw.software_name,Astsfw.maker'));
				$get = array('Astsfw.software_name','Astsfw.maker','count(distinct(Astsfw.host_id)) as Astsfw__host_ids');
			}
		}

		$csvcondition = $conditions;
		$csvcondition[] = "Astsfw.log_time = (select max(log_time) from astsfws as c where c.host_id = Astsfw.host_id)";	
		list($order,$limit,$page) = $this->Pagination->init($csvcondition, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_mng_sfws/lists', 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),  'style' => 'ajax','sortBy' => $this->Lv->sortBy('Astsfw.software_name')));

		if($link=='csv'){
			$data = $this->Astsfw->findByAsso($csvcondition, $get, $order, null, null, $asso);
		}else{
			$data = $this->Astsfw->findByAsso($csvcondition, $get, $order, $limit, $page, $asso);
		}
		$arr = array();
		$arr_i=0;
		$arr_lay = count($this->Grpauth->getParentsByChild($group_id));
		if($this->data['license']['check']==1){
			foreach ($data as $p){
				// ソフトウェア名
				$arr[$arr_i]['Astsfw']['software_name']=$p['Astsfw']['software_name'];
				// メーカー
				$arr[$arr_i]['Astsfw']['maker']=$p['Astsfw']['maker'];
				// 導入数
				$arr[$arr_i]['Astsfw']['host_ids']=$p['Astsfw']['host_ids'];
				// レイヤー数
				$arr[$arr_i]['Astsfw']['lay'] = $arr_lay;
				$arr_i++;
			}
			$license_check_ok = 'license_check_ok';
			$this->set('license_check_ok',$license_check_ok);
		}else{
			if($this->data['version']['check']==1){
				foreach ($data as $p){
					// ソフトウェア名
					$arr[$arr_i]['Astsfw']['software_name']=$p['Astsfw']['software_name'];
					// バージョン情報
					$arr[$arr_i]['Astsfw']['version']=$p['Astsfw']['version'];
					// メーカー
					$arr[$arr_i]['Astsfw']['maker']=$p['Astsfw']['maker'];
					// 導入数
					$arr[$arr_i]['Astsfw']['host_ids']=$p['Astsfw']['host_ids'];
					// レイヤー数
					$arr[$arr_i]['Astsfw']['lay'] = $arr_lay;
					$arr_i++;
				}
				$version_check_ok = 'version_check_ok';
				$this->set('version_check_ok',$version_check_ok);
			}else{
				foreach ($data as $p){
					// ソフトウェア名
					$arr[$arr_i]['Astsfw']['software_name']=$p['Astsfw']['software_name'];
					// メーカー
					$arr[$arr_i]['Astsfw']['maker']=$p['Astsfw']['maker'];
					// 導入数
					$arr[$arr_i]['Astsfw']['host_ids']=$p['Astsfw']['host_ids'];
					// レイヤー数
					$arr[$arr_i]['Astsfw']['lay'] = $arr_lay;
					$arr_i++;
				}
			}
		}
		$data = $arr;
		$asso1 = array(
		'Rlthstgrp : rlthstgrps' => array('Astsfw.host_id = Rlthstgrp.host_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
		);
		$conditions_lis[]=" trim(Astsfw.licence_code)!='' ";
		if(isset($cond))
		$conditions_lis[]="  Group.id in(".$cond.")";
		$conditions_lis[] = "Astsfw.log_time = (select max(log_time) from astsfws as c where c.host_id = Astsfw.host_id)";
		$data_lis = $this->Astsfw->findByAsso($conditions_lis, $field_lis, null, null, null, $asso1);
		$i='0';
		foreach ($data as $datafor)
		{
			$lic = 0;
			foreach ($data_lis as $datafor_list)
			{
				if($this->data['version']['check']==1){
					if($datafor['Astsfw']['software_name']==$datafor_list['Astsfw']['software_name']
					&&$datafor['Astsfw']['maker']==$datafor_list['Astsfw']['maker']
					&&$datafor['Astsfw']['version']==$datafor_list['Astsfw']['version']
					)
					{
						if($this->data['license']['check']==1){
							// ライセンス数
							$data[$i]['Astsfw']['licens']=$datafor_list['Astsfw']['ids'];
							// 保有ライセンス数
							$set_lince = $this->Rltastsfw->findAll(array("Rltastsfw.group_id" => $this->Lv->spec_char_dbm($group_id),"Rltastsfw.software_name" => $this->Lv->spec_char_dbm($datafor['Astsfw']['software_name'])),array("Rltastsfw.setlicence_number"));
							foreach ($set_lince as $vv){
								$lic += $vv['Rltastsfw']['setlicence_number'];
							}
							$data[$i]['Astsfw']['setlicence_number'] = $lic!=0?$lic:"---";
						}else{
							// ライセンス数
							$data[$i]['Astsfw']['licens']=$datafor_list['Astsfw']['ids'];
							$set_lince = $this->Rltastsfw->findAll(array("Rltastsfw.group_id" => $this->Lv->spec_char_dbm($group_id),"Rltastsfw.software_name" => $this->Lv->spec_char_dbm($datafor['Astsfw']['software_name'])),array("Rltastsfw.setlicence_number"));
							foreach ($set_lince as $vv){
								$lic += $vv['Rltastsfw']['setlicence_number'];
							}
							$data[$i]['Astsfw']['setlicence_number'] = $lic!=0?$lic:"---";
						}
					}
				}else{
					if($datafor['Astsfw']['software_name']==$datafor_list['Astsfw']['software_name']
					&&$datafor['Astsfw']['maker']==$datafor_list['Astsfw']['maker']
					)
					{
						if($this->data['license']['check']==1){
							// ライセンス数
							$data[$i]['Astsfw']['licens']=$datafor_list['Astsfw']['ids'];
							// 保有ライセンス数
							$set_lince = $this->Rltastsfw->findAll(array("Rltastsfw.group_id" => $this->Lv->spec_char_dbm($group_id),"Rltastsfw.software_name" => $this->Lv->spec_char_dbm($datafor['Astsfw']['software_name'])));
							foreach ($set_lince as $vv){
								$lic += $vv['Rltastsfw']['setlicence_number'];
							}
							$data[$i]['Astsfw']['setlicence_number'] = $lic!=0?$lic:"---";
						}else{
							// ライセンス数
							$data[$i]['Astsfw']['licens']=$datafor_list['Astsfw']['ids'];
							$set_lince = $this->Rltastsfw->findAll(array("Rltastsfw.group_id" => $this->Lv->spec_char_dbm($group_id),"Rltastsfw.software_name" => $this->Lv->spec_char_dbm($datafor['Astsfw']['software_name'])),array("Rltastsfw.setlicence_number"));
							foreach ($set_lince as $vv){
								$lic += $vv['Rltastsfw']['setlicence_number'];
							}
							$data[$i]['Astsfw']['setlicence_number'] = $lic!=0?$lic:"---";
						}
					}
				}
			}
			$i++;
		}
		for($j = 0; $j < count($data); $j++){
			if(empty($data[$j]['Astsfw']['setlicence_number'] ))
				$data[$j]['Astsfw']['setlicence_number'] = "---";
		}
		$x='0';
		$data_all = $this->Host->findAll(array("Host.status!= 1"), array(' Host.id'), null, null, null);
		if($this->data['license']['check']==1){
			$hcount[] = "Astsfw.licence_code != ''";
		}

		$hcount[] = "Astsfw.log_time = (select max(log_time) from astsfws as c where c.host_id = Astsfw.host_id)";
		$data1 = $this->Astsfw->findByAsso($hcount, array('distinct(Astsfw.host_id) as Astsfw__host_ids'), null, null, null, $asso);
		
		$counthost="";
		foreach ($data1 as $da)
		{
			$counthost++;
		}

		if(!empty($counthost))
		{
			$this->set('data_all',count($data_all));
			$this->set('data1',$counthost);
		}
		else
		{
			$this->set('data1','0');
		}

		//===ソフトウェア名をクリックした場合
		if (isset($search)&&($link=='2' ||$link=='csv1'))  //==ライセンス情報
		{
		    $data_p_conditons[] = "Astsfw.log_time = (select max(log_time) from astsfws as c where c.host_id = Astsfw.host_id)";
			$data_csv1 = $this->Astsfw->findByAsso($data_p_conditons, array('Astsfw.software_name','Astsfw.maker','Astsfw.version','count(distinct(Astsfw.host_id)) as Astsfw__host_ids'), $order, $limit, $page, $asso);
			$m = 0;
			foreach ($data_csv1 as $datafor_csv1)
			{
				foreach ($data_lis as $datafor_list)
				{
					if($datafor_csv1['Astsfw']['software_name']==$datafor_list['Astsfw']['software_name']
					&&$datafor_csv1['Astsfw']['maker']==$datafor_list['Astsfw']['maker']
					&&$datafor_csv1['Astsfw']['version']==$datafor_list['Astsfw']['version']
					)
					{
						$data_csv1[$m]['Astsfw']['licens']=$datafor_list['Astsfw']['ids'];
					}
				}
				$m++;
			}
			if(!empty($search) && $search!=null){
				$search_con = "lower(Astsfw.software_name) = '".strtolower($this->Lv->spec_char_dbm($search))."'";
			}else{
				$search_con = "1=1";
			}

			if($this->data['version']['check'] == 1){
				if(!is_null($version)){
					$version_con = "Astsfw.version = '".$this->Lv->spec_char_dbm($version)."'";
				}else{
					$version_con = "10=10";
				}
			}else{
				$version_con = "11=11";
			}

			if(!empty($maker) && $maker!=null){
				$maker_con = "lower(Astsfw.maker) = '".strtolower($this->Lv->spec_char_dbm($maker))."'";
			}else{
				$maker_con = "1=1";
			}

			if(!empty($cond) && $cond!=null){
				$cond_con = "Group.id in (".$cond.")";
			}else{
				$cond_con = "1=1";
			}

			$asso_licenc = array(
			'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
			'Group : groups : LEFT' => array('Rlthstgrp.group_id = Group.id'),
			);
			$licence_code = $this->Astsfw->findByAsso(array($search_con,$version_con,$maker_con,$cond_con,
			"group by"=>"CASE WHEN lower(Astsfw.software_name) like '%office%' THEN LEFT(Astsfw.licence_code,17) ELSE Astsfw.licence_code END",
			" ((lower(Astsfw.software_name) like '%office%' and lower(Astsfw.maker) = 'microsoft corporation') or lower(Astsfw.maker) like '%adobe%')"),
			array("CASE WHEN lower(Astsfw.software_name) like '%office%' THEN LEFT(Astsfw.licence_code,17) ELSE Astsfw.licence_code END AS Astsfw__licence_code",
			'count(distinct(Astsfw.host_id)) as Astsfw__host_ids'), null, null, null, $asso_licenc);

			$this->set('licence_code',$licence_code);
			$j=0;

			$data_detail_csv1=null;

			$datail_con = $conditions;
			if($this->data['version']['check']==1){
				$datail_con['GROUP BY'] = "Astsfw.software_name,Astsfw.maker,Astsfw.version,CASE WHEN lower(Astsfw.software_name) like '%office%' THEN LEFT(Astsfw.licence_code,17) ELSE Astsfw.licence_code END";
			    $data = $this->Astsfw->findByAsso($datail_con, array('distinct Astsfw.software_name as Astsfw__software_name','Astsfw.maker','Astsfw.version','count(distinct(Astsfw.host_id)) as Astsfw__host_ids','CASE WHEN lower(Astsfw.software_name) like \'%office%\' THEN LEFT(Astsfw.licence_code,17) ELSE Astsfw.licence_code END AS Astsfw__licence_code'), $order, $limit, $page, $asso_timeout);
			}else{
				$datail_con['GROUP BY'] = "Astsfw.software_name,Astsfw.maker,CASE WHEN lower(Astsfw.software_name) like '%office%' THEN LEFT(Astsfw.licence_code,17) ELSE Astsfw.licence_code END";
				$data = $this->Astsfw->findByAsso($datail_con, array('distinct Astsfw.software_name as Astsfw__software_name','Astsfw.maker','count(distinct(Astsfw.host_id)) as Astsfw__host_ids','CASE WHEN lower(Astsfw.software_name) like \'%office%\' THEN LEFT(Astsfw.licence_code,17) ELSE Astsfw.licence_code END AS Astsfw__licence_code'), $order, $limit, $page, $asso_timeout);		         
			}
			foreach ($data as $output)
			{
				if(empty($output['Astsfw']['licens']))
				{
					$untrue="0";
					$lic_count='0';
				}
				else
				{
					$untrue="0";
					$lic_count=$code['Astsfw']['host_ids'];
				}


				$setlicence_number_con = array();
				$setlicence_number_con[] = "Rltastsfw.software_name = 0x".bin2hex($output['Astsfw']['software_name']);
				$setlicence_number_con[] = "Rltastsfw.licence_code ='".$output['Astsfw']['licence_code']."'";
				if($group_id){
					$setlicence_number_con[] = "Rltastsfw.group_id = ".$group_id;
				}else{
					$setlicence_number_con[] = "1=1";
				}
				$setlicence_number = $this->Rltastsfw->findAll($setlicence_number_con,array("Rltastsfw.setlicence_number"));
				// ソフトウェア名
				$data_detail[$j]['Astsfw']['software_name']=$output['Astsfw']['software_name'];
				// バージョン情報
				if(isset($output['Astsfw']['version'])){
					$data_detail[$j]['Astsfw']['version']=$output['Astsfw']['version'];
				}
				// メーカー
				if(empty($output['Astsfw']['maker'])){
					$data_detail[$j]['Astsfw']['maker'] = "---";
				}else{
					$data_detail[$j]['Astsfw']['maker']=$output['Astsfw']['maker'];
				}
				// ライセンス情報
				if(empty($output['Astsfw']['licence_code'])){
					$data_detail[$j]['Astsfw']['licence_code'] = "---";
				}else{
					$data_detail[$j]['Astsfw']['licence_code']=$output['Astsfw']['licence_code'];
				}
				// 保有ライセンス数
				if($group_id && $output['Astsfw']['software_name']){
					if(empty($setlicence_number[0]['Rltastsfw']['setlicence_number'])){
						$data_detail[$j]['Astsfw']['setlicence_number'] = "---";
					}
					else{
						$data_detail[$j]['Astsfw']['setlicence_number'] = $setlicence_number[0]['Rltastsfw']['setlicence_number'];
					}
				}else{
					$data_detail[$j]['Astsfw']['setlicence_number'] = "---";
				}
				// 導入数
				$data_detail[$j]['Astsfw']['host_ids']=$output['Astsfw']['host_ids']==0 ? '---' :$output['Astsfw']['host_ids'];
				// 差異
				$data_detail[$j]['Astsfw']['untrue']=$untrue==0 ? '---' : $untrue;
				// レイヤー数
				$data_detail[$j]['Astsfw']['lay']=count($this->Grpauth->getParentsByChild($group_id));

				$li_un=$li_un+$lic_count;
				//						$data_detail[$j]['Sfwlcc']['lic_id']=$code['Sfwlcc']['id'];
				$j++;
				//}

			}


			$c = 0;
			$this->set('flag',$this->data['version']['check']);
			$this->set('data_detail',$data_detail);

			if($link=='csv1')
			{
				$this->csvdown1($data_detail);exit;
			}
		}
		//============================csv====================
		if($link=='csv')
		{
			if($this->data['version']['check']==1){
				$data_csv = $this->Astsfw->findByAsso($conditions, array('Astsfw.software_name','Astsfw.maker','Astsfw.version','count(distinct(Astsfw.host_id)) as Astsfw__host_ids',"sum(case when licence_code ='' then 0 else 1 end) as Astsfw__licens"), $order, null, null, $asso_timeout);
				$flag = 1;
			}
			elseif ($this->data['license']['check']==1){
				$data_csv = $data;
				$flag = 2;
			}else{
				$data_csv = $data;
				$flag = 3;
			}
			$this->csvdown($data_csv,$flag);exit;
		}

		$this->set('err',$err);

		$this->set('data',$data);
		$this->set('version',$version);
		$this->set('maker',$maker);
		$this->set('group_id',$group_id);
		$this->set('limit',$limit);
		$this->set('page',$pag);

		/*echo '$search=';
var_dump($search);
echo '<br/>$link=';
var_dump($link);
echo '<br/>$maker=';
var_dump($maker);*/
		if((isset($search)&&$link==1)||$link=='pg')
		{
			$this->render('lists');
		}
		elseif (isset($search)&&$link==2)
		{
			$this->render('detail');
		}
	}

	function licset($flag=null,$licence_code=null,$software_name=null,$maker=null,$setlicence_number=null,$host_ids=null,$untrue=null)
	{
		if(isset($this->data['license']['loginin'])&&$this->data['license']['loginin']==1){
			$this->set('license_loginin',1);
		}
		$this->layout="ajax";
		if(isset($this->data['asset']['group_name'])){
			$group_id = $this->data['asset']['group_name'];
		}
		else{
			$group_id = $this->_getUserGroup();
		}
		$group_name = $this->Group->find(array("Group.id" => $this->Lv->spec_char_dbm($group_id)),array("Group.group_name"));
		// session hidden
		$hid_arr = array();
		$hid_arr[] = $licence_code;
		$hid_arr[] = $software_name;
		$hid_arr[] = $maker;
		$hid_arr[] = $setlicence_number;
		$hid_arr[] = $host_ids;
		$hid_arr[] = $untrue;
		if(empty($_SESSION['hid_session'])){
			session_unregister('hid_session');
			$_SESSION['hid_session'] = $hid_arr;
		}else{
			$_SESSION['hid_session'] = $hid_arr;
		}


		if($flag == 0){
			$assgroupid = $this->data['asset']['group_name'];
		}else{
			$assgroupid = $group_id;
		}

		if($setlicence_number=="---"){
			$setlicence_number = 0;
		}else{
			$setlicence_number = (int)$setlicence_number;
		}

		if($host_ids == "---"){
			$host_ids = 0;
		}else{
			$host_ids = (int)$host_ids;
		}

		if($untrue == "---"){
			$untrue = 0;
		}else{
			$untrue = (int)$untrue;
		}
		$asso = array( // 'Host : hosts : LEFT' => array('Astsfw.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps : LEFT' => array('Astsfw.host_id = Rlthstgrp.host_id'),
		'Grpauth : grpauths : LEFT' => array('Grpauth.group_id = Rlthstgrp.group_id'),
		'T1 : (SELECT host_id, MAX(log_time) as log_time FROM astsfws group by host_id) ' => array('Astsfw.host_id = T1.host_id and Astsfw.log_time = T1.log_time'),);

		// プロダクトID
		$this->set('licence_code',$licence_code);
		// アプリケーション名
		$softwareName_decode = $this->Lv->url_param_decode2($software_name);
		$maker_decode = $this->Lv->url_param_decode2($maker);
		$this->set('software_name',$softwareName_decode);
		// メーカー名
		$this->set('maker',$maker_decode);

		// 総保有ライセンス数
		$all_setlicence_number = $this->Rltastsfw->find(array("Rltastsfw.software_name" => $this->Lv->spec_char_dbm($softwareName_decode),"Rltastsfw.group_id" => 1,"Rltastsfw.licence_code" => $this->Lv->spec_char_dbm($licence_code)),array("Rltastsfw.setlicence_number"));

		if($all_setlicence_number['Rltastsfw']['setlicence_number'] == ''){
			$this->set('all_setlicence_number','---');
		}else{
			$this->set('all_setlicence_number',$all_setlicence_number['Rltastsfw']['setlicence_number']);
		}
		// 総導入数
		$grpin_allarr = $this->Grpauth->getChildrenByParent(1);
		$licset_allcondition = array();
		$licset_allcondition[] = "Astsfw.licence_code like '%".$this->Lv->spec_char_like($licence_code)."%'";
		$licset_allcondition[] = "Astsfw.software_name = '".$this->Lv->spec_char_dbm($softwareName_decode)."'";
		$licset_allcondition[] = "Astsfw.maker = '".$this->Lv->spec_char_dbm($maker_decode)."'";
		foreach($grpin_allarr as $key1 => $value1){
			$cond1.=$key1.",";
		}
		$cond1 = substr($cond1,0,-1);
		$licset_allcondition[]=" Grpauth.group_id in (".$cond1.") ";
		$all_host_ids = $this->Astsfw->findByAsso($licset_allcondition,array('count(distinct(Astsfw.host_id)) as Astsfw__host_ids'),null,null,null,$asso);
		if($all_host_ids[0]['Astsfw']['host_ids'] == ''){
			$this->set('all_host_ids','---');
		}else{
			$this->set('all_host_ids',$all_host_ids[0]['Astsfw']['host_ids']);
		}
		// 差異
		if($all_setlicence_number['Rltastsfw']['setlicence_number']== ''){
			$this->set('all_untrue','---');
		}else{
			$all_untrue = $all_setlicence_number['Rltastsfw']['setlicence_number'] - $all_host_ids[0]['Astsfw']['host_ids'];
			$this->set('all_untrue',$all_untrue);
		}

		// グループ組
		$grpin = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$this->set('grpin',$grpin);

		$x = 0;
		$assets_group = array();
		$temp_group = $this->Group->findAll(array("Group.parent_id" => $this->Lv->spec_char_dbm($group_id)),array("Group.id","Group.group_name"));
		$assets_group[$x]['Group']['id'] = $group_id;
		$assets_group[$x]['Group']['group_name'] = $group_name['Group']['group_name'];
		$x++;
		if(count($temp_group)>0 && count($this->Grpauth->getParentsByChild($group_id))<=3){
			foreach ($temp_group as $temp_value){
				$assets_group[$x]['Group']['id'] = $temp_value['Group']['id'];
				$assets_group[$x]['Group']['group_name'] = $temp_value['Group']['group_name'];
				$x++;
				if(count($this->Grpauth->getParentsByChild($temp_value['Group']['id']))<=3){
					$temp_group_lay2 = $this->Group->findAll(array("Group.parent_id =".$temp_value['Group']['id']),array("Group.id","Group.group_name"));
					if(count($temp_group_lay2)>0){
						//echo '====================================='.count($this->Group->findAll(array("Group.parent_id =".$temp_value['Group']['id']),array("Group.id","Group.group_name"))).'<br/>';
						//$y = $x;
						foreach ($temp_group_lay2 as $temp_value1){
							$assets_group[$x]['Group']['id'] = $temp_value1['Group']['id'];
							$assets_group[$x]['Group']['group_name'] = $temp_value1['Group']['group_name'];
							$x++;
						}
					}
				}
			}
		}


		$licset_arr = array();
		$k=0;
		foreach ($assets_group as $val) {
			//if($val['Group']['id'] != $group_id){
			//グループ名
			$licset_arr[$k]['licset']['group_id'] = $val['Group']['id'];
			$licset_arr[$k]['licset']['group_name'] = $val['Group']['group_name'];
			//保有ライセンス数
			//echo '----------'.$val['Group']['id'].'----------'.$software_name.'<br/>';
			$temp_groupname =  $this->Rltastsfw->find(array("Rltastsfw.group_id" => $this->Lv->spec_char_dbm($val['Group']['id']),"Rltastsfw.software_name" => $this->Lv->spec_char_dbm($softwareName_decode),"Rltastsfw.licence_code" => $this->Lv->spec_char_dbm($licence_code)),array("Rltastsfw.setlicence_number"));
			//debug($temp_groupname,true);
			if($temp_groupname == '' || $temp_groupname['Rltastsfw']['setlicence_number'] == ''){
				$licset_arr[$k]['licset']['setlicence_number'] = '---';
			}else{
				$licset_arr[$k]['licset']['setlicence_number'] = $temp_groupname['Rltastsfw']['setlicence_number'];
			}
			//導入数
			$grpin_arr = $this->Grpauth->getChildrenByParent($val['Group']['id']);
			$licset_condition = array();
			$licset_condition[] = "Astsfw.licence_code like '%".$this->Lv->spec_char_like($licence_code)."%'";
			$licset_condition[] = "Astsfw.software_name = '".$this->Lv->spec_char_dbm($softwareName_decode)."'";
			$licset_condition[] = "Astsfw.maker = '".$this->Lv->spec_char_dbm($maker_decode)."'";
			//$licset_condition['GROUP BY'] = 'Astsfw.version';
			//debug($grpin_arr,true);
			foreach($grpin_arr as $key => $value){
				//if($key != $group_id){
				$cond.=$key.",";
				//}
			}
			//echo '------------'.$cond.'<br/>';
			$cond = substr($cond,0,-1);

			$licset_condition[]=" Grpauth.group_id in (".$cond.") ";
			$cond = '';
			$Astsfw_arr = $this->Astsfw->findByAsso($licset_condition,array('count(distinct(Astsfw.host_id)) as Astsfw__host_ids'),null,null,null,$asso);
			//debug($Astsfw_arr,true);
			if($Astsfw_arr[0]['Astsfw']['host_ids']==''||$Astsfw_arr[0]['Astsfw']['host_ids']==0){
				$licset_arr[$k]['licset']['host_ids1'] = '---';
			}else{
				$licset_arr[$k]['licset']['host_ids1'] = $Astsfw_arr[0]['Astsfw']['host_ids'];
			}
			//差異
			if($temp_groupname == '' || $temp_groupname['Rltastsfw']['setlicence_number'] == ''){
				$licset_arr[$k]['licset']['untrue'] = '---';
			}else{
				$licset_arr[$k]['licset']['untrue'] = (int)$licset_arr[$k]['licset']['setlicence_number'] - (int)$licset_arr[$k]['licset']['host_ids1'];
			}
			//レイヤー数
			$licset_arr[$k]['licset']['lay'] = count($this->Grpauth->getParentsByChild($val['Group']['id']));
			//バージョン名
			if(empty($Astsfw_arr[0]['Astsfw']['version']) || $Astsfw_arr[0]['Astsfw']['version'] == ""){
				$licset_arr[$k]['licset']['version'] = '---';
			}else{
				$licset_arr[$k]['licset']['version'] = $Astsfw_arr[0]['Astsfw']['version'];
			}
			$k++;
			//}
		}

		$this->set('licset_arr',$licset_arr);

		// グループ名HEAD
		$group_name_head = $this->Group->find(array("Group.id" => $this->Lv->spec_char_dbm($assgroupid)),array("Group.group_name"));
		$this->set('current_group_name',$group_name_head['Group']['group_name']);

		// 保有ライセンス数HEAD
		$setlicence_number_head = $this->Rltastsfw->find(array("Rltastsfw.group_id" => $group_id,"Rltastsfw.software_name ='".$this->Lv->spec_char_dbm($softwareName_decode)."'","Rltastsfw.licence_code ='".$licence_code."'"),array("Rltastsfw.setlicence_number"));
		//echo '-----------'.$setlicence_number_head['Rltastsfw']['setlicence_number'];
		if($setlicence_number_head['Rltastsfw']['setlicence_number'] == ''){
			$this->set('current_licset_setlicence_number','---');
		}else{
			$this->set('current_licset_setlicence_number',$setlicence_number_head['Rltastsfw']['setlicence_number']);
		}

		// 導入数HEAD
		//debug($licset_arr,true);
		$licset_untrue_head = 0;
		foreach ($licset_arr as $arr_value){
			if($arr_value['licset']['group_id'] == $group_id){
				$licset_untrue_head = $arr_value['licset']['host_ids1'];
			}
		}
		$this->set('current_licset_host_ids',$licset_untrue_head);

		// 差異HEAD
		if($setlicence_number_head['Rltastsfw']['setlicence_number'] == ''){
			$this->set('current_licset_untrue','---');
		}else{
			$this->set('current_licset_untrue',$setlicence_number_head['Rltastsfw']['setlicence_number'] - $licset_untrue_head);
		}
		// グループID
		$this->set('group_id',$group_id);
		$this->set('setlicence_number',$setlicence_number);
		$this->set('host_ids',$host_ids);
		$this->set('untrue',$untrue);
		$this->render('licset');
	}

	function licset_set($flag=null,$software_name,$version,$make,$group_id,$setlicence_number,$licencse_code=null,$all_host_ids=null,$all_untrue=null){

		if(isset($this->data['license']['loginin'])&&$this->data['license']['loginin']==1){
			$this->set('license_loginin',1);
		}
		$this->set('licencse_code',$licencse_code);
		$this->set('all_host_ids',$all_host_ids);
		$this->set('all_untrue',$all_untrue);
		//zhangs end 20080604
		$this->layout="ajax";
		$errorMessage = array();
		$this->set('software_name',$software_name);
		//		$this->set('licence_code',$licence_code);
		$this->set('version',$version);
		$this->set('make',$make);
		$group_name = $this->Group->find(array("Group.id" => $this->Lv->spec_char_dbm($group_id)));
		$this->set('group_name',$group_name['Group']['group_name']);
		$this->set('group_id',$group_id);
		if($flag == 0){
			if(trim($this->data['licset_set']['input'])=="" || ereg("^(0|[1-9][0-9]*)$",trim($this->data['licset_set']['input']))){

				$parents_temp = $this->Group->find(array("Group.id" => $group_id),array("Group.parent_id"));
				$parent_conditon = array();
				if($parents_temp['Group']['parent_id'] == ''){
					$parent_conditon[] = '1=1';
				}else{
					$parent_conditon[] = "Group.parent_id =".$parents_temp['Group']['parent_id'];
				}
				$parent_conditon[] = "Group.id !=".$group_id;
				$parents = $this->Group->findAll($parent_conditon);

				$number = 0;
				$num_child = 0;
				//check parent
				if($parents_temp['Group']['parent_id'] == ''){
					$num_parent = 0;
				}else{
					$num_parent = $this->Rltastsfw->find(array("Rltastsfw.group_id" => $parents_temp['Group']['parent_id'],"Rltastsfw.software_name" => $software_name,"Rltastsfw.licence_code" => $_SESSION['hid_session'][0]),array("Rltastsfw.setlicence_number"));
				}
				foreach ($parents as $values){
					if($values['Group']['id'] != $group_id){
						$num_temp = $this->Rltastsfw->find(array("Rltastsfw.group_id" => $values['Group']['id'],"Rltastsfw.software_name" => $software_name,"Rltastsfw.licence_code" => $_SESSION['hid_session'][0]),array("Rltastsfw.setlicence_number"));
						if($num_temp['Rltastsfw']['setlicence_number'] == ''){
							$number -= 0;
						}else{
							$number -= (int)$num_temp['Rltastsfw']['setlicence_number'];
						}
						//$j++;
					}
				}

				if($num_parent['Rltastsfw']['setlicence_number'] == ''){
					$number = 0;
				}else{
					$number = (int)$num_parent['Rltastsfw']['setlicence_number'] + $number;
				}

				if(strlen($this->data['licset_set']['input'])>9){
					$setlicence_number = trim($this->data['licset_set']['input']);
					$errorMessage[]=__('licence_error7',$return = true);
				}else{
					if($group_id != 1){
						if($this->data['licset_set']['input'] != ''){
							if(strlen($this->data['licset_set']['input'])>9){
							}else{
								if($num_parent['Rltastsfw']['setlicence_number'] == ''){
									$setlicence_number = trim($this->data['licset_set']['input']);
									$errorMessage[]=__('licence_error2',$return = true);

								}elseif((int)trim($this->data['licset_set']['input']) > $number){
									$setlicence_number = trim($this->data['licset_set']['input']);
									$errorMessage[]=__('licence_error1',$return = true);
								}
							}
						}
					}
				}

				//check child
				$child = $this->Group->findAll(array("Group.parent_id" => $this->Lv->spec_char_dbm($group_id)));
				foreach ($child as $child_value){
					$num_child_temp = $this->Rltastsfw->find(array("Rltastsfw.group_id" => $child_value['Group']['id'],"Rltastsfw.software_name ='".$software_name."'","Rltastsfw.licence_code ='".$_SESSION['hid_session'][0]."'"),array("Rltastsfw.setlicence_number"));
					if($num_child_temp['Rltastsfw']['setlicence_number'] == ''){
						$num_child += 0;
					}else{
						$num_child += (int)$num_child_temp['Rltastsfw']['setlicence_number'];
					}
				}
				if($this->data['licset_set']['input'] == '' && $num_child>0){
					$setlicence_number = trim($this->data['licset_set']['input']);
					$errorMessage[]=__('licence_error6',$return = true);
				}
				elseif($this->data['licset_set']['input'] != ''){
					if((int)$this->data['licset_set']['input'] < $num_child){
						$setlicence_number = trim($this->data['licset_set']['input']);
						$errorMessage[]=__('licence_error6',$return = true);
					}
				}

			}else{
				$setlicence_number = trim($this->data['licset_set']['input']);
				$errorMessage[]=__('licence_error3',$return = true);

			}
			if(!empty($errorMessage)){
				$this->set('errorMessage',$errorMessage);
			}else{
				if(trim($this->data['licset_set']['input']) == "" || trim($this->data['licset_set']['input']) == "0"){
					$set_nember = 'NULL';
				}else{
					$set_nember = trim($this->data['licset_set']['input']);
				}

				$flag = $this->Rltastsfw->findAll(array("Rltastsfw.group_id" => $this->Lv->spec_char_dbm($group_id),"Rltastsfw.software_name" => $this->Lv->spec_char_dbm($software_name),"Rltastsfw.licence_code" => $this->Lv->spec_char_dbm($_SESSION['hid_session'][0])));
				//INSERT
				if(count($flag)==0){
					$this->Rltastsfw->query("insert into rltastsfws values(".$group_id.",'".$software_name."',".$set_nember.",'".$_SESSION['hid_session'][0]."')");
				}else{
					//UPDATE
					$this->Rltastsfw->query("update rltastsfws set setlicence_number =".$set_nember." where group_id =".$group_id." and software_name ='".$software_name."' and licence_code ='".$_SESSION['hid_session'][0]."'");
				}
				$this->licset(-1,$_SESSION['hid_session'][0],$_SESSION['hid_session'][1],$_SESSION['hid_session'][2],$_SESSION['hid_session'][3],$_SESSION['hid_session'][4],$_SESSION['hid_session'][5],$_SESSION['hid_session'][6]);
			}
		}
		if($setlicence_number == '' || $setlicence_number == "---"){
			$this->set('setlicence_number','');
		}else{
			$this->set('setlicence_number',$setlicence_number);
		}

	}

	function detail($id)
	{
		$this->layout="ajax";
	}


	function csvdown($data,$flag)
	{
		require_once( 'csv/DlFactory.php' );

		$csv = DlFactory::create("assets_mng_sfws");
		if($flag == 1){

			foreach ($data as $key=>$ac)
			{
				if(!empty($ac['Astsfw']['lic']))
				{
					if($ac['Astsfw']['host_ids']-$ac['Astsfw']['lic']=='0')
					{
						$data[$key]['Astsfw']['nolic']="---";
					}
					else
					{
						$data[$key]['Astsfw']['nolic']=$ac['Astsfw']['host_ids']-$ac['Astsfw']['lic'];
					}
				}
				else
				{
					$data[$key]['Astsfw']['nolic']=$ac['Astsfw']['host_ids'];
					$data[$key]['Astsfw']['lic']="---";
				}
			}


			$array = array("Astsfw/software_name"=>__('software', $return = true),//"ソフトウェア名",
			"Astsfw/version"=>__('version', $return = true),//"バージョン情報",
			"Astsfw/maker"=>__('maker', $return = true),//"メーカー",
			"Astsfw/host_ids"=>__('inter', $return = true),//"導入数",
			"Astsfw/licens"=>__('License', $return = true),//"ライセンス数",
			"Astsfw/nolic"=>__('untrue', $return = true),//"未確認数",

			);
		}
		elseif($flag == 2){
			foreach ($data as $key=>$ac)
			{
				if($ac['Astsfw']['host_ids'] != ''){
					if(!empty($ac['Astsfw']['licens']))
					{
						$data[$key]['Astsfw']['nolic']=(int)$ac['Astsfw']['host_ids']-(int)$ac['Astsfw']['licens'];
					}
					else
					{
						$data[$key]['Astsfw']['nolic']=(int)$ac['Astsfw']['host_ids'];
					}
				}else{
					$data[$key]['Astsfw']['nolic']='---';
				}
			}
			$array = array("Astsfw/software_name"=>__('software', $return = true),//"ソフトウェア名",
			"Astsfw/maker"=>__('maker', $return = true),//"メーカー",
			"Astsfw/setlicence_number"=>__('setlicence_number', $return = true),//"保有ライセンス数",
			"Astsfw/host_ids"=>__('inter', $return = true),//"導入数",
			"Astsfw/licens"=>__('License', $return = true),//"ライセンス数",
			"Astsfw/nolic"=>__('untrue', $return = true),//"未確認数",

			);
		}
		elseif($flag == 3){
			foreach ($data as $key=>$ac)
			{
				if(!empty($ac['Astsfw']['licens']))
				{
					if(empty($ac['Astsfw']['host_ids']))
					{
						$data[$key]['Astsfw']['nolic']="---";
					}
					else
					{
						$data[$key]['Astsfw']['nolic']=$ac['Astsfw']['host_ids']-$ac['Astsfw']['licens'];
					}
				}
				else
				{
					$data[$key]['Astsfw']['nolic']=$ac['Astsfw']['host_ids'];
					$data[$key]['Astsfw']['licens']="---";
				}
			}
			$array = array("Astsfw/software_name"=>__('software', $return = true),//"ソフトウェア名",
			"Astsfw/maker"=>__('maker', $return = true),//"メーカー",
			"Astsfw/host_ids"=>__('inter', $return = true),//"導入数",
			"Astsfw/licens"=>__('License', $return = true),//"ライセンス数",
			"Astsfw/nolic"=>__('untrue', $return = true),//"未確認数",

			);
		}
		//			       debug($data);
		$csv->special_cols=$array;
		$csv->sendCSVFile($data,$this->data,__('sfw',$return=true));

		exit;
		//zhangs end 20080605
		//xinw end 20080429
	}

	//zhangs start 20080610
	function csvdown1($data=nul)
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("assets_mng_sfws");


		$array = array("Astsfw/software_name"=>__('software', $return = true),//"ソフトウェア名",
		"Astsfw/maker"=>__('maker', $return = true),//"メーカー",
		"Astsfw/licence_code"=>__('license inf', $return = true),//"ライセンス情報",
		"Astsfw/setlicence_number"=>__('setlicence_number', $return = true),//"保有ライセンス数",
		"Astsfw/host_ids"=>__('inter', $return = true),//"導入数",
		"Astsfw/untrue"=>__('untrue', $return = true),//"差異",

		);

		$csv->special_cols=$array;
		//	        debug($array,true);
		//debug($data);
		$csv->sendCSVFile($data,$this->data,__('sfwdetail',$return=true));
	}
	
	function checkin_arr($arr,$data){
		$check = -1;
		foreach ($arr as $key=>$value){
			if($value['Astsfw']['software_name'] == $data && $value['Astsfw']['software_name']){
				$check = $key;
				break;
			}else{
				$check = -1;
			}
		}
		return $check;
	}
	
	function checkin_arr2($arr,$arr2){
		$check = -1;
		foreach ($arr as $key=>$value){
			if($value['Astsfw']['software_name'] == $arr2['Astsfw']['software_name'] && $value['Astsfw']['software_name']){
				if($value['Astsfw']['maker'] == $arr2['Astsfw']['maker'] && $value['Astsfw']['maker']){
					$check = $key;
					break;
				}else 
					$check = -1;
			}else{
				$check = -1;
			}
		}
		return $check;
	}

}
?>