<?php
/*********************************************************************
*@filename alert_pc_controller.php
*@description AlertPcControllerComponent メールポップアップ 
*@note 
*@histories  rivision	author		date		comment
*            2.0      sunhuiyan     20090305   modify for ALERT
********************************************************************/  
class AlertPcControllerComponent extends Object    
{
	var $controller = true;
	
	function startup(&$controller)
	{
		$this->controller = &$controller;
	}	
	
	//20090309 sunhy start	
	function search_judge($table_name, $column_name, $txt_name, $condition_array)//検索条件を判断する
	{
		if (!empty($txt_name)){
			$condition = $this -> get_text($table_name, $column_name, $txt_name, $condition_array);
			return $condition;
		}
		else{
			return $condition_array;
		}
		
	}
	
	function get_text($table_name, $column_name, $txt_name, $condition_array)//テクスト内容を取得する
	{
		//xinw start 20080221
		//xuchan start 20081029
		//$criteria = $criteria."lower(Astsfw.software_name) like '%".strtolower($app_name)."%' and ";
		$condition_array[] = "lower(".$table_name.".".$column_name.") like '%".strtolower($txt_name)."%'";
		//xuchan end 20081029
		//xinw end 20080221
		return $condition_array;
	}
	//20090309 sunhy end
	
	function get_group($group_id)//グループ情報を取得する
	{
		if(empty($group_id)){
			$group_id = $this->data['Group']['group_id'];
		}
		$condition = array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group = $this->controller->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
		return $group;
	}
	
	
	function get_child_info($group_id, $table1,$column1, $table2, $column2, $condition)//child設定を取得する
	{	
		$condition1=null;
		$child_list = $this->controller->Grpauth->getChildrenByParent($group_id);
		if (!empty($child_list)){
			foreach ($child_list as $key=>$list){
				if($key<>$group_id){
					if($column2 != "host_id")
						$condition1 = $condition1."$table1.group_id = $key or ";
					else
						$condition1 = $condition1."$table1.host_id = $key or ";
				}
			}
		}
		
		$condition1 = substr($condition1,0,-3);
		if($column2 != "host_id"){
			$condition1 = $condition1."GROUP BY $table1.$column1, $table1.group_id";
			$check_child = $this->controller->$table1->findAll($condition1,"$table1.group_id, $table1.$column1");
		}
		else{
			$condition1 = $condition1."GROUP BY $table1.$column1, $table1.host_id";
			$check_child = $this->controller->$table1->findAll($condition1,"$table1.host_id, $table1.$column1");
		}
		
		
		if (!empty($check_child)){
			$condition = $this -> get_pc_value($table1,$column1, $table2, $column2, $condition, $check_child);
		}	
		
		return $condition;
	}
	
	//20090309 sunhy start
	function get_pc_value($table1,$column1, $table2, $column2, $condition, $check_child)//PCの情報を取得する
	{
		foreach ($check_child as $value_child){
			//sunhy start 2009/05/22 modify for JLN-001
			//$grp_child = $value_child["$table1"]["group_id"];
			$grp_child = empty($value_child["$table1"]["group_id"]) ? 0 : $value_child["$table1"]["group_id"];
			//sunhy end 2009/05/22 modify for JLN-001
			$lim_hid = $this->controller->Rlthstgrp->findAll(array("Rlthstgrp.group_id" => $grp_child),"Rlthstgrp.host_id");
			foreach ($lim_hid as $out_hid){
				$se_hid = $out_hid['Rlthstgrp']['host_id'];
				$condition[] = "($table2.$column2 <> '".$value_child["$table1"]["$column1"]."' or $table2.host_id <> $se_hid) ";
			}
		}
		
		return $condition;
	}
	
	//20090310 sunhy start
	/*function add_info($table_name, $table_column, $table_value, $arr)//アラート内容を増加する
	{
		$arr[$table_name][$table_column] = $table_value;
		
		return $arr;
	}*/
	//20090310 sunhy end

}