<?php
class DirectoryComponent extends Object
{
	private $children;
	private $name;
	private $id;
	private $parent_id;
	
	/*
	function construct($name)
	{
		$this->name = $name;
		echo '<br> namename: ' . $this->name;
		$this->children = array();
	}
	*/
	
	function setName($name)
	{
		$this->name = $name;
	}
	
	function getName()
	{
		return $this->name;
	}
	
	function setId($id)
	{
		$this->id = $id;
	}
	
	function getParent_id()
	{
		return $this->parent_id;
	}
	
	function setParent_id($parent_id)
	{
		$this->parent_id = $parent_id;
	}
	
	function getId()
	{
		return $this->id;
	}
	
	function getChildren()
	{
		return $this->children;
	}
	
	function hasChildren()
	{
		return (count($this->children) != 0);
	}
	
	function isChildExist($childName)
	{
		foreach($this->children as $key => $value) 
		{
			if ($value->name == $childName)
			{
				return true;
			}
		}
		return false;
	}
	
	function getChild($childName)
	{
		for($i = 0; $i < count($this->children); $i++)
		{
			if ($this->children[$i]->name == $childName)
				return $this->children[$i];
		}
		return null;
	}
	
	function addChild($child)
	{
		$this->children[] = $child;
	}
}
?>