<?php
/*********************************************************************
*@filename mail_popup_controller.php
*@description MailPopupControllerComponent メールポップアップ 
*@note 
*@histories  rivision	    author		date		comment
*               2.0           sunhuiyan    	20090304   	add for JLN-001
*               2.0           sunhuiyan    	20090511   	add for YBR-32
*               2.0           sunhuiyan    	20090724   	add for JL-0035
********************************************************************/  
class MailPopupControllerComponent extends Object    
{
	var $components = array ('Lv');
	var $controller = true;
	
	function startup(&$controller)
	{
		$this->controller = &$controller;
	}
	
	function setMailPop($id, $group_id, $mail_notice, $mail_notice_time, $popup, $up_cast, $receive, $type, $class_name){
		
		$setMailPop = array(
			$class_name => Array(
				'id' => $id,
				'group_id' => $group_id,
				'mail_notice' => $mail_notice,
				'mail_notice_time' => $mail_notice_time,
				'popup' => $popup,
				'up_cast' => $up_cast,
				'receive' => $receive,
				'type' => $type,
			)					
		);  
		
		$this->controller->$class_name->save($setMailPop);
	}
	
	function getMailPop($class_name, $condition){
		return $this->controller->$class_name->find($condition);
	}
	
	//sunhy start 2009/05/11 added for YBR-32
	//function setAltMsg($type, $title, $detail_flg, $alt_id){
	function setAltMsg($type, $title, $detail_flg, $alt_id, $group_id){
	//sunhy end 2009/05/11 added for YBR-32
		$add_msg = array(
				'Altmsg' => array(
					'id' => $alt_id,
					'message_id' => $type,
					'message' =>$this->controller->Lv->spec_char_dbm($title),
					'detail_flg' =>$detail_flg==1?0:1,
					//sunhy start 2009/05/11 added for YBR-32
					'group_id'=>$group_id,
					//sunhy end 2009/05/11 added for YBR-32
					)
				   );
		empty($add_msg)?null:$this->controller->Altmsg->save($add_msg);
	}
	
	//sunhy start 2009/05/11 added for YBR-32
	//function getAltMsg($type){
	function getAltMsg($type, $group_id){
	//sunhy end 2009/05/11 added for YBR-32
		//sunhy start 2009/05/11 added for YBR-32
		//$msg = $this->controller->Altmsg->find("Altmsg.message_id = '".$type."'");	
		$msg = $this->controller->Altmsg->find(array("Altmsg.message_id" => $this->Lv->spec_char_dbm($type), "group_id" => $this->Lv->spec_char_dbm($group_id)));	
		//sunhy end 2009/05/11 added for YBR-32
		return $msg;
	}
	
	//sunhy start 2009/07/24 modify for JL-0035
	function delAltMsg($Message_id, $group_id, $isAdd = null){
		$this->controller->addModel("Grpauth");
		$altmsg_del = "message_id = '".$Message_id."' and group_id = ". $group_id;
		$child_list = $this->controller->Grpauth->getChildrenByParent($group_id);
		$group_del = array();
		foreach ($child_list as $key => $group_name){
			if($key != $group_id){
				$group_del[] = $key;
			}
		}
		if($group_id == 1){
			$this->controller->Altmsg->query("update altmsgs set message = '". __($Message_id,$return = true) ."', detail_flg = 1 where " . $altmsg_del);
			if($Message_id == "E0008"){
				$this->controller->Altmsg->query("delete from altmsgs where message_id = '".$Message_id."' and group_id != 1");
			}
		}
		else{
			if($isAdd == null){
				$this->controller->Altmsg->query("delete from altmsgs where " . $altmsg_del);
			}
			if($Message_id == "E0008"){
				$this->controller->Altmsg->query("delete from altmsgs where message_id = '".$Message_id."' and group_id  IN ( " . implode(',', $group_del) . " )");
			}
		}
	}
	
	function delAltTit($type, $group_id, $isAdd = null){
		$this->controller->addModel("Grpauth");
		$title_del = "type = ".$type." and group_id = ". $group_id;
		$child_list = $this->controller->Grpauth->getChildrenByParent($group_id);
		$group_del = array();
		foreach ($child_list as $key => $group_name){
			if($key != $group_id){
				$group_del[] = $key;
			}
		}
		if($group_id == 1){
			$this->controller->Title->query("update titles set title_flg = 0 where " . $title_del);
			if($type == 11){
				$this->controller->Title->query("delete from titles where type = ".$type." and group_id != 1");
			}
		}
		else{
			if($isAdd == null){
				$this->controller->Title->query("delete from titles where " . $title_del);
			}
			if($type == 11){
				$this->controller->Title->query("delete from titles where type = ".$type." and group_id  IN ( " . implode(',', $group_del) . " )");
			}
		}
	}
	//sunhy end 2009/07/24 modify for JL-0035
}