<?php
/*********************************************************************
*@filename 		jpgraph_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/16   modify for LV20R1-125
*            2.0        xinw        2009/01/14   modify for LV20R1-185
*            2.0        xushanning  2009/04/13   modify for LogvillageChinese
********************************************************************/
class JpgraphController extends AppController

{
    var $uses=array("Host","Optweb");

    function beforeFilter()
    {
    	
    }
    function index($devicetype,$time="")

    {

        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_line.php");
        //xinw start 20081216
        //modify for LV20R1-125
        include ("../jpgraph/jpgraph_date.php");
        //xinw end 20081216
        
//        if(isset)
        list($start,$end)=$this->getSessionDate();

        // Set the start time to be on the closest minute just before the "start" timestamp

        $adjstart=strtotime($start);
        if($start==$end|| (strlen($end)==0))
        {
            $adjend=strtotime($start) +3600*24;
            
        }else{
            $adjend=strtotime($end);
        }
        //echo date("Y-m-d H:i:s",$adjend);exit;
        // Create a data set in range (20,100) and X-positions
        // We also apply a simple low pass filter on the data to make it less
        // random and a little smoother
        $xdata = array();

        // Assume that the data points represents data that is sampled every 10s
        // when determing the end value on the scale. We also add some extra
        // length to end on an even label tick.


        function TimeCallback($aVal) {
            list($start,$end)=JpgraphController::getSessionDate();
            $start_date=explode(" ",$start);
            list($start_year,$start_month,$start_day)=explode('-',$start_date[0]);
            if(strlen($end)>0)
            {
                $end_date=explode(" ",$end);
                list($end_year,$end_month,$end_day)=explode('-',$end_date[0]);
                //echo $start."##".$end;
                if($start_year!=$end_year)
                {
                    return Date('y/m', $aVal);
                }
                if($start_month!=$end_month)
                {
                    return Date('m/d', $aVal);
                }
                if($start_day!=$end_day)
                {
                    //return Date('d H', $aVal);
                    if($end_day-$start_day<=10)
                    {
                        return Date('m/d H:i', $aVal);
                    }else{
                        return Date('m/d', $aVal);
                    }
                }
            }
            return Date('H:i', $aVal);
        }
        //xuwc 2007/06/01 14:38 end
        $datas=$this->Session->read('data'); 
//        echo "<pre>";
//        var_dump($datas['hdd']);exit;

        $graph = new Graph(800,175);  
//        $graph->img->SetMargin(100,600,100,40);
        //$graph->SetMargin(700,10,0,0);
       

        
//            $graph = new Graph(540,300);

//          //   Slightly larger than normal margins at the bottom to have room for
//           //  the x-axis labels
//            $graph->SetMargin(40,40,30,130);

        


        //xuwc 2007/06/01 14:35 begin
//        echo $adjstart."##".$adjend;
        if($devicetype==4||$devicetype==7)
        {
        	//xinw start 20081216
        	//modify for LV20R1-125
            //$graph->SetScale("intlin",0,100,$adjstart,$adjend);
            $graph->SetScale("datlin",0,100,$adjstart,$adjend);
            //xinw end 20081216
        }else{
        	//xinw start 20081216
        	//modify for LV20R1-125
            //$graph->SetScale("intlin",0,0,$adjstart,$adjend);
            $graph->SetScale("datlin",0,0,$adjstart,$adjend);
            //xinw end 20081216
        }
        
        //xuwc 2007/06/01 14:35 end
        $graph->xaxis->SetLabelFormatCallback('TimeCallback');
        
        
//        echo "<pre>";
//        var_dump($datas['hdd']);exit;
        $graph->SetFrame(false);

       if(count($datas)>0)
       {
            switch ($devicetype)
            {
                case  4:
                     empty($datas['cpu']) ? $data=array():$dataCpu=$datas['cpu'];
                     //xuwc 2007/09/08 begin
                     $data=$this->get_view_data($dataCpu);
                    //xuwc 2007/09/08 end
                     break;
                case  5:
                     empty($datas['memory']) ? $data=array():$dataMemory=$datas['memory'];
                     //xuwc 2007/09/08 begin
                     $data=$this->get_view_data($dataMemory);
                    //xuwc 2007/09/08 end
                     break;
                case  6:
                    empty($datas['network']) ? $data=array():$dataNetwork=$datas['network'];
                    //xuwc 2007/09/08 begin
                     $data=$this->get_view_data($dataNetwork);
                    //xuwc 2007/09/08 end
                     break;
                 case  2:
                     //HDD残








                    empty($datas['hdd']) ? $dataHdd=array():$dataHdd=$datas['hdd'];
                    //xuwc 2007/09/07 begin
                     $data=$this->get_view_data($dataHdd);
                    //xuwc 2007/09/07 end
                        
                     break;
                 case  7:
                    empty($datas['disk']) ? $data=array():$dataDisk=$datas['disk'];
                    //xuwc 2007/09/08 begin
                     $data=$this->get_view_data($dataDisk);
                    //xuwc 2007/09/08 end
                     break;
            }
        }else{
            $data=array();
        }
        
//        echo "<pre>";
//         var_dump($data);exit; 
        if(count($data)==0)
        {
            $ydata=array(0,0);
            $lineplot=new LinePlot($ydata);
            $graph->Add($lineplot);
        }else{
            
            for($i=0;$i<count($data);$i++)
            {
                $hosts[]=$data[$i]['hostname'];
                unset($data[$i]['hostname']);
            }
//            echo "<pre>";
//            var_dump($data);exit;       

            $maxdata=array();
//            echo "<pre>";
//            var_dump($data);exit;
            for($i=0;$i< count($data);$i++)
            { 
                
                $ydata=array();
                
                 for($j=0;$j< count($data[$i]);$j++)
                 {
                     //xuwc 2007/08/16 begin
                     $maxdata[]=$data[$i][$j]['usage'];
                     //xuwc 2007/08/16 end
                    $ydata[$i][]=$data[$i][$j]['usage'];
                    $time="";
                    $time=strtotime($data[$i][$j]['time']);
                    //xuwc 2007/08/23 begin
                    //$xdata[$i][]= $start + $time ;
                    $xdata[$i][]=$time ;
                    //xuwc 2007/08/23 end
                 }  
//                 echo '<pre>';
//                 var_dump($data);exit;
                 if(max($maxdata)>10000)
                 {
                     //xuwc 2007/08/12 begin
                     $graph->yaxis->SetLabelMargin(0);
                     if(max($maxdata)>1000000000)
                     {
                         $ydata=array();
                          for($j=0;$j< count($data[$i]);$j++)
                        {
                            $ydata[$i][]=round($data[$i][$j]['usage']/(1024*1024));
//                            echo $i."@@".$j."##";
                        }
                     }else{
                         $ydata=array();
//                         echo "<pre>";
//                         var_dump($data[$i]);exit;
                         for($j=0;$j< count($data[$i]);$j++)
                        {
                            $ydata[$i][]=round($data[$i][$j]['usage']/1024);
                        }
                     }
                    //xuwc 2007/08/12 end
                 }
//                echo "<pre>";
//                var_dump($ydata[$i]);exit;
                
                $lineplot[$i]=new LinePlot($ydata[$i],$xdata[$i]);
                //
//                $lineplot[$i]->posx=10;
//                $lineplot[$i]->posy=0.65;
                //
                // Add the plot to the graph
                $graph->Add($lineplot[$i]);
                
//                $lineplot[$i]->SetColor("blue");
                $lineplot[$i]->SetWeight(2);
                //xuwc 2007/08/15 begin
                $lineplot[$i]->SetLegend($hosts[$i]);
//                $lineplot2->SetLegend("Plot 2");
                //xuwc 2007/08/15 end
                //���ϒl�̐F�̐ݒ�
                //xuwc 2007/08/19 begin
                if($i==0)
                {
                    $lineplot[$i]->SetColor("pink");
                }
                if($i==1)
                {
                    $lineplot[$i]->SetColor("darkblue");
                }
                if($i==2)
                {
                    $lineplot[$i]->SetColor("aqua");
                }
                if($i==3)
                {
                    $lineplot[$i]->SetColor("lightblue");
                }
                if($i==4)
                {
                    $lineplot[$i]->SetColor("purple");
                }
                if($i==5)
                {
                    $lineplot[$i]->SetColor("blue");
                }
                if($i==6)
                {
                    $lineplot[$i]->SetColor("azure");
                }
                if($i==7)
                {
                    $lineplot[$i]->SetColor("yellow");
                }
                if($i==8)
                {
                    $lineplot[$i]->SetColor("gray");
                }
                if($i==9)
                {
                    $lineplot[$i]->SetColor("wheat");
                }
                
                //xuwc 2007/08/19 end
                if($i==count($data)-1)
                {
                    $lineplot[$i]->SetColor("orange");
                    $lineplot[$i]->SetWeight(2);
                }
                    
    //                $lineplot2->SetColor("orange");
    //                $lineplot2->SetWeight(2);
            }
        }
        //xuwc 閾値 begin
        if($devicetype==4)
        {
            if(!empty($datas['group']))
            {
    	        $datay=array($datas['group'],$datas['group']);
    	        $datax=array($adjstart,$adjend);
    	        $lineplots=new LinePlot($datay,$datax);
    	        
    	        $lineplots->SetColor("green");
    	        $lineplots->SetWeight(2);
    	                
    	        // Add the plot to the graph
    	        $graph->Add($lineplots);
            }
        }
        
	//xuwc 閾値 end
        $graph->img->SetMargin(80,100,20,40);

//        $graph->xaxis->title->Set("X-title");
//        $graph->yaxis->title->Set("CPU");
        
        $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->xaxis->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->legend->SetFont(FF_MINCHO,FS_NORMAL);
//        $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);

        
        $graph->yaxis->SetColor("red");
        $graph->yaxis->SetWeight(2);
        //xuwc 2007/08/12 begin
//        $graph->ygrid->show(false,false);
        //xuwc 2007/08/12 end
//        $graph->yaxis->scale->ticks->SupressFirst(100);
//        echo MAX($maxdata)."@@";exit;
        if($devicetype==4 || $devicetype==7)
        //if($devicetype==4 )
        {
            
            if(MAX($maxdata)>10000)
            {
                if(MAX($maxdata)>1000000000)
                {
                     $graph->title->Set("GB");
                     $graph->yaxis->SetLabelFormat('%3d%%');
                }else{
                    $graph->title->Set("MB");
                    $graph->yaxis->SetLabelFormat('%3d%%');
                }
            }else{
//                $graph->title->Set("パーセント");
                $graph->yaxis->SetLabelFormat('%3d%%');
            }
//            $graph->yaxis->SetLabelFormat('%3d%%');
//            $datax=array(0,6,18,24,30,36,42,48,54,60,66,72,78,84,90,100);
//            $graph->yaxis->SetTickLabels($datax);
        }else{
            //xuwc 2007/08/16 begin
            if(MAX($maxdata)>10000)
            {
                if(MAX($maxdata)>1000000000)
                {
                     $graph->title->Set("GB");
                }else{
                    $graph->title->Set("MB");
                }
            }else{
                $graph->title->Set("KB");
            }
//            echo "<pre>";
//            var_dump($data);exit;
            
            //xuwc 2007/08/16 end
        }
        $graph->SetShadow(); 
        $graph->legend->Pos(0,0.5,"right","center");
        //$graph->xaxis->SetLabelAngle(90);
        //xinw start 20081216
        //modify for LV20R1-125
        //$graph->xaxis->SetLabelAngle(15);
        $graph->xaxis->SetLabelAngle(30);
		//xinw end 20081216

        // Display the graph
        $graph->Stroke();

       

    }
    function getSessionDate()
    {
//        echo "<pre>";
//        var_dump($_SESSION['start_time']);exit;
        if(isset($_SESSION['start_time']))
        {
            $start=$_SESSION['start_time'];
//            $start=date("2007-05-31 00:00:00");
        }else{
            $start=date("Y-m-d 00:00:00");
//            $start=date("2007-05-31 00:00:00");
        }
         if(isset($_SESSION['end_time']))
        {
            $end=$_SESSION['end_time'];
        }else{
            $end="";
        }
        if(strlen($start)==0)
        {
            $start=date("Y-m-d 00:00:00");
        }
        $adjstart=strtotime($start);
         if(strlen($start)==0)
        {
            $end=date("Y-m-d 00:00:00");
        }
        return array($start,$end);
    }
    
    function group($key="",$devicetype="")

    {

        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_line.php");
        //xinw start 20081216
        //modify for LV20R1-125
        include ("../jpgraph/jpgraph_date.php");
        //xinw end 20081216
        
        $datas=$this->Session->read('group_data');
        
        $xdata = array();
//        echo "<pre>";
//        var_dump($datas);
        
        if(isset($key) && strlen($key)>0 && $key!='group')
        {
            $datas['host']=$this->get_group_host_data($datas['host']);
            for($i=0;$i<count($datas['host'][$key]);$i++)
            {
                $ydataTmp[]=$datas['host'][$key][$i]['usage'];
                $xdata[]=strtotime($datas['host'][$key][$i]['time']);
            }
            if(max($ydataTmp)>10000)
            {
                $maxflag=1;
                for($i=0;$i<count($ydataTmp);$i++)
                {
                    $ydata[]=round($ydataTmp[$i]/1024);
                }
            }else{
                $maxflag=0;
                $ydata=$ydataTmp;
            }
        }else{
            //**********************************************************************************************************
            //�O���[�v�S��
            
            $index=0;
            $groupData=array();
            foreach($datas['host'] as $key=>$value)
            {
                $groupData[$index]=$value;
                $groupData[$index]['hostname']=$key;
                $index++;
            }
            $datas['group']=$this->get_avg_view_data($groupData);
//            echo "<pre>";
//            var_dump($datas['group']);exit;
            if(count($datas['group'])>0)
            {
                if(max($datas['group']['usage'])>10000)
                {
                    $maxflag=1;
                    for($i=0;$i<count($datas['group']['usage']);$i++)
                    {
                        $ydata[]=round($datas['group']['usage'][$i]/1024);
                    }
                }else{
                    $maxflag=0;
                    $ydata=$datas['group']['usage'];
                }
            
                for($i=0;$i<count($datas['group']['time']);$i++)
                {
                    $xdata[]=strtotime($datas['group']['time'][$i]);
                }
            }else{
                $ydata=array(0,0);
                $xdata=array(0,0);
//                $lineplot=new LinePlot($ydata);
//                $graph->Add($lineplot);
            }
         }    
            
//       echo "<pre>";
//       var_dump($ydata);exit;
        list($start,$end)=$this->getSessionDate();
//        echo $start."@@".$end;exit;
        // Set the start time to be on the closest minute just before the "start" timestamp

        $adjstart=strtotime($start);
        if($start==$end|| (strlen($end)==0))
        {
            $adjend=strtotime($start) +3600*24;
        }else{
            $adjend=strtotime($end);
        }
        
        // Create a data set in range (20,100) and X-positions
        // We also apply a simple low pass filter on the data to make it less
        // random and a little smoother

        // Assume that the data points represents data that is sampled every 10s
        // when determing the end value on the scale. We also add some extra
        // length to end on an even label tick.


    function TimeCallback($aVal) {
            list($start,$end)=JpgraphController::getSessionDate();
            $start_date=explode(" ",$start);
            list($start_year,$start_month,$start_day)=explode('-',$start_date[0]);
            if(strlen($end)>0)
            {
                $end_date=explode(" ",$end);
                list($end_year,$end_month,$end_day)=explode('-',$end_date[0]);
                //echo $start."##".$end;
                if($start_year!=$end_year)
                {
                    return Date('y-m', $aVal);
                }
                if($start_month!=$end_month)
                {
                    return Date('m-d', $aVal);
                }
                if($start_day!=$end_day)
                {
                   //return Date('d H', $aVal);
                    return Date('m/d', $aVal);
                }
            }
            return Date('H:i', $aVal);
        }
        //xuwc 2007/06/01 14:38 end
//            $datas=$this->Session->read('data'); 

        $graph = new Graph(800,150,"auto");  
        //xuwc 2007/06/01 14:35 begin
        
//        echo date("Y-m-d",$adjstart)."##".date("Y-m-d",$adjend);exit;
        if($devicetype==4 || $devicetype==7)
        {
        	//xinw start 20081216
        	//modify for LV20R1-125
            //$graph->SetScale("intlin",0,100,$adjstart,$adjend);
            $graph->SetScale("datlin",0,100,$adjstart,$adjend);
            //xinw start 20081216
        }else{
        	//xinw start 20081216
        	//modify for LV20R1-125
            //$graph->SetScale("intlin",0,0,$adjstart,$adjend);
            $graph->SetScale("datlin",0,0,$adjstart,$adjend);
            //xinw start 20081216
        }
        
        //xuwc 2007/06/01 14:35 end
        $graph->xaxis->SetLabelFormatCallback('TimeCallback');
        $graph->SetFrame(false);
//        for($i=0;$i<count($xdata);$i++)
//        {
//            $xdata[$i]=date("Y-m-d",$xdata[$i]);
//        }
//        echo '<pre>';
//        var_dump($xdata);exit;
//        $ydata=array(12,13,14,44,55);
//        $xdata=array(1183420800,1183420800,1183420800,1183420800,1183420800);
        $lineplot=new LinePlot($ydata,$xdata);
        $graph->Add($lineplot);
        $graph->img->SetMargin(40,20,20,40);
        
        if(isset($key) && strlen($key)>0)
        {
            $lineplot->SetColor("blue");
        }else{
            $lineplot->SetColor("orange");
        }
//        $graph->title->Set("Timing a graph");
//        $graph->xaxis->title->Set("X-title");
//        $graph->yaxis->title->Set("CPU");
    
        $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->yaxis->title->SetFont(FF_MINCHO,FS_NORMAL);
        
//        $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
        //xuwc 2007/07/03 20:23 begin
         //if($devicetype==4 || $devicetype==7)
         if($devicetype==4 || $devicetype==7)
        {
            $graph->yaxis->SetLabelFormat('%3d%%');
//            $datax=array(0,6,18,24,30,36,42,48,54,60,66,72,78,84,90,100);
//            $graph->yaxis->SetTickLabels($datax);
        }else{
            //xuwc 2007/08/16 begin
            if($maxflag==1)
            {
                $graph->yaxis->SetLabelMargin(0);
                $graph->title->Set("MB");
            }else{
                $graph->title->Set("KB");
            }
//            echo "<pre>";
//            var_dump($data);exit;
            
            //xuwc 2007/08/16 end
        }
//        $datax=array(0,6,18,24,30,36,42,48,54,60,66,72,78,84,90,100);
//        $graph->yaxis->SetTickLabels($datax);
        //xuwc 2007/07/03 20:23 end
        //xinw start 20081216
        //modify for LV20R1-125
        $graph->xaxis->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->xaxis->SetLabelAngle(30);
		//xinw end 20081216
        $graph->yaxis->SetColor("red");
        $graph->yaxis->SetWeight(2);
        $graph->SetShadow(); 

        // Display the graph
        $graph->Stroke();
            
            //**********************************************************************************************************
        


       

    }
     function pie($type="",$time="")
    {
         include ("../jpgraph/jpgraph.php");
         include ("../jpgraph/jpgraph_pie.php");
         //  data
        $datas=$this->Session->read('data'); 
//        echo "<pre>";
//        var_dump($datas);exit;

        if($type==1)
        {
            $data=array($datas['totals']['use'],$datas['totals']['nouse']);
            $legends=array( __('jpgraph_use',$return = true),__('jpgraph_nouse',$return = true));
        }else{
    
            $data = $datas['usage'];
            $legends=$datas['name'];

        }
//        for($i=0;$i<count($data);$i++)
//        {
//            $data[$i]=(int)$data[$i];
//        }
//                echo "<pre>";
//        var_dump($data);exit;
//       
        // Create the Pie Graph. 
        if(count($data)==2)
        {
        	//xinw start 20090114
        	//modify for LV20R1-185
            //$graph = new PieGraph(400,350,"auto");
            $graph = new PieGraph(500,550,"auto");
            //xinw end 20090114
            $graph->title->Set(__('pc_all_log',$return = true));
            $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
            
        }else{
        	//xinw start 20090114
        	//modify for LV20R1-185
            //$graph = new PieGraph(600,550,"auto");
            $graph = new PieGraph(500,550,"auto");
            //xinw end 20090114
            $graph->title->Set(__('use_prc',$return = true));
            $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
            
        }
        if($type==1)
        {
            $colors=array('gray','pink');
        }else{
            $colors=array('brown','green','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat');
        }
        
        
        //$graph->SetMargin(-10,10,10,10);   
//        $graph->value->SetMargin(50);
        
        
        
        $graph->SetShadow();
        $graph->SetFrame(false);
        
        // Set A title for the plot
//        $graph->title->Set("Example 2 Pie plot");
//        $graph->title->SetFont(FF_MINCHO,FF_MINCHO);
//        $graph->title->SetFont(FF_PMINCHO, FS_NORMAL);
        $graph->legend->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->legend->Pos(0,0,"right","auto");
//        $graph->legend->SetMargin(10);
//        echo '<pre>';
 
//         var_dump($legends);
        // Create
        $p1 = new PiePlot($data);
        $p1->SetLegends($legends);
        //xinw start 20090114
        //modify for LV20R1-185
/*        if(count($data)!=2)
        {*/
        //xinw end 20090114	
            $p1->SetCenter(0.4);
            $p1->SetSize(0.2);
        //xinw start 20090114
        //modify for LV20R1-185
        //}
        //xinw end 20090114
        //xuwc 2007/09/03 begin
//        $p1->posx=0.32;
//        $p1->posy=0.65;
        //xuwc 2007/09/03 end
        $p1->SetSliceColors($colors);
        $graph->Add($p1);
        $graph->Stroke();

    }

    /**
     * bigdetail画面のグラフの初期化.
     * jinl
     * @param unknown_type $type
     * @param unknown_type $time
     */
    function piebigdetail($type="",$time="",$fenbianlvwidth,$fenbianlvheight)
    {
        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_pienoline.php");
                 $asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'));
        $criteria  = $_SESSION['session_criteria'];
        $criteria[]='Optweb.catalog1 > 100 and 2500 > Optweb.catalog1';
        for ($i = 2; $i < 25; $i++){
        	   $criteria[] = 'Optweb.catalog1 != '. $i*100;
        }
        $temp = $this->Optweb->findByAsso($criteria,array('Optweb.catalog1'),null,null,null,$asso);
        if(count($temp) == 0){
        	    $data = array(1);
        	    $legends = array('nodata_jinl');
        	    $colors=array('sandybrown');
        }else{
        	    $data1 = array();
        	    $legends1= array();
        	    $data = array();
        	    $legends = array();
        	    $temps=array();
             foreach ($temp as $subdata){
		$index = $this->getflagnumb($subdata['Optweb']['catalog1'])-1;
		$data1[$index] = ++$data1[$index];
		if(!isset($legends1[$index])){
		      $legends1[$index] = __('bunnruyi'.($index+1)*100,$return = true);
		      $temps[] = $index;
		}
	     }
	     sort($temps);
	     foreach ($temps as $subtemp){
	     	$data[] = $data1[$subtemp];
	     	$legends[] = $legends1[$subtemp];
	     }
	     $tempdata = $data;
	     $data = $this->sortbycatalogcount($tempdata,$legends,$_SESSION['catagory_flag'],'data');
	     $legends = $this->sortbycatalogcount($tempdata,$legends,$_SESSION['catagory_flag'],'legends');
	     $colors=array('gray','pink','brown','mediumslateblue','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat','red','indianred','black','mediumspringgreen','darkslategray','chartreuse','peru','khaki','magenta','lightgreen','sandybrown');
        }
        if(count($data) == 1){
        	    $flag = "imagefilledarc";
        }
        $graph = new PieGraph(426,356,"auto");
		//xushanning start 2009/04/13 modify for LogvillageChinese
        //$graph->title->Set("カテゴリ(大分類)別ヒット数");
		$graph->title->Set(__('kindbig',$retrun=true));
        //xushanning end 2009/04/13 modify for LogvillageChinese
        $graph->title->SetFont(FF_MINCHO,FS_NORMAL,8);
        $graph->SetShadow();
        $graph->SetFrame(false);
        $graph->legend->SetFont(FF_MINCHO,FS_NORMAL,7.4);
        $graph->legend->Pos(0,0.04,"right","auto");
        $p1 = new PiePlot($data);
        $p1->SetLegends($legends);
        $p1->SetCenter(0.35);
        $p1->SetSize(0.36);
        $p1->SetSliceColors($colors);
        $graph->Add($p1);
        $graph->Stroke();
    }
    
    /**
     * Enter description here...
     * jinl
     * @param unknown_type $inputdata
     * @return unknown
     */
    function getflagnumb($inputdata){
    	$outputdata = 0;
    	if($inputdata <1000){
    	    $outputdata = substr((string)$inputdata,0,1);
    	}else{
    	    $outputdata = substr((string)$inputdata,0,2);
    	}
    	return intval($outputdata);
    }
    
    function sortbycatalogcount($inputdata,$legends,$catagory_flag,$flag){
		$outputdata = array();
		$outputlegends = array();
		$autoarray = $inputdata;
		$autolegends = $legends;
		for($k = 0; $k<$catagory_flag;$k++){
		    $selectedindex = 0;
		    $maxdata = $autoarray[0];	   
		    for($i = 0; $i<count($autoarray)-1;$i++){
		        if($autoarray[$i+1] > $maxdata){
		       	   $maxdata = $autoarray[$i+1];
		       	   $selectedindex = $i+1;
		        }
		    }
		    if($maxdata == 0){
		    	break;
		    }else{
			    $outputdata[] = $autoarray[$selectedindex];
			    $outputlegends[] = $autolegends[$selectedindex];
			    array_splice($autoarray,$selectedindex,1);
			    array_splice($autolegends,$selectedindex,1);
		    }
		}
		if($flag == 'data'){
			return $outputdata;
		}else{
			return $outputlegends;
		}
	}
    
    /**
     * smalldetail画面のグラフの初期化.
     * jinl
     * @param unknown_type $type
     * @param unknown_type $time
     * @param unknown_type $minid
     * @param unknown_type $maxid
     * @param unknown_type $dayibunnruyiname　　対応する大分類の名前.
     */
    function piesmalldetail($type="",$time="",$minid,$maxid,$dayibunnruyiname)
    {
         include ("../jpgraph/jpgraph.php");
         include ("../jpgraph/jpgraph_pienoline.php");
         $asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'));
	$criteria  = $_SESSION['session_criteria'];
	$criteria[]= 'Optweb.catalog1 > '.$minid.' and '.$maxid.' > Optweb.catalog1';
	$temp = $this->Optweb->findByAsso($criteria,array('Optweb.catalog1'),null,null,null,$asso);
         $data = array();
         $legends= array();
         if(count($temp) == 0){
              $data = array(1);
              $legends= array('No data!');
              $colors = array('sandybrown');
         }else{
		$buruyicount = $maxid - $minid -1;
		foreach ($temp as $subdata){
			$flag = 0;
			while($buruyicount - $flag > 0){
				if($subdata['Optweb']['catalog1'] == $minid+1+$flag){
					if(isset($data[$flag])){
						$data[$flag] = ++$data[$flag];
					}else{
						$data[$flag] = 1;
						$legends[$flag] = __('bunnruyi'.$subdata['Optweb']['catalog1'],$return = true);
					}
				}
				$flag++;
			}
		}
		$tempdata = array();
		$templegends = array();
		foreach ($data as $subdata){
			$tempdata[] = $subdata;
		}
		foreach ($legends as $sublegends){
			$templegends[] = $sublegends;
		}
	         $data = $this->sortbycatalogcount($tempdata,$templegends,count($tempdata),'data');
	         $legends = $this->sortbycatalogcount($tempdata,$templegends,count($tempdata),'legends');
		$colors=array('gray','pink','brown','mediumslateblue','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat','red','indianred','black','mediumspringgreen','darkslategray','chartreuse','peru','khaki','magenta','lightgreen','sandybrown');
         }
        if(count($data) == 1){
        	    $flag = "imagearc";
        }else{
        	    $flag = "imagefilledarc";
        }
        $graph = new PieGraph(400,320,"auto");
		//xushanning start 2009/04/13 modify for LogvillageChinese
        //$graph->title->Set($dayibunnruyiname."の小分類別ヒット数");
		$graph->title->Set($dayibunnruyiname.__('kindsmall',$retrun=true));
        //xushanning end 2009/04/13 modify for LogvillageChinese
        $graph->title->SetFont(FF_PGOTHIC,FS_NORMAL,9);
        $graph->SetShadow();
        $graph->SetFrame(false);

        $graph->legend->SetFont(FF_MINCHO,FS_NORMAL,7.4);
        $graph->legend->Pos(0,0.2,"right","auto");
        $p1 = new PiePlot($data);
        $p1->SetLegends($legends);
        $p1->SetCenter(0.35,0.45);

        $p1->SetSliceColors($colors);
        $graph->Add($p1);
        $graph->Stroke();

    }
    
    function bar($time="")
    {
        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_bar.php");
        
        setlocale (LC_ALL, 'et_EE.ISO-8859-1');
        $datas=$this->Session->read('data'); 
//        echo $hostid;
//        echo '<pre>';
//        var_dump($datas);
        $data=$datas['bar_data'];
        $hosts=$datas['hostname'];
//        $index=0;
//       foreach($data as $key=>$value)
//        {
//            
//            for($i=0;$i<count($value)-1;$i++)
//            {
//                $array[$index][$i]=$value[$i];
//            }
//            $index++;
//        }
//        foreach($array as $key=>$value)
//        {
//            foreach($value as $k=>$v)
//            {
//                $arrays[$key][$k]=$v;
//            }
//        }
//        echo "<pre>";
//        var_dump($data);exit;
        //$colors=array('gray','pink','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat');
        $colors=array('gray','brown','green','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat');
        for($i=0;$i<count($data);$i++)
        {
            $color[]=$colors[$i];
        }
        
        $color=array_reverse($color);
//        echo "<pre>";
//        var_dump($color);exit;
        $graph = new Graph(800,280,"auto");    
        $graph->SetScale("textlin");
        // No frame around the image
        $graph->SetFrame(false);
        $graph->title->Set(__('pc_use_prc',$return = true));
        $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
        
        // Rotate graph 90 degrees and set margin
        $graph->Set90AndMargin();
//        echo "<pre>";
//        var_dump($hosts);exit;
        foreach($data as $key=>$value)
        {
            $index=0;
            for($i=0;$i<count($value);$i++)
            {
                $datay[$key][]=$value[$i];
                
//                echo "<pre>";
//                var_dump($datay);exit;
                
            }
            $bplot[$key] = new BarPlot($datay[$key]);
            $bplot[$key]->SetFillColor($color[$key]);
            $array[]=$bplot[$key];
            
            $index++;
        }
        
        // Create the grouped bar plot
        $gbplot = new AccBarPlot($array);
        
        // ...and add it to the graPH
        $graph->Add($gbplot);
        $graph->xaxis->SetTickLabels($hosts);
        $graph->xaxis->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->yaxis->SetLabelFormat('%3d%%');
//        $graph->title->Set("Accumulated bar plots");
 //       $graph->xaxis->title->Set("X-title");
//        $graph->yaxis->title->Set("Y-title");
       
//        $graph->title->SetFont(FF_FONT1,FS_BOLD);
//        $graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
//        $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
        
        // Display the graph
        $graph->Stroke();
        

    }
    function test()
    {
        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_line.php");
        
        $ydata = array(11,3,8,12,5,1,9,13,5,7);
        $y2data = array(354,200,265,99,111,91,198,225,293,251);
        
        // Create the graph and specify the scale for both Y-axis
        $graph = new Graph(400,200,"auto");    
        $graph->SetScale("textlin");
        $graph->SetY2Scale("lin");
        $graph->SetShadow();
        
        // Adjust the margin
        $graph->img->SetMargin(40,100,20,40);
        
        // Create the two linear plot
        $lineplot=new LinePlot($ydata);
        $lineplot2=new LinePlot($y2data);
        
        // Add the plot to the graph
        $graph->Add($lineplot);
        $graph->AddY2($lineplot2);
        $lineplot2->SetColor("orange");
        $lineplot2->SetWeight(2);
        
        // Adjust the axis color
        $graph->y2axis->SetColor("orange");
        $graph->yaxis->SetColor("blue");
        
        $graph->title->Set("Example 6");
        $graph->xaxis->title->Set("X-title");
        $graph->yaxis->title->Set("Y-title");
        
        $graph->title->SetFont(FF_FONT1,FS_BOLD);
        $graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
        $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
        
        // Set the colors for the plots 
        $lineplot->SetColor("blue");
        $lineplot->SetWeight(2);
        $lineplot2->SetColor("orange");
        $lineplot2->SetWeight(2);
        
        // Set the legends for the plots
        $lineplot->SetLegend("Plot 1");
        $lineplot2->SetLegend("Plot 2");
        
        // Adjust the legend position
        $graph->legend->Pos(0.05,0.5,"right","center");
        
        // Display the graph
        $graph->Stroke();

    }
    function get_view_data($dataHdd)
    {
        $k=0;
        for($i=0;$i<count($dataHdd);$i++)
        {
        //                        $newarray[$i]=array();
        //                        if(count($dataHdd[$i])>$k)
        //                        {
        //                            $kvalue=$i;
        //                            $k = count($dataHdd[$i]);
        //                        }
            for($j=0;$j<count($dataHdd[$i])-1;$j++)
            {
                $timekey=substr($dataHdd[$i][$j]['time'],0,strlen($dataHdd[$i][$j]['time'])-3);
                $newarray[$i][$timekey]=$dataHdd[$i][$j]['usage'];
                $avg_array[$timekey]="";
                
            }
            $newarray[$i]['hostname']=$dataHdd[$i]['hostname'];
            
         }
         
        //                     echo "<pre>";
        //                     var_dump($avgData);exit;
         for($i=0;$i<count($newarray);$i++)
         {
             $index=0;
             foreach($newarray[$i] as $key=>$value)
             {
                 
                 if($key!="hostname")
                 {
                     $data[$i][$index]['usage']=$value;
                     $data[$i][$index]['time']=$key;
                 }else{
                     $data[$i][$key]=$value;
                 }
                 $index++;
             }
         }
         ksort ($avg_array);
//                            echo "<pre>";
//                            var_dump($data);exit;
         
         //平均値 begin
         $avg_index=0;
         $hostUsage=0;
         $usageHistory0=-1;
         $usageHistory1=-1;
         $usageHistory2=-1;
         $usageHistory3=-1;
         $usageHistory4=-1;
         $usageHistory5=-1;
         $usageHistory6=-1;
         $usageHistory7=-1;
         $usageHistory8=-1;
         $usageHistory9=-1;
         foreach($avg_array as $key => $value)
         {
            
             $hostcount=0;
             $dataAvg=0;
             $hostUsage=0;
            for($i=0;$i<count($data);$i++)
            {
                $timeType=0;
                for($j=0;$j<count($data[$i])-1;$j++)
                {
                    if($key==$data[$i][$j]['time'])
                    {
                        $timeType=$data[$i][$j]['usage'];
        //                                    $hostUsage=$data[$i][$j]['usage'];
                        $currusageUsage=$data[$i][$j]['usage'];
                            //$currusageHistory=$data[$i][$j]['usage'];
        //                                        echo $i."!!!!!!!!!";
                        if($i==0)
                        {
                            $usageHistory0=$data[$i][$j]['usage'];
                        }
                        if($i==1)
                        {
                            $usageHistory1=$data[$i][$j]['usage'];
                        }
                        if($i==2)
                        {
                            $usageHistory2=$data[$i][$j]['usage'];
        //                                       echo $usageHistory2."%%";
                        }
                        if($i==3)
                        {
                            $usageHistory3=$data[$i][$j]['usage'];
                        }
                        if($i==4)
                        {
                            $usageHistory4=$data[$i][$j]['usage'];
                        }
                        if($i==5)
                        {
                            $usageHistory5=$data[$i][$j]['usage'];
                        }
                        if($i==6)
                        {
                            $usageHistory6=$data[$i][$j]['usage'];
                        }
                        if($i==7)
                        {
                            $usageHistory7=$data[$i][$j]['usage'];
                        }
                        if($i==8)
                        {
                            $usageHistory8=$data[$i][$j]['usage'];
                        }
                        if($i==9)
                        {
                            $usageHistory9=$data[$i][$j]['usage'];
                        }
                    }
                }
                
                if($timeType==0)
                {
                    
                    if($i==0)
                    {
                        if($usageHistory0==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory0;
                        }
                    }
                    if($i==1)
                    {
                        //echo $usageHistory1."@@".$i."##<br>";exit;
                        if($usageHistory1==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory1;
                            
                        }
                    }
                    if($i==2)
                    {
        //                                    echo $usageHistory2."**";
                        if($usageHistory2==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            
                            $hostUsage=$usageHistory2;
                        }
                    }
                    if($i==3)
                    {
                        if($usageHistory3==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory3;
                        }
                    }
                    if($i==4)
                    {
                        if($usageHistory4==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory4;
                        }
                    }
                    if($i==5)
                    {
                        if($usageHistory5==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory5;
                        }
                    }
                    if($i==6)
                    {
                        if($usageHistory6==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory6;
                        }
                    }
                    if($i==7)
                    {
                        if($usageHistory7==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory7;
                        }
                    }
                    if($i==8)
                    {
                        if($usageHistory8==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory8;
                        }
                    }
                    if($i==9)
                    {
                        if($usageHistory9==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory9;
                        }
                    }
                    
        
                }else{
//                                        echo $currusageUsage."***********";
                    $hostUsage=$currusageUsage;
                                       
                }
//                 echo $hostUsage."@@<br>";
                $dataAvg=$hostUsage+$dataAvg;
            }
            
 //                               echo $dataAvg."##".(count($dataHdd)-$hostcount)."@@<br>";exit;
            $avgData[$avg_index]['usage']=$dataAvg/((count($dataHdd)-$hostcount)==0?1:count($dataHdd)-$hostcount);
            //$avgData[$avg_index]['usage']=$dataAvg/4;
            $avgData[$avg_index]['time']=$key;
			//xushanning start 2009/04/13 modify for LogvillageChinese
            //$avgData['hostname']="平均(".count($data)."台)";
			$avgData['hostname']=__('avgbrackets',$retrun=true).count($data).__('bracketsdesk',$retrun=true);
            //xushanning end 2009/04/13 modify for LogvillageChinese
            $avg_index++;
         }
//         echo "<pre>";
//         var_dump($avgData);exit;
         array_push($data,$avgData);
         //平均値 end
         return $data;
    }
    function get_group_host_data($dataHdd)
    {
        $k=0;
        foreach($dataHdd as $key => $value)
        {
        //                        $newarray[$i]=array();
        //                        if(count($dataHdd[$i])>$k)
        //                        {
        //                            $kvalue=$i;
        //                            $k = count($dataHdd[$i]);
        //                        }
            for($j=0;$j<count($dataHdd[$key]);$j++)
            {
                $timekey=substr($dataHdd[$key][$j]['time'],0,strlen($dataHdd[$key][$j]['time'])-3);
                $newarray[$key][$timekey]=$dataHdd[$key][$j]['usage'];
                $avg_array[$timekey]="";
                
            }
//            $newarray[$i]['hostname']=$dataHdd[$i]['hostname'];
            
         }
         
//         echo "<pre>";
//         var_dump($newarray);exit;
         foreach($newarray as $k => $v)
         {
             $index=0;
             foreach($newarray[$k] as $key=>$value)
             {
                 $data[$k][$index]['usage']=$value;
                 $data[$k][$index]['time']=$key;
                 $index++;
             }
         }
         
          return $data;
    }
    function get_group_data($dataHdd)
    {
        $k=0;
//        foreach($dataHdd as $key => $value)
//        {
        //                        $newarray[$i]=array();
        //                        if(count($dataHdd[$i])>$k)
        //                        {
        //                            $kvalue=$i;
        //                            $k = count($dataHdd[$i]);
        //                        }
//        echo "<pre>";
//        var_dump($dataHdd);exit;
            for($j=0;$j<count($dataHdd['time']);$j++)
            {
                $timekey=substr($dataHdd['time'][$j],0,strlen($dataHdd['time'][$j])-3);
                $newarray[$timekey]=$dataHdd['usage'][$j];
                $avg_array[$timekey]="";
                
            }
//            $newarray[$i]['hostname']=$dataHdd[$i]['hostname'];
            
 //        }
         
//         echo "<pre>";
//         var_dump($newarray);exit;
         foreach($newarray as $key => $value)
         {
             $data['usage'][]=$value;
             $data['time'][]=$key;
         }
//         echo "<pre>";
//         var_dump($data);exit;
          return $data;
    }
    function get_avg_view_data($dataHdd)
    {
        
        $k=0;
        for($i=0;$i<count($dataHdd);$i++)
        {
        //                        $newarray[$i]=array();
        //                        if(count($dataHdd[$i])>$k)
        //                        {
        //                            $kvalue=$i;
        //                            $k = count($dataHdd[$i]);
        //                        }
            for($j=0;$j<count($dataHdd[$i])-1;$j++)
            {
                $timekey=substr($dataHdd[$i][$j]['time'],0,strlen($dataHdd[$i][$j]['time'])-3);
                $newarray[$i][$timekey]=$dataHdd[$i][$j]['usage'];
                $avg_array[$timekey]="";
                
            }
            $newarray[$i]['hostname']=$dataHdd[$i]['hostname'];
            
         }
//         echo "<pre>";
//        var_dump($newarray);exit;
        //                     echo "<pre>";
        //                     var_dump($avgData);exit;
         for($i=0;$i<count($newarray);$i++)
         {
             $index=0;
             foreach($newarray[$i] as $key=>$value)
             {
                 
                 if($key!="hostname")
                 {
                     $data[$i][$index]['usage']=$value;
                     $data[$i][$index]['time']=$key;
                 }else{
                     $data[$i][$key]=$value;
                 }
                 $index++;
             }
         }
         ksort ($avg_array);
//                            echo "<pre>";
//                            var_dump($data);exit;
         
         //平均値 begin
         $avg_index=0;
         $hostUsage=0;
         $usageHistory0=-1;
         $usageHistory1=-1;
         $usageHistory2=-1;
         $usageHistory3=-1;
         $usageHistory4=-1;
         $usageHistory5=-1;
         $usageHistory6=-1;
         $usageHistory7=-1;
         $usageHistory8=-1;
         $usageHistory9=-1;
         foreach($avg_array as $key => $value)
         {
            
             $hostcount=0;
             $dataAvg=0;
             $hostUsage=0;
            for($i=0;$i<count($data);$i++)
            {
                $timeType=0;
                for($j=0;$j<count($data[$i])-1;$j++)
                {
                    if($key==$data[$i][$j]['time'])
                    {
                        $timeType=$data[$i][$j]['usage'];
        //                                    $hostUsage=$data[$i][$j]['usage'];
                        $currusageUsage=$data[$i][$j]['usage'];
                            //$currusageHistory=$data[$i][$j]['usage'];
        //                                        echo $i."!!!!!!!!!";
                        if($i==0)
                        {
                            $usageHistory0=$data[$i][$j]['usage'];
                        }
                        if($i==1)
                        {
                            $usageHistory1=$data[$i][$j]['usage'];
                        }
                        if($i==2)
                        {
                            $usageHistory2=$data[$i][$j]['usage'];
        //                                       echo $usageHistory2."%%";
                        }
                        if($i==3)
                        {
                            $usageHistory3=$data[$i][$j]['usage'];
                        }
                        //echo "&&&&&&&&&&&&";var_dump($data[$i][$j]['usage']);echo "&&&&&&&&&&&&";
                        if($i==4 )
                        {
                            
                            $usageHistory4=$data[$i][$j]['usage'];
                        }
                        if($i==5)
                        {
                            $usageHistory5=$data[$i][$j]['usage'];
                        }
                        if($i==6)
                        {
                            $usageHistory6=$data[$i][$j]['usage'];
                        }
                        if($i==7)
                        {
                            $usageHistory7=$data[$i][$j]['usage'];
                        }
                        if($i==8)
                        {
                            $usageHistory8=$data[$i][$j]['usage'];
                        }
                        if($i==9)
                        {
                            $usageHistory9=$data[$i][$j]['usage'];
                        }
                    }
                }
                
                if($timeType==0)
                {
                    
                    if($i==0)
                    {
                        if($usageHistory0==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory0;
                        }
                    }
                    if($i==1)
                    {
                        //echo $usageHistory1."@@".$i."##<br>";exit;
                        if($usageHistory1==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory1;
                            
                        }
                    }
                    if($i==2)
                    {
        //                                    echo $usageHistory2."**";
                        if($usageHistory2==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            
                            $hostUsage=$usageHistory2;
                        }
                    }
                    if($i==3)
                    {
                        if($usageHistory3==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory3;
                        }
                    }
                    if($i==4)
                    {
                        //echo $usageHistory4."***********************";
                        if($usageHistory4==-1)
                        {
                            
                            $hostcount++;
//                            echo $hostcount."************";
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory4;
                        }
                    }
                    if($i==5)
                    {
                        
                        if($usageHistory5==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory5;
                        }
                    }
                    if($i==6)
                    {
                        if($usageHistory6==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory6;
                        }
                    }
                    if($i==7)
                    {
                        if($usageHistory7==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory7;
                        }
                    }
                    if($i==8)
                    {
                        if($usageHistory8==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory8;
                        }
                    }
                    if($i==9)
                    {
                        if($usageHistory9==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory9;
                        }
                    }
                    
        
                }else{
//                                        echo $currusageUsage."***********";
                    $hostUsage=$currusageUsage;
                                       
                }
//                 echo $hostUsage."@@<br>";
                $dataAvg=$hostUsage+$dataAvg;
            }
//            echo "<pre>";
//            var_dump($hostcount);
//            echo $dataAvg."##".(count($dataHdd)-$hostcount)."@@<br>";
            $avgData['usage'][]=$dataAvg/((count($dataHdd)-$hostcount)==0?1:count($dataHdd)-$hostcount);
            //$avgData[$avg_index]['usage']=$dataAvg/4;
            $avgData['time'][]=$key;
            $avg_index++;
         }
//         echo "<pre>";
//         var_dump($avgData);exit;
//         array_push($data,$avgData);
         //平均値 end
         return $avgData;
    }

}

?>