<?php
/*********************************************************************
*@filename 		jpgraphpc_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        yaozl	   2009/08/26	add for JL-0039
********************************************************************/
// yaozl start 2009/08/26 add for JL-0039
class JpgraphpcController extends Controller
{    
	var $uses=array();
    function index($devicetype,$time="")
    {
        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_line.php");
        include ("../jpgraph/jpgraph_date.php");

        list($start,$end)=$this->getSessionDate();

        $adjstart=strtotime($start);
        if($start==$end|| (strlen($end)==0))
        {
            $adjend=strtotime($start) +3600*24;
            
        }else{
            $adjend=strtotime($end);
        }

        $xdata = array();

        function TimeCallback($aVal) {
            list($start,$end)=JpgraphpcController::getSessionDate();
            $start_date=explode(" ",$start);
            list($start_year,$start_month,$start_day)=explode('-',$start_date[0]);
            if(strlen($end)>0)
            {
                $end_date=explode(" ",$end);
                list($end_year,$end_month,$end_day)=explode('-',$end_date[0]);
                if($start_year!=$end_year)
                {
                    return Date('y/m', $aVal);
                }
                if($start_month!=$end_month)
                {
                    return Date('m/d', $aVal);
                }
                if($start_day!=$end_day)
                {
                    if($end_day-$start_day<=10)
                    {
                        return Date('m/d H:i', $aVal);
                    }else{
                        return Date('m/d', $aVal);
                    }
                }
            }
            return Date('H:i', $aVal);
        }
        $datas=$this->Session->read('data'); 


        $graph = new Graph(810,190);  

        if($devicetype==4||$devicetype==7)
        {
            $graph->SetScale("datlin",0,100,$adjstart,$adjend);
        }else{
            $graph->SetScale("datlin",0,0,$adjstart,$adjend);
        }

        $graph->xaxis->SetLabelFormatCallback('TimeCallback');
        

        $graph->SetFrame(false);

       if(count($datas)>0)
       {
            switch ($devicetype)
            {
                case  4:
                     empty($datas['cpu']) ? $data=array():$dataCpu=$datas['cpu'];
                     $data=$this->get_view_data($dataCpu);
                     break;
                case  5:
                     empty($datas['memory']) ? $data=array():$dataMemory=$datas['memory'];
                     $data=$this->get_view_data($dataMemory);
                     break;
                case  6:
                    empty($datas['network']) ? $data=array():$dataNetwork=$datas['network'];
                     $data=$this->get_view_data($dataNetwork);
                     break;
                 case  2:
                    empty($datas['hdd']) ? $dataHdd=array():$dataHdd=$datas['hdd'];
                     $data=$this->get_view_data($dataHdd);
                        
                     break;
                 case  7:
                    empty($datas['disk']) ? $data=array():$dataDisk=$datas['disk'];
                     $data=$this->get_view_data($dataDisk);
                     break;
            }
        }else{
            $data=array();
        }
        

        if(count($data)==0)
        {
            $ydata=array(0,0);
            $lineplot=new LinePlot($ydata);
            $graph->Add($lineplot);
        }else{
            
            for($i=0;$i<count($data);$i++)
            {
                $hosts[]=$data[$i]['hostname'];
                unset($data[$i]['hostname']);
            }

            $maxdata=array();
            for($i=0;$i< count($data);$i++)
            { 
                
                $ydata=array();
                
                 for($j=0;$j< count($data[$i]);$j++)
                 {
					if(is_numeric($data[$i][$j]['usage'])){
                    $maxdata[]=$data[$i][$j]['usage'];
					}
                    $ydata[$i][]=$data[$i][$j]['usage'];
                    $time="";
                    $time=strtotime($data[$i][$j]['time']);
                    $xdata[$i][]=$time ;

                 }  
                 if(max($maxdata)>10000)
                 {
                     $graph->yaxis->SetLabelMargin(0);
                     if(max($maxdata)>1000000000)
                     {
                         $ydata=array();
                          for($j=0;$j< count($data[$i]);$j++)
                        {
						if(is_numeric($data[$i][$j]['usage']))
                            $ydata[$i][]=round($data[$i][$j]['usage']/(1024*1024));
							else
							$ydata[$i][]=$data[$i][$j]['usage'];
                        }
                     }else{
                         $ydata=array();
                         for($j=0;$j< count($data[$i]);$j++)
                        {
						if(is_numeric($data[$i][$j]['usage']))
                            $ydata[$i][]=round($data[$i][$j]['usage']/1024);
							else
							$ydata[$i][]=$data[$i][$j]['usage'];
                        }
                     }
                 }
                
                $lineplot[$i]=new LinePlot($ydata[$i],$xdata[$i]);
				
				$color = "orange";
				if($i==count($data)-1)
                {
					$color = "orange";
                }else{
					$color = $this->getColor($i);
				}
				$lineplot[$i]->SetColor($color);
			//$lineplot[$i]->mark->SetType(MARK_FILLEDCIRCLE);
			//$lineplot[$i]->mark->SetFillColor("white");
			//$lineplot[$i]->mark->SetWidth(2);

                $graph->Add($lineplot[$i]);

                $lineplot[$i]->SetWeight(2);

                $lineplot[$i]->SetLegend($hosts[$i]);
                

            }
        }

        if($devicetype==4)
        {
            if(!empty($datas['group']))
            {
    	        $datay=array($datas['group'],$datas['group']);
    	        $datax=array($adjstart,$adjend);
    	        $lineplots=new LinePlot($datay,$datax);
    	        
    	        $lineplots->SetColor("green");
    	        $lineplots->SetWeight(2);
    	                
    	        $graph->Add($lineplots);
            }
        }
        
        $graph->img->SetMargin(60,140,20,50);

        $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->xaxis->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->legend->SetFont(FF_MINCHO,FS_NORMAL);
$graph->legend->SetLineWeight(2); 
//$graph->legend->SetMarkAbsSize(2); 
//$graph->legend->SetMarkAbsHSize(10);

        $graph->yaxis->SetColor("red");
        $graph->yaxis->SetWeight(2);
        if($devicetype==4 || $devicetype==7)
        {
            
            if(MAX($maxdata)>10000)
            {
                if(MAX($maxdata)>1000000000)
                {
                     $graph->title->Set("GB");
                     $graph->yaxis->SetLabelFormat('%3d%%');
                }else{
                    $graph->title->Set("MB");
                    $graph->yaxis->SetLabelFormat('%3d%%');
                }
            }else{
                $graph->yaxis->SetLabelFormat('%3d%%');
            }
        }else{
            if(MAX($maxdata)>10000)
            {
                if(MAX($maxdata)>1000000000)
                {
                     $graph->title->Set("GB");
                }else{
                    $graph->title->Set("MB");
                }
            }else{
                $graph->title->Set("KB");
            }
        }
        $graph->SetShadow(); 
        $graph->legend->Pos(0,0.5,"right","center");
        $graph->xaxis->SetLabelAngle(30);

        $graph->Stroke();
    }
	function getColor($number){
		switch($number){
			case 0: return "pink";
			case 1: return "darkblue";
			case 2: return "aqua";
			case 3: return "lightblue";
			case 4: return "purple";
			case 5: return "blue";
			case 6: return "azure";
			case 7: return "yellow";
			case 8: return "gray";
			case 9: return "wheat";
			default: return "orange";
        }
	}
    function getSessionDate()
    {
        if(isset($_SESSION['start_time']))
        {
            $start=$_SESSION['start_time'];
        }else{
            $start=date("Y-m-d 00:00:00");
        }
         if(isset($_SESSION['end_time']))
        {
            $end=$_SESSION['end_time'];
        }else{
            $end="";
        }
        if(strlen($start)==0)
        {
            $start=date("Y-m-d 00:00:00");
        }
        $adjstart=strtotime($start);
         if(strlen($start)==0)
        {
            $end=date("Y-m-d 00:00:00");
        }
        return array($start,$end);
    }
    
    function group($key="",$devicetype="")

    {

        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_line.php");
        include ("../jpgraph/jpgraph_date.php");
        
        $datas=$this->Session->read('group_data');
        
        $xdata = array();
        
        if(isset($key) && strlen($key)>0 && $key!='group')
        {
            $datas['host']=$this->get_group_host_data($datas['host']);
            for($i=0;$i<count($datas['host'][$key]);$i++)
            {
                $ydataTmp[]=$datas['host'][$key][$i]['usage'];
                $xdata[]=strtotime($datas['host'][$key][$i]['time']);
            }
            if(max($ydataTmp)>10000)
            {
                $maxflag=1;
                for($i=0;$i<count($ydataTmp);$i++)
                {
                    $ydata[]=round($ydataTmp[$i]/1024);
                }
            }else{
                $maxflag=0;
                $ydata=$ydataTmp;
            }
        }else{
            $index=0;
            $groupData=array();
            foreach($datas['host'] as $key=>$value)
            {
                $groupData[$index]=$value;
                $groupData[$index]['hostname']=$key;
                $index++;
            }
            $datas['group']=$this->get_avg_view_data($groupData);
            if(count($datas['group'])>0)
            {
                if(max($datas['group']['usage'])>10000)
                {
                    $maxflag=1;
                    for($i=0;$i<count($datas['group']['usage']);$i++)
                    {
                        $ydata[]=round($datas['group']['usage'][$i]/1024);
                    }
                }else{
                    $maxflag=0;
                    $ydata=$datas['group']['usage'];
                }
            
                for($i=0;$i<count($datas['group']['time']);$i++)
                {
                    $xdata[]=strtotime($datas['group']['time'][$i]);
                }
            }else{
                $ydata=array(0,0);
                $xdata=array(0,0);
            }
         }    
            
        list($start,$end)=$this->getSessionDate();

        $adjstart=strtotime($start);
        if($start==$end|| (strlen($end)==0))
        {
            $adjend=strtotime($start) +3600*24;
        }else{
            $adjend=strtotime($end);
        }

    function TimeCallback($aVal) {
            list($start,$end)=JpgraphpcController::getSessionDate();
            $start_date=explode(" ",$start);
            list($start_year,$start_month,$start_day)=explode('-',$start_date[0]);
            if(strlen($end)>0)
            {
                $end_date=explode(" ",$end);
                list($end_year,$end_month,$end_day)=explode('-',$end_date[0]);
                if($start_year!=$end_year)
                {
                    return Date('y-m', $aVal);
                }
                if($start_month!=$end_month)
                {
                    return Date('m-d', $aVal);
                }
                if($start_day!=$end_day)
                {
                    return Date('m/d', $aVal);
                }
            }
            return Date('H:i', $aVal);
        }

        $graph = new Graph(800,150,"auto");  
        
        if($devicetype==4 || $devicetype==7)
        {
            $graph->SetScale("datlin",0,100,$adjstart,$adjend);
        }else{
            $graph->SetScale("datlin",0,0,$adjstart,$adjend);
        }
        
        $graph->xaxis->SetLabelFormatCallback('TimeCallback');
        $graph->SetFrame(false);

        $lineplot=new LinePlot($ydata,$xdata);
        $graph->Add($lineplot);
        $graph->img->SetMargin(50,20,20,40);
        
        if(isset($key) && strlen($key)>0)
        {
            $lineplot->SetColor("blue");
        }else{
            $lineplot->SetColor("orange");
        }
    
        $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->yaxis->title->SetFont(FF_MINCHO,FS_NORMAL);
        
         if($devicetype==4 || $devicetype==7)
        {
            $graph->yaxis->SetLabelFormat('%3d%%');
        }else{
            if($maxflag==1)
            {
                $graph->yaxis->SetLabelMargin(0);
                $graph->title->Set("MB");
            }else{
                $graph->title->Set("KB");
            }
        }

        $graph->xaxis->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->xaxis->SetLabelAngle(30);

        $graph->yaxis->SetColor("red");
        $graph->yaxis->SetWeight(2);
        $graph->SetShadow(); 

        $graph->Stroke();
    }
     function pie($type="",$time="")
    {
         include ("../jpgraph/jpgraph.php");
         include ("../jpgraph/jpgraph_pie.php");
        $datas=$this->Session->read('data'); 

        if($type==1)
        {
            $data=array($datas['totals']['use'],$datas['totals']['nouse']);
            $legends=array( __('jpgraph_use',$return = true),__('jpgraph_nouse',$return = true));
        }else{
    
            $data = $datas['usage'];
            $legends=$datas['name'];

        }

        if(count($data)==2)
        {
            $graph = new PieGraph(500,550,"auto");
            $graph->title->Set(__('pc_all_log',$return = true));
            $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
            
        }else{
            $graph = new PieGraph(500,550,"auto");
            $graph->title->Set(__('use_prc',$return = true));
            $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
            
        }
        if($type==1)
        {
            $colors=array('gray','pink');
        }else{
            $colors=array('brown','green','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat');
        }
        
        $graph->SetShadow();
        $graph->SetFrame(false);
        
        $graph->legend->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->legend->Pos(0,0,"right","auto");

        $p1 = new PiePlot($data);
        $p1->SetLegends($legends);

        $p1->SetCenter(0.4);
        $p1->SetSize(0.2);

        $p1->SetSliceColors($colors);
        $graph->Add($p1);
        $graph->Stroke();

    }

    function pie_security($type="",$time="")
	{
		include ("../jpgraph/jpgraph.php");
		include ("../jpgraph/jpgraph_pie.php");
		$datas=$this->Session->read('data');
		session_unregister('data');
		$data_first_month=array($datas['host']['total_first_month']-$datas['host']['alt_month'],$datas['host']['alt_month']);
		$data_sec_month=array($datas['host']['total_sec_month']-$datas['host']['alt_lastmonth'],$datas['host']['alt_lastmonth']);
		$legends=array( __('normal',$return = true),__('alert_happen',$return = true));

		$graph = new PieGraph(1100,350,"auto");
		$graph->title->SetFont(FF_MINCHO,FS_NORMAL);
		$colors=array('thickred','thickblue');

		$graph->SetFrame(true);

		$graph->legend->SetFont(FF_MINCHO,FS_NORMAL);
		$graph->legend->Pos(0.5,0.8,"right","auto");
		if (!empty($datas['host']['total_first_month']) && !empty($datas['host']['total_sec_month'])) {
			$p1 = new PiePlot($data_first_month,'sec');
			$p1->SetLegends($legends);
			$p2 = new PiePlot($data_sec_month,'sec');
			$p1->SetCenter(0.2);
			$p1->SetSize(0.3);
			$p2->SetCenter(0.7);
			$p2->SetSize(0.3);
			$p1->SetSliceColors($colors);
			$graph->Add($p1);
			$p2->SetSliceColors($colors);
			$graph->Add($p2);
		}elseif (empty($datas['host']['total_first_month']) && !empty($datas['host']['total_sec_month'])) {
			$p2 = new PiePlot($data_sec_month,'sec');
			$p2->SetLegends($legends);
			$p2->SetCenter(0.7);
			$p2->SetSize(0.3);
			$p2->SetSliceColors($colors);
			$graph->Add($p2);
		}elseif (!empty($datas['host']['total_first_month']) && empty($datas['host']['total_sec_month']))
		{
			$p1 = new PiePlot($data_first_month,'sec');
			$p1->SetLegends($legends);
			$p1->SetCenter(0.2);
			$p1->SetSize(0.3);
			$p1->SetSliceColors($colors);
			$graph->Add($p1);
		}
		$graph->Stroke();
	}
    
    function getflagnumb($inputdata){
    	$outputdata = 0;
    	if($inputdata <1000){
    	    $outputdata = substr((string)$inputdata,0,1);
    	}else{
    	    $outputdata = substr((string)$inputdata,0,2);
    	}
    	return intval($outputdata);
    }
    
    function sortbycatalogcount($inputdata,$legends,$catagory_flag,$flag){
		$outputdata = array();
		$outputlegends = array();
		$autoarray = $inputdata;
		$autolegends = $legends;
		for($k = 0; $k<$catagory_flag;$k++){
		    $selectedindex = 0;
		    $maxdata = $autoarray[0];	   
		    for($i = 0; $i<count($autoarray)-1;$i++){
		        if($autoarray[$i+1] > $maxdata){
		       	   $maxdata = $autoarray[$i+1];
		       	   $selectedindex = $i+1;
		        }
		    }
		    if($maxdata == 0){
		    	break;
		    }else{
			    $outputdata[] = $autoarray[$selectedindex];
			    $outputlegends[] = $autolegends[$selectedindex];
			    array_splice($autoarray,$selectedindex,1);
			    array_splice($autolegends,$selectedindex,1);
		    }
		}
		if($flag == 'data'){
			return $outputdata;
		}else{
			return $outputlegends;
		}
	}
    

    
    function bar($time="")
    {
        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_bar.php");
        
        setlocale (LC_ALL, 'et_EE.ISO-8859-1');
        $datas=$this->Session->read('data'); 

        $data=$datas['bar_data'];
        $hosts=$datas['hostname'];

        $colors=array('gray','brown','green','yellow','aqua','lightblue','azure','blue','purple','darkblue','orange','wheat');
        for($i=0;$i<count($data);$i++)
        {
            $color[]=$colors[$i];
        }
        
        $color=array_reverse($color);

        $graph = new Graph(800,280,"auto");    
        $graph->SetScale("textlin");

        $graph->SetFrame(false);
        $graph->title->Set(__('pc_use_prc',$return = true));
        $graph->title->SetFont(FF_MINCHO,FS_NORMAL);
        
        $graph->Set90AndMargin();

        foreach($data as $key=>$value)
        {
            $index=0;
            for($i=0;$i<count($value);$i++)
            {
                $datay[$key][]=$value[$i]; 
            }
            $bplot[$key] = new BarPlot($datay[$key]);
            $bplot[$key]->SetFillColor($color[$key]);
            $array[]=$bplot[$key];
            
            $index++;
        }
        
        $gbplot = new AccBarPlot($array);
        
        $graph->Add($gbplot);
        $graph->xaxis->SetTickLabels($hosts);
        $graph->xaxis->SetFont(FF_MINCHO,FS_NORMAL);
        $graph->yaxis->SetLabelFormat('%3d%%');

        $graph->Stroke();
        

    }
    function test()
    {
        include ("../jpgraph/jpgraph.php");
        include ("../jpgraph/jpgraph_line.php");
        
        $ydata = array(11,3,8,12,5,1,9,13,5,7);
        $y2data = array(354,200,265,99,111,91,198,225,293,251);
        
        $graph = new Graph(400,200,"auto");    
        $graph->SetScale("textlin");
        $graph->SetY2Scale("lin");
        $graph->SetShadow();
        
        $graph->img->SetMargin(40,100,20,40);
        
        $lineplot=new LinePlot($ydata);
        $lineplot2=new LinePlot($y2data);
        
        $graph->Add($lineplot);
        $graph->AddY2($lineplot2);
        $lineplot2->SetColor("orange");
        $lineplot2->SetWeight(2);
        
        $graph->y2axis->SetColor("orange");
        $graph->yaxis->SetColor("blue");
        
        $graph->title->Set("Example 6");
        $graph->xaxis->title->Set("X-title");
        $graph->yaxis->title->Set("Y-title");
        
        $graph->title->SetFont(FF_FONT1,FS_BOLD);
        $graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
        $graph->xaxis->title->SetFont(FF_FONT1,FS_BOLD);
        
        $lineplot->SetColor("blue");
        $lineplot->SetWeight(2);
        $lineplot2->SetColor("orange");
        $lineplot2->SetWeight(2);
        
        $lineplot->SetLegend("Plot 1");
        $lineplot2->SetLegend("Plot 2");
        
        $graph->legend->Pos(0.05,0.5,"right","center");
        
        $graph->Stroke();
    }
    function get_view_data($dataHdd)
    {
        $k=0;
        for($i=0;$i<count($dataHdd);$i++)
        {
            for($j=0;$j<count($dataHdd[$i])-1;$j++)
            {
                $timekey=substr($dataHdd[$i][$j]['time'],0,strlen($dataHdd[$i][$j]['time'])-3);
                $newarray[$i][$timekey]=$dataHdd[$i][$j]['usage'];
                $avg_array[$timekey]="";
                
            }
            $newarray[$i]['hostname']=$dataHdd[$i]['hostname'];
            
         }

         for($i=0;$i<count($newarray);$i++)
         {
             $index=0;
             foreach($newarray[$i] as $key=>$value)
             {
                 
                 if($key!="hostname")
                 {
                     $data[$i][$index]['usage']=$value;
                     $data[$i][$index]['time']=$key;
                 }else{
                     $data[$i][$key]=$value;
                 }
                 $index++;
             }
         }
         ksort ($avg_array);

         $avg_index=0;
         $hostUsage=0;
         $usageHistory0=-1;
         $usageHistory1=-1;
         $usageHistory2=-1;
         $usageHistory3=-1;
         $usageHistory4=-1;
         $usageHistory5=-1;
         $usageHistory6=-1;
         $usageHistory7=-1;
         $usageHistory8=-1;
         $usageHistory9=-1;
         foreach($avg_array as $key => $value)
         {
            
             $hostcount=0;
             $dataAvg=0;
             $hostUsage=0;
            for($i=0;$i<count($data);$i++)
            {
                $timeType=0;
                for($j=0;$j<count($data[$i])-1;$j++)
                {
                    if($key==$data[$i][$j]['time'])
                    {
                        $timeType=$data[$i][$j]['usage'];
                        $currusageUsage=$data[$i][$j]['usage'];
                        if($i==0)
                        {
                            $usageHistory0=$data[$i][$j]['usage'];
                        }
                        if($i==1)
                        {
                            $usageHistory1=$data[$i][$j]['usage'];
                        }
                        if($i==2)
                        {
                            $usageHistory2=$data[$i][$j]['usage'];
                        }
                        if($i==3)
                        {
                            $usageHistory3=$data[$i][$j]['usage'];
                        }
                        if($i==4)
                        {
                            $usageHistory4=$data[$i][$j]['usage'];
                        }
                        if($i==5)
                        {
                            $usageHistory5=$data[$i][$j]['usage'];
                        }
                        if($i==6)
                        {
                            $usageHistory6=$data[$i][$j]['usage'];
                        }
                        if($i==7)
                        {
                            $usageHistory7=$data[$i][$j]['usage'];
                        }
                        if($i==8)
                        {
                            $usageHistory8=$data[$i][$j]['usage'];
                        }
                        if($i==9)
                        {
                            $usageHistory9=$data[$i][$j]['usage'];
                        }
                    }
                }
                
                if($timeType==0)
                {
                    
                    if($i==0)
                    {
                        if($usageHistory0==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory0;
                        }
                    }
                    if($i==1)
                    {
                        if($usageHistory1==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory1;
                            
                        }
                    }
                    if($i==2)
                    {
                        if($usageHistory2==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            
                            $hostUsage=$usageHistory2;
                        }
                    }
                    if($i==3)
                    {
                        if($usageHistory3==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory3;
                        }
                    }
                    if($i==4)
                    {
                        if($usageHistory4==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory4;
                        }
                    }
                    if($i==5)
                    {
                        if($usageHistory5==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory5;
                        }
                    }
                    if($i==6)
                    {
                        if($usageHistory6==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory6;
                        }
                    }
                    if($i==7)
                    {
                        if($usageHistory7==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory7;
                        }
                    }
                    if($i==8)
                    {
                        if($usageHistory8==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory8;
                        }
                    }
                    if($i==9)
                    {
                        if($usageHistory9==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory9;
                        }
                    }
                    
        
                }else{
                    $hostUsage=$currusageUsage;
                }
                $dataAvg=$hostUsage+$dataAvg;
            }
            
            $avgData[$avg_index]['usage']=$dataAvg/((count($dataHdd)-$hostcount)==0?1:count($dataHdd)-$hostcount);
            $avgData[$avg_index]['time']=$key;
			$avgData['hostname']=__('avgbrackets',$retrun=true).count($data).__('bracketsdesk',$retrun=true);
            $avg_index++;
         }
         array_push($data,$avgData);
         return $data;
    }
    function get_group_host_data($dataHdd)
    {
        $k=0;
        foreach($dataHdd as $key => $value)
        {
            for($j=0;$j<count($dataHdd[$key]);$j++)
            {
                $timekey=substr($dataHdd[$key][$j]['time'],0,strlen($dataHdd[$key][$j]['time'])-3);
                $newarray[$key][$timekey]=$dataHdd[$key][$j]['usage'];
                $avg_array[$timekey]="";
                
            }      
         }
         
         foreach($newarray as $k => $v)
         {
             $index=0;
             foreach($newarray[$k] as $key=>$value)
             {
                 $data[$k][$index]['usage']=$value;
                 $data[$k][$index]['time']=$key;
                 $index++;
             }
         }
         
          return $data;
    }
    function get_group_data($dataHdd)
    {
        $k=0;
        for($j=0;$j<count($dataHdd['time']);$j++)
        {
            $timekey=substr($dataHdd['time'][$j],0,strlen($dataHdd['time'][$j])-3);
            $newarray[$timekey]=$dataHdd['usage'][$j];
            $avg_array[$timekey]="";
            
        }

         foreach($newarray as $key => $value)
         {
             $data['usage'][]=$value;
             $data['time'][]=$key;
         }
         return $data;
    }
    function get_avg_view_data($dataHdd)
    {
        
        $k=0;
        for($i=0;$i<count($dataHdd);$i++)
        {
            for($j=0;$j<count($dataHdd[$i])-1;$j++)
            {
                $timekey=substr($dataHdd[$i][$j]['time'],0,strlen($dataHdd[$i][$j]['time'])-3);
                $newarray[$i][$timekey]=$dataHdd[$i][$j]['usage'];
                $avg_array[$timekey]="";
                
            }
            $newarray[$i]['hostname']=$dataHdd[$i]['hostname'];
            
         }

         for($i=0;$i<count($newarray);$i++)
         {
             $index=0;
             foreach($newarray[$i] as $key=>$value)
             {
                 
                 if($key!="hostname")
                 {
                     $data[$i][$index]['usage']=$value;
                     $data[$i][$index]['time']=$key;
                 }else{
                     $data[$i][$key]=$value;
                 }
                 $index++;
             }
         }
         ksort ($avg_array);
         
         $avg_index=0;
         $hostUsage=0;
         $usageHistory0=-1;
         $usageHistory1=-1;
         $usageHistory2=-1;
         $usageHistory3=-1;
         $usageHistory4=-1;
         $usageHistory5=-1;
         $usageHistory6=-1;
         $usageHistory7=-1;
         $usageHistory8=-1;
         $usageHistory9=-1;
         foreach($avg_array as $key => $value)
         {
            
             $hostcount=0;
             $dataAvg=0;
             $hostUsage=0;
            for($i=0;$i<count($data);$i++)
            {
                $timeType=0;
                for($j=0;$j<count($data[$i])-1;$j++)
                {
                    if($key==$data[$i][$j]['time'])
                    {
                        $timeType=$data[$i][$j]['usage'];
                        $currusageUsage=$data[$i][$j]['usage'];
                        if($i==0)
                        {
                            $usageHistory0=$data[$i][$j]['usage'];
                        }
                        if($i==1)
                        {
                            $usageHistory1=$data[$i][$j]['usage'];
                        }
                        if($i==2)
                        {
                            $usageHistory2=$data[$i][$j]['usage'];
                        }
                        if($i==3)
                        {
                            $usageHistory3=$data[$i][$j]['usage'];
                        }
                        if($i==4 )
                        {
                            
                            $usageHistory4=$data[$i][$j]['usage'];
                        }
                        if($i==5)
                        {
                            $usageHistory5=$data[$i][$j]['usage'];
                        }
                        if($i==6)
                        {
                            $usageHistory6=$data[$i][$j]['usage'];
                        }
                        if($i==7)
                        {
                            $usageHistory7=$data[$i][$j]['usage'];
                        }
                        if($i==8)
                        {
                            $usageHistory8=$data[$i][$j]['usage'];
                        }
                        if($i==9)
                        {
                            $usageHistory9=$data[$i][$j]['usage'];
                        }
                    }
                }
                
                if($timeType==0)
                {
                    
                    if($i==0)
                    {
                        if($usageHistory0==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory0;
                        }
                    }
                    if($i==1)
                    {
                        if($usageHistory1==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory1;
                            
                        }
                    }
                    if($i==2)
                    {
                        if($usageHistory2==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            
                            $hostUsage=$usageHistory2;
                        }
                    }
                    if($i==3)
                    {
                        if($usageHistory3==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory3;
                        }
                    }
                    if($i==4)
                    {
                        if($usageHistory4==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory4;
                        }
                    }
                    if($i==5)
                    {
                        
                        if($usageHistory5==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory5;
                        }
                    }
                    if($i==6)
                    {
                        if($usageHistory6==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory6;
                        }
                    }
                    if($i==7)
                    {
                        if($usageHistory7==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory7;
                        }
                    }
                    if($i==8)
                    {
                        if($usageHistory8==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory8;
                        }
                    }
                    if($i==9)
                    {
                        if($usageHistory9==-1)
                        {
                            $hostcount++;
                            $hostUsage=0;
                        }else{
                            $hostUsage=$usageHistory9;
                        }
                    }
                    
        
                }else{
                    $hostUsage=$currusageUsage;
                }
                $dataAvg=$hostUsage+$dataAvg;
            }

            $avgData['usage'][]=$dataAvg/((count($dataHdd)-$hostcount)==0?1:count($dataHdd)-$hostcount);
            $avgData['time'][]=$key;
            $avg_index++;
         }
         return $avgData;
    }

}
// yaozl end 2009/08/26 add for JL-0039
?>