﻿<?php
class NetmetrixesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
    	var $components = array ('Pagination', 'Lv','Check','Netmetrix');
    	var $uses=array('Host','Rlthstgrp','Group','Grpauth','Asthrd','Astose');
    	var $layout='alert';
    	var $replacedName = "system_all_netmetrixes";			//add by wzy at 20071119 for Authority
    	function beforeFilter()
    	{
			parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
    			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
		}
    	} 	
     	function index()
    	{
    		$this->pageTitle = __('title',$return = true);
	 	$search= $this->requestAction('/netmetrixes/search/',array('return'));
	 	$this->set('search',$search);
    	}
     	function search($a = null)
    	{
		$this->layout = 'ajax';
		if($a == 2){
			$errorMessage['computer_err'][] = 'E-00200';	
			$this->set('errorMessage',$errorMessage); 
		}
		$condition = array();
		if (empty($this->data)){
			$condition[] = "1=1";
		}
		elseif($a == 1){
			$condition[] = "1=1";
		}else{
			isset($this->data['Group']['groupname'])?$group_id = $this->data['Group']['groupname']:$group_id = 0;
			isset($this->data['Group']['windows'])?$os_id = $this->data['Group']['windows']:$os_id = 0;
			if ($group_id<>0){
				$grp_name_se = $this->Grpauth->getChildrenByParent($group_id);
				$grp_name = implode("','",$grp_name_se);
				$condition[] = "Temp.group_name in ('$grp_name')";				
			}
			if ($os_id<>0){
				$condition[] = "Temp.os_name like '%Windows%'";		
			}
		}
		if (empty($condition)){
			$condition[] = "1=1";
		}
		$this->pg($condition);
    	}     	
     	function pg(& $condition)
    	{
		$this->layout='ajax'; 			
		$logvillage_done = __('logvillage_done',$return = true);			//LogVillage未登録
		$logvillage_except_os = __('logvillage_except_os',$return = true);		//LogVillageサポート外OS
		$netmetrix_findnone = __('netmetrix_findnone',$return = true);		//NETMETRIXにて未検出
		$netmetrix_change_lognone = __('netmetrix_change_lognone',$return = true);	//NETMETRIX変化端末状態、LogVillage未登録	
		$netmetrix_change = __('netmetrix_change',$return = true);		//NETMETRIX変化端末状態



		$netmetrix_change_computer_namechange = __('netmetrix_change_computer_namechange',$return = true);	//NETMETRIX変化端末状態　（コンピュータ名が変更されました）



		$netmetrix_new = __('netmetrix_new',$return = true);			//NETMETRIX新規端末状態


		$netmetrix_new_lvnone = __('netmetrix_new_lvnone',$return = true);	//NETMETRIX新規端末状態、LogVillage未登録
    		$own_user_id = $this->_getUserGroup();	
    		$glist = $this->Grpauth->getChildrenByParent($own_user_id);	
 	 	$glist[0] = __('all_select',$return = true);					//すべて
	  	ksort($glist);	
	 	$this->set('glist',$glist); 
	 	$option[0] = __('all_select',$return = true);					//すべて
	 	$option[1] = __('windows_select',$return = true);				//Windows 端末情報のみ
	 	$this->set('option',$option); 	
		$db=$this->Netmetrix->init();
		$rs = $db->Execute('lv_get_nodes');
		$net_data = $this->Netmetrix->GetRows($rs);
//		debug($net_data,true);
		$result = $this->Host->query('CREATE TEMPORARY TABLE temppsoptusers (id serial, domain_id integer, log_id integer, host_name varchar(256), group_name varchar(200), nex_status integer, lv_status integer, account varchar(127), os_name varchar(64), address varchar(32), etc varchar(200), password varchar(127))');
		$hstname_array = null;
		foreach ($net_data as $output){			
			$domain_id = $output['domain_id'];
			$node_id = $output['node_id'];
			$log_id = $output['log_id'];
			$host_name = $output['netbios_name'];
			$os_name = $output['os'];
			$address = $output['mac_address'];
			$status = $output['error_level'];
			$change_name = $output['new_netbios_name'];			
			if ($status == -1){
				$asso = array('Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
						'Group : groups' => array('Rlthstgrp.group_id = Group.id')
						);					
				$host = $this->Host->findByAsso(array("upper(Host.host_name) = '".$host_name."'"), array("Host.password","Host.username","Group.group_name"),null,null,null,$asso);			
				if (empty($host)){
					$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}',NULL,$status,2,NULL,'{$os_name}','{$address}','{$logvillage_done}',NULL);");					
				}else{
					$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}','{$host[0]['Group']['group_name']}',$status,-1,'{$host[0]['Host']['username']}','{$os_name}','{$address}','','{$host[0]['Host']['password']}');");
					$hstname_array = $hstname_array."'".$host_name."',";
				}				
			}elseif ($status == 0){			
				$asso = array('Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
						'Group : groups' => array('Rlthstgrp.group_id = Group.id')
						);					
				$host = $this->Host->findByAsso(array("upper(Host.host_name) = '".$host_name."'"), array("Host.password","Host.username","Group.group_name"),null,null,null,$asso);		
				if (empty($host)){
					$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}',NULL,$status,-1,NULL,'{$os_name}','{$address}','{$netmetrix_findnone}',NULL);");					
				}else{
					$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}','{$host[0]['Group']['group_name']}',$status,-1,'{$host[0]['Host']['username']}','{$os_name}','{$address}','{$netmetrix_findnone}','{$host[0]['Host']['password']}');");
					$hstname_array = $hstname_array."'".$host_name."',";
				}				
			}elseif ($status == 1){
				$asso = array('Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
						'Group : groups' => array('Rlthstgrp.group_id = Group.id')
						);					
				$host = $this->Host->findByAsso(array("upper(Host.host_name) = '".$host_name."'"), array("Host.password","Host.username","Group.group_name"),null,null,null,$asso);			
				if (empty($change_name)){
					if (empty($host)){
						$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}',NULL,$status,2,NULL,'{$os_name}','{$address}','{$netmetrix_change_lognone}',NULL);");						
					}else{
						$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}','{$host[0]['Group']['group_name']}',$status,-1,'{$host[0]['Host']['username']}','{$os_name}','{$address}','{$netmetrix_change}','{$host[0]['Host']['password']}');");
						$hstname_array = $hstname_array."'".$host_name."',";
					}										
				}else{
					if (empty($host)){
						$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}',NULL,$status,2,NULL,'{$os_name}','{$address}','{$netmetrix_change_lognone}',NULL);");						
					}else{
						$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}','{$host[0]['Group']['group_name']}',$status,1,'{$host[0]['Host']['username']}','{$os_name}','{$address}','{$netmetrix_change_computer_namechange}','{$host[0]['Host']['password']}');");
						$hstname_array = $hstname_array."'".$host_name."',";
					}					
				}
				
			}elseif ($status == 2){
				$asso = array('Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
						'Group : groups' => array('Rlthstgrp.group_id = Group.id')
						);					
				$host = $this->Host->findByAsso(array("upper(Host.host_name) = '".$host_name."'"), array("Host.password","Host.username","Group.group_name"),null,null,null,$asso);		
				if (empty($host)){
					$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}',NULL,$status,2,NULL,'{$os_name}','{$address}','{$netmetrix_new_lvnone}',NULL);");					
				}else{
					$this->Host->query("INSERT INTO temppsoptusers VALUES($node_id,$domain_id,$log_id,'{$host_name}','{$host[0]['Group']['group_name']}',$status,-1,'{$host[0]['Host']['username']}','{$os_name}','{$address}','{$netmetrix_new}','{$host[0]['Host']['password']}');");
					$hstname_array = $hstname_array."'".$host_name."',";
				}				
			}
		}
		if (!empty($hstname_array)){
			$hstname_array = substr($hstname_array,0,-1); 
		}
		else{
			$hstname_array = "'null'";
		}
		$asso = array('Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
				'Group : groups' => array('Rlthstgrp.group_id = Group.id'),
				'Asthrd : asthrds:left' => array('Host.id = Asthrd.host_id'),
				'Astose : astoses:left' => array('Asthrd.id = Astose.hardware_id')
				);					
		$host_lv = $this->Host->findByAsso(array("upper(Host.host_name) not in ($hstname_array)"), array("Host.password as Host__password, Host.username as Host__username, Group.group_name as Group__group_name, upper(Host.host_name) as Host__host_name, Host.id as Host__id, Astose.os_name as Astose__os_name"),null,null,null,$asso);		
		foreach ($host_lv as $insert){
			$this->Host->query("INSERT INTO temppsoptusers VALUES({$insert['Host']['id']},null,null,'{$insert['Host']['host_name']}','{$insert['Group']['group_name']}',0,-1,'{$insert['Host']['username']}','{$insert['Astose']['os_name']}',null,'{$netmetrix_findnone}','{$insert['Host']['password']}');");
		}
		$this->addModel("Temp");
    		$this->Temp->useTable = "temppsoptusers";	
    		$order_now = "Temp.host_name";		
		$asso = array();
		
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'view', 'url'=>'/netmetrixes/search/', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso','asso' => $asso), 'sortBy' => $this->Lv->sortBy($order_now)));			
		$data = $this->Temp->findByAsso($condition, array("Temp.id","Temp.domain_id","Temp.log_id","Temp.host_name","Temp.group_name","Temp.nex_status","Temp.lv_status","Temp.account","Temp.os_name","Temp.address","Temp.etc","Temp.password"),$order,$limit,$page);		
		empty($data)? $data=array():$data;	
		$this->set('data',$data); 
		
		
		$data_export = $this->Temp->findByAsso($condition, array("Temp.id","Temp.domain_id","Temp.log_id","Temp.host_name","Temp.group_name","Temp.nex_status","Temp.lv_status","Temp.account","Temp.os_name","Temp.address","Temp.etc","Temp.password"),$order,null,$page);
		$this->Session->write("netmetrix_export_data",$data_export);
		$this->render('pg');
    	} 
    	function done(){	
    		$this->layout='ajax';	
		$this->index();	
		$this->render('index');  
    	}    	
}
?>