<?php
/*********************************************************************
*@filename   opu_webs_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/02   modify for LV20R1-187
*            2.0        xushanning  2009/04/15   modify for LogvillageChinese
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        xht         2009/04/28   modify for LogvillageChinese
********************************************************************/
class OpuWebsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation','Optweb');
	var $layout='alert';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('menu_url',$retrun=true);    //アラート通知履歴
		//$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($resultsPerPage=null,$alert_id=null,$starttime=null,$endtime=null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());//グルプリストー   Sessionから
		ksort($glist);
		$this->set('glist',$glist);
		/* $criteria[] =" User.id = ".$this->_getUserId() ;//Sessionから

		$criteria[]=" Authority.controller_name like '%alerts_%' ";

		$asso = array('Rltuserauth : rltuserauths' => array('Rltuserauth.authority_id = Authority.id'),
		'User : users' => array('User.id = Rltuserauth.user_id'),
		);
		$data = $this->Authority->findByAsso($criteria, array('Authority.id','Authority.authority_name','Authority.controller_name'), 'Authority.id', null, null, $asso);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		if($group_id!=null){
		$this->data['dt_check']['name']='Hstalt-alert_time';
		$this->data['dt_check']['start_year']=substr($starttime, 0, 4);
		$this->data['dt_check']['start_month']=substr($starttime, 5, 2);
		$this->data['dt_check']['start_day']=substr($starttime, 8, 2);
		$this->data['dt_check'][0]='date';
		$this->data['dt_check']['end_year']=substr($endtime, 0, 4);
		$this->data['dt_check']['end_month']=substr($endtime, 5, 2);
		$this->data['dt_check']['end_day']=substr($endtime, 8, 2);
		$this->data['hstalt']['group']=$group_id;
		$this->data['Hstalt']['alert_type']=1;
		$this->data['Hstalt']['alert_type_ck'][0]=$alert_id;
		$this->set('group_id',$group_id);
		$this->set('alert_id',$alert_id);
		$contro= $this->requestAction('/alerts/contro/'.$group_id.'/'.$alert_id.'/'.$starttime.'/'.$endtime,array('return'));
		$this->set('contro',$contro);
		}
		else{
		//$contro= $this->requestAction('/alerts/contro',array('return'));
		//$this->set('contro',$contro);
		}*/
	}

	/**
	 * 画面の検索条件データのチャック
	 * jinl
	 * @return エラーがあるの場合「null」を戻る、エラーがないの場合検索条件を戻る。




	 */
	function pagecheck(){
		$criteria = array();
		$by_dt = $this->Lv->optionsDatetime();
		if(!empty($by_dt['error'])){
			$this->set('err1',$by_dt['error']);
		}else{
			$criteria[] = implode(' and ', $by_dt);
		}
		$errorMessage = array();
		//search by host_name
		if(isset($this->data['Host']['host_name']))
		{
			if($this->data['Host']['host_name']==1){
				if(isset($this->data['Host']['hostname_t']))
				{
					if(!$this->Lv->is_empty($this->data['Host']['hostname_t'])){
						if(!$this->Check->checkAllHalf($this->data['Host']['hostname_t']) || !$this->Validation->maxLength($this->data['Host']['hostname_t'],127)){
							if(!$this->Check->checkAllHalf($this->data['Host']['hostname_t'])){
								//xushanning start 2009/04/22   modify for LogvillageChinese
								//$errorMessage['computer'][] = 'E-00400';
								$errorMessage['computer_name'][] = 'E-00400';
								//xushanning end 2009/04/22   modify for LogvillageChinese
							}
							if(!$this->Validation->maxLength($this->data['Host']['hostname_t'],127)){
								//xushanning start 2009/04/22   modify for LogvillageChinese
								//$errorMessage['computer'][] = 'E-00300';
								$errorMessage['computer_name'][] = 'E-00300';
								//xushanning end 2009/04/22   modify for LogvillageChinese
							}
						}
						else{
							if($this->data['Host']['hostname_ck']==0){
								$criteria[]= " (lower(Host.host_name)='".strtolower($this->data['Host']['hostname_t'])."') ";
							}
							else{
								$criteria[]= " (lower(Host.host_name) like '%".strtolower($this->data['Host']['hostname_t'])."%') ";
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Host']['hostname_t'])){
						//xushanning start 2009/04/22   modify for LogvillageChinese
						//$errorMessage['computer'][] = 'E-00100';
						$errorMessage['computer_name'][] = 'E-00100';
						//xushanning end 2009/04/22   modify for LogvillageChinese
					}
				}
			}
		}
		

		//search by account
		if(isset($this->data['Optweb']['account']))
		{
			if($this->data['Optweb']['account']==1){
				if(isset($this->data['Optweb']['account_t']))
				{
					if(!$this->Lv->is_empty($this->data['Optweb']['account_t'])){
						if(/*!$this->Check->checkAllHalf($this->data['Optweb']['account_t']) ||*/ !$this->Validation->maxLength($this->data['Optweb']['account_t'],127)){
							//							if(!$this->Check->checkAllHalf($this->data['Optweb']['account_t'])){
							//								$errorMessage['logon account'][] = 'E-00400';
							//							}
							if(!$this->Validation->maxLength($this->data['Optweb']['account_t'],127)){
								//xushanning start 2009/04/22   modify for LogvillageChinese
								//$errorMessage['logon account'][] = 'E-00300';
								$errorMessage['account_name'][] = 'E-00300';
								//xushanning end 2009/04/22   modify for LogvillageChinese
							}
						}
						else{
							if($this->data['Optweb']['account_ck']==0){
								$criteria[]= " (lower(Optweb.account)='".strtolower($this->data['Optweb']['account_t'])."') ";
							}
							else{
								$criteria[]= " (lower(Optweb.account) like '%".strtolower($this->data['Optweb']['account_t'])."%') ";
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Optweb']['account_t'])){
						//xushanning start 2009/04/22   modify for LogvillageChinese
						//$errorMessage['logon account'][] = 'E-00100';
						$errorMessage['account_name'][] = 'E-00100';
						//xushanning end 2009/04/22   modify for LogvillageChinese
					}
				}
			}
		}

		//search by group
		if($this->data['Optweb']['group']=='0' || empty($this->data['Optweb']['group']))
		{
			$this->data['Optweb']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['Optweb']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";

		//return
		if(!empty($errorMessage)){
			$this->set('errorMessage',$errorMessage);
		}
		if(!empty($dy_dt['error']) || !empty($errorMessage)){
			return null;
		}else{
			$_SESSION['catagory_flag'] = $_POST['catagory_flag'];
			return $criteria;
		}
	}

	function contro($resultsPerPage=null,$search=null,$field=null,$session_about=null,$minid=null,$maxid=null)
	{
		if($this->data['Optweb']['detailog']==2 && $resultsPerPage == "smalldetail"){
			$this->smalldetail($minid,$maxid,$_POST['fenbianlvwidth'],$_POST['fenbianlvheight']);
		}else if($this->data['Optweb']['detailog']==2 && $resultsPerPage == "bigdetail"){
			if($session_about=="destroy_allsession"){
				session_unregister('session_criteria');
			}
			$this->bigdetail($_POST['fenbianlvwidth'],$_POST['fenbianlvheight']);
		}else {
			if ($session_about=="destroy_extractsession") {
				session_unregister('field');
				session_unregister('value');
			}

			if($session_about=="destroy_allsession"){
				session_unregister('show');
				session_unregister('field');
				session_unregister('value');
				session_unregister('title_wholedisplay');
				session_unregister('url_wholedisplay');
			}
			$this->layout='ajax';
			$dt= date('Y-m-d',time());
			$criteria = array();
			$by_kw = $this->Lv->operSearch();
			$by_dt = $this->Lv->optionsDatetime();
			//if($resultsPerPage!=null){
			if(empty($by_dt['error'])){
				if(empty($by_kw['error'])){
					if(empty($err)){
						if(empty($by_dt) && empty($by_kw))
						{
							$criteria[]="datepart(Hstalt.alert_time)= '".$dt."'";
						}
						else
						{
							empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
							empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
						}
						$this->url(null,$criteria,null,null,null,$resultsPerPage,$search,$field,$session_about);
					}
					else{
						$this->url(null,$criteria,null,null,$err,$resultsPerPage,$search,$field,$session_about);
					}
				}
				else{
					if(empty($err)){
						$this->url(null,$criteria,null,$by_kw['error'],null,$resultsPerPage,$search,$field,$session_about);
					}
					else{
						$this->url(null,$criteria,null,$by_kw['error'],$err,$resultsPerPage,$search,$field,$session_about);
					}
				}
			}
			else{
				if(empty($by_kw['error'])){
					if(empty($err)){
						$this->url(null,$criteria,$by_dt['error'],null,null,$resultsPerPage,$search,$field,$session_about);
					}
					else{
						$this->url(null,$criteria,$by_dt['error'],null,$err,$resultsPerPage,$search,$field,$session_about);
					}
				}
				else{
					if(empty($err)){
						$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],null,$resultsPerPage,$search,$field,$session_about);
					}
					else{
						$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],$err,$resultsPerPage,$search,$field,$session_about);
					}
				}
			}
			//			}
			//			else{
			//				if(empty($by_dt['error'])){
			//					if(empty($by_kw['error'])){
			//						if(empty($err)){
			//							if(empty($by_dt) && empty($by_kw))
			//							{
			//								$criteria[]="datepart(Hstalt.alert_time)= '".$dt."'";
			//							}
			//							else
			//							{
			//								empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			//								empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
			//							}
			//							$this->url(null,$criteria,null,null,null,null,null,null,null);
			//						}
			//						else{
			//							$this->url(null,$criteria,null,null,$err,null,null,null,null);
			//						}
			//					}
			//					else{
			//						if(empty($err)){
			//							$this->url(null,$criteria,null,$by_kw['error'],null,null,null,null,null);
			//						}
			//						else{
			//							$this->url(null,$criteria,null,$by_kw['error'],$err,null,null,null,null);
			//						}
			//					}
			//				}
			//				else{
			//					if(empty($by_kw['error'])){
			//						if(empty($err)){
			//							$this->url(null,$criteria,$by_dt['error'],null,null,null,null,null,null);
			//						}
			//						else{
			//							$this->url(null,$criteria,$by_dt['error'],null,$err,null,null,null,null);
			//						}
			//					}
			//					else{
			//						if(empty($err)){
			//							$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],null,null,null,null,null);
			//						}
			//						else{
			//							$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],$err,null,null,null,null);
			//						}
			//					}
			//				}
			//			}
		}
	}

	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}

	function csvdown($criteria=array(),$type=null)
	{
		require_once( 'csv/DlFactory.php' );
		if(!isset($this->data["Optweb"]["group"])||($this->data["Optweb"]["group"] == 0)){
			$this_groups =$this->_getUserGroup();
		}
		else {
			$this_groups =$this->data["Optweb"]["group"];
		}
		$this->data["Optweb"]["group"] = $this->groupName($this_groups);


		if (!empty($this->data["Optweb"]["big_category"])) {										//抽出条件中の分類をCSV出力する







			if (!empty($this->data["Optweb"]["small_category"]) && $this->data["Optweb"]["catagory2"]==1) {
				$num=$this->data["Optweb"]["big_category"].$this->data["Optweb"]["small_category"];
				$this->data['Optweb']['big_sort_s']=$this->get_character1($num);
				$this->data['Optweb']['small_sort_s']=$this->get_character2($num);
			}else {
				$num=$this->data["Optweb"]["big_category"]."5";									//大分類を探し出すために、後ろに0以外の任意数字をつける
				$this->data['Optweb']['big_sort_s']=$this->get_character1($num);
			}
		}

		$dt= date('Y-m-d',time());
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		if(empty($by_kw['error']) && empty($by_dt['error']))
		{
			if(empty($by_dt) && empty($by_kw))
			{
				$criteria[]="datepart(Optweb.access_time)= '".$dt."'";
			}
			else
			{
				empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
				empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
			}
		}
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		$data = $this->Optweb->findByAsso($criteria, array('Optweb.access_time', 'Group.group_name','Host.host_name','Optweb.account','Optweb.catalog1','Optweb.url_title','Optweb.url'), 'Optweb.access_time,Group.group_name,Host.host_name,Optweb.account,Optweb.catalog1,Optweb.url_title,Optweb.url', 100000, 1, $asso);
		//$data=$this->Optweb->findAll(null, null, null, null, null, 0);
		$i=0;
		//$data[0]['Optweb']['big_sort']='11';
		//$data[0]['Optweb']['small_sort']='22';
		foreach ($data as $data1)
		{
			if (empty($data1['Optweb']['catalog1'])) {
				$data[$i]['Optweb']['big_sort']="";
				$data[$i]['Optweb']['small_sort']="";
			}else {
				$cha1=$this->get_character1($data1['Optweb']['catalog1']);
				$cha2=$this->get_character2($data1['Optweb']['catalog1']);
				$data[$i]['Optweb']['big_sort']=$cha1;
				$data[$i]['Optweb']['small_sort']=$cha2;
			}
			$i++;
		}
		if($type=='csv'){
			$csv = DlFactory::create("opt_webs");
			//debug($data,true);
			//xht strat 2009/04/28 mpdify for modify for LogvillageChinese
			//$csv->sendCSVFile($data,$this->data,__('詳細ログ',$return = true));
			$csv->sendCSVFile($data,$this->data,__('detail log',$return = true));
			//xht end 2009/04/28 mpdify for modify for LogvillageChinese
		}
		//		elseif($type=='xml')
		//		{
		//			$xml = DlFactory::createxml("opt_webs");
		//			$xml->sendXMLFile($data,$this->data,__('menu_alert',$return = true));exit;
		//		}
	}



	function url($type=null,& $criteria=array(),$err1=null,$err2=null,$err3=null,$resultsPerPage=null,$search=null,$field=null,$session_about=null)
	{
		$this->layout='ajax';
		/*  if($group_id!=null){
		$this->data['dt_check']['name']='Hstalt-alert_time';
		$this->data['dt_check']['start_year']=substr($starttime, 0, 4);
		$this->data['dt_check']['start_month']=substr($starttime, 5, 2);
		$this->data['dt_check']['start_day']=substr($starttime, 8, 2);
		$this->data['dt_check'][0]='date';
		$this->data['dt_check']['end_year']=substr($endtime, 0, 4);
		$this->data['dt_check']['end_month']=substr($endtime, 5, 2);
		$this->data['dt_check']['end_day']=substr($endtime, 8, 2);
		$this->data['hstalt']['group']=$group_id;
		$this->data['Hstalt']['alert_type']=1;
		$this->data['Hstalt']['alert_type_ck'][0]=$alert_id;
		$this->set('group_id',$group_id);
		$this->set('alert_id',$alert_id);
		}*/
		$search=$this->Lv->url_param_decode2($search);
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();

		($resultsPerPage=="title_wholedisplay")?$_SESSION['title_wholedisplay']=$resultsPerPage:null;
		($resultsPerPage=="url_wholedisplay")?$_SESSION['url_wholedisplay']=$resultsPerPage:null;

		$errorMessage = array();
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			if($group_id!=null){
				$this->set('forHideVar', '&data%5Bdt_check%5D%5Bname%5D=Optweb-access_time&data%5Bdt_check%5D%5Bstart_year%5D=' . substr($starttime, 0, 4) . '&data%5Bdt_check%5D%5Bstart_month%5D=' . substr($starttime, 5, 2) . '&data%5Bdt_check%5D%5Bstart_day%5D=' . substr($starttime, 8, 2) . '&data%5Bdt_check%5D%5B%5D=date&data%5Bdt_check%5D%5Bend_year%5D=' . substr($endtime, 0, 4) . '&data%5Bdt_check%5D%5Bend_month%5D=' . substr($endtime, 5, 2) . '&data%5Bdt_check%5D%5Bend_day%5D=' . substr($endtime, 8, 2) . '&data%5Bhstalt%5D%5Bgroup%5D=' . $group_id . '&data%5BHstalt%5D%5Balert_type%5D=0&data%5BHstalt%5D%5Balert_type%5D=1&data%5BHstalt%5D%5Balert_type_ck%5D%5B%5D=' . $alert_id . '&data%5BHstalt%5D%5Balert_content%5D=0&data%5BHstalt%5D%5Balert_content_ck%5D=-1&btn1=%E5%AE%9F%E8%A1%8C');
			}
			else{
				$this->set('forHideVar', '&data%5Bdt_check%5D%5Bname%5D=Optweb-access_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Bhstalt%5D%5Bgroup%5D=1&data%5BHstalt%5D%5Balert_type%5D=0&data%5BHstalt%5D%5Balert_content%5D=0&data%5BHstalt%5D%5Balert_content_ck%5D=-1&btn1=%E5%AE%9F%E8%A1%8C');
			}
		}
		//search by host_name
		if(isset($this->data['Host']['host_name']))
		{
			if($this->data['Host']['host_name']==1){
				if(isset($this->data['Host']['hostname_t']))
				{
					if(!$this->Lv->is_empty($this->data['Host']['hostname_t'])){
						if(!$this->Check->checkAllHalf($this->data['Host']['hostname_t']) || !$this->Validation->maxLength($this->data['Host']['hostname_t'],127)){
							if(!$this->Check->checkAllHalf($this->data['Host']['hostname_t'])){
								//xushanning start 2009/04/22   modify for LogvillageChinese
								//$errorMessage['computer'][] = 'E-00400';
								$errorMessage['computer_name'][] = 'E-00400';
								//xushanning end 2009/04/22   modify for LogvillageChinese
							}
							if(!$this->Validation->maxLength($this->data['Host']['hostname_t'],127)){
								//xushanning start 2009/04/22   modify for LogvillageChinese
								//$errorMessage['computer'][] = 'E-00300';
								$errorMessage['computer_name'][] = 'E-00300';
								//xushanning end 2009/04/22   modify for LogvillageChinese
							}
						}
						else{
							if($this->data['Host']['hostname_ck']==0){
								$criteria[]= " (lower(Host.host_name)='".strtolower($this->data['Host']['hostname_t'])."') ";
							}
							else{
								$criteria[]= " (lower(Host.host_name) like '%".strtolower($this->data['Host']['hostname_t'])."%') ";
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Host']['hostname_t'])){
						//xushanning start 2009/04/22   modify for LogvillageChinese
						//$errorMessage['computer'][] = 'E-00100';
						$errorMessage['computer_name'][] = 'E-00100';
						//xushanning end 2009/04/22   modify for LogvillageChinese
					}
				}
			}
		}

		//search by account
		if(isset($this->data['Optweb']['account']))
		{
			if($this->data['Optweb']['account']==1){
				if(isset($this->data['Optweb']['account_t']))
				{
					if(!$this->Lv->is_empty($this->data['Optweb']['account_t'])){
						if(/*!$this->Check->checkAllHalf($this->data['Optweb']['account_t']) ||*/ !$this->Validation->maxLength($this->data['Optweb']['account_t'],127)){
							//							if(!$this->Check->checkAllHalf($this->data['Optweb']['account_t'])){
							//								$errorMessage['logon account'][] = 'E-00400';
							//							}
							if(!$this->Validation->maxLength($this->data['Optweb']['account_t'],127)){
								//xushanning start 2009/04/22   modify for LogvillageChinese
								//$errorMessage['logon account'][] = 'E-00300';
								$errorMessage['account_name'][] = 'E-00300';
								//xushanning end 2009/04/22   modify for LogvillageChinese
							}
						}
						else{
							if($this->data['Optweb']['account_ck']==0){
								$criteria[]= " (lower(Optweb.account)='".strtolower($this->data['Optweb']['account_t'])."') ";
							}
							else{
								$criteria[]= " (lower(Optweb.account) like '%".strtolower($this->data['Optweb']['account_t'])."%') ";
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Optweb']['account_t'])){
						//xushanning start 2009/04/22   modify for LogvillageChinese
						//$errorMessage['logon account'][] = 'E-00100';
						$errorMessage['account_name'][] = 'E-00100';
						//xushanning end 2009/04/22   modify for LogvillageChinese
					}
				}
			}
		}


		//分類で検索を行う
		if(isset($this->data['Optweb']['catagory1']))
		{
			if($this->data['Optweb']['catagory1']==1)
			{
				if ($this->data['Optweb']['big_category']=="")
				{
					//xushanning start 2009/04/22   modify for LogvillageChinese
					//$errorMessage['big_category'][] = 'E-03600';
					$errorMessage['big category'][] = 'E-03600';
					//xushanning end 2009/04/22   modify for LogvillageChinese
				}elseif ($this->data['Optweb']['catagory2']==1)
				{
					if ($this->data['Optweb']['small_category']!="") {
						$criteria[]="catalog1=".$this->data['Optweb']['big_category'].$this->data['Optweb']['small_category'];
					}else {
						//xushanning start 2009/04/22   modify for LogvillageChinese
						//$errorMessage['small_category'][] = 'E-03600';
						$errorMessage['small category'][] = 'E-03600';
						//xushanning end 2009/04/22   modify for LogvillageChinese
					}
				}else {
					//						$catalog1=(integer)$this->data['Optweb']['big_category'];
					//						$min=$catalog1+1;
					//						$max=$catalog1+9;
					$criteria[]="catalog1<=".$this->data['Optweb']['big_category']."9 AND catalog1>=".$this->data['Optweb']['big_category']."1";
				}
			}
		}
		//分類で検索を行う




		//search by group
		if($this->data['Optweb']['group']=='0' || empty($this->data['Optweb']['group']))
		{
			$this->data['Optweb']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['Optweb']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";

		//絞込みを行ない部分









		if ($field=="group_name" || $_SESSION['field']=="group_name" ) {
		(empty($_SESSION['value']))?$_SESSION['value']=$search:"";
		(empty($_SESSION['field']))?$_SESSION['field']=$field:"";
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$mess_pc = "グループ名: 「".$_SESSION['value']."」 で絞込み";
		$mess_pc = __('group_Name',true).$_SESSION['value'].__('conditions',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$this->set("mess_pc",$mess_pc);
		$criteria[]=" Group.group_name = '".$this->Lv->spec_char_dbm($_SESSION['value'])."'";
		}
		if ($field=="host_name" || $_SESSION['field']=="host_name" ) {
		(empty($_SESSION['value']))?$_SESSION['value']=$search:"";
		(empty($_SESSION['field']))?$_SESSION['field']=$field:"";
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$mess_pc = "コンピュータ名: 「".$_SESSION['value']."」 で絞込み";
		$mess_pc = __('computerName',true).$_SESSION['value'].__('conditions',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$this->set("mess_pc",$mess_pc);
		$criteria[]=" Host.host_name = '".$this->Lv->spec_char_dbm($_SESSION['value'])."'";
		}
		if ($field=="account" || $_SESSION['field']=="account" ) {
		(empty($_SESSION['value']))?$_SESSION['value']=$search:"";
		(empty($_SESSION['field']))?$_SESSION['field']=$field:"";
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$mess_pc = "アカウント名: 「".$_SESSION['value']."」 で絞込み";
		$mess_pc = __('account_Name',true).$_SESSION['value'].__('conditions',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$this->set("mess_pc",$mess_pc);
		$criteria[]=" Optweb.account = '".$this->Lv->spec_char_dbm($_SESSION['value'])."'";
		}
		if ($field=="catalog1" || $_SESSION['field']=="catalog1" ) {
		(empty($_SESSION['value']))?$_SESSION['value']=$search:"";
		$chn1=$this->get_character1($_SESSION['value']);
		(empty($_SESSION['field']))?$_SESSION['field']=$field:"";
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$mess_pc = "大分類: 「".$chn1."」 で絞込み";
		$mess_pc = __('big_Category',true).$chn1.__('conditions',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$this->set("mess_pc",$mess_pc);
		$min=intval($_SESSION['value']/10)*10+1;
		$max=intval($_SESSION['value']/10)*10+9;
		$criteria[]=" catalog1<=".$max." AND catalog1>=".$min;
		}
		if ($field=="catalog1_small" || $_SESSION['field']=="catalog1_small" ) {
		(empty($_SESSION['value']))?$_SESSION['value']=$search:"";
		$chn2=$this->get_character2($_SESSION['value']);
		(empty($_SESSION['field']))?$_SESSION['field']=$field:"";
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$mess_pc = "小分類: 「".$chn2."」 で絞込み";
		$mess_pc = __('small_Category',true).$chn2.__('conditions',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$this->set("mess_pc",$mess_pc);
		$criteria[]=" Optweb.catalog1 = ".$this->Lv->spec_char_dbm($_SESSION['value']);
		}
		//絞込みを行ない部分













		/*
		$criteria2[] =" User.id = ".$this->_getUserId() ;//Sessionから
		$criteria2[]=" Authority.controller_name like '%alerts_%' ";
		$asso2 = array('Rltuserauth : rltuserauths' => array('Rltuserauth.authority_id = Authority.id'),
		'User : users' => array('User.id = Rltuserauth.user_id'),
		);
		$data2 = $this->Authority->findByAsso($criteria2, array('Authority.id','Authority.authority_name','Authority.controller_name'), 'Authority.id', null, null, $asso2);
		empty($data2)? $data2=array():$data2;
		$alert_type="";
		*/


		//////////////////user_id from Session
		if(!empty($errorMessage) || !empty($err1) || !empty($err2) || !empty($err3)){
			empty($err1) ? null : $this->set('err1',$err1);
			empty($err2) ? null : $this->set('err2',$err2);
			empty($err3) ? null : $this->set('err3',$err3);
			empty($errorMessage) ? null : $this->set('errorMessage',$errorMessage);
			$criteria[]="1=2";
		}
		//xinw start 20081202
		//modify for LV20R1-187
		elseif (empty($errorMessage) && empty($err1) && empty($err2) && empty($err3)) {
			$asso_prt = array('Host : hosts' => array('Optweb.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$log_count=$this->Optweb->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_URL_category'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_URL_category']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_URL_category'].__("E-03900-1",true));
				}
			}
		}
		//xinw end 20081202
		$criteria[]="1=1";
		if($type=='csv'||$type=='xml')
		{
			$this->csvdown($criteria,$type);exit;
		}
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//'Authority : authorities' => array('Hstalt.alert_type_id = Authority.id-15'),
		//'Rltuserauth : rltuserauths' => array('Rltuserauth.authority_id = Authority.id'),
		//'User : users' => array('User.id = Rltuserauth.user_id'),
		);
		if ($resultsPerPage=="20_resultsPerPage")
		{
			session_unregister('show');
			$pagecounts[0]=20;
			$_SESSION['show']=20;
		}elseif($resultsPerPage=="50_resultsPerPage" )
		{
			session_unregister('show');
			$pagecounts[0]=50;
			$_SESSION['show']=50;
		}elseif($resultsPerPage=="100_resultsPerPage" )
		{
			session_unregister('show');
			$pagecounts[0]=100;
			$_SESSION['show']=100;
		}
		empty($_SESSION['show'])?$pagecounts[0]=50:$pagecounts[0]=$_SESSION['show'];
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/opu_webs/contro', 'modelClass'=>'Optweb', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Optweb.access_time, Group.group_name, Host.host_name, Optweb.account,Optweb.catalog1,Optweb.catalog2,Optweb.url_title,Optweb.url,Optweb.domain')),$pagecounts);
		$data = $this->Optweb->findByAsso($criteria, array('Optweb.access_time', 'Group.group_name','Host.host_name', 'Optweb.account','Optweb.url_title','Optweb.url','Optweb.catalog1','Optweb.catalog2','Optweb.domain'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->render('url');
	}

	/**
          * bigdetail画面のcsv操作.
          *　jinl
          */
	function csvdown_bigdetail(){
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("operwebs_bigdetail");
		$this->getgroupname();
		$criteria  = $_SESSION['session_criteria'];
		$tempdata  = $this->getarraydata('getarray',$criteria);
		$data = $this->sortbycatalogcount($tempdata,$_SESSION['catagory_flag']);
		$numdata = $this->sortbycatalogcount($tempdata,$_SESSION['catagory_flag'],'datacount');
		if($numdata == 0){
			//xushanning start 2009/04/13 modify for LogvillageChinese
			//$data[] = array('catalogname'=>'合計','catalogcount'=>$numdata,'cataloghiritu'=>'0%',);
			$data[] = array('catalogname'=>__('totle',true),'catalogcount'=>$numdata,'cataloghiritu'=>'0%',);
			//xushanning end 2009/04/13 modify for LogvillageChinese
		}else{
			//xushanning start 2009/04/13 modify for LogvillageChinese
			//$data[] = array('catalogname'=>'合計','catalogcount'=>$numdata,'cataloghiritu'=>'100%',);
			$data[] = array('catalogname'=>__('totle',true),'catalogcount'=>$numdata,'cataloghiritu'=>'100%',);
			//xushanning end 2009/04/13 modify for LogvillageChinese
		}
		for($i = 0; $i < count($data); $i++){
			$data[$i] = array('Optweb'=>$data[$i]);
		}
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$csvName = __('カテゴリ大分類',true);
		$csvName = __('areabig_Category',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$csv->sendCSVFile($data,$this->data,$csvName);
		exit();
	}

	/**
          * smalldetail画面のcsv操作.
          *　jinl
          */
	function csvdown_smalldetail($minid=null,$maxid=null){
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("operwebs_smalldetail");
		$this->getgroupname();
		$criteria  = $_SESSION['session_criteria'];
		$tempdata  = $this->getsmalldetailarray($maxid,$minid,'getarraydata',$criteria);
		$data = $this->sortbycatalogcount($tempdata,count($tempdata));
		$numdata = $this->sortbycatalogcount($tempdata,count($tempdata),'datacount');
		if($numdata == 0){
			//xushanning start 2009/04/13 modify for LogvillageChinese
			//$data[] = array('catalogname'=>'合計','catalogcount'=>$numdata,'cataloghiritu'=>'0%',);
			$data[] = array('catalogname'=>__('totle',true),'catalogcount'=>$numdata,'cataloghiritu'=>'0%',);
			//xushanning end 2009/04/13 modify for LogvillageChinese
		}else{
			//xushanning start 2009/04/13 modify for LogvillageChinese
			//$data[] = array('catalogname'=>'合計','catalogcount'=>$numdata,'cataloghiritu'=>'100%',);
			$data[] = array('catalogname'=>__('totle',true),'catalogcount'=>$numdata,'cataloghiritu'=>'100%',);
			//xushanning end 2009/04/13 modify for LogvillageChinese
		}
		for($i = 0; $i < count($data); $i++){
			$data[$i] = array('Optweb'=>$data[$i]);
		}
		//xushanning start 2009/04/13 modify for LogvillageChinese
		//$csvName = __('カテゴリ小分類',true);
		$csvName = __('areasmall_Category',true);
		//xushanning end 2009/04/13 modify for LogvillageChinese
		$csv->sendCSVFile($data,$this->data,$csvName);
		exit();
	}

	/**
	 * ユーザの名前の設定

	 * jinl
	 */
	function getgroupname(){
		if(!isset($this->data["Optweb"]["group"])||($this->data["Optweb"]["group"] == 0)){
			$this_groups =$this->_getUserGroup();
		}
		else {
			$this_groups =$this->data["Optweb"]["group"];
		}
		$this->data["Optweb"]["group"] = $this->groupName($this_groups);
	}

	/**
	 * smalldetail画面のデータの初期化.
	 * jinl
	 * @param $minid　この大分類のOptweb.catalog1の最小値－１.
	 * @param $maxid　この大分類のOptweb.catalog1の最大値－1.
	 */
	function smalldetail($minid=null,$maxid=null){
		$this->layout='ajax';
		$criteria  = $_SESSION['session_criteria'];
		$tempdata  = $this->getsmalldetailarray($maxid,$minid,'getarraydata',$criteria);
		$this->set('data',$this->sortbycatalogcount($tempdata,count($tempdata)));
		$this->set('numdata',$this->sortbycatalogcount($tempdata,count($tempdata),'datacount'));
		$this->set('minid',$minid);
		$this->set('maxid',$maxid);
		$this->set('dayibunnruyiname',__('bunnruyi'.$minid,$return = true));
		$this->render('smalldetail');
	}

	/**
	 * smalldetail画面のデータの取得.
	 * jinl
	 * @param $minid　この大分類のOptweb.catalog1の最小値－１.
	 * @param $maxid　この大分類のOptweb.catalog1の最大値－１.
	 * @param $flag　戻る値のフラグ
	 * @return umalldetail画面のデータ
	 */
	function getsmalldetailarray($maxid,$minid,$flag,$criteria){
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'));
		$criteria[] = 'Optweb.catalog1 > '.$minid.' and '.$maxid.' > Optweb.catalog1';
		$temp = $this->Optweb->findByAsso($criteria,array('Optweb.catalog1'),null,null,null,$asso);
		$numdata = count($temp);
		if($flag == 'getnumdata'){
			return $numdata;
		}
		$data = array();
		$buruyicount = $maxid - $minid -1;
		for($i = 0; $i < $buruyicount; $i++){
			$data[$i] = array('catalogname' =>__('bunnruyi'.($minid+$i+1),$return = true), 'catalogcount' => 0);
		}
		foreach ($temp as $subdata){
			$flag = 0;
			while($buruyicount - $flag > 0){
				if($subdata['Optweb']['catalog1'] == $minid+1+$flag){
					$data[$flag]['catalogcount'] = ++$data[$flag]['catalogcount'];
				}
				$flag++;
			}
		}
		for ($i = 0 ; $i < count($data) ; $i++){
			$data[$i]['cataloghiritu'] = round($data[$i]['catalogcount']*100/$numdata,2).'%';
			$data[$i]['bunnruyiid'] = $minid+$i+1;
		}
		return $data;
	}

	/**
          * bigdetail画面のデータの初期化.
          *　jinl
          */
	function bigdetail($fenbianlvwidth,$fenbianlvheight)
	{
		$this->layout='ajax';
		$criteria = $this->pagecheck();
		if($criteria != null){
			if(!session_is_registered("session_criteria")){
				$_SESSION['session_criteria'] = $criteria;
			}
			$data = $this->getarraydata('getarray',$criteria);
			$this->set('data',$this->sortbycatalogcount($data,$_SESSION['catagory_flag']));
			$this->set('numdata',$this->sortbycatalogcount($data,$_SESSION['catagory_flag'],'datacount'));
			$this->set('fenbianlvwidth',$fenbianlvwidth);
			$this->set('fenbianlvheight',$fenbianlvheight);
		}
		$this->render('bigdetail');
	}

	/**
	 * bigdetail画面のデータの取得.
	 * jinl
	 * @param $flag　戻る値のフラグ
	 * @return bigdetail画面のデータ
	 */
	function getarraydata($flag,$criteria){
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'));
		$criteria[]=' Optweb.catalog1 > 100 and 2500 > Optweb.catalog1';
		for ($i = 2; $i < 25; $i++){
			$criteria[] = 'Optweb.catalog1 != '. $i*100;
		}
		$temp = $this->Optweb->findByAsso($criteria,array('Optweb.catalog1'),null,null,null,$asso);
		if($flag == 'getnum'){
			return  count($temp);
		}
		$data = array(array('catalogname'=>__('bunnruyi100',$return = true),'catalogcount'=>0,'minid'=>100,'maxid'=>104)
		,array('catalogname'=>__('bunnruyi200',$return = true),'catalogcount'=>0,'minid'=>200,'maxid'=>206)
		,array('catalogname'=>__('bunnruyi300',$return = true),'catalogcount'=>0,'minid'=>300,'maxid'=>305)
		,array('catalogname'=>__('bunnruyi400',$return = true),'catalogcount'=>0,'minid'=>400,'maxid'=>404)
		,array('catalogname'=>__('bunnruyi500',$return = true),'catalogcount'=>0,'minid'=>500,'maxid'=>503)
		,array('catalogname'=>__('bunnruyi600',$return = true),'catalogcount'=>0,'minid'=>600,'maxid'=>605)
		,array('catalogname'=>__('bunnruyi700',$return = true),'catalogcount'=>0,'minid'=>700,'maxid'=>703)
		,array('catalogname'=>__('bunnruyi800',$return = true),'catalogcount'=>0,'minid'=>800,'maxid'=>803)
		,array('catalogname'=>__('bunnruyi900',$return = true),'catalogcount'=>0,'minid'=>900,'maxid'=>905)
		,array('catalogname'=>__('bunnruyi1000',$return = true),'catalogcount'=>0,'minid'=>1000,'maxid'=>1007)
		,array('catalogname'=>__('bunnruyi1100',$return = true),'catalogcount'=>0,'minid'=>1100,'maxid'=>1104)
		,array('catalogname'=>__('bunnruyi1200',$return = true),'catalogcount'=>0,'minid'=>1200,'maxid'=>1204)
		,array('catalogname'=>__('bunnruyi1300',$return = true),'catalogcount'=>0,'minid'=>1300,'maxid'=>1302)
		,array('catalogname'=>__('bunnruyi1400',$return = true),'catalogcount'=>0,'minid'=>1400,'maxid'=>1403)
		,array('catalogname'=>__('bunnruyi1500',$return = true),'catalogcount'=>0,'minid'=>1500,'maxid'=>1508)
		,array('catalogname'=>__('bunnruyi1600',$return = true),'catalogcount'=>0,'minid'=>1600,'maxid'=>1602)
		,array('catalogname'=>__('bunnruyi1700',$return = true),'catalogcount'=>0,'minid'=>1700,'maxid'=>1702)
		,array('catalogname'=>__('bunnruyi1800',$return = true),'catalogcount'=>0,'minid'=>1800,'maxid'=>1804)
		,array('catalogname'=>__('bunnruyi1900',$return = true),'catalogcount'=>0,'minid'=>1900,'maxid'=>1905)
		,array('catalogname'=>__('bunnruyi2000',$return = true),'catalogcount'=>0,'minid'=>2000,'maxid'=>2006)
		,array('catalogname'=>__('bunnruyi2100',$return = true),'catalogcount'=>0,'minid'=>2100,'maxid'=>2103)
		,array('catalogname'=>__('bunnruyi2200',$return = true),'catalogcount'=>0,'minid'=>2200,'maxid'=>2202)
		,array('catalogname'=>__('bunnruyi2300',$return = true),'catalogcount'=>0,'minid'=>2300,'maxid'=>2303)
		,array('catalogname'=>__('bunnruyi2400',$return = true),'catalogcount'=>0,'minid'=>2400,'maxid'=>2402)
		);
		foreach ($temp as $subdata){
			$index = $this->getflagnumb($subdata['Optweb']['catalog1'])-1;
			$data[$index]['catalogcount'] = ++$data[$index]['catalogcount'];
		}
		$numdata = count($temp);
		for($i = 0; $i< count($data);$i++){
			$data[$i]['cataloghiritu'] = $this->gethiritu($data[$i]['catalogcount'],$numdata).'%';
		}
		return $data;
	}

	/**
	 * カテゴリのデータをソートする.
	 * jinl
	 * @param unknown_type $inputdata
	 * @param unknown_type $catagory_flag
	 * @param unknown_type $returnflag
	 * @return unknown
	 */
	function sortbycatalogcount($inputdata,$catagory_flag,$returnflag){
		$outputdata = array();
		$autoarray = $inputdata;
		$numdata = 0;
		for($k = 0; $k<$catagory_flag;$k++){
			$selectedindex = 0;
			$maxdata = $autoarray[0]['catalogcount'];
			for($i = 0; $i<count($autoarray)-1;$i++){
				if($autoarray[$i+1]['catalogcount'] > $maxdata){
					$maxdata = $autoarray[$i+1]['catalogcount'];
					$selectedindex = $i+1;
				}
			}
			$outputdata[] = $autoarray[$selectedindex];
			$numdata = $numdata + $autoarray[$selectedindex]['catalogcount'];
			array_splice($autoarray,$selectedindex,1);
		}
		for($i = 0; $i< count($outputdata);$i++){
			$outputdata[$i]['cataloghiritu'] = $this->gethiritu($outputdata[$i]['catalogcount'],$numdata).'%';
		}
		if($returnflag == "datacount"){
			return $numdata;
		}
		return $outputdata;
	}

	/**
	 * 比率の取得.
	 *  jinl
	 * @param$inputdata　分類の件数
	 * @param$numdata　分類の件数の合計.
	 * @return 比率
	 */
	function gethiritu($inputdata,$numdata){
		$outputdata = 0;
		if($numdata != 0){
			$outputdata = round(100*$inputdata/$numdata,2);
		}
		return $outputdata;
	}

	/**
	 * stringのフォーマート.
	 * jinl
	 * @param $inputdata
	 * @return unknown
	 */
	function getflagnumb($inputdata){
		$outputdata = 0;
		if($inputdata <1000){
			$outputdata = substr((string)$inputdata,0,1);
		}else{
			$outputdata = substr((string)$inputdata,0,2);
		}
		return intval($outputdata);
	}


	//大分類の漢字を取る
	function get_character1($num)
	{
		switch ($num)
		{
			case ($num<=109&&$num>=101):
				$big_sort=__('illegal',$return = true);
				break;
			case ($num<=209&&$num>=201):
				$big_sort=__('claim',$return = true);
				break;
			case ($num<=309&&$num>=301):
				$big_sort=__('adult',$return = true);
				break;
			case ($num<=409&&$num>=401):
				$big_sort=__('security',$return = true);
				break;
			case ($num<=509&&$num>=501):
				$big_sort=__('meeting',$return = true);
				break;
			case ($num<=609&&$num>=601):
				$big_sort=__('finance',$return = true);
				break;
			case ($num<=709&&$num>=701):
				$big_sort=__('gamble',$return = true);
				break;
			case ($num<=809&&$num>=801):
				$big_sort=__('game',$return = true);
				break;
			case ($num<=909&&$num>=901):
				$big_sort=__('shopping',$return = true);
				break;
			case ($num<=1009&&$num>=1001):
				$big_sort=__('communication',$return = true);
				break;
			case ($num<=1109&&$num>=1101):
				$big_sort=__('download',$return = true);
				break;
			case ($num<=1209&&$num>=1201):
				$big_sort=__('job-hunting',$return = true);
				break;
			case ($num<=1309&&$num>=1301):
				$big_sort=__('special',$return = true);
				break;
			case ($num<=1409&&$num>=1401):
				$big_sort=__('topic',$return = true);
				break;
			case ($num<=1509&&$num>=1501):
				$big_sort=__('communication',$return = true);
				break;
			case ($num<=1609&&$num>=1601):
				$big_sort=__('occult',$return = true);
				break;
			case ($num<=1709&&$num>=1701):
				$big_sort=__('lifestyle',$return = true);
				break;
			case ($num<=1809&&$num>=1801):
				$big_sort=__('sports',$return = true);
				break;
			case ($num<=1909&&$num>=1901):
				$big_sort=__('journey',$return = true);
				break;
			case ($num<=2009&&$num>=2001):
				$big_sort=__('interest',$return = true);
				break;
			case ($num<=2109&&$num>=2101):
				$big_sort=__('religion',$return = true);
				break;
			case ($num<=2209&&$num>=2201):
				$big_sort=__('politics',$return = true);
				break;
			case ($num<=2309&&$num>=2301):
				$big_sort=__('advertisement',$return = true);
				break;
			case ($num<=2409&&$num>=2401):
				$big_sort=__('news',$return = true);
				break;
		}
		return $big_sort;
	}



	//小分類の漢字を取る
	function get_character2($num)
	{
		switch ($num) { 												//小分類を見分ける
			case "101":
				$small_sort=__('illegal_1',$return = true);
				break;
			case "102":
				$small_sort=__('illegal_2',$return = true);
				break;
			case "103":
				$small_sort=__('illegal_3',$return = true);
				break;
			case "201":
				$small_sort=__('claim_1',$return = true);
				break;
			case "202":
				$small_sort=__('claim_2',$return = true);
				break;
			case "203":
				$small_sort=__('claim_3',$return = true);
				break;
			case "204":
				$small_sort=__('claim_4',$return = true);
				break;
			case "205":
				$small_sort=__('claim_5',$return = true);
				break;
			case "301":
				$small_sort=__('adult_1',$return = true);
				break;
			case "302":
				$small_sort=__('adult_2',$return = true);
				break;
			case "303":
				$small_sort=__('adult_3',$return = true);
				break;
			case "304":
				$small_sort=__('adult_4',$return = true);
				break;
			case "401":
				$small_sort=__('security_1',$return = true);
				break;
			case "402":
				$small_sort=__('security_2',$return = true);
				break;
			case "403":
				$small_sort=__('security_3',$return = true);
				break;
			case "501":
				$small_sort=__('meeting_1',$return = true);
				break;
			case "502":
				$small_sort=__('meeting_2',$return = true);
				break;
			case "601":
				$small_sort=__('finance_1',$return = true);
				break;
			case "602":
				$small_sort=__('finance_2',$return = true);
				break;
			case "603":
				$small_sort=__('finance_3',$return = true);
				break;
			case "604":
				$small_sort=__('finance_3',$return = true);
				break;
			case "701":
				$small_sort=__('gamble_1',$return = true);
				break;
			case "702":
				$small_sort=__('gamble_2',$return = true);
				break;
			case "801":
				$small_sort=__('game_1',$return = true);
				break;
			case "802":
				$small_sort=__('game_2',$return = true);
				break;
			case "901":
				$small_sort=__('shopping_1',$return = true);
				break;
			case "902":
				$small_sort=__('shopping_2',$return = true);
				break;
			case "903":
				$small_sort=__('shopping_3',$return = true);
				break;
			case "904":
				$small_sort=__('shopping_4',$return = true);
				break;
			case "1001":
				$small_sort=__('communication_1',$return = true);
				break;
			case "1002":
				$small_sort=__('communication_2',$return = true);
				break;
			case "1003":
				$small_sort=__('communication_3',$return = true);
				break;
			case "1004":
				$small_sort=__('communication_4',$return = true);
				break;
			case "1005":
				$small_sort=__('communication_5',$return = true);
				break;
			case "1006":
				$small_sort=__('communication_6',$return = true);
				break;
			case "1101":
				$small_sort=__('download_1',$return = true);
				break;
			case "1102":
				$small_sort=__('download_2',$return = true);
				break;
			case "1103":
				$small_sort=__('download_3',$return = true);
				break;
			case "1201":
				$small_sort=__('job-hunting_1',$return = true);
				break;
			case "1202":
				$small_sort=__('job-hunting_2',$return = true);
				break;
			case "1203":
				$small_sort=__('job-hunting_3',$return = true);
				break;
			case "1301":
				$small_sort=__('special_1',$return = true);
				break;
			case "1401":
				$small_sort=__('topic_1',$return = true);
				break;
			case "1402":
				$small_sort=__('topic_2',$return = true);
				break;
			case "1501":
				$small_sort=__('communication_1',$return = true);
				break;
			case "1502":
				$small_sort=__('communication_2',$return = true);
				break;
			case "1503":
				$small_sort=__('communication_3',$return = true);
				break;
			case "1504":
				$small_sort=__('communication_4',$return = true);
				break;
			case "1505":
				$small_sort=__('communication_5',$return = true);
				break;
			case "1506":
				$small_sort=__('communication_6',$return = true);
				break;
			case "1507":
				$small_sort=__('communication_6',$return = true);
				break;
			case "1601":
				$small_sort=__('occult_1',$return = true);
				break;
			case "1701":
				$small_sort=__('lifestyle_1',$return = true);
				break;
			case "1801":
				$small_sort=__('sports_1',$return = true);
				break;
			case "1802":
				$small_sort=__('sports_2',$return = true);
				break;
			case "1803":
				$small_sort=__('sports_3',$return = true);
				break;
			case "1901":
				$small_sort=__('journey_1',$return = true);
				break;
			case "1902":
				$small_sort=__('journey_2',$return = true);
				break;
			case "1903":
				$small_sort=__('journey_3',$return = true);
				break;
			case "1904":
				$small_sort=__('journey_4',$return = true);
				break;
			case "2001":
				$small_sort=__('interest_1',$return = true);
				break;
			case "2002":
				$small_sort=__('interest_2',$return = true);
				break;
			case "2003":
				$small_sort=__('interest_3',$return = true);
				break;
			case "2004":
				$small_sort=__('interest_4',$return = true);
				break;
			case "2005":
				$small_sort=__('interest_5',$return = true);
				break;
			case "2101":
				$small_sort=__('religion_1',$return = true);
				break;
			case "2102":
				$small_sort=__('religion_2',$return = true);
				break;
			case "2201":
				$small_sort=__('politics_1',$return = true);
				break;
			case "2301":
				$small_sort=__('advertisement_1',$return = true);
				break;
			case "2302":
				$small_sort=__('advertisement_2',$return = true);
				break;
			case "2401":
				$small_sort=__('news_1',$return = true);
				break;
		}
		return $small_sort;
	}


}
?>