<?php
/*********************************************************************
*@filename oper_evtusers_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            1.0        xinw        2008/10/24   modify for LV20R1-182-2
*            2.0        yaozl          2009/08/18       modify for JL-0038
********************************************************************/
class RemoteConnectController extends AppController
{

	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv', 'GenerateFiles','Check');
	//bih start 20080508
	var $uses=array('Poll','Group', 'Host','Mailserver','Module','Grpauth','Configure', 'Validation','Pollog','License','Hstaltsvc','Grpalt','User','Mail','Mailaddress'
		,'Remoteport');
	//bih end 20080508
	var $layout='remote';



	function beforeFilter()
	{
		parent::beforeFilter();

		$this->pageTitle =__('poll title',$return = true);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
			//	    		debug($_POST['forHideVar'], true);
			//	    		echo "forHideVar";
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			//	    		debug($_POST['forHideVar1']);
			//	    		echo "forHideVar1";
		}
		
		$s_list = array(0=>__('All',$return = true),'8'=>__('apping',$return = true),'6'=>__('waiting',$return = true));
		$this->set('s_list',$s_list);
	}

	function index()
	{
		$search= $this->requestAction('/remote_connect/search/',array('return'));
		$this->set('search',$search);
	}

	function gethidevars()
	{

	}

	function search($do=null,$page=null)
	{
		$this->layout="ajax";
		if($do!='first')
		{
			$where= null;
			if( $this->Validation->maxLength($this->data['Poll']['poll_name'],256) )
			{
				if($do!=1)
				{
					if($this->data['Poll']['status']=='8')
					{
						$statu="0,3,4,5,8";
					}
					else
					{
						$statu=$this->data['Poll']['status'];
					}

					empty($this->data['Poll']['poll_id']) ? null : $where[]= "Poll.id=".$this->data['Poll']['poll_id'];
					empty($this->data['Poll']['poll_name']) ? null : $where[]= "lower(Poll.poll_name) like '%".strtolower($this->Lv->spec_char_like($this->data['Poll']['poll_name']))."%'  ";
					empty($this->data['Poll']['poll_version']) ? null : $where[]= "lower(Pollversion.mversion) like '%".strtolower($this->Lv->spec_char_like($this->data['Poll']['poll_version']))."%' ";
					empty($this->data['Poll']['get_time']) ? null : $where[]= "Hstloghead.end_time>='".$this->data['Poll']['get_time']."'  AND Hstloghead.end_time<'".$this->data['Poll']['get_time'].".999'    ";
					$this->data['Poll']['status']==0 ?  null : $where[]="Poll.status in (".$statu.")  " ;


					empty($this->data['Poll']['poll_id']) ? null : $this->set('poll_id',$this->data['Poll']['poll_id']);
					empty($this->data['Poll']['poll_name']) ? null : $this->set('poll_name',$this->data['Poll']['poll_name']);
					empty($this->data['Poll']['poll_version']) ? null : $this->set('poll_version',$this->data['Poll']['poll_version']);
					empty($this->data['Poll']['get_time']) ? null : $this->set('get_time',$this->data['Poll']['get_time']);
					$this->data['Poll']['status']==0 ?  null : $this->set('status',$this->data['Poll']['status']);
				}
				else
				{
					empty($_POST['poll_id']) ? null : $where[]= "Poll.id=".$_POST['poll_id'];
					empty($_POST['poll_name']) ? null : $where[]= "lower(Poll.poll_name) like '%".strtolower($this->Lv->spec_char_like($_POST['poll_name']))."%'  ";
					empty($_POST['poll_version']) ? null : $where[]= "lower(Pollversion.mversion) like '%".strtolower($this->Lv->spec_char_like($_POST['poll_version']))."%' ";
					empty($_POST['get_time']) ? null : $where[]= "Hstloghead.end_time>='".$_POST['get_time']."' AND Hstloghead.end_time<='".$_POST['get_time'].".999'   ";
					$_POST['status']==0 ?  null : $where[]="Poll.status=".$_POST['status']." " ;

					empty($_POST['poll_id']) ? null : $this->set('poll_id',$_POST['poll_id']);
					empty($_POST['poll_name']) ? null : $this->set('poll_name',$_POST['poll_name']);
					empty($_POST['poll_version']) ? null : $this->set('poll_version',$_POST['poll_version']);
					empty($_POST['get_time']) ? null : $this->set('get_time',$_POST['get_time']);
					$_POST['status']==0 ?  null : $this->set('status',$_POST['status']);
				}
			}
			else
			{
				if(!$this->Validation->maxLength($this->data['Poll']['poll_name'],256))
				{
					$err[]=__('poll name',$return = true)."　".__('E-00300',$return = true);
				}

				if(!$this->Validation->maxLength($this->data['Poll']['poll_version'],20))
				{
					$err[]=__('version',$return = true)."　".__('E-00300',$return = true);
				}
				if(!$this->Validation->maxLength($this->data['Poll']['get_time'],200))
				{
					$err[]=__('sensor time',$return = true)."　".__('E-00300',$return = true);
				}

			}

			if(empty($where))
			{
				$asso = array(
				'Mailserver : mailservers : LEFT' => array('Poll.id = Mailserver.poll_id'),
				'Host : hosts : LEFT' => array('Host.poll_id = Poll.id'),
				'Hstloghead : hstlogheads : LEFT' => array('Host.id = Hstloghead.host_id'),
				'Pollversion : pollversions : LEFT' => array('Poll.id = Pollversion.poll_id'),				
				'Remoteport : remoteports : LEFT' => array('Poll.id = Remoteport.ps_id'),
				);
				$where=array("Poll.id<>0");
				$conditions=array('Poll.id<>0','GROUP BY'=>'Poll.id');
				$join=$asso;
			}
			else
			{
				$asso = array(
				'Mailserver : mailservers : LEFT' => array('Poll.id = Mailserver.poll_id'),
				'Host : hosts : LEFT' => array('Host.poll_id = Poll.id'),
				'Hstloghead : hstlogheads : LEFT' => array('Host.id = Hstloghead.host_id'),
				'Pollversion : pollversions : LEFT' => array('Poll.id = Pollversion.poll_id'),
				'Remoteport : remoteports : LEFT' => array('Poll.id = Remoteport.ps_id'),
				);
				$where[]= "Poll.id<>0";
				$conditions=array_merge($where,array('GROUP BY'=>'Poll.id'));
				$join=$asso;
			}
			$where=array_merge($where,array('GROUP BY'=>'Poll.id,Poll.poll_name,Pollversion.mversion,Poll.status,Poll.update_time'));

			isset($page)?$_GET['page']=$page : null;
			list($order,$limit,$page) = $this->Pagination->init($conditions,null,array('ajaxDivUpdate'=>'select','url'=>'/remote_connect/search', 'modelClass'=>'Poll', 'queryType' => array('function' => 'findByAsso', 'asso' => $join),'sortBy' => $this->Lv->sortBy('Poll.id')));
			$fields = array(
				'distinct(Poll.id) AS Poll__id', 
				'Poll.poll_name',
				'Pollversion.mversion',
				'MAX(Hstloghead.end_time) AS Hstloghead__poll_time',
				'Poll.status',
				'Poll.update_time',
				'Remoteport.status',
				'Remoteport.access_time',
				);
			$datatm = $this->Poll->findByAsso($where, $fields, $order, $limit, $page, $asso);
			if(!empty($datatm))
			{
				foreach ($datatm as $tm)
				{
					if(!empty($tm['Hstloghead']['poll_time']))
					{
						$sensor['id']=$tm['Poll']['id'];
						$sensor['status']='8';
						$this->Poll->save($sensor);
					}
				}
			}
			$fields =array(
				'distinct(Poll.id) AS Poll__id', 
				'Poll.poll_name',
				'Pollversion.mversion',
				'MAX(Hstloghead.end_time) AS Hstloghead__poll_time',
				'Poll.status','Poll.update_time',
				'Remoteport.status',
				'Remoteport.access_time'
				);
			$data = $this->Poll->findByAsso($where, $fields, $order, $limit, $page, $asso);

			if(!empty($data))
			{
				foreach ($data as $key=>$da)
				{
					$data[$key]['Poll']['version']=$data[$key]['Pollversion']['mversion'];
				}
			}
			if(!empty($err))
			{
				$this->set('err',$err);
			}
			$this->set('page',$page);
			$this->set('data',$data);


			if(!empty($_SESSION['detail_condition']) && $_SESSION['detail_condition'] && $_SESSION['do_import'] == 1){

				$this->detail($_SESSION['detail_condition'][0],$_SESSION['detail_condition'][1],$_SESSION['detail_condition'][2]);
				session_unregister('do_import');
				$errupload = $_SESSION['errupload'];
				session_unregister('errupload');
				$this->set('errupload',$errupload);
				$this->render('detail');
			}else{
				$this->render('search');
			}
		}

	}

	//登録リスト画面
	function remote($op){
		$this->layout="ajax";
		$psid = $this->data['psid'];
		if($op == "open"){
			//ポート空けたか確認
			$opened = false;
			$port = $this->Remoteport->find(array("Remoteport.ps_id" => $this->Lv->spec_char_dbm($psid)));
			//debug($port);
			if(empty($port) || $port['Remoteport']['status'] == 0 || $port['Remoteport']['status'] == -1 || $port['Remoteport']['status'] == 4){
				//開ける
				$tag = $this->genRandomString(15);
				//ポート状態テーブル更新
				$newport=Array(
					'Remoteport' => Array(
					'ps_id' => $psid,
					'status' => -1,
					'tag' => $tag
					)
				);
				$this->Remoteport->save($newport);
				//指示ファイル作成
				//$this->GenerateFiles->hook_by_ps($psid, array('remote'));
				
				header("LVREMOTETAG: ".$tag);
				header("LVREMOTEPSID: ".$psid);		
				echo "ok";
			}else{
				header("LVREMOTETAG: ".$port['Remoteport']['tag']);
				header("LVREMOTEPSID: ".$psid);			
				//閉じていない
				echo "ng";		
			}

		}/*else if($op == "check"){
			$port = $this->Remoteport->find("Remoteport.ps_id = ".$psid);
			if(empty($port) || $port['Remoteport']['status'] == -1){//ポート閉じている
				echo "closed";
			}else if($port['Remoteport']['status'] == 0){//closing
				echo "closing";
			}else if($port['Remoteport']['status'] == 1){//解放
				$tag = $this->genRandomString(15);
				$newport=Array(
					'Remoteport' => Array(
					'ps_id' => $psid,
					'tag' => $tag
					)
				);
				$this->Remoteport->save($newport);
				//接続用の情報
				header("LVREMOTETARGET: ".$port['Remoteport']['ipaddr']);
				header("LVREMOTEPORT: ".$port['Remoteport']['port']);
				header("LVREMOTEUSER: user");
				header("LVREMOTEPASSWORD: password");
				header("LVREMOTETAG: ".$tag);
				header("LVREMOTEPSID: ".$psid);
				echo "opened";
			}else if($port['Remoteport']['status'] == 2){//解放処理中
				echo "opening";
			}
			exit;
		}*/

	}
	
	function genRandomString($len)
	{
	    $chars = array(
	        "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", 
	        "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", 
	        "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", 
	        "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", 
	        "S", "T", "U", "V", "W", "X", "Y", "Z", "0", "1", "2", 
	        "3", "4", "5", "6", "7", "8", "9"
	    );
	    $charsLen = count($chars) - 1;
	 
	    shuffle($chars);
	    
	    $output = "";
	    for ($i=0; $i<$len; $i++)
	    {
	        $output .= $chars[mt_rand(0, $charsLen)];
	    }
	 
	    return $output;
 
	}
	
}
?>