<?php
/*********************************************************************
*@filename system_all_hotfixes_controller.php
*@description 
*@note
*@histories  rivision	author		date		comment
*            1.0        xushanning     2009/02/23  modify for LV20R1-231
*            1.0        yuanxiaojun    2009/04/09  modify for mantis-525
********************************************************************/
class SystemAllHotfixesController extends AppController{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Optweb','Group', 'Host','Hotfix','Hotfixtype','Configure','Validation');
	var $layout='system';
	//var $errorMessage = array ();
	
	
	function beforeFilter(){
		parent::beforeFilter();
		//$this->Configure->write('debug',2);
		if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	function index($errorMessage=array(),$type=null,$type2 = null){
		$this->pageTitle = __('title',$return = true);  
		

		if($type == 3){
			$this->search(3);
		}
		if($type ==null){
			$this->common(array(),null,null,1);
		}
		//$this->render('index');
		$this->set('errorMessage',$errorMessage);
		if($type2 == 10){
			$this->set('errorMessageFlag',1);
		}else{
			$this->set('errorMessageFlag',0);
		}

	}

	function index_list($errorMessage=array(),$type=null){
		$this->layout = 'ajax';
		$this->pageTitle =  __('lv_system_manage',$return = true)."/". __('all_setting',$return = true)."/". __('login_hotfix_set',$return = true);
		$this->set('errorMessage',$errorMessage);

		if($type ==null){
			$this->common(array(),null,null,20);
			$this->render('index');	exit();
		}
		if($type == 1){
			$this->common(array(),null,null,20);
			$this->render('index');		    
		}
	}
	function common($errorMessage=array(),$depand=null,$type=null,$index_flag =null,$index_flag_sortby=null){//echo "common<br>";
		if($index_flag == 1){			
		}else{
			$this->layout = 'ajax';
		}

/*		if(isset($_SESSION['type']) && strlen(($_SESSION['type']))>0 && $depand!=2){
           	    echo "2222222222222";
            	    //echo "##".$_SESSION['type']."@@";
            	    $word_type = $_SESSION['type'];
            	    $this->data['Hotfixtype']['searchtype'] =$word_type;
            	}else{
            	    echo "111111111111";
            	    $word_type   = $this->data['Hotfixtype']['searchtype'];  
            	    $_SESSION['type'] = $word_type;
            	}*/
            	//echo $index_flag."@@".$index_flag_sortby;


		//if(isset($this->data['Hotfixtype']['searchtype'])&&$depand=='0'){echo "type1<br>";
		if(isset($this->data['Hotfixtype']['searchtype'])){//echo "type1<br>";
			$word_type   = $this->data['Hotfixtype']['searchtype'];
			$word_type = rawurldecode(rawurldecode($word_type));
			$this->data['Hotfixtype']['searchtype'] = $word_type;
			
			$word_code   = $this->data['Hotfix']['searchcode'];
			$word_code = rawurldecode(rawurldecode($word_code));
			$this->data['Hotfix']['searchcode'] = $word_code; 
			   
			$word_name   = $this->data['Hotfix']['searchname'];
			$word_name = rawurldecode(rawurldecode($word_name));
			$this->data['Hotfix']['searchname'] = $word_name;
			
		}			
		else{       
			if(isset($this->data['Hotfixtype']['hiddentype'])){//echo "type2<br>";
				$word_type   = $this->data['Hotfixtype']['hiddentype'];  
				$word_code   = $this->data['Hotfix']['hiddencode'];    
				$word_name   = $this->data['Hotfix']['hiddenname'];
			}
			else{    //echo "type3<br>";
				$word_type='';
				$word_code='';
				$word_name='';
			}
		}
		//echo "index_flag=".$index_flag."<br>";
            	if($index_flag ==20)
            	{
            	    $this->set("index_flag",$index_flag);
            	}
            	if(($index_flag_sortby == 2)){
            	    $word_type = '';
            	    $word_code ='';
            	    $word_name='';
            	}
	    if($this->Check->checkAllHalf($word_code)&&$this->Validation->maxLength($word_type,512)&&$this->Validation->maxLength($word_code,30)&&$this->Validation->maxLength($word_name,900)){   
	    	$condition[] = "1=1";
	    	$word_type_select = 0;
				if(trim($word_type)!=""){
					$word_type_select = 1;
					//$condition[] = "Hotfixtype.hotfix_type_name like '%".$word_type."%'";
					
				}
				if(trim($word_code)!=""){  
					//wangs start 20080202
					//$condition[] = "Hotfix.hotfix_code like '%".trim($word_code)."%'";  
					$condition[] = "lower(Hotfix.hotfix_code) like '%".strtolower(trim($this->Lv->spec_char_like($word_code)))."%'";  
					//wangs end 20080202 
					      	           
				}
				if(trim($word_name)!=""){
					//wangs start 20080202
					//$condition[] = "Hotfix.hotfix_name like '%".trim($word_name)."%'";
					$condition[] = "lower(Hotfix.hotfix_name) like '%".strtolower(trim($this->Lv->spec_char_like($word_name)))."%'";
					//wangs end 20080202     
					       	           
				}
				$this->set('hiddentype', $word_type);
				$this->set('hiddencode', $word_code);
				$this->set('hiddenname', $word_name);

				//$data = $this->Poll->findByAsso($where, array('distinct(Poll.id) AS Poll__id', 'Poll.poll_name','Poll.version','MAX(Hstloghead.end_time) AS Rltpolmod__poll_time ','Poll.status','Poll.update_time'), $order, $limit, $page, $asso);
				list($order,$limit,$page) = $this->Pagination->init($condition,null,array('ajaxDivUpdate'=>'view','url'=>'/system_all_hotfixes/common/', 'modelClass'=>'Hotfix', 'queryType' => array('function' => 'findByAsso', 'asso' => null),'sortBy' => $this->Lv->sortBy('Hotfix.hotfix_code')));
				$result = $this->Hotfix->findByAsso($condition, array('distinct(Hotfix.hotfix_code) AS Hotfix__hotfix_code','Hotfix.hotfix_name'),$order, $limit=null,$page=null, $asso=null);

				if($word_type_select == 0){
					$hotfix_array =  array();
					$hotfix_array_id = array();
					$hotfix_array_hotfix= array();
					if(!empty($result)){
						foreach ($result as $value){
							foreach ($value as $v){
								
								$con = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($v['hotfix_code']));
								$res =$this->Hotfix->findAll($con,null,null,'0',null,null);
								foreach ($res as $v_0){
									$hotfix_array[$v_0['Hotfix']['hotfix_code']][] = $v_0['hotfixtype']['hotfix_type_name'];
									$hotfix_array_id[$v_0['Hotfix']['hotfix_code']][$v_0['hotfixtype']['hotfix_type_name']] = $v_0['Hotfix']['id'];
									$hotfix_array_hotfix[$v_0['Hotfix']['hotfix_code']][$v_0['hotfixtype']['hotfix_type_name']] = $v_0['hotfixtype']['id'];
								}
							}
						}
					}
				}
				
				if($word_type_select == 1){
					$hotfix_array =  array();
					$hotfix_array_id = array();
					$hotfix_array_hotfix= array();
					if(!empty($result)){
						foreach ($result as $value){
							foreach ($value as $v){
								
								$asso = array('Hotfixtype : hotfixtypes' => array('Hotfixtype.id = Hotfix.hotfix_type_id'), 
										);
								//wangs start 20080202
								//$con0[0] = "Hotfix.hotfix_code ='".$v['hotfix_code']."' and Hotfixtype.hotfix_type_name like '%".trim($word_type)."%'";
								$con0[0] = "Hotfix.hotfix_code ='".$this->Lv->spec_char_dbm($v['hotfix_code'])."' and lower(Hotfixtype.hotfix_type_name) like '%".strtolower(trim($this->Lv->spec_char_like($word_type)))."%'";
								//wangs end 20080202
								$result_type = $this->Hotfix->findByAsso($con0, array('distinct(Hotfix.hotfix_code) AS Hotfix__hotfix_code','Hotfix.hotfix_name','Hotfixtype.hotfix_type_name','Hotfixtype.id','Hotfix.id','Hotfix.hotfix_type_id'),'Hotfix.hotfix_code,Hotfixtype.hotfix_type_name', $limit=null, $page=null, $asso);
								if(!empty($result_type)){
									foreach ($result_type as $v_0){
										$hotfix_array[$v_0['Hotfix']['hotfix_code']][] = $v_0['Hotfixtype']['hotfix_type_name'];
										$hotfix_array_id[$v_0['Hotfix']['hotfix_code']][$v_0['Hotfixtype']['hotfix_type_name']] = $v_0['Hotfix']['id'];
										$hotfix_array_hotfix[$v_0['Hotfix']['hotfix_code']][$v_0['Hotfixtype']['hotfix_type_name']] = $v_0['Hotfixtype']['id'];
									}
								}
							}
						}
					}					
				}
				$this->set('hotfix_array',$hotfix_array);
				$this->set('hotfix_array_id',$hotfix_array_id);
				$this->set('hotfix_array_hotfix',$hotfix_array_hotfix);
				$this->set('origin',1);

		}
		else{ 
	            $errorMessage = array();
				if(!$this->Validation->maxLength($word_type,512)){
					$errorMessage['hotfix_type'][]  = 'E-00300';				
				}
		
				if(!$this->Check->checkAllHalf($word_code)){
					$errorMessage['hotfix_code'][]  = 'E-00400';		
				}
				if(!$this->Validation->maxLength($word_code,30)){
					$errorMessage['hotfix_code'][]  = 'E-00300';		
				}					
				if(!$this->Validation->maxLength($word_name,900)){
					$errorMessage['hotfix_name'][]  = 'E-00300';		
				}
				$condition[] = "1=1";
				$asso = array('Hotfixtype : hotfixtypes' => array('Hotfixtype.id = Hotfix.hotfix_type_id'), 
										);

				list($order,$limit,$page) = $this->Pagination->init($condition,null,array('ajaxDivUpdate'=>'view','url'=>'/system_all_hotfixes/search/', 'modelClass'=>'Hotfix', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Hotfixtype.hotfix_type_name')));
				$result = $this->Hotfix->findByAsso($condition, array('Hotfixtype.hotfix_type_name','Hotfixtype.id','Hotfix.id', 'Hotfix.hotfix_code','Hotfix.hotfix_type_id','Hotfix.hotfix_name'),$order, $limit, $page, $asso);
				$this->set('origin',1);
		}
		$this->set('hotfix', $result);
		$this->set('errorMessage', $errorMessage);

		if($depand=='csv'){
			$this->csvdown();
		}
		//$this->render('index');
	}
	function search($depand=null,$getdata=array(),$errorMessage=array()){ 
		$this->layout = 'ajax';
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', 'forHideVar1=0');
   		}
   		if(isset($_POST['forHideVar'])){
   			$this->set('forHideVar', $_POST['forHideVar']);
   		}

		if($depand=='1'){
			if(!empty($getdata)){
				$this->data=$getdata;
			}
			$i = 2;
			foreach($getdata as $v){
		  		
		  			$this->data['Hotfix']['addcode']=$v[0];
		  			$this->data['Hotfix']['addname']=$v[1];
		  			$this->data['Hotfixtype']['addtype']=$v[2];
					$addtype=$this->data['Hotfixtype']['addtype'];
					$addcode=$this->data['Hotfix']['addcode'];
					$addname=$this->data['Hotfix']['addname'];
					$error = "( ".$i." )";
					if(trim($addtype)==""){
						//$errorMessage['hotfix_type'][] = 'E-00100';						
						$errorMessage['E-03200'][$i] = $error;
					}
					elseif(trim($addcode)==""){
						//$errorMessage['hotfix_code'][$i]  = 'E-00100';
						$errorMessage['E-03200'][$i] = $error;	
					}
					elseif(!$this->Check->checkAllHalf($addcode)){
						//$errorMessage['hotfix_code'][$i] = 'E-00400';
						$errorMessage['E-03200'][$i] = $error;	
					}
					elseif(!$this->Validation->maxLength($addcode,30)){
						//$errorMessage['hotfix_code'][$i]  = 'E-00300';
						$errorMessage['E-03200'][$i] = $error;	
					}					
					elseif(trim($addname)==""){
						//$errorMessage['hotfix_name'][$i]  = 'E-00100';
						$errorMessage['E-03200'][$i] = $error;	
					}
					elseif(!$this->Validation->maxLength($addname,900)){
						//$errorMessage['hotfix_name'][$i]  = 'E-00300';
						$errorMessage['E-03200'][$i] = $error;	
					}else{
						$content_all_0 = explode(';',$addtype);
						$content_all_flag = 0;
							foreach ($content_all_0 as $type_value0){
									if(!$this->Validation->maxLength($type_value0,512)){
										$content_all_flag = 1;
										break;										
									}								
							}
							if($content_all_flag == 1){
								$errorMessage['E-03200'][$i] = $error;	
							}
					}
					
			

					if(empty($errorMessage['E-03200'][$i])){
							
							$con_hotfix = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($addcode));
							$res_hotfix =$this->Hotfix->findAll($con_hotfix,array("Hotfix.id","Hotfix.hotfix_type_id"),null,'0',null,null);
							if(count($res_hotfix) > 0){
								foreach ($res_hotfix as $res_hotfix_id){
									//echo $res_hotfix_id['Hotfix']['id'];
									$con_hotfix_1 = array("Hotfix.hotfix_code" => "!= ".$this->Lv->spec_char_dbm($addcode),
														"Hotfix.hotfix_type_id" => $this->Lv->spec_char_dbm($res_hotfix_id['Hotfix']['hotfix_type_id']));
									$result_con_hotfix = $this->Hotfix->findAll($con_hotfix_1,array("Hotfix.hotfix_type_id"),null,'0',null,null);
									if(count($result_con_hotfix) == 0){
										$this->Hotfixtype->del($res_hotfix_id['Hotfix']['hotfix_type_id']);
									}
									$this->Hotfix->del($res_hotfix_id['Hotfix']['id']);								
								}
							}
							$content_all = explode(';',$addtype);
							foreach ($content_all as $type_value){
									$conditon =  array("Hotfixtype.hotfix_type_name" => $this->Lv->spec_char_dbm($type_value));
									$r_type = $this->Hotfixtype->findAll($conditon,null,null,'0',null,null);
									if(count($r_type) > 0){    // 更新
											$r_type_flag = 1;
											$hotfixtype_id = $r_type[0]['Hotfixtype']['id'];
											
											$hotfixtype_id_select = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($addcode), 
																		"Hotfix.hotfix_type_id" => $this->Lv->spec_char_dbm($hotfixtype_id));
											$res_hotfix_d =$this->Hotfix->findAll($hotfixtype_id_select,array("Hotfix.id"),null,'0',null,null);
											if(count($res_hotfix_d) >0){
												$r_type_flag = 0;
											}
											if($r_type_flag == 1){
													$insertdate1=Array(
														'Hotfix' => Array(
														            'hotfix_code' => $addcode,
														            'hotfix_type_id' =>$hotfixtype_id,
														            'hotfix_name' => $addname
														)
													);
													$this->Hotfix->save($insertdate1);
											}
									}else{  // 追加
											$this->Hotfixtype->saveField('hotfix_type_name',$type_value);
											$result_type_id = $this->Hotfixtype->getLastInsertID();
	
													$insertdate3=Array(
														'Hotfix' => Array(
														            'hotfix_code' => $addcode,
														            'hotfix_type_id' =>$result_type_id,
														            'hotfix_name' => $addname
														)
													);
													$this->Hotfix->save($insertdate3);
													//debug($insertdate3);										
																												 
									}
							}
					}
				$i++;		

			}
			
		}
		else if($depand=='3'){

				if(!isset($this->data['Hotfix']['code'])){
					$errorMessage['hotfix_list'][] = 'E-00200';	
				}
				if(!empty($errorMessage)){
					$this->common($errorMessage,$depand,1);
					$this->render('index');
					exit();
				}
				if(empty($errorMessage)){
					$word_id = $this->data['Hotfix']['code'];
					//debug($word_id);
					//debug($this->data['Hotfix']['code_del_id']);
					foreach ($word_id as $check){
							$check = rawurldecode(rawurldecode($check));
						    $type_no = $this->data['Hotfix']['code_del_id'][$check];
						    $type_no_hotfixtype = $this->data['Hotfix']['code_del_hotfixtype'][$check];
						    //debug($type_no_hotfixtype);
						    //debug($type_no);
							foreach ($type_no as $id){
						   		$this->Hotfix->del($id);
						   		
							}
							
					} 
					foreach ($word_id as $check){
							$check = rawurldecode(rawurldecode($check));
						    $type_no_hotfixtype = $this->data['Hotfix']['code_del_hotfixtype'][$check];
							foreach ($type_no_hotfixtype as $id){
								//debug($id);
								$con = array("Hotfix.hotfix_type_id" => $this->Lv->spec_char_dbm($id));
								$con_result = $this->Hotfix->findAll($con);
								if(count($con_result) == 0){
									//echo "delete<br>";
									//debug($id);
									$this->Hotfixtype->del($id);
								}						   		
							}
							
					}
				$this->index_list();
				$this->render('index');
				exit();				
				}

		}		
		
		if(empty($getdata)){	
		    if($depand == 20){
			             $this->common($errorMessage,$depand,null,null,2);
		    }else{
		                 $this->common($errorMessage,$depand,null,null);
		    }
		}
		else{
			return $errorMessage;
		}
		$this->render('index');
	}
	function csvdown(){
		require_once( 'csv/DlFactory.php' );
		$clos=array('distinct(Hotfix.hotfix_code) AS Hotfix__hotfix_code','Hotfix.hotfix_name');
			$asso = array(
			'Hotfixtype : hotfixtypes' =>array('Hotfixtype.id = Hotfix.hotfix_type_id'), 
			);
		    $criteria=array("1=1");
		    if($this->data['Hotfixtype']['searchtype']!=""){
		    	//wangs start 20080202
				//$criteria[]="Hotfixtype.hotfix_type_name like '%".$this->data['Hotfixtype']['searchtype']."%'";
				$criteria[]="lower(Hotfixtype.hotfix_type_name) like '%".strtolower($this->Lv->spec_char_like($this->data['Hotfixtype']['searchtype']))."%'";
				//wangs end 20080202
			}
			if($this->data['Hotfix']['searchcode']!=""){  
				//wangs start 20080202
				//$criteria[]="Hotfix.hotfix_code like '%".$this->data['Hotfix']['searchcode']."%'"; 
				$criteria[]="lower(Hotfix.hotfix_code) like '%".strtolower($this->Lv->spec_char_like($this->data['Hotfix']['searchcode']))."%'"; 
				//wangs end 20080202     	           
			}
			if($this->data['Hotfix']['searchname']!=""){     
				//wangs start 20080202  
				//$criteria[]="Hotfix.hotfix_name like '%".$this->data['Hotfix']['searchname']."%'";    
				$criteria[]="lower(Hotfix.hotfix_name) like '%".strtolower($this->Lv->spec_char_like($this->data['Hotfix']['searchname']))."%'";    
				//wangs end 20080202     	           
			}	
//debug($criteria);
	         $rows =  $this->Hotfix->findByAsso($criteria, array('distinct(Hotfix.hotfix_code) AS Hotfix__hotfix_code','Hotfix.hotfix_name'),'Hotfix.hotfix_code', 10000,1, $asso);

//debug($rows);exit();

	           $i=0;
	           foreach ($rows as $result){	 
                       	$con = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($rows[$i]['Hotfix']['hotfix_code']));
						$res =$this->Hotfix->findAll($con,null,null,'0',null,null);
	
                       	$type_hitfix='';
                       	foreach ($res as $v){
                       		$type_hitfix.=$v['hotfixtype']['hotfix_type_name'].";";
                       	}
                       	$type_hitfix = substr($type_hitfix,0,-1);
//                       	$rows[$i]['Hotfixtype']['hotfix_type_name']='"'.$type_hitfix.'"';                          	
//                       	$rows[$i]['Hotfix']['hotfix_name']='"'.$rows[$i]['Hotfix']['hotfix_name'].'"';
//                       	$rows[$i]['Hotfix']['hotfix_code']='"'.$rows[$i]['Hotfix']['hotfix_code'].'"';
//ADD BY WQ 1008
							$rows[$i]['Hotfixtype']['hotfix_type_name']=$type_hitfix;                          	
	                       	$rows[$i]['Hotfix']['hotfix_name']=$rows[$i]['Hotfix']['hotfix_name'];
	                       	$rows[$i]['Hotfix']['hotfix_code']=$rows[$i]['Hotfix']['hotfix_code'];
//ADD BY WQ 1008
                       	$i++;
               }//debug($rows);
//exit();
	         $csv = DlFactory::create("system_all_hotfixes");
 		     $csv->sendCSVFile($rows,$this->data,__('hotfix_new',$return = true));

	         exit;
	}
	  	function do_import()
  	{
  		require_once("csv_imports_controller.php");
  		$hear_num = 1;
		$data = CsvImportsController :: do_import($hear_num);
		$errorMessage = array();
		//yuanxiaojun start 2009/04/09  modified for mantis-525
		if($data[0]!='error_csv' && $data[0]!='error_format'){
		//yuanxiaojun end  2009/04/09 modified for mantis-525	
			$errorMessage=$this->search(1,$data);
			//debug($errorMessage);
			//$this->search();
			empty($errorMessage)?$errorMessage=null:$errorMessage=$errorMessage;
		
		//yuanxiaojun start 2009/04/09  modified for mantis-525
		}else{
			$errorMessage[__('surecsv',$return = true)][] = 'E-06000';
		}
		//yuanxiaojun end 2009/04/09  modified for mantis-525
		
		
		$this->index($errorMessage,null,10);
		$this->layout='system';
		$this->render("index");
  		//exit();
  	}
  	function getHotfixtype(){
  		$array = array();
  		$result =$this->Hotfixtype->findAll(null,null,null,'0',null,null);
  		if(count($result) >0) {
  			foreach ($result as $v){
  				$id=$v['Hotfixtype']['id'];
  				$array[$id] = $v['Hotfixtype']['hotfix_type_name']; 				
  			}
  			return $array;
  		}else{
  			return 0;
  		}
  	}
  //add 9-1	
    function getHotfixCode($var){
  		$array = array();
  		$conditon = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($var));
  		$result =$this->Hotfix->findAll($conditon,null,null,'0',null,null);
  		if(count($result) >0) {
  			$id = $result[0]['Hotfix']['id'];
  			return $id;
  		}else{
  			return false;
  		}
  	}
    function getHotfix_Type($var){
  		$array = array();
  		$conditon = array("Hotfixtype.hotfix_type_name" => $this->Lv->spec_char_dbm($var));
  		$result =$this->Hotfixtype->findAll($conditon,null,null,'0',null,null);
  		if(count($result) >0) {
  			$id = $result[0]['Hotfixtype']['id'];
  			return $id;
  		}else{
  			return false;
  		}
  	}
  	//add 9-1
  	function addWindowsUpdate($flag=null){
  	    //xuwc
  	    if(isset($_SESSION['type']))
  	    {
  	        unset($_SESSION['type']);
  	    }
  	    //xuwc
  		$this->layout = 'ajax';

 		if($flag == 1){
			
			$addcode=$this->data['Hotfix']['addcode'];
			$addname=$this->data['Hotfix']['addname'];
			$addtype=$this->data['Hotfixtype']['addtype'];
			if(trim($addtype)==""){
				$errorMessage['hotfix type'][] = 'E-00100';	
			}
			if(!$this->Validation->maxLength($addtype,512)){
				$errorMessage['hotfix type'][]  = 'E-00300';	
			}
			if(trim($addcode)==""){
				$errorMessage['hotfix code'][]  = 'E-00100';	
			}
			if(!$this->Check->checkAllHalf($addcode)){
				$errorMessage['hotfix code'][] = 'E-00400';	
			}
			if(!$this->Validation->maxLength($addcode,30)){
				$errorMessage['hotfix code'][]  = 'E-00300';	
			}					
			if(trim($addname)==""){
				$errorMessage['hotfix name'][]  = 'E-00100';	
			}
			if(!$this->Validation->maxLength($addname,900)){
				$errorMessage['hotfix name'][]  = 'E-00300';	
			}					
							
			if((trim($addtype)!="")&&(trim($addcode)!="")&&(trim($addname)!="")
				&& $this->Check->checkAllHalf($addcode)
				&& $this->Validation->maxLength($addtype,512)
				&& $this->Validation->maxLength($addcode,30)
				&& $this->Validation->maxLength($addname,900)){		
					//xushanning start 2009/02/23
					//modify for LV20R1-231
					//$return_flag =$this->getHotfixCode($addcode);
					$return_flag =$this->getHotfixCode(substr($addcode,0,6));
					//xushanning end 2009/02/23
					if($return_flag == false){						
					}else{
						if( @!in_array('E-01900',$errorMessage['hotfix code']))
						$errorMessage['hotfix code'][] = 'hotfix code have login';								
					}
					
					
					$type_flag = 0;
					$content_all_type = explode(';',$addtype);
					
					$j=0;
					foreach ($content_all_type as $key => $type_check){
						$f = 0;
						    foreach ($content_all_type as $key1 => $type_check_i){										
							     if($key != $key1) {   
								      if ($type_check == $type_check_i){
								       		$f=1;
								       		break;
								      }
							     }
						    }
					    if($f==1){
					    		$j=1;
					    		break; 
					    }
					}
					if($j==1){
							if( @!in_array('E-01900',$errorMessage['hotfix type']))
							$errorMessage['hotfix type'][] = 'E-01900';									
					}
			}

			if(!empty($errorMessage)){
				$this->set('errorMessage',$errorMessage);
				$this->render('add');
				exit();
			}
			if(empty($errorMessage)){
				$content_all = explode(';',$addtype);
				foreach ($content_all as $type_value){
					$conditon = array("Hotfixtype.hotfix_type_name" => $this->Lv->spec_char_dbm($type_value));
					$r_type = $this->Hotfixtype->findAll($conditon,null,null,'0',null,null);
					if(count($r_type) > 0){
						$result_type_id = $r_type[0]['Hotfixtype']['id'];
					}else{
						$this->Hotfixtype->saveField('hotfix_type_name',$this->Lv->spec_char_dbm($type_value));
						$result_type_id = $this->Hotfixtype->getLastInsertID();	
					}
					$insertdate=Array(
						'Hotfix' => Array(
						            'hotfix_code' => $this->Lv->spec_char_dbm($addcode),
						            'hotfix_type_id' => $result_type_id,
						            'hotfix_name' => $this->Lv->spec_char_dbm($addname)
						)
					);
					$this->Hotfix->save($insertdate);
				}
				
				$this->index_list(array(),1);
				//$this->render('index');
  				exit();
			}		

 		}
 		$this->render('add');
  		exit();
				
  	}
   	function editWindowsUpdate($value=null,$flag=null){
  		$this->layout = 'ajax';
  		$this->set('value',$value);
		if($flag == null){
				$hotfix_array_0 = array();
				$con = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($value));
				$res =$this->Hotfix->findAll($con,null,null,'0',null,null);
				$addtype='';
				foreach ($res as $v_0){
					$addtype.= $v_0['hotfixtype']['hotfix_type_name'].";";
				}
				$addtype = substr($addtype,0,-1);
				$this->data['Hotfix']['addname'] = $res[0]['Hotfix']['hotfix_name'];
				$this->data['Hotfixtype']['addtype'] =$addtype;
		}
 		if($flag == 1){
					
					$addname=$this->data['Hotfix']['addname'];
					$addtype=$this->data['Hotfixtype']['addtype'];
					if(trim($addtype)==""){
						$errorMessage['hotfix type'][] = 'E-00100';	
					}
					if(!$this->Validation->maxLength($addtype,512)){
						$errorMessage['hotfix type'][]  = 'E-00300';	
					}					
					if(trim($addname)==""){
						$errorMessage['hotfix name'][]  = 'E-00100';	
					}
					if(!$this->Validation->maxLength($addname,900)){
						$errorMessage['hotfix name'][]  = 'E-00300';	
					}					
									
					if((trim($addtype)!="")&&(trim($addname)!="")&&$this->Validation->maxLength($addtype,512)&&$this->Validation->maxLength($addname,900)){		

							$content_all_type = explode(';',$addtype);
							$j=0;
							foreach ($content_all_type as $key => $type_check){
								$f = 0;
								    foreach ($content_all_type as $key1 => $type_check_i){										
									     if($key != $key1) {   
										      if ($type_check == $type_check_i){
										       		$f=1;
										       		break;
										      }
									     }
								    }
							    if($f==1){
							    		$j=1;
							    		break; 
							    }
							}
							if($j==1){
									if( @!in_array('E-01900',$errorMessage['hotfix type']))
									$errorMessage['hotfix type'][] = 'E-01900';									
							}
					}

					if(!empty($errorMessage)){
						$this->set('errorMessage',$errorMessage);
						$this->render('edit');
						exit();
					}
					if(empty($errorMessage)){
							$con = array("Hotfix.hotfix_code" => $this->Lv->spec_char_dbm($value));
							$res =$this->Hotfix->findAll($con,null,null,'0',null,null);
							foreach ($res as $v_1){
								$this->Hotfix->del($v_1['Hotfix']['id']);
							}
							$content_all = explode(';',$addtype);
							foreach ($content_all as $type_value){
								$conditon = array("Hotfixtype.hotfix_type_name" => $this->Lv->spec_char_dbm($type_value));
								$r_type = $this->Hotfixtype->findAll($conditon,null,null,'0',null,null);
								if(count($r_type) > 0){
									$result_type_id = $r_type[0]['Hotfixtype']['id'];
								}else{
									$this->Hotfixtype->saveField('hotfix_type_name', $this->Lv->spec_char_dbm($type_value));
									$result_type_id = $this->Hotfixtype->getLastInsertID();	
								}
								
								$insertdate=Array(
									'Hotfix' => Array(
									            'hotfix_code' => $this->Lv->spec_char_dbm($value),
									            'hotfix_type_id' => $this->Lv->spec_char_dbm($result_type_id),
									            'hotfix_name' => $this->Lv->spec_char_dbm($addname)
									)
								);
								$this->Hotfix->save($insertdate);
							}
							$this->index_list(array(),1);
							//$this->render('index');
  							exit();
					}		

 		}
 		$this->render('edit');
  		exit();
				
  	}
}
?>