<?php
/*********************************************************************
*@filename system_all_manages_controller.php
*@description
*@note
*@histories  rivision	author		date		comment
*            1.0        xinw        2008/11/18  modify for LV20R1-167
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        yaozl        2009/09/22   modify for JL-0042
*            2.0        yaozl        2009/09/23   modify for JL-0041
********************************************************************/
class SystemAllManagesController extends AppController{
    var $helpers = array('Html', 'Javascript', 'Ajax', 'Lv','Form');
    var $components = array ('Lv','Check');
    var $uses=array('Addition','Hstadt','Hstalthrd','Validation');
    var $layout='system';
    var $hadtemptable = false;
    function beforeFilter(){
        parent :: beforeFilter();
    }
    function index()
    {
//    	$this->redirect("/system_all_manages/manage");
    	$this->set("manage", $this->requestAction("/system_all_manages/manage", array("return"))) ;
    	$this->layout = "system";
    	$this->pageTitle = __('title',$return = true);  
    }
    //ASSSETS MANAGEMENT
    function manage($depand=null,$tag=null){
        $errorMessage=array();
        $this->layout='ajax';
        $data= $this->Addition->findAll();
        $number=count($data)+1;
        //add assets
        if($depand=='1'){
        	   //yaozl start 2009/09/23 added for JL-0041
        	   $this->data['Addition']['addcontent'] = eregi_replace("　", " ", $this->data['Addition']['addcontent']);
            $this->data['Addition']['addcontent'] = trim($this->data['Addition']['addcontent'], " ");
            //yaozl end 2009/09/23 added for JL-0041
            if($this->data['Addition']['addcontent']!=""&&$this->Validation->maxLength($this->data['Addition']['addcontent'],200)){
                //yaozl start 2009/09/23 modify for JL-0041
                //$condition="addition_content ='".$this->data['Addition']['addcontent']."'";
                $condition= $this->data['Addition']['addcontent'] == "NULL" ? "addition_content is NULL" : "addition_content = '".$this->Lv->spec_char_dbm($this->data['Addition']['addcontent'])."'";
                //yaozl end 2009/09/23 modify for JL-0041
                $result =$this->Addition->findAll($condition,null,null,'0',null,null);
                if($number<=10&&empty($result)){
//                    echo "<pre>";
//                    var_dump($this->data);exit;
                    if($this->data['Addition']['check']=='1'){
                        $flg1='1';
                    }
                    else{
                        $flg1='0';
                    }
                    $flg1=$this->data['Addition']['check'];
                    if($this->data['Addition']['radio']=='0'){
                        $flg2='00';
                    }
                    else{
                        $flg2='10';
                    }
                    $flg=bindec($flg1.$flg2);
                    $addaddition=Array(
                    'Addition' => Array(
                    'addition_name' => 'option'.$number,
                    //yaozl start 2009/09/23 modify for JL-0041
                    //'addition_content' =>$this->data['Addition']['addcontent'],
                    'addition_content' =>trim( $this->Lv->spec_char_dbm($this->data['Addition']['addcontent']), " "),
                    //yaozl end 2009/09/23 modify for JL-0041
                    'display' =>$flg,
                    )
                    );
                    $this->Addition->save($addaddition);
                }
                else if($number>10){
                   //xushanning start 2009/04/22   modify for LogvillageChinese
                    //$errorMessage['asset_show_set'][] = 'assets_10';
                    $errorMessage['computer_list'][] = 'assets_10';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }
                else if(!empty($result)){
                    //xushanning start 2009/04/22   modify for LogvillageChinese
                    //$errorMessage['asset_show_set'][] = 'E-01900';
                    $errorMessage['computer_list'][] = 'E-01900';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }
            }
            else{
                $errorMessage=array();
                if($this->data['Addition']['addcontent']==""){
                    //xushanning start 2009/04/22   modify for LogvillageChinese
                    //if(@ !in_array('E-00100',$errorMessage['asset_show_set']))
                    //$errorMessage['asset_show_set'][] = 'E-00100';
                    if(@ !in_array('E-00100',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00100';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }
                if(!$this->Validation->maxLength($this->data['Addition']['addcontent'],200)){
                    //xushanning start 2009/04/22   modify for LogvillageChinese
                    //if(@ !in_array('E-00300',$errorMessage['asset_show_set']))
                    //$errorMessage['asset_show_set'][] = 'E-00300';
                    if(@ !in_array('E-00300',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00300';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }
            }
        }
        //assets setting
        else if($depand=='2'){
            //yaozl start 2009/09/23 added for JL-0041
            $this->data['Addition']['content_'.$tag] = eregi_replace("　", " ", $this->data['Addition']['content_'.$tag]);
            $this->data['Addition']['content_'.$tag] = trim($this->data['Addition']['content_'.$tag], " ");
            //yaozl end 2009/09/23 added for JL-0041
            if($this->data['Addition']['content_'.$tag]!=""&&$this->Validation->maxLength($this->data['Addition']['content_'.$tag],200)){
                //yaozl start 2009/09/23 modify for JL-0041
                //$condition="addition_content ='".$this->data['Addition']['content_'.$tag]."' and id!=".$tag;
                $condition= $this->data['Addition']['content_'.$tag] == "NULL" ? "addition_content is NULL and id!=".$tag : "addition_content = '".$this->data['Addition']['addcontent']."' and id!=".$tag;
                //yaozl end 2009/09/23 modify for JL-0041
                $result =$this->Addition->findAll($condition,null,null,'0',null,null);
//                echo "<pre>";
//                var_dump($this->data);
                if(empty($result)){
                    if(isset($this->data['Addition']['check_'.$tag])){
                        $flg1='1';
                    }
                    else{
                        $flg1='0';
                    }
                    if(isset($this->data['Addition']['radio_'.$tag])){
                        $flg2='10';
                    }
                    else{
                        $flg2='00';
                    }
                    $flg=bindec($flg1.$flg2);

                    $updateaddition=Array(
                    'Addition' => Array(
                    'id' => $tag,
                    //yaozl start 2009/09/23 modify for JL-0041
                    //'addition_content' =>$this->data['Addition']['content_'.$tag],
                    'addition_content' =>trim( $this->Lv->spec_char_dbm($this->data['Addition']['content_'.$tag]), " "),
                    //yaozl end 2009/09/23 modify for JL-0041
                    'display' =>$flg,
                    )
                    );
                    $this->Addition->save($updateaddition);
                }
                else{
                    //xushanning start 2009/04/22   modify for LogvillageChinese
                    //$errorMessage['asset_show_set'][] = 'E-01900';
                    $errorMessage['computer_list'][] = 'E-01900';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }

            }
            else{
                $errorMessage=array();
                if($this->data['Addition']['content_'.$tag]==""){
                    //xushanning start 2009/04/22   modify for LogvillageChinese
                    //if(@ !in_array('E-00100',$errorMessage['asset_show_set']))
                    //$errorMessage['asset_show_set'][] = 'E-00100';
                    if(@ !in_array('E-00100',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00100';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }
                if(!$this->Validation->maxLength($this->data['Addition']['content_'.$tag],200)){
                   //xushanning start 2009/04/22   modify for LogvillageChinese
                    //if(@ !in_array('E-00300',$errorMessage['asset_show_set']))
                    //$errorMessage['asset_show_set'][] = 'E-00300';
                    if(@ !in_array('E-00300',$errorMessage['computer_list']))
                    $errorMessage['computer_list'][] = 'E-00300';
                    //xushanning end 2009/04/22   modify for LogvillageChinese
                }
            }
        }
        //delete assets
        else if($depand=='3'){
            $condition="id=".$tag;
            $result =$this->Addition->findAll($condition,null,null,'0',null,null);
            if(strlen($result[0]['Addition']['addition_name'])==7){
                $getid=intval(substr($result[0]['Addition']['addition_name'],6,1));
            }
            else{
                $getid=intval(substr($result[0]['Addition']['addition_name'],6,2));
            }
            $this->Addition->del($tag);
            //xinw start 20081118
			//modify for LV20R1-167
			$num =$this->Addition->findAll();
			if (count($num)==0) {
				$num_hst =$this->Hstadt->findAll();
				foreach ($num_hst as $temp)
				{
					$this->Hstadt->del($temp['Hstadt']['id']);
				}
			}
			//xinw end 20081118
            for($j=($getid+1);$j<$number;$j++){
                $condition2="addition_name='option".$j."'";
                $result2 =$this->Addition->findAll($condition2,null,null,'0',null,null);
                $del_update=Array(
                'Addition' => Array(
                'id' => $result2[0]['Addition']['id'],
                'addition_name' => 'option'.($j-1),
                )
                );
                $this->Addition->save($del_update);
            }
            $getdata =$this->Hstadt->findAll(null,null,null,'0',null,null);
            for($m=0;$m<count($getdata);$m++){
                for($j=$getid;$j<$number;$j++){
                    if($j==($number-1)){
                        $del_update=Array(
                        'Hstadt' => Array(
                        'id' => $getdata[$m]['Hstadt']['id'],
                        //xinw start 20081118
						//modify for LV20R1-167
						//'option'.$j => '',
						'option'.$j => 'NULL',
						//xinw end 20081118
                        )
                        );
                    }
                    else{
                        $del_update=Array(
                        'Hstadt' => Array(
                        'id' => $getdata[$m]['Hstadt']['id'],
                        //yaozl start 2009/09/22 modify for JL-0042
                        //'option'.$j => $getdata[$m]['Hstadt']['option'.($j+1)],
                        'option'.$j => empty($getdata[$m]['Hstadt']['option'.($j+1)]) ? NULL : $this->Lv->spec_char_dbm($getdata[$m]['Hstadt']['option'.($j+1)]),
                        //yaozl start 2009/09/22 modify for JL-0042
                        )
                        );
                    }
                    $this->Hstadt->save($del_update);
                }
            }

        }
        // alert setting
        else if($depand=='4'){
            if($this->data['Hstalthrd']['low']!=""&&$this->Validation->numeric($this->data['Hstalthrd']['low'])&&$this->Validation->maxLength($this->data['Hstalthrd']['low'],2)){
                $set_update=Array(
                'Hstalthrd' => Array(
                'id' =>1,
                'low' => $this->data['Hstalthrd']['low'],
                )
                );
                $this->Hstalthrd->save($set_update);
            }
            else{
                $errorMessage=array();
                if($this->data['Hstalthrd']['low']==""){
                    if(@ !in_array('E-00100',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00100';
                }
                else if(!$this->Validation->numeric($this->data['Hstalthrd']['low'])){
                	//xushanning start 2009/05/26   modify for LogvillageChinese
                    //if(@ !in_array('E-00500',$errorMessage['alert_depand']))
                    //$errorMessage['alert_depand'][] = 'E-00500';
                    if(@ !in_array('E-00600',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00600';
                    //xushanning end 2009/05/26   modify for LogvillageChinese
                }
                if(!$this->Validation->maxLength($this->data['Hstalthrd']['low'],2)){
                    if(@ !in_array('E-00300',$errorMessage['alert_depand']))
                    $errorMessage['alert_depand'][] = 'E-00300';
                }
            }
        }
        $set= $this->Hstalthrd->findAll();
        $this->set('set', $set);
        $data= $this->Addition->findAll();
        $this->set('data', $data);
        $this->set('errorMessage', $errorMessage);
    }
}
?>