<?php
/*********************************************************************
*@filename      system_all_procapps_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/08   modify for LV20R1-188
********************************************************************/
class SystemAllProcappsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Uselgcproc','Procapp','Validation','Application','Configure','Astsfw');
	var $layout='system';
	function beforeFilter(){
		parent::beforeFilter();
		$this->Configure->write('debug',3);
		if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	function index($type=null,$errorMessage=array()){
		$this->pageTitle = __('title',$return = true);

		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', 'forHideVar1=0&data%5BProcapp%5D%5Bapp_name%5D=&data%5BProcapp%5D%5Bproc_name%5D=&submitToSearch=%E7%B5%9E%E8%BE%BC%E3%81%BF&data%5BProcapp%5D%5Badd_app_name%5D=');
		}
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		$app_name="";
		$proc_name="";
		$condition = array('1 = 1');
		if($type!='kong'){
			if(!$this->Lv->is_empty($this->data['Procapp']['app_name'])){
				$app_name = $this->data['Procapp']['app_name'];
				//wangs start 20080202
				//$condition[] = "Application.application_name like '%".$app_name."%' ";
				$condition[] = " lower(Application.application_name) like '%".strtolower($this->Lv->spec_char_like($app_name))."%' ";
				//wangs end 20080202
			}
			if(!$this->Lv->is_empty($this->data['Procapp']['proc_name'])){
				$proc_name=$this->data['Procapp']['proc_name'];
				//wangs start 20080202
				//$condition[] = "Procapp.process_name like '%".$proc_name."%' ";
				$condition[] = " lower(Procapp.process_name) like '%".strtolower($this->Lv->spec_char_like($proc_name))."%' ";
				//wangs end 20080202
			}
		}
		else{
			if(!empty($errorMessage))
			$this->set('errorMessage',$errorMessage);
		}
		/*		if(!empty($condition)){
		$condition = substr($condition, 0, strlen($condition)-4);
		}*/
		if($type=='csv'){
			$this->csvdown($condition);
			exit;
		}
		$asso = array('Procapp : procapps : left' => array('Procapp.application_id = Application.id '), );
		//list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_prints/contro', 'modelClass'=>'Optprt', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		$result = $this->Application->findByAsso($condition, array('Procapp.id','Procapp.application_id','Procapp.process_name','Application.id','Application.application_name'), 'Application.id', null, null, $asso);
		//debug($result);
		$this->set('result',$result);
		$this->set('hiddenapp', $app_name);
		$this->set('hiddenproc', $proc_name);
		$this->_setByExtract('result',$result,'{n}.Application.application_name','{n}.Procapp.process_name');
		//	$this->set('result',$result);
	}
	function search($flag=null){
		$this->layout='ajax';

		if($flag==1){
			if(isset($this->data['Application']['id'])){
				$word_id  = $this->data['Application']['id'];
				foreach ($word_id as $check){
					$this->Application->del($check);
				}
			}
			else{
				$errorMessage['app_name']=array();
				if(!(in_array('E-00200',$errorMessage['app_name']))){
					$errorMessage['app_name'][] = array('E-00200');
					$this->set('errorMessage', $errorMessage);
				}
			}
		}else{
			$errorMessage['app_name']=array();
			$errorMessage['proc_name']=array();
			if(!($this->Validation->maxLength($this->data['Procapp']['app_name'],256))){
				if(!(in_array('E-00300',$errorMessage['app_name']))){
					$errorMessage['app_name'][] = array('E-00300');
					$this->set('errorMessage', $errorMessage);
				}
			}
			if(!($this->Validation->maxLength($this->data['Procapp']['proc_name'],260))){
				if(!(in_array('E-00300',$errorMessage['proc_name']))){
					$errorMessage['proc_name'][] = array('E-00300');
					$this->set('errorMessage', $errorMessage);
				}
			}
			if(!($this->Check->checkAllHalf($this->data['Procapp']['proc_name']))){
				if(!(in_array('E-00400',$errorMessage['proc_name']))){
					$errorMessage['proc_name'][] = array('E-00400');
					$this->set('errorMessage', $errorMessage);
				}
			}
		}
		if($flag=='csv'){
			$this->index('csv');
			exit;
		}
		else{
			$this->index();
		}
	}
	function _setByExtract($to, $from, $groupby1, $groupby2)
	{
		if(empty($from) || empty($to) || empty($groupby1) || empty($groupby2)){
			return false;
		}
		$keys = set :: extract($from, $groupby2);
		$vals = $from;
		$out = array();
		$group = Set::extract($from, $groupby1);
		if (!empty($group)) {
			$c = count($keys);
			for ($i = 0; $i < $c; $i++) {
				if(!isset($group[$i])) {
					$group[$i] = 0;
				}
				if (!isset($out[$group[$i]])) {
					$out[$group[$i]] = array();
				}
				$out[$group[$i]][$i] = $vals[$i];
			}
		}
		else {
			return false;
		}
		$this->set($to, $out);
		//debug($out);
		return $out;
	}
	function procset($flag=null,$app_id=null,$getdata=array(),$flag2=null)
	{
		$this->layout='ajax';
		$this->set('flag',$flag);
		$errorMessage['app_name']=array();
		if($flag2==1){
			$this->data=$getdata;
		}
		$result=array();
		if($flag==1){//////////////////////////update/////////////////////
			$condition = "Application.id=$app_id";
			$result = $this->Application->findAll($condition,null,null,'0',null,null);
			$this->set('result',$result);
			$app=$result[0]['Application']['application_name'];
			$condition = "Procapp.application_id=$app_id";
			$results = $this->Procapp->findAll($condition,null,null,'0',null,null);
			$this->set('result',$results);
			$this->set('app_id',$app_id);
			$this->set('app',$app);
		}
		else{///////////////////////addapp//////////////////////
			$app="";
			if(isset($this->data['Application']['application_name'])){
				$app =html_entity_decode(trim($this->data['Application']['application_name']));
			}elseif(isset($this->data['Procapp']['add_app_name'])){
				$app =trim($this->data['Procapp']['add_app_name']);
			}
			if($this->Lv->is_empty($app)){
				if($flag==2){
					if(!in_array('E-00200',$errorMessage['app_name'])){
						$errorMessage['app_name'][]=array('E-00200');
						$this->set('errorMessage',$errorMessage);
					}
				}else{
					if(!in_array('E-00100',$errorMessage['app_name'])){	
						$errorMessage['app_name'][]=array('E-00100');
						$this->set('errorMessage',$errorMessage);
					}
				}
			}
			//			if(!($this->Check->checkAllHalf($app))){
			//				if(!in_array('E-00400',$errorMessage['app_name'])){
			//					$errorMessage['app_name'][]=array('E-00400');
			//					$this->set('errorMessage',$errorMessage);
			//				}
			//			}
			if(!($this->Validation->maxLength($app,256))){
				if(!in_array('E-00300',$errorMessage['app_name'])){
					$errorMessage['app_name'][]=array('E-00300');
					$this->set('errorMessage',$errorMessage);
				}
			}
			if(empty($errorMessage['app_name'])){
				//wangs start 20080202
				//$condition="Application.application_name='$app'";
				$condition=" lower(Application.application_name)='".strtolower($this->Lv->spec_char_dbm($app))."'";
				//wangs end 20080202
				$result=$this->Application->findAll($condition,null,null,null,null,null);
				if(empty($result)){
					$insertdate=Array(
					'Application' => Array(
					'application_name' => $this->Lv->spec_char_dbm($app),
					)
					);
					//					debug($insertdate);
					$this->Application->save($insertdate);
					$app_last_id = $this->Application->getLastInsertID();
					$this->set('app_id',$app_last_id);
					$this->set('app',$app);
					if($flag2==1){
						return	$errorMessage;
						exit;
					}
				}
				else{
					if(!in_array('E-01900',$errorMessage['app_name'])){
						$errorMessage['app_name'][]=array('E-01900');
						if($flag2==1){
							return	$errorMessage;
							exit;
						}
						$this->set('errorMessage',$errorMessage);
						$this->index();
						$this->render('index');
						exit();
					}
				}
			}
			else{

				if($flag2==1){
					return	$errorMessage;
					exit;
				}

				else if($flag==2){
					$this->applist();
					$this->render('applist');
					exit();
				}else{
					$this->index();
					$this->render('index');
					exit();
				}
			}
		}
	}
	function applist() {
		$this->layout='ajax';
		//$condition=array('1=1');
		$hiddenapp = '';
		if(isset($this->data['Procapp']['search_app'])){
			$hiddenapp =$this->data['Procapp']['search_app'] ;
		}
		$errorMessage['app_name']=array();
		if(!($this->Validation->maxLength($hiddenapp,256))){
			if(!in_array('E-00300',$errorMessage['app_name'])){
				$errorMessage['app_name'][]=array('E-00300');
				$this->set('errorMessage',$errorMessage);
			}
		}
		//$hiddenapp = '';
		$this->set("hiddenapp",$hiddenapp);
		if(isset($hiddenapp)){
			//wangs start 20080202
			//$condition=array("Astsfw.software_name not in (select applications.application_name from applications)", "Astsfw.software_name like '%$hiddenapp%'","group by"=>" Astsfw.software_name");
			$condition=array("Astsfw.software_name not in (select applications.application_name from applications)", " lower(Astsfw.software_name) like '%".strtolower($this->Lv->spec_char_like($hiddenapp))."%'","group by"=>" Astsfw.software_name");
			//wangs end 20080202

		}else{
			$condition=array("Astsfw.software_name not in (select applications.application_name from applications)","group by"=>" Astsfw.software_name");

		}
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'sub_main', 'url'=>'/system_all_procapps/applist', 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findAll'), 'sortBy' => $this->Lv->sortBy('Astsfw.software_name'), 'ajaxFormId'=>'form1'));

		$result = $this->Astsfw->findAll($condition,'Astsfw.software_name', $order, $limit, $page, -1);
		//$this->set('count',$con = $this->Astsfw->findAll($condition,'count(*) as count', null, null, null, null));
		$this->set("result",$result);
	}

	function addproc($flag,$getdata=array(),$flag2=null){
		$this->layout='ajax';
		if($flag2==1){
			$this->data=$getdata;
		}
		if(isset($this->data['Procapp']['appid'])){
			$add_app_id=$this->data['Procapp']['appid'];
			//			echo $add_app_id;
		}
		if($flag==1){///add
			$errorMessage['proc_name']=array();
			if(isset($this->data['Procapp']['add_last_id'])){
				$add_app_id=$this->data['Procapp']['add_last_id'];
			}  elseif(isset($this->data['Procapp']['appid'])){
				$add_app_id=$this->data['Procapp']['appid'];
			}
			$app=trim($this->data['Procapp']['app_name']);
			$this->set('app',$app);
			$this->set('app_id',$add_app_id);
			$add_proc=trim($this->data['Procapp']['add_proc']);

			if($this->Lv->is_empty($add_proc)){
				if(!in_array('E-00100',$errorMessage['proc_name'])){
					$errorMessage['proc_name'][]=array('E-00100');
					$this->set('errorMessage',$errorMessage);
				}
			}
			if(!($this->Validation->maxLength($add_proc,260))){
				if(!in_array('E-00300',$errorMessage['proc_name'])){
					$errorMessage['proc_name'][]=array('E-00300');
					$this->set('errorMessage',$errorMessage);
				}
			}
			if(!$this->Check->checkAllHalf($add_proc)){
				if(!in_array('E-00400',$errorMessage['proc_name'])){
					$errorMessage['proc_name'][]=array('E-00400');
					$this->set('errorMessage',$errorMessage);
				}
			}
			//			if(empty($errorMessage['proc_name'])){
			//				$condition="process_name='.$add_proc'";
			//				$result = $this->Procapp->findAll($condition,null,null,'0',null,null);
			//				if(!empty($result)){
			//					if(!in_array('E-01900',$errorMessage['proc_name'])){
			//						$errorMessage['proc_name'][]=array('E-01900');
			//						$this->set('errorMessage',$errorMessage);
			//					}
			//				}
			//				else{
			//					if(empty($result)&&($add_proc != "")){
			//						$insertdate=Array(
			//						'Procapp' => Array(
			//						'application_id' => $add_app_id,
			//						'process_name'=>$add_proc
			//						)
			//						);
			//						$this->Procapp->save($insertdate);
			//					}
			//				}
			//			}
			if(empty($errorMessage['proc_name'])){
				//wangs start 20080202
				//$condition="process_name='$add_proc'";
				$condition="lower(process_name)='". strtolower($this->Lv->spec_char_dbm($add_proc))."'";
				//wangs end 20080202

				$result = $this->Procapp->findAll($condition,null,null,'0',null,null);
				if(!empty($result)){
					if(!in_array('E-01900',$errorMessage['proc_name'])){
						$errorMessage['proc_name'][]=array('E-01900');
						$this->set('errorMessage',$errorMessage);
					}
				}
				else{
					if(empty($result)&&($add_proc != "")){
						$insertdate=Array(
						'Procapp' => Array(
						'application_id' => $add_app_id,
						'process_name'=> $this->Lv->spec_char_dbm($add_proc)
						)
						);
						$this->Procapp->save($insertdate);
					}
				}
			}
			$condition="application_id=$add_app_id";
			$result=$this->Procapp->findAll($condition,null,null,'0',null,null);
			$this->set('result',$result);
			if($flag2==1){
				return  $errorMessage;
				exit;
			}

		}
		if($flag==0){//delete:
			$this->set('app_id',$add_app_id);
			$app=trim($this->data['Procapp']['app_name']);
			$this->set('app',$app);
			if(isset($this->data['Procapp']['id'])){
				$word_id  = $this->data['Procapp']['id'];
				//debug($word_id);
				foreach ($word_id as $check){
					$this->Procapp->del($check);
				}
			}
			else{
				$errorMessage['proc_name']=array();
				if(!in_array('E-00200',$errorMessage['proc_name'])){
					$errorMessage['proc_name'][]=array('E-00200');
					$this->set('errorMessage',$errorMessage);
				}
			}
			$condition="application_id=$add_app_id";
			$result=$this->Procapp->findAll($condition,null,null,'0',null,null);
			$this->set('result',$result);
		}
		if($flag==2){///////////add from proclist///////////////
			$errorMessage['proc_name']=array();
			$condition="application_id=$add_app_id";
			$result=$this->Procapp->findAll($condition,null,null,'0',null,null);
			if(empty($result)){
				$condition="id=$add_app_id";
				$result=$this->Application->findAll($condition,null,null,'0',null,null);
				//debug($result);
			}
			$app = $result[0]['Application']['application_name'];
			$app_id=$result[0]['Application']['id'];
			$this->set('app',$app);
			$this->set('app_id',$app_id);
			if(isset($this->data['Procapp']['proc_id'])){
				$word_id  = $this->data['Procapp']['proc_id'];
				foreach ($word_id as $check){
					$procname= $this->Lv->spec_char_dbm(trim($this->data['Procapp']['use_proc'.$check]));
					$app_list_id = $add_app_id;

					//$condition="application_id=$add_app_id and process_name = '$procname'";
					//$result=$this->Procapp->findAll($condition,null,null,'0',null,null);
					if(!empty($app_id)&&!empty($procname)){
						$insertdate=Array(
						'Procapp' => Array(
						'application_id' => $app_list_id,
						'process_name'=> $procname
						)
						);
						//debug($insertdate);
						$this->Procapp->save($insertdate);
						$condition="application_id=$add_app_id";
						$result=$this->Procapp->findAll($condition,null,null,'0',null,null);
						$this->set('result',$result);
					}
				}
			}
			else{
				if(!(in_array('E-00200',$errorMessage['proc_name']))){
					$errorMessage['proc_name'][] = array('E-00200');
					$this->set('errorMessage', $errorMessage);
					$this->proclist($add_app_id);
					$this->render('proclist');
					exit();
				}
			}
		}
		//$this->search();
	}
	function proclist($appid){
		$this->layout='ajax';
		$errorMessage['proc_name']=array();

		$condition="id=$appid";
		$result=$this->Application->findAll($condition,null,null,'0',null,null);
		$app = $result[0]['Application']['application_name'];

		if(isset($this->data['Procapp']['add_last_id'])){
			$add_last_id=$this->data['Procapp']['add_last_id'];
			//			echo "add_last_id=".$add_last_id;
		}  elseif(isset($this->data['Procapp']['add_id'])){
			$app_id=$this->data['Procapp']['add_id'];
			//			echo "app_id=".$app_id;
		}
		$this->set('appid',$appid);
		$this->set('app',$app);
		$hiddenproc="";
		if(isset($this->data['Procapp']['search_proc'])){
			$hiddenproc = $this->data['Procapp']['search_proc'];
		}
		if(!($this->Validation->maxLength($this->data['Procapp']['search_proc'],260))){
			if(!in_array('E-00300',$errorMessage['proc_name'])){
				$errorMessage['proc_name'][]=array('E-00300');
				$this->set('errorMessage',$errorMessage);
				$hiddenproc="";
			}
		}
		if(!$this->Check->checkAllHalf($this->data['Procapp']['search_proc'])){
			if(!in_array('E-00400',$errorMessage['proc_name'])){
				$errorMessage['proc_name'][]=array('E-00400');
				$this->set('errorMessage',$errorMessage);
				$hiddenproc="";
			}
		}

		$this->set('hiddenproc',$hiddenproc);
		//wangs start 20080202
		//$condition=array("Uselgcproc.process_name not in (select procapps.process_name from procapps)","Uselgcproc.process_name like '%$hiddenproc%'","group by"=>" Uselgcproc.process_name");
		$condition=array("Uselgcproc.process_name not in (select procapps.process_name from procapps)"," lower(Uselgcproc.process_name) like '%" . strtolower($this->Lv->spec_char_like($hiddenproc)). "%'","group by"=>" Uselgcproc.process_name");
		//wangs end 20080202
		//$result=$this->Uselgcproc->findAll($condition,'Uselgcproc.process_name', 'Uselgcproc.process_name', '0', null, null);
		list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'sub_main', 'url'=>'/system_all_procapps/proclist/'.$appid, 'modelClass'=>'Uselgcproc', 'queryType' => array('function' => 'findAll'), 'sortBy' => $this->Lv->sortBy('Uselgcproc.process_name'),'ajaxFormId'=>'form1'));
		$result = $this->Uselgcproc->findAll($condition,'Uselgcproc.process_name', $order, $limit, $page,-1);
		//$this->set('count',$con = $this->Uselgcproc->findAll($condition,'count(*) as count', null, null, null, null));
		$this->set('result',$result);
	}
	function csvdown($criteria=array("1=1")){
		require_once( 'csv/DlFactory.php' );
		$col=array('Procapp.process_name','Application.application_name','Application.id');
		$asso = array('Procapp : procapps : left' => array('Procapp.application_id = Application.id '), );
		$rows = $this->Application->findByAsso($criteria,$col, 'Application.id', 100000, 1, $asso);
		$i=0;
		foreach ($rows as $result){
			//	               	$rows[$i]['Application']['application_name']='"'.$rows[$i]['Application']['application_name'].'"';
			//	               	$rows[$i]['Procapp']['process_name']='"'.$rows[$i]['Procapp']['process_name'].'"';
			//ADD BY WQ 1008
			$rows[$i]['Application']['application_name']=$rows[$i]['Application']['application_name'];
			$rows[$i]['Procapp']['process_name']=$rows[$i]['Procapp']['process_name'];
			//ADD BY WQ 1008
			$i++;
		}
		$csv = DlFactory::create("system_all_procapps");
		$csv->sendCSVFile($rows,$this->data,__('endapplist',$return = true));
		exit;
	}
	function do_import()
	{
		require_once("csv_imports_controller.php");
		$hear_num = 1;
		$data = CsvImportsController :: do_import($hear_num);
		$errorMessage=array();
		$i=0;
		//xinw start 20081208
		//modify for LV20R1-188
		if (!in_array('error_csv',$data) && !in_array('error_format',$data)) {
		//xinw end 20081208
			foreach($data as $v){
				//xinw start 20081208
				//modify for LV20R1-188
				if (!isset($v[1]) || empty($v[1])) {
					$v[1]="";				
				}
				//xinw end 20081208
				$this->data['Procapp']['add_app_name']=$v[0];
				//xinw start 20081208
				//modify for LV20R1-188
				$this->data['Procapp']['add_proc']=$v[1];
				//xinw end 20081208
				//xinw start 20081208
				//modify for LV20R1-188
				//$errorMessage[$i]=$this->procset(3,null,null,$this->data,1);
				$errorMessage[$i]=$this->procset(3,null,$this->data,1);
				//xinw end 20081208
				if(empty($errorMessage[$i]['app_name'])){
					$this->data['Procapp']['add_proc']=$v[1];
					$this->data['Procapp']['app_name']=$v[0];
					$this->data['Procapp']['add_last_id']= $this->Application->getLastInsertID();
					$errorMessage[$i]=$this->addproc(1,$this->data,1);
				}
				else if(@in_array(array('E-01900'),$errorMessage[$i]['app_name'])){
					$this->data['Procapp']['add_proc']=$v[1];
					$this->data['Procapp']['app_name']=$v[0];
					//wangs start 20080202
					//$condition="Application.application_name='".$v[0]."'";
					$condition=" lower(Application.application_name)='".strtolower($v[0])."'";
					//wangs end 20080202

					$result=$this->Application->findAll($condition,null,null,null,null,null);
					$this->data['Procapp']['add_last_id']=$result[0]['Application']['id'];
					$errorMessage[$i]=$this->addproc(1,$this->data,1);
				}
				//xinw start 20081208
				//modify for LV20R1-188
				$errorMessage[$i]['content']=$v[0].",".$v[1];
				//xinw end 20081208
				$i++;
			}
		//xinw start 20081208
		//modify for LV20R1-188
		}
		//xinw end 20081208
		$datas=array();
		//xinw start 20081208
		//modify for LV20R1-188
/*		foreach($errorMessage as $result){
			if(isset($result['app_name'])){
				foreach($result['app_name'] as $error){
					if(@!in_array($error,$datas['app_name'])){
						$datas['app_name'][]=$error;
					}
				}
			}
			if(isset($result['proc_name'])){
				foreach($result['proc_name'] as $error){
					if(@!in_array('E-00300',$datas['proc_name'])){
						if(@!in_array($error,$datas['proc_name'])){
							$datas['proc_name'][]=$error;
						}
					}
				}
			}
		}*/
		$datas=$errorMessage;
		$this->set('type','import');
		//xinw end 20081208
		$this->index('kong',$datas);
		$this->layout='system';
		$this->render("index");
		exit();
	}
}
?>