<?php
/*********************************************************************
*@filename 		system_grpset_alert_apps_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhy              2009/03/04   modify for JLN-001
*            2.0        xushanning  2009/04/23   modify for LogvillageChinese
*            2.0        sunhy              2009/05/20   modify for YBR-32
*            2.0       yuanxiaojun       2009/06/30	   modify for JL-0028
*            2.0        yzl        2009/07/06    modify for JL-0032
*            2.0        sunhy       2009/07/15    modify for YBR-40
*            2.0        sunhuiyan         2009/07/15   modify for YBR-41
*            2.0        sunhy    	  2009/07/25 modify for JL-0035
*            2.0        sunhy    	  2009/10/23 modify for JL-0046
*            2.0        sawaki       2009/11/13   modify for ポップアップを表示させない。
********************************************************************/
class SystemGrpsetAlertAppsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');

	//sunhy start 2009/03/04 modify for JLN-001
	//var $components = array ('Pagination', 'Lv', 'GenerateFiles');
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'MailPopupController','AlertPcController');
	//sunhy end 2009/03/04 modify for JLN-001
	var $uses=array('Grpalt','Rltgrpaltapp','Grpaltapp','Hstaltapp','Group', 'Host','Configure','Grpauth','Mail','Rlthstgrp','User','Validation','Astsfw','Poll','Title','Altmsg','Hstaltatoapp');
	var $layout='system';
	function beforeFilter(){
		parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	function index()
	{
		$this->pageTitle = __('title',$return = true);
		$own_group_id = $this->_getUserGroup();
		$glist = $this->Group->getChildrenByParent($own_group_id);
		$this->set('glist',$glist);
		$glist2 = $this->Grpauth->getChildrenByParent($own_group_id);
		$plist = $this->Grpauth->getParentsByChild($own_group_id);
		$flist = array();
		foreach ($plist as $group_id=>$group_name){
			if($group_id <> $own_group_id){
				$flist[$group_id] = $group_name;
			}
		}
		foreach ($flist as $key=>$value){
			$criteria = " Grpalt.type = 10 AND Group.id = $key";
			$grp_alt = $this->Grpalt->findAll($criteria,'Grpalt.mail_notice,Grpalt.mail_notice_time,Grpalt.popup');
			$condition_grp = "Rltgrpaltapp.group_id = $key AND Rltgrpaltapp.org_grp_id = $key";
			$grp_app = $this->Grpaltapp->findAll($condition_grp,'Grpaltapp.id,Grpaltapp.app_name,Grpaltapp.app_status','Grpaltapp.id');
			$condition_hst = array("Rlthstgrp.group_id = $key");
			$asso = array(
			'Host : hosts' => array(
			'Hstaltapp.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			);
			$hst_app = $this->Hstaltapp->findByAsso($condition_hst, array('Hstaltapp.id as Hstaltapp__id,Host.host_name as Host__host_name,Hstaltapp.app_name as Hstaltapp__app_name,Hstaltapp.app_status as Hstaltapp__app_status'), 'Hstaltapp.id', null, null, $asso);
			$apps = array();
			for($i=0;$i<count($grp_app);$i++){
				$apps[$i]['Altapp']['app_name'] = $grp_app[$i]['Grpaltapp']['app_name'];
				$apps[$i]['Altapp']['host_name'] = __('whole',$return = true);      //すべて
				$apps[$i]['Altapp']['app_status'] = $grp_app[$i]['Grpaltapp']['app_status'];
			}
			$count = count($grp_app)+count($hst_app);
			for($i=count($grp_app);$i<$count;$i++){
				$j = $i-count($grp_app);
				$apps[$i]['Altapp']['app_name'] = $hst_app[$j]['Hstaltapp']['app_name'];
				$apps[$i]['Altapp']['host_name'] = $hst_app[$j]['Host']['host_name'];
				$apps[$i]['Altapp']['app_status'] = $hst_app[$j]['Hstaltapp']['app_status'];
			}
			if ($count==0){
				$count=1;
			}
			if(!empty($grp_alt)){
				if(empty($apps)){
					$undata[$key]['Grpalt']['count'] = $count;
					$undata[$key]['Group']['group_name'] = $value;
					$undata[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
					if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
						$undata[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
					}
					$undata[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
					$undata[$key]['Altapp'][] = array();
				}
				else {
					foreach ($apps as $app){
						$undata[$key]['Grpalt']['count'] = $count;
						$undata[$key]['Group']['group_name'] = $value;
						$undata[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
							$undata[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$undata[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
						$undata[$key]['Altapp'][] = $app['Altapp'];
					}
				}
			}
		}
		foreach ($glist2 as $key=>$value){
			$criteria = " Grpalt.type = 10 AND Group.id = $key";
			$grp_alt = $this->Grpalt->findAll($criteria,'Grpalt.mail_notice,Grpalt.mail_notice_time,Grpalt.popup');
			$condition_grp = "Rltgrpaltapp.group_id = $key AND Rltgrpaltapp.org_grp_id = $key";
			$grp_app = $this->Grpaltapp->findAll($condition_grp,'Grpaltapp.id,Grpaltapp.app_name,Grpaltapp.app_status','Grpaltapp.id');
			$condition_hst = array("Rlthstgrp.group_id = $key");
			$asso = array(
			'Host : hosts' => array('Hstaltapp.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			);
			$hst_app = $this->Hstaltapp->findByAsso($condition_hst, array('Hstaltapp.id as Hstaltapp__id,Host.host_name as Host__host_name,Hstaltapp.app_name as Hstaltapp__app_name,Hstaltapp.app_status as Hstaltapp__app_status'), 'Hstaltapp.id', null, null, $asso);
			$apps = array();
			for($i=0;$i<count($grp_app);$i++){
				$apps[$i]['Altapp']['app_name'] = $grp_app[$i]['Grpaltapp']['app_name'];
				$apps[$i]['Altapp']['host_name'] = __('whole',$return = true);      //すべて
				$apps[$i]['Altapp']['app_status'] = $grp_app[$i]['Grpaltapp']['app_status'];
			}
			$count = count($grp_app)+count($hst_app);
			for($i=count($grp_app);$i<$count;$i++){
				$j = $i-count($grp_app);
				$apps[$i]['Altapp']['app_name'] = $hst_app[$j]['Hstaltapp']['app_name'];
				$apps[$i]['Altapp']['host_name'] = $hst_app[$j]['Host']['host_name'];
				$apps[$i]['Altapp']['app_status'] = $hst_app[$j]['Hstaltapp']['app_status'];
			}
			if ($count==0){
				$count=1;
			}
			if(!empty($grp_alt)){
				if(empty($apps)){
					$data[$key]['Grpalt']['count'] = $count;
					$data[$key]['Group']['group_name'] = $value;
					$data[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
					if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
						$data[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
					}
					$data[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
					$data[$key]['Altapp'][] = array();
				}
				else {
					foreach ($apps as $app){
						$data[$key]['Grpalt']['count'] = $count;
						$data[$key]['Group']['group_name'] = $value;
						$data[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
							$data[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$data[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
						$data[$key]['Altapp'][] = $app['Altapp'];
					}
				}
			}
		}
		empty($undata)? $undata=array():$undata;
		empty($data)? $data=array():$data;
		$this->set('undata',$undata);
		$this->set('data',$data);
	}
	function delete($jude = null)
	{
		$this->layout = 'ajax';
		if($jude == 1){
			if(isset($this->data['Grpalt']['group_id'])){
				foreach ($this->data['Grpalt']['group_id'] as $group_id){
					$condition_alt = "Grpalt.group_id = $group_id AND Grpalt.type = 10";
					$grpalt_id = $this->Grpalt->findAll($condition_alt,'Grpalt.id');
					foreach ($grpalt_id as $output){
						//$grpalt_del[] = $output['Grpalt']['id'];
						$this->Grpalt->del($output['Grpalt']['id']);
					}
					$condition_grp = "Rltgrpaltapp.group_id = $group_id AND Rltgrpaltapp.org_grp_id = $group_id";
					$grpapp_id = $this->Grpaltapp->findAll($condition_grp,'Grpaltapp.id,Grpaltapp.app_name');
					foreach ($grpapp_id as $output){
						//$grpapp_del[] = $output['Grpaltapp']['id'];
						//=================================================================by zhangying 2007.11.4 start
						$asso = array(
						'Rlthstgrp : rlthstgrps' => array('Hstaltatoapp.host_id = Rlthstgrp.host_id'),
						'Grpauth : grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'),
						);
						$delgrp_id = $this->Hstaltatoapp->findByAsso(array("Grpauth.org_grp_id = $group_id and Hstaltatoapp.app_name = '".$this->Lv->spec_char_dbm($output['Grpaltapp']['app_name'])."'"),array("Hstaltatoapp.id as Hstaltatoapp__id"),null,null,null,$asso);
						foreach ($delgrp_id as $del_id){
							$this->Hstaltatoapp->save(array("Hstaltatoapp" => array("id"=>$del_id['Hstaltatoapp']['id'], "del_flg" => 0)));
						}
						//=================================================================by zhangying 2007.11.4 end
						$this->Grpaltapp->del($output['Grpaltapp']['id']);
					}
					$condition_hst = array("Rlthstgrp.group_id = $group_id");
					$asso = array(
					'Host : hosts' => array('Hstaltapp.host_id = Host.id'),
					'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
					);
					$hstapp_id = $this->Hstaltapp->findByAsso($condition_hst, array('Hstaltapp.id as Hstaltapp__id,Hstaltapp.app_name as Hstaltapp__app_name,Hstaltapp.host_id as Hstaltapp__host_id'),null,null,null,$asso);
					foreach ($hstapp_id as $output){
						//$hstapp_del[] = $output['Hstaltapp']['id'];
						$hst_id[] = $output['Hstaltapp']['host_id'];
						$ato_hstid = $output['Hstaltapp']['host_id'];
						//=================================================================by zhangying 2007.11.4 start
						$delhost_id = $this->Hstaltatoapp->findAll("Hstaltatoapp.host_id = $ato_hstid and Hstaltatoapp.app_name = '".$this->Lv->spec_char_dbm($output['Hstaltapp']['app_name'])."'","Hstaltatoapp.id",null,null,null,null);
						foreach ($delhost_id as $del_id){
							$this->Hstaltatoapp->save(array("Hstaltatoapp" => array("id" =>$del_id['Hstaltatoapp']['id'], "del_flg" => 0)));
						}
						//=================================================================by zhangying 2007.11.4 end
						$this->Hstaltapp->del($output['Hstaltapp']['id']);
					}
					//sunhy start 2009/05/21 added for YBR-32
					//empty($grpalt_del)?null:$this->Grpalt->del(array($grpalt_del));
					//empty($grpapp_del)?null:$this->Grpaltapp->del(array($grpapp_del));
					//empty($hstapp_del)?null:$this->Hstaltapp->del(array($hstapp_del));
					//sunhy    start  2009/07/25 modify for JL-0035
					$this->MailPopupController->delAltMsg("E0007", $group_id);
					$this->MailPopupController->delAltTit(10, $group_id);
					//sunhy    end  2009/07/25 modify for JL-0035
					$this->GenerateFiles->hook_by_group($group_id, array('appli'));  															//sunhy end 2009/05/21 added for YBR-32
				}
				//sunhy start 2009/05/21 delete for YBR-32
				//empty($grpalt_del)?null:$this->Grpalt->del(array($grpalt_del));
				//empty($grpapp_del)?null:$this->Grpaltapp->del(array($grpapp_del));
				//empty($hstapp_del)?null:$this->Hstaltapp->del(array($hstapp_del));

				//$this->GenerateFiles->hook_by_group($this->data['Grpalt']['group_id'], array('appli'));
				//sunhy end 2009/05/21 delete for YBR-32
				//sunhy start 2009/05/21 modify for YBR-32
				//empty($hst_id)?null:$this->GenerateFiles->hook_by_host($hst_id, array('appli'));
				empty($hst_id)?null:$this->GenerateFiles->hook_by_host($hst_id, array('appli'), $group_id);
				//sunhy end 2009/05/21 modify for YBR-32
			}
			else{
				//xushanning start 2009/04/23   modify for LogvillageChinese
				//$errorMessage['Group'][] = 'E-00200';
				$errorMessage['entry'][] = 'E-00200';
				//xushanning end 2009/04/23   modify for LogvillageChinese
				$this->set('errorMessage',$errorMessage);
			}
			$this->index();
			$this->render('index');
		}
		if($jude == 2){
			if(isset($this->data['Altapp']['id'])){
				$group_id = $this->data['Group']['group_id'];
				$file_hst = array();
				foreach ($this->data['Altapp']['id'] as $id){
					if ($id{0} == 'g'){
						$grp_id = substr($id, 1);
						//=================================================================by zhangying 2007.11.4 start
						$condition_atogrp = "Grpaltapp.id = $grp_id";
						$output = $this->Grpaltapp->find($condition_atogrp,'Grpaltapp.app_name');
						$asso = array(
						'Rlthstgrp : rlthstgrps' => array('Hstaltatoapp.host_id = Rlthstgrp.host_id'),
						'Grpauth : grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'),
						);
						if ($output){
							$delgrp_id = $this->Hstaltatoapp->findByAsso(array("Grpauth.org_grp_id = $group_id and Hstaltatoapp.app_name = '".$this->Lv->spec_char_dbm($output['Grpaltapp']['app_name'])."'"),array("Hstaltatoapp.id as Hstaltatoapp__id"),null,null,null,$asso);
							foreach ($delgrp_id as $del_id){
								$this->Hstaltatoapp->save(array("Hstaltatoapp" => array("id"=>$del_id['Hstaltatoapp']['id'], "del_flg" => 0)));
							}
						}
						$this->Grpaltapp->del($grp_id);
						//=================================================================by zhangying 2007.11.4 end
					}
					else{
						$hst_id = substr($id, 1);
						$host_id = $this->Hstaltapp->find("Hstaltapp.id = $hst_id",'Hstaltapp.host_id,Hstaltapp.app_name');
						$file_hst[] = $host_id['Hstaltapp']['host_id'];
						$this->Hstaltapp->del($hst_id);
						//=================================================================by zhangying 2007.11.4 start
						$ato_hstid = $host_id['Hstaltapp']['host_id'];
						$delhost_id = $this->Hstaltatoapp->findAll("Hstaltatoapp.host_id = $ato_hstid and Hstaltatoapp.app_name = '".$this->Lv->spec_char_dbm($host_id['Hstaltapp']['app_name'])."'","Hstaltatoapp.id",null,null,null,null);
						foreach ($delhost_id as $del_id){
							$this->Hstaltatoapp->save(array("Hstaltatoapp" => array("id" =>$del_id['Hstaltatoapp']['id'], "del_flg" => 0)));
						}
						//=================================================================by zhangying 2007.11.4 end
					}
				}
				empty($group_id)?null:$this->GenerateFiles->hook_by_group($group_id, array('appli'));
				//sunhy start 2009/05/21 modify for YBR-32
				//empty($file_hst)?null:$this->GenerateFiles->hook_by_host($file_hst, array('appli'));
				empty($file_hst)?null:$this->GenerateFiles->hook_by_host($file_hst, array('appli'), $group_id);
				//sunhy end 2009/05/21 modify for YBR-32
			}
			else{
				//xushanning start 2009/04/23   modify for LogvillageChinese
				//$errorMessage_middle['application_info'][] = 'E-00200';
				$errorMessage_middle['entry'][] = 'E-00200';
				//xushanning end 2009/04/23   modify for LogvillageChinese
				$this->set('errorMessage_middle',$errorMessage_middle);
			}
			//xinw start 20090209
			//modify for ASP4-031
			//$this->set_alert();
			$this->set_alert(null,'nodo');
			//xinw end 20090209
			$this->render('set_alert');
		}
		if($jude == 3){
			$group_id = $this->data['Group']['group_id'];
			if (isset($this->data['Grpaltapp']['app'])){
				$app_name = $this->data['Grpaltapp']['app'];
			}
			else{
				$app_name = null;
			}
			if(isset($this->data['Astsfw']['id'])){
				$this->Astsfw->del(array($this->data['Astsfw']['id']));
			}
			else{
				$errorMessage['application_info'][] = 'E-00200';
				$this->set('errorMessage',$errorMessage);
			}
			$this->application($group_id,$app_name);
			$this->render('application');
		}
		if($jude == 4){
			$group_id = $this->data['Group']['group_id'];
			if (isset($this->data['Hstaltapp']['app'])){
				$app_name = $this->data['Hstaltapp']['app'];
			}
			else{
				$app_name = null;
			}
			if (isset($this->data['Hstaltapp']['host'])){
				$host_name = $this->data['Hstaltapp']['host'];
			}
			else{
				$host_name = null;
			}
			if(isset($this->data['Astsfw']['id'])){
				$this->Astsfw->del(array($this->data['Astsfw']['id']));
			}
			else{
				$errorMessage['client_pc'][] = 'E-00200';
				$this->set('errorMessage',$errorMessage);
			}
			$this->client_pc($group_id,$app_name,$host_name);
			$this->render('client_pc');
		}
	}
	//xinw start 20090203
	//modify for ASP4-031
	//function set_alert($group_id = null)
	function set_alert($group_id = null,$do=null)
	//xinw end 20090203
	{
		//xinw start 20090203
		//modify for ASP4-031
		if ($group_id=='null') {
			$group_id=null;
		}
		//xinw end 20090203
		$this->layout = 'ajax';
		if(empty($group_id)){
			$group_id = $this->data['Group']['group_id'];
		}
		$own_group_id = $this->_getUserGroup();
		$this->set('own_group_id',$own_group_id);
		$condition = "Group.id = $group_id";
		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
		$this->set('group',$group);

		//sunhy start 2009/03/30 added for JLN-001
		$getUserGroup = $this->_getUserGroup();
		//		$getUserGroup = 1;
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/30 added for JLN-001

		$plist = $this->Grpauth->getParentsByChild($group_id);
		$data=array();
		foreach ($plist as $key=>$value){
			$condition_grp = "Rltgrpaltapp.group_id = $key AND Rltgrpaltapp.org_grp_id = $key";
			$grp_app = $this->Grpaltapp->findAll($condition_grp,'Grpaltapp.id,Grpaltapp.app_name,Grpaltapp.app_status','Grpaltapp.id');
			$condition_hst = array("Rlthstgrp.group_id = $key");
			$asso = array(
			'Host : hosts' => array('Hstaltapp.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			);
			$hst_app = $this->Hstaltapp->findByAsso($condition_hst, array('Hstaltapp.id as Hstaltapp__id,Host.host_name as Host__host_name,Hstaltapp.app_name as Hstaltapp__app_name,Hstaltapp.app_status as Hstaltapp__app_status'), 'Hstaltapp.id', null, null, $asso);
			$app = array();
			for($i=0;$i<count($grp_app);$i++){
				$app[$i]['Altapp']['grp_id'] = $grp_app[$i]['Grpaltapp']['id'];
				$app[$i]['Altapp']['app_name'] = $grp_app[$i]['Grpaltapp']['app_name'];
				$app[$i]['Altapp']['host_name'] = __('whole',$return = true);      //すべて
				$app[$i]['Altapp']['app_status'] = $grp_app[$i]['Grpaltapp']['app_status'];
			}
			$count = count($grp_app)+count($hst_app);
			for($i=count($grp_app);$i<$count;$i++){
				$j = $i-count($grp_app);
				$app[$i]['Altapp']['hst_id'] = $hst_app[$j]['Hstaltapp']['id'];
				$app[$i]['Altapp']['app_name'] = $hst_app[$j]['Hstaltapp']['app_name'];
				$app[$i]['Altapp']['host_name'] = $hst_app[$j]['Host']['host_name'];
				$app[$i]['Altapp']['app_status'] = $hst_app[$j]['Hstaltapp']['app_status'];
			}
			if(!empty($app)){
				$data[$key] = $app;
			}
		}
		$this->set('data',$data);

		//sunhy start 2009/05/20 modify for YBR-32
		//$title= $this->Title->find("Title.type = 10");
		$title= $this->Title->find("Title.type = 10 and group_id=".$group_id);
		//sunhy end 2009/05/20 modify for YBR-32
		if (!isset($this->data['Title']['id'])){
			if($title['Title']['title_flg'] == 0){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = 0;
			}
		}
		$this->data['Title']['id'] = $title['Title']['id'];

		//sunhy start 2009/03/04 modify for JLN-001
		//$msg= $this->Altmsg->find("Altmsg.message_id = 'E0007'");
		//sunhy start 2009/05/20 modify for YBR-32
		//$msg = $this->MailPopupController->getAltMsg('E0007');
		$msg = $this->MailPopupController->getAltMsg('E0007', $group_id);
		//sunhy end 2009/05/20 modify for YBR-32
		//sunhy end 2009/03/04 modify for JLN-001
		if (!isset($this->data['Altmsg']['id'])){
			//sunhy start 2009/03/04 modify for JLN-001
			/*if($msg['Altmsg']['detail_flg'] == 0){
			$this->data['Altmsg']['detail_flg'] = 1;
			}
			else {
			$this->data['Altmsg']['detail_flg'] = 0;
			}*/
			if($msg['Altmsg']['detail_flg'] == 0){
				$this->data['Altmsg']['detail_flg'] = 0;
			}
			else {
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//sunhy start 2009/05/20 added for YBR-32
			if($msg['Altmsg']['detail_flg']== ""){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//sunhy end 2009/05/20 added for YBR-32
			//sunhy end 2009/03/04 modify for JLN-001
			//sunhy start 2009/05/20 modify for YBR-32
			//$this->data['Altmsg']['message'] = $msg['Altmsg']['message'];
			$this->data['Altmsg']['message'] = empty($msg['Altmsg']['message']) ? __('E0007',$return = true) : $msg['Altmsg']['message'];
			//sunhy end 2009/05/20 modify for YBR-32
		}
		$this->data['Altmsg']['id'] = $msg['Altmsg']['id'];
		$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 10";
		//sunhy start 2009/03/04 modify for JLN-001
		//$value = $this->Grpalt->find($condition);
		$value = $this->MailPopupController->getMailPop('Grpalt', $condition);
		//sunhy end 2009/03/04 modify for JLN-001
		if($value){
			if (!isset($this->data['Grpalt']['id'])){
				$this->data['Grpalt']['mail_notice'] = $value['Grpalt']['mail_notice'];
				$this->data['Grpalt']['mail_notice_time'] = $value['Grpalt']['mail_notice_time'];
				$this->data['Grpalt']['popup'] = $value['Grpalt']['popup'];
				if($value['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}
			}
			$this->data['Grpalt']['id'] = $value['Grpalt']['id'];
		}
		else{
			//sunhy start 2009/03/04 modify for JLN-001
			/*$add = array(
			'Grpalt' => array(
			'group_id' => $group_id,
			'mail_notice' => 1,
			'mail_notice_time' => '00:00:00',
			'receive' => 1,
			'popup' => 0,
			'type' => 10,
			)
			);
			//xinw start 20090203
			//modify for ASP4-031
			//$this->Grpalt->save($add);
			if ($do=='nodo') {
			$this->data['Grpalt']['mail_notice']=1;
			}else
			{
			$this->Grpalt->save($add);
			}
			//xinw end 20090203*/
			if($do=='nodo'){
				$this->data['Grpalt']['mail_notice']=1;
			}
			else{
				//sunhy start 2009/07/15 modify for YBR-41
				//$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 1, null, 0, 10, 'Grpalt');
				//sunhy end 2009/07/15 modify for YBR-41
			}
			//sunhy end 2009/03/04 modify for JLN-001
			$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 10";
			//sunhy start 2009/03/04 modify for JLN-001
			//$value_1 = $this->Grpalt->find($condition);
			$value_1 = $this->MailPopupController->getMailPop('Grpalt', $condition);
			//sunhy end 2009/03/04 modify for JLN-001
			if($value_1){
				$this->data['Grpalt']['id'] = $value_1['Grpalt']['id'];
				$this->data['Grpalt']['mail_notice'] = $value_1['Grpalt']['mail_notice'];
				$this->data['Grpalt']['mail_notice_time'] = $value_1['Grpalt']['mail_notice_time'];
				$this->data['Grpalt']['popup'] = $value_1['Grpalt']['popup'];
				if($value_1['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}
			}
		}
		$condition = "User.group_id = $group_id";
		$mail = $this->User->findAll($condition,'Mail.mail_address');
		//sunhy start 2009/03/04 modify for JLN-001
		//$this->set('mail',$mail);
		$this->set('email',$mail);
		//sunhy end 2009/03/04 modify for JLN-001
		if(!$value){
			$group_array[]=$group_id;
			//			$group_array[]=1;
			//			$this->GenerateFiles->hook_by_group($group_array, array('appli'));
			//			$this->GenerateFiles->hook_by_group(1, array('popup'));
			//sunhy start 2009/05/20 modify for YBR-32
			//$this->GenerateFiles->hook_by_ps(0, array("appli", "popup"));
			// yzl start 2009/07/06 modify for JL-0032
			//$this->GenerateFiles->hook_by_group($group_id, array("appli", "popup"));
			if ($do != "nodo") {
				$this->GenerateFiles->hook_by_group($group_id, array("appli", "popup"));
			}
			// yzl end 2009/07/06 modify for JL-0032
			//sunhy end 2009/05/20 modify for YBR-32
		}
	}
	function none()
	{
		$this->layout = 'ajax';
		$this->data = array();
		$this->index();
		$this->render('index');
	}
	function add_alert()
	{
		$this->layout = 'ajax';
		$own_group_id = $this->_getUserGroup();
		//sunhy start 2009/05/20 added for YBR-32
		$group_id = $this->data['Group']['group_id'];
		//sunhy end 2009/05/20 added for YBR-32
		//sunhy start 2009/05/20 modify for YBR-32
		//if($own_group_id == 1){
		//sunhy end 2009/05/20 modify for YBR-32
		if($this->Lv->is_empty($this->data['Altmsg']['message']) || !$this->Validation->maxLength($this->data['Altmsg']['message'],2000)){
			if($this->Lv->is_empty($this->data['Altmsg']['message'])){
//start sawaki 20091113 modify for ポップアップを表示させない。
			//	$errorMessage['popup_info'][] = 'E-00100';
//end sawaki 20091113 modify for ポップアップを表示させない。
			}
			if(!$this->Validation->maxLength($this->data['Altmsg']['message'],2000)){
				$errorMessage['popup_info'][] = 'E-00300';
			}
		}
		if(isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);
			$this->set_alert();
			$this->render('set_alert');
			exit();
		}
		else{
			if($this->data['Grpalt']['mail_notice'] == 2){
				//sunhy start 2009/03/04 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Group']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
				'receive' => $this->data['Grpalt']['receive']==1?0:1,
				'popup' => $this->data['Grpalt']['popup'],
				'type' => 10,
				)
				);*/
				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'], $this->data['Grpalt']['mail_notice_time_hour'], $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 10, 'Grpalt');
				//sunhy end 2009/03/04 modify for JLN-001
				$add_title = array(
				'Title' => array(
				'id' => $this->data['Title']['id'],
				'title_flg' => $this->data['Title']['title_flg']==1?0:1,
				'type' => 10,
				//sunhy start 2009/05/20 modify for YBR-32
				'group_id'=>$group_id
				//sunhy end 2009/05/20 modify for YBR-32
				)
				);
				//sunhy start 2009/03/04 modify for JLN-001
				/*$add_msg = array(
				'Altmsg' => array(
				'id' => $this->data['Altmsg']['id'],
				'message_id' => 'E0007',
				'message' => $this->data['Altmsg']['message'],
				'detail_flg' => $this->data['Altmsg']['detail_flg']==1?0:1,
				)
				); */
				$detail_flg = ($this->data['Altmsg']['detail_flg']==1) ? 0 : 1;
				//sunhy start 2009/05/21 modify for YBR-32
				//$add_msg = $this->MailPopupController->setAltMsg('E0007', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id']);
				$add_msg = $this->MailPopupController->setAltMsg('E0007', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id'], $group_id);
				//sunhy end 2009/05/21 modify for YBR-32
				//sunhy end 2009/03/04 modify for JLN-001
			}
			else {
				//sunhy start 2009/03/04 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Group']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => '00:00:00',
				'receive' => $this->data['Grpalt']['receive']==1?0:1,
				'popup' => $this->data['Grpalt']['popup'],
				'type' => 10,
				)
				);*/
				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'], '00:00:00', $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 10, 'Grpalt');
				//sunhy end 2009/03/04 modify for JLN-001
				$add_title = array(
				'Title' => array(
				'id' => $this->data['Title']['id'],
				'title_flg' => $this->data['Title']['title_flg']==1?0:1,
				'type' => 10,
				//sunhy start 2009/05/21 added for YBR-32
				'group_id'=>$group_id
				//sunhy end 2009/05/21 added for YBR-32
				)
				);
				//sunhy start 2009/03/04 modify for JLN-001
				/*$add_msg = array(
				'Altmsg' => array(
				'id' => $this->data['Altmsg']['id'],
				'message_id' => 'E0007',
				'message' => $this->data['Altmsg']['message'],
				'detail_flg' => $this->data['Altmsg']['detail_flg']==1?0:1,
				)
				); */
				$detail_flg = ($this->data['Altmsg']['detail_flg']==1) ? 0 : 1;
				//sunhy start 2009/05/21 modify for YBR-32
				//$add_msg = $this->MailPopupController->setAltMsg('E0007', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id']);
				$add_msg = $this->MailPopupController->setAltMsg('E0007', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id'], $group_id);
				//sunhy end 2009/05/21 modify for YBR-32
				//sunhy end 2009/03/04 modify for JLN-001
			}
		}
		//sunhy start 2009/05/21 modify for YBR-32
		//	}
		//	else{
		//		if($this->data['Grpalt']['mail_notice'] == 2){
		//sunhy start 2009/03/04 modify for JLN-001
		/*$add = array(
		'Grpalt' => array(
		'id' => $this->data['Grpalt']['id'],
		'group_id' => $this->data['Group']['group_id'],
		'mail_notice' => $this->data['Grpalt']['mail_notice'],
		'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
		'receive' => $this->data['Grpalt']['receive']==1?0:1,
		'popup' => $this->data['Grpalt']['popup'],
		'type' => 10,
		)
		); */
		//				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'], $this->data['Grpalt']['mail_notice_time_hour'], $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 10, 'Grpalt');
		//sunhy end 2009/03/04 modify for JLN-001
		//		}
		//		else {
		//sunhy start 2009/03/04 modify for JLN-001
		/*$add = array(
		'Grpalt' => array(
		'id' => $this->data['Grpalt']['id'],
		'group_id' => $this->data['Group']['group_id'],
		'mail_notice' => $this->data['Grpalt']['mail_notice'],
		'mail_notice_time' => '00:00:00',
		'receive' => $this->data['Grpalt']['receive']==1?0:1,
		'popup' => $this->data['Grpalt']['popup'],
		'type' => 10,
		)
		); */
		//				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'], '00:00:00', $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 10, 'Grpalt');
		//sunhy end 2009/03/04 modify for JLN-001
		//		}
		//	}
		//sunhy end 2009/05/21 modify for YBR-32
		//sunhy start 2009/03/04 delete for JLN-001
		//$this->Grpalt->save($add);
		//sunhy end 2009/03/04 delete for JLN-001
		empty($add_title)?null:$this->Title->save($add_title);
		empty($add_msg)?null:$this->Altmsg->save($add_msg);
		$group = $this->data['Group']['group_id'];
		//    		if ($group <> 1){
		//    			$group_array[]=$group;
		//    			$this->GenerateFiles->hook_by_group($group_array, array('appli'));
		//    			$this->GenerateFiles->hook_by_group(1, array('popup'));
		//    		}else{
		//    			$this->GenerateFiles->hook_by_group($group, array('appli'));
		//    			$this->GenerateFiles->hook_by_group(1, array('popup'));
		//    		}
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("appli", "popup"));
		$this->GenerateFiles->hook_by_group($group_id, array("appli", "popup"));
		//sunhy end 2009/05/21 modify for YBR-32
		$this->index();
		$this->render('index');
		exit();
	}
	function application($group_id = null,$app_name = null)
	{
		$this->layout = 'ajax';
		if(empty($group_id)){
			$group_id = $this->data['Group']['group_id'];
		}
		$condition = "Group.id = $group_id";
		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
		$this->set('group',$group);
		$parent_list = $this->Grpauth->getParentsByChild($group_id);
		$condition=null;
		foreach ($parent_list as $key=>$list){
			$condition = $condition."Grpaltapp.group_id = $key or ";
		}
		$condition = substr($condition,0,-3);
		$condition = $condition."GROUP BY Grpaltapp.app_name";
		//sunhy start 2009/10/23 deleted for JL-0046
		//$check = $this->Grpaltapp->findAll($condition,'Grpaltapp.app_name');
		//sunhy end 2009/10/23 deleted for JL-0046
		$criteria = null;
		//sunhy start 2009/10/23 deleted for JL-0046
		/*$asso = array(
		'Host : hosts' => array('Astsfw.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Grpauth : grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'),
		);*/
		//sunhy end 2009/10/23 deleted for JL-0046
		if(!empty($app_name)){
			//xinw start 20080221
			$criteria = $criteria."Grpauth.org_grp_id = $group_id and lower(Astsfw.software_name) like '%".strtolower($this->Lv->spec_char_like($app_name))."%' and ";
			//xinw end 20080221
			$this->set('app_name',$app_name);
		}
		else{
			$criteria = $criteria."Grpauth.org_grp_id = $group_id and ";
		}
		//yuanxiaojun start 2009/06/30 modified for JL-0028
		//		foreach ($check as $value){
		//		    	$criteria = $criteria."Astsfw.software_name <> '".$value['Grpaltapp']['app_name']."' and ";
		//		}
		//yuanxiaojun end 2009/06/30 modified for JL-0028
		$criteria = substr($criteria,0,-4);
		$condition_array[] = $criteria;
		//sunhy start 2009/10/23 added for JL-0046
		$this->Astsfw->query("CREATE TEMPORARY TABLE temp_astsfws_alert as
					SELECT Astsfw.software_name as software_name FROM astsfws AS Astsfw 
					INNER JOIN hosts AS Host ON Astsfw.host_id = Host.id INNER JOIN 
					rlthstgrps AS Rlthstgrp ON Host.id = Rlthstgrp.host_id INNER JOIN 
					grpauths AS Grpauth ON Rlthstgrp.group_id = Grpauth.group_id 
					WHERE " . $criteria . " GROUP BY Astsfw.software_name ORDER BY Astsfw.software_name");
		$this->Grpaltapp->query("CREATE TEMPORARY TABLE temp_exist_astsfws_alert as
					SELECT app_name FROM grpaltapps AS Grpaltapp 
					LEFT JOIN rltgrpaltapps AS Rltgrpaltapp ON Rltgrpaltapp.alert_id = Grpaltapp.id 
					WHERE ". $condition);
		$this->Astsfw->query("delete from temp_astsfws_alert 
					where EXISTS (SELECT * FROM temp_exist_astsfws_alert B 
					WHERE temp_astsfws_alert.software_name = B.app_name)");
		//sunhy end 2009/10/23 added for JL-0046
		//sunhy start 2009/10/23 deleted for JL-0046
		//yuanxiaojun start 2009/06/30 modified for JL-0028
		/*if(!empty($check)){
			$condition_array[] = "Astsfw.software_name  not in (SELECT Grpaltapp.app_name AS Grpaltapp__app_name FROM grpaltapps AS Grpaltapp LEFT JOIN rltgrpaltapps AS Rltgrpaltapp ON Rltgrpaltapp.alert_id = Grpaltapp.id WHERE ". $condition.")";
		}*/
		//yuanxiaojun end 2009/06/30 modified for JL-0028
		//$condition_array['GROUP BY'] = "Astsfw.software_name";
		//sunhy end 2009/10/23 deleted for JL-0046
		//sunhy start 2009/10/23 modify for JL-0046
		//list($order,$limit,$page) = $this->Pagination->init($condition_array, null, array('ajaxDivUpdate'=>'view', 'url'=>'/system_grpset_alert_apps/application/'.$group_id."/".$app_name, 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		list($order,$limit,$page) = $this->Pagination->init(array("1=1"), null, array('ajaxDivUpdate'=>'view', 'url'=>'/system_grpset_alert_apps/application/'.$group_id."/".$app_name, 'modelClass'=>'temp_astsfws_alert'));
		//$data1 = $this->Astsfw->findByAsso($condition_array,array('Astsfw.software_name as Astsfw__software_name'),'Astsfw.software_name',$limit,$page,$asso);
		$data1 = $this->Astsfw->query("select * from temp_astsfws_alert order by software_name ASC Limit " . (($page == 0 ? 1 : $page) - 1) * 100 .", 100");
		//sunhy end 2009/10/23 modify for JL-0046
		$data = array();
		if (!empty($data1)){
			foreach ($data1 as $add_id){
				//sunhy start 2009/10/23 modify for JL-0046
				//$software_name = $add_id['Astsfw']['software_name'];
				$software_name = $add_id['0']['software_name'];
				//sunhy end 2009/10/23 modify for JL-0046
				$id_array = $this->Astsfw->find("Astsfw.software_name='".$this->Lv->spec_char_dbm($software_name)."'","Astsfw.id");
				//sunhy start 2009/04/09 added for JLN-001
				//$software_name = ereg_replace("\"","&quot;" ,$software_name);
				//sunhy end 2009/04/09 added for JLN-001
				if($id_array){
					$pass =array(
					'Astsfw'=>array(
					'id'=>$id_array['Astsfw']['id'],
					'software_name' => $software_name
					)
					);
					$data[] = $pass;
				}
			}
		}
		$this->set('data',$data);
		//sunhy start 2009/10/23 deleted for JL-0046
		$this->Astsfw->query("drop table temp_astsfws_alert");
		$this->Grpaltapp->query("drop table temp_exist_astsfws_alert");
		//sunhy end 2009/10/23 deleted for JL-0046
		//$status_list[1] = __('not_allow',$return = true); //modified by zhuhongjuan 20070929
		$status_list[0] = __('allow',$return = true);
		$status_list[1] = __('not_allow',$return = true); //modified by zhuhongjuan 20070929
		$status_list[2] = __('neccessary',$return = true);
		$this->set('status_list',$status_list);
	}
	function client_pc($group_id = null,$app_name = null,$host_name = null)
	{
		$this->layout = 'ajax';
		if(empty($group_id)){
			$group_id = $this->data['Group']['group_id'];
		}
		$condition = "Group.id = $group_id";
		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
		$this->set('group',$group);

		//    		$parent_list = $this->Grpauth->getParentsByChild($group_id);
		//    		$condition=null;
		//    		foreach ($parent_list as $key=>$list){
		//    			$condition = $condition."Grpaltapp.group_id = $key or ";
		//    		}
		//    		$condition = substr($condition,0,-3);
		//    		$condition = $condition."GROUP BY Grpaltapp.app_name";
		//    		$check_grp = $this->Grpaltapp->findAll($condition,'Grpaltapp.app_name');
		//
		//		$condition = array("Rlthstgrp.group_id = $group_id");
		//		$asso1 = array(
		//				'Host : hosts' => array('Hstaltapp.host_id = Host.id'),
		//				'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		//		);
		//		$check_hst = $this->Hstaltapp->findByAsso($condition,array('Hstaltapp.host_id as Hstaltapp__host_id,Hstaltapp.app_name as Hstaltapp__app_name'),'Hstaltapp.host_id',null,null,$asso1);

		$parent_list = $this->Grpauth->getParentsByChild($group_id);
		//yuanxiaojun start 2009/06/30 modified for JL-0028
		//		$condition=null;
		//    		foreach ($parent_list as $key=>$list){
		//    			$condition = $condition."Grpaltapp.group_id = $key or ";
		//    		}
		//    		$condition = substr($condition,0,-3);
		//    		$condition = $condition."GROUP BY Grpaltapp.app_name";
		//    		$check_grp = $this->Grpaltapp->findAll($condition,'Grpaltapp.app_name');

		$grpaltapp_condition=null;
		foreach ($parent_list as $key=>$list){
			$grpaltapp_condition = $grpaltapp_condition."Grpaltapp.group_id = $key or ";
		}
		$grpaltapp_condition = substr($grpaltapp_condition,0,-3);
		$grpaltapp_condition = $grpaltapp_condition."GROUP BY Grpaltapp.app_name";
		//sunhy start 2009/10/23 deleted for JL-0046
		//$check_grp = $this->Grpaltapp->findAll($grpaltapp_condition,'Grpaltapp.app_name');
		//sunhy end 2009/10/23 deleted for JL-0046
		//yuanxiaojun end 2009/06/30 modified for JL-0028

		//sunhy start 2009/03/04 modify for JLN-001
		//=========================================================================================
		/*$condition1=null;
		$child_list = $this->Grpauth->getChildrenByParent($group_id);
		if (!empty($child_list)){
		foreach ($child_list as $key=>$list){
		if($key<>$group_id){
		$condition1 = $condition1."Grpaltapp.group_id = $key or ";
		}
		}
		}
		$condition1 = substr($condition1,0,-3);
		$condition1 = $condition1."GROUP BY Grpaltapp.app_name,,Grpaltapp.group_id";
		$check_child = $this->Grpaltapp->findAll($condition1,'Grpaltapp.group_id,Grpaltapp.app_name');*/
		//===============================================================================================
		//sunhy end 2009/03/04 modify for JLN-001


		$condition = array("Grpauth.org_grp_id = $group_id");
		//sunhy start 2009/10/23 deleted for JL-0046
		/*$asso1 = array(
		'Host : hosts' => array('Hstaltapp.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Grpauth : grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'),
		);
		$check_hst = $this->Hstaltapp->findByAsso($condition,array('Hstaltapp.host_id as Hstaltapp__host_id,Hstaltapp.app_name as Hstaltapp__app_name'),'Hstaltapp.host_id',null,null,$asso1);*/
		//sunhy end 2009/10/23 deleted for JL-0046




		//sunhy start 2009/03/04 modify for JLN-001
		//$criteria = "Grpauth.org_grp_id = $group_id and ";
		$condition_array[] = "Grpauth.org_grp_id = $group_id";
		//sunhy end 2009/03/04 modify for JLN-001
		//sunhy start 2009/10/23 deleted for JL-0046
		/*$asso = array(
		'Host : hosts' => array('Astsfw.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Grpauth : grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'),
		);*/
		//sunhy end 2009/10/23 deleted for JL-0046
		//sunhy start 2009/03/04 modify for JLN-001
		/*if (!empty($app_name)){
		//xinw start 20080221
		$criteria = $criteria."lower(Astsfw.software_name) like '%".strtolower($app_name)."%' and ";
		//xinw end 20080221
		$this->set('app_name',$app_name);
		}
		else {
		$app_name = 0;
		}
		if (!empty($host_name)){
		//xinw start 20080221
		$criteria = $criteria."lower(Host.host_name) like '%".strtolower($host_name)."%' and ";
		//xinw end 20080221
		$this->set('host_name',$host_name);
		}
		//==========================================================
		if (!empty($check_child)){
		foreach ($check_child as $value_child){
		$grp_child = $value_child['Grpaltapp']['group_id'];
		$lim_hid = $this->Rlthstgrp->findAll(array("Rlthstgrp.group_id" => $grp_child),"Rlthstgrp.host_id");
		foreach ($lim_hid as $out_hid){
		$se_hid = $out_hid['Rlthstgrp']['host_id'];
		$criteria = $criteria."(Astsfw.software_name <> '".$value_child['Grpaltapp']['app_name']."' or Astsfw.host_id <> $se_hid) and ";
		}
		}
		}*/
		// yuanxiaojun start 2009/06/30 modified for JL-0028
		//sunhy start 2009/07/16 modify for YBR-40
		//if (!empty($app_name)){
		if (!empty($app_name) && $app_name != "null"){
			//sunhy end 2009/07/16 modify for YBR-40
			$condition_array[] = "lower(Astsfw.software_name) like '%".strtolower($this->Lv->spec_char_like($app_name))."%'";
		}
		if (!empty($host_name)){
			$condition_array[] = "lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like($host_name))."%'";
		}
		//$condition_array = $this->AlertPcController->search_judge("Astsfw", "software_name", $app_name, $condition_array);
		//$condition_array = $this->AlertPcController->search_judge("Host", "host_name", $host_name, $condition_array);
		//yuanxiaojun end 2009/06/30 modified for JL-0028
		$this->set('app_name',$app_name);
		$this->set('host_name',$host_name);
		//yuanxiaojun start 2009/06/30 modified for JL-0028
		//$condition_array = $this->AlertPcController->get_child_info($group_id, "Grpaltapp","app_name", "Astsfw", "software_name", $condition_array);
		//yuanxiaojun end 2009/06/30 modified for JL-0028
		//sunhy end 2009/03/04 modify for JLN-001
		//             yuanxiaojun start 2009/06/30 modified for JL-0028
		//		foreach ($check_grp as $value_grp){
		//		//$group_idcon = $value_grp['Grpaltapp']['group_id'];
		//
		//	    		//sunhy start 2009/03/04 modify for JLN-001
		//			//$criteria = $criteria."Astsfw.software_name <> '".$value_grp['Grpaltapp']['app_name']."' and ";
		//			$condition_array[] = "Astsfw.software_name <> '".$value_grp['Grpaltapp']['app_name']."'";
		//			//sunhy end 2009/03/04 modify for JLN-001
		//		}
		//sunhy start 2009/10/23 added for JL-0046
		$temp_condition = "";
		foreach($condition_array as $key){
			$temp_condition .= $key . " and ";
		}
		$temp_condition = substr($temp_condition,0,-4);
		$this->Astsfw->query("CREATE TEMPORARY TABLE temp_astsfws_alert as
					SELECT Host.id as Host__id,Host.host_name as Host__host_name,Astsfw.software_name as 
					Astsfw__software_name FROM astsfws AS Astsfw INNER JOIN hosts AS Host ON 
					Astsfw.host_id = Host.id INNER JOIN rlthstgrps AS Rlthstgrp ON Host.id = 
					Rlthstgrp.host_id INNER JOIN grpauths AS Grpauth ON Rlthstgrp.group_id = 
					Grpauth.group_id WHERE " . $temp_condition . " GROUP BY 
					Host.id,Host.host_name,Astsfw.software_name ORDER BY Host.host_name");
		$this->Grpaltapp->query("CREATE TEMPORARY TABLE temp_exist_astsfws_alert_group as 
					SELECT Grpaltapp.app_name AS Grpaltapp__app_name FROM grpaltapps AS Grpaltapp 
					LEFT JOIN rltgrpaltapps AS Rltgrpaltapp ON Rltgrpaltapp.alert_id = Grpaltapp.id WHERE " . $grpaltapp_condition);
		$this->Hstaltapp->query("CREATE TEMPORARY TABLE temp_exist_astsfws_alert_host as 
					SELECT Hstaltapp.app_name as Hstaltapp__app_name, Hstaltapp.host_id as Hstaltapp__host_id FROM 
					hstaltapps AS Hstaltapp INNER JOIN hosts AS Host ON 
					Hstaltapp.host_id = Host.id");
		$this->Astsfw->query("delete from temp_astsfws_alert where EXISTS (SELECT * FROM temp_exist_astsfws_alert_group B 
					WHERE temp_astsfws_alert.Astsfw__software_name = B.Grpaltapp__app_name) or EXISTS (SELECT * FROM temp_exist_astsfws_alert_host B 
					WHERE temp_astsfws_alert.Astsfw__software_name = B.Hstaltapp__app_name and temp_astsfws_alert.Host__id = B.Hstaltapp__host_id);");
		//sunhy end 2009/10/23 added for JL-0046
		//sunhy start 2009/10/23 deleted for JL-0046
		/*if(!empty($check_grp)){
			$condition_array[] = "Astsfw.software_name  not in (SELECT Grpaltapp.app_name AS Grpaltapp__app_name FROM grpaltapps AS Grpaltapp LEFT JOIN rltgrpaltapps AS Rltgrpaltapp ON Rltgrpaltapp.alert_id = Grpaltapp.id WHERE ". $grpaltapp_condition.")";
		}*/
		//sunhy start 2009/10/23 deleted for JL-0046
		//		foreach ($check_hst as $value_hst){
		//		         $host_id = $value_hst['Hstaltapp']['host_id'];
		//
		//	    		//sunhy start 2009/03/04 modify for JLN-001
		//			//$criteria = $criteria."(Astsfw.software_name <> '".$value_hst['Hstaltapp']['app_name']."' or Astsfw.host_id <> $host_id) and ";
		//			$condition_array[] = "(Astsfw.software_name <> '".$value_hst['Hstaltapp']['app_name']."' or Astsfw.host_id <> $host_id)";
		//			//sunhy end 2009/03/04 modify for JLN-001
		//		}
		//sunhy start 2009/10/23 deleted for JL-0046
		/*if(!empty($check_hst)){
			//sunhy start 2009/07/16 modify for YBR-40
			//			$condition_array[] = "(Astsfw.software_name  not in (SELECT Hstaltapp.app_name as Hstaltapp__app_name FROM hstaltapps AS Hstaltapp
			//   				INNER JOIN hosts AS Host ON Hstaltapp.host_id = Host.id INNER JOIN rlthstgrps AS Rlthstgrp ON Host.id = Rlthstgrp.host_id
			//				WHERE Rlthstgrp.group_id = ".$group_id. " and astsfws.host_id=Hstaltapp.host_id)) ";
			$condition_array[] = "(Astsfw.software_name  not in (SELECT Hstaltapp.app_name as Hstaltapp__app_name FROM hstaltapps AS Hstaltapp
   				INNER JOIN hosts AS Host ON Hstaltapp.host_id = Host.id and astsfws.host_id=Hstaltapp.host_id)) ";
			//sunhy end 2009/07/16 modify for YBR-40
		}*/
		//sunhy start 2009/10/23 deleted for JL-0046
		//yuanxiaojun end 2009/06/30 modified for JL-0028
		//sunhy start 2009/03/04 delete for JLN-001
		/*$condition = substr($criteria,0,-4);
		$condition_array[] = $condition;*/
		//sunhy end 2009/03/04 delete for JLN-001
		//sunhy start 2009/10/23 deleted for JL-0046
		//$condition_array['GROUP BY'] = "Host.id,Host.host_name,Astsfw.software_name";
		//sunhy end 2009/10/23 deleted for JL-0046
		//sunhy start 2009/07/15 modify for YBR-40
		//list($order,$limit,$page) = $this->Pagination->init($condition_array, null, array('ajaxDivUpdate'=>'view', 'url'=>'/system_grpset_alert_apps/client_pc/'.$group_id."/".$app_name."/".$host_name, 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		//sunhy start 2009/10/23 modify for JL-0046
		//list($order,$limit,$page) = $this->Pagination->init($condition_array, null, array('ajaxDivUpdate'=>'view', 'url'=>'/system_grpset_alert_apps/client_pc/'.$group_id."/".(empty($app_name) ? "null" : $app_name)."/".$host_name, 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		list($order,$limit,$page) = $this->Pagination->init(array("1=1"), null, array('ajaxDivUpdate'=>'view', 'url'=>'/system_grpset_alert_apps/client_pc/'.$group_id."/".(empty($app_name) ? "null" : $app_name)."/".$host_name, 'modelClass'=>'temp_astsfws_alert'));
		//sunhy end 2009/07/15 modify for YBR-40
		//$data1 = $this->Astsfw->findByAsso($condition_array,array('Host.id as Host__id,Host.host_name as Host__host_name,Astsfw.software_name as Astsfw__software_name'),'Host.host_name',$limit,$page,$asso);
		$data1 = $this->Astsfw->query("select * from temp_astsfws_alert order by Host__host_name ASC, Astsfw__software_name Limit " . (($page == 0 ? 1 : $page) - 1) * 100 .", 100");
		//sunhy end 2009/10/23 modify for JL-0046
		$data = array();
		if (!empty($data1)){
			foreach ($data1 as $add_id){
				//sunhy start 2009/10/23 modify for JL-0046
				//$hst_id = $add_id['Host']['id'];
				//$hst_name = $add_id['Host']['host_name'];
				//$software_name = $add_id['Astsfw']['software_name'];
				$hst_id = $add_id['Host']['id'];
				$hst_name = $add_id['Host']['host_name'];
				$software_name = $add_id['Astsfw']['software_name'];
				//sunhy end 2009/10/23 modify for JL-0046
				$id_array = $this->Astsfw->find("Astsfw.software_name='".$this->Lv->spec_char_dbm($software_name)."' and Astsfw.host_id = $hst_id","Astsfw.id");
				//sunhy start 2009/04/09 added for JLN-001
				//$software_name = ereg_replace("\"","&quot;" ,$software_name);
				//sunhy end 2009/04/09 added for JLN-001
				if($id_array){
					$pass =array(
					'Astsfw'=>array(
					'id'=>$id_array['Astsfw']['id'],
					'software_name' => $software_name
					),
					'Host' =>array(
					'host_name' => $hst_name,
					'host_id' => $hst_id
					)
					);
					$data[] = $pass;
				}
			}
		}
		$this->set('data',$data);
		//sunhy start 2009/10/23 deleted for JL-0046
		$this->Astsfw->query("drop table temp_astsfws_alert");
		$this->Grpaltapp->query("drop table temp_exist_astsfws_alert_group");
		$this->Hstaltapp->query("drop table temp_exist_astsfws_alert_host");
		//sunhy end 2009/10/23 deleted for JL-0046
		//$status_list[1] = __('not_allow',$return = true); //modified by zhuhongjuan 20070929
		$status_list[0] = __('allow',$return = true);
		$status_list[1] = __('not_allow',$return = true); //modified by zhuhongjuan 20070929
		$status_list[2] = __('neccessary',$return = true);
		$this->set('status_list',$status_list);
	}
	function add_grp()
	{
		$this->layout = 'ajax';
		$group_id = $this->data['Group']['group_id'];
		if (isset($this->data['Grpaltapp']['app'])){
			$app_name = $this->data['Grpaltapp']['app'];
		}
		else{
			$app_name = null;
		}
		if(isset($this->data['Astsfw']['id'])){
			foreach ($this->data['Astsfw']['id'] as $id){
				//				$insert_data = $this->Astsfw->find("Astsfw.id = $id");		// by zhangying 2007.10.31
				$appname = $this->Lv->spec_char_dbm(urldecode($this->data['Grpaltapp']['software_'.$id]));
				$children = $this->Grpauth->getChildrenByParent($group_id);
				foreach ($children as $grp_id=>$grp_name){
					$condition_hst = array("Rlthstgrp.group_id = $grp_id and Hstaltapp.app_name = '".$appname."'");
					$asso = array(
					'Host : hosts' => array('Hstaltapp.host_id = Host.id'),
					'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
					);
					$hst_del = $this->Hstaltapp->findByAsso($condition_hst,array('Hstaltapp.id as Hstaltapp__id,Hstaltapp.host_id as Hstaltapp__host_id'),null,null,null,$asso);
					if (!empty($hst_del)){
						$error = 1;
					}
					$condition_grp = array("Grpaltapp.group_id = $grp_id and Grpaltapp.app_name = '".$appname."'");
					$grp_del = $this->Grpaltapp->findAll($condition_grp);
					if (!empty($grp_del)){
						$error = 1;
					}
				}
			}
			if (isset($error)){
				$errorMessage['application_info'][] = 'E-02400';
				$this->set('errorMessage',$errorMessage);
			}
			else {
				foreach ($this->data['Astsfw']['id'] as $id){
					//					$insert_data = $this->Astsfw->find("Astsfw.id = $id");
					$appname = $this->Lv->spec_char_dbm(urldecode($this->data['Grpaltapp']['software_'.$id]));
					$add = array(
					'Grpaltapp' => array(
					'group_id' => $group_id,
					'app_name' => $appname,
					'app_status' => $this->data['Grpaltapp']['app_status_'.$id]
					)
					);
					$this->Grpaltapp->save($add);
					$last_id = $this->Grpaltapp->getLastInsertID();
					$children = $this->Grpauth->getChildrenByParent($group_id);
					foreach ($children as $group=>$group_name){
						$rlt_add = array(
						'Rltgrpaltapp' =>array(
						'group_id' => $group,
						'alert_id' => $last_id,
						'org_grp_id' => $group_id
						)
						);
						$this->Rltgrpaltapp->save($rlt_add);
					}
					////////////////////////2007.10.20 by zhangying start
					$asso = array(
					'Rlthstgrp : rlthstgrps' => array('Hstaltatoapp.host_id = Rlthstgrp.host_id'),
					'Grpauth : grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'),
					);
					$delhost_id = $this->Hstaltatoapp->findByAsso(array("Grpauth.org_grp_id = $group_id and Hstaltatoapp.app_name = '".$appname."'"),array("Hstaltatoapp.id as Hstaltatoapp__id"),null,null,null,$asso);
					foreach ($delhost_id as $del_id){
						//						$delato_id[] = $del_id['Hstaltatoapp']['id'];/////changed by wzy at 20071104
						$this->Hstaltatoapp->save(array("Hstaltatoapp" => array("id"=>$del_id['Hstaltatoapp']['id'], "del_flg" => 1)));
					}
					//					if (isset($delato_id)){
					////						$this->Hstaltatoapp->del(array($delato_id));
					//					}
					////////////////////////2007.10.20 by zhangying end
					//xinw start 20090203
					//modify for ASP4-031
					$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 10";
					$value = $this->Grpalt->find($condition);
					if (!$value){
						//sunhy start 2009/03/04 modify for JLN-001
						/*$add_alt = array(
						'Grpalt' => array(
						'group_id' => $group_id,
						'mail_notice' => 1,
						'mail_notice_time' => '00:00:00',
						'receive' => 1,
						'popup' => 0,
						'type' => 10,
						)
						);
						$this->Grpalt->save($add_alt);*/
						//sunhy start 2009/05/21 modify for YBR-32
						//$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 1, null, 0, 10, 'Grpalt');
						$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 0, null, 1, 10, 'Grpalt');
						//sunhy end 2009/05/21 modify for YBR-32
						//sunhy end 2009/03/04 modify for JLN-001
						$flag = 1;
					}
					//xinw end 20090203
				}
				$this->GenerateFiles->hook_by_group($group_id, array('appli'));
			}
		}
		else{
			$errorMessage['application_info'][] = 'E-00200';
			$this->set('errorMessage',$errorMessage);
		}
		$this->application($group_id,$app_name);
		$this->render('application');
		exit();
	}
	function add_hst()
	{
		$this->layout = 'ajax';
		//		debug($this->data,true);
		$group_id = $this->data['Group']['group_id'];
		if (isset($this->data['Hstaltapp']['app'])){
			$app_name = $this->data['Hstaltapp']['app'];
		}
		else{
			$app_name = null;
		}
		if (isset($this->data['Hstaltapp']['host'])){
			$host_name = $this->data['Hstaltapp']['host'];
		}
		else{
			$host_name = null;
		}
		if(isset($this->data['Astsfw']['id'])){
			$host_id = array();
			foreach ($this->data['Astsfw']['id'] as $id){
				//				$insert_data = $this->Astsfw->find("Astsfw.id = $id");	//by zhangying 2007.10.31
				$appname = $this->Lv->spec_char_dbm(urldecode($this->data['Hstaltapp']['software_'.$id]));
				$add = array(
				'Hstaltapp' => array(
				'host_id' => $this->data['Hstaltapp']['host_'.$id],
				'app_name' => $appname,
				'app_status' => $this->data['Hstaltapp']['app_status_'.$id]
				)
				);
				$this->Hstaltapp->save($add);
				$host_id[] = $this->data['Hstaltapp']['host_'.$id];
				////////////////////////2007.10.20 by zhangying start
				$delhost_id = $this->data['Hstaltapp']['host_'.$id];
				$delhost_id = $this->Hstaltatoapp->findAll("Hstaltatoapp.host_id = $delhost_id and Hstaltatoapp.app_name = '".$appname."'","Hstaltatoapp.id",null,null,null,null);
				foreach ($delhost_id as $del_id){
					//					$delato_id[] = $del_id['Hstaltatoapp']['id'];	/////changed by wzy at 20071104
					$this->Hstaltatoapp->save(array("Hstaltatoapp" => array("id" =>$del_id['Hstaltatoapp']['id'], "del_flg" => 1)));
				}
				//				if (isset($delato_id)){
				////					$this->Hstaltatoapp->del(array($delato_id));
				//				}
				////////////////////////2007.10.20 by zhangying end
				////////////////////////2007.10.18 by zhangying start  ==change the grpalt's addition
				$host = $this->data['Hstaltapp']['host_'.$id];	// by zhangying 2007.10.31
				$condition_findgrp = "Rlthstgrp.host_id = $host";
				$group = $this->Rlthstgrp->find($condition_findgrp);
				$group_findalt = $group['Rlthstgrp']['group_id'];
				$condition = "Grpalt.group_id = $group_findalt AND Grpalt.type = 10";
				$value = $this->Grpalt->find($condition);
				if (!$value){
					//sunhy start 2009/03/04 modify for JLN-001
					/*$add_alt = array(
					'Grpalt' => array(
					'group_id' => $group_findalt,
					'mail_notice' => 1,
					'mail_notice_time' => '00:00:00',
					'receive' => 1,
					'popup' => 0,
					'type' => 10,
					)
					);
					$this->Grpalt->save($add_alt);*/
					//sunhy start 2009/05/21 modify for YBR-32
					//$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 1, null, 0, 10, 'Grpalt');
					$this->MailPopupController->setMailPop(null, $group_findalt, 1, '00:00:00', 0, null, 1, 10, 'Grpalt');
					//sunhy end 2009/05/21 modify for YBR-32
					//sunhy end 2009/03/04 modify for JLN-001
					$flag = 1;
				}
				////////////////////////2007.10.18 by zhangying end  ==change the grpalt's addition
			}
			//	    		if (isset($flag)){
			//	    			$this->GenerateFiles->hook_by_group(1, array('popup'));
			//	    		}
			//sunhy start 2009/05/21 modify for YBR-32
			//$this->GenerateFiles->hook_by_host($host_id, array('appli'));
			$this->GenerateFiles->hook_by_host($host_id, array('appli'), $group_id);
			//sunhy end 2009/05/21 modify for YBR-32
		}
		else{
			$errorMessage['client_pc'][] = 'E-00200';
			$this->set('errorMessage',$errorMessage);
		}
		$this->client_pc($group_id,$app_name,$host_name);
		$this->render('client_pc');
		exit();
	}
	function application_search()
	{
		$this->layout = 'ajax';
		$group_id = $this->data['Group']['group_id'];
		$app_name = null;
		if (!$this->Lv->is_empty($this->data['Grpaltapp']['app_name'])){
			if(!$this->Validation->maxLength($this->data['Grpaltapp']['app_name'],256)){
				$errorMessage['application_info'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			else{
				$app_name = $this->data['Grpaltapp']['app_name'];
			}
		}
		$this->set('app_name',$app_name);
		$this->application($group_id,$app_name);
		$this->render('application');
		exit();
	}
	function client_search()
	{
		$this->layout = 'ajax';
		$group_id = $this->data['Group']['group_id'];
		$app_name = null;
		$host_name = null;
		if (!$this->Lv->is_empty($this->data['Hstaltapp']['app_name'])){
			if(!$this->Validation->maxLength($this->data['Hstaltapp']['app_name'],256)){
				$errorMessage['application_info'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			else{
				$app_name = $this->data['Hstaltapp']['app_name'];
			}
		}
		if (!$this->Lv->is_empty($this->data['Host']['host_name'])){
			if(!$this->Validation->maxLength($this->data['Host']['host_name'],256)){
				$errorMessage['client_pc'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			else{
				$host_name = $this->data['Host']['host_name'];
			}
		}
		$this->set('app_name',$app_name);
		$this->set('host_name',$host_name);
		$this->client_pc($group_id,$app_name,$host_name);
		$this->render('client_pc');
		exit();
	}
	//sunhy start 2009/05/21 modfiy for YBR-32
	//function findTitleid($title_id = null)
	function findTitleid($group_id = null)
	//sunhy end 2009/05/21 modfiy for YBR-32
	{
		//sunhy start 2009/05/21 modfiy for YBR-32
		//$title= $this->Title->find("Title.type = 10");
		$title= $this->Title->find("Title.type = 10 and group_id= " . $group_id);
		//sunhy end 2009/05/21 modfiy for YBR-32
		return $title['Title']['id'];
	}
	//sunhy start 2009/05/21 modfiy for YBR-32
	//function findMsgid($msg_id = null)
	function findMsgid($group_id = null)
	//sunhy end 2009/05/21 modfiy for YBR-32
	{
		//sunhy start 2009/05/21 modfiy for YBR-32
		$msg= $this->Altmsg->find("Altmsg.message_id = 'E0007'");
		$msg= $this->Altmsg->find("Altmsg.message_id = 'E0007' and group_id = " . $group_id);
		//sunhy end 2009/05/21 modfiy for YBR-32
		return $msg['Altmsg']['id'];
	}
	
}
?>