<?php
/*********************************************************************
*@filename 		system_grpset_alert_evtlogs_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhy    	2009/03/30   modify for JLN-001
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy    	2009/05/21   modify for YBR-32
********************************************************************/
class SystemGrpsetAlertEvtlogsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	//sunhy start 2009/03/30 modify for JLN-001
	//var $components = array ('Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','GenerateFiles','MailPopupController','AlertPcController');
	//sunhy end 2009/03/30 modify for JLN-001
	var $uses=array('Grpaltevtlog','Rltgrpaltevtlog','Configure','Group','Grpalt','Grpauth','User','Validation','Title');
	var $layout='system';
	function beforeFilter()
	{
		parent::beforeFilter();
	}
	function index()
	{
		$this->pageTitle = __('title',$return = true);
		$own_group_id = $this->_getUserGroup();
		$glist = $this->Group->getChildrenByParent($own_group_id);
		$this->set('glist',$glist);
		$plist = $this->Grpauth->getParentsByChild($own_group_id);
		$flist = array();
		foreach ($plist as $group_id=>$group_name){
			if($group_id <> $own_group_id){
				$flist[$group_id] = $group_name;
			}
		}
		foreach ($flist as $key=>$value){
			$criteria = " Grpalt.type = 6 AND Group.id = $key";
			$grp_alt = $this->Grpalt->findAll($criteria,'Grpalt.mail_notice,Grpalt.mail_notice_time');
			$condition = "Rltgrpaltevtlog.group_id = $key AND Rltgrpaltevtlog.org_grp_id = $key GROUP BY Grpaltevtlog.rule_name";
			$rule = $this->Grpaltevtlog->findAll($condition,'Grpaltevtlog.rule_name,count(Grpaltevtlog.rule_name) as Grpaltevtlog__count','Grpaltevtlog.rule_name');
			if(!empty($grp_alt)){
				if(empty($rule)){
					$undata[$key]['Grpalt']['count'] = 1;
					$undata[$key]['Group']['group_name'] = $value;
					$undata[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
					if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
						$undata[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
					}
					$undata[$key]['Grpaltevtlog'][] = array();
				}
				else{
					$ccount = 0;
					foreach ($rule as $rule){
						$ccount = $ccount + $rule['Grpaltevtlog']['count'];
						$undata[$key]['Grpalt']['count'] = $ccount;
						$undata[$key]['Group']['group_name'] = $value;
						$undata[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
							$undata[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$rule_name = $rule['Grpaltevtlog']['rule_name'];
						$condition_data = "Rltgrpaltevtlog.group_id = $key AND Rltgrpaltevtlog.org_grp_id = $key AND Grpaltevtlog.rule_name = '".$this->Lv->spec_char_dbm($rule_name)."'";
						$rule_data = $this->Grpaltevtlog->findAll($condition_data,'Grpaltevtlog.event_catalog,Grpaltevtlog.event_type,Grpaltevtlog.source,Grpaltevtlog.source_content,Grpaltevtlog.specification');
						$pass_data = array();
						foreach ($rule_data as $output){
							$pass_data['count'] = $rule['Grpaltevtlog']['count'];
							$pass_data['rule_name'] = $rule_name;
							$pass_data['Evtlog'][] = $output['Grpaltevtlog'];

						}
						$undata[$key]['Grpaltevtlog'][] = $pass_data;
					}
				}
			}
		}
		foreach ($glist as $key=>$value){
			$criteria = " Grpalt.type = 6 AND Group.id = $key";
			$grp_alt = $this->Grpalt->findAll($criteria,'Grpalt.mail_notice,Grpalt.mail_notice_time,Group.parent_id');
			$condition = "Rltgrpaltevtlog.group_id = $key AND Rltgrpaltevtlog.org_grp_id = $key GROUP BY Grpaltevtlog.rule_name";
			$rule = $this->Grpaltevtlog->findAll($condition,'Grpaltevtlog.rule_name,count(Grpaltevtlog.rule_name) as Grpaltevtlog__count','Grpaltevtlog.rule_name');
			if(!empty($grp_alt)){
				if(empty($rule)){
					$data[$key]['Grpalt']['count'] = 1;
					$data[$key]['Group']['group_name'] = $value;
					$data[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
					if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
						$data[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
					}
					$data[$key]['Grpaltevtlog'][] = array();
				}
				else{
					$ccount = 0;
					foreach ($rule as $rule){
						$ccount = $ccount + $rule['Grpaltevtlog']['count'];
						$data[$key]['Grpalt']['count'] = $ccount;
						$data[$key]['Group']['group_name'] = $value;
						$data[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice'] == 2){
							$data[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$rule_name = $rule['Grpaltevtlog']['rule_name'];
						$condition_data = "Rltgrpaltevtlog.group_id = $key AND Rltgrpaltevtlog.org_grp_id = $key AND Grpaltevtlog.rule_name = '".$this->Lv->spec_char_dbm($rule_name)."'";
						$rule_data = $this->Grpaltevtlog->findAll($condition_data,'Grpaltevtlog.event_catalog,Grpaltevtlog.event_type,Grpaltevtlog.source,Grpaltevtlog.source_content,Grpaltevtlog.specification');
						$pass_data = array();
						foreach ($rule_data as $output){
							$pass_data['count'] = $rule['Grpaltevtlog']['count'];
							$pass_data['rule_name'] = $rule_name;
							$pass_data['Evtlog'][] = $output['Grpaltevtlog'];

						}
						$data[$key]['Grpaltevtlog'][] = $pass_data;
					}
				}
			}
		}
		empty($undata)? $undata=array():$undata;
		empty($data)? $data=array():$data;
		$this->set('undata',$undata);
		$this->set('data',$data);
	}
	function delete($judg = null)
	{
		$this->layout = 'ajax';
		if($judg == 1){
			if(isset($this->data['Grpalt']['group_id'])){
				foreach ($this->data['Grpalt']['group_id'] as $group_id){
					$condition1 = "Grpalt.group_id = $group_id AND Grpalt.type = 6";
					$alt_id = $this->Grpalt->findAll($condition1,'Grpalt.id');
					foreach ($alt_id as $output){
						//$altid[] = $output['Grpalt']['id'];
						$this->Grpalt->del($output['Grpalt']['id']);
					}
					$condition2 = "Rltgrpaltevtlog.group_id = $group_id AND Rltgrpaltevtlog.org_grp_id = $group_id";
					$evtlog_id = $this->Grpaltevtlog->findAll($condition2,'Grpaltevtlog.id');
					foreach ($evtlog_id as $output){
						//$evtid[] = $output['Grpaltevtlog']['id'];
						$this->Grpaltevtlog->del($output['Grpaltevtlog']['id']);
					}
					//sunhy start 2009/05/21 added for YBR-32
					//empty($altid)?null:$this->Grpalt->del(array($altid));
					//empty($evtid)?null:$this->Grpaltevtlog->del(array($evtid));
					
					$this->GenerateFiles->hook_by_group($group_id, array('evtlog','popup'));
					//sunhy end 2009/05/21 added for YBR-32
				}
				//sunhy start 2009/05/21 added for YBR-32
				/*empty($altid)?null:$this->Grpalt->del(array($altid));
				empty($evtid)?null:$this->Grpaltevtlog->del(array($evtid));*/
				//sunhy end 2009/05/21 added for YBR-32
			}
			else {
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$errorMessage['Group'][] = 'E-00200';
				$errorMessage['entry'][] = 'E-00200';
				//xushanning end 2009/04/22   modify for LogvillageChinese
				$this->set('errorMessage',$errorMessage);
				
			}
			//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/21 delete for JLN-001
			//$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'));
			//sunhy end 2009/05/21 delete for JLN-001
			//sunhy end 2009/03/30 added for JLN-001
			$this->index();
			$this->render('index');
		}
		elseif ($judg == 2){
			if(isset($this->data['Grpaltevtlog']['id'])){
				foreach ($this->data['Grpaltevtlog']['id'] as $altevt_id){
					//$del_id = array();
					$evt_name = $this->Grpaltevtlog->find("Grpaltevtlog.id = $altevt_id");
					$name = $this->Lv->spec_char_dbm($evt_name['Grpaltevtlog']['rule_name']);
					$evg_id= $this->Grpaltevtlog->findAll("Grpaltevtlog.rule_name = '".$name."' GROUP BY Grpaltevtlog.id","Grpaltevtlog.id");

					foreach ($evg_id as $pass_id){
						//$del_id[] = $pass_id['Grpaltevtlog']['id'];
						
						$this->Grpaltevtlog->del($pass_id['Grpaltevtlog']['id']);
					}
					//$this->Grpaltevtlog->del(array($del_id));
				}
			}
			else {
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$errorMessage_middle['rule'][] = 'E-00200';
				$errorMessage_middle['rule_name'][] = 'E-00200';
				//xushanning end 2009/04/22   modify for LogvillageChinese
				$this->set('errorMessage_middle',$errorMessage_middle);
			}
			//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/21 modify for JLN-001
			//$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'));
			$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'), $this->data['Grpaltevtlog']['group_id']);
			//sunhy end 2009/05/21 modify for JLN-001
			//sunhy end 2009/03/30 added for JLN-001
			//xinw start 20090209
			//modify for ASP4-031
			//$this->set_alert();
			$this->set_alert(null,'nodo');
			//xinw end 20090209
		}
		elseif ($judg == 3){
			if(isset($this->data['Grpaltevtlog']['id'])){
				foreach ($this->data['Grpaltevtlog']['id'] as $delid){
					$this->Grpaltevtlog->del($delid);
				}
			}
			else {
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$errorMessage['rule'][] = 'E-00200';
				$errorMessage['alert_condition_detail'][] = 'E-00200';
				//xushanning end 2009/04/22   modify for LogvillageChinese
				$this->set('errorMessage',$errorMessage);
			}
			//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/21 modify for YBR-32
			//$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'));
			$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'), $this->data['Grpaltevtlog']['group_id']);
			//sunhy end 2009/05/21 modify for YBR-32
			//sunhy end 2009/03/30 added for JLN-001
			$this->set_rule();
		}
	}
	//xinw start 20090203
	//modify for ASP4-031
	//function set_alert($group_id = null)
	function set_alert($group_id = null,$do=null)
	//xinw end 20090203
	{
		//xinw start 20090203
		//modify for ASP4-031
		if ($group_id=='null') {
			$group_id=null;
		}
		//xinw end 20090203
		$this->layout = 'ajax';
		if(empty($group_id)){
			$group_id = $this->data['Grpaltevtlog']['group_id'];
		}
		$own_group_id = $this->_getUserGroup();
		$this->set('own_group_id',$own_group_id);
		$condition = "Group.id = $group_id";
		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
		$this->set('group',$group);

		//sunhy start 2009/03/30 added for JLN-001
		$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/30 added for JLN-001
		
		$data=array();
		$plist = $this->Grpauth->getParentsByChild($group_id);
		foreach ($plist as $key=>$value){
			$condition_app = "Rltgrpaltevtlog.group_id = $key AND Rltgrpaltevtlog.org_grp_id = $key GROUP BY Grpaltevtlog.rule_name";
			$rule = $this->Grpaltevtlog->findAll($condition_app,'Grpaltevtlog.rule_name,count(Grpaltevtlog.rule_name) as Grpaltevtlog__count','Grpaltevtlog.rule_name');
			foreach ($rule as $rule){
				$rule_name = $rule['Grpaltevtlog']['rule_name'];
				$condition = "Rltgrpaltevtlog.group_id = $key AND Rltgrpaltevtlog.org_grp_id = $key AND Grpaltevtlog.rule_name = '".$this->Lv->spec_char_dbm($rule_name)."'";
				$evtlog = $this->Grpaltevtlog->findAll($condition,null,'Grpaltevtlog.id');
				$pass_data['count'] = $rule['Grpaltevtlog']['count'];
				$pass_data['rule_name'] = $rule_name;
				$pass_data['Grpaltevtlog'] = array();
				foreach($evtlog as $evtlog){
					$pass_data['Grpaltevtlog'][] = $evtlog['Grpaltevtlog'];
				}
				$data[$key][] = $pass_data;
			}
		}
		$this->set('data',$data);

		//sunhy start 2009/05/21 modify for YBR-32
		/*$title= $this->Title->find("Title.type = 6");
		if (!isset($this->data['Title']['id'])){
			if($title['Title']['title_flg'] == 0){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = 0;
			}
		}
		$this->data['Title']['id'] = $title['Title']['id'];*/
		
		$title= $this->Title->find("Title.type = 6 and Title.group_id = ".$group_id);
		if($title && !empty($title)){
			if (!isset($this->data['Title']['id'])){
				if($title['Title']['title_flg'] == 0){
					$this->data['Title']['title_flg'] = 1;
				}
				else {
					$this->data['Title']['title_flg'] = 0;
				}
			}
			$this->data['Title']['id'] = $title['Title']['id'];
		}else{
			$this->data['Title']['title_flg'] = 1;
			$maxtitid = $this->Title->findAll(null,array('max(id) as Title__maxid'));
			$this->data['Title']['id'] = $maxtitid[0]['Title']['maxid'] + 1;
		}
		//sunhy end 2009/05/21 modify for YBR-32
		$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 6";
		$value = $this->Grpalt->find($condition);
		if($value){
			if (!isset($this->data['Grpalt']['id'])){
				$this->data['Grpalt']['mail_notice'] = $value['Grpalt']['mail_notice'];
				$this->data['Grpalt']['mail_notice_time'] = $value['Grpalt']['mail_notice_time'];
				if($value['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}
			}
			$this->data['Grpalt']['id'] = $value['Grpalt']['id'];
		}
		else{
			//sunhy start 2009/03/30 modify for JLN-001
			/*$add = array(
			'Grpalt' => array(
			'group_id' => $group_id,
			'mail_notice' => 1,
			'mail_notice_time' => '00:00:00',
			'receive' => 1,
			'type' => 6,
			)
			);*/
			//sunhy end 2009/03/30 modify for JLN-001
			//xinw start 20090203
			//modify for ASP4-031
			//$this->Grpalt->save($add);
			if ($do=='nodo') {
				$this->data['Grpalt']['mail_notice']=1;
			}else 
			{
				//sunhy start 2009/03/30 modify for JLN-001
				//$this->Grpalt->save($add);
				$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', null, null, 1, 6, 'Grpalt');
				//sunhy end 2009/03/30 modify for JLN-001
			}
			//xinw end 20090203
			$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 6";
			$value_1 = $this->Grpalt->find($condition);
			if($value_1){
				$this->data['Grpalt']['id'] = $value_1['Grpalt']['id'];
				$this->data['Grpalt']['mail_notice'] = $value_1['Grpalt']['mail_notice'];
				$this->data['Grpalt']['mail_notice_time'] = $value_1['Grpalt']['mail_notice_time'];
				if($value_1['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}
			}
		}
		$condition = "User.group_id = $group_id";
		$mail = $this->User->findAll($condition,'Mail.mail_address');
		//sunhy start 2009/03/30 modify for JLN-001
		//$this->set('mail',$mail);
		$this->set('email',$mail);
		//sunhy end 2009/03/30 modify for JLN-001
		$this->render('set_alert');
	}
	function add_alert()
	{
		$this->layout = 'ajax';
		if($this->data['Grpalt']['mail_notice'] == 2){
			if(isset($this->data['Title']['title_flg'])){
				//sunhy start 2009/03/30 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
				//						'receive' => $this->data['Grpalt']['receive']==1?0:1,		// by zhangying 2007.11.2
				'receive' => 1,
				'type' => 6,
				)
				);*/
				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Grpaltevtlog']['group_id'], $this->data['Grpalt']['mail_notice'], $this->data['Grpalt']['mail_notice_time_hour'], null, null, 1, 6, 'Grpalt');
				//sunhy end 2009/03/30 modify for JLN-001
				$add_title = array(
				'Title' => array(
				'id' => $this->data['Title']['id'],
				'title_flg' => $this->data['Title']['title_flg']==1?0:1,
				'type' => 6,
				//sunhy start 2009/05/21 modify for YBR-32
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				//sunhy end 2009/05/21 modify for YBR-32
				)
				);
			}
			else{
				
				//sunhy start 2009/03/30 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
				//						'receive' => $this->data['Grpalt']['receive']==1?0:1,		// by zhangying 2007.11.2
				'receive' => 1,
				'type' => 6,
				)
				);*/
				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Grpaltevtlog']['group_id'], $this->data['Grpalt']['mail_notice'], $this->data['Grpalt']['mail_notice_time_hour'], null, null, 1, 6, 'Grpalt');
				//sunhy end 2009/03/30 modify for JLN-001
			}
		}
		else{
			if(isset($this->data['Title']['title_flg'])){
				//sunhy start 2009/03/30 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => '00:00:00',
				//						'receive' => $this->data['Grpalt']['receive']==1?0:1,		// by zhangying 2007.11.2
				'receive' => 1,
				'type' => 6,
				)
				);*/
				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Grpaltevtlog']['group_id'], $this->data['Grpalt']['mail_notice'], '00:00:00', null, null, 1, 6, 'Grpalt');
				//sunhy end 2009/03/30 modify for JLN-001
				$add_title = array(
				'Title' => array(
				'id' => $this->data['Title']['id'],
				'title_flg' => $this->data['Title']['title_flg']==1?0:1,
				'type' => 6,
				//sunhy start 2009/05/21 modify for YBR-32
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				//sunhy end 2009/05/21 modify for YBR-32
				)
				);
			}
			else{
				//sunhy start 2009/03/30 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => '00:00:00',
				//						'receive' => $this->data['Grpalt']['receive']==1?0:1,		// by zhangying 2007.11.2
				'receive' => 1,
				'type' => 6,
				)
				);*/
				$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Grpaltevtlog']['group_id'], $this->data['Grpalt']['mail_notice'], '00:00:00', null, null, 1, 6, 'Grpalt');
				//sunhy end 2009/03/30 modify for JLN-001
			}
		}
		//sunhy start 2009/03/30 delete for JLN-001
		//$this->Grpalt->save($add);
		//sunhy end 2009/03/30 delete for JLN-001
		empty($add_title)?null:$this->Title->save($add_title);
		//sunhy start 2009/03/30 added for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'));
		$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'), $this->data['Grpaltevtlog']['group_id']);
		//sunhy end 2009/05/21 modify for YBR-32
		//sunhy end 2009/03/30 added for JLN-001
		$this->index();
		$this->render('index');
		exit();
	}
	function set_rule($group_id = null,$id = null)
	{
		$this->layout = 'ajax';
		if(empty($group_id)){
			$group_id = $this->data['Grpaltevtlog']['group_id'];
		}
		if(empty($id)){
			$rule_name = $this->data['Grpaltevtlog']['rule_name'];
		}
		else{
			if ($id == 'judg'){
				if(!$this->Lv->is_empty($this->data['Grpaltevtlog']['rule_name'])){
					if(!$this->Validation->maxLength($this->data['Grpaltevtlog']['rule_name'],200)){
						$errorMessage_middle['rule_name'][] = 'E-00300';
						$this->set('errorMessage_middle',$errorMessage_middle);
						$this->set_alert();
						exit();
					}
					else {
						$rule_name = $this->data['Grpaltevtlog']['rule_name'];
					}
				}
				else{
					$errorMessage_middle['rule_name'][] = 'E-00100';
					$this->set('errorMessage_middle',$errorMessage_middle);
					//xinw start 20090209
					//modify for ASP4-031
					//$this->set_alert();
					$this->set_alert(null,'nodo');
					//xinw end 20090209
					exit();
				}
			}else{
				$rule = $this->Grpaltevtlog->find("Grpaltevtlog.id = $id",'Grpaltevtlog.rule_name');
				$rule_name = $rule['Grpaltevtlog']['rule_name'];
			}
			$this->data['Grpaltevtlog']['source'] = 1;
		}
		$this->set('rule_name',$rule_name);
		$condition = "Group.id = $group_id";
		$group = $this->Group->find($condition,'Group.id,Group.group_name');
		$this->set('group',$group);

		$condition = "Rltgrpaltevtlog.group_id = $group_id AND Rltgrpaltevtlog.org_grp_id = $group_id AND Grpaltevtlog.rule_name = '".$this->Lv->spec_char_dbm($rule_name)."'";
		$data = $this->Grpaltevtlog->findAll($condition,'id,event_catalog,event_type,source,source_content,specification','Grpaltevtlog.id');
		$this->set('data',$data);

		$type_list[1] = __('error',$return = true);
		$type_list[2] = __('warning',$return = true);
		$type_list[3] = __('whole',$return = true);
		$this->set('type_list',$type_list);

		$this->render('set_rule');
	}
	function add_rule()
	{
		$this->layout = 'ajax';
		if($this->Lv->is_empty($this->data['Grpaltevtlog']['rule_name']) || !$this->Validation->maxLength($this->data['Grpaltevtlog']['rule_name'],200)){
			if($this->Lv->is_empty($this->data['Grpaltevtlog']['rule_name'])){
				$errorMessage['rule_name'][] = 'E-00100';
			}
			if(!$this->Validation->maxLength($this->data['Grpaltevtlog']['rule_name'],200)){
				$errorMessage['rule_name'][] = 'E-00300';
			}
		}
		if($this->data['Grpaltevtlog']['event_catalog1'] ==0 && $this->data['Grpaltevtlog']['event_catalog2'] ==0 && $this->data['Grpaltevtlog']['event_catalog3'] ==0){
			$errorMessage['event_catalog'][] = 'E-00200';
		}
		if(!$this->Validation->maxLength($this->data['Grpaltevtlog']['source_content'],127) || !$this->Validation->maxLength($this->data['Grpaltevtlog']['specification'],2000)){
			if(!$this->Validation->maxLength($this->data['Grpaltevtlog']['source_content'],127)){
				$errorMessage['event_source'][] = 'E-00300';
			}
			if(!$this->Validation->maxLength($this->data['Grpaltevtlog']['specification'],2000)){
				$errorMessage['specification'][] = 'E-00300';
			}
		}
		if(isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);
		}
		else{
			if($this->data['Grpaltevtlog']['event_catalog1'] == 1){
				$event_catalog[] = 1;
			}
			if($this->data['Grpaltevtlog']['event_catalog2'] == 1){
				$event_catalog[] = 2;
			}
			if($this->data['Grpaltevtlog']['event_catalog3'] == 1){
				$event_catalog[] = 3;
			}
			foreach ($event_catalog as $event_catalog){
				$add = array(
				'Grpaltevtlog' => array(
				'group_id' => $this->data['Grpaltevtlog']['group_id'],
				'rule_name' => $this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['update_rule']),
				'event_catalog' => $event_catalog,
				'event_type' => $this->data['Grpaltevtlog']['event_type'],
				'source_content' => $this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['source_content']),
				'source' => empty($this->data['Grpaltevtlog']['source'])?1:0,
				'specification' => $this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['specification']),
				)
				);
				$this->Grpaltevtlog->save($add);
				$alert_id = $this->Grpaltevtlog->getLastInsertID();
				$children = $this->Grpauth->getChildrenByParent($this->data['Grpaltevtlog']['group_id']);
				foreach ($children as $group_id=>$group_name){
					$rlt_add = array(
					'Rltgrpaltevtlog' =>array(
					'group_id' => $group_id,
					'alert_id' => $alert_id,
					'org_grp_id' => $this->data['Grpaltevtlog']['group_id']
					)
					);
					$this->Rltgrpaltevtlog->save($rlt_add);
				}
			}
			if($this->data['Grpaltevtlog']['rule_name'] <> $this->data['Grpaltevtlog']['update_rule']){
				$group_id = $this->data['Grpaltevtlog']['group_id'];
				$condition = "Grpaltevtlog.rule_name = '".$this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['update_rule'])."' AND Rltgrpaltevtlog.group_id = $group_id";
				$id = $this->Grpaltevtlog->findAll($condition,'Grpaltevtlog.id');
				foreach ($id as $id){
					$add = array(
					'Grpaltevtlog' => array(
					'id' => $id['Grpaltevtlog']['id'],
					'rule_name' => $this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['rule_name']),
					)
					);
					$this->Grpaltevtlog->save($add);
				}
			}
			//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/21 added for YBR-32
			//$this->MailPopupController->setMailPop(null, $this->data['Grpaltevtlog']['group_id'], 1, '00:00:00', null, null, 1, 6, 'Grpalt');
			$MailPop = $this->MailPopupController->getMailPop('Grpalt', 'Grpalt.type = 6 and Grpalt.group_id ='.$this->data['Grpaltevtlog']['group_id']);
			if(empty($MailPop)){
				$this->MailPopupController->setMailPop(null, $this->data['Grpaltevtlog']['group_id'], 1, '00:00:00', null, null, 1, 6, 'Grpalt');
			}
			//sunhy end 2009/05/21 added for YBR-32
			$this->update_rule();
			//sunhy end 2009/03/30 added for JLN-001
		}
		$this->set_rule();
		exit();
	}
	function update_rule()
	{
		$this->layout = 'ajax';
		if($this->Lv->is_empty($this->data['Grpaltevtlog']['rule_name']) || !$this->Validation->maxLength($this->data['Grpaltevtlog']['rule_name'],200)){
			if($this->Lv->is_empty($this->data['Grpaltevtlog']['rule_name'])){
				$errorMessage['rule_name'][] = 'E-00100';
			}
			if(!$this->Validation->maxLength($this->data['Grpaltevtlog']['rule_name'],200)){
				$errorMessage['rule_name'][] = 'E-00300';
			}
		}
		if(isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);
			$this->set_rule();
			exit();
		}
		else{
			if($this->data['Grpaltevtlog']['rule_name'] <> $this->data['Grpaltevtlog']['update_rule']){
				$group_id = $this->data['Grpaltevtlog']['group_id'];
				$condition = "Grpaltevtlog.rule_name = '".$this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['update_rule'])."' AND Rltgrpaltevtlog.group_id = $group_id";
				$id = $this->Grpaltevtlog->findAll($condition,'Grpaltevtlog.id');
				foreach ($id as $id){
					$add = array(
					'Grpaltevtlog' => array(
					'id' => $id['Grpaltevtlog']['id'],
					'rule_name' => $this->Lv->spec_char_dbm($this->data['Grpaltevtlog']['rule_name']),
					)
					);
					$this->Grpaltevtlog->save($add);
				}
			}
			//sunhy start 2009/03/30 added for JLN-001
			//$this->MailPopupController->setMailPop(null, $this->_getUserGroup(), 1, '00:00:00', null, null, 1, 6, 'Grpalt');
			//sunhy start 2009/05/06 added for JLN-001
			//sunhy start 2009/05/21 added for YBR-32
			//$this->MailPopupController->setMailPop(null, $this->data['Grpaltevtlog']['group_id'], 1, '00:00:00', null, null, 1, 6, 'Grpalt');
			$MailPop = $this->MailPopupController->getMailPop('Grpalt', 'Grpalt.type = 6 and Grpalt.group_id ='.$this->data['Grpaltevtlog']['group_id']);
			if(empty($MailPop)){
				$this->MailPopupController->setMailPop(null, $this->data['Grpaltevtlog']['group_id'], 1, '00:00:00', null, null, 1, 6, 'Grpalt');
			}
			//sunhy end 2009/05/21 added for YBR-32
			//sunhy end 2009/05/06 added for JLN-001
			$this->GenerateFiles->hook_by_ps(0, array('evtlog','popup'), $this->data['Grpaltevtlog']['group_id']);
			//sunhy end 2009/03/30 added for JLN-001
			$this->set_alert();
			exit();
		}
	}
	function none()
	{
		$this->layout = 'ajax';
		$this->data = array();
		$this->index();
		$this->render('index');
	}
	function findTitleid($title_id = null)
	{
		//sunhy start 2009/05/21 modify for YBR-32
		//$title= $this->Title->find("Title.type = 6");
		$title= $this->Title->find("Title.type = 6 and Title.group_id = " . $this->data['Grpaltevtlog']['group_id']);
		//sunhy end 2009/05/21 modify for YBR-32
		return $title['Title']['id'];
	}
}
?>