<?php
/*********************************************************************
*@filename system_grpset_alert_perfs_controller.php
*@description SystemGrpsetAlertPerfsController PCリソースのしきい値超過
*@note
*@histories  rivision	author		date		comment
********************************************************************/
class SystemGrpsetAlertHdwsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'Check','MailPopupController','AlertPcController');

	var $uses=array('Group','Poll','Grpauth','Configure','Grpalthdw','Rltgrpalthdw',
	'Grpaltcpu','Rltgrpaltcpu','Grpaltmem','Rltgrpaltmem','Grpaltnet','Rltgrpaltnet','Grpalthdd','Rltgrpaltdsk','Grpaltdsk','Rltgrpalthdd',
	'Altmsg','Validation','Grpalt','Title','User','Mail');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index(){
		$this->pageTitle = __('title',$return = true);   
		$group_id= $this->_getUserGroup_id();
		//echo "group_id=".$group_id;
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$this->set('glist',$glist);

		$re = $this->index_select($group_id);

		$array_res = array();
		foreach ($glist as $gid =>$v){
			$tmp = $this->selectGrpalt($gid, "Grpalthdw");
			if(isset($tmp[0])){
				$group_name = $this->groupName($gid);
				$tmp[0]['Grpalthdw']['group_name'] = $group_name;
				$array_res[] = $tmp[0];
			}
		}
		//debug($array_res);
		$this->set('group_only',1);
		$this->set('array_res',$array_res);
	}

	/*  登録済アラートリストの捜索  */
	function index_select($group_id){
		//$this->layout='ajax';
		$res_phantosys = $this->selectRltgrpaltre($group_id,'Rltgrpalthdw');
		
		if($res_phantosys ==1) {
			$flag = 1;
		}elseif($res_phantosys ==2){
			$flag = 2;
		}else{
			$flag = 0;
		}
		return $flag;

	}

	/*   control  */
	function control($flag=null,$group_id=null){
		$this->layout='ajax';
		$group_id = $this->data["Grpaltcpu"]["group_id_select"];
		
		//$re = $this->index_select($group_id);
		$re = $this->selectRltgrpaltre($group_id,'Rltgrpalthdw');
		
		if($re == 1){
			$this->index_edit($group_id);
			exit();
		}/*elseif($re == 2){

			// you  wen ti
			$array = $this->_getGrpaltRltgrpaltName();
			foreach ($array as $key =>$value){
				$re = $this->selectRltgrpaltre($group_id,$key);
				if($re ==2) {
					$group_father = $this->selectRltgrpalt($group_id,$key);
					//debug($group_father);
					$group_father_id = $group_father[0][$key]['org_grp_id'];
					//debug($group_father_id);
				}

			}
			$this->index_add_sun($group_father_id,$group_id);
			$this->render('index_add_sun');
			exit();
		}*/else{
			$this->index_add($group_id);
			exit();
		}

	}

	/*   新規登録  */
	function index_add($group_id){
		//echo "index_add<br>";
		$this->layout='ajax';
		$groupName = $this->groupName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);
		
		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		$all = empty($this->data['Grpalthdw']['all']) ? 0: 127;
		$mon = empty($this->data['Grpalthdw']['mon']) ? 0: 2;
		$tue = empty($this->data['Grpalthdw']['tue']) ? 0: 4;
		$wed = empty($this->data['Grpalthdw']['wed']) ? 0: 8;
		$thu = empty($this->data['Grpalthdw']['thu']) ? 0: 16;
		$fri = empty($this->data['Grpalthdw']['fri']) ? 0: 32;
		$sat = empty($this->data['Grpalthdw']['sat']) ? 0: 64;
		$sun = empty($this->data['Grpalthdw']['sun']) ? 0: 1;
		$week_day = $mon+$tue+$wed+$thu+$fri+$sat+$sun;
		if($week_day < $all)
			$week_day = $all;
		$this->data["Grpalthdw"]["weekday"] = $week_day;//echo $week_day;
		@$GAP_weekday = $this->data["Grpalthdw"]["weekday"];
		@$GAP_start_time = $this->data["Grpalthdw"]["start_time"];
		
		@$GAP_not_found = $this->data["Grpalthdw"]["not_found"];
		@$GAP_title = __('default_mailtitle', true);//$this->data["Grpalthdw"]["title"];

		@$Grpaltcontent = $this->data["Altmsg"]["message"];
		//debug($Grpaltcontent);

		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)))
		{
			$error = array();

			//全部空
			if(count($error) == 0){
				$errorMessage = array();
			}else{
				$errorMessage = array();
				if(!count($error) == 0){
					$errorMessage =array_merge($errorMessage,$error);
				}
			}
			$count =count($errorMessage);
			$this->set('errorMessage', $errorMessage);

			/* 追加　*/
			if(($count == 0)&&(empty($errorMessage))) {
				//echo "right<BR>";
				$this->deleteGrpalt($group_id,'Grpalthdw');

				if ($group_id == 1)
					$this->Grpalt->query("delete from grpalts where type = 11 and group_id != 1");
		
				$this->addGrpalt($group_id,'Grpalthdw','Rltgrpalthdw');

				$this->index();
				$this->render('index');
				exit();

			}
		}
		/*　ページの保存　*/
		$this->set('GAP_weekday', @$GAP_weekday);
		$this->set('GAP_start_time', @$GAP_start_time);
		
		$this->set('GAP_not_found', @$GAP_not_found);
		$this->set('GAP_title', @$GAP_title);

		$this->set('flg',1);
		//debug($this->data);
		if(!empty($errorMessage)){
			$this->render('index_add');
			exit();
		}
		$this->render('index_add');
	}

	/*   編集  */
	function index_edit($group_id){

		//echo "index_edit<br>";
		$this->layout='ajax';
		$groupName = $this->groupName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		$this->set('email',$email);
		
		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		if(!isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"]))
		{
			$condition = "Grpalthdw.group_id =".$group_id." ";
			$grpalt = $this->Grpalthdw->findAll($condition);
			
			foreach($grpalt as $v){
				foreach($v as $k =>$va){
					$GAP_weekday = $va["weekday"];
					$GAP_start_time = $va["start_time"];
					
					$GAP_not_found = $va["not_found"];
					$GAP_title = $va["title"];
				}
			}
			
		}

		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)))
		{
			$all = empty($this->data['Grpalthdw']['all']) ? 0: 127;
			$mon = empty($this->data['Grpalthdw']['mon']) ? 0: 2;
			$tue = empty($this->data['Grpalthdw']['tue']) ? 0: 4;
			$wed = empty($this->data['Grpalthdw']['wed']) ? 0: 8;
			$thu = empty($this->data['Grpalthdw']['thu']) ? 0: 16;
			$fri = empty($this->data['Grpalthdw']['fri']) ? 0: 32;
			$sat = empty($this->data['Grpalthdw']['sat']) ? 0: 64;
			$sun = empty($this->data['Grpalthdw']['sun']) ? 0: 1;
			$week_day = $mon+$tue+$wed+$thu+$fri+$sat+$sun;
			if($week_day < $all)
				$week_day = $all;
			$this->data["Grpalthdw"]["weekday"] = $week_day;//echo $week_day;
			@$GAP_weekday = $this->data["Grpalthdw"]["weekday"];
			@$GAP_start_time = $this->data["Grpalthdw"]["start_time"];
			
			@$GAP_not_found = $this->data["Grpalthdw"]["not_found"];
			@$GAP_title = $this->data["Grpalthdw"]["title"];
		
			$error = array();

			$count =count($error);
			$this->set('errorMessage', $error);

			/* 追加　*/
			if(($count == 0)&&(empty($error)))
			{
				if($this->selectGrpaltFlag($group_id,'Grpalthdw') ==1){
					$this->editGrpalt($group_id,'Grpalthdw');
				}else{
					$this->deleteGrpalt($group_id,'Grpalthdw');
					$this->addGrpalt($group_id,'Grpalthdw','Rltgrpalthdw');
				}
				
				//$this->edit_grpalt($group_id,$checkbox_flag);
				$this->edit_grpalt($group_id,1);
				$this->index();
				$this->render('index');
				exit();
			}
		}

		/*　ページの保存　*/
		$this->set('GAP_weekday', @$GAP_weekday);
		$this->set('GAP_start_time', @$GAP_start_time);
		
		$this->set('GAP_not_found', @$GAP_not_found);
		$this->set('GAP_title', @$GAP_title);
		
		$this->set('flg',2);

		$this->render('index_add');

	}


	/**
     *  上位グループの設定 
     * 
     * */
	function index_add_sun($group_father_id,$group_id,$flag=null){
		//echo "index_add_sun<br>";
		$this->layout='ajax';
		$groupName = $this->groupName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_father_id',$group_father_id);
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);
		
		$condition = "Grpalthdw.group_id =".$group_father_id." ";
		$grpalt = $this->Grpalthdw->findAll($condition);
		
		foreach($grpalt as $v){
			foreach($v as $k =>$va){
				$GAP_weekday = $va["weekday"];
				$GAP_start_time = $va["start_time"];
				
				$GAP_not_found = $va["not_found"];
				$GAP_title = $va["title"];
			}
		}

		/*　ページの保存　*/
		$this->set('GAP_weekday', @$GAP_weekday);
		$this->set('GAP_start_time', @$GAP_start_time);
		
		$this->set('GAP_not_found', @$GAP_not_found);
		$this->set('GAP_title', @$GAP_title);

	}

	/**
  	  *  空白と数値の判定 
  	  * */
	function error_judge_numeric(&$errorMessage, $value = null,$name1=null){
		$re1 =$this->Lv->is_empty($value);
		if(!$re1){
			$result = $this->Validation->numeric($value);
			if(!$result){
				$errorMessage[$name1][] = 'E-00600';
			}else{
				if($value < 0){
					$errorMessage[$name1][] = 'cpu_above';
				}
			}
		}
	}

	/* グループ共通の判定 */
	function error_judge_grpalt($content = null,$name2){
		$re1 =$this->Lv->is_empty($content);
		if($re1){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!$re1){
			if(!$this->Validation->maxLength($content,2000)){
				$errorMessage[$name2][] = 'E-00300';
			}
		}

		return $errorMessage;
	}

	
	/**
	 *
	 * 新規登録
	 */
	/* 新規追加CPU,ディスクIO */
	function addGrpalt($group_id,$table_name,$link_name){
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		
		$weekday = $this->data[$table_name]["weekday"];
		$start_time = $this->data[$table_name]["start_time"];
		
		$not_found = $this->data[$table_name]["not_found"];
		$title = $this->data[$table_name]["title"];
		
		$insert=Array(
		$table_name => Array(
		'weekday'  => $weekday ,
		'start_time'  => $start_time ,
		
		'not_found' => $not_found,
		'group_id' =>  $group_id,
		'title' =>  $title,
		)
		);
		$this->$table_name->save($insert);
		$grpalt_id = $this->$table_name->getLastInsertID();
		foreach ($glist as $key=>$value) {

			$insertrlt=Array(
			$link_name => Array(
			'group_id' => $key,
			'alert_id' => $grpalt_id,
			'org_grp_id' =>  $group_id,
			)
			);
			$this->$link_name->save($insertrlt);
		}
	}
	

	/*  編集グループ共通 */
	function edit_grpalt($group_id,$checkbox_flag){
		//echo "edit_grpalt<br>";

		$grpalt_id = $this->grpalt_list_id($group_id);
		if($checkbox_flag == 1) {
			//echo "edit_grpalt :up_cast=1<br>";
			if($this->data["Grpalt"]["mail_notice"] == 2){
				$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
			}else{
				$mail_notice_time = '00:00:00';
			}
			if(isset($this->data["Grpalt"]["mail_notice"])){
				$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, $popup, null, null, 11, 'Grpalt');

				$getUserGroup = $this->_getUserGroup_id();

			}
		}elseif($checkbox_flag == 0) {
			$this->MailPopupController->setMailPop($grpalt_id, $group_id, null, null, null, null, null, 11, 'Grpalt');
		}
		//	$this->GenerateFiles->hook_by_group($group_id, array("perfalert"));
	}

	/**
	 *
	 * 変更する
	 */
	function editGrpalt($group_id,$table_name){
		$weekday = $this->data[$table_name]["weekday"];
		$start_time = $this->data[$table_name]["start_time"];
		
		$not_found = $this->data[$table_name]["not_found"];
		$title = $this->data[$table_name]["title"];
		
		$grpalt = $this->selectGrpalt($group_id,$table_name);
		$grpalt_id = $grpalt[0][$table_name]['id'];
		$insert=Array(
			$table_name => Array(
			'id' => $grpalt_id,
			'weekday'  => $weekday ,
			'start_time'  => $start_time ,
			'not_found' => $not_found,
			'group_id' =>  $group_id,
			'title' =>  $title,
			)
		);
		$this->$table_name->save($insert);

	}

	
	/**
	 *
	 * 下位グループの設定の解除
	 */   

	function deleteGrpalt($group_id,$table_name){
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		foreach($glist as $key => $value){
			$condition = $table_name.".group_id =".$key." ";
			//echo  $condition;
			$grpalt = $this->$table_name->findAll($condition);
			//debug($grpalt);
			if(count($grpalt) == 1){
				$grpalt_id = $grpalt[0]["$table_name"]["id"];
				$this->$table_name->del($grpalt_id);
			}
		}

	}

	/*目前のグループの削除*/

	function delete(){

		$this->layout='ajax';
		$g_new = array();
		if(isset($this->data['Grpaltcpu']['del'])){
			$word_id=$this->data["Grpaltcpu"]["del"];
			//debug($word_id);
			foreach ($word_id as $value){
				/*$g_new[]=$value;
				$delete_list =$this->data['Grpalt']['del_id'];
				$delete = $delete_list[$value];
				debug($delete);
				foreach($delete as $key=>$id) {
					$condition = $key.".id =".$id[0]." ";
					$grpalt = $this->$key->findAll($condition);
					if(count($grpalt) == 1){
						$grpalt_id = $grpalt[0]["$key"]["id"];
						$this->$key->del($grpalt_id);
					}
				}*/
				$del_grpalt = $this->grpalt_list_id($value);
				$this->Grpalthdw->del($del_grpalt);
				
				$this->Rltgrpalthdw->deleteAll(Array("Rltgrpalthdw.org_grp_id =".$value));

			}

		}else{//未選択
			$error =__('E-00200',$return = true);
			$errorMessage['entry'] = $error;
			$this->set('errorMessage', $errorMessage);
		}
		$this->index();
		$this->render('index');
		exit();
	}




	/**
	 *登録ユーザ属するグループ取得

	 *
	 * @return ユーザのグループID　Group.id
	 */
/*	function _getUserGroup()
	{
		$usergroup =1;///////////////////Sessionから
		return $usergroup;
	}*/
	function _getUserGroup_id(){
	   return $this->_getUserGroup();
	}
	function _getGrpaltRltgrpaltName()
	{
		//$array = array('Rltgrpaltcpu'=>'Grpaltcpu','Rltgrpaltmem'=>'Grpaltmem','Rltgrpaltnet'=>'Grpaltnet','Rltgrpaltdsk'=>'Grpaltdsk','Rltgrpalthdd'=>'Grpalthdd');
		$array = array('Rltgrpalthdw'=>'Grpalthdw');
		return $array;
	}
	/* グループ名の取得 */
	function groupName($group_id){

		$condition=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($condition);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;

	}

	/* アラート設定の取得 */
	function selectGrpalt($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		return $grpalt;

	}
	function selectId($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		if(count($grpalt == 1)){
			$id=$grpalt[0][$table_name]["id"];
			return $id;
		}else{
			return 0;
		}
	}	
	function selectGrpaltFlag($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		if(count($grpalt) ==1){
			$flag =1;
		}else{
			$flag =0;
		}
		return $flag;

	}

	/* 関連設定の取得 */
	function selectRltgrpalt($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		return $grpalt;

	}
	
	function selectRltgrpaltre($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);

		if(count($grpalt) == 1){
			$group_id = $grpalt[0]["$table_name"]["group_id"];
			$org_grp_id = $grpalt[0]["$table_name"]["org_grp_id"];
			if($group_id == $org_grp_id){
				$fiag = 1;
			}elseif($group_id !=$org_grp_id){
				$fiag = 2;
			}
		}elseif(count($grpalt) == 0){
			$fiag = 0;
		}
		return $fiag;

	}

	function group_father_id($group_id){
		$criteria=" Group.id=".$group_id." ";
		$group_i= $this->Group->findAll($criteria);
		$group_father_i = $group_i[0]["Group"]["parent_id"];
		return $group_father_i;

	}

	function grpalt_list($group_id){
		$condition =" Grpalthdw.group_id =".$group_id;
		$grpalt = $this->Grpalthdw->findAll($condition);
		return $grpalt;

	}
	function grpalt_list_id($group_id){
		$condition =" Grpalthdw.group_id =".$group_id;
		$grpalt = $this->Grpalthdw->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalthdw"]["id"];
		}else{
			$id =0;
		}
		return $id;

	}

	function _getemail($group_id){
		//$group_id= $this->_getUserGroup();
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		//debug($data_email);
		return $data_email;

	}
	
	function reset(){
		$this->layout='ajax';
		$this->index();
		$this->render('index');

	}

}