<?php
/*********************************************************************
*@filename system_grpset_alert_perfs_controller.php
*@description SystemGrpsetAlertPerfsController PCリソースのしきい値超過
*@note
*@histories  rivision	author		date		comment
*            2.0      zhangzn     2008/10/22   modify for 脆弱性改修3.3
*            2.0      xuchan     2008/10/28   modify for 脆弱性改修3.1
*            2.0        xht        2008/10/24   //modify for 脆弱性3.5
*            2.0        yzl        2008/10/29   //modify for 脆弱性3.2
*            2.0        xinw      2009/02/17   modify for ASP4-033
*            2.0        xuhaitao    2009/03/03   modify for ASP4-033
*            2.0      yuanxiaojun    2009/03/05   modify for ASP4-033
*            2.0        sunhy    	  2009/03/24   modify for JLN-001
*            2.0        xushanning  2009/04/23  modify for LogvillageChinese
*            2.0        sunhy    	  2009/05/22   modify for YBR-32
*            2.0        sunhy    	  2009/07/25 modify for JL-0035
********************************************************************/
class SystemGrpsetAlertPerfsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	
	//sunhy start 2009/03/04 modify for JLN-001
	//var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'Check','MailPopupController','AlertPcController');
	//sunhy end 2009/03/04 modify for JLN-001
	var $uses=array('Group','Poll','Grpauth','Configure','Grpaltcpu','Rltgrpaltcpu','Altmsg','Grpaltmem','Rltgrpaltmem','Grpaltnet','Rltgrpaltnet','Grpalthdd','Rltgrpaltdsk','Grpaltdsk','Rltgrpalthdd','Validation','Grpalt','Title','User','Mail');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index(){
		$this->pageTitle = __('title',$return = true);   
		$group_id= $this->_getUserGroup_id();
		//echo "group_id=".$group_id;
		$glist = $this->Group->getChildrenByParent($group_id);
		//ksort($glist);
		$this->set('glist',$glist);

		$re = $this->index_select($group_id);
		$array = $this->_getGrpaltRltgrpaltName();

		/* 自己グループ */
		if($re == 1){ //echo "re == 1<br>";
			foreach ($array as $key =>$value){
				//debug($key);
				$res = $this->selectRltgrpaltre($group_id,$key);
				if($res == 1){
					$array_res[] = $this->selectGrpalt($group_id,$value);
				}
			}
			//debug($array_res);
			$this->set('group_only',1);
			$group_name = $this->groupName($group_id);
			$this->set('group_name',$group_name);
			$this->set('array_res',$array_res);

			/*   上位グループ   */
		}elseif($re == 2){//echo "re == 2<br>";
			foreach ($array as $key =>$value){
				$group_father = $this->selectRltgrpalt($group_id,$key);
				if((count($group_father) ==1)){
					$group_father_id = $group_father[0][$key]['org_grp_id'];
				}
			}
			foreach ($array as $key =>$value){
				$res = $this->selectRltgrpaltre($group_father_id,$key);
				if($res == 1){
					$array_res[] = $this->selectGrpalt($group_father_id,$value);
				}
			}
			$group_name = $this->groupName($group_father_id);
			$this->set('group_name',$group_name);
			$this->set('array_res',$array_res);
			$this->set('group_only',2);
			
			/*  上位グループの設定を引き継ぐ  */
			/*$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($group_father_id,11);

			if($checkbox_flag == '0'){
				$group_father_i = $this->group_father_id($group_father_id);
				$data_father_group_c=$this->grpalt_list($group_father_i);
				if(count($data_father_group_c) ==1){
					$data_group[$group_id]["Grpalt"]= $data_father_group_c;
				}
			}elseif($checkbox_flag == '1'){
				$data_group_c=$this->grpalt_list($group_father_id);
				if(count($data_group_c) ==1){
					$data_group[$group_father_id]["Grpalt"]= $data_group_c;
				}
			//}*/
			$data_group_c=$this->grpalt_list($group_father_id);
			if(count($data_group_c) ==1){
				$data_group[$group_father_id]["Grpalt"]= $data_group_c;
			}
			$this->set('data_group',@$data_group);


			/*   下位グループ  */
		}elseif($re == 0){//echo "re == 0<br>";
			foreach ($glist as $group_id =>$v){
				//debug($group_id);
				$re_s= $this->index_select($group_id);
				if($re_s == 1){
					foreach ($array as $key =>$value){
						//debug($key);
						$res = $this->selectRltgrpaltre($group_id,$key);
						if($res == 1){
							$array_res[$group_id][] = $this->selectGrpalt($group_id,$value);
							$group_name = $this->groupName($group_id);
							$group_na[$group_id] = $group_name;
						}
					}
				}

			}
			//debug($array_res);
			$this->set('group_only',0);
			$this->set('array_res',@$array_res);
			$this->set('group_na',@$group_na);
		}
		//echo "re=".$re."<br>";
		if($re == 1){//echo "!0<br>";
				$data_group_c=$this->grpalt_list($group_id);
				if(count($data_group_c) ==1){
					$data_group[$group_id]["Grpalt"]= $data_group_c;
				}
/*			$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($group_id,11);
			if($checkbox_flag == '0'){
				//echo "checkbox_flag == '0'<br>";
				$group_father_i = $this->group_father_id($group_id);
				$data_father_group_c=$this->grpalt_list($group_father_i);
				if(count($data_father_group_c) ==1){
					$data_group[$group_id]["Grpalt"]= $data_father_group_c;
				}
			}elseif($checkbox_flag == '1'){
				$data_group_c=$this->grpalt_list($group_id);
				if(count($data_group_c) ==1){
					$data_group[$group_id]["Grpalt"]= $data_group_c;
				}
			}*/
		}elseif($re == 0){
			foreach ($glist as $group_id =>$v){
					$data_group_c=$this->grpalt_list($group_id);
					if(count($data_group_c) ==1){
						$data_group[$group_id]["Grpalt"]= $data_group_c;
					}
/*				$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($group_id,11);
				if($checkbox_flag == 1){
					$data_group_c=$this->grpalt_list($group_id);
					if(count($data_group_c) ==1){
						$data_group[$group_id]["Grpalt"]= $data_group_c;
					}
				}*/

			}

		}
		$this->set('data_group',@$data_group);
	}

	/*  登録済アラートリストの捜索  */
	function index_select($group_id){
		//$this->layout='ajax';
		$res_cpu = $this->selectRltgrpaltre($group_id,'Rltgrpaltcpu');
		$res_mem = $this->selectRltgrpaltre($group_id,'Rltgrpaltmem');
		$res_net = $this->selectRltgrpaltre($group_id,'Rltgrpaltnet');
		$res_hdd = $this->selectRltgrpaltre($group_id,'Rltgrpalthdd');
		$res_dsk = $this->selectRltgrpaltre($group_id,'Rltgrpaltdsk');
		$array = $this->_getGrpaltRltgrpaltName();
		if(($res_cpu ==1)||($res_mem==1)||($res_net == 1)||($res_hdd ==1)||($res_dsk ==1)) {
			$flag = 1;
		}elseif(($res_cpu ==2)||($res_mem==2)||($res_net == 2)||($res_hdd ==2)||($res_dsk ==2)){
			$flag = 2;
		}else{
			$flag = 0;
		}
		return $flag;

	}

	/*   control  */
	function control($flag=null,$group_id=null){
		$this->layout='ajax';
		$group_id = $this->data["Grpaltcpu"]["group_id_select"];

		$re = $this->index_select($group_id);
		$array = $this->_getGrpaltRltgrpaltName();
		if($re == 1){
			$this->index_edit($group_id);
			exit();
		}elseif($re == 2){

			// you  wen ti
			$array = $this->_getGrpaltRltgrpaltName();
			foreach ($array as $key =>$value){
				$re = $this->selectRltgrpaltre($group_id,$key);
				if($re ==2) {
					$group_father = $this->selectRltgrpalt($group_id,$key);
					//debug($group_father);
					$group_father_id = $group_father[0][$key]['org_grp_id'];
					//debug($group_father_id);
				}

			}
			$this->index_add_sun($group_father_id,$group_id);
			$this->render('index_add_sun');
			exit();
		}else{
			$this->index_add($group_id);
			exit();
		}

	}

	/*   新規登録  */
	function index_add($group_id){
		//echo "index_add<br>";
		$this->layout='ajax';
		$groupName = $this->groupName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);
		
		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
/*		if((isset($this->data['Grpalt']['up_cast']))&&($this->data['Grpalt']['up_cast'] == '1')){
			//上位グループの設定を引き継ぐ
			$checkbox_flag =0;
		}else{
			$checkbox_flag =1;
		}*/

		//上位グループの設定を引き継ぐ
		$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,11);
		//if(@$this->data["Grpaltcpu"]["Grpaltcpu_flag"] != 1) {
		if(!isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])) {
			if($grpalt_f == 1){  //echo "111<br>";
				$grpalt_r = $this->grpalt_list($group_id);
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
        		($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';
    	        $this->set('mail_notice_time_c',$mail_notice_time_c);
				$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;

			}else{ //echo "22<br>";
				$this->data['Grpalt']['mail_notice'] = 1;
				$this->data['Grpalt']['popup'] = 2;
				$this->set('mail_notice_time_c','');
				$up_cast_flag = 1;
			}

			/*  件名管理情報,エラー情報  */
			//sunhy start 2009/05/22 modify for YBR-32
			
			//if($getUserGroup == 1){
			if(!empty($getUserGroup)){	
			//sunhy end 2009/05/22 modify for YBR-32
				//sunhy start 2009/05/22 modify for YBR-32
				//$title =$this->title_list();
				$titleflg =$this->title_list($group_id);
				//sunhy end 2009/05/22 modify for YBR-32
				//$this->data['Title']['title_flg'] = ($titleflg!=1)?1:0;
				if($titleflg== 2){
					$this->data['Title']['title_flg'] = 1;
				}
				else {
					$this->data['Title']['title_flg'] = ($titleflg == 1) ? 0 : 1;
				}
				
				//sunhy start 2009/05/22 modify for YBR-32
				//$altmsg_list =$this->altmsg_list();
				$altmsg_list =$this->altmsg_list($group_id);
				//sunhy end 2009/05/22 modify for YBR-32
				//echo $altmsg_list[0]['Altmsg']['detail_flg'];
				if($altmsg_list !=2){
					//sunhy start 2009/03/25 modify for JLN-001
					//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
					$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?0:1;
					$msg = $this->MailPopupController->getAltMsg('E0008', $group_id);
					if($msg['Altmsg']['detail_flg']== 0){
						$this->data['Altmsg']['detail_flg'] = 0;
					}
					else {
						$this->data['Altmsg']['detail_flg'] = 1;
					}
					if($msg['Altmsg']['detail_flg']== ""){
						$this->data['Altmsg']['detail_flg'] = 1;
					}
					//sunhy end 2009/03/25 modify for JLN-001
				}else{
					$this->data['Altmsg']['detail_flg'] = 1;
				}
				//sunhy start 2009/05/22 modify for YBR-32
				//$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
				$altmsg=$this->Altmsg->findAll(array("message_id='E0008'","Altmsg.group_id=".$group_id));
				if(!empty($altmsg[0]['Altmsg']['message'])){
					$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
				}else{
					$this->data['Altmsg']['message']=__('E0008',$return = true);
				}
				//sunhy end 2009/05/22 modify for YBR-32
			}
		}
/*		if(!isset($up_cast_flag)){
			$up_cast_flag = 1;
		}
		$this->set('up_cast_flag',$up_cast_flag);*/



		@$Grpaltcpuinter_time = $this->data["Grpaltcpu"]["inter_time"];
		@$Grpaltcpupercent = $this->data["Grpaltcpu"]["percent"];

		@$Grpaltmeminter_time = $this->data["Grpaltmem"]["capacity"];
//		@$Grpaltmempercent = $this->data["Grpaltmem"]["percent"];

		@$Grpalthddpercent = $this->data["Grpalthdd"]["capacity"];

		@$Grpaltnetinter_time = $this->data["Grpaltnet"]["inter_time"];
		@$Grpaltnetpercent = $this->data["Grpaltnet"]["capacity"];

		@$Grpaltdskinter_time = $this->data["Grpaltdsk"]["inter_time"];
		@$Grpaltdskpercent = $this->data["Grpaltdsk"]["percent"];

		@$Grpaltcontent = $this->data["Altmsg"]["message"];
		//debug($Grpaltcontent);

		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)))
		{
			@$result_cpu = $this->error_judge($Grpaltcpuinter_time,$Grpaltcpupercent,'Grpaltcpuinter_time','Grpaltcpupercent');
			@$result_mem = $this->error_judge_hdd($Grpaltmeminter_time,'Grpaltmeminter_time');
			@$result_hdd = $this->error_judge_hdd($Grpalthddpercent,'Grpalthddpercent');
			@$result_net = $this->error_judge_dsk($Grpaltnetinter_time,$Grpaltnetpercent,'Grpaltnetinter_time','Grpaltnetpercent');
			@$result_dsk = $this->error_judge($Grpaltdskinter_time,$Grpaltdskpercent,'Grpaltdskinter_time','Grpaltdskpercent');
/*			if($checkbox_flag == 1){*/
				//sunhy start 2009/05/22 modify for YBR-32
			//if($getUserGroup == 1){
			//sunhy end 2009/05/22 modify for YBR-32
					@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');
					if(!count($result_content) == 0){
						$re = 0;
					}else{
						$re = 1;
					}
				//sunhy start 2009/05/22 modify for YBR-32	
//			}else{
//				$re = 1;
//			}
			//sunhy end 2009/05/22 modify for YBR-32
/*			}else{
				$re = 1;
			}*/
			if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
				($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
			}else{
				$res_hour=1;
			}
			if((count($result_cpu) == 0)&&(count($result_mem) == 0)&&(count($result_net) == 0)&&(count($result_dsk) == 0)&&(count($result_hdd) == 0)&&($re == 1)&&($res_hour == 1)){
				$errorMessage = array();
				if((trim($Grpaltcpuinter_time) == '')&&(trim($Grpaltcpupercent) == '')&&(trim($Grpaltmeminter_time) == '')&&(trim($Grpalthddpercent) == '')&&(trim($Grpaltnetinter_time) =='')&&(trim($Grpaltnetpercent) == '')&&(trim($Grpaltdskinter_time) == '')&&(trim($Grpaltdskpercent) =='')) {
					$Message['Error'][] = 'E-00100';
					$errorMessage = array_merge($errorMessage,$Message);
				}
/*				if($checkbox_flag == 0) {
					$flag = $this->Group->getFatherSet($group_id,$this->Grpalt,11);
					if($flag ==0){
						$Message['father_group_alert_inherit'][] = 'father_group_set_no';
						$errorMessage = array_merge($errorMessage,$Message);
					}
				}*/
			}else{
				$errorMessage = array();
				if(!count($result_cpu) == 0){
					$errorMessage =array_merge($errorMessage,$result_cpu);
				}
				if(!count($result_mem) == 0){
					$errorMessage =array_merge($errorMessage,$result_mem);
				}
				if(!count($result_net) == 0){
					$errorMessage =array_merge($errorMessage,$result_net);
				}
				if(!count($result_hdd) == 0){
					$errorMessage =array_merge($errorMessage,$result_hdd);
				}
				if(!count($result_dsk) == 0){
					$errorMessage =array_merge($errorMessage,$result_dsk);
				}

				$errorMessage_alert = array();
				if($re == 0){
					$errorMessage_alert =array_merge($errorMessage_alert,$result_content);
				}
				if($res_hour == 0){
	  				$error =__('E-00100',$return = true);
	  				$time=__('time',$return=true);
					$errorMessage_alert[$time][] = $error;
					$this->set('errorMessage_alert', $errorMessage_alert);						
				}
			}
			$count =count($errorMessage);
			(!empty($errorMessage_alert))?($this->set('errorMessage_alert', $errorMessage_alert)):(null);
			$this->set('errorMessage', $errorMessage);

			/* 追加　*/
			if(($count == 0)&&(empty($errorMessage))&&(empty($errorMessage_alert))) {
				//echo "right<BR>";
				$this->deleteGrpalt($group_id,'Grpaltcpu');
				$this->deleteGrpalt($group_id,'Grpaltmem');
				$this->deleteGrpalt($group_id,'Grpalthdd');
				$this->deleteGrpalt($group_id,'Grpaltnet');
				$this->deleteGrpalt($group_id,'Grpaltdsk');
				//chenhao start 2009/11/02 modified for JL-0048
				if ($group_id == 1)
					$this->Grpalt->query("delete from grpalts where type = 11 and group_id != 1");
				//chenhao end 2009/11/02 modified for JL-0048
				//sunhy start 2009/07/25 modify for JL-0035
				$this->MailPopupController->delAltMsg("E0008", $group_id, 1);
    				$this->MailPopupController->delAltTit(11, $group_id, 1);
				//sunhy end 2009/07/25 modify for JL-0035
				if(trim($Grpaltcpuinter_time) != ''){
					$this->addGrpalt($group_id,'Grpaltcpu','Rltgrpaltcpu');
				}
				if(trim($Grpaltmeminter_time) != ''){
					//$this->addGrpalt($group_id,'Grpaltmem','Rltgrpaltmem');
					$this->addGrpalthdd($group_id,'Grpaltmem','Rltgrpaltmem');
				}
				if(trim($Grpalthddpercent) != ''){
					$this->addGrpalthdd($group_id,'Grpalthdd','Rltgrpalthdd');
				}
				if(trim($Grpaltnetinter_time) != ''){
					$this->addGrpaltnet($group_id,'Grpaltnet','Rltgrpaltnet');
				}
				if(trim($Grpaltdskinter_time) != ''){
					$this->addGrpalt($group_id,'Grpaltdsk','Rltgrpaltdsk');
				}

				//新規グループ共通の追加
				//$this->add_grpalt($group_id,$checkbox_flag);
				$this->add_grpalt($group_id,1);
				$this->index();
				$this->render('index');
				exit();

			}
		}
		/*　ページの保存　*/
		$this->set('Grpaltcpuinter_time', @$Grpaltcpuinter_time);
		$this->set('Grpaltcpupercent', @$Grpaltcpupercent);
		$this->set('Grpaltmeminter_time', @$Grpaltmeminter_time);
		$this->set('Grpaltmempercent', @$Grpaltmempercent);
		$this->set('Grpaltnetinter_time', @$Grpaltnetinter_time);
		$this->set('Grpaltnetpercent', @$Grpaltnetpercent);
		$this->set('Grpaltdskinter_time', @$Grpaltdskinter_time);
		$this->set('Grpaltdskpercent', @$Grpaltdskpercent);
		$this->set('Grpalthddpercent', @$Grpalthddpercent);
		$this->set('flg',1);
		//debug($this->data);
		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1))) {
			if(!empty($errorMessage)||!empty($errorMessage_alert)){
/*				if($checkbox_flag == 0){
					$title =$this->title_list();
					$this->data['Title']['title_flg'] = ($title==1)?0:1;
					$altmsg_list =$this->altmsg_list();
					$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==1)?0:1;
					$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
					if($grpalt_f == 1){
						$grpalt_r = $this->grpalt_list($group_id);
						$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
						$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
						$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
					}else{
						$this->data['Grpalt']['mail_notice'] =3;
						$this->data['Grpalt']['popup'] = 1;
						$mail_notice_time_c = '00';
						
					}
					$this->set('up_cast_flag',0);
				}else{
					$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
				}*/
				isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->render('index_add');
				exit();
			}
		}
		$this->render('index_add');
	}

	/*   編集  */
	function index_edit($group_id){

		//echo "index_edit<br>";
		$this->layout='ajax';
		$groupName = $this->groupName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		$this->set('email',$email);
		
		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//現す

		if(!isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])){
				$array = $this->_getGrpaltRltgrpaltName();
				foreach ($array as $key =>$value){
					$result = $this->selectGrpalt($group_id,$value);
					if(count($result) == 1){
						$array_res[] = $result[0];
					}
				}
				//debug($array_res);
				foreach($array_res as $v){
					foreach($v as $k =>$va){
						if($k == "Grpaltcpu"){
							$Grpaltcpuinter_time = $va['inter_time'];
							$Grpaltcpupercent = $va['percent'];
						}elseif($k == "Grpaltmem"){
							$Grpaltmeminter_time = $va['capacity'];
						}elseif($k == "Grpaltnet"){
							$Grpaltnetinter_time =$va['inter_time'];
							$Grpaltnetpercent =$va['capacity'];
						}elseif($k == "Grpaltdsk"){
							$Grpaltdskinter_time = $va['inter_time'];
							$Grpaltdskpercent = $va['percent'];					
						}elseif($k == "Grpalthdd"){
							$Grpalthddpercent=$va['capacity'];
						}
					}
		
				}
		}
		/*if((isset($this->data['Grpalt']['up_cast']))&&($this->data['Grpalt']['up_cast'] == '1')){*/
			/*  上位グループの設定を引き継ぐ */
/*			$checkbox_flag =0;
		}else{
			$checkbox_flag =1;
		}*/

		/*  上位グループの設定を引き継ぐ  */

		$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,11);
		if($grpalt_f == 1){
			$grpalt_r = $this->grpalt_list($group_id);
			if(@$this->data["Grpaltcpu"]["Grpaltcpu_flag"] != 1) {
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
				($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';
				$this->set('mail_notice_time_c',$mail_notice_time_c);

				/*$grpalt_up_cast = $grpalt_r[0]["Grpalt"]["up_cast"];*/
			}
		}
/*		if(!isset($grpalt_up_cast)||($grpalt_up_cast ==1))	{
			$up_cast_flag = 1;
		}elseif($grpalt_up_cast ==0){
			$up_cast_flag = 0;
		}
		$this->set('up_cast_flag',$up_cast_flag);*/


		/*  件名管理情報,エラー情報  */
		//sunhy start 2009/05/22 delete for YBR-32
		//if($getUserGroup == 1){
		//sunhy end 2009/05/22 delete for YBR-32
			if(@$this->data["Grpaltcpu"]["Grpaltcpu_flag"] != 1) {
				//sunhy start 2009/05/22 modify for YBR-32
				//$title =$this->title_list();
				$title =$this->title_list($group_id);
				//sunhy end 2009/05/22 modify for YBR-32
				$this->data['Title']['title_flg'] = ($title==0)?1:0;
				//sunhy start 2009/05/22 modify for YBR-32
				//$altmsg_list =$this->altmsg_list();
				$altmsg_list =$this->altmsg_list($group_id);
				//sunhy end 2009/05/22 modify for YBR-32
				//debug($altmsg_list,true);
				//sunhy start 2009/03/30 modify for JLN-001
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
				$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?0:1;
				//sunhy end 2009/03/30 modify for JLN-001
				$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			}
		//sunhy start 2009/05/22 delete for YBR-32
		//}
		//sunhy end 2009/05/22 delete for YBR-32

		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)))
		{
			
			@$Grpaltcpuinter_time = $this->data["Grpaltcpu"]["inter_time"];
			@$Grpaltcpupercent = $this->data["Grpaltcpu"]["percent"];
			
			@$Grpaltmeminter_time = $this->data["Grpaltmem"]["capacity"];

			@$Grpalthddpercent = $this->data["Grpalthdd"]["capacity"];

			@$Grpaltnetinter_time = $this->data["Grpaltnet"]["inter_time"];
			@$Grpaltnetpercent = $this->data["Grpaltnet"]["capacity"];

			@$Grpaltdskinter_time = $this->data["Grpaltdsk"]["inter_time"];
			@$Grpaltdskpercent = $this->data["Grpaltdsk"]["percent"];
			@$Grpaltcontent = $this->data["Altmsg"]["message"];
			@$result_cpu = $this->error_judge($Grpaltcpuinter_time,$Grpaltcpupercent,'Grpaltcpuinter_time','Grpaltcpupercent');
			@$result_mem = $this->error_judge_hdd($Grpaltmeminter_time,'Grpaltmeminter_time');
			@$result_hdd = $this->error_judge_hdd($Grpalthddpercent,'Grpalthddpercent');
			@$result_net = $this->error_judge_dsk($Grpaltnetinter_time,$Grpaltnetpercent,'Grpaltnetinter_time','Grpaltnetpercent');
			@$result_dsk = $this->error_judge($Grpaltdskinter_time,$Grpaltdskpercent,'Grpaltdskinter_time','Grpaltdskpercent');
			/*if($checkbox_flag == 1){*/
				//sunhy start 2009/05/22 delete for YBR-32
			//if($getUserGroup == 1){
			//sunhy end 2009/05/22 delete for YBR-32
					@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');
					if(!count($result_content) == 0){
						$re = 0;
					}else{
						$re = 1;
					}
				//sunhy start 2009/05/22 delete for YBR-32	
//			}else{
//				$re = 1;
//			}
			//sunhy end 2009/05/22 delete for YBR-32
/*			}else{
				$re = 1;
			}*/
			if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
				($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
			}else{
				$res_hour=1;
			}
			if((count($result_cpu) == 0)&&(count($result_mem) == 0)&&(count($result_net) == 0)&&(count($result_dsk) == 0)&&(count($result_hdd) == 0)&&($re == 1)&&($res_hour ==1)){
				$errorMessage = array();
				if((trim($Grpaltcpuinter_time) == '')&&(trim($Grpaltcpupercent) == '')&&(trim($Grpaltmeminter_time) == '')&&(trim($Grpalthddpercent) == '')&&(trim($Grpaltnetinter_time) == '')&&(trim($Grpaltnetpercent) == '')&&(trim($Grpaltdskinter_time) == '')&&(trim($Grpaltdskpercent) =='')) {
					$Message['Error'][] = 'E-00100';
					$errorMessage = array_merge($errorMessage,$Message);
				}
/*				if($checkbox_flag == 0) {
					$flag = $this->Group->getFatherSet($group_id,$this->Grpalt,11);
					if($flag ==0){
						$Message['father_group_alert_inherit'][] = 'father_group_set_no';
						$errorMessage = array_merge($errorMessage,$Message);

					}
				}*/
			}else{
				$errorMessage = array();
				if(!count($result_cpu) == 0){
					$errorMessage =array_merge($errorMessage,$result_cpu);
				}
				if(!count($result_mem) == 0){
					$errorMessage =array_merge($errorMessage,$result_mem);
				}
				if(!count($result_net) == 0){
					$errorMessage =array_merge($errorMessage,$result_net);
				}
				if(!count($result_hdd) == 0){
					$errorMessage =array_merge($errorMessage,$result_hdd);
				}
				if(!count($result_dsk) == 0){
					$errorMessage =array_merge($errorMessage,$result_dsk);
				}

				$errorMessage_alert = array();
				if($re == 0){
					$errorMessage_alert =array_merge($errorMessage_alert,$result_content);
				}
			 	if($res_hour == 0){
	  				$error =__('E-00100',$return = true);
	  				$time=__('time',$return=true);
					$errorMessage_alert[$time][] = $error;
					$this->set('errorMessage_alert', $errorMessage_alert);						
				}
			}

			$count =count($errorMessage);
			$this->set('errorMessage', $errorMessage);
			(!empty($errorMessage_alert))?($this->set('errorMessage_alert', $errorMessage_alert)):null;
			//$this->set('errorMessage_alert', $errorMessage_alert);
			/* 追加　*/
			if(($count == 0)&&(empty($errorMessage)&&(empty($errorMessage_alert))))
			{
				//if((!empty($Grpaltcpuinter_time))&&(!empty($Grpaltcpupercent))){  //CPU
				if(trim($Grpaltcpuinter_time) != ''){
					if($this->selectGrpaltFlag($group_id,'Grpaltcpu') ==1){
						$this->editGrpalt($group_id,'Grpaltcpu');
					}else{
						$this->deleteGrpalt($group_id,'Grpaltcpu');
						$this->addGrpalt($group_id,'Grpaltcpu','Rltgrpaltcpu');
					}
				}else{
					if($this->selectGrpaltFlag($group_id,'Grpaltcpu') ==1){	
						$id = $this->selectId($group_id,'Grpaltcpu');		
						$this->Grpaltcpu->del($id);
					}				
				}
				if(trim($Grpaltmeminter_time) != '') {  //メモリ残

					if($this->selectGrpaltFlag($group_id,'Grpaltmem') ==1){
						$this->editGrpalthdd($group_id,'Grpaltmem');
					}else{
						$this->deleteGrpalt($group_id,'Grpaltmem');
						$this->addGrpalthdd($group_id,'Grpaltmem','Rltgrpaltmem');
					}
				}else{
					if($this->selectGrpaltFlag($group_id,'Grpaltmem') ==1){
						$id = $this->selectId($group_id,'Grpaltmem');		
						$this->Grpaltmem->del($id);
					}					
				}
				
				if(trim($Grpalthddpercent) != ''){  //HDD残

					if($this->selectGrpaltFlag($group_id,'Grpalthdd') ==1){
						$this->editGrpalthdd($group_id,'Grpalthdd');
					}else{
						$this->deleteGrpalt($group_id,'Grpalthdd');
						$this->addGrpalthdd($group_id,'Grpalthdd','Rltgrpalthdd');
					}
				}else{  
						if($this->selectGrpaltFlag($group_id,'Grpalthdd') ==1){
							$id = $this->selectId($group_id,'Grpalthdd');		
							$this->Grpalthdd->del($id);
						}
				}
				
				if(trim($Grpaltnetinter_time) != ''){ //ネットワークIO
					if($this->selectGrpaltFlag($group_id,'Grpaltnet') ==1){
						$this->editGrpaltnet($group_id,'Grpaltnet');
					}else{
						$this->deleteGrpalt($group_id,'Grpaltnet');
						$this->addGrpaltnet($group_id,'Grpaltnet','Rltgrpaltnet');
					}
				}else{
					if($this->selectGrpaltFlag($group_id,'Grpaltnet') ==1){
						$id = $this->selectId($group_id,'Grpaltnet');		
						$this->Grpaltnet->del($id);
					}					
				}
				if(trim($Grpaltdskinter_time) != ''){ //ディスクIO
					if($this->selectGrpaltFlag($group_id,'Grpaltdsk') ==1){
						$this->editGrpalt($group_id,'Grpaltdsk');
					}else{
						$this->deleteGrpalt($group_id,'Grpaltdsk');
						$this->addGrpalt($group_id,'Grpaltdsk','Rltgrpaltdsk');
					}
				}else{
					if($this->selectGrpaltFlag($group_id,'Grpaltdsk') ==1){	
						$id = $this->selectId($group_id,'Grpaltdsk');		
						$this->Grpaltdsk->del($id);
					}					
				}

				//$this->edit_grpalt($group_id,$checkbox_flag);
				$this->edit_grpalt($group_id,1);
				$this->index();
				$this->render('index');
				exit();

			}


		}

		/*　ページの保存　*/
		$this->set('Grpaltcpuinter_time', @$Grpaltcpuinter_time);
		$this->set('Grpaltcpupercent', @$Grpaltcpupercent);
		$this->set('Grpaltmeminter_time', @$Grpaltmeminter_time);
		$this->set('Grpaltmempercent', @$Grpaltmempercent);
		$this->set('Grpaltnetinter_time', @$Grpaltnetinter_time);
		$this->set('Grpaltnetpercent', @$Grpaltnetpercent);
		$this->set('Grpaltdskinter_time', @$Grpaltdskinter_time);
		$this->set('Grpaltdskpercent', @$Grpaltdskpercent);
		$this->set('Grpalthddpercent', @$Grpalthddpercent);
		$this->set('flg',2);
		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1))){
			if(!empty($errorMessage)||!empty($errorMessage_alert)){
/*				if($checkbox_flag == 0){
					$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
					$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
					$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);

					$title =$this->title_list();
					$this->data['Title']['title_flg'] = ($title==0)?1:0;

					$altmsg_list =$this->altmsg_list();
					$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
					$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
					$this->set('up_cast_flag',0);
				}else{
					$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];

				}*/
				isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->render('index_add');
				exit();
			}
		}
		$this->render('index_add');

	}


	/**
     *  上位グループの設定 
     * 
     * */
	function index_add_sun($group_father_id,$group_id,$flag=null){
		//echo "index_add_sun<br>";
		$this->layout='ajax';
		$groupName = $this->groupName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_father_id',$group_father_id);
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);
		
		//現す

		$array = $this->_getGrpaltRltgrpaltName();
		foreach ($array as $key =>$value){
			$result = $this->selectGrpalt($group_father_id,$value);
			if(count($result) == 1){
				$array_res[] = $result[0];
			}
		}
		//debug($array_res);
		foreach($array_res as $v){
			foreach($v as $k =>$va){
				if($k == "Grpaltcpu"){
					$Grpaltcpuinter_time = $va['inter_time'];
					$Grpaltcpupercent = $va['percent'];
				}elseif($k == "Grpaltmem"){
					$Grpaltmeminter_time = $va['capacity'];
				}elseif($k == "Grpaltnet"){
					$Grpaltnetinter_time =$va['inter_time'];
					$Grpaltnetpercent =$va['capacity'];
				}elseif($k == "Grpaltdsk"){
					$Grpaltdskinter_time = $va['inter_time'];
					$Grpaltdskpercent = $va['percent'];					
				}elseif($k == "Grpalthdd"){
					$Grpalthddpercent=$va['capacity'];
				}
			}

		}


/*		if((isset($this->data['Grpalt']['up_cast']))&&($this->data['Grpalt']['up_cast'] == '1')){
			//上位グループの設定を引き継ぐ
			$checkbox_flag =0;
		}else{
			$checkbox_flag =1;
		}*/

		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		//上位グループの設定を引き継ぐ
		//if(@$this->data["Grpaltcpu"]["Grpaltcpu_flag"] != 1){
		if(!isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])){
			$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,11);
			if($grpalt_f == 1){
				$grpalt_r = $this->grpalt_list($group_id);
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
				($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';
				//$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->set('flg',2);

			}else{
				$this->data['Grpalt']['mail_notice'] = 1;
				$this->data['Grpalt']['popup'] = 2;
				$mail_notice_time_c = '';
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				//$up_cast_flag = 1;
				$this->set('flg',1);
			}
			//sunhy start 2009/05/22 modify for YBR-32
			/*if($getUserGroup == 1){
				$title =$this->title_list();
				$this->data['Title']['title_flg'] = ($title!=1)?1:0;

				$altmsg_list =$this->altmsg_list();
				//sunhy start 2009/03/25 modify for JLN-001
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
			$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?0:1;
			//sunhy start 2009/03/25 modify for JLN-001
				$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			}*/
			$titleflg=$this->title_list($group_id);
			if($titleflg== 2){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = ($titleflg == 1) ? 0 : 1;
			}
			$msg = $this->MailPopupController->getAltMsg('E0008', $group_id);
			if($msg['Altmsg']['detail_flg']== 0){
				$this->data['Altmsg']['detail_flg'] = 0;
			}
			else {
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			if(empty($msg['Altmsg']['detail_flg'])){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			$altmsg=$this->Altmsg->findAll(array("message_id='E0008'","Altmsg.group_id=".$group_id));
			if(!empty($altmsg[0]['Altmsg']['message'])){
				$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			}else{
				$this->data['Altmsg']['message']=__('E0008',$return = true);
			}
			//sunhy end 2009/05/22 modify for YBR-32
		}
/*		if(!isset($up_cast_flag)){
			$up_cast_flag = 1;
		}
		$this->set('up_cast_flag',$up_cast_flag);*/
		/* 追加　*/
		//if(@$this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1) {
		if(isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)){
/*			if($checkbox_flag == 0) {
				/*** * ***/
/*				$flag_father = $this->Group->getFatherSet($group_id,$this->Grpalt,11);
				if($flag_father ==0){
					$Message['father_group_alert_inherit'][] = 'father_group_set_no';
					$errorMessage = $Message;
					$this->set('errorMessage',$errorMessage);
					$this->data['Grpalt']['mail_notice'] = 3;
					$this->data['Grpalt']['popup'] = 1;
					$this->set('mail_notice_time_c','00');
					$this->set('up_cast_flag',0);
				}
			}elseif($checkbox_flag == 1){*/
				$getUserGroup = $this->_getUserGroup_id();
				//sunhy start 2009/05/22 modify for YBR-32
			//if($getUserGroup == 1){
			//sunhy end 2009/05/22 modify for YBR-32 
					@$Grpaltcontent = $this->data["Altmsg"]["message"];
					@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');
					$errorMessage_alert = array();					
					if(!count($result_content) == 0){
						//debug($this->data);
						$errorMessage_alert =$result_content;
						$this->set('errorMessage_alert',$errorMessage_alert);
						isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
						$this->set('mail_notice_time_c',$mail_notice_time_c);
					}
				//sunhy start 2009/05/22 modify for YBR-32	
		//}
                //sunhy end 2009/05/22 modify for YBR-32
					if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
						($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
					}else{
						$res_hour=1;
					}
					if($res_hour==0){
		  				$error =__('E-00100',$return = true);
		  				$time=__('time',$return=true);
						$errorMessage_alert[$time][] = $error;
						$this->set('errorMessage_alert', $errorMessage_alert);	
					}
					//debug($errorMessage_alert,true);				
				
/*			}*/
			if(empty($errorMessage_alert)){
				if($flag == 1){
					//$this->add_grpalt($group_id,$checkbox_flag);
					$this->add_grpalt($group_id,1);
				}elseif($flag == 2){
					//$this->edit_grpalt($group_id,$checkbox_flag);
					$this->edit_grpalt($group_id,1);
				}
				$this->index();
				$this->render('index');
				exit();
			}
		}

		/*　ページの保存　*/
		$this->set('Grpaltcpuinter_time', @$Grpaltcpuinter_time);
		$this->set('Grpaltcpupercent', @$Grpaltcpupercent);
		$this->set('Grpaltmeminter_time', @$Grpaltmeminter_time);
		$this->set('Grpaltmempercent', @$Grpaltmempercent);
		$this->set('Grpaltnetinter_time', @$Grpaltnetinter_time);
		$this->set('Grpaltnetpercent', @$Grpaltnetpercent);
		$this->set('Grpaltdskinter_time', @$Grpaltdskinter_time);
		$this->set('Grpaltdskpercent', @$Grpaltdskpercent);
		$this->set('Grpalthddpercent', @$Grpalthddpercent);
		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1))){
			if(!empty($errorMessage_alert)){
/*				if($checkbox_flag == 0){
					if($this->grpalt_list_id($group_id)!=0){
						$grpalt_r = $this->grpalt_list($group_id);
						$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
						$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
						$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
					}else{
						$mail_notice_time_c='00';
					}
					$title =$this->title_list();
					$this->data['Title']['title_flg'] = ($title!=1)?1:0;

					$altmsg_list =$this->altmsg_list();
					$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
					$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
					$this->set('up_cast_flag',0);
				}else{
					$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];

				}*/
				isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
			}
		}
	}

	/**
  	  *  CPU.ディスクIOのエラーの判定 
  	  * */
	function error_judge($inter_time = null,$percent = null,$name1=null,$name2){
		$re1 =$this->Lv->is_empty($inter_time);
		$re2 =$this->Lv->is_empty($percent);
		if($re1&&(!$re2)){
			$errorMessage[$name1][] = 'E-00100';
		}
		if(!$re1&&($re2)){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!$re1){
			$result = $this->Validation->numeric($inter_time);
			if(!$result){
				$errorMessage[$name1][] = 'E-00600';
			}else{
//				if($inter_time>120){
				if($inter_time>60){//2007/12/04 zhaoli 変更
					$errorMessage[$name1][] = 'cpu_above';
				}
				if($inter_time <1){
					$errorMessage[$name1][] = 'cpu_above';
				}
			}
		}
		if(!$re2){
			$result = $this->Validation->numeric($percent);
			if(!$result){
				$errorMessage[$name2][] = 'E-00600';
			}else{
/*				if(!$this->Validation->maxLength($percent,2)){
					$errorMessage[$name2][] = 'E-00300';
				}*/
				if($percent>100){
					$errorMessage[$name2][] = 'cpu_below';
				}
				if($percent <1){
					$errorMessage[$name2][] = 'cpu_below';
				}
			}
		}

		return $errorMessage;
	}

	/* HDD残,メモリ残のエラーの判定 */
	function error_judge_hdd($percent = null,$name2){
		$re1 =$this->Lv->is_empty($percent);
		if(!$re1){
			$result = $this->Validation->numeric($percent);
			if(!$result){
				$errorMessage[$name2][] = 'E-00600';
			}else{
/*				if(!$this->Validation->maxLength($percent,3)){
					$errorMessage[$name2][] = 'E-00300';
				}*/
				if($percent>999){
					$errorMessage[$name2][] = 'hdd_below1';
				}
				if($percent <1){
					$errorMessage[$name2][] = 'hdd_below1';
				}
			}
		}

		return $errorMessage;
	}
	/* グループ共通の判定 */
	function error_judge_grpalt($content = null,$name2){
		$re1 =$this->Lv->is_empty($content);
		if($re1){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!$re1){
			if(!$this->Validation->maxLength($content,2000)){
				$errorMessage[$name2][] = 'E-00300';
			}
		}

		return $errorMessage;
	}

	/* ネットワークIO.ディスクIOのエラーの判定 */
	function error_judge_dsk($inter_time = null,$percent = null,$name1,$name2){
		$re1 =$this->Lv->is_empty($inter_time);
		$re2 =$this->Lv->is_empty($percent);
		if($re1&&(!$re2)){
			$errorMessage[$name1][] = 'E-00100';
		}
		if(!$re1&&($re2)){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!$re1){
			$result = $this->Validation->numeric($inter_time);
			if(!$result){
				$errorMessage[$name1][] = 'E-00600';
			}else{
				if($inter_time>60){//2007/12/04 zhaoli 変更
//				if($inter_time>120){
					$errorMessage[$name1][] = 'cpu_above';
				}
				if($inter_time <1){
					$errorMessage[$name1][] = 'cpu_above';
				}
			}
		}
		if(!$re2){
			$result = $this->Validation->numeric($percent);
			if(!$result){
				$errorMessage[$name2][] = 'E-00600';
			}else{
				if($percent>9999){
					$errorMessage[$name2][] = 'hdd_below';
				}
				if($percent <1){
					$errorMessage[$name2][] = 'hdd_below';
				}
			}
		}

		return $errorMessage;
	}
	/**
	 *
	 * 新規登録
	 */
	/* 新規追加CPU,ディスクIO */
	function addGrpalt($group_id,$table_name,$link_name){
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$inter_time = $this->data[$table_name]["inter_time"];
		$percent = $this->data[$table_name]["percent"];
		$insert=Array(
		$table_name => Array(
		'inter_time' => $inter_time,
		'percent' =>  $percent,
		'group_id' =>  $group_id,
		)
		);
		$this->$table_name->save($insert);
		$grpalt_id = $this->$table_name->getLastInsertID();
		foreach ($glist as $key=>$value) {

			$insertrlt=Array(
			$link_name => Array(
			'group_id' => $key,
			'alert_id' => $grpalt_id,
			'org_grp_id' =>  $group_id,
			)
			);
			$this->$link_name->save($insertrlt);
		}
/*		$this->GenerateFiles->hook_by_group($group_id, array('perfalert'));
		$this->GenerateFiles->hook_by_group(1, array('popup'));*/
	}
	/* 新規追加HDD残 ,メモリ残*/
	function addGrpalthdd($group_id,$table_name,$link_name){
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$Grpalthddpercent = $this->data[$table_name]["capacity"];
		$inserthdd=Array(
		$table_name => Array(
		'capacity' =>  $Grpalthddpercent,
		'group_id' =>  $group_id,
		)
		);
		$this->$table_name->save($inserthdd);
		$grpalthdd_id = $this->$table_name->getLastInsertID();
		foreach ($glist as $key=>$value) {

			$insertrlthdd=Array(
			$link_name => Array(
			'group_id' => $key,
			'alert_id' => $grpalthdd_id,
			'org_grp_id' =>  $group_id,
			)
			);
			$this->$link_name->save($insertrlthdd);
		}
/*		$this->GenerateFiles->hook_by_group($group_id, array('perfalert'));
		$this->GenerateFiles->hook_by_group(1, array('popup'));*/
	}
	/* 新規追加ネットワークIO*/
	function addGrpaltnet($group_id,$table_name,$link_name){
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$inter_time = $this->data[$table_name]["inter_time"];
		$capacity = $this->data[$table_name]["capacity"];
		$insertnet=Array(
		$table_name => Array(
		'inter_time' => $inter_time,
		'capacity' =>  $capacity,
		'group_id' =>  $group_id,
		)
		);
		$this->$table_name->save($insertnet);
		$grpaltnet_id = $this->$table_name->getLastInsertID();
		foreach ($glist as $key=>$value) {

			$insertrltnet=Array(
			$link_name => Array(
			'group_id' => $key,
			'alert_id' => $grpaltnet_id,
			'org_grp_id' =>  $group_id,
			)
			);
			$this->$link_name->save($insertrltnet);
		}
/*		$this->GenerateFiles->hook_by_group($group_id, array('perfalert'));
		$this->GenerateFiles->hook_by_group(1, array('popup'));*/
	}

	/* グループ共通設定テーブルのデータ */
	function add_grpalt($group_id,$checkbox_flag){
		//echo "add_grpalt<br>";
		$getUserGroup = $this->_getUserGroup_id();
		$grpalt=$this->Grpalt->grpalt_list_flag($group_id,11);
		if($grpalt == 1){
			//$this->edit_grpalt($group_id,$checkbox_flag);
			$this->edit_grpalt($group_id,1);
		}else{

			if($checkbox_flag == 1) {
				if(isset($this->data["Grpalt"]["mail_notice"]))
				{
					$mail_notice = $this->data["Grpalt"]["mail_notice"];
					if($mail_notice == 2){
						$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
					}else{
						$mail_notice_time = '00:00:00';
					}


					if(!empty($mail_notice)){
						$grpalt=$this->grpalt_list($group_id);
						if($this->data["Grpalt"]["popup"] == 1){
							$popup = 1;
						}else{
							$popup = 0;
						}
						//sunhy start 2009/03/25 modify for JLN-001
						/*$insertgrpalt=Array(
						'Grpalt' => Array(
						'group_id' => $group_id,
						'mail_notice' => $mail_notice,
						'mail_notice_time' => $mail_notice_time,
						'popup' =>$popup,
						//'up_cast' => 1,
						'type' => 11,
						));
						//debug($insertgrpalt);
						$this->Grpalt->save($insertgrpalt);*/
						$this->MailPopupController->setMailPop(null, $group_id, $mail_notice, $mail_notice_time, $popup, null, null, 11, 'Grpalt' );
						//sunhy end 2009/03/25 modify for JLN-001
						//sunhy start 2009/05/22 modify for YBR-32
						//if($getUserGroup == 1){
						
							//$re_title =$this->title_flag();
							$re_title =$this->title_flag($group_id);
							
							if($re_title == 0){
								
								//$this->addTitle();
								$this->addTitle($group_id);
								
							}else{
								//$this->editTitle($re_title);
								$this->editTitle($re_title, $group_id);
							}
							
							//$re_msg =$this->altmsg_flag();
							$re_msg =$this->altmsg_flag($group_id);
							
							if($re_msg == 0){
								
								//$this->addAltmsg();
								$this->addAltmsg($group_id);
								
							}else{
								//$this->editAltmsg($re_msg);
								$this->editAltmsg($re_msg, $group_id);
							}
						//}
						//sunhy end 2009/05/22 modify for YBR-32
					}
				}
			}elseif($checkbox_flag == 0) {
				//echo "add_grpalt :up_cast=0<br>";
				//sunhy start 2009/03/25 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' => 3,
				'popup' =>1,
				'mail_notice_time' => '00:00:00',
				'type' => 11,
				//'up_cast' => 0,
				));
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop(null, $group_id, 3, '00:00:00', 1, null, null, 11, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001
			}
  			//sunhy start 2009/05/22 modify for YBR-32
			//$this->GenerateFiles->hook_by_group(0, array("perfalert", "popup"));
			$this->GenerateFiles->hook_by_group($group_id, array("perfalert", "popup"));
			//sunhy end 2009/05/22 modify for YBR-32
		}
	}

	/*  編集グループ共通 */
	function edit_grpalt($group_id,$checkbox_flag){
		//echo "edit_grpalt<br>";

		$grpalt_id = $this->grpalt_list_id($group_id);
		if($checkbox_flag == 1) {
			//echo "edit_grpalt :up_cast=1<br>";
			if($this->data["Grpalt"]["popup"] == 1){
				$popup = 1;
			}else{
				$popup = 0;
			}
			if($this->data["Grpalt"]["mail_notice"] == 2){
				$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
			}else{
				$mail_notice_time = '00:00:00';
			}
			if(isset($this->data["Grpalt"]["mail_notice"])){
				//sunhy start 2009/03/25 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'id' => $grpalt_id,
				'group_id' => $group_id,
				'mail_notice' => $this->data["Grpalt"]["mail_notice"],
				'mail_notice_time' => @$mail_notice_time,
				'popup' =>$popup,
				'type'=>11,
				//'up_cast' => 1,
				));
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, $popup, null, null, 11, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001

				$getUserGroup = $this->_getUserGroup_id();
				//sunhy start 2009/05/22 modify for YBR-32
				//if($getUserGroup == 1){
						
					//$re_title =$this->title_flag();
					$re_title =$this->title_flag($group_id);
							
					if($re_title == 0){
								
						//$this->addTitle();
						$this->addTitle($group_id);
								
					}else{
						//$this->editTitle($re_title);
						$this->editTitle($re_title, $group_id);
					}
							
					//$re_msg =$this->altmsg_flag();
					$re_msg =$this->altmsg_flag($group_id);
							
					if($re_msg == 0){
								
						//$this->addAltmsg();
						$this->addAltmsg($group_id);
								
					}else{
						//$this->editAltmsg($re_msg);
						$this->editAltmsg($re_msg, $group_id);
					}
				//}
				//sunhy end 2009/05/22 modify for YBR-32
			}
		}elseif($checkbox_flag == 0) {
			//echo "edit_grpalt :up_cast=0<br>";
			//sunhy start 2009/03/25 modify for JLN-001
			/*$insertgrpalt=Array(
			'Grpalt' => Array(
			'id' => $grpalt_id,
			'group_id' => $group_id,
			'type' => 11,
			//'up_cast' => 0,
			));
			$this->Grpalt->save($insertgrpalt);*/
			$this->MailPopupController->setMailPop($grpalt_id, $group_id, null, null, null, null, null, 11, 'Grpalt');
			//sunhy end 2009/03/25 modify for JLN-001
		}
			//sunhy start 2009/05/22 modify for YBR-32
			//$this->GenerateFiles->hook_by_group(0, array("perfalert", "popup"));
			$this->GenerateFiles->hook_by_group($group_id, array("perfalert", "popup"));
			//sunhy end 2009/05/22 modify for YBR-32;
	}


	/*
	*件名管理情報追加
	*/

	//sunhy start 2009/05/22 modify for YBR-32
	//function addTitle(){
	function addTitle($group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'title_flg' => $title_flg,
		'type' => 11,
		//sunhy start 2009/05/22 modify for YBR-32
		'group_id' => $group_id,
		//sunhy end 2009/05/22 modify for YBR-32
		));
		$this->Title->save($inserttitle);
	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/22 modify for YBR-32
	//function editTitle($id){
	function editTitle($id, $group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'id'=>$id,
		'title_flg' => $title_flg,
		'type' => 11,
		//sunhy start 2009/05/22 modify for YBR-32
		'group_id' => $group_id,
		//sunhy start 2009/05/22 modify for YBR-32
		));
		$this->Title->save($inserttitle);
	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/22 modify for YBR-32
	//function addAltmsg(){
	function addAltmsg($group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/25 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'message_id' => 'E0008',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		/*$this->GenerateFiles->hook_by_group(1, array('perfalert','popup'));*/
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0008', $message, $detail_flg, null, $this->_getUserGroup_id());
		$this->MailPopupController->setAltMsg('E0008', $message, $detail_flg, null, $group_id);
		//sunhy end 2009/05/22 modify for YBR-32
		//sunhy end 2009/03/25 modify for JLN-001
		/*$this->GenerateFiles->hook_by_group(1, array('perfalert','popup'));*/
	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/22 modify for YBR-32
	//function editAltmsg($id){
	function editAltmsg($id, $group_id){
	//sunhy start 2009/05/22 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/25 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'id'=>$id,
		'message_id' => 'E0008',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0008', $message, $detail_flg, $id, $this->_getUserGroup_id());
		$this->MailPopupController->setAltMsg('E0008', $message, $detail_flg, $id, $group_id);
		//sunhy start 2009/05/22 modify for YBR-32
		//sunhy end 2009/03/25 modify for JLN-001

	}

	/**
	 *
	 * 変更する
	 */
	/* 変更CPU,メモリ残 ,ネットワークIO,ディスクIO */
	function editGrpalt($group_id,$table_name){
		$inter_time = $this->data[$table_name]["inter_time"];
		$percent = $this->data[$table_name]["percent"];
		$grpalt = $this->selectGrpalt($group_id,$table_name);
		$grpalt_id = $grpalt[0][$table_name]['id'];
		$insert=Array(
		$table_name => Array(
		'id' => $grpalt_id,
		'inter_time' => $inter_time,
		'percent' =>  $percent,
		'group_id' =>  $group_id,
		)
		);
		$this->$table_name->save($insert);

	}

	/* 変更HDD残 */
	function editGrpalthdd($group_id,$table_name){
		$capacity = $this->data[$table_name]["capacity"];
		$grpalt = $this->selectGrpalt($group_id,$table_name);
		$grpalt_id = $grpalt[0][$table_name]['id'];
		$inserthdd=Array(
		$table_name => Array(
		'id' =>$grpalt_id,
		'capacity' =>  $capacity,
		'group_id' =>  $group_id,
		)
		);
		$this->$table_name->save($inserthdd);

	}
	/* 変更CPU,ディスクIO */
	function editGrpaltnet($group_id,$table_name){
		$inter_time = $this->data[$table_name]["inter_time"];
		$capacity = $this->data[$table_name]["capacity"];
		$grpalt = $this->selectGrpalt($group_id,$table_name);
		$grpalt_id = $grpalt[0][$table_name]['id'];
		$insert=Array(
		$table_name => Array(
		'id' => $grpalt_id,
		'inter_time' => $inter_time,
		'capacity' =>  $capacity,
		'group_id' =>  $group_id,
		)
		);
		$this->$table_name->save($insert);

	}
	/**
	 *
	 * 下位グループの設定の解除
	 */   

	function deleteGrpalt($group_id,$table_name){
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		foreach($glist as $key => $value){
			$condition = $table_name.".group_id =".$key." ";
			//echo  $condition;
			$grpalt = $this->$table_name->findAll($condition);
			//debug($grpalt);
			if(count($grpalt) == 1){
				$grpalt_id = $grpalt[0]["$table_name"]["id"];
				$this->$table_name->del($grpalt_id);
			}
		}

	}

	/*目前のグループの削除*/

	function delete(){

		$this->layout='ajax';
		$g_new = array();
		if(isset($this->data['Grpaltcpu']['del'])){
			$word_id=$this->data["Grpaltcpu"]["del"];
			foreach ($word_id as $value){

/*				$onesun =$this->_findOneSun($value);
				$i=0;
				if($onesun !=2){
					foreach ($onesun as $key => $v){
						if($v == 0) {
							$i++;
						}
					}
				}

				if($i > 0) {
					$error =__('delete_list_group_error',$return = true);
					$errorMessage['delete_list_group'] =$error;
					$this->set('errorMessage',$errorMessage);

				}else{  //echo "right!";*/
					$g_new[]=$value;
					$delete_list =$this->data['Grpalt']['del_id'];
					$delete = $delete_list[$value];
					foreach($delete as $key=>$id) {
						$condition = $key.".id =".$id[0]." ";
						$grpalt = $this->$key->findAll($condition);
						if(count($grpalt) == 1){
							$grpalt_id = $grpalt[0]["$key"]["id"];
							$this->$key->del($grpalt_id);
						}
					}
					$del_grpalt = $this->grpalt_list_id($value);
					$this->Grpalt->del($del_grpalt);
					//chenhao start 2009/11/02 modified for JL-0048
					if ($value == 1)
						$this->Grpalt->query("delete from grpalts where type = 11 and group_id != 1");
					//chenhao end 2009/11/02 modified for JL-0048
					//sunhy start 2009/07/25 modify for JL-0035
					$this->MailPopupController->delAltMsg("E0008", $value);
    					$this->MailPopupController->delAltTit(11, $value);
    					//sunhy end 2009/07/25 modify for JL-0035
//					$con = "Grpalt.type=11 ";
//					$grpalt = $this->Grpalt->findAll($con);
//					if(count($grpalt) == 0){
//						$title_id =$this-> title_flag();
//						if($title_id != 0){
//							$this->Title->del($title_id);
//						}
//						$msg_id =$this-> altmsg_flag();
//						if($msg_id != 0){
//							$this->Altmsg->del($msg_id);
//						}
//					}

					if(!empty($g_new)){
						//sunhy start 2009/05/22 modify for YBR-32
						/*$this->GenerateFiles->hook_by_group($g_new, array('perfalert'));
						$this->GenerateFiles->hook_by_group(1, array('popup'));*/
						$this->GenerateFiles->hook_by_group($value, array('perfalert', 'popup'));
						//sunhy end 2009/05/22 modify for YBR-32
					}



			}

		}else{//未選択

			$error =__('E-00200',$return = true);
			//xushanning start 2009/04/23  modify for LogvillageChinese
			//$errorMessage['list'] = $error;
			$errorMessage['entry'] = $error;
			//xushanning end 2009/04/23  modify for LogvillageChinese
			$this->set('errorMessage', $errorMessage);

		}
		$this->index();
		$this->render('index');
		exit();
	}




	/**
	 *登録ユーザ属するグループ取得

	 *
	 * @return ユーザのグループID　Group.id
	 */
/*	function _getUserGroup()
	{
		$usergroup =1;///////////////////Sessionから
		return $usergroup;
	}*/
	function _getUserGroup_id(){
	   return $this->_getUserGroup();
	}
	function _getGrpaltRltgrpaltName()
	{
		//$array = array('Rltgrpaltcpu'=>'Grpaltcpu','Rltgrpaltmem'=>'Grpaltmem','Rltgrpaltnet'=>'Grpaltnet','Rltgrpaltdsk'=>'Grpaltdsk','Rltgrpalthdd'=>'Grpalthdd');
		$array = array('Rltgrpaltcpu'=>'Grpaltcpu','Rltgrpaltmem'=>'Grpaltmem','Rltgrpaltnet'=>'Grpaltnet','Rltgrpalthdd'=>'Grpalthdd','Rltgrpaltdsk'=>'Grpaltdsk');
		return $array;
	}
	/* グループ名の取得 */
	function groupName($group_id){

		$condition=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($condition);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;

	}

	/* アラート設定の取得 */
	function selectGrpalt($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		return $grpalt;

	}
	function selectId($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		if(count($grpalt == 1)){
			$id=$grpalt[0][$table_name]["id"];
			return $id;
		}else{
			return 0;
		}
	}	
	function selectGrpaltFlag($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		if(count($grpalt) ==1){
			$flag =1;
		}else{
			$flag =0;
		}
		return $flag;

	}

	/* 関連設定の取得 */
	function selectRltgrpalt($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);
		return $grpalt;

	}
	function selectRltgrpaltre($group_id,$table_name){

		$condition =$table_name.".group_id =".$group_id." ";
		$grpalt = $this->$table_name->findAll($condition);

		if(count($grpalt) == 1){
			$group_id = $grpalt[0]["$table_name"]["group_id"];
			$org_grp_id = $grpalt[0]["$table_name"]["org_grp_id"];
			if($group_id == $org_grp_id){
				$fiag = 1;
			}elseif($group_id !=$org_grp_id){
				$fiag = 2;
			}
		}elseif(count($grpalt) == 0){
			$fiag = 0;
		}
		return $fiag;

	}

	function group_father_id($group_id){
		$criteria=" Group.id=".$group_id." ";
		$group_i= $this->Group->findAll($criteria);
		$group_father_i = $group_i[0]["Group"]["parent_id"];
		return $group_father_i;

	}

	function grpalt_list($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=11 ";
		$grpalt = $this->Grpalt->findAll($condition);
		return $grpalt;

	}
	function grpalt_list_id($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=11 ";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalt"]["id"];
		}else{
			$id =0;
		}
		return $id;

	}



/*	function grpalt_list_flag($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=11 ";
		$grpalt = $this->Grpalt->findAll($condition);
		//debug($grpalt);
		if(count($grpalt) == 1){
			$flag = 1;
		}else{
			$flag = 0;
		}
		return $flag;

	}*/


	/* 件名管理情報  start*/
	//sunhy start 2009/05/22 modify for YBR-32
	//function title_flag(){
	function title_flag($group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		//sunhy start 2009/05/22 modify for YBR-32
		//$condition =" Title.type=11 ";
		$condition =" Title.type=11 and group_id=".$group_id;
		//sunhy end 2009/05/22 modify for YBR-32
		$title = $this->Title->findAll($condition);
		//debug($grpalt);
		if(count($title) == 1){
			$flag = $title[0]['Title']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	//sunhy start 2009/05/22 modify for YBR-32
	//function altmsg_flag(){
	function altmsg_flag($group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		//sunhy start 2009/05/22 modify for YBR-32
		//$condition =" Altmsg.message_id='E0008' ";
		$condition =" Altmsg.message_id='E0008' and group_id=".$group_id;
		//sunhy end 2009/05/22 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$flag = $altmsg[0]['Altmsg']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	//sunhy start 2009/05/22 modify for YBR-32
	//function title_list(){
	function title_list($group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		//sunhy start 2009/05/22 modify for YBR-32
		//$condition =" Title.type=11 and Title.id !=0";
		$condition =" Title.type=11 and Title.id !=0 and group_id=".$group_id;
		//sunhy end 2009/05/22 modify for YBR-32
		$title = $this->Title->findAll($condition);
		//debug($grpalt);
		if(count($title) == 1){
			$flag = $title[0]['Title']['title_flg'];
		}else{
			$flag =2;
		}
		return $flag;
	}
	//sunhy start 2009/05/22 modify for YBR-32
	//function altmsg_list(){
	function altmsg_list($group_id){
	//sunhy end 2009/05/22 modify for YBR-32
		//sunhy start 2009/05/22 modify for YBR-32
		//$condition =" Altmsg.message_id='E0008' ";
		$condition =" Altmsg.message_id='E0008' and group_id=".$group_id;
		//sunhy end 2009/05/22 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$array = $altmsg;
		}else{
			$array = 2;
		}
		return $array;
	}

	/*  end */
/*	function getGrpalt_up_cast($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=11 ";
		$data_group_c =$this->Grpalt->findAll($condition);
		if(count($data_group_c) == 1){
			$checkbox_flag =$data_group_c[0]["Grpalt"]["up_cast"];
		}else{
			$checkbox_flag = null;
		}
		return  $checkbox_flag;
	}*/

	function _getemail($group_id){
		//$group_id= $this->_getUserGroup();
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		//debug($data_email);
		return $data_email;

	}
	
	function reset(){
		$this->layout='ajax';
		$this ->index();
		$this->render('index');

	}
	function _findOneSun($group_id){
		$criteria=" Group.parent_id=".$group_id." ";
		$parent= $this->Group->findAll($criteria);
		//debug($parent);
		if(count($parent) != 0){
			foreach ($parent as $value){
				$id =$value['Group']['id'];
				//debug($id);
				$grpalt =$this->grpalt_list($id);
				if(count($grpalt) == 1){
					$grpalt_up_cast = $grpalt[0]['Grpalt']['up_cast'];
					$array[$id] =$grpalt_up_cast;
					return $array;
					exit();
				}else{
					return 2;
				}

			}
		}else{
			return 2;
		}

	}

/*	function  _getFatherSet($group_id){

		if($group_id !=1){
			$group_father_i = $this->group_father_id($group_id);
			$grpalt_list_flag=$this->grpalt_list_flag($group_father_i);
			if($grpalt_list_flag ==1) {
				$checkbox_flag =$this->getGrpalt_up_cast($group_father_i);
				if($checkbox_flag == 1) {
					return $group_father_i;
				}else{ //echo "1<br>";
					$result = $this->_getFatherSet($group_father_i);
					return $result;
				}

			}else{
				$id =0;
				return $id;
			}
		}else{
			$id =0;
			return $id;
		}
	}*/



}