<?php
/*********************************************************************
*@filename 		system_grpset_alert_prints_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhy    	  2009/03/28   modify for JLN-001
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy    	  2009/05/14   modify for YBR-32
*            2.0        yzl         2009/07/24    modify for JL-0035
********************************************************************/
class SystemGrpsetAlertPrintsController extends AppController
{
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    //sunhy start 2009/03/28 modify for JLN-001
    //var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
    var $components = array ('Pagination', 'Lv','GenerateFiles' ,'Check','MailPopupController','AlertPcController');
    //sunhy end 2009/03/28 modify for JLN-001
    //var $uses=array('Group','Grpauth','Configure','Grpaltprt','Rltgrpaltprt','Grpaltprtcnt','Rltgrpaltprtcnt','Grpalt','Grpprt','Optprt');
    //sunhy start 2009/05/14 modify for YBR-32
    //var $uses=array('Group','Grpauth','Configure','Grpaltprtcnt','Rltgrpaltprtcnt','Grpalt','Grpaltprtfile','Rltgrpaltprtfile','Grpaltprtext','Rltgrpaltprtext','User','Title','Altmsg','Mail','Validation','Printer','Prtsub','Optprt','Host');
    var $uses=array('Rlthstgrp','Group','Grpauth','Configure','Grpaltprtcnt','Rltgrpaltprtcnt','Grpalt','Grpaltprtfile','Rltgrpaltprtfile','Grpaltprtext','Rltgrpaltprtext','User','Title','Altmsg','Mail','Validation','Printer','Prtsub','Optprt','Host');
    //sunhy end 2009/05/14 modify for YBR-32
    var $layout='system';
   
	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);
		if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	
	function _getUserGroup_id(){
		//return 1;
	   return $this->_getUserGroup();
	}
	
	function index(){
		//$this->layout='ajax';
		$this->pageTitle = __('title',$return = true);   
		$group_id = $this->_getUserGroup_id();
		$glist = $this->Group->getChildrenByParent($group_id);
		//ksort($glist);
		$this->set('glist',$glist);
		$this->group_list();
		$this->print_list();
		
	}
	
	function index_list(){
	
		$this->layout='ajax';
		$group_id = $this->_getUserGroup_id();
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$this->set('glist',$glist);
		$this->group_list();
		$this->print_list();
		$this->render('index');
	
	}	
	
	function alert_list(){
	
		$this->layout='ajax';
		$group_id = $this->_getUserGroup_id();
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$this->set('glist',$glist);
		$this->group_list();
		$this->print_list();
		$this->render('index');
	
	}	
	
	/* /登録済アラートリストの表示
	*/
	function group_list(){
		
		$group_id = $this->_getUserGroup_id();
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$grpalt_group_id =  array();

		$glist_p=$this->Grpauth->getParentsByChild($group_id);
		ksort($glist_p);
		unset($glist_p[$group_id]);
		//debug($glist_p);
		foreach ($glist_p as $key=>$value) {
			
			$data_group=$this->grpalt_list($key);
			if(count($data_group) ==1){
/*				$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($key,2);
				if($checkbox_flag == 0){
					$flag = $this->Group->getFatherSet($key,$this->Grpalt,2);
					$data_group_p=$this->grpalt_list($flag);
					$grpalt_group[$key]= $data_group_p[0]["Grpalt"];
				}else{
					$grpalt_group[$key]= $data_group[0]["Grpalt"];
				}*/
				$grpalt_group[$key]= $data_group[0]["Grpalt"];
				
				$count_file = $this->selectGrpaltprtfileflag($key);
				$count_text = $this->selectGrpaltprtextflag($key);
				if(($count_file == 0)&&($count_text == 0)){
					$grpalt_group_id[$key]=null;
				}else{
						if($count_file ==1){
							$selectGrpaltprtfile = $this->selectGrpaltprtfile($key);
							foreach ($selectGrpaltprtfile as $output){
								//$grpalt_group_id[$key]["Grpaltprtfile"][]=$output;
								$grpalt_group_id[$key][]=$output;
							}
						}
						//$count_text = $this->selectGrpaltprtextflag($key);
						if($count_text ==1){
							$selectGrpaltprtext = $this->selectGrpaltprtext($key);
							foreach ($selectGrpaltprtext as $out){
								$grpalt_group_id[$key][]=$out;
							}
						}
				}
			}	
		}
		
		$grpalt_p= $grpalt_group_id;
		$this->set('grpalt_p',$grpalt_p);
		
		foreach ($glist as $key=>$value) {
			
			$data_group=$this->grpalt_list($key);
			if(count($data_group) ==1){
/*				$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($key,2);
				if($checkbox_flag == 0){
					$flag = $this->Group->getFatherSet($key,$this->Grpalt,2);
					$data_group_p=$this->grpalt_list($flag);
					$grpalt_group[$key]= $data_group_p[0]["Grpalt"];
				}else{
					$grpalt_group[$key]= $data_group[0]["Grpalt"];
				}*/
				$grpalt_group[$key]= $data_group[0]["Grpalt"];
				
				$count_file = $this->selectGrpaltprtfileflag($key);
				$count_text = $this->selectGrpaltprtextflag($key);
				if(($count_file == 0)&&($count_text == 0)){
					$grpalt_group_id[$key]=null;
				}else{
						if($count_file ==1){
							$selectGrpaltprtfile = $this->selectGrpaltprtfile($key);
							foreach ($selectGrpaltprtfile as $output){
								//$grpalt_group_id[$key]["Grpaltprtfile"][]=$output;
								$grpalt_group_id[$key][]=$output;
							}
						}						
						if($count_text ==1){
							$selectGrpaltprtext = $this->selectGrpaltprtext($key);
							foreach ($selectGrpaltprtext as $out){
								$grpalt_group_id[$key][]=$out;
							}
						}
				}
			}
		
		}
		
		
		/* グループ印刷ファイル設定表 */		
		$this->groupName();
		$this->findGrpaltprtcnt();
		$this->set('grpalt_group_id',$grpalt_group_id);
		if(!empty($grpalt_group)){
			$this->set('grpalt_group',$grpalt_group);
		}else{
			$this->set('grpalt_group',null);
		}
		

	}
	
	/* プリンタ別設定の表示
	*/
	function print_list(){
		$group_id = $this->_getUserGroup_id();
		if($group_id == '1') {
			$this->set('grpprt_list',1);
		}else{
			$this->set('grpprt_list',0);
		}
	}
	
	/* 絞込み ページ 1
	*/
	function select_group_list(){
		$this->layout='ajax';
		$group_id = $this->_getUserGroup_id();
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		ksort($glist);
		$this->set('glist',$glist);
						
		$extent_name_id =$this->data["Group"]["grp_group_name"];		
		//var_dump($extent_name_id,true);
		//if(isset($this->data["Grpaltprtfile"]["file_name"])&&($this->data["Grpaltprtfile"]["file_name"] !='')){
			
/*            if(!$this->Check->checkAllHalf($this->data["Grpaltprtfile"]["file_name"])){
          		$errorMessage['keyword'][] = 'E-00400';
		    	$this->set('errorMessage',$errorMessage);
				$this->index();
				$this->render('index');
				exit();	
        	}elseif(!$this->Validation->maxLength($this->data['Grpaltprtfile']['file_name'],2000)){*/
			$text1 = trim($this->Lv->spec_char_like($this->data["Grpaltprtfile"]["file_name"]));
			
			if(!$this->Validation->maxLength($this->data['Grpaltprtfile']['file_name'],200)){
           		$errorMessage['keyword'][] = 'E-00300';
		    	$this->set('errorMessage',$errorMessage);
				$this->index();
				$this->render('index');
				exit();	       		
        	}else{      	
 					/* 絞込み */
/* 					if(trim($text1) == ''){
 						$text1 = "1=1";
 					}*/
					if($this->data["Grpaltprtfile"]["extent_file"] == '1'){				
						//$count_file = $this->selectGrpaltprtfileflag($extent_name_id);
						$glist_child = $this->Grpauth->getChildrenByParent($extent_name_id);
						ksort($glist_child);
						foreach ($glist_child as $key=>$value) {
							$count_file = $this->selectGrpaltprtfileflag($key);
							//wangs start 20080202
							//$criteria =" Grpaltprtfile.group_id=".$key." and Grpaltprtfile.file_name like '%".$text1."%' ";
							$criteria =" Grpaltprtfile.group_id=".$key." and lower(Grpaltprtfile.file_name) like '%".strtolower($text1)."%' ";
							//wangs end 20080202
							if($count_file ==1){
								   $selectGrpaltprtfile =$this->Grpaltprtfile->findAll($criteria,null,"Grpaltprtfile.file_name ASC");
									foreach ($selectGrpaltprtfile as $output){
										$grpalt_group_id[$key][]=$output;
									}
							}
							$data_group=$this->grpalt_list($key);
							if(count($data_group) ==1){
								$grpalt_group[$key]= $data_group[0]["Grpalt"];
							}
						}
						//debug($grpalt_group_id);
//						if($count_file ==1){
//							$selectGrpaltprtfile = $this->selectGrpaltprtfile($key);
//							foreach ($selectGrpaltprtfile as $output){
//								//$grpalt_group_id[$key]["Grpaltprtfile"][]=$output;
//								$grpalt_group_id[$key][]=$output;
//							}
//						}				
					}elseif($this->data["Grpaltprtfile"]["extent_file"] == '0'){
						//$criteria =" Grpaltprtext.group_id=".$extent_name_id." and Grpaltprtext.extent like '%".$text1."%'  order by Grpaltprtext.extent ASC";
						$glist_child = $this->Grpauth->getChildrenByParent($extent_name_id);
						ksort($glist_child);
						foreach ($glist_child as $key=>$value) {
								//wangs start 20080202
								//$criteria =" Grpaltprtext.group_id=".$key." and Grpaltprtext.extent like '%".$text1."%' ";
								$criteria =" Grpaltprtext.group_id=".$key." and lower(Grpaltprtext.extent) like '%".strtolower($text1)."%' ";
								//wangs start 20080202
								$count_text = $this->selectGrpaltprtextflag($key);
								if($count_text ==1){
									$selectGrpaltprtext = $this->Grpaltprtext->findAll($criteria,null,"Grpaltprtext.extent ASC");
									foreach ($selectGrpaltprtext as $out){
										$grpalt_group_id[$key][]=$out;
									}
								}
								$data_group=$this->grpalt_list($key);
								if(count($data_group) ==1){
									$grpalt_group[$key]= $data_group[0]["Grpalt"];
								}
						}
					}
/*					$data_group=$this->grpalt_list($extent_name_id);
					if(count($data_group) ==1){
						$grpalt_group[$extent_name_id]= $data_group[0]["Grpalt"];
						$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($extent_name_id,2);
						if($checkbox_flag == 0){
							$flag = $this->Group->getFatherSet($extent_name_id,$this->Grpalt,2);
							$data_group_p=$this->grpalt_list($flag);
							$grpalt_group[$extent_name_id]= $data_group_p[0]["Grpalt"];
						}else{
							$grpalt_group[$extent_name_id]= $data_group[0]["Grpalt"];
						}
					}*/
					//$this->set('grpalt_group',$grpalt_group);
					(!empty($grpalt_group))?($this->set('grpalt_group',$grpalt_group)):null;
           }
		
/*		}else{
				if(empty($this->data["Grpaltprtfile"]["file_name"])){
						$errorMessage['keyword'][] = 'E-00100';
						$this->set('errorMessage', $errorMessage);
					
				}
				$this->index();
				$this->render('index');
				exit();			
		}*/				
		$this->groupName();
		$this->findGrpaltprtcnt();
		(!empty($grpalt_group_id))?($this->set('grpalt_group_id',$grpalt_group_id)):null;
		$this->set('hiddengrp',1);
		$this->print_list();
		$this->render('index');
		exit();
		
	}
	
	/* グループName  ページ 1
	*/
	function groupName(){
		$glist = $this->Grpauth->getChildrenByParent('1');
		ksort($glist);
		foreach ($glist as $key=>$value) {
			$criteria1=" Group.id=".$key." ";
			$group_name[$key]= $this->Group->findAll($criteria1);
		}
		//debug($group_name);
		$this->set('group_name',$group_name);
		
	}
	/////////////////////////////////////////////////////////////////find all from Grpaltprtcnt
	function findGrpaltprtcnt(){
		
		$glist = $this->Grpauth->getChildrenByParent('1');
		ksort($glist);
		foreach ($glist as $key=>$value) {
			$criteria2=" Grpaltprtcnt.group_id=".$key." ";
			$grpaltprtcnt_list[$key]= $this->Grpaltprtcnt->findAll($criteria2);
		}
		//debug($grpaltprtcnt_list);
		$this->set('grpaltprtcnt_list',$grpaltprtcnt_list);		
	}
	
	///////////////////////////////////////////////////////////     find from Grpaltprt where condition
	function findPartGrpaltprt(){
		
	}
	
	////////////////////////////////////////////////////////////////////////////control 
	//xinw start 20090203
	//modify for ASP4-031
	//function control($id=null,$group_id=null){
	function control($id=null,$group_id=null,$do=null){
	//xinw end 20090203
		$this->layout='ajax';
		if($id == '1'){
			$group_id = $group_id;
		}elseif($id == '2'){
			$group_id = $this->data["Grpaltprtfile"]["group_id_select"];
		}
		//xinw start 20090203
		//modify for ASP4-031
		//$this->view_file_ext($group_id);
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->view_file_ext($group_id,$do);
		$this->alert_set($group_id,$do);
		//sunhy start 2009/03/28 modify for JLN-001
		//xinw end 20090203
		//$this->render('index');
	}

	/////////////////////////////////////////////////////////////////ファイル名と拡張子の表示
	//sunhy start 2009/03/28 modify for JLN-001
	//function view_file_ext($group_id,$flag=null){//echo "view_file_ext<BR>";
	function alert_set($group_id,$flag=null){
	//sunhy start 2009/03/28 modify for JLN-001
		//debug($this->data);
		$this->layout='ajax';
		$this->print_list();
		$condition =" Group.id =".$group_id." ";
		$group= $this->Group->findAll($condition);
		$this->set('group',$group);
		$this->set('group_id',$group_id);
		
		//sunhy start 2009/03/28 modify for JLN-001
		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/28 modify for JLN-001
		/* グループ印刷ファイル設定表 */

		$glist_p=$this->Grpauth->getParentsByChild($group_id);
		ksort($glist_p);
		unset($glist_p[$group_id]);
		if(!empty($glist_p)){
			$parent_result =array();
				foreach ($glist_p as $key =>$v){

						$count_file_parent = $this->selectGrpaltprtfileflag($key);
					if($count_file_parent ==1){
						$selectGrpaltprtfileparent = $this->selectGrpaltprtfile($key);
						foreach ($selectGrpaltprtfileparent as $output){
							$parent_result[$key][] =$output;
						}
					}
			
					/* グループ拡張子印刷設定 */
					$count_text_p = $this->selectGrpaltprtextflag($key);
					if($count_text_p ==1){
						$selectGrpaltprtextParent = $this->selectGrpaltprtext($key);
						foreach ($selectGrpaltprtextParent as $output1){
/*							$file ="parent_file_extent_".$key."_".$m;
							$this->data["Grpaltprtfile"][$file] =  $output["Grpaltprtext"]["extent"];
							$m++;*/
							$parent_result[$key][] =$output1;
						}
						//debug($selectGrpaltprtextParent,true);
						//$this->set('selectGrpaltprtextParent',$selectGrpaltprtextParent);
						
					}
								
				}
				//$this->data['Grpaltprtfile']['animi_1_0'] =1;
/*				if(!empty($parent_result)){
						foreach ($parent_result as $key => $value){
							foreach ($value as $k => $v){
							 	foreach ($v as $k1 => $v2){
									if($k1 == "Grpaltprtfile"){
										$ami ="animi_".$key."_".$k;							
									   ($v2['animi'] == 0)?$this->data['Grpaltprtfile'][$ami] =1:$this->data['Grpaltprtfile'][$ami] =0;
									}
							 	}
							}
						}
				}*/
									   
				(empty($parent_result))?null:($this->set('parent_result',$parent_result));

		}

		
		
//echo "flag=".$flag."<br>";
	//if(!isset($this->data['Grpalt']['flag_radio'])){
		$count_file = $this->selectGrpaltprtfileflag($group_id);
		$i=1;
		if($count_file ==1){
			$selectGrpaltprtfile = $this->selectGrpaltprtfile($group_id);
			foreach ($selectGrpaltprtfile as $output){
				$name = "animi_".$i;
				if(!isset($this->data['Grpalt']['flag_radio'])||($flag == 9)){
					$this->data["Grpaltprtfile"][$name] = ($output["Grpaltprtfile"]["animi"] == 0)?1:0;
				}else{
					$this->data["Grpaltprtfile"][$name]=$this->data["Grpaltprtfile"][$name];
				}
				$radio = "radio_add_".$i;
				if(!isset($this->data['Grpalt']['flag_radio'])||($flag == 9)){
					$this->data["Grpaltprtext"][$radio] = 1;
				}else{
					$this->data["Grpaltprtext"][$radio]=$this->data["Grpaltprtext"][$radio];
				}
				//$this->data["Grpaltprtext"][$radio] = 1;
				$file ="file_extent_".$i;
				if(!isset($this->data['Grpalt']['flag_radio'])||($flag == 9)){
					$this->data["Grpaltprtfile"][$file] = $output["Grpaltprtfile"]["file_name"];
				}else{
					$this->data["Grpaltprtfile"][$file]=$this->data["Grpaltprtfile"][$file];
				}
				//$this->data["Grpaltprtfile"][$file] =  $output["Grpaltprtfile"]["file_name"];
				$i++;
			}
			//debug($selectGrpaltprtfile,true);
			//debug($this->data);
			$this->set('selectGrpaltprtfile',$selectGrpaltprtfile);
		}

		/* グループ拡張子印刷設定 */
		$count_text = $this->selectGrpaltprtextflag($group_id);
		if($count_text ==1){
			$selectGrpaltprtext = $this->selectGrpaltprtext($group_id);
			$j = $i;
			foreach ($selectGrpaltprtext as $output){
				$name = "animi_".$j;
				if(!isset($this->data['Grpalt']['flag_radio'])||($flag == 9)){
					$this->data["Grpaltprtfile"][$name] = 0;
				}else{
					$this->data["Grpaltprtfile"][$name]=$this->data["Grpaltprtfile"][$name];
				}
				$radio = "radio_add_".$j;
				if(!isset($this->data['Grpalt']['flag_radio'])||($flag == 9)){
					$this->data["Grpaltprtext"][$radio] = 2;
				}else{
					$this->data["Grpaltprtext"][$radio]=$this->data["Grpaltprtext"][$radio];
				}
				$file ="file_extent_".$j;
				if(!isset($this->data['Grpalt']['flag_radio'])||($flag == 9)){
					$this->data["Grpaltprtfile"][$file] = $output["Grpaltprtext"]["extent"];
				}else{
					$this->data["Grpaltprtfile"][$file]=$this->data["Grpaltprtfile"][$file];
				}
/*				$file ="file_extent_".$j;
				$this->data["Grpaltprtfile"][$file] =  $output["Grpaltprtext"]["extent"];*/
				$j++;
			}
			//debug($selectGrpaltprtext,true);
			$this->set('selectGrpaltprtext',$selectGrpaltprtext);
		}
	//}
		
		/* 月次累計枚数の表示 */

		$this->set('group_id',$group_id);		
		$con_grpaltprtcnt=" Grpaltprtcnt.group_id =".$group_id." ";
		$con_cnt= $this->Grpaltprtcnt->findAll($con_grpaltprtcnt);
		if(count($con_cnt) == 1){
			$this->set('grpaltprtcnt_flg','1');
			if(!isset($this->data['Grpaltprtcnt']['flag'])){
				$this->data['Grpaltprtcnt']['cnt_count'] =$con_cnt[0]["Grpaltprtcnt"]["count"];
			}
		}else{
			$this->set('grpaltprtcnt_flg','2');	
			if(!isset($this->data['Grpaltprtcnt']['flag'])){
				$this->data['Grpaltprtcnt']['cnt_count'] ='';//0;
			}
		}
		
		/* アラートメール／ポップアップ設定の表示 */
		//xinw start 20090203
		//modify for ASP4-031
		//$this->grpalt_set($group_id);
		$judge=$this->Grpalt->findAll(array('Grpalt.group_id='.$group_id,'Grpalt.type=2'));
		if (($flag=='nodo' || $flag=='nodo1') && empty($judge)) {
			//sunhy start 2009/05/14 modify for YBR-32
			//$this->data['Title']['title_flg']=1;
			$title =$this->title_list($group_id);
			$this->data['Title']['title_flg'] = ($title!=1)?1:0;
			//sunhy end 2009/05/14 modify for YBR-32
			//sunhy start 2009/03/28 modify for JLN-001
			//$this->data['Grpalt']['popup']=2;
			$this->data['Grpalt']['popup']=0;
			//sunhy end 2009/03/28 modify for JLN-001
			//sunhy start 2009/03/28 added for JLN-001
			$this->data['Grpalt']['mail_notice']=1;
			//sunhy end 2009/03/28 added for JLN-001
			//sunhy start 2009/05/14 modify for YBR-32
			//$this->data['Altmsg']['detail_flg']=1;
			$altmsg_list =$this->altmsg_list($group_id);
			$altmsg_list_detail =$this->altmsg_list_detail($group_id);
			$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
			if($altmsg_list[0]['Altmsg']['detail_flg']== ""){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//$altmsg=$this->Altmsg->findAll(array('id=2'));
			//$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			$this->data['Altmsg']['message'] = ((empty($altmsg_list[0]['Altmsg']['message']))?__('E0002', true):$altmsg_list[0]['Altmsg']['message']);
			//sunhy end 2009/05/14 modify for YBR-32
			$email = $this->_getemail($group_id);
			$this->set('email',$email);			
		}else 
		{
			$this->grpalt_set($group_id);
		}
		//xinw end 20090203

		/* 月次累計枚数の上限 */
		$glist_p=$this->Grpauth->getParentsByChild($group_id);
		ksort($glist_p);
		unset($glist_p[$group_id]);
		$i=0;
		foreach($glist_p as $k=>$v){
			$condition ="Grpaltprtcnt.group_id =".$k;
			$res_p=$this->Grpaltprtcnt->findAll($condition);
			if(count($res_p) == 1){
				$i++;
			}
		}
		if($group_id == 1){
			$this->set('getMaxPrtcnt','9999');	
		}else{
			if($i>0){
				$getMaxPrtcnt =$this->getMaxPrtcnt($group_id);
				$this->set('getMaxPrtcnt',$getMaxPrtcnt);
			}else{
				$this->set('getMaxPrtcnt','9999');	
			}			
		}
		$this->data["Grpaltprtext"]["radio_add"] = 1;
		$this->data["Grpaltprtfile"]["animi"] = 1;
		$this->set('checkbox_flag',$flag);
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->render('add');
		$this->render('alert_set');
		//sunhy end 2009/03/28 modify for JLN-001
		exit();		
		
	}
	
	

	/* 新規登録 印刷 (アラート設定)ページ　2
	*/
	function add($group_id,$flag=null){
		$this->layout='ajax';

		$condition =" Group.id =".$group_id." ";
		$group= $this->Group->findAll($condition);
		$this->set('group',$group);
		$this->print_list();
		//debug($group,true);'Grpalt/flag_radio
/*		if(!isset($this->data['Grpalt']['flag_radio'])){echo "jingjingjingjingjign<br>";
			$this->data['Grpaltprtfile']['animi'] =1;
		}else{*/
		if($flag == 9){
				$g_new = array();
				if(isset($this->data["Grpaltprtfile"]["file_extent"])&&(trim($this->data["Grpaltprtfile"]["file_extent"]) !='')){
					if(isset($this->data["Grpaltprtext"]["radio_add"])) {
						if($this->data["Grpaltprtext"]["radio_add"] == '1'){ 
							$file = $this->Lv->spec_char_dbm($this->data["Grpaltprtfile"]['file_extent']);
												 
							$con = "Grpaltprtfile.file_name ='".$file."' and Grpaltprtfile.group_id =".$group_id." and Grpaltprtfile.animi !=".$this->data["Grpaltprtfile"]["animi"];
							$res = $this->Grpaltprtfile->findAll($con);
							if(count($res) >0 ){
								$errorMessage_cnt['keyword'][] = 'E-01900';
								$this->set('errorMessage_cnt', $errorMessage_cnt);
								//sunhy start 2009/03/28 modify for JLN-001
								//$this->view_file_ext($group_id);
								$this->alert_set($group_id);
								//sunhy end 2009/03/28 modify for JLN-001
								exit();						
							}else{ 
								$this->addGrpaltprtfile($group_id);
								//$this->data["Grpaltprtfile"]["file_extent"] = '';
							}
						}elseif($this->data["Grpaltprtext"]["radio_add"] == '2') {		
							$file = $this->Lv->spec_char_dbm($this->data["Grpaltprtfile"]['file_extent']);
							$con = "Grpaltprtext.extent ='".$file."' and Grpaltprtext.group_id =".$group_id;
							$res = $this->Grpaltprtext->findAll($con);	
							if(count($res) >0){
								$errorMessage_cnt['keyword'][] = 'E-01900';
								$this->set('errorMessage_cnt', $errorMessage_cnt);
								//sunhy start 2009/03/28 modify for JLN-001
								//$this->view_file_ext($group_id);
								$this->alert_set($group_id);
								//sunhy end 2009/03/28 modify for JLN-001
								exit();						
							}else{
								$this->addGrpaltprtext($group_id);
								//$this->data["Grpaltprtfile"]["file_extent"] = '';
							}
						}	
									
						$this->set('group_id',$group_id);
						$g_new[]=$group_id;
						if(!empty($g_new)){
							//$this->GenerateFiles->hook_by_group($g_new, array('prints','popup'));
							//sunhy start 2009/05/06 modify for JLN-001
							//$this->GenerateFiles->hook_by_group($g_new, array('prints'));
							//sunhy start 2009/05/14 modify for YBR-32
							//$this->GenerateFiles->hook_by_ps(0, array("prints", "popup"));
							$grpalt = $this->grpalt_list($group_id);
							if(empty($grpalt[0]['Grpalt']['id']))
								$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 0, null, 1, 2, 'Grpalt');
							$this->GenerateFiles->hook_by_group($group_id, array("prints", "popup"));
							//sunhy end 2009/05/14 modify for YBR-32
							//sunhy start 2009/05/06 modify for JLN-001

						}
						//sunhy start 2009/03/28 modify for JLN-001
						//$this->view_file_ext($group_id,$flag);
						$this->alert_set($group_id,$flag);
						//sunhy end 2009/03/28 modify for JLN-001
		//				$this->render('add');
						exit();									
						
					}else{//未選択 
						$this->set('group_id',$group_id);
						$errorMessage_cnt = array('E-00200');
						$this->set('errorMessage_cnt', $errorMessage_cnt);
					}
					
				}else{
						$errorMessage_cnt['keyword'][] = 'E-00100';
						$this->set('errorMessage_cnt', $errorMessage_cnt);		
				}
		}
		/*}*/
		//echo "hahah=".$flag."<br>";
		//xinw start 20090209
		//modify for ASP4-031
		//$this->view_file_ext($group_id,$flag);
		$con_grpaltprtcnt=" Grpaltprtcnt.group_id =".$group_id." ";
		$con_cnt= $this->Grpaltprtcnt->findAll($con_grpaltprtcnt);
		//sunhy start 2009/04/06 modfiy for JLN-001
		/*if(count($con_cnt) == 1){
			$this->set('grpaltprtcnt_flg','1');
			if(!isset($this->data['Grpaltprtcnt']['flag'])){
				$this->data['Grpaltprtcnt']['cnt_count'] =$con_cnt[0]["Grpaltprtcnt"]["count"];
			}
			else{
				$this->data['Grpaltprtcnt']['cnt_count'] =0;
			}
		}else{
			$this->set('grpaltprtcnt_flg','2');	
			if(!isset($this->data['Grpaltprtcnt']['flag'])){
				$this->data['Grpaltprtcnt']['cnt_count'] =0;
			}
		}
		if($group_id == 1){
			$this->set('getMaxPrtcnt','9999');	
		}else{
			if($i>0){
				$getMaxPrtcnt =$this->getMaxPrtcnt($group_id);
				$this->set('getMaxPrtcnt',$getMaxPrtcnt);
			}else{
				$this->set('getMaxPrtcnt','9999');	
			}			
		}*/
		//sunhy end 2009/04/06 modify for JLN-001
		$this->set('group_id',$group_id);
		$judge=$this->Grpalt->findAll(array('Grpalt.group_id='.$group_id,'Grpalt.type=2'));
		if (array_key_exists('keyword',$errorMessage_cnt) && empty($judge)) {
			//sunhy start 2009/05/14 modify for YBR-32
			//$this->data['Title']['title_flg']=1;
			$title =$this->title_list($group_id);
			$this->data['Title']['title_flg'] = ($title!=1)?1:0;
			//sunhy end 2009/05/14 modify for YBR-32
			//sunhy start 2009/03/28 modify for JLN-001
			//$this->data['Grpalt']['popup']=2;
			$this->data['Grpalt']['popup']=0;
			//sunhy end 2009/03/28 modify for JLN-001
			//sunhy start 2009/03/28 added for JLN-001
			$this->data['Grpalt']['mail_notice']=1;
			//sunhy end 2009/03/28 added for JLN-001
			//sunhy start 2009/05/14 modify for YBR-32
			//$this->data['Altmsg']['detail_flg']=1;
			//$altmsg=$this->Altmsg->findAll(array('id=2'));
			//$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			$altmsg_list =$this->altmsg_list($group_id);
			$altmsg_list_detail =$this->altmsg_list_detail($group_id);
			$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
			$this->data['Altmsg']['message'] = (empty($altmsg_list[0]['Altmsg']['message'])?__('E0002', true):$altmsg_list[0]['Altmsg']['message']);
			//sunhy end 2009/05/14 modify for YBR-32
			$email = $this->_getemail($group_id);
			$this->set('email',$email);
			//sunhy start 2009/05/14 added for YBR-32
			$this->set('group_id',$group[0]['Group']['id']);
			//sunhy end 2009/05/14 added for YBR-32
			$this->set('getMaxPrtcnt','9999');
			$this->set('grpaltprtcnt_flg','1');
			$this->data["Grpaltprtcnt"]["cnt_count"]=0;
		}
		else 
		{
			//sunhy start 2009/03/28 modify for JLN-001
			//$this->view_file_ext($group_id,$flag);
			$this->alert_set($group_id,$flag);
			//sunhy start 2009/03/28 modify for JLN-001
		}
		//xinw end 20090209
	}
	
	
	/*
	* グループ印刷ファイル設定表(grpaltprtfiles)データの追加　ページ　2
	*/
	function addGrpaltprtfile($group_id,$num =null){
				if(empty($num)){ 
						if(isset($this->data["Grpaltprtfile"]["animi"])&&($this->data["Grpaltprtfile"]["animi"] == '1')){
								$checkbox = 0;
						}else{
								$checkbox = 1;
						}
						$file_name = $this->data["Grpaltprtfile"]["file_extent"];
				}else{
					$ext = "file_extent_".$num;
					$file_name = $this->data["Grpaltprtfile"][$ext];
					$animi = "animi_".$num;
					if(isset($this->data["Grpaltprtfile"][$animi])&&($this->data["Grpaltprtfile"][$animi] == '1')){
							$checkbox = 0;
					}else{
							$checkbox = 1;
					}
				 }
				 //debug($insertgrpaltprtfiles);
				$insertgrpaltprtfiles=Array(	
					'Grpaltprtfile' => Array(
					'id' => null,
					'group_id' => $group_id,
					'file_name' => $this->Lv->spec_char_dbm($file_name),
					'animi' => $checkbox,
				));
				//debug($insertgrpaltprtfiles);
				$this->data['Grpaltprtfile']['id'] = null;
				$this->Grpaltprtfile->save($insertgrpaltprtfiles);
				
				
				
				$alertId = $this->Grpaltprtfile->getLastInsertID();	
				$glist_child = $this->Grpauth->getChildrenByParent($group_id);
				ksort($glist_child);
				foreach ($glist_child as $key=>$value) {
						$insertrltgrpaltprtfiles=Array(	
							'Rltgrpaltprtfile' => Array(
							'group_id' => $key,
							'alert_id' => $alertId,
							'org_grp_id' => $group_id,
						));
						$this->Rltgrpaltprtfile->save($insertrltgrpaltprtfiles);	
				}
				if(empty($num)){   //echo "mm";
					$this->data["Grpaltprtfile"]["file_extent"] = null;
				}
	}
	/*
	* グループ印刷ファイル設定表(grpaltprtfiles)データの変更
	*/
	function editGrpaltprtfile($id,$check){
		//echo "editGrpaltprtfile<br>";
				$animi ="animi_".$check;
				if(isset($this->data["Grpaltprtfile"][$animi])&&($this->data["Grpaltprtfile"][$animi] == '1')){
						$checkbox = 0;
				}else{
						$checkbox = 1;
				}
				$file ="file_extent_".$check;
				$insertgrpaltprtfiles=Array(	
					'Grpaltprtfile' => Array(
					'id' => $id,
					'file_name' => $this->Lv->spec_char_dbm($this->data["Grpaltprtfile"][$file]),
					'animi' => $checkbox,
				));
				//debug($insertgrpaltprtfiles);
				$this->Grpaltprtfile->save($insertgrpaltprtfiles);	
	}
	/*
	* グループ印刷ファイル設定表(grpaltprtfiles)データの捜索
	*/
	function selectGrpaltprtfile($group_id){
		$condition = "Grpaltprtfile.group_id =".$group_id." order by Grpaltprtfile.id ASC";
		$data =$this->Grpaltprtfile->findAll($condition);
		return $data;
	}
	function selectGrpaltprtfileflag($group_id){
		$condition = "Grpaltprtfile.group_id =".$group_id;
		$data =$this->Grpaltprtfile->findAll($condition);
		if(count($data)>0){
			return 1;
		}else{
			return 0;
		}
	}
	/*
	* グループ拡張子印刷設定(grpaltprtexts)データの追加
	*/
	function addGrpaltprtext($group_id,$num = null){
				if(empty($num)){   //echo "mm";
					$file = $this->data["Grpaltprtfile"]["file_extent"];
				}else{ //echo "nn";
					$ext = "file_extent_".$num;
					$file = $this->data["Grpaltprtfile"][$ext];
				}
				$insertgrpaltprtexts=Array(	
					'Grpaltprtext' => Array(
					'id' => null,
					'group_id' => $group_id,
					'extent' => $this->Lv->spec_char_dbm($file),
				));
				//debug($insertgrpaltprtexts);
				$this->Grpaltprtext->save($insertgrpaltprtexts);
				$alertId = $this->Grpaltprtext->getLastInsertID();	
				$glist_child = $this->Grpauth->getChildrenByParent($group_id);
				ksort($glist_child);
				foreach ($glist_child as $key=>$value) {
						$insertrltgrpaltprtexts=Array(	
							'Rltgrpaltprtext' => Array(
							'group_id' => $key,
							'alert_id' => $alertId,
							'org_grp_id' => $group_id,
						));
						$this->Rltgrpaltprtext->save($insertrltgrpaltprtexts);	
				}
				if(empty($num)){   //echo "mm";
					$this->data["Grpaltprtfile"]["file_extent"] = null;
				}
	}
	/*
	* グループ拡張子印刷設定(grpaltprtexts)データの変更
	*/
	function editGrpaltprtext($id,$check){
				$ext = "file_extent_".$check;
				$file = $this->data["Grpaltprtfile"][$ext];
				$insertgrpaltprtexts=Array(	
					'Grpaltprtext' => Array(
					'id' => $id,
					'extent' => $this->Lv->spec_char_dbm($file),
				));
				
				$this->Grpaltprtext->save($insertgrpaltprtexts);		
	}
	/*
	* グループ拡張子印刷設定(grpaltprtexts)データの捜索
	*/
	function selectGrpaltprtext($group_id){
		$condition = "Grpaltprtext.group_id =".$group_id." order by Grpaltprtext.id ASC";
		$data =$this->Grpaltprtext->findAll($condition);
		return $data;
	}
	function selectGrpaltprtextflag($group_id){
		$condition = "Grpaltprtext.group_id =".$group_id;
		$data =$this->Grpaltprtext->findAll($condition);
		if(count($data)>0){
			return 1;
		}else{
			return 0;
		}
	}
   ////////////////////////////////////////////////////////////////削除する  //add delete
   function deleteGrpaltfile_text($group_id){
		$this->layout='ajax';
		$g_new = array();
		if(!isset($this->data['Grpaltprtfile']['id']) &&(!isset($this->data['Grpaltprtext']['id']))){
				$error =__('E-00200',$return = true);
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$errorMessage_cnt['list'][] =$error;
				$errorMessage_cnt['keyword'][] =$error;
				//xushanning end 2009/04/22   modify for LogvillageChinese
				//debug($errorMessage);
				$this->set('errorMessage_cnt',$errorMessage_cnt);
				
		}else{
			if(isset($this->data['Grpaltprtfile']['id'])){
				$word_id  = $this->data['Grpaltprtfile']['id'];
				foreach ($word_id as $check){
					$radio = "radio_add_".$check;
					$id=$this->data["Grpaltprtfile"]["edit"][$check][0];
					//echo "id=".$id."<br>";
					$this->Grpaltprtfile->del($id);
				}
			}
			if(isset($this->data['Grpaltprtext']['id'])){
				$word_id  = $this->data['Grpaltprtext']['id'];
				foreach ($word_id as $check){
					$radio = "radio_add_".$check;
					$id=$this->data["Grpaltprtext"]["edit"][$check][0];
					//echo "id=".$id."<br>";
					$this->Grpaltprtext->del($id);
				}				
			}
				$g_new[]=$group_id;
				if(!empty($g_new)){
					//sunhy start 2009/05/14 modify for YBR-32
					//$this->GenerateFiles->hook_by_group($g_new, array('prints'));
					$this->GenerateFiles->hook_by_group($group_id, array('prints'));
					//sunhy end 2009/05/14 modify for YBR-32
				}			
		}
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->view_file_ext($group_id,9);
		$this->alert_set($group_id,9);
		//sunhy start 2009/03/28 modify for JLN-001	
   	
   }
   
   ////////////////////////////////////////////////////////////////ファイル削除
   function deleteGrpaltfileGroup(){
  		$this->layout='ajax';

/*		debug($this->data['Grpaltprtfile']['del'],true);
		debug($this->data['Grpaltprtfile']['del_id'],true);
		debug($this->data["Grpaltprtext"]["del_id"]);*/
		$g_new = array();
		if(isset($this->data['Grpaltprtfile']['del'])){
			$dei =$this->data['Grpaltprtfile']['del'];
				foreach ($dei as $key=>$v){
					//debug($key);
					//debug($v);
						
/*						$onesun =$this->_findOneSun($v);
						$i=0;
						if($onesun !=2){
							foreach ($onesun as $key => $v1){
								if($v1 == 0) {
									$i++;
								}
							}
						}
		
						if($i > 0) {
							$error =__('delete_list_group_error',$return = true);
							$errorMessage['delete_list_group'][] =$error;
							//debug($errorMessage);
							$this->set('errorMessage',$errorMessage);
						}else{*/
								$g_new[]=$v;
								if(isset($this->data['Grpaltprtfile']['del_id'])){
									$word_id  = $this->data['Grpaltprtfile']['del_id'];
									foreach ($word_id as $key_file=>$check){
										if($key_file == $v){
											foreach ($check as $id){
												$this->Grpaltprtfile->del($id);
											}
										}
									}
								}
								if(isset($this->data['Grpaltprtext']['del_id'])){
									$word_id  = $this->data['Grpaltprtext']['del_id'];
									foreach ($word_id as $key_ext => $check){
										if($key_ext == $v) {
											foreach ($check as $id){
												$this->Grpaltprtext->del($id);
											}
										}
									}				
								}								
								$con_file ="Grpaltprtfile.group_id =".$v;
								$re1 =$this->Grpaltprtfile->findAll($con_file);
								$con_text ="Grpaltprtext.group_id =".$v;
								$re2 =$this->Grpaltprtext->findAll($con_text);
								if((empty($re1))&&(empty($re2))){
									    $con_count = "Grpaltprtcnt.group_id =".$v;
									    $prtcnt = $this->Grpaltprtcnt->findAll($con_count);
									    if(count($prtcnt) == 1){
									    	$prtcnt_id = $prtcnt[0]['Grpaltprtcnt']['id'];
									    	//echo "prtcnt_id =".$prtcnt_id;
									    	$this->Grpaltprtcnt->del($prtcnt_id);
									    }
										$del_grpalt = $this->grpalt_list_id($v);
										$this->Grpalt->del($del_grpalt);
										//$con = "Grpalt.type=2 ";
										//$grpalt = $this->Grpalt->findAll($con);
										////////delete by wzy
//										if(count($grpalt) == 0){
////											$title_id =$this-> title_flag();
////											if($title_id != 0){
//////												$this->Title->del($title_id);				
////											}
////											$msg_id =$this->altmsg_flag();
////											if($msg_id != 0){
//////												$this->Altmsg->del($msg_id);				
////												//$this->GenerateFiles->hook_by_group(1, array('popup'));
////											}
//										}
								}						
						/*}*/
					if(!empty($g_new)){
						//$this->GenerateFiles->hook_by_group($g_new, array('prints','popup'));
						//sunhy start 2009/05/14 modify for YBR-32
						//$this->GenerateFiles->hook_by_group($g_new, array('prints'));
						// yzl start 2009/07/24 modify for JL-0035
						//$this->GenerateFiles->hook_by_group($v, array('prints'));
						$this->MailPopupController->delAltMsg("E0002",$v);
						$this->MailPopupController->delAltTit("2",$v);
						$this->GenerateFiles->hook_by_group($v, array('prints','popup'));
						// yzl end 2009/07/24 modify for JL-0035
						//sunhy end 2009/05/14 modify for YBR-32
						//$this->GenerateFiles->hook_by_group(array("1"), array('prints'));
					}
						
				}
		}else{
				$error =__('E-00200',$return = true);
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$errorMessage['list'][] =$error;
				$errorMessage['entry'][] =$error;
				//xushanning end 2009/04/22   modify for LogvillageChinese
				//debug($errorMessage);
				$this->set('errorMessage',$errorMessage);
		}

		if(isset($this->data["Rltgrpaltprtfile"]["hiddengrp"])&&($this->data["Rltgrpaltprtfile"]["hiddengrp"] ==1)){//echo "33333333333333333333333";
			$this->select_group_list();
		}else{
			$this->index();
			$this->render('index');
			exit();			
		}  	
   }
   
   /* 印刷 アラート設定編集画面 ページ 2
   */
	function editGrpaltfile_text($group_id){
		$this->layout='ajax';
		//echo "editGrpaltfile_text<br>";
/*		debug($this->data['Grpaltprtfile']['id'],true);
		debug($this->data['Grpaltprtext']['id'],true);
		debug($this->data["Grpaltprtfile"]["edit"]);
		debug($this->data["Grpaltprtext"]["edit"]);*/
		$g_new = array();
		if(!isset($this->data['Grpaltprtfile']['id'])&&(!isset($this->data['Grpaltprtext']['id']))){
				$error =__('E-00200',$return = true);
				$errorMessage_cnt['keyword'][] =$error;
				$this->set('errorMessage_cnt',$errorMessage_cnt);
		}else{
			
			if(isset($this->data['Grpaltprtfile']['id'])){
					$word_id  = $this->data['Grpaltprtfile']['id'];
					foreach ($word_id as $check){
						$radio = "radio_add_".$check;
						$id=$this->data["Grpaltprtfile"]["edit"][$check][0];
						$animi = "animi_".$check;
						$ext = "file_extent_".$check;
						$file = $this->Lv->spec_char_dbm($this->data["Grpaltprtfile"][$ext]);
						
						$re_file =$this->Lv->is_empty($file);
						if($re_file){
									$errorMessage_cnt['keyword'][] = 'E-00100';
									$this->set('errorMessage_cnt', $errorMessage_cnt);	
									//sunhy start 2009/03/28 modify for JLN-001
									//$this->view_file_ext($group_id);
									$this->alert_set($group_id);
									//sunhy start 2009/03/28 modify for JLN-001
									exit();						
						}else{
								if($this->data["Grpaltprtext"][$radio] == '1'){
									
									$con = "Grpaltprtfile.file_name ='".$file."' and Grpaltprtfile.group_id =".$group_id." and Grpaltprtfile.animi !=".$this->data["Grpaltprtfile"][$animi]." and Grpaltprtfile.id !=".$id;
									$res = $this->Grpaltprtfile->findAll($con);
									if(count($res) >0 ){
										$errorMessage_cnt['keyword'][] = 'E-01900';
										$this->set('errorMessage_cnt', $errorMessage_cnt);
										//sunhy start 2009/03/28 modify for JLN-001
										//$this->view_file_ext($group_id);
										$this->alert_set($group_id);
										//sunhy start 2009/03/28 modify for JLN-001
										exit();	
									}
								}else{
										$con = "Grpaltprtext.extent ='".$file."' and Grpaltprtext.group_id =".$group_id;
										$res = $this->Grpaltprtext->findAll($con);	
										if(count($res) >0){
											$errorMessage_cnt['keyword'][] = 'E-01900';
											$this->set('errorMessage_cnt', $errorMessage_cnt);
											//sunhy start 2009/03/28 modify for JLN-001
											//$this->view_file_ext($group_id);
											$this->alert_set($group_id);
											//sunhy start 2009/03/28 modify for JLN-001
											exit();						
										}
								}
						}
					}
					foreach ($word_id as $check){
					     $radio=$this->data['Grpaltprtext']['radio_add_'.$check];
					     $animi=$this->data['Grpaltprtfile']['animi_'.$check];
						 $file = $this->data["Grpaltprtfile"]['file_extent_'.$check];
					     $flag=0;
						    foreach ($word_id as $id){
						
						     if(($check != $id) and ($flag ==0) ) {       
						      if ($radio == $this->data['Grpaltprtext']['radio_add_'.$id] and ($animi==$this->data['Grpaltprtfile']['animi_'.$id]) and ($file==$this->data['Grpaltprtfile']['file_extent_'.$id])){
						       $flag=1;
						      }
						     }
						    }
					    if($flag==1){//echo "111<br>";
								$errorMessage_cnt['keyword'][] = 'E-01900';
								$this->set('errorMessage_cnt', $errorMessage_cnt);      
					    }
					}
			}
			if(isset($this->data['Grpaltprtext']['id'])){
					$word_id  = $this->data['Grpaltprtext']['id'];
					foreach ($word_id as $check){
						$radio = "radio_add_".$check;
						$id=$this->data["Grpaltprtext"]["edit"][$check][0];
						$animi = "animi_".$check;
						$ext = "file_extent_".$check;
						$file = $this->Lv->spec_char_dbm($this->data["Grpaltprtfile"][$ext]);
						$re_file_text =$this->Lv->is_empty($file);
						if($re_file_text){
									$errorMessage_cnt['keyword'][] = 'E-00100';
									$this->set('errorMessage_cnt', $errorMessage_cnt);	
									//sunhy start 2009/03/28 modify for JLN-001
									//$this->view_file_ext($group_id);
									$this->alert_set($group_id);
									//sunhy start 2009/03/28 modify for JLN-001
									exit();						
						}else{
								if($this->data["Grpaltprtext"][$radio] == '1'){
									$con = "Grpaltprtfile.file_name ='".$file."' and Grpaltprtfile.group_id =".$group_id." and Grpaltprtfile.animi !=".$this->data["Grpaltprtfile"][$animi];
									$res = $this->Grpaltprtfile->findAll($con);
									if(count($res) >0 ){
										$errorMessage_cnt['keyword'][] = 'E-01900';
										$this->set('errorMessage_cnt', $errorMessage_cnt);
										//sunhy start 2009/03/28 modify for JLN-001
										//$this->view_file_ext($group_id);
										$this->alert_set($group_id);
										//sunhy start 2009/03/28 modify for JLN-001
										exit();						
									}		
								}else{
										$con = "Grpaltprtext.extent ='".$file."' and Grpaltprtext.group_id =".$group_id." and Grpaltprtext.id !=".$id;
										$res = $this->Grpaltprtext->findAll($con);	
										if(count($res) >0){
											$errorMessage_cnt['keyword'][] = 'E-01900';
											$this->set('errorMessage_cnt', $errorMessage_cnt);
											//sunhy start 2009/03/28 modify for JLN-001
											//$this->view_file_ext($group_id);
											$this->alert_set($group_id);
											//sunhy start 2009/03/28 modify for JLN-001
											exit();						
										}			
								}
						}
					}
					foreach ($word_id as $check){
					     $radio=$this->data['Grpaltprtext']['radio_add_'.$check];
					     $animi=$this->data['Grpaltprtfile']['animi_'.$check];
						 $file = $this->data["Grpaltprtfile"]['file_extent_'.$check];
					     $flag=0;
						    foreach ($word_id as $id){
						
						     if(($check != $id) and ($flag ==0) ) {       
						      if ($radio == $this->data['Grpaltprtext']['radio_add_'.$id] and ($animi==$this->data['Grpaltprtfile']['animi_'.$id]) and ($file==$this->data['Grpaltprtfile']['file_extent_'.$id])){
						       $flag=1;
						      }
						     }
						    }
					    if($flag==1){//echo "222<br>";
								$errorMessage_cnt['keyword'][] = 'E-01900';
								$this->set('errorMessage_cnt', $errorMessage_cnt);      
					    }
					}				
			}
			
			if(isset($this->data['Grpaltprtfile']['id'])&&(isset($this->data['Grpaltprtext']['id']))){
				$word_id  = $this->data['Grpaltprtfile']['id'];
				$word_id_text = $this->data['Grpaltprtext']['id'];
				foreach ($word_id as $check){
				     $radio=$this->data['Grpaltprtext']['radio_add_'.$check];
				     $animi=$this->data['Grpaltprtfile']['animi_'.$check];
				     $file=$this->data['Grpaltprtfile']['file_extent_'.$check];

				     $flag=0;
					    foreach ($word_id_text as $id){
					
					     if(($check != $id) and ($flag ==0) ) {       
					      if ($radio == $this->data['Grpaltprtext']['radio_add_'.$id] and ($animi==$this->data['Grpaltprtfile']['animi_'.$id]) and ($file==$this->data['Grpaltprtfile']['file_extent_'.$id])){
					       $flag=1;
					      }
					     }
					    }
				    if($flag==1){//echo "333<br>";
							$errorMessage_cnt['keyword'][] = 'E-01900';
							$this->set('errorMessage_cnt', $errorMessage_cnt);      
				    }
				}
			}
			//debug($errorMessage_cnt);
			
			if(empty($errorMessage_cnt)){
					if(isset($this->data['Grpaltprtfile']['id'])){
						$word_id  = $this->data['Grpaltprtfile']['id'];
						foreach ($word_id as $check){
							$radio = "radio_add_".$check;
							$id=$this->data["Grpaltprtfile"]["edit"][$check][0];
							//echo "id_file=".$id."<br>";
							$animi = "animi_".$check;
							$ext = "file_extent_".$check;
							$file = $this->data["Grpaltprtfile"][$ext];
							
							if($this->data["Grpaltprtext"][$radio] == '1'){
							//echo "id_file=".$id."<br>";
									$this->editGrpaltprtfile($id,$check);
									
							}else{
									$this->Grpaltprtfile->del($id);
								    $this->addGrpaltprtext($group_id,$check);
									$this->data['Grpaltprtfile'][$animi] =0;
							}
						}
					}
					if(isset($this->data['Grpaltprtext']['id'])){
						$word_id_text  = $this->data['Grpaltprtext']['id'];
						foreach ($word_id_text as $check){
							$radio = "radio_add_".$check;
							$id=$this->data["Grpaltprtext"]["edit"][$check][0];
							//echo "id_text=".$id."<br>";
							$animi = "animi_".$check;
							$ext = "file_extent_".$check;
							$file = $this->data["Grpaltprtfile"][$ext];

							if($this->data["Grpaltprtext"][$radio] == '1'){
									$this->addGrpaltprtfile($group_id,$check);				
									$this->Grpaltprtext->del($id);	
							}else{
									$this->editGrpaltprtext($id,$check);
									$this->data['Grpaltprtfile'][$animi] =0;				
			
							}
						}			
					}
				$g_new[]=$group_id;
				if(!empty($g_new)){
					//sunhy start 2009/05/14 modify for YBR-32
					//$this->GenerateFiles->hook_by_group($g_new, array('prints'));
					$this->GenerateFiles->hook_by_group($group_id, array('prints'));
					//sunhy end 2009/05/14 modify for YBR-32
				}
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->view_file_ext($group_id,9);
				$this->alert_set($group_id,9);
				//sunhy start 2009/03/28 modify for JLN-001
				exit();			
			}

		}
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->view_file_ext($group_id);
		$this->alert_set($group_id);
		//sunhy start 2009/03/28 modify for JLN-001	
	}
	
	

	/* 追加月次累計枚数 ページ 2
	*/
	//xinw start 20090209
	//modify for ASP4-031
	//function addGrpaltprtcnt($group_id){
	function addGrpaltprtcnt($group_id,$do=null){	
	//xinw end 20090209
		//echo "addGrpaltprtcnt<br>";
		$con = "Grpaltprtcnt.group_id =".$group_id;
		$result = $this->Grpaltprtcnt->findAll($con);
		if(count($result) >0) {
			$this->editGrpaltprtcnt($group_id);
			exit();
		}else{
				$errorMessage_cnt =$this->checkGrpaltprtcnt();
				if(empty($errorMessage_cnt)){
				//if(isset($this->data["Grpaltprtcnt"]["cnt_count"])){echo "111<br>";
					if($this->data["Grpaltprtcnt"]["cnt_count"] > $this->data['Grpaltprtcnt']['max_prtcnt'] ){
						$errorMessage_cnt['month_accumulate'][] = 'paper_above';
						$this->set('errorMessage_cnt', $errorMessage_cnt);	
					}else if($this->data["Grpaltprtcnt"]["cnt_count"] < 0){
						$con_count = "Grpaltprtcnt.group_id =".$group_id;
						$prtcnt = $this->Grpaltprtcnt->findAll($con_count);
						if(count($prtcnt) == 1){
							$prtcnt_id = $prtcnt[0]['Grpaltprtcnt']['id'];
							$this->Grpaltprtcnt->del($prtcnt_id);
						}
						$this->data["Grpaltprtcnt"]["cnt_count"] = '';
					}else{
							$insertGrpaltprtcnt=Array(	
								'Grpaltprtcnt' => Array(
								'group_id' => $group_id,
								'count' => $this->data["Grpaltprtcnt"]["cnt_count"],
							));
							$this->Grpaltprtcnt->save($insertGrpaltprtcnt);
							
							//追加月次累計枚数関連設定





							$alertId = $this->Grpaltprtcnt->getLastInsertID();			
							$glist_child = $this->Grpauth->getChildrenByParent($group_id);
							ksort($glist_child);
							foreach ($glist_child as $key=>$value) {
								$insertrltgrpaltprtcnt=Array(	
									'Rltgrpaltprtcnt' => Array(
									'group_id' => $key,
									'alert_id' => $alertId,
									'org_grp_id' => $group_id,
								));
								$this->Rltgrpaltprtcnt->save($insertrltgrpaltprtcnt);					
							}			
					}
		
				}else{//ban jiao 
					//$errorMessage_cnt = array('E-00100');
					$this->set('errorMessage_cnt', $errorMessage_cnt);			
				}
				//xinw start 20090209
				//modify for ASP4-031
				//$this->view_file_ext($group_id);
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->view_file_ext($group_id,$do);
				//sunhy start 2009/05/06 added for JLN-001
				$grpalt = $this->grpalt_list($group_id);
				if(empty($grpalt[0]['Grpalt']['id']))
					$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 0, null, 1, 2, 'Grpalt');
				//sunhy end 2009/05/06 added for JLN-001
				//sunhy start 2009/05/14 modify for YBR-32
				//$this->GenerateFiles->hook_by_ps(0, array("prints", "popup"));
				$this->GenerateFiles->hook_by_group($group_id, array('prints'));
				//sunhy end 2009/05/14 modify for YBR-32
				$this->alert_set($group_id,$do);
				//sunhy start 2009/03/28 modify for JLN-001
				//xinw end 20090209
		}
		
	}
	
	/* 変更月次累計枚数 ページ2
	*/
	//xinw start 20090209
	//modify for ASP4-031
	//function editGrpaltprtcnt($group_id){
	function editGrpaltprtcnt($group_id,$do=null){
	//xinw end 20090209
		//echo "editGrpaltprtcnt<br>";
		$condition =" Grpaltprtcnt.group_id =".$group_id." ";
		$grpaltprtcnt_id_group= $this->Grpaltprtcnt->findAll($condition);
		//sunhy start 2009/04/06 modify for JLN-001
		//$grpaltprtcnt_id = 	   $grpaltprtcnt_id_group[0]["Grpaltprtcnt"]["id"];
		$grpaltprtcnt_id = 	empty($grpaltprtcnt_id_group[0]["Grpaltprtcnt"]["id"])?0:$grpaltprtcnt_id_group[0]["Grpaltprtcnt"]["id"];
		//sunhy end 2009/04/06 modify for JLN-001
		$errorMessage_cnt =$this->checkGrpaltprtcnt();
		if(!empty($errorMessage_cnt)){
			$this->set('errorMessage_cnt', $errorMessage_cnt);			
		}else{//echo "222<br>";
			if($this->data["Grpaltprtcnt"]["cnt_count"] > $this->data['Grpaltprtcnt']['max_prtcnt'] ){
				$errorMessage_cnt['month_accumulate'][] = 'paper_above';
				$this->set('errorMessage_cnt', $errorMessage_cnt);	
			}else if($this->data["Grpaltprtcnt"]["cnt_count"] < 0){
				$con_count = "Grpaltprtcnt.group_id =".$group_id;
				$prtcnt = $this->Grpaltprtcnt->findAll($con_count);
				if(count($prtcnt) == 1){
					$prtcnt_id = $prtcnt[0]['Grpaltprtcnt']['id'];
					$this->Grpaltprtcnt->del($prtcnt_id);
				}
				$this->data["Grpaltprtcnt"]["cnt_count"] = '';
			}else{
/*				if($this->data["Grpaltprtcnt"]["cnt_count"] == ''){
					$this->data["Grpaltprtcnt"]["cnt_count"] = 0;
				}*/
				$insertGrpaltprtcnt=Array(
					'Grpaltprtcnt' => Array(
					'id' =>	$grpaltprtcnt_id,
					'group_id' => $group_id,
					'count' => $this->data["Grpaltprtcnt"]["cnt_count"],
				));
	
				$this->Grpaltprtcnt->save($insertGrpaltprtcnt);
				
			}	
		}
		//xinw start 20090209
		//modify for ASP4-031
		//$this->view_file_ext($group_id);
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->view_file_ext($group_id,$do);
		//sunhy start 2009/05/14 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("prints", "popup"));
		$this->GenerateFiles->hook_by_group($group_id, array('prints'));
		//sunhy end 2009/05/14 modify for YBR-32
		$this->alert_set($group_id,$do);
		//sunhy start 2009/03/28 modify for JLN-001
		//xinw end 20090209	
	}
	
	/* 月次累計枚数のチェック ページ2
	*/
	function checkGrpaltprtcnt(){
			$flag = 0;
			if(trim($this->data["Grpaltprtcnt"]["cnt_count"]) == ''){
				$this->data["Grpaltprtcnt"]["cnt_count"]=-1;
				
			}
/*				$errorMessage['month_accumulate'][] = 'E-00100';
				$flag = 1;		
			}else{*/
				$result = $this->Validation->numeric($this->data["Grpaltprtcnt"]["cnt_count"]);
				if(!$result){
					$errorMessage['month_accumulate'][] = 'E-00600';
					$flag = 1;
				}
		         if(!$this->Validation->maxLength($this->data['Grpaltprtcnt']['cnt_count'],4))
		        {
		             //$hostname_error['Host/host_name']=__('E-00300',$return = true);
		             $errorMessage['month_accumulate'][] = 'E-00300';
		             $flag = 1;
		        }
/*			}*/
			//debug($errorMessage);
			if($flag == 1){
				return 	$errorMessage;
			}else{
				return null;
			}
			
	}
	
	function getMaxPrtcnt($group_id){
		$con = "Group.id =".$group_id;
		$result = $this->Group->findAll($con);
		$parent_id = $result[0]["Group"]["parent_id"];
		$con_cnt = "Grpaltprtcnt.group_id =".$parent_id;
		$res=$this->Grpaltprtcnt->findAll($con_cnt);
		if(count($res) == 1){
			return $res[0]["Grpaltprtcnt"]["count"];
			exit();
		}else{
			$key = $this->getMaxPrtcnt($parent_id);
			return $key;
		}
		
	}
	function getGrpaltprtcntset($group_id){
        if($group_id !=null){
			if($group_id !=1){
				$group_father_i = $this->group_father_id($group_id);
				$grpalt_list_flag=$model->grpalt_list_flag($group_father_i,$type);
				if($grpalt_list_flag ==1) {
					$checkbox_flag =$model->getGrpalt_up_cast($group_father_i,$type);
					if($checkbox_flag == 1) {
						return $group_father_i;
					}else{ //echo "1<br>";
						$result = $this->getFatherSet($group_father_i,& $model,$type);
						return $result;
						
					}
				}else{
					$id =0;
					return $id;
				}
			}else{
				$id =0;
				return $id;
			}
        }		
	}
	
	////////////////////////////////////////////////////////////////登録済みプリンタリスト





	function grpprt_list(){
		
	}
	function  getFatherSet($group_id, & $model,$type){
        if($group_id !=null){
			if($group_id !=1){
				$group_father_i = $this->group_father_id($group_id);
				$grpalt_list_flag=$model->grpalt_list_flag($group_father_i,$type);
				if($grpalt_list_flag ==1) {
					$checkbox_flag =$model->getGrpalt_up_cast($group_father_i,$type);
					if($checkbox_flag == 1) {
						return $group_father_i;
					}else{ //echo "1<br>";
						$result = $this->getFatherSet($group_father_i,& $model,$type);
						return $result;
						
					}
				}else{
					$id =0;
					return $id;
				}
			}else{
				$id =0;
				return $id;
			}
        }
	}
	
	function grpalt_set($group_id,$flag=null){
		//echo "grpalt_set<br>";
		$this->layout='ajax';
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);


		/*if((isset($this->data['Grpalt']['up_cast']))&&($this->data['Grpalt']['up_cast'] == '1')){*/
			//上位グループの設定を引き継ぐ
/*			$checkbox_flag =0;
		}else{
			$checkbox_flag =1;
		}*/

		$getUserGroup = $this->_getUserGroup_id();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		//上位グループの設定を引き継ぐ
		//if(@$this->data["Grpalt"]["Grpalt_flag"] != 1){
		if(!isset($this->data["Grpalt"]["Grpalt_flag"])){  //echo "Grpalt_flag<br>";
			$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,2);
			if($grpalt_f == 1){ //echo "1111<br>";
				$grpalt_r = $this->grpalt_list($group_id);
				//debug($grpalt_r);
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:0;
				//sunhy end 2009/03/28 modify for JLN-001
				$this->data['Grpalt']['receive'] = ($grpalt_r[0]['Grpalt']['receive']==0)?1:0;
				($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';
				//$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->set('flg',2);

			}else{ //echo "Grpalt_flag!=1<br>";
				$this->data['Grpalt']['mail_notice'] = 1;
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->data['Grpalt']['popup'] = 2;
				$this->data['Grpalt']['popup'] = 0;
				//sunhy end 2009/03/28 modify for JLN-001
				$mail_notice_time_c = '00';
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->data['Grpalt']['mail_notice_time_hour'] = ''; 
				$this->data['Grpalt']['receive'] = 0; 
				//$up_cast_flag = 1;
				
				//追加grpalt
				$this->add_grpalt($group_id,1,2);
				$this->set('flg',1);
			}
			//sunhy start 2009/05/14 modify for YBR-32
			//if($getUserGroup == 1){ //echo "getUserGroup == 1<br>";
			if(!empty($getUserGroup)){
				//$title =$this->title_list();
				$title =$this->title_list($group_id);
				$this->data['Title']['title_flg'] = ($title!=1)?1:0;

				//$altmsg_list =$this->altmsg_list();
				$altmsg_list =$this->altmsg_list($group_id);
				//$altmsg_list_detail =$this->altmsg_list_detail();
				$altmsg_list_detail =$this->altmsg_list_detail($group_id);
				//sunhy start 2009/03/28 added for JLN-001
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
				$this->data['Altmsg']['detail_flg'] = (empty($altmsg_list_detail)||$altmsg_list_detail==0)?0:1;
				//sunhy end 2009/03/28 added for JLN-001
				//$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
				$this->data['Altmsg']['message'] = ((empty($altmsg_list[0]['Altmsg']['message']))?__('E0002', true):$altmsg_list[0]['Altmsg']['message']);
				//debug($this->data);
			}
			//sunhy end 2009/05/14 modfiy for YBR-32
		}
/*		if(!isset($up_cast_flag)){
			$up_cast_flag = 1;
		}
		$this->set('up_cast_flag',$up_cast_flag);*/
		/* 追加　*/
		if(isset($this->data["Grpalt"]["Grpalt_flag"])&&($this->data["Grpalt"]["Grpalt_flag"] == 1)){
			/*if($checkbox_flag == 0) {*/
				/*** * ***/
/*				$flag_father = $this->Group->getFatherSet($group_id,$this->Grpalt,2);
				if($flag_father ==0){
					$Message['father_group_alert_inherit'][] = 'father_group_set_no';
					$errorMessage = $Message;
					$this->set('errorMessage',$errorMessage);
					$this->data['Grpalt']['mail_notice'] = 3;
					$this->data['Grpalt']['popup'] = 1;
					$this->set('mail_notice_time_c','00');
					$this->set('up_cast_flag',0);
				}
			}elseif($checkbox_flag == 1){*/
				$getUserGroup = $this->_getUserGroup_id();
				//sunhy start 2009/05/14 modify for YBR-32
				//if($getUserGroup == 1){
				//sunhy end 2009/05/14 modify for YBR-32
					@$Grpaltcontent = $this->data["Altmsg"]["message"];
					@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');
					
					if(!count($result_content) == 0){
						//debug($this->data);
						$errorMessage =$result_content;
						$this->set('errorMessage',$errorMessage);
						isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c='';
						//$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
						$this->set('mail_notice_time_c',$mail_notice_time_c);
					}
					//sunhy start 2009/05/14 modify for YBR-32
				//}
				//sunhy end 2009/05/14 modify for YBR-32
				if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
					($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
				}else{
					$res_hour=1;
				}
				if($res_hour == 0){
	  				$error =__('E-00100',$return = true);
	  				$time=__('time',$return=true);
					$errorMessage[$time][] = $error;
					$this->set('errorMessage', $errorMessage);						
				}
//			}
			if(empty($errorMessage)){

				/*$this->add_grpalt($group_id,$checkbox_flag,1);*/
				$this->add_grpalt($group_id,1,1);
				$this->index();
				$this->render('index');
				exit();
			}
		}

		/*　ページの保存　*/
		if((isset($this->data["Grpalt"]["Grpalt_flag"])&&($this->data["Grpalt"]["Grpalt_flag"] == 1))){
			if(!empty($errorMessage)){
/*				if($checkbox_flag == 0){
					if($this->grpalt_list_id($group_id)!=0){
						$grpalt_r = $this->grpalt_list($group_id);
						$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
						$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
						$this->data['Grpalt']['receive'] = ($grpalt_r[0]['Grpalt']['receive']==0)?1:0;
						$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
					}else{
						$mail_notice_time_c='00';
					}
					$title =$this->title_list();
					$this->data['Title']['title_flg'] = ($title!=1)?1:0;

					$altmsg_list =$this->altmsg_list();
					$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
					$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
					$this->set('up_cast_flag',0);
				}else{
					$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];

				}*/
				isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
			}
		}
		//$this->render('add');
	}
  
	function grpalt_list($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=2 ";
		$grpalt = $this->Grpalt->findAll($condition);
		return $grpalt;

	}
	
	/* グループ共通設定テーブルのデータ */
	function add_grpalt($group_id,$checkbox_flag,$add_flag){
		//echo "add_grpalt<br>";
		$getUserGroup = $this->_getUserGroup_id();
		$grpalt=$this->Grpalt->grpalt_list_flag($group_id,2);
		if($grpalt == 1){
			//$this->edit_grpalt($group_id,$checkbox_flag);
			$this->edit_grpalt($group_id,1);
		}else{

			if($checkbox_flag == 1) {
				//echo "add_grpalt :up_cast=1<br>";
				if(isset($this->data["Grpalt"]["mail_notice"]))
				{
					$mail_notice = $this->data["Grpalt"]["mail_notice"];
					if($mail_notice == 2){
						$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
					}else{
						$mail_notice_time = '00:00:00';
					}
					$receive = ($this->data["Grpalt"]["receive"] == 1)?0:1;

					if(!empty($mail_notice)){
						$grpalt=$this->grpalt_list($group_id);
						$popup = ($this->data["Grpalt"]["popup"] == 1)?1:0;
						//sunhy end 2009/03/28 modify for JLN-001
						/*$insertgrpalt=Array(
						'Grpalt' => Array(
						'group_id' => $group_id,
						'mail_notice' => $mail_notice,
						'mail_notice_time' => $mail_notice_time,
						'receive' =>$receive,
						'popup' =>$popup,
						//'up_cast' => 1,
						'type' => 2,
						));
						$this->Grpalt->save($insertgrpalt);*/
						$this->MailPopupController->setMailPop(null, $group_id, $mail_notice, $mail_notice_time, $popup, null, $receive, 2, 'Grpalt');
						//sunhy end 2009/03/28 modify for JLN-001
						$this->set('mail_notice_time_c',substr($mail_notice_time,0,2));
						if($add_flag == 1){
								//sunhy start 2009/05/14 modify for YBR-32
								//if($getUserGroup == 1){
								if(!empty($getUserGroup)){
									//$re_title =$this->title_flag();
									$re_title =$this->title_flag($group_id);
									if($re_title == 0){
										//$this->addTitle();
										$this->addTitle($group_id);
									}else{ 
										//$this->editTitle($re_title);
										$this->editTitle($re_title, $group_id);
									}
									//$re_msg =$this->altmsg_flag();
									$re_msg =$this->altmsg_flag($group_id);
									if($re_msg == 0){
										//echo "addAltmsg<br>";
										//$this->addAltmsg();
										$this->addAltmsg($group_id);
									}else{//echo "editAltmsg<br>";
										//$this->editAltmsg($re_msg);
										$this->editAltmsg($re_msg, $group_id);
									}
								}
								//sunhy end 2009/05/14 modify for YBR-32
						}
					}
				}
			}elseif($checkbox_flag == 0) {
				//echo "add_grpalt :up_cast=0<br>";
				//sunhy end 2009/03/28 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' => 3,
				'popup' =>1,
				'receive' =>1,
				'mail_notice_time' => '00:00:00',
				'type' => 2,
				//'up_cast' => 0,
				));
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop(null, $group_id, 3, '00:00:00', 1, null, 1, 2, 'Grpalt');
				//sunhy end 2009/03/28 modify for JLN-001
				$this->set('mail_notice_time_c','00');
				$this->set('up_cast_flag',0);
				$this->data["Grpalt"]["mail_notice"] = 3;
			 	$this->data["Grpalt"]["popup"] = 1;
				$title =$this->title_list();
				$this->data['Title']['title_flg'] = ($title!=1)?1:0;

				//sunhy start 2009/05/14 modify for YBR-32
				//$altmsg_list =$this->altmsg_list();
				//$altmsg_list_detail =$this->altmsg_list_detail();
				$altmsg_list =$this->altmsg_list($group_id);
				$altmsg_list_detail =$this->altmsg_list_detail($group_id);
				//sunhy end 2009/05/14 modify for YBR-32
				//sunhy start 2009/03/28 added for JLN-001
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
				$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
				//sunhy end 2009/03/28 added for JLN-001
				$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			}
			//$this->GenerateFiles->hook_by_group($group_id, array('prints'));
  			//sunhy start 2009/03/28 added for JLN-001
			//$this->GenerateFiles->hook_by_ps(0, array("prints", "popup"));
			$this->GenerateFiles->hook_by_group($group_id, array("prints", "popup"));
			//sunhy end 2009/03/28 added for JLN-001
			//$this->GenerateFiles->hook_by_group(1, array('popup'));
		}
	}

	/*  編集グループ共通 */
	function edit_grpalt($group_id,$checkbox_flag){
		//echo "edit_grpalt<br>";

		$grpalt_id = $this->grpalt_list_id($group_id);
		if($checkbox_flag == 1) {
			//echo "edit_grpalt :up_cast=1<br>";
			if($this->data["Grpalt"]["mail_notice"] == 2){
				$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
			}else{
				$mail_notice_time = '00:00:00';
			}
			$receive = ($this->data["Grpalt"]["receive"] == 1)?0:1;
			$popup = ($this->data["Grpalt"]["popup"] == 1)?1:0;
			if(isset($this->data["Grpalt"]["mail_notice"])){
				//sunhy end 2009/03/28 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'id' => $grpalt_id,
				'group_id' => $group_id,
				'mail_notice' => $this->data["Grpalt"]["mail_notice"],
				'mail_notice_time' => @$mail_notice_time,
				'popup' =>$popup,
				'receive' =>$receive,
				'type'=>2,
				'up_cast' => 1,
				));
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, $popup, 1, $receive, 2, 'Grpalt');
				//sunhy end 2009/03/28 modify for JLN-001

				$getUserGroup = $this->_getUserGroup_id();
				//sunhy start 2009/05/14 modify for YBR-32
				//if($getUserGroup == 1){
				if(!empty($getUserGroup)){
					//$re_title =$this->title_flag();
					$re_title =$this->title_flag($group_id);
					if($re_title !=0){
						//$this->editTitle($re_title);
						$this->editTitle($re_title, $group_id);
					}else{
						//$this->addTitle();
						$this->addTitle($group_id);
					}
					//$re_msg =$this->altmsg_flag();
					$re_msg =$this->altmsg_flag($group_id);
					if($re_msg !=0){
					//debug($re_msg);
						//$this->editAltmsg($re_msg);
						$this->editAltmsg($re_msg, $group_id);
					}else{
						//$this->addAltmsg();
						$this->addAltmsg($group_id);
					}
				}
				$this->set('mail_notice_time_c',substr($mail_notice_time,0,2));
			}
		}elseif($checkbox_flag == 0) {
			//echo "edit_grpalt :up_cast=0<br>";
			//sunhy end 2009/03/28 modify for JLN-001
			/*$insertgrpalt=Array(
			'Grpalt' => Array(
			'id' => $grpalt_id,
			'group_id' => $group_id,
			'type' => 2,
			'up_cast' => 0,
			));
			$this->Grpalt->save($insertgrpalt);*/
			$this->MailPopupController->setMailPop($grpalt_id, $group_id, null, null, null, 0, null, 2, 'Grpalt');
			//sunhy end 2009/03/28 modify for JLN-001
			$this->set('mail_notice_time_c','00');
			$this->data["Grpalt"]["mail_notice"] = 3;
			$this->data["Grpalt"]["popup"] = 1;
			$this->set('up_cast_flag',0);
			$title =$this->title_list();
			$this->data['Title']['title_flg'] = ($title!=1)?1:0;

			//sunhy start 2009/05/14 modify for YBR-32
			//$altmsg_list =$this->altmsg_list();
			//$altmsg_list_detail =$this->altmsg_list_detail();
			$altmsg_list =$this->altmsg_list($group_id);
			$altmsg_list_detail =$this->altmsg_list_detail($group_id);
			//sunhy end 2009/05/14 modify for YBR-32
			//sunhy start 2009/03/28 added for JLN-001
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
			$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
			//sunhy end 2009/03/28 added for JLN-001
			$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
		}
  			//sunhy start 2009/05/14 modify for YBR-32
			//$this->GenerateFiles->hook_by_ps(0, array("prints", "popup"));
			$this->GenerateFiles->hook_by_group($group_id, array("prints", "popup"));
			//sunhy end 2009/05/14 modify for YBR-32

	}


	/*
	*件名管理情報追加
	*/

	//sunhy start 2009/05/14 modify for YBR-32
	//function addTitle(){
	function addTitle($group_id){
	//sunhy end 2009/05/14 modify for YBR-32
		//echo "addtitleaddadadadadaddddadadadadadadaad<br>";
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'title_flg' => $title_flg,
		'type' =>2,
		//sunhy start 2009/05/14 modify for YBR-32
		'group_id' =>$group_id,
		//sunhy end 2009/05/14 modify for YBR-32
		));
		$this->Title->save($inserttitle);
	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/14 modify for YBR-32
	//function editTitle($id){
	function editTitle($id,$group_id){
	//sunhy end 2009/05/14 modify for YBR-32
		//echo "editediteditediteditediteditediteditediteditedit<br>";
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'id'=>$id,
		'title_flg' => $title_flg,
		'type' => 2,
		//sunhy start 2009/05/14 modify for YBR-32
		'group_id' => $group_id,
		//sunhy end 2009/05/14 modify for YBR-32
		));
		$this->Title->save($inserttitle);
	}
	/*
	*エラー情報変更
	*/
	//sunhy start 2009/05/14 modify for YBR-32
	//function addAltmsg(){
	function addAltmsg($group_id){
	//sunhy end 2009/05/14 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/28 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'message_id' => 'E0002',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/14 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0002', $message, $detail_flg, null);
		$this->MailPopupController->setAltMsg('E0002', $message, $detail_flg, null, $group_id);
		//sunhy start 2009/05/14 modify for YBR-32
		//sunhy end 2009/03/28 modify for JLN-001
	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/14 modify for YBR-32
	//function editAltmsg($id){
	function editAltmsg($id, $group_id){
	//sunhy end 2009/05/14 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/28 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'id'=>$id,
		'message_id' => 'E0002',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/14 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0002', $message, $detail_flg, $id);
		$this->MailPopupController->setAltMsg('E0002', $message, $detail_flg, $id, $group_id);
		//sunhy start 2009/05/14 modify for YBR-32
		//sunhy end 2009/03/28 modify for JLN-001
	}

	function _getemail($group_id){
		//$group_id= $this->_getUserGroup();
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		//debug($data_email);
		return $data_email;

	}
	
	//sunhy start 2009/05/14 modify for YBR-32
	//function title_list(){
	function title_list($group_id){
	
		//$condition =" Title.type=2 and Title.id !=0";
		$condition =" Title.type=2 and Title.id !=0 and group_id=".$group_id;
	//sunhy end 2009/05/14 modify for YBR-32
		$title = $this->Title->findAll($condition);
		//debug($grpalt);
		if(count($title) == 1){
			$flag = $title[0]['Title']['title_flg'];
		}else{
			$flag =2;
		}
		return $flag;
	}
	//sunhy start 2009/05/14 modify for YBR-32
	//function altmsg_list_detail(){
	function altmsg_list_detail($group_id){
		//$condition =" Altmsg.message_id='E0002' ";
		$condition =" Altmsg.message_id='E0002' and group_id=".$group_id;
	//sunhy end 2009/05/14 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$array = $altmsg["0"]["Altmsg"]["detail_flg"];
		}else{
			$array = 2;
		}
		return $array;
	}
	//sunhy start 2009/05/14 modify for YBR-32
	//function altmsg_list(){
	function altmsg_list($group_id){
		
		//$condition =" Altmsg.message_id='E0002' ";
		$condition =" Altmsg.message_id='E0002' and group_id=".$group_id;
	//sunhy end 2009/05/14 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$array = $altmsg;
		}else{
			$array = 2;
		}
		return $array;
	}
	/* グループ共通の判定 */
	function error_judge_grpalt($content = null,$name2){
		$re1 =$this->Lv->is_empty($content);
		if($re1){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!$re1){
			if(!$this->Validation->maxLength($content,2000)){
				$errorMessage[$name2][] = 'E-00300';
			}
		}

		return $errorMessage;
	}
	
	/* 件名管理情報 */
	//sunhy start 2009/05/14 modify for YBR-32
	//function title_flag(){
	function title_flag($group_id){
		
		//$condition =" Title.type=2 ";
		$condition =" Title.type=2 and group_id=".$group_id;
	//sunhy end 2009/05/14 modify for YBR-32
		$title = $this->Title->findAll($condition);
		//debug($grpalt);
		if(count($title) == 1){
			$flag = $title[0]['Title']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	//sunhy start 2009/05/14 modify for YBR-32
	//function altmsg_flag(){
	function altmsg_flag($group_id){
		
		//$condition =" Altmsg.message_id='E0002' ";
		$condition =" Altmsg.message_id='E0002' and group_id=".$group_id;
	//sunhy end 2009/05/14 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$flag = $altmsg[0]['Altmsg']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	
	function grpalt_list_id($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=2 ";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalt"]["id"];
		}else{
			$id =0;
		}
		return $id;

	}
	
	function _findOneSun($group_id){
		$criteria=" Group.parent_id=".$group_id." ";
		$parent= $this->Group->findAll($criteria);
		//debug($parent);
		if(count($parent) != 0){
			foreach ($parent as $value){
				$id =$value['Group']['id'];
				//debug($id);
				$grpalt =$this->grpalt_list($id);
				if(count($grpalt) == 1){
					$grpalt_up_cast = $grpalt[0]['Grpalt']['up_cast'];
					$array[$id] =$grpalt_up_cast;
					return $array;
					exit();
				}else{
					return 2;
				}

			}
		}else{
			return 2;
		}

	}

	
	
	/*  プリンタ別設定　ページ 3
	
	*/
	function print_list_set($selecttag =null){
		$this->layout='ajax';
		$printer_name_list = $this->getPrintsName();
		$this->set('printer_name_list',$printer_name_list);
		
		//debug($this->data['Printer']['printer_name_selecttag']);
		if($selecttag == 1){
			$conditon ="Printer.id =".$this->data['Printer']['printer_name_selecttag'];
			$this->set('printer_flag',1);
		}else{
			$conditon ="1=1";
		}
		$list = $this->Printer->findAll($conditon, 'Printer.id, Printer.printer_name,Printer.m_print_num', 'Printer.id, Printer.printer_name,Printer.m_print_num', null, null, 1);
		//debug($list);
		$this->previous_count($list);
		$this->present_count($list);
		$this->set('list',$list);
	}
	
	/*プリンタ名,プリンタIDの取得 ページ 3
	*/
	function getPrintsName()
	{
    	$prints = $this->Printer->findAll("1=1", 'Printer.id, Printer.printer_name', 'Printer.id, Printer.printer_name', null, null, 1);
    	if(!empty($prints)){
    		$keys = Set::extract($prints, '{n}.Printer.id');
			$vals = Set::extract($prints, '{n}.Printer.printer_name');
			$prints = array_combine($keys, $vals);
			return $prints;
    	}
    	else {
    		return array();
    	}
	}
	
	/* プリンタ別設定削除  ページ 3
	*/
	function deletePrint(){
		//debug($id);
		//echo "if=".$id;
		$this->layout='ajax';
		if(!isset($this->data['Printer']['del_print'])){  //未選択





			$error =__('E-00200',$return = true);
			$errorMessage['list'][] = $error;
			$this->set('errorMessage', $errorMessage);
		}else{
			//debug($this->data['Printer']['del_print']);
			$del  = $this->data['Printer']['del_print'];
			foreach ($del as $key =>$v){
				//debug($v);
				$this->Printer->del($v);
			}
		}
		if(isset($this->data['Printer']['printer_flag'])&&($this->data['Printer']['printer_flag'] == 1)){
			$this->print_list_set(1);
		}else{
			$this->print_list_set();
		}
		$this->render('print_list_set');
		exit();	
	}
	
	/* 前月の累計枚数 ページ　3
	*/
	function previous_count($list){
		$arr =array();
		foreach ($list as $key_n=>$v){
			$conditon = "Prtsub.print_id =".$v["Printer"]["id"];
			$result = $this->Prtsub->findAll($conditon);
			//debug($result);
			if(count($result) != 0){
				$con2=0;
				foreach ($result as $key){
						$criteria=array();
						$month1 = date('m',mktime(0, 0, 0, date("m")-1, date("d"),   date("Y")));
						$year1 = date("Y");
						$time1 = $year1."-".$month1."-"."01"." "."00:00:00";
						$time2 = $year1."-".$month1."-"."31"." "."23:59:59";
						
						
						//debug($time1);debug($time2);
					 	//$time1 = 
						$criteria[] = "Optprt.host_id =".$key['Prtsub']['host_id']." and Optprt.driver ='".$key['Prtsub']['driver']."' and Optprt.printer ='".$key['Prtsub']['device_name']."' ";
						//$criteria['GROUP BY']="Optprt.driver,Optprt.printer,Host.host_name,Host.id";
						$criteria[] ="Optprt.print_time >='".$time1."' and Optprt.print_time <='".$time2."' ";
						//$criteria[] ="Optprt.print_time >'2007-01-01 00:00:00' and Optprt.print_time <'2007-08-04 00:00:00'";
						$asso = array(
								'Host : hosts' => array('Optprt.host_id = Host.id'), 
								 );
						//debug($criteria);
					
						$data=$this->Optprt->findByAsso($criteria,array('Optprt.papers','Optprt.printer','Host.host_name','Host.id','Optprt.print_time'),$order=null, $limit=null, $page=null, $asso);
						//debug($data);
						$con =0;
						if(!empty($data)){
							foreach ($data as $key=>$v){
								$con+=$v["Optprt"]["papers"];
							}
						}
						//echo "con=".$con."<br>";
						
					$con2+=$con;
				}
				//echo "con=".$con2."<br>";
				$arr[$key_n] =$con2;
				
			}else{
				$arr[$key_n] =0;
			}
			
			
		}
		
		$this->set('arr',$arr);
		
	}
	
	/* 月次累計枚数 ページ　3
	*/
	function present_count($list){
		$arr_present =array();
		foreach ($list as $key_n=>$v){
			$conditon = "Prtsub.print_id =".$v["Printer"]["id"];
			$result = $this->Prtsub->findAll($conditon);
			if(count($result) != 0){
				$con2=0;
				foreach ($result as $key){
						$criteria=array();
						$month1 = date('m',mktime(0, 0, 0, date("m"), date("d"),date("Y")));
						$year1 = date("Y");
						$day1 = date('d',mktime(0, 0, 0, date("m"), date("d"),date("Y")));
						$time1 = $year1."-".$month1."-"."01"." "."00:00:00";
						$time2 = $year1."-".$month1."-".$day1." "."23:59:59";
						
						$criteria[] = "Optprt.host_id =".$key['Prtsub']['host_id']." and Optprt.driver ='".$key['Prtsub']['driver']."' and Optprt.printer ='".$key['Prtsub']['device_name']."' ";
						//$criteria['GROUP BY']="Optprt.driver,Optprt.printer,Host.host_name,Host.id";
						$criteria[] ="Optprt.print_time >='".$time1."' and Optprt.print_time <='".$time2."' ";
						$asso = array(
								'Host : hosts' => array('Optprt.host_id = Host.id'), 
								 );
						$data=$this->Optprt->findByAsso($criteria,array('Optprt.papers','Optprt.printer','Host.host_name','Host.id','Optprt.print_time'),$order=null, $limit=null, $page=null, $asso);
						//debug($data);
						$con =0;
						if(!empty($data)){
							foreach ($data as $key=>$v){
								$con+=$v["Optprt"]["papers"];
							}
						}
						//echo "con=".$con."<br>";
						
					$con2+=$con;
				}
				//echo "con=".$con2."<br>";
				$arr_present[$key_n] =$con2;
				
			}else{
				$arr_present[$key_n] =0;
			}
			
			
		}
		$count_present=0;
		foreach ($arr_present as $v){
			if($v == 0){
				$count_present=0;
			}else{
				$count_present++;
			}
		}
		//echo "count_present=".$count_present."<br>";
		$this->set('arr_present',$arr_present);
		$this->set('count_present',$count_present);
		
	}
	
	/* プリンタ設定（リスト)のコントロール　ページ 3
	*/	
	function print_driver_add(){
		$errorMessage = $this->_check_printer("printer_name","print_name");
		//debug($errorMessage);
		if(empty($errorMessage)){
        	$this->layout='ajax';
        	$this->print_driver(null,1);
        }else{
        	$this->layout='ajax';
        	$this->set('errorMessage', $errorMessage);
        	$this->print_list_set();
        	$this->render('print_list_set');
        	exit();	
        }
        		
	}

	/* 新規プリンタ追加のチェック ページ 3
	*/	
	function _check_printer($name,$message){
		$re1 =$this->Lv->is_empty($this->data["Printer"][$name]);
		if($re1){
			$errormessage[$message][] = __('E-00100',$return = true);
		}
/*        if(!$this->Check->checkAllHalf($this->data['Printer'][$name]))
        {
             $errormessage[$message][]= __('E-00400',$return = true);
        }*/
         if(!$this->Validation->maxLength($this->data['Printer'][$name],200))
        {
             $errormessage[$message][] = __('E-00300',$return = true);
        }
        if(!empty($errormessage)){
        	 return $errormessage;
        }else{
        	return null;
        }
       
	}
	
	/* 新規プリンタ追加(設定枚数)のチェック
	*/
	function _check_printer_paper($name,$message){
/*		if($this->data["Printer"][$name] =''){
			$this->data["Printer"][$name] =0;
		}*/
		$re1 =$this->Lv->is_empty($this->data["Printer"][$name]);
		if(!$re1){
				$result = $this->Validation->numeric($this->data['Printer'][$name]);
				if(!$result){
					$errorMessage[$message][] =__('E-00600',$return = true);
				}
		         if(!$this->Validation->maxLength($this->data['Printer'][$name],4))
		        {
		             $errormessage[$message][] = __('E-00300',$return = true);
		        }
		}
        if(!empty($errorMessage)){
        	 return $errorMessage;
        }else{
        	return null;
        }
       
	}		
	/* プリンタ設定（リスト)の追加(参照するプリンタドライバ) ページ　4
	*/
	function print_driver($id_no = null,$link=null){
		$this->layout='ajax';
		//debug($this->data["Printer"]["printer_name"]);		
		if(!isset($this->data["Printer"]["flag"])){
			//echo "jinjing";
				if($link ==1){//echo "111<br>";
						$printername = $this->Lv->spec_char_dbm($this->data["Printer"]["printer_name"]);
						$con = "Printer.printer_name ='".$printername."' ";
						$printer = $this->Printer->findAll($con);
						//var_dump($printer);
						if(count($printer) == 1){//echo "222";
							$id = $printer[0]["Printer"]["id"];
							$this->data['Printer']['printer_name'] = $printer[0]["Printer"]["printer_name"];
							$this->data["Printer"]["m_print_num"] = $printer[0]["Printer"]["m_print_num"];
							$flag = 1;
						}else{		
							$flag = 0;
							$id = 0;
							$this->data['Printer']['m_print_num'] =0;
						}
				}
				if($link==3){
					$con_link = "Printer.id =".$id_no;
					$printer_link = $this->Printer->findAll($con_link);
					//debug($printer_link);
					if(count($printer_link)==1){
						$this->data['Printer']['printer_name'] = $printer_link[0]["Printer"]["printer_name"];
						$this->data["Printer"]["m_print_num"] = $printer_link[0]["Printer"]["m_print_num"];							
					}
					$id =$id_no;
				}
		//$this->set('flag',$flag);
		$this->set('id',$id);
		}
		//debug($this->data["Printer"]["flag_id"]);
		if(isset($this->data["Printer"]["flag"])&&($this->data["Printer"]["flag"] == 1)){
			$errorMsg1 = $this->_check_printer("printer_name","print_name");
			$errorMsg2 = $this->_check_printer_paper("m_print_num","paper_set");
			if(trim($this->data["Printer"]["m_print_num"]) == ''){
				$this->data["Printer"]["m_print_num"] = 0;
			}
			if(empty($errorMsg1)&&empty($errorMsg2)){
				if($this->data["Printer"]["flag_id"] != 0){//echo "edit";
					$printername = $this->Lv->spec_char_dbm($this->data["Printer"]["printer_name"]);
					$con = "Printer.printer_name ='".$printername."' and Printer.id !=".$this->data["Printer"]["flag_id"];
					$re = $this->Printer->findAll($con);
					if(count($re) ==1){
							$errorMessage['print_name'][] =__('E-01900',$return = true);
							$this->set('errorMessage',$errorMessage);
							$id =$this->data["Printer"]["flag_id"];
							$this->set('id', $id);					
					}else{
							$insertprint=Array(
								'Printer' => Array(
								'id' => $this->data["Printer"]["flag_id"],
								'printer_name' => $printername,
								'm_print_num' => $this->data["Printer"]["m_print_num"],
								));
							$this->Printer->save($insertprint);
							//$this->set('id',0);
							$id =$this->data["Printer"]["flag_id"];
							$this->set('id', $id);
							//echo __('set_complete',$return = true);
					}				
				}else{ //echo "add";		
					$printername = $this->Lv->spec_char_dbm($this->data["Printer"]["printer_name"]);
					$con = "Printer.printer_name ='".$printername."'";
					$re = $this->Printer->findAll($con);
					if(count($re) ==1){
							$errorMessage['print_name'][] =__('E-01900',$return = true);
							$this->set('errorMessage',$errorMessage);
							$this->set('id', 0);
					}else{
							$insertprint=Array(
								'Printer' => Array(
									'printer_name' => $printername,
									'm_print_num' => $this->data["Printer"]["m_print_num"],
								));
							$this->Printer->save($insertprint);
							$alertId = $this->Printer->getLastInsertID();
							$id =$alertId;
							$this->set('id',$id);
							//echo __('set_complete',$return = true);	
					}							
				}
			}else{//echo "nono";
/*				debug($errorMsg1);
				debug($errorMsg2);*/
				$this->set('errorMessage1', @$errorMsg1);
				$this->set('errorMessage2', @$errorMsg2);
				if(isset($this->data["Printer"]["flag_id"])){
					$id =$this->data["Printer"]["flag_id"];
					$this->set('id', $id);
				}else{
					$this->set('id',0);
				}
			}
			//$this->set('set_complete',0);	
		}
		$this->set('printer_name',@$this->data["Printer"]["printer_name"]);
		$this->set('m_print_num',$this->data["Printer"]["m_print_num"]);
		
		if(isset($this->data["Printer"]["flag3"])&&($this->data["Printer"]["flag3"] == 1)){
				$errorMsg3 = $this->_check_printer("driver","print_driver_name");
				$printerdrvname = $this->Lv->spec_char_dbm($this->data["Printer"]["driver"]);
				$criteria ="Optprt.driver ='".trim($printerdrvname)."' ";
				$result = $this->Optprt->findAll($criteria);
				if(count($result) == 0){
					$error =__('print_no',$return = true);
					$errorMessage['print_driver_name'][] = $error;
					
				}
				if(empty($errorMsg3)&&(empty($errorMessage))){
					$this->print_driver_log(1,null);
					$this->render('print_driver_log');
					exit();
				}else{
					if(!empty($errorMsg3)){
						$this->set('errorMessage3', $errorMsg3);
					}elseif(!empty($errorMessage)){
						$this->set('errorMessage', $errorMessage);
					}
					
				}
				//debug($this->data["Printer"]["flag_id2"]);
				$id =$this->data["Printer"]["flag_id3"];
				$this->set('id', $id);		
		}
		
		/*参照するプリンタドライバの表示
		*/
		if(@$id != 0){
			$this->prtsuc_show($id,2);
		}else {
			$this->set('prtsub_list',null);	
		}
		//echo "id=".$id."<br>";
		if(isset($id)&&($id != 0)){
			$this->set('page_print_driver',1);	
		}elseif($id == 0){
			$this->set('page_print_driver',0);	
		}
	$this->render('print_driver');
	}
	
	/*
	*参照するプリンタドライバ  ページ 4
	*/ 
	function deletePrint_driver($id = null){
		//debug($id);
		//echo "print_id=".$id;
		$this->layout='ajax';
		if(!isset($this->data['Prtsub']['del_print'])){
			$error =__('E-00200',$return = true);
			$errorMessage['list'][] = $error;
			$this->set('errorMessage', $errorMessage);
			$this->print_driver($id,3);
		}else{
			//debug($this->data['Prtsub']['del_print']);
			$del  = $this->data['Prtsub']['del_print'];
			foreach ($del as $key =>$v){
				$this->Prtsub->del($v);
				
			}
			$this->print_driver($id,3);
		}
		
	}
	/*  未登録プリンタリスト ページ5
	
	*/
	function print_driver_log($link=null,$id_print=null){
		if($link == null){
			$link =$this->data['Prtsub']['link'];
		}
		//debug($this->data);

//echo "link=".$link."<br>";
		$this->layout='ajax';
		if($link ==1){     /* 追加 */
			$this->data['Printer']['printer_name'] = $this->data['Printer']['printer_name'];
			$this->data['Printer']['m_print_num'] = $this->data['Printer']['m_print_num'];
		}

		if($link ==2){  /* リンく */
			if(!isset($this->data['Prtsub']['flag'])){
				$con = "Printer.id =".$id_print;
				$con_redult = $this->Printer->findAll($con);
				$this->data["Printer"]["printer_name"] = $con_redult[0]['Printer']['printer_name'];
			}elseif(isset($this->data['Prtsub']['flag'])){
				$this->data["Printer"]["printer_name"] =$this->data["Printer"]["printer_name"];
			}		
		}
	$printername = $this->Lv->spec_char_dbm($this->data["Printer"]["printer_name"]);
		$con = "Printer.printer_name ='".$printername."' ";
		$printer = $this->Printer->findAll($con);
		$this->data["Printer"]["m_print_num"] = $printer[0]['Printer']['m_print_num'];
		$id=  $printer[0]["Printer"]["id"];
		//echo "id=".$id;
		$this->set('id',$id);
		//echo "id=".$id."<br>";
/*		/*参照するプリンタドライバの表示
		*/

		$this->prtsuc_show($id,$link);

		/*参照するプリンタドライバの追加
		*/	

		/*未登録プリンタリストの表示
		*/
		if(isset($this->data['Prtsub']['select'])&&($this->data['Prtsub']['select'] == 4)){
			$this->unprtsuc_show($link,3,$id);
			$this->set('select',4);
		}else{
			$this->unprtsuc_show($link,null,$id);
			$this->set('select',0);
		}
		$this->set('link',$link);
	}
	
	
/*参照するプリンタドライバの追加
*/	
	function prtsuc_add($id,$link){	
		//debug($this->data);	
			if(isset($this->data["Prtsub"]["flag"])){
				//echo "jingjing";
				//debug($this->data);
				if(isset($this->data["Optprt"]["del"])){
					//echo "right";
					$del = $this->data["Optprt"]["del"];
					//debug($del);
					foreach ($del as $key => $v){
						$add_list = $this->data["Grpaltvir"]["add_id"][$v];

						//debug($add_list);
								$insertprtsubs=Array(
									'Prtsub' => Array(
									'print_id' => $id,
									'driver' => $add_list[0],
									'device_name' => $add_list[1],
									'host_id' => $add_list[2],
									));
								//debug($insertprtsubs);
								$this->Prtsub->save($insertprtsubs);
								$this->prtsuc_show($id,$link);
					}
				}else{
					$errorMessage['print_driver_name'][] = 'E-00200';
					$this->set('errorMessage', $errorMessage);
				}
				
			}
			$this->print_driver_log($link);
			$this->render('print_driver_log');
	}	
/*  プリンタドライバ設定削除 ページ5	
*/
function deletePrtsuc($id,$link){
		$this->layout='ajax';
		/*$con = "Printer.printer_name ='".$this->data["Printer"]["printer_name"]."' ";
		$printer = $this->Printer->findAll($con);
		$this->data["Printer"]["m_print_num"] = $printer[0]['Printer']['m_print_num'];
		$id=  $printer[0]["Printer"]["id"];
		$this->set('id',$id);*
/*		/*参照するプリンタドライバの表示
		*/

		//$this->prtsuc_show($id,$link);

		/*参照するプリンタドライバの追加
		*/					
		if(isset($this->data["Prtsub"]["flag"])){
			//debug($this->data);
			if(isset($this->data["Optprt"]["del"])){
				$del = $this->data["Optprt"]["del"];
				//debug($del);
				foreach ($del as $key => $v){
					$add_list = $this->data["Grpaltvir"]["add_id"][$v];
					$con = "Optprt.driver ='".$add_list[0]."' and Optprt.printer='".$add_list[1]."' and Host.id =".$add_list[2];
					$result = $this->Optprt->findAll($con);
					if(count($result) !=0){
						foreach ($result as $v){
							$id = $v['Optprt']['id'];
							//debug($id);
							$this->Optprt->del($id);
						}
					}
				}
			}else{
				$errorMessage['print_driver_name'][] = 'E-00200';
				$this->set('errorMessage', $errorMessage);	
			}
			$this->print_driver_log($link);		
		}
		

		/*未登録プリンタリストの表示
		*/
		
		if(isset($this->data['Prtsub']['select'])&&($this->data['Prtsub']['select'] == 4)){
			$this->unprtsuc_show($link,3,$id);
			$this->set('select',4);
		}else{
			$this->unprtsuc_show($link,null,$id);
			$this->set('select',0);
		}
		$this->set('link',$link);
		$this->render('print_driver_log');
}
	

/*参照するプリンタドライバの表示
*/
	function prtsuc_show($id,$link){
		if($link == 2){
			$con = "Prtsub.print_id =".$id." order by Prtsub.driver ";
		}elseif($link == 1){
			$con = "Prtsub.print_id =".$id." and Prtsub.driver ='".trim($this->data['Printer']['driver'])."' order by Prtsub.driver ";
		}
		$prtsub_list = $this->Prtsub->findAll($con);
		if(count($prtsub_list)>0){
			foreach ($prtsub_list as $k => $v){
				$con1 = "Host.id =".$v['Prtsub']['host_id'];
				$host_id = $this->Host->findAll($con1);
				//debug($host_id);
				$prtsub_list[$k]["Prtsub"]["host_name"] = $host_id[0]["Host"]["host_name"];
			}
		}
		//debug($prtsub_list);
		$this->set('prtsub_list',$prtsub_list);	
	}
		
/*未登録プリンタリストの表示
*/
	function unprtsuc_show($link =null,$select =null,$prtsub_id=null){
		if($link ==1){
			$criteria[] ="Optprt.driver ='".trim($this->data['Printer']['driver'])."' ";
		}elseif($link ==2){
			$criteria[] ="1=1";
		}
		/* 絞込み*/
		if($select == 3){
			$re_printer =$this->Lv->is_empty($this->data["Optprt"]["printer"]);
			if(!$re_printer){
				//wangs start 20080202
				//$criteria[] = "Optprt.printer like '%".trim($this->data["Optprt"]["printer"])."%' ";
				$criteria[] = "lower(Optprt.printer) like '%".strtolower(trim($this->data["Optprt"]["printer"]))."%' ";
				//wangs end 20080202
			}
			$re_host_name =$this->Lv->is_empty($this->data["Host"]["host_name"]);
			if(!$re_host_name){
				//wangs start 20080202
				//$criteria[] = "Host.host_name like '%".trim($this->data["Host"]["host_name"])."%' ";
				$criteria[] = "lower(Host.host_name) like '%".strtolower(trim($this->data["Host"]["host_name"]))."%' ";
				//wangs end 20080202
			}			
		}
		//$criteria[] = "Optprt.printer not in (select Prtsub.device_name from prtsubs as Prtsub where Prtsub.host_id = Optprt.host_id and Prtsub.driver = Optprt.driver)";
		$criteria[] = "Optprt.printer not in (select Prtsub.device_name from prtsubs as Prtsub where Prtsub.host_id = Optprt.host_id and Prtsub.driver = Optprt.driver and Prtsub.device_name = Optprt.printer and Prtsub.print_id =".$prtsub_id.")";
		//sunhy start 2009/04/14 added for JLN-001
		$criteria[] =  "Optprt.driver !=''";
		//sunhy end 2009/04/14 added for JLN-001
		$criteria['GROUP BY']="Optprt.driver,Optprt.printer,Host.host_name,Host.id";
		$asso = array(
				'Host : hosts' => array('Optprt.host_id = Host.id'), 
				 );

		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'list', 'url'=>"/system_grpset_alert_prints/print_driver_log/", 'modelClass'=>'Optprt','queryType' => array('function' => 'findByAsso','asso'=>$asso),'sortBy' => $this->Lv->sortBy('Optprt.driver'),'ajaxFormId'=>'form1'));

		//$data=$this->Optprt->findByAsso($criteria,array('Optprt.driver','Optprt.printer','Host.host_name','Host.id'),$order=null, $limit=null, $page=null, $asso);
		$data=$this->Optprt->findByAsso($criteria,array('Optprt.driver','Optprt.printer','Host.host_name','Host.id'),$order, $limit, $page, $asso);
		$data_null=$this->Optprt->findByAsso($criteria,array('Optprt.driver','Optprt.printer','Host.host_name','Host.id'),$order=null, $limit=null, $page=null, $asso);
		$count_data_1 =count($data_null);
		$this->set('count_data_1',$count_data_1);
		$this->set('data',$data);
	}
	
/*　未登録プリンタリストの絞込み
*/

	function print_driver_log_select($link=null,$prtsub_id=null){
		//echo "link =".$link;
		if($link == null){
			$link =$this->data['Prtsub']['link'];
		}
		if($prtsub_id == null){
			$prtsub_id = $this->data['Printer']['id_flag'];
		}
		$this->layout='ajax';
		$this->data["Optprt"]["printer"];
		$this->data["Host"]["host_name"];
		//debug($this->data["Optprt"]["printer"]);
		//debug($this->data["Host"]["host_name"]);
		$error1 = $this->_check_driver("Optprt","printer");
		$error2 = $this->_check_driver("Host","host_name");

/*		if(empty($this->data["Optprt"]["printer"])&&empty($this->data["Host"]["host_name"])){
				$errorMessage['search_print'][] = 'E-00100';
				$this->set('errorMessage', $errorMessage);	
				$this->set('select',0);
		}else{*/

			$this->set('select',4);
				if($link ==1){
					$criteria[] ="Optprt.driver ='".$this->data['Printer']['driver']."' ";
				}elseif($link ==2){
					$criteria[] ="1=1";
				}
				$re_printer =$this->Lv->is_empty($this->data["Optprt"]["printer"]);
				if(!$re_printer){
					//wangs start 20080202
					//$criteria[] = "Optprt.printer like '%".trim($this->data["Optprt"]["printer"])."%' ";
					$criteria[] = "lower(Optprt.printer) like '%".strtolower($this->Lv->spec_char_like(trim($this->data["Optprt"]["printer"])))."%' ";
					//wangs end 20080202
				}
				$re_host_name =$this->Lv->is_empty($this->data["Host"]["host_name"]);
				if(!$re_host_name){
					//wangs start 20080202
					//$criteria[] = "Host.host_name like '%".trim($this->data["Host"]["host_name"])."%' ";
					$criteria[] = "lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like(trim($this->data["Host"]["host_name"])))."%' ";
					//wangs start 20080202
				}			
				$criteria[] = "Optprt.printer not in (select Prtsub.device_name from prtsubs as Prtsub where Prtsub.host_id = Optprt.host_id and Prtsub.driver = Optprt.driver and Prtsub.device_name = Optprt.printer and Prtsub.print_id =".$prtsub_id.")";
				//sunhy start 2009/04/14 added for JLN-001
				$criteria[] =  "Optprt.driver !=''";
				//sunhy end 2009/04/14 added for JLN-001
				$criteria['GROUP BY']="Optprt.driver,Optprt.printer,Host.host_name,Host.id";
				$asso = array(
						'Host : hosts' => array('Optprt.host_id = Host.id'), 
						 );

				list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'list', 'url'=>"/system_grpset_alert_prints/print_driver_log_select/", 'modelClass'=>'Optprt','queryType' => array('function' => 'findByAsso','asso'=>$asso),'sortBy' => $this->Lv->sortBy('Optprt.driver'), 'ajaxFormId'=>'form1'));

				//$data=$this->Optprt->findByAsso($criteria,array('Optprt.driver','Optprt.printer','Host.host_name','Host.id'),$order=null, $limit=null, $page=null, $asso);
				$data=$this->Optprt->findByAsso($criteria,array('Optprt.driver','Optprt.printer','Host.host_name','Host.id'),$order, $limit, $page, $asso);
				$data_null=$this->Optprt->findByAsso($criteria,array('Optprt.driver','Optprt.printer','Host.host_name','Host.id'),$order=null, $limit=null, $page=null, $asso);
				$count_data_1 =count($data_null);
				$this->set('count_data_1',$count_data_1);
				$this->set('data',$data);
/*		}*/
		
/*		/*参照するプリンタドライバの表示
		*/
$printername = $this->Lv->spec_char_dbm($this->data["Printer"]["printer_name"]);		
		$con = "Printer.printer_name ='".$printername."' ";
		$printer = $this->Printer->findAll($con);
		$this->data["Printer"]["m_print_num"] = $printer[0]['Printer']['m_print_num'];
		$id=  $printer[0]["Printer"]["id"];
		//echo "id=".$id;
		$this->set('id',$id);
		$this->prtsuc_show($id,$link);
		
		//$this->print_driver_log($link);
		$this->set('link',$link);
		$this->render('print_driver_log');
	}

	
	function _check_driver($model,$name){
/*        if(!$this->Check->checkAllHalf($this->data[$model][$name]))
        {
             //$hostname_error['Host/host_name']=__('E-00400',$return = true);
             $errormessage[]= __('E-00400',$return = true);
        }*/
         if(!$this->Validation->maxLength($this->data[$model][$name],200))
        {
             //$hostname_error['Host/host_name']=__('E-00300',$return = true);
             $errormessage[] = __('E-00300',$return = true);
        }
        if(!empty($errormessage)){
        	 return $errormessage;
        }else{
        	return null;
        }
       
	}
	
	function driver_reset($id){
		$this->layout='ajax';
		$this ->print_driver($id,3);
	}
	

}	
?>