<?php
/*********************************************************************
*@filename 		system_grpset_alert_processes_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhuiyan         2009/03/04   modify for JLN-001
*            2.0        sunhuiyan         2009/05/22   modify for YBR-32
*            2.0        sunhuiyan         2009/07/15   modify for YBR-41
*            2.0        sunhy    	  2009/07/25 modify for JL-0035
********************************************************************/
class SystemGrpsetAlertProcessesController extends AppController {
	var $name = 'SystemGrpsetAlertProcesses';

	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	//sunhy start 2009/03/04 modify for JLN-001
	//var $components = array ('Pagination', 'Lv','GenerateFiles' );
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'MailPopupController','AlertPcController');
	//sunhy end 2009/03/04 modify for JLN-001
	
	var $uses=array('Configure','Grpalt','Grpauth','Group','Host','Rltgrpaltproc','Rlthstgrp','Host','Grpaltproc','Hstaltproc','Uselgcproc','User','Mail','Validation','Poll','Procapp','Application','Title','Altmsg');

	var $layout='system';
	function beforeFilter()
	{
		parent::beforeFilter();
		//sunhy start 2009/05/08 delete for JLN-001
		//$this->Configure->write('debug',2);
		//sunhy end 2009/05/08 delete for JLN-001
	}

	/*

	*******************************   getUser group *****************************

	*/

	//	function _getUserGroup()
	//	{
	//		$groupid=1;
	//		return $groupid;
	//	}
	/*
	*******************************   index page  ************************************

	*/
	//xinw start 20090203
	//modify for ASP4-031
	//sunhy start 2009/03/04 modify for JLN-001
	//function reset(){
	function alert_list(){
	//sunhy end 2009/03/04 modify for JLN-001
		$this->layout='ajax';
		$this ->index();
		$this->render('index');
	}
	//xinw end 20090203

	function index(){
		$this->pageTitle = __('title',$return = true);   
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//ksort($glist);
		$glist_key=array_keys($glist);
		$this->set('glist_key',$glist_key);
		
		$glist_p=$this->Grpauth->getParentsByChild($this->_getUserGroup());
		ksort($glist_p);
		
		
		$glist_p_key=array_keys($glist_p);
		$this->set('glist_p_key',$glist_p_key);
		
		$key_glist=$glist+$glist_p;
		ksort($key_glist);
		$this->set('key_glist',$key_glist);

		//debug($glist);
		$this->set('glist',$glist);
		$asso = array(
		"Grpauth:grpauths" =>array("Grpaltproc.group_id=Grpauth.org_grp_id"),
		"Group : groups" => array("Group.id = Grpaltproc.group_id"),
		"Grpalt:grpalts"=>array("Grpalt.group_id=Group.id","Grpalt.type=8"),
		'Procapp : procapps:left' => array('Grpaltproc.process_name = Procapp.process_name'),
		'Application : applications:left' => array('Application.id = Procapp.application_id')
		);
		$a=$this->_getUserGroup();
		$this->set("usergroup",$a);
		$condition=array("Grpauth.group_id=$a","Grpalt.type=8");
		$result = $this->Grpaltproc->findByAsso($condition, array('Group.group_name','Grpaltproc.id','Group.id','Grpaltproc.process_name','Grpaltproc.application_name','Grpaltproc.process_status','Grpaltproc.specified_time','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso);

		$asso_host = array(

		"Host:hosts"=>array("Hstaltproc.host_id=Host.id"),
		"Rlthstgrp:rlthstgrps"=>array("Host.id=Rlthstgrp.host_id"),
		"Group:groups"=>array("Rlthstgrp.group_id=Group.id"),
		"Grpalt:grpalts"=>array("Grpalt.group_id=Group.id","Grpalt.type=8"),
		'Procapp : procapps:left' => array('Hstaltproc.process_name = Procapp.process_name'),
		'Application : applications:left' => array('Application.id = Procapp.application_id'),
		);

		$condition_host=array("Rlthstgrp.group_id in (select grpauths.org_grp_id from grpauths where grpauths.group_id=$a)");
		$result_host = $this->Hstaltproc->findByAsso($condition_host,array('Hstaltproc.process_name','Group.id','Group.group_name','Host.id','Host.host_name','Hstaltproc.application_name','Hstaltproc.process_status','Hstaltproc.id','Hstaltproc.specified_time','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso_host);

		$host=array();
		if(!empty($result_host)){
			$host=$this->trans_r($result_host);
		}
		$this->set('result_host',$host);
		$rs=array();
		if(!empty($result)){
			$rs=$this->trans_r($result);	
		}
		$this->set('result',$rs);

		$asso = array(
		"Grpauth:grpauths" =>array("Grpaltproc.group_id=Grpauth.group_id"),
		"Group : groups" => array("Group.id = Grpaltproc.group_id"),
		"Grpalt:grpalts:left"=>array("Grpalt.group_id=Group.id","Grpalt.type=8"),
		'Procapp : procapps:left' => array('Grpaltproc.process_name = Procapp.process_name'),
		'Application : applications:left' => array('Application.id = Procapp.application_id'),
		);
		$a=$this->_getUserGroup();
		$this->set("usergroup",$a);
		$condition=array("Grpauth.org_grp_id =$a","Grpauth.group_id != $a","Grpalt.type=8");
		$child = $this->Grpaltproc->findByAsso($condition, array('Group.group_name','Grpaltproc.id','Group.id','Grpaltproc.process_name','Grpaltproc.application_name','Grpaltproc.specified_time','Grpaltproc.process_status','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso);

		$asso_host = array(

		"Host:hosts"=>array("Hstaltproc.host_id=Host.id"),
		"Rlthstgrp:rlthstgrps"=>array("Host.id=Rlthstgrp.host_id"),
		"Group:groups"=>array("Rlthstgrp.group_id=Group.id"),
		"Grpalt:grpalts"=>array("Grpalt.group_id=Group.id","Grpalt.type=8"),
		'Procapp : procapps:left' => array('Hstaltproc.process_name = Procapp.process_name'),
		'Application : applications:left' => array('Application.id = Procapp.application_id'),
		);
		$condition_host=array("Rlthstgrp.group_id in (select grpauths.group_id from grpauths where grpauths.org_grp_id=$a and grpauths.org_grp_id != grpauths.group_id)");
		$child_host = $this->Hstaltproc->findByAsso($condition_host,array('Hstaltproc.process_name','Group.id','Group.group_name','Host.id','Host.host_name','Hstaltproc.application_name','Hstaltproc.process_status','Hstaltproc.id','Hstaltproc.specified_time','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso_host);
		$host=array();
		if(!empty($child_host)){	
			$host=$this->trans_r($child_host);		
		}
		$this->set('child_host',$host);
		$rs=array();
		if(!empty($child)){			
			$rs2=$this->trans_r($child);
			$rs=$this->trans_g($rs2);			
		}
		$this->set('child',$rs);
		$asso_alt=array(
		"Group:groups"=>array("Group.id=Grpalt.group_id"),
		
		);
		//sunhy start 2009/05/22 modify for YBR-32
		$childgroup= $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$groupIn="";
		foreach ($childgroup as $keys => $vaule){
			$groupIn .= $keys.",";
		}
		$groupIn .= "0";
		$result_alt=array();
		$alt=array();
		//$result_alt=$this->Grpalt->findAll(array('type=8'),array('Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast','Group.group_name','Group.id'));
		$result_alt=$this->Grpalt->findByAsso(array('type=8 and group_id in('.$groupIn.')'),array('Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast','Group.group_name','Group.id'), null, null, null, $asso_alt);
		//sunhy end 2009/05/22 modify for YBR-32
		if(!empty($result_alt)){	
			$alt=$this->trans_r($result_alt);		
		}
		$this->set('result_alt',$alt);
	}
	function trans_g($rs){
		foreach ($rs as $key=>$value){
			if($value[0]['Grpalt']['up_cast']==0){
				$g_id=$this->Group->getFatherSet($value[0]['Group']['id'],$this->Grpalt,8);
				$condition="Grpalt.group_id=$g_id and Grpalt.type=8";
				$rs_u=$this->Grpalt->findAll($condition,null,null,null,null,null);
				if(!empty($rs_u)){
					foreach ($rs_u as $rs_t){
						$rs[$key][0]['Grpalt']['mail_notice_time']=$rs_t['Grpalt']['mail_notice_time'];
						$rs[$key][0]['Grpalt']['popup'] =$rs_t['Grpalt']['popup'];
						$rs[$key][0]['Grpalt']['mail_notice'] =$rs_t['Grpalt']['mail_notice'];
						$rs[$key][0]['Grpalt']['receive'] =$rs_t['Grpalt']['receive'];
					}
				}
			}
		}
		return	$rs;
	}	
	function trans_r($result){ 
		$group_name=array();
		$rs=array();
		$group_name=set :: extract($result, '{n}.Group.group_name');

		$c=count($group_name);
		for($i=0;$i<$c;$i++){
			if(!isset($group_name[$i])) {
				$group_name[$i] = 0;
			}
			if (!isset($rs[$group_name[$i]])) {
				$rs[$group_name[$i]] = array();
			}
			$rs[$group_name[$i]][]=$result[$i];
		}
		return  $rs;
	}

	/*
	************************* index_del **************************************

	*/
	function index_del(){
		$this->layout='ajax';
		if(isset($this->data['Group']['groupid'])){
			$group_id=$this->data['Group']['groupid'];
			$g_new = array();
			$h_new = array();
			$errorMessage['error_upcast_alert']=array();

			foreach ($group_id as $rs_group_id){

				if(empty($errormessage['error_upcast_alert'])){
					$g_new[]=$rs_group_id;
					$this->Grpaltproc->deleteAll(array("group_id=$rs_group_id"));
					$this->Grpalt->deleteAll(array("group_id=$rs_group_id","type=8"));
					if(isset($this->data['Hstaltproc']['hostid'.$rs_group_id])){						
						$word_id = $this->data['Hstaltproc']['hostid'.$rs_group_id];
						foreach ($word_id as $check){
							$h_new[]=$check;
							$this->Hstaltproc->deleteAll(array("host_id=".$check));
						}
					}
				}
				//sunhy    start  2009/07/25 modify for JL-0035
    				$this->MailPopupController->delAltMsg("E0006", $rs_group_id);
    				$this->MailPopupController->delAltTit(8, $rs_group_id);
    				//sunhy    end  2009/07/25 modify for JL-0035
				//sunhy start 2009/05/22 added for YBR-32
				$this->GenerateFiles->hook_by_group($rs_group_id, array('process'));
				//sunhy end 2009/05/22 added for YBR-32
			}
			if(!empty($g_new)){
				//sunhy start 2009/05/22 delete for YBR-32
				//$this->GenerateFiles->hook_by_group($g_new, array('process'));
				//sunhy end 2009/05/22 delete for YBR-32
			}
		}
		else{
			$errorMessage['index_del']=array();
			if(!(in_array('E-00200',$errorMessage['index_del']))){
				$errorMessage['index_del'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		$this->index();
		$this->render('index');
		exit();
	}
	/*

	*************************   the second page's del**************************************

	*/

	function proc_set_del(){
		$group_id=$this->data['Group']['group_id'];
		$errorMessage['proc_set_del']=array();
		$hostid=array();
		if(isset($this->data['Group']['id'])){
			$word_id = $this->data['Group']['id'];
				foreach ($word_id as $check){
					$str=substr($check,0,3);
					$check1=substr($check,3);
					if($str=='grp'){
						$this->Grpaltproc->del($check1);
					}
					if($str=='hst'){
						$hostid[]=$this->data['Host']['id'.$check1];
						$this->Hstaltproc->del($check1);
					}
					//sunhy start 2009/05/22 added for YBR-32
					$this->GenerateFiles->hook_by_group($check, array('process'));
					//sunhy end 2009/05/22 added for YBR-32
				}
				//sunhy start 2009/05/22 delete for YBR-32
				//$this->GenerateFiles->hook_by_group($group_id, array('process'));
				//sunhy end 2009/05/22 delete for YBR-32
		}
		else{		
			if(!(in_array('E-00200',$errorMessage['proc_set_del']))){
				$errorMessage['proc_set_del'] = array('E-00200');
				$this->set('err', $errorMessage);
			}
		}
		//xinw start 20090209
		//modify for ASP4-031
		//$this->proc_alert_set($this->data['Group']['group_id']);
		
		//sunhy start 2009/03/04 modify for JLN-001
		//$this->proc_alert_set($this->data['Group']['group_id'],'nodo');
		$this->alert_set($this->data['Group']['group_id'],'nodo');
		//sunhy end 2009/03/04 modify for JLN-001
		//xinw end 20090209
		//sunhy start 2009/03/04 modify for JLN-001
		//$this->render('proc_alert_set');
		$this->render('alert_set');
		//sunhy end 2009/03/04 modify for JLN-001;
		exit();
	}
	/*************************************   the   second   page        ************************************/
	//xinw start 20090203
	//modify for ASP4-031
	//function proc_alert_set($group_id=null) {
	//sunhy start 2009/03/04 modify for JLN-001
	//function proc_alert_set($group_id=null,$do=null) {
	function alert_set($group_id=null,$do=null) {
	//sunhy end 2009/03/04 modify for JLN-001
	//xinw end 20090203
		//xinw start 20090203
		//modify for ASP4-031
		if ($group_id=='null') {
			$group_id=null;		
		}
		//xinw end 20090203
		$this->layout='ajax';
		if($group_id==""){
			$group_id=$this->data['Rltgrpaltproc']['group'];
		}

		$glist=array();
		$glist=$this->Grpauth->getParentsByChild($group_id);
		$this->set('glist',$glist);

		$condition = "Group.id=$group_id";
		$rs1 = $this->Group->findAll($condition,null,null,'0',null,null);
		$group_name=$rs1[0]['Group']['group_name'];
		$this->set('group_name',$group_name);
		$this->set('group_id',$group_id);
		
		//sunhy start 2009/03/30 added for JLN-001
		$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/30 added for JLN-001
		
		$asso = array(
		"Grpaltproc:grpaltprocs" =>array("Grpaltproc.group_id=Rltgrpaltproc.org_grp_id","Grpaltproc.id=Rltgrpaltproc.alert_id"),
		"Group : groups" => array("Group.id = Grpaltproc.group_id"),
		'Procapp : procapps:left' => array('Grpaltproc.process_name = Procapp.process_name'),
		'Application : applications:left' => array('Application.id = Procapp.application_id'),
		);
		$condition=array("Rltgrpaltproc.group_id=$group_id");
		$result = $this->Rltgrpaltproc->findByAsso($condition, array('Group.group_name','Group.id','Grpaltproc.process_name','Grpaltproc.application_name','Grpaltproc.id','Grpaltproc.process_status','Grpaltproc.specified_time'),null, null, null, $asso);
		$asso_host = array(

		"Host:hosts"=>array("Hstaltproc.host_id=Host.id"),
		"Rlthstgrp:rlthstgrps"=>array("Host.id=Rlthstgrp.host_id"),
		"Group:groups"=>array("Rlthstgrp.group_id=Group.id"),
		'Procapp : procapps:left' => array('Hstaltproc.process_name = Procapp.process_name'),
		'Application : applications:left' => array('Application.id = Procapp.application_id'),
		);
		$condition_host=array("Rlthstgrp.group_id in (select grpauths.org_grp_id from grpauths where grpauths.group_id=$group_id)");
		$result_host = $this->Hstaltproc->findByAsso($condition_host,array('Hstaltproc.process_name','Group.id','Group.group_name','Host.id','Host.host_name','Hstaltproc.application_name','Hstaltproc.process_status','Hstaltproc.id','Hstaltproc.specified_time'),null, null, null, $asso_host);
		if(!empty($result_host)){
			$host=array();
			$host=$this->trans_r($result_host);
			$this->set('result_host',$host);
		}
		if(!empty($result)){
			$rs=array();
			$rs=$this->trans_r($result);
			$this->set('result',$rs);
		}
		//xinw start 20090203
		//modify for ASP4-031
		//$this->index_add_sun($group_id);
		$judge=$this->Grpalt->findAll(array('Grpalt.group_id='.$group_id,'Grpalt.type=8'));
		if (empty($judge) && $do=='nodo') {
			$this->data['Grpalt']['mail_notice']=1;
			//sunhy start 2009/05/22 delete for YBR-32
			//$this->data['Title']['title_flg']=1;
			//sunhy end 2009/05/22 delete for YBR-32
			//sunhy start 2009/03/04 modify for JLN-001
			//$this->data['Grpalt']['popup']=2;
			$this->data['Grpalt']['popup']=0;
			//sunhy end 2009/03/04 modify for JLN-001
			//sunhy start 2009/03/25 modify for JLN-001
			//sunhy start 2009/05/22 delete for YBR-32
			//if($this->_getUserGroup() ==1 ){
			//sunhy end 2009/05/22 delete for YBR-32
				//sunhy start 2009/05/22 modify for YBR-32
			//$titleflg=$this->title_list($this->_getUserGroup());
			$titleflg=$this->title_list($group_id);
			//$this->data['Title']['title_flg'] = ($titleflg!=1)?1:0;
			if($titleflg== 0){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = 0;
			}
			if($titleflg== 2){
				$this->data['Title']['title_flg'] = 1;
			}
				//$altmsg_list_detail =$this->altmsg_list_detail($this->_getUserGroup());
			$msg = $this->MailPopupController->getAltMsg('E0006', $group_id);
			if($msg['Altmsg']['detail_flg']== 0){
				$this->data['Altmsg']['detail_flg'] = 0;
			}
			else{
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			if($msg['Altmsg']['detail_flg']== ""){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
			//sunhy end 2009/05/22 modify for YBR-32
			//}
			//else{
			//	$this->data['Altmsg']['detail_flg'] = 1;
			//	$this->data['Title']['title_flg']=1;
			//}
			//sunhy end 2009/03/25 modify for JLN-001

			
			//sunhy start 2009/05/22 modify for YBR-32
			//$altmsg=$this->Altmsg->findAll(array("message_id='E0006'"));
			//$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			$altmsg=$this->Altmsg->findAll(array("message_id='E0006'","Altmsg.group_id=".$group_id));
			if(!empty($altmsg)){
				$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			}else{
				$this->data['Altmsg']['message']=__('E0006',$return = true);
			}
			//sunhy end 2009/05/22 modify for YBR-32
			$email = $this->_getemail($group_id);
			//sunhy start 2009/03/04 modify for JLN-001
			//$this->set('group_email',$email);
			$this->set('email',$email);
			//sunhy end 2009/03/04 modify for JLN-001
		}else 
		{
			$this->index_add_sun($group_id);
		}
		//xinw end 20090203
	}

	/*

	プロセス名別表示

	*/

	function proclist($group_id=null) {
		$this->layout='ajax';

		$svc_name="";
		$svc_spec="";
		

		
		$errormessage['proclist']=array();
		if(!($this->Validation->maxLength($this->data['Uselgcproc']['svc_name'],260))||!($this->Validation->maxLength($this->data['Uselgcproc']['svc_spec'],256))){
			if(!(in_array('E-00300',$errorMessage['proclist']))){
				$errorMessage['proclist'][] = array('E-00300');
				$this->set('errorMessage', $errorMessage);
			}
		}
		if(empty($errorMessage['proclist'])){
			$condition=array("1=1");
			if($this->data['Uselgcproc']['svc_name']!=""){
				$svc_name=$this->data['Uselgcproc']['svc_name'];
				//xinw start 20080221
				$condition[]="lower(Uselgcproc.process_name) like '%".strtolower($this->Lv->spec_char_like($svc_name))."%'";
				//xinw end 20080221
			}
			if($this->data['Uselgcproc']['svc_spec']!=""){
				$svc_spec=$this->data['Uselgcproc']['svc_spec'];
				//xinw start 20080221
				$condition[]="lower(Application.application_name) like '%".strtolower($this->Lv->spec_char_like($svc_spec))."%'";
				//xinw end 20080221
			}
	
			$this->set('hdsvc_name',$svc_name);
			$this->set('hdsvc_spec',$svc_spec);
	
			if($group_id!==""){
				$condition1 = "Group.id=$group_id";
				$rs1 = $this->Group->findAll($condition1,null,null,'0',null,null);
				$group_name=$rs1[0]['Group']['group_name'];
			}
			elseif(($group_id=="") and (isset($this->data['Group']['group']))){
				$group_id=$this->data['Group']['group'];
				$group_name =$this->data['Group']['group_name'];
			}
			$this->set('group_id',$group_id);
			$this->set('group_name',$group_name);
		$glist = $this->Grpauth->getParentsByChild($group_id);
		ksort($glist);
		$glist_key=array_keys($glist);
	
			$asso=array(
	
			"Rlthstgrp:rlthstgrps"=>array("Rlthstgrp.host_id=Uselgcproc.host_id"),
			"Host:hosts"=>array("Host.id=Rlthstgrp.host_id"),
			'Procapp : procapps:left' => array('Uselgcproc.process_name = Procapp.process_name'),
			'Application : applications:left' => array('Application.id = Procapp.application_id'),
			'Grpauth : grpauths' => array('Grpauth.group_id = Rlthstgrp.group_id'),				
			);
			$condition[]="Grpauth.org_grp_id=$group_id";// by zhangying
			$condition[]="Uselgcproc.process_name not in (SELECT Grpaltproc.process_name AS Grpaltproc__process_name FROM grpaltprocs AS Grpaltproc  WHERE  Grpaltproc.group_id in (". implode(",", $glist_key) .") )";
			$condition['group by']="Uselgcproc.process_name,Application.application_name";
			list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'proclist', 'url'=>'/system_grpset_alert_processes/proclist/'.$group_id, 'modelClass'=>'Uselgcproc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso),'sortBy' => $this->Lv->sortBy('UPPER(Uselgcproc.process_name)'), 'ajaxFormId'=>'form1'));
			$result=$this->Uselgcproc->findByAsso($condition,array("Uselgcproc.process_name","Application.application_name"),$order, $limit, $page, $asso);
			$this->set('result',$result);

		}
		//sunhy start 2009/07/15 modify for YB-41
		if($group_id!==""){
			$condition1 = "Group.id=$group_id";
			$rs1 = $this->Group->findAll($condition1,null,null,'0',null,null);
			$group_name=$rs1[0]['Group']['group_name'];
		}
		elseif(($group_id=="") and (isset($this->data['Group']['group']))){
			$group_id=$this->data['Group']['group'];
			$group_name =$this->data['Group']['group_name'];
		}
		$this->set('group_id',$group_id);
		$this->set('group_name',$group_name);
		//sunhy end 2009/07/15 modify for YB-41
	}

	/*
	***********************************   *クライアントPC別表示          ***********************************************
	*/
	function pclist($group_id=null) {
		$this->layout='ajax';
		$host_name="";
		$svc_name="";
		$svc_spec="";
		$errormessage['pclist']=array();
		if(!($this->Validation->maxLength($this->data['Uselgcproc']['svc_name'],260))||!($this->Validation->maxLength($this->data['Uselgcproc']['svc_spec'],256))||!($this->Validation->maxLength($this->data['Uselgcproc']['host_name'],127))){
			if(!(in_array('E-00300',$errorMessage['pclist']))){
				$errorMessage['pclist'][] = array('E-00300');
				$this->set('errorMessage', $errorMessage);
			}
		}
		if(empty($errormessage['pclist'])){
			$condition=array("1=1");
			//sunhy start 2009/03/04 modify for JLN-001
			/*if($this->data['Uselgcproc']['host_name']!=""){
				$host_name=$this->data['Uselgcproc']['host_name'];
				//xinw start 20080221
				$condition[]="lower(Host.host_name) like '%".strtolower($host_name)."%'";
				//xinw end 20080221
			}
			if($this->data['Uselgcproc']['svc_name']!=""){
				$svc_name=$this->data['Uselgcproc']['svc_name'];
				//xinw start 20080221
				$condition[]="lower(Uselgcproc.process_name) like '%".strtolower($svc_name)."%'";
				//xinw end 20080221
			}
			if($this->data['Uselgcproc']['svc_spec']!=""){
				$svc_spec=$this->data['Uselgcproc']['svc_spec'];
				//xinw start 20080221
				$condition[]="lower(Application.application_name) like '%".strtolower($svc_spec)."%'";
				//xinw end 20080221
			}
*/
			$condition = $this->AlertPcController->search_judge("Host", "host_name", $this->Lv->spec_char_like($this->data['Uselgcproc']['host_name']), $condition);
			$condition = $this->AlertPcController->search_judge("Uselgcproc", "process_name", $this->Lv->spec_char_like($this->data['Uselgcproc']['svc_name']), $condition);
			$condition = $this->AlertPcController->search_judge("Application", "application_name", $this->Lv->spec_char_like($this->data['Uselgcproc']['svc_spec']), $condition);
			//sunhy end 2009/03/04 modify for JLN-001
			//sunhy start 2009/07/15 modify for YBR-41
			/*$this->set('hdhost_name',$host_name);
			$this->set('hdsvc_name',$svc_name);
			$this->set('hdsvc_spec',$svc_spec);*/
			$this->set('hdhost_name',$this->data['Uselgcproc']['host_name']);
			$this->set('hdsvc_name',$this->data['Uselgcproc']['svc_name']);
			$this->set('hdsvc_spec',$this->data['Uselgcproc']['svc_spec']);
			//sunhy end 2009/07/15 modify for YBR-41

			if($group_id!==""){
				//sunhy start 2009/03/04 modify for JLN-001
				/*$condition1 = "Group.id=$group_id";
				$rs1 = $this->Group->findAll($condition1,null,null,'0',null,null);
				$group_name=$rs1[0]['Group']['group_name'];*/
				$group = $this->AlertPcController->get_group($group_id);
				//$group_name=$group[0]['Group']['group_name'];
				//echo debug($group, 2);
				$group_name = $group['Group']['group_name'];
				//sunhy end 2009/03/04 modify for JLN-001
			}
			elseif(($group_id=="") and (isset($this->data['Group']['group']))){
				$group_id=$this->data['Group']['group'];
				$group_name =$this->data['Group']['group_name'];
			}
			$this->set('group_id',$group_id);
			$this->set('group_name',$group_name);
			$glist = $this->Grpauth->getParentsByChild($group_id);
			ksort($glist);
			$glist_key=array_keys($glist);

			$asso=array(
			"Rlthstgrp:rlthstgrps"=>array("Rlthstgrp.host_id=Uselgcproc.host_id"),
			"Host:hosts"=>array("Host.id=Rlthstgrp.host_id"),
			'Procapp : procapps:left' => array('Uselgcproc.process_name = Procapp.process_name'),
			'Application : applications:left' => array('Application.id = Procapp.application_id'),
			'Grpauth : grpauths' => array('Grpauth.group_id = Rlthstgrp.group_id'),				
			);
			$condition[]="Grpauth.org_grp_id=$group_id";// by zhangying
			$condition[]="Uselgcproc.process_name not in (SELECT Grpaltproc.process_name AS Grpaltproc__process_name FROM grpaltprocs AS Grpaltproc WHERE  Grpaltproc.group_id in (". implode(",", $glist_key) .") )";
			$condition[]="Uselgcproc.process_name not in (select Hstaltproc.process_name  from hstaltprocs as Hstaltproc where Hstaltproc.host_id=Uselgcproc.host_id )";
			//sunhy start 2009/03/04 modify for JLN-001
			/*$condition1 = null;
	    		$child_list = $this->Grpauth->getChildrenByParent($group_id);    		
	    		if (!empty($child_list)){
		      		foreach ($child_list as $key=>$list){
		     			if($key<>$group_id){
		     				$condition1 = $condition1."Grpaltproc.group_id = $key or ";
		     			}
		    		}      			
	    		}
	    		$condition1 = substr($condition1,0,-3);
	    		$condition1 = $condition1."GROUP BY Grpaltproc.process_name,,Grpaltproc.group_id";
	    		$check_child = $this->Grpaltproc->findAll($condition1,'Grpaltproc.group_id,Grpaltproc.process_name'); 
			if (!empty($check_child)){
				foreach ($check_child as $value_child){
				         $grp_child = $value_child['Grpaltproc']['group_id'];
				         $lim_hid = $this->Rlthstgrp->findAll(array("Rlthstgrp.group_id" => $grp_child),"Rlthstgrp.host_id");
				         foreach ($lim_hid as $out_hid){
				         	$se_hid = $out_hid['Rlthstgrp']['host_id'];
				         	$condition[] = "(Uselgcproc.process_name <> '".$value_child['Grpaltproc']['process_name']."' or Uselgcproc.host_id <> $se_hid)";	
				         }	
				}			
			}*/
			$condition = $this->AlertPcController->get_child_info($group_id, "Grpaltproc","process_name", "Rlthstgrp", "group_id", $condition);
			//sunhy end 2009/03/04 modify for JLN-001		
			$condition['group by']="Uselgcproc.process_name,Application.application_name,Host.host_name,Uselgcproc.host_id";
			list($order,$limit,$page) = $this->Pagination->init($condition,null, array('ajaxDivUpdate'=>'pclist', 'url'=>'/system_grpset_alert_processes/pclist/'.$group_id, 'modelClass'=>'Uselgcproc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso),  'sortBy' => $this->Lv->sortBy('UPPER(Host.host_name),UPPER(Uselgcproc.process_name)'),'ajaxFormId'=>'form1'));
			$result=$this->Uselgcproc->findByAsso($condition,array("Uselgcproc.process_name","Application.application_name","Host.host_name","Uselgcproc.host_id"),$order, $limit, $page, $asso);
			$this->set('result',$result);
		}
	}
	
	
	/*
	*クライアントPC別表示

	ルールに追加する

	*/
	function add_pc_rule(){
		$group_id=$this->data['Group']['group'];
		$errorMessage['add_pc_rule']=array();
		if(isset($this->data['Uselgcproc']['Uselgcproc_id'])){
			$word_id = $this->data['Uselgcproc']['Uselgcproc_id'];
			$host_id=array();
			$i=0;
				foreach ($word_id as $check){
					$host=$this->data['Uselgcproc']['host_id_'.$check];
					$specified_time="";
					//sunhy start 2009/03/30 modify for JLN-001	
					//$specified_time=$this->data['Uselgcproc']['specified_time'.$check];
					if(isset($this->data['Uselgcproc']['specified_time'.$check])){
						$specified_time=$this->data['Uselgcproc']['specified_time'.$check];				
					}
					if($specified_time == ""){
						$specified_time = 0;
					}
					//sunhy end 2009/03/30 modify for JLN-001
					//sunhy start 2009/03/25 modify for JLN-001
					if(!is_numeric($specified_time) || $specified_time<0){
						$errorMessage['add_proc_rule'][] = 'E-04002';
		    				$this->set('errorMessage',$errorMessage);     
					}
					else if(strlen($specified_time)>9){
						$errorMessage['add_proc_rule'][] = 'E-04003';
		    				$this->set('errorMessage',$errorMessage);
					}
					else{
					//sunhy end 2009/03/25 modify for JLN-001
						$host_id[]=$this->data['Uselgcproc']['host_id_'.$check];
						$insertdate=Array(
							'Hstaltproc' => Array(
							'host_id'=>$this->data['Uselgcproc']['host_id_'.$check],
							'process_name' => $this->data['Uselgcproc']['svc_name_'.$check],
							'application_name'=> $this->Lv->spec_char_dbm($this->data['Uselgcproc']['svc_spec_'.$check]),
							'process_status'=> $this->data['Uselgcproc']['status_'.$check],
							'specified_time'=>$specified_time
							)
						);
						$this->Hstaltproc->save($insertdate);
					//sunhy start 2009/03/25 modify for JLN-001
					}
					//sunhy end 2009/03/25 modify for JLN-001
						$host = $this->data['Uselgcproc']['host_id_'.$check];
						$condition_findgrp = "Rlthstgrp.host_id = $host";
						$group = $this->Rlthstgrp->find($condition_findgrp);
						$group_findalt = $group['Rlthstgrp']['group_id'];
				    		$condition = "Grpalt.group_id = $group_findalt AND Grpalt.type = 8";
				    		$value = $this->Grpalt->find($condition);   
				    		if (!$value){
							//sunhy start 2009/03/25 modify for JLN-001
							/*$add_alt = array(
								'Grpalt' => Array(
								'group_id' => $group_findalt,
								'mail_notice' =>1,
								'mail_notice_time' => '00',
								'popup' =>0,
								'up_cast' =>1,
								'receive'=>1,
								'type' =>8,
								)			
							);  
							$this->Grpalt->save($add_alt);*/ 	
							$this->MailPopupController->setMailPop(null, $group_findalt, 1, '00', 0, 1, 1, 8, 'Grpalt');
							//sunhy end 2009/03/25 modify for JLN-001	    				    			
				    		}						
						$this->data['Uselgcproc']['status_'.$check]=1;
						if(isset($this->data['Uselgcproc']['specified_time'.$check])){
							$this->data['Uselgcproc']['specified_time'.$check]="";
						}	
						$this->data['Uselgcproc']['Uselgcproc_id'][$i]=null;	
					$i++;
				}
		}
		else{
			if(!(in_array('E-00200',$errorMessage['add_pc_rule']))){
				$errorMessage['add_pc_rule'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}			
		}
		if(empty($errorMessage['add_pc_rule']) and !empty($host_id)){
			//sunhy start 2009/05/22 modify for YBR-32
			//$this->GenerateFiles->hook_by_host($host_id, array('process'));
			$this->GenerateFiles->hook_by_host($host_id, array('process'), $group_id);
			//sunhy end 2009/05/22 modify for YBR-32
		}
		
		$this->pclist($group_id);		
		$this->render('pclist');
		exit();
	}
	/*
	*クライアントPC別表示
	削除する

	*/
	function pc_del(){
		$this->layout='ajax';
		if(isset($this->data['Uselgcproc']['Uselgcproc_id'])){
			$word_id=$this->data['Uselgcproc']['Uselgcproc_id'];
			$host_id=array();
			foreach ($word_id as $check){
				$host_id[]=$this->data['Uselgcproc']['host_id_'.$check];
			}
			//sunhy start 2009/05/22 modify for YBR-32
			//$this->GenerateFiles->hook_by_host($host_id, array('process'));
			$this->GenerateFiles->hook_by_host($host_id, array('process'), $this->data['Group']['group']);
			//sunhy end 2009/05/22 modify for YBR-32
		}
		else{
			$errorMessage['pc_del']=array();
			if(!(in_array('E-00200',$errorMessage['pc_del']))){
				$errorMessage['pc_del'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		$this->pclist($this->data['Group']['group']);
		$this->render('pclist');
		exit();
	}


	/*
	*プロセス名別表示

	削除する

	*/
	function add_proc_rule(){
		$group_id=$this->data['Group']['group'];
		$errorMessage['add_svc_rule']=array();
		if(isset($this->data['Uselgcproc']['Uselgcproc_id'])){
			$word_id = $this->data['Uselgcproc']['Uselgcproc_id'];
			foreach ($word_id as $check){
				if(isset($this->data['Uselgcproc']['specified_time'.$check]) and ($this->data['Uselgcproc']['status_'.$check]==3)){
					$specified_time=$this->data['Uselgcproc']['specified_time'.$check];
					if($this->Lv->is_empty($specified_time)){
						if(!(in_array('error_rule_alert',$errorMessage['add_svc_rule']))){
							$errorMessage['add_svc_rule'] = array('date_alert');
							$this->set('errorMessage', $errorMessage);
						}											
					}
				}
			}
			if(empty($errorMessage['add_svc_rule'])){								
				$i=0;
				foreach ($word_id as $check){	
					$proc_name=$this->Lv->spec_char_dbm($this->data['Uselgcproc']['svc_name_'.$check]);				
					$children = $this->Grpauth->getChildrenByParent($group_id);
					foreach ($children as $grp_id=>$grp_name){
						$condition_hst = array("Rlthstgrp.group_id = $grp_id and Hstaltproc.process_name = '".$proc_name."'");
						$asso = array(			
								'Host : hosts' => array('Hstaltproc.host_id = Host.id'),
								'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),	
						);
						$hst_del = $this->Hstaltproc->findByAsso($condition_hst,array('Hstaltproc.id as Hstaltproc__id,Hstaltproc.host_id as Hstaltproc__host_id'),null,null,null,$asso);
						if (!empty($hst_del)){					
							$error = 1;	
						}									
						$condition_grp = array("Grpaltproc.group_id = $grp_id and Grpaltproc.process_name = '".$proc_name."'");					
						$grp_del = $this->Grpaltproc->findAll($condition_grp);
						if (!empty($grp_del)){				
							$error = 1;	
						}										
					}
				}				
				if (isset($error)){		
					$errorMessage['add_proc_rule'][] = 'E-02400';
			    		$this->set('errorMessage',$errorMessage);     										
				}
				else {
					foreach ($word_id as $check){					
						$specified_time="";
						if(isset($this->data['Uselgcproc']['specified_time'.$check])){
							$specified_time=$this->data['Uselgcproc']['specified_time'.$check];				
						}
						//sunhy start 2009/03/30 modify for JLN-001
						if($specified_time == ""){
							$specified_time = 0;
						}
						//sunhy end 2009/03/30 modify for JLN-001
						//sunhy start 2009/03/25 modify for JLN-001
						if(!is_numeric($specified_time) || $specified_time<0){
							$errorMessage['add_proc_rule'][] = 'E-04002';
			    				$this->set('errorMessage',$errorMessage);     
						}
						else if(strlen($specified_time)>9){
						$errorMessage['add_proc_rule'][] = 'E-04003';
		    				$this->set('errorMessage',$errorMessage);
						}
						else{
						//sunhy end 2009/03/25 modify for JLN-001
						$insertdate=Array(
							'Grpaltproc' => Array(
							'group_id'=>$this->data['Group']['group'],
							'process_name' => $this->data['Uselgcproc']['svc_name_'.$check],
							'application_name'=> $this->Lv->spec_char_dbm($this->data['Uselgcproc']['svc_spec_'.$check]),
							'process_status'=> $this->data['Uselgcproc']['status_'.$check],
							'specified_time'=>$specified_time,
							)
						);
						
						$this->Grpaltproc->save($insertdate);
						//sunhy start 2009/03/25 modify for JLN-001
						}
						//sunhy end 2009/03/25 modify for JLN-001
						$alert_id = $this->Grpaltproc->getLastInsertID();
						$glist = $this->Grpauth->getChildrenByParent($this->data['Group']['group']);
						foreach ($glist as $key=>$value){
							$insertdate=Array(
								'Rltgrpaltproc' => Array(
								'group_id' => $key,
								'alert_id' =>  $alert_id,
								'org_grp_id' => $this->data['Group']['group'],
								)
							);
							$this->Rltgrpaltproc->save($insertdate);
							$this->data['Uselgcproc']['status_'.$check]=1;
							if(isset($this->data['Uselgcproc']['specified_time'.$check])){
								$this->data['Uselgcproc']['specified_time'.$check]="";
							}	
							$this->data['Uselgcproc']['Uselgcproc_id'][$i]=null	;							
						}
						$this->data['Uselgcproc']['status_'.$check]=1;
						
						if(isset($this->data['Uselgcproc']['specified_time'.$check])){
							$this->data['Uselgcproc']['specified_time'.$check]="";						
						}
						$this->data['Uselgcproc']['Uselgcproc_id'][$i]=null;
						$i++;	
					}
					//xinw start 20090203
					//modify for ASP4-031
					$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 8";
			    	$value = $this->Grpalt->find($condition);   
			    	if (!$value){
					//sunhy start 2009/03/25 modify for JLN-001
					/*$add_alt = array(
						'Grpalt' => Array(
						'group_id' => $group_id,
						'mail_notice' =>1,
						'mail_notice_time' => '00',
						'popup' =>0,
						'up_cast' =>1,
						'receive'=>1,
						'type' =>8,
						)					
					);  
					$this->Grpalt->save($add_alt); 	*/
					$this->MailPopupController->setMailPop(null, $group_id, 1, '00', 0, 1, 1, 8, 'Grpalt');
					//sunhy end 2009/03/25 modify for JLN-001	    				    			
				    }
					//xinw end 20090203
					$this->GenerateFiles->hook_by_group($this->data['Group']['group'], array('process'));				
				}
			}			
		}
		else{
				$errorMessage['add_proc_rule'] = array('E-00200');			
				$this->set('errorMessage', $errorMessage);
		}
		$this->proclist($this->data['Group']['group']);
		$this->render('proclist');
		exit();
	}
	/*
	*プロセス名別表示

	ルールに追加する

	*/
	function proc_del(){
		if(isset($this->data['Uselgcproc']['Uselgcproc_id'])){
			$word_id=$this->data['Uselgcproc']['Uselgcproc_id'];
			foreach ($word_id as $check){
				$this->Uselgcproc->del($check);
			}
			$this->GenerateFiles->hook_by_group($this->data['Group']['group'], array('process'));
		}
		else{
			$errorMessage['proc_del']=array();
			if(!(in_array('E-00200',$errorMessage['proc_del']))){
				$errorMessage['proc_del'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		$this->proclist($this->data['Group']['group']);
		$this->render('proclist');
		exit();
	}

	/* グループ共通の判定 */
	function error_judge_grpalt($content = null,$name2){
		if(empty($content)){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!empty($content)){
			if(!$this->Validation->maxLength($content,2000)){
				$errorMessage[$name2][] = 'E-00300';
			}
		}
		return $errorMessage;
	}

	/*
	************************* grpalt_list **************************************

	*/
	function grpalt_list($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=8 ";
		$grpalt = $this->Grpalt->findAll($condition);
		return $grpalt;

	}
	function _getemail($group_id){
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		return $data_email;

	}

	/**
     *  **************************************上位グループの設定 **********************************************************
     * 
     * */

	function index_add_sun($group_id){
		$this->layout='ajax';
		$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,8);
		$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		//上位グループの設定を引き継ぐ
		if(@$this->data["Grpaltproc"]["procalt_flag"] != 1) {
			if($grpalt_f == 1){  //echo "71<br>";
				$grpalt_r = $this->grpalt_list($group_id);
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				$this->data['Grpalt']['receive'] = ($grpalt_r[0]['Grpalt']['receive']==0?1:0);
				//sunhy start 2009/03/04 modify for JLN-001
				//$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:0;
				//sunhy end 2009/03/04 modify for JLN-001
				$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
				$this->set('mail_notice_time_c',$mail_notice_time_c);

			}else{ 

				$this->data['Grpalt']['mail_notice'] = 1;
				//sunhy start 2009/03/04 modify for JLN-001
				//$this->data['Grpalt']['popup'] = 2;
				$this->data['Grpalt']['popup'] = 0;
				//sunhy end 2009/03/04 modify for JLN-001
				$mail_notice_time_c = '00';
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$up_cast_flag = 1;
				$this->data['Grpalt']['receive']=0;

				//sunhy     start      2009/07/15   modify for YBR-41
				//$this->add_grpalt($group_id,1);
				//sunhy     end      2009/07/15   modify for YBR-41
			}
			/*  件名管理情報,エラー情報  */
				//sunhy start 2009/05/22 modify for YBR-32  
			//if($getUserGroup == 1){
		 	//$title =$this->title_list();
			$title =$this->title_list($group_id);
			//sunhy end 2009/05/22 modify for YBR-32 
			if($title== 0){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = 0;
			}
			if($title== 2){
				$this->data['Title']['title_flg'] = 1;
			}
			//sunhy start 2009/05/22 modify for YBR-32  
			//$altmsg_list =$this->altmsg_list();
			$altmsg_list =$this->altmsg_list($group_id);
			if($altmsg_list==2){
				$this->data['Altmsg']['message']=__('E0006',$return = true);
			}else{
				$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			}
			//$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?0:1;
			$msg = $this->MailPopupController->getAltMsg('E0006', $group_id);
			if($msg['Altmsg']['detail_flg']== 0){
				$this->data['Altmsg']['detail_flg'] = 0;
			}
			else {
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			if($msg['Altmsg']['detail_flg']== ""){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//sunhy end 2009/05/22 modify for YBR-32 
				
			//sunhy start 2009/05/22 modify for YBR-32 
			//}
			//sunhy end 2009/05/22 modify for YBR-32 
		}
		$group_email = $this->_getemail($group_id);
		//sunhy start 2009/03/04 modify for JLN-001
		//$this->set('group_email',$group_email);
		$this->set('email',$group_email);
		//sunhy end 2009/03/04 modify for JLN-001

		/* 追加　*/


		if(@$this->data["Grpaltproc"]["procalt_flag"] == 1) {
			$getUserGroup = $this->_getUserGroup();
			//sunhy start 2009/05/22 modify for YBR-32  
			//if($getUserGroup == 1){
			//sunhy end 2009/05/22 modify for YBR-32 
			@$Grpaltcontent = $this->data["Altmsg"]["message"];
			@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');
			if(!count($result_content) == 0){
				$errorMessage =$result_content;
				if(!empty($result_content)){
					$this->set('errorMessage',$errorMessage);
				}
				//sunhy start 2009/05/22 modify for YBR-32 
				//$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
				isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c='00';
				//sunhy end 2009/05/22 modify for YBR-32 
				$this->set('mail_notice_time_c',$mail_notice_time_c);
			}
				//sunhy start 2009/05/22 modify for YBR-32  	
				//}
				//sunhy end 2009/05/22 modify for YBR-32 
			if(!empty($errorMessage)){
				//sunhy start 2009/05/22 modify for YBR-32  	
				//$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
                isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c='00';
				//sunhy end 2009/05/22 modify for YBR-32 

				$this->set('mail_notice_time_c',$mail_notice_time_c);
				//sunhy start 2009/03/04 modify for JLN-001
				//$this->render('proc_alert_set');
				$this->render('alert_set');
				//sunhy end 2009/03/04 modify for JLN-001
				exit();
			}
			if(empty($errorMessage)){
				if(isset($this->data['Grpalt']['mail_notice_time_hour'])){
					$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
				}else{
					$mail_notice_time_c ='00';
				}
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->add_grpalt($group_id,1);
				$this->index();
				$this->render('index');
				exit();
			}
		}
	}



	/* 件名管理情報  start*/
	//sunhy start 2009/05/22 modify for YBR-32 
	//function title_flag(){
	function title_flag($group_id=null){	
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Title.group_id=$group_id";
		//$condition =" Title.type=8 ";
		$condition[] =" Title.type=8 ";
		//sunhy end 2009/05/22 modify for YBR-32 
		$title = $this->Title->findAll($condition);
		if(count($title) == 1){
			$flag = $title[0]['Title']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	//sunhy start 2009/05/22 modify for YBR-32 
	function altmsg_flag($group_id=null){
	//function altmsg_flag(){
	         $condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Altmsg.group_id=$group_id";
		//$condition =" Altmsg.message_id='E0006' ";
		$condition[] =" Altmsg.message_id='E0006' ";
		//sunhy end 2009/05/22 modify for YBR-32 
		$altmsg = $this->Altmsg->findAll($condition);
		if(count($altmsg) == 1){
			$flag = $altmsg[0]['Altmsg']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}

	//sunhy start 2009/05/22 modify for YBR-32 
	//function title_list(){
	function title_list($group_id=null){	
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Title.group_id=$group_id";
		//$condition =" Title.type=8 ";
		$condition[] =" Title.type=8 ";
		//sunhy end 2009/05/22 modify for YBR-32 
		$title = $this->Title->findAll($condition);
		if(count($title) == 1){
			$flag = $title[0]['Title']['title_flg'];
		}else{
			$flag =2;
		}
		return $flag;
	}
	//sunhy start 2009/05/22 modify for YBR-32 
	//function altmsg_list(){
	function altmsg_list($group_id=null){	
		 $condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Altmsg.group_id=$group_id";	
		//$condition =" Altmsg.message_id='E0006' ";
		$condition[] =" Altmsg.message_id='E0006' ";
		//sunhy end 2009/05/22 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		if(count($altmsg) == 1){
			$array = $altmsg;
		}else{
			//sunhy start 2009/05/22 modify for YBR-32 
			//$array = 0;
			$array = 2;
			//sunhy end 2009/05/22 modify for YBR-32 
		}
		return $array;
	}
	function grpalt_list_id($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=8 ";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalt"]["id"];
		}else{
			$id =0;
		}
		return $id;

	}
	/*  編集グループ共通 */
	function edit_grpalt($group_id,$checkbox_flag){
		$grpalt_id = $this->grpalt_list_id($group_id);
		if($checkbox_flag == 1) {
			if($this->data["Grpalt"]["popup"] == 1){
				$popup = 1;
			}else{
				$popup = 0;
			}
			if($this->data["Grpalt"]["mail_notice"] == 2){
				$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
			}else{
				$mail_notice_time = '00:00:00';
			}
			if(isset($this->data["Grpalt"]["mail_notice"])){
				//sunhy start 2009/03/25 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'id' => $grpalt_id,
				'group_id' => $group_id,
				'mail_notice' => $this->data["Grpalt"]["mail_notice"],
				'mail_notice_time' => @$mail_notice_time,
				'popup' =>$popup,
				'type'=>8,
				'up_cast' => 1,
				'receive'=>($this->data['Grpalt']['receive']==1?0:1),
				));
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, $popup, 1, $this->data['Grpalt']['receive']==1?0:1, 8, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001
				//sunhy start 2009/05/22 modify for YBR-32 
				//$this->GenerateFiles->hook_by_ps(0, array("process", "popup"));
				//sunhy end 2009/05/22 modify for YBR-32 
				$getUserGroup = $this->_getUserGroup();
				//sunhy start 2009/05/22 modify for YBR-32 
				//if($getUserGroup == 1){
					//$re_title =$this->title_flag();
					//$this->editTitle($re_title);
					//$re_msg =$this->altmsg_flag();
					//$this->editAltmsg($re_msg);
					
				$re_title =$this->title_flag($group_id);
				if($re_title == 0){
			 		$this->addTitle($group_id);
				}else{
			 		$this->editTitle($re_title,$group_id);
				}
				$re_msg =$this->altmsg_flag($group_id);
				if($re_msg == 0){
					$this->addAltmsg($group_id);
				}else{
					$this->editAltmsg($re_msg,$group_id);
				}
			//}
				//sunhy end 2009/05/22 modify for YBR-32 
			}
			//sunhy start 2009/05/22 modify for YBR-32 
			$this->GenerateFiles->hook_by_group($group_id, array("process", "popup"));
			//sunhy end 2009/05/22 modify for YBR-32 
		}
	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/22 modify for YBR-32
	//function addTitle(){
	function addTitle($group_id=null){	
		if(empty($group_id)){
			$group_id=1;
		}
	//sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'title_flg' => $title_flg,
		'type' => 8,
		//sunhy start 2009/05/22 modify for YBR-32
		'group_id'=>$group_id,
		//sunhy end 2009/05/22 modify for YBR-32
		));
		$this->Title->save($inserttitle);
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("process", "popup"));
		//sunhy end 2009/05/22 modify for YBR-32
	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/22 modify for YBR-32
	//function editTitle($id){
	function editTitle($id,$group_id=null){	
		if(empty($group_id)){
			$group_id=1;
		}
	///sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'id'=>$id,
		'title_flg' => $title_flg,
		'type' => 8,
		//sunhy start 2009/05/22 modify for YBR-32
		'group_id'=>$group_id,
		//sunhy end 2009/05/22 modify for YBR-32
		));
		$this->Title->save($inserttitle);
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("process", "popup"));
		//sunhy end 2009/05/22 modify for YBR-32
	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/22 modify for YBR-32
	//function addAltmsg(){
	   function addAltmsg($group_id=null){	
		 if(empty($group_id)){
	           	$group_id=1;
	           }
		//sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/25 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'message_id' => 'E0006',
		//xuchan start 20081029
		//'message' => $message,
		'message' =>$this->Lv->spec_char_change( $message),
		//xuchan end 20081029
		'detail_flg' => $detail_flg,
		//yuanxiaojun start 20090209 modify for ASP4-033
		'group_id'=>$group_id,
		//yuanxiaojun end 20090209
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0006', $message, $detail_flg, null);
		$this->MailPopupController->setAltMsg('E0006', $message, $detail_flg, null, $group_id);
		//sunhy end 2009/05/22 modify for YBR-32
		//sunhy end 2009/03/25 modify for JLN-001
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("process", "popup"));
		//sunhy end 2009/05/22 modify for YBR-32
	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/22 modify for YBR-32
	//function editAltmsg($id){
	function editAltmsg($id,$group_id=null){	
		 if(empty($group_id)){
	           	$group_id=1;
	           }
		//sunhy end 2009/05/22 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/25 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'id'=>$id,
		'message_id' => 'E0006',
		//xuchan start 20081029
		//'message' => $message,
		'message' =>$this->Lv->spec_char_change( $message),
		//xuchan end 20081029
		'detail_flg' => $detail_flg,
		 //yuanxiaojun start 20090209 modify for ASP4-033
		'group_id'=>$group_id,
		//yuanxiaojun end 20090209
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0006', $message, $detail_flg, $id);
		$this->MailPopupController->setAltMsg('E0006', $message, $detail_flg, $id, $group_id);
		//sunhy start 2009/05/22 modify for YBR-32
		//sunhy end 2009/03/25 modify for JLN-001
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("process", "popup"));
		//sunhy end 2009/05/22 modify for YBR-32
	}

	/* グループ共通設定テーブルのデータ */
	function add_grpalt($group_id,$checkbox_flag){
		$getUserGroup = $this->_getUserGroup();
		$grpalt=$this->Grpalt->grpalt_list_flag($group_id,8);
		if($grpalt == 1){
			$this->edit_grpalt($group_id,1);
		}
		else{
			if($checkbox_flag == 1) {
				//sunhy start 2009/03/25 modify for JLN-001
				//$insertgrpalt=Array(
				//xinw start 20090203
				//modify for ASP4-031
				/*'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' =>1,
				'mail_notice_time' => '00',
				'popup' =>0,
				'up_cast' =>1,
				'receive'=>0,
				'type' =>8,
				)*/
				/*'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' =>$this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => '00',
				'popup' =>($this->data["Grpalt"]["popup"] == 1)?1:0,
				'up_cast' =>1,
				'receive'=>($this->data["Grpalt"]["receive"] == 1)?0:1,
				'type' =>8,
				)
				//xinw end 20090203
				);
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop(null, $group_id, $this->data['Grpalt']['mail_notice'], '00', $this->data["Grpalt"]["popup"] == 1?1:0, 1, $this->data["Grpalt"]["receive"] == 1?0:1, 8, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001
				//sunhy start 2009/05/22 modify for YBR-32
				 $re_title =$this->title_flag($group_id);
				 if($re_title == 0){
				 	$this->addTitle($group_id);
				 }else{
				 	$this->editTitle($re_title,$group_id);
				 }
				$re_msg =$this->altmsg_flag($group_id);
				if($re_msg == 0){
					$this->addAltmsg($group_id);
				}else{
					$this->editAltmsg($re_msg,$group_id);
				}
				//$this->GenerateFiles->hook_by_ps(0, array("process", "popup"));
				//sunhy end 2009/05/22 modify for YBR-32
			}
			//sunhy start 2009/05/22 modify for YBR-32
			$this->GenerateFiles->hook_by_group($group_id, array("process", "popup"));
			//sunhy end 2009/05/22 modify for YBR-32
		}
	}
	//sunhy start 2009/03/25 modify for JLN-001
	//sunhy start 2009/05/22 modify for YBR-32
	//function altmsg_list_detail(){
	   function altmsg_list_detail($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[]=" Altmsg.group_id=$group_id";
	//sunhy end 2009/05/22 modify for YBR-32
		$condition[] =" Altmsg.message_id='E0006' ";
		
		$altmsg = $this->Altmsg->findAll($condition);
	
		if(count($altmsg) == 1){
			$array = $altmsg[0]["Altmsg"]["detail_flg"];
		}else{
			$array = 2;
		}
		return $array;
	}
	//sunhy end 2009/03/25 modify for JLN-001
}
?>