<?php
/*********************************************************************
*@filename 		system_grpset_alert_services_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhy    	  2009/03/30   modify for JLN-001
*            2.0        sunhy    	  2009/05/21   modify for YBR-32
*            2.0        sunhy    	  2009/07/01   modify for YBR-35
*            2.0        sunhy           2009/07/15   modify for YBR-41
*            2.0        sunhy    	  2009/07/25 modify for JL-0035
********************************************************************/
class SystemGrpsetAlertServicesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	//sunhy start 2009/03/30 modify for JLN-001
	//var $components = array ('Pagination', 'Lv','GenerateFiles','Check');
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'Check','MailPopupController','AlertPcController');
	//sunhy end 2009/03/30 modify for JLN-001
	var $uses=array('Configure','Grpalt','Grpauth','Group','Host','Rltgrpaltsvc','Rlthstgrp','Host','Grpaltsvc','Hstaltsvc','User','Mail','Validation','Poll','Title','Altmsg','Uselgcsvc');
	var $layout='system';
	function beforeFilter()
	{
		parent::beforeFilter();
	}
	//sunhy start 2009/03/30 modify for JLN-001
	//function reset(){
	function alert_list(){
	//sunhy end 2009/03/30 modify for JLN-001
		$this->layout='ajax';
		$this ->index();
		$this->render('index');

	}
	/*
	************************************************               the index page                        ********************************************************
	*/
	function index(){
		$this->pageTitle = __('title',$return = true);   
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		
		//ksort($glist);
		$this->set('glist',$glist);
		$glist_key=array_keys($glist);
		$this->set('glist_key',$glist_key);
		
		$glist_p=$this->Grpauth->getParentsByChild($this->_getUserGroup());
		ksort($glist_p);		
		$glist_p_key=array_keys($glist_p);
		$this->set('glist_p_key',$glist_p_key);

		$key_glist=$glist+$glist_p;
		ksort($key_glist);
		$this->set('key_glist',$key_glist);

		$asso = array(

		"Grpauth:grpauths" =>array("Grpaltsvc.group_id=Grpauth.org_grp_id"),
		"Group : groups" => array("Group.id = Grpaltsvc.group_id"),
		"Grpalt:grpalts:left"=>array("Grpalt.group_id=Group.id","Grpalt.type=7")
		//"Grpalt:grpalts:left"=>array("Grpalt.group_id=Group.id")
		);
		$a=$this->_getUserGroup();
		$this->set("usergroup",$a);
		$condition=array("Grpauth.group_id=$a");
		$result = $this->Grpaltsvc->findByAsso($condition, array('Group.group_name','Grpaltsvc.id','Group.id','Grpaltsvc.service_name','Grpaltsvc.specification','Grpaltsvc.service_status','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso);

		$asso_host = array(

		"Host:hosts"=>array("Hstaltsvc.host_id=Host.id"),
		"Rlthstgrp:rlthstgrps"=>array("Host.id=Rlthstgrp.host_id"),
		"Group:groups"=>array("Rlthstgrp.group_id=Group.id"),
		"Grpalt:grpalts:left"=>array("Grpalt.group_id=Group.id","Grpalt.type=7")
		);
		$condition_host=array("Rlthstgrp.group_id in (select grpauths.org_grp_id from grpauths where grpauths.group_id=$a)");
		$result_host = $this->Hstaltsvc->findByAsso($condition_host,array('Hstaltsvc.service_name','Group.id','Group.group_name','Host.id','Host.host_name','Hstaltsvc.specification','Hstaltsvc.service_status','Hstaltsvc.id','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso_host);

		$host=array();
		if(!empty($result_host)){
			$host=$this->trans_r($result_host);		
		}
		$this->set('result_host',$host);
		$rs=array();
		if(!empty($result)){
			$rs=$this->trans_r($result);			
		}
		$this->set('result',$rs);
		$asso = array(
		"Grpauth:grpauths" =>array("Grpaltsvc.group_id=Grpauth.group_id"),
		"Group : groups" => array("Group.id = Grpaltsvc.group_id"),
		"Grpalt:grpalts:left"=>array("Grpalt.group_id=Group.id","Grpalt.type=7")
		);

		$condition=array("Grpauth.org_grp_id =$a","Grpauth.group_id != $a");
		$child = $this->Grpaltsvc->findByAsso($condition, array('Group.group_name','Grpaltsvc.id','Group.id','Grpaltsvc.service_name','Grpaltsvc.specification','Grpaltsvc.service_status','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso);

		$asso_host = array(

		"Host:hosts"=>array("Hstaltsvc.host_id=Host.id"),
		"Rlthstgrp:rlthstgrps"=>array("Host.id=Rlthstgrp.host_id"),
		"Group:groups"=>array("Rlthstgrp.group_id=Group.id"),
		"Grpalt:grpalts:left"=>array("Grpalt.group_id=Group.id","Grpalt.type=7")
		);
		$condition_host=array("Rlthstgrp.group_id in (select grpauths.group_id from grpauths where grpauths.org_grp_id=$a and grpauths.org_grp_id != grpauths.group_id)");
		$child_host = $this->Hstaltsvc->findByAsso($condition_host,array('Hstaltsvc.service_name','Group.id','Group.group_name','Host.id','Host.host_name','Hstaltsvc.specification','Hstaltsvc.service_status','Hstaltsvc.id','Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast'),null, null, null, $asso_host);
		$host=array();
		if(!empty($child_host)){
			$host=$this->trans_r($child_host);						
		}
		$this->set('child_host',$host);
		$rs=array();
		if(!empty($child)){		
			$rs=$this->trans_r($child);				
		}
		$this->set('child',$rs);
		$asso_alt=array(
		"Group:groups"=>array("Group.id=Grpalt.group_id"),
		
		);
		//sunhy start 2009/05/21 modify for YBR-32
		$childgroup= $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$groupIn="";
		foreach ($childgroup as $keys => $vaule){
			$groupIn .= $keys.",";
		}
		$groupIn .= "0";
		//sunhy end 2009/05/21 modify for YBR-32
		$result_alt=array();
		$alt=array();
		//sunhy start 2009/05/21 modify for YBR-32
		//$result_alt=$this->Grpalt->findAll(array('type=7'),array('Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast','Group.group_name','Group.id'));
		$result_alt=$this->Grpalt->findByAsso(array('type=7 and group_id in('.$groupIn.')'),array('Grpalt.mail_notice','Grpalt.popup','Grpalt.mail_notice_time','Grpalt.up_cast','Group.group_name','Group.id'), null, null, null, $asso_alt);
		//sunhy end 2009/05/21 modify for YBR-32
		if(!empty($result_alt)){	
			$alt=$this->trans_r($result_alt);		
		}
		$this->set('result_alt',$alt);
	}
	
	function trans_g($rs){
		foreach ($rs as $key=>$value){
			//debug($rs);
			if($value[0]['Grpalt']['up_cast']==0){
				$g_id=$this->Group->getFatherSet($value[0]['Group']['id'],$this->Grpalt,7);
				$condition="Grpalt.group_id=$g_id and Grpalt.type=7";
				$rs_u=$this->Grpalt->findAll($condition,null,null,null,null,null);
				if(!empty($rs_u)){
					foreach ($rs_u as $rs_t){
						$rs[$key][0]['Grpalt']['mail_notice_time']=$rs_t['Grpalt']['mail_notice_time'];
						$rs[$key][0]['Grpalt']['popup'] =$rs_t['Grpalt']['popup'];
						$rs[$key][0]['Grpalt']['mail_notice'] =$rs_t['Grpalt']['mail_notice'];
						$rs[$key][0]['Grpalt']['receive'] =$rs_t['Grpalt']['receive'];
					}
				}
			}
		}
		return	$rs;
	}

	function trans_r($result){
		$group_name=array();
		$rs=array();
		$group_name=set :: extract($result, '{n}.Group.group_name');

		$c=count($group_name);
		for($i=0;$i<$c;$i++){
			if(!isset($group_name[$i])) {
				$group_name[$i] = 0;
			}
			if (!isset($rs[$group_name[$i]])) {
				$rs[$group_name[$i]] = array();
			}
			$rs[$group_name[$i]][]=$result[$i];
		}
		return  $rs;
	}

	/*
	************************* index_del **************************************

	*/
	function index_del(){
		$this->layout='ajax';
		if(isset($this->data['Group']['groupid'])){
			$group_id=$this->data['Group']['groupid'];
			$g_new = array();
			$h_new = array();
			$errorMessage['error_upcast_alert']=array();

			foreach ($group_id as $rs_group_id){
				if(empty($errorMessage['error_upcast_alert'])){
					$g_new[]=$rs_group_id;
					//echo "group-id:".$rs_group_id;
					$this->Grpaltsvc->deleteAll(array("group_id=$rs_group_id"));
					$this->Grpalt->deleteAll(array("group_id=$rs_group_id","type=7"));
					if(isset($this->data['Hstaltsvc']['hostid'.$rs_group_id])){
						
						$word_id = $this->data['Hstaltsvc']['hostid'.$rs_group_id];
						foreach ($word_id as $check){
							$h_new[]=$check;
							$this->Hstaltsvc->deleteAll(array("host_id=".$check));

						}
					}
				}
				//sunhy    start  2009/07/25 modify for JL-0035
    				$this->MailPopupController->delAltMsg("E0005", $rs_group_id);
    				$this->MailPopupController->delAltTit(7, $rs_group_id);
    				//sunhy    end  2009/07/25 modify for JL-0035	
				//sunhy start 2009/05/21 added for YB-32
				$this->GenerateFiles->hook_by_group($rs_group_id, array('service'));
				//sunhy end 2009/05/21 added for YB-32				
			}
			if(!empty($g_new)){
				//sunhy start 2009/05/21 delete for YB-32
				//$this->GenerateFiles->hook_by_group($g_new, array('service'));
				//sunhy end 2009/05/21 delete for YB-32
			}
		}
		else{
			$errorMessage['index_del']=array();
			if(!(in_array('E-00200',$errorMessage['index_del']))){
				$errorMessage['index_del'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		$this->index();
		$this->render('index');
		exit();
	}

	/*

	*************************   the second page's del**************************************

	*/

	function svc_set_del(){
		$group_id=$this->data['Group']['group_id'];
		$errorMessage['svc_set_del']=array();
		$hostid=array();
		if(isset($this->data['Group']['id'])){
			$word_id = $this->data['Group']['id'];
			foreach ($word_id as $check){
				$str=substr($check,0,3);
				$check1=substr($check,3);

				if($str=='grp'){
					$this->Grpaltsvc->del($check1);
				}
				if($str=='hst'){
					$hostid[]=$this->data['Host']['id'.$check1];
					$this->Hstaltsvc->del($check1);
				}
				$this->GenerateFiles->hook_by_group($group_id, array('service'));
			}
		}
		else{			
			if(!(in_array('E-00200',$errorMessage['svc_set_del']))){
				$errorMessage['svc_set_del'] = array('E-00200');
				$this->set('err', $errorMessage);
			}
		}
		//xinw start 20090209
		//modify for ASP4-031
		//$this->svc_alert_set($this->data['Group']['group_id']);
		//sunhy start 2009/03/30 modify for JLN-001
		//$this->svc_alert_set($this->data['Group']['group_id'],'nodo');
		$this->alert_set($this->data['Group']['group_id'],'nodo');
		//sunhy end 2009/03/30 modify for JLN-001
		//xinw end 20090209
		//sunhy start 2009/03/30 modify for JLN-001
		//$this->render('svc_alert_set');
		$this->render('alert_set');
		//sunhy end 2009/03/30 modify for JLN-001;
		exit();
	}

	/*

	************************************************               the second page                        ********************************************************

	*/
	//xinw start 20090203
	//modify for ASP4-031
	//function svc_alert_set($group_id=null) {
	//sunhy start 2009/03/30 modify for JLN-001
	//function svc_alert_set($group_id=null,$do=null) {
	function alert_set($group_id=null,$do=null) {
	//sunhy end 2009/03/30 modify for JLN-001
	//xinw end 20090203
	//xinw start 20090203
	//modify for ASP4-031
	if ($group_id=='null') {
		$group_id=null;		
	}
	//xinw end 20090203
		$this->layout='ajax';
		if($group_id==""){
			$group_id=$this->data['Rltgrpaltsvc']['group'];
		}
		$glist=array();
		$glist=$this->Grpauth->getParentsByChild($group_id);
		$this->set('glist',$glist);
		$condition = "Group.id=$group_id";
		$rs1 = $this->Group->findAll($condition,null,null,'0',null,null);
		$group_name=$rs1[0]['Group']['group_name'];
		$this->set('group_name',$group_name);
		$this->set('group_id',$group_id);
		//sunhy start 2009/03/30 added for JLN-001
		$getUserGroup = $this->_getUserGroup();
//		$getUserGroup = 1;
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/30 added for JLN-001
		$asso = array(
		"Grpaltsvc:grpaltsvcs" =>array("Grpaltsvc.group_id=Rltgrpaltsvc.org_grp_id","Grpaltsvc.id=Rltgrpaltsvc.alert_id"),
		"Group : groups" => array("Group.id = Grpaltsvc.group_id"),
		);
		$condition=array("Rltgrpaltsvc.group_id=$group_id");
		$result = $this->Rltgrpaltsvc->findByAsso($condition, array('Group.group_name','Group.id','Grpaltsvc.service_name','Grpaltsvc.specification','Grpaltsvc.id','Grpaltsvc.service_status'),null, null, null, $asso);

		$asso_host = array(

		"Host:hosts"=>array("Hstaltsvc.host_id=Host.id"),
		"Rlthstgrp:rlthstgrps"=>array("Host.id=Rlthstgrp.host_id"),
		"Group:groups"=>array("Rlthstgrp.group_id=Group.id"),
		);
		$condition_host=array("Rlthstgrp.group_id in (select grpauths.org_grp_id from grpauths where grpauths.group_id=$group_id)");
		$result_host = $this->Hstaltsvc->findByAsso($condition_host,array('Hstaltsvc.service_name','Group.id','Group.group_name','Host.id','Host.host_name','Hstaltsvc.specification','Hstaltsvc.service_status','Hstaltsvc.id'),null, null, null, $asso_host);
		$host=array();
		if(!empty($result_host)){
			
			$host=$this->trans_r($result_host);			
		}
		$rs=array();
		$this->set('result_host',$host);
		if(!empty($result)){
			
			$rs=$this->trans_r($result);
			
		}
		$this->set('result',$rs);
		//sunhy start 2009/03/30 modify for JLN-001
		//$errorMessage['svc_alert_set']=array();
		$errorMessage['alert_set']=array();
		//sunhy end 2009/03/30 modify for JLN-001
		//xinw start 20090203
		//modify for ASP4-031
		//$this->index_add_sun($group_id);
		$judge=$this->Grpalt->findAll(array('Grpalt.group_id='.$group_id,'Grpalt.type=7'));
		//sunhy start 2009/03/30 modify for JLN-001
		if (empty($judge) && $do=='nodo') {
		//sunhy end 2009/03/30 modify for JLN-001
			
			$this->data['Grpalt']['mail_notice']=1;
			//sunhy start 2009/03/30 modify for JLN-001
			//$this->data['Title']['title_flg']=1;
			//$this->data['Grpalt']['popup']=2;
			$this->data['Grpalt']['popup']=0;
			//$this->data['Altmsg']['detail_flg'] = 1
			/*$titleflg=$this->title_list($this->_getUserGroup());
			$this->data['Title']['title_flg'] = ($titleflg!=1)?1:0;*/
			//sunhy start 2009/05/21 modify for YBR-32
			//if($this->_getUserGroup() ==1 ){
			
			//$titleflg=$this->title_list($this->_getUserGroup());
			$titleflg=$this->title_list($group_id);
			if($titleflg== 2){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = ($titleflg == 1) ? 0 : 1;
			}
			//$altmsg_list_detail =$this->altmsg_list_detail($this->_getUserGroup());
			$altmsg_list_detail = $this->altmsg_list_detail($group_id);
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
			$msg = $this->MailPopupController->getAltMsg('E0005', $group_id);
			if($msg['Altmsg']['detail_flg']== 0){
				$this->data['Altmsg']['detail_flg'] = 0;
			}
			else{
				$this->data['Altmsg']['detail_flg'] = 1;
				}
			if(empty($msg['Altmsg']['detail_flg'])){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//sunhy end 2009/05/21 modify for YBR-32
			//sunhy start 2009/05/21 delete for YBR-32
			//}
			//else{
			//	$this->data['Altmsg']['detail_flg'] = 1;
			//	$this->data['Title']['title_flg']=1;
			//}
			//sunhy end 2009/05/21 delete for YBR-32

			//sunhy end 2009/03/30 modify for JLN-001
			//sunhy start 2009/05/21 delete for YBR-32
			//$altmsg=$this->Altmsg->findAll(array("message_id='E0005'"));
			$altmsg=$this->Altmsg->findAll(array("message_id='E0005'","Altmsg.group_id=".$group_id));
			//sunhy end 2009/05/21 delete for YBR-32
			//sunhy start 2009/04/23 modify for JLN-001
			//$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			if(!empty($altmsg[0]['Altmsg']['message'])){
				$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			}else{
				$this->data['Altmsg']['message']=__('E0005',$return = true);
			}
			//sunhy end 2009/04/23 modify for JLN-001
			$email = $this->_getemail($group_id);
			$this->set('email',$email);
		}else 
		{
			
			$this->index_add_sun($group_id);
		}
		//xinw end 20090203
	}
	/*

	サービス別表示

	*/
	function svclist($group_id=null) {
		$this->layout='ajax';

		$svc_name="";
		$svc_spec="";	
		$errormessage['svclist']=array();
		if(!($this->Validation->maxLength($this->data['Uselgcsvc']['svc_name'],200))||!($this->Validation->maxLength($this->data['Uselgcsvc']['svc_spec'],2000))){
			if(!(in_array('E-00300',$errorMessage['virus_soft_name']))){
				$errorMessage['svclist'][] = array('E-00300');
				$this->set('errorMessage', $errorMessage);
			}
		}
		if(empty($errorMessage['svclist'])){
			$condition=array("1=1");

			if($this->data['Uselgcsvc']['svc_name']!=""){
				$svc_name=$this->data['Uselgcsvc']['svc_name'];
				//xinw start 20080221
				$condition[]="lower(Uselgcsvc.service_name) like '%".strtolower($this->Lv->spec_char_like($svc_name))."%'";
				//xinw end 20080221
			}
			if($this->data['Uselgcsvc']['svc_spec']!=""){
				$svc_spec=$this->data['Uselgcsvc']['svc_spec'];
				//xinw start 20080221
				$condition[]="lower(Uselgcsvc.specification) like '%".strtolower($this->Lv->spec_char_like($svc_spec))."%'";
				//xinw end 20080221
			}

			$this->set('hdsvc_name',$svc_name);
			$this->set('hdsvc_spec',$svc_spec);

			if($group_id!==""){
				$condition1 = "Group.id=$group_id";
				$rs1 = $this->Group->findAll($condition1,null,null,'0',null,null);
				$group_name=$rs1[0]['Group']['group_name'];
			}
			elseif(($group_id=="") and (isset($this->data['Group']['group']))){
				$group_id=$this->data['Group']['group'];
				$group_name =$this->data['Group']['group_name'];
			}
			$this->set('group_id',$group_id);
			$this->set('group_name',$group_name);
			
			$glist = $this->Grpauth->getParentsByChild($group_id);
			ksort($glist);
			$glist_key=array_keys($glist);

			$asso=array(
				"Rlthstgrp:rlthstgrps"=>array("Rlthstgrp.host_id=Uselgcsvc.host_id"),
				"Host:hosts"=>array("Host.id=Rlthstgrp.host_id"),
				'Grpauth : grpauths' => array('Grpauth.group_id = Rlthstgrp.group_id'),			
			);
			$condition[]="Grpauth.org_grp_id=$group_id";
			$condition['group by']="Uselgcsvc.service_name,Uselgcsvc.specification";
			$condition[]="Uselgcsvc.service_name not in (SELECT Grpaltsvc.service_name AS Grpaltsvc__service_name FROM grpaltsvcs AS Grpaltsvc WHERE Grpaltsvc.group_id in (". implode(",", $glist_key) .") )";
			list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'svclist', 'url'=>'/system_grpset_alert_services/svclist', 'modelClass'=>'Uselgcsvc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'sortBy' => $this->Lv->sortBy('UPPER(Uselgcsvc.service_name)'), 'ajaxFormId'=>'form1'));
			$result=$this->Uselgcsvc->findByAsso($condition,array("Uselgcsvc.service_name","Uselgcsvc.specification"),$order, $limit, $page, $asso);
			$this->set('result',$result);
		}
		//sunhy start 2009/07/15 modify for YB-41
		if($group_id!==""){
			$condition1 = "Group.id=$group_id";
			$rs1 = $this->Group->findAll($condition1,null,null,'0',null,null);
			$group_name=$rs1[0]['Group']['group_name'];
		}
		elseif(($group_id=="") and (isset($this->data['Group']['group']))){
			$group_id=$this->data['Group']['group'];
			$group_name =$this->data['Group']['group_name'];
		}
		$this->set('group_id',$group_id);
		$this->set('group_name',$group_name);
		//sunhy end 2009/07/15 modify for YB-41
	}
	/*

	クライアントPC別表示

	*/
	function pclist($group_id=null) {
		$this->layout='ajax';
		$host_name="";
		$svc_name="";
		$svc_spec="";

		$errormessage['pclist']=array();
		if(!($this->Validation->maxLength($this->data['Uselgcsvc']['svc_name'],200))||!($this->Validation->maxLength($this->data['Uselgcsvc']['svc_spec'],2000))||!($this->Validation->maxLength($this->data['Uselgcsvc']['host_name'],127))){
			if(!(in_array('E-00300',$errorMessage['pclist']))){
				$errorMessage['pclist'][] = array('E-00300');
				$this->set('errorMessage', $errorMessage);
			}
		}
		if(empty($errormessage['pclist'])){
			$condition=array("1=1");
			if($this->data['Uselgcsvc']['host_name']!=""){
				$host_name=$this->data['Uselgcsvc']['host_name'];
				//xinw start 20080221
				//sunhy start 2009/03/30 modify for JLN-001
				//$condition[]="lower(Host.host_name) like '%".strtolower($host_name)."%'";
				$condition = $this->AlertPcController->search_judge("Host", "host_name", strtolower($this->Lv->spec_char_like($host_name)), $condition);
				//sunhy end 2009/03/30 modify for JLN-001
				//xinw end 20080221
			}
			if($this->data['Uselgcsvc']['svc_name']!=""){
				$svc_name=$this->data['Uselgcsvc']['svc_name'];
				//xinw start 20080221
				//sunhy start 2009/03/30 modify for JLN-001
				//$condition[]="lower(Uselgcsvc.service_name) like '%".strtolower($svc_name)."%'";
				$condition = $this->AlertPcController->search_judge("Uselgcsvc", "service_name", strtolower($this->Lv->spec_char_like($svc_name)), $condition);
				//sunhy end 2009/03/30 modify for JLN-001
				//xinw end 20080221
			}
			if($this->data['Uselgcsvc']['svc_spec']!=""){
				$svc_spec=$this->data['Uselgcsvc']['svc_spec'];
				//xinw start 20080221
				//sunhy start 2009/03/30 modify for JLN-001
				//$condition[]="lower(Uselgcsvc.specification) like '%".strtolower($svc_spec)."%'";
				$condition = $this->AlertPcController->search_judge("Uselgcsvc", "specification", strtolower($this->Lv->spec_char_like($svc_spec)), $condition);
				//sunhy end 2009/03/30 modify for JLN-001
				//xinw end 20080221
			}

			$this->set('hdhost_name',$host_name);
			$this->set('hdsvc_name',$svc_name);
			$this->set('hdsvc_spec',$svc_spec);

			if($group_id!==""){
				//sunhy start 2009/03/30 modify for JLN-001
				/*$condition1 = "Group.id=$group_id";
				$rs1 = $this->Group->findAll($condition1,null,null,'0',null,null);
				$group_name=$rs1[0]['Group']['group_name'];*/
				$group = $this->AlertPcController->get_group($group_id);
				//$group_name=$group[0]['Group']['group_name'];
				//echo debug($group, 2);
				$group_name = $group['Group']['group_name'];
				//sunhy end 2009/03/30 modify for JLN-001
			}
			elseif(($group_id=="") and (isset($this->data['Group']['group']))){
				$group_id=$this->data['Group']['group'];
				$group_name =$this->data['Group']['group_name'];
			}
			$this->set('group_id',$group_id);
			$this->set('group_name',$group_name);
		$glist = $this->Grpauth->getParentsByChild($group_id);
		ksort($glist);
		$glist_key=array_keys($glist);

			$asso=array(
				"Rlthstgrp:rlthstgrps"=>array("Rlthstgrp.host_id=Uselgcsvc.host_id"),
				"Host:hosts"=>array("Host.id=Rlthstgrp.host_id"),
				'Grpauth : grpauths' => array('Grpauth.group_id = Rlthstgrp.group_id'),		
			);
			$condition[]="Grpauth.org_grp_id=$group_id";
			$condition[]="Uselgcsvc.service_name not in (SELECT Grpaltsvc.service_name AS Grpaltsvc__service_name FROM grpaltsvcs AS Grpaltsvc  WHERE Grpaltsvc.group_id in (". implode(",", $glist_key) .") )";
			$condition[]="Uselgcsvc.service_name not in (select Hstaltsvc.service_name  from hstaltsvcs as Hstaltsvc where Hstaltsvc.host_id=Uselgcsvc.host_id )";
			$condition1 = null;
	    		$child_list = $this->Grpauth->getChildrenByParent($group_id);    
	    		//sunhy start 2009/03/30 modify for JLN-001		
	    		/*if (!empty($child_list)){
		      		foreach ($child_list as $key=>$list){
		     			if($key<>$group_id){
		     				$condition1 = $condition1."Grpaltsvc.group_id = $key or ";
		     			}
		    		}      			
	    		}
	    		$condition1 = substr($condition1,0,-3);
	    		$condition1 = $condition1."GROUP BY Grpaltsvc.service_name,,Grpaltsvc.group_id";
	    		$check_child = $this->Grpaltsvc->findAll($condition1,'Grpaltsvc.group_id,Grpaltsvc.service_name'); 
			if (!empty($check_child)){
				foreach ($check_child as $value_child){
				         $grp_child = $value_child['Grpaltsvc']['group_id'];
				         $lim_hid = $this->Rlthstgrp->findAll(array("Rlthstgrp.group_id" => $grp_child),"Rlthstgrp.host_id");
				         foreach ($lim_hid as $out_hid){
				         	$se_hid = $out_hid['Rlthstgrp']['host_id'];
				         	$condition[] = "(Uselgcsvc.service_name <> '".$value_child['Grpaltsvc']['service_name']."' or Uselgcsvc.host_id <> $se_hid)";	
				         }	
				}			
			}	*/	
	    		$condition = $this->AlertPcController->get_child_info($group_id, "Hstaltsvc","service_name", "Rlthstgrp", "host_id", $condition);
	    		//sunhy end 2009/03/30 modify for JLN-001
			$condition['group by']="Uselgcsvc.service_name,Uselgcsvc.specification,Host.host_name,Uselgcsvc.host_id";
			list($order,$limit,$page) = $this->Pagination->init($condition, null, array('ajaxDivUpdate'=>'sub_main', 'url'=>'/system_grpset_alert_services/pclist/'.$group_id, 'modelClass'=>'Uselgcsvc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'sortBy' => $this->Lv->sortBy('UPPER(Host.host_name),UPPER(Uselgcsvc.service_name)'), 'ajaxFormId'=>'form1'));
			$result=$this->Uselgcsvc->findByAsso($condition,array("Uselgcsvc.service_name","Uselgcsvc.specification","Host.host_name","Uselgcsvc.host_id"),$order, $limit, $page, $asso);
			$this->set('result',$result);
		}
	}
	/*
	*クライアントPC別表示
	削除する

	*/
	function pc_del(){
		$this->layout='ajax';
		if(isset($this->data['Uselgcsvc']['usesvc_id'])){
			$word_id=$this->data['Uselgcsvc']['usesvc_id'];
			$host_id=array();
			foreach ($word_id as $check){
				$this->Uselgcsvc->del($check);
				$host_id[]=$this->data['Uselgcsvc']['host_id_'.$check];
			}
			//sunhy start 2009/05/21 modify for YBR-32
			//$this->GenerateFiles->hook_by_host($host_id, array('service'));
			$this->GenerateFiles->hook_by_host($host_id, array('service'), $this->data['Rltgrpaltsvc']['group']);
			//sunhy end 2009/05/21 modify for YBR-32
		}
		else{
			$errorMessage['pc_del']=array();
			if(!(in_array('E-00200',$errorMessage['pc_del']))){
				$errorMessage['pc_del'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		$this->pclist($this->data['Group']['group']);
		$this->render('pclist');
		exit();
	}

	/* グループ共通の判定 */
	function error_judge_grpalt($content = null,$name2){
		if(empty($content)){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!empty($content)){
			if(!$this->Validation->maxLength($content,2000)){
				$errorMessage[$name2][] = 'E-00300';
			}
		}

		return $errorMessage;
	}

	/*
	*クライアントPC別表示

	ルールに追加する

	*/
	function add_pc_rule(){
		$group_id=$this->data['Group']['group'];
		$errorMessage['add_pc_rule']=array();
		if(isset($this->data['Uselgcsvc']['usesvc_id'])){
			$word_id = $this->data['Uselgcsvc']['usesvc_id'];
			$host_id=array();
			foreach ($word_id as $check){	
					$host_id[]=$this->data['Uselgcsvc']['host_id_'.$check];
					$insertdate=Array(
						'Hstaltsvc' => Array(
						'host_id'=>$this->data['Uselgcsvc']['host_id_'.$check],
						'service_name' => $this->data['Uselgcsvc']['svc_name_'.$check],
						'specification'=> $this->data['Uselgcsvc']['svc_spec_'.$check],
						'service_status'=> $this->data['Uselgcsvc']['status_'.$check],
						)
					);
					$this->Hstaltsvc->save($insertdate);
					$this->set('flag',1);
					$host = $this->data['Uselgcsvc']['host_id_'.$check];
					$condition_findgrp = "Rlthstgrp.host_id = $host";
					$group = $this->Rlthstgrp->find($condition_findgrp);
					$group_findalt = $group['Rlthstgrp']['group_id'];
			    		$condition = "Grpalt.group_id = $group_findalt AND Grpalt.type = 7";
			    		$value = $this->Grpalt->find($condition);   
			    		if (!$value){
						 //sunhy start 2009/03/25 modify for JLN-001
						/*$add_alt = array(
							'Grpalt' => Array(
							'group_id' => $group_findalt,
							'mail_notice' =>1,
							'mail_notice_time' => '00',
							'popup' =>0,
							'up_cast' =>1,
							'receive'=>1,
							'type' =>7,
							)					
						); 
						$this->Grpalt->save($add_alt);*/
						$this->MailPopupController->setMailPop(null, $group_findalt, 1, '00', 0, 1, 1, 7, 'Grpalt');
						//sunhy end 2009/03/25 modify for JLN-001    			
			    		}
			    		//sunhy start 2009/05/22 added for YBR-32
			    		$this->data['Uselgcsvc']['status_'.$check] = 1;	    
			    		//sunhy end 2009/05/22 added for YBR-32		    		
			}		    						
		}
		else{
			if(!(in_array('E-00200',$errorMessage['add_pc_rule']))){
				$errorMessage['add_pc_rule'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		if(empty($errorMessage['add_pc_rule']) and !empty($host_id)){
			//sunhy start 2009/05/21 modify for YBR-32
			//$this->GenerateFiles->hook_by_host($host_id, array('service'));
			$this->GenerateFiles->hook_by_host($host_id, array('service'), $group_id);
			//sunhy end 2009/05/21 modify for YBR-32
		}
		$this->pclist($this->data['Group']['group']);
		$this->render('pclist');
		exit();
	}

	/*
	*サービス別表示

	削除する

	*/
	function add_svc_rule(){
		$group_id=$this->data['Group']['group'];
		$errorMessage['add_svc_rule']=array();
		if(isset($this->data['Uselgcsvc']['usesvc_id'])){			
			foreach ($this->data['Uselgcsvc']['usesvc_id'] as $check){	
				$svc_name=$this->data['Uselgcsvc']['svc_name_'.$check];					
				$children = $this->Grpauth->getChildrenByParent($group_id);
				foreach ($children as $grp_id=>$grp_name){
					$condition_hst = array("Rlthstgrp.group_id = $grp_id and Hstaltsvc.service_name = '".$svc_name."'");
					$asso = array(			
							'Host : hosts' => array('Hstaltsvc.host_id = Host.id'),
							'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),	
					);
					$hst_del = $this->Hstaltsvc->findByAsso($condition_hst,array('Hstaltsvc.id as Hstaltsvc__id,Hstaltsvc.host_id as Hstaltsvc__host_id'),null,null,null,$asso);
					if (!empty($hst_del)){					
						$error = 1;	
					}									
					$condition_grp = array("Grpaltsvc.group_id = $grp_id and Grpaltsvc.service_name = '".$svc_name."'");					
					$grp_del = $this->Grpaltsvc->findAll($condition_grp);
					if (!empty($grp_del)){				
						$error = 1;	
					}										
				}
			}			
			if (isset($error)){		
				$errorMessage['add_svc_rule'][] = 'E-02400';
		    		$this->set('errorMessage',$errorMessage);     										
			}
			else {
				foreach ($this->data['Uselgcsvc']['usesvc_id'] as $id){
					$insertdate=Array(
						'Grpaltsvc' => Array(
						'group_id'=>$group_id,
						'service_name' => $this->data['Uselgcsvc']['svc_name_'.$id],
						'specification'=> $this->data['Uselgcsvc']['svc_spec_'.$id],
						'service_status'=> $this->data['Uselgcsvc']['status_'.$id],
						)
					);
					$this->Grpaltsvc->save($insertdate);
					$alert_id = $this->Grpaltsvc->getLastInsertID();
					$glist = $this->Grpauth->getChildrenByParent($group_id);
					foreach ($glist as $key=>$value){
						$insertdate=Array(
							'Rltgrpaltsvc' => Array(
							'group_id' => $key,
							'alert_id' =>  $alert_id,
							'org_grp_id' => $group_id,
							)
						);
						$this->Rltgrpaltsvc->save($insertdate);
					}
					//sunhy start 2009/05/22 added for YBR-32
					$this->data['Uselgcsvc']['status_'.$id] = 1;	
					//sunhy end 2009/05/22 added for YBR-32					
				}
				//xinw start 20090203
				//modify for ASP4-031
				$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 7";
			    $value = $this->Grpalt->find($condition);   
			    if (!$value){
				//sunhy start 2009/03/25 modify for JLN-001
				/*$add_alt = array(
					'Grpalt' => Array(
					'group_id' => $group_id,
					'mail_notice' =>1,
					'mail_notice_time' => '00',
					'popup' =>0,
					'up_cast' =>1,
					'receive'=>1,
					'type' =>7,
					)					
				);  
				$this->Grpalt->save($add_alt);*/
				$this->MailPopupController->setMailPop(null, $group_id, 1, '00', 0, 1, 1, 7, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001	    				    			
			    }
				//xinw end 20090203
				$this->GenerateFiles->hook_by_group($group_id, array('service'));
			}			
		}
		else{
			$errorMessage['add_svc_rule'] = array('E-00200');
			$this->set('errorMessage', $errorMessage);
		}
		$this->svclist($this->data['Group']['group']);
		$this->render('svclist');
		exit();
	}
	/*
	*サービス別表示

	ルールに追加する

	*/
	function svc_del(){
		if(isset($this->data['Uselgcsvc']['usesvc_id'])){
			$word_id=$this->data['Uselgcsvc']['usesvc_id'];
			foreach ($word_id as $check){
				$this->Uselgcsvc->del($check);
			}
			$this->GenerateFiles->hook_by_group($this->data['Group']['group'], array('service'));
		}
		else{
			$errorMessage['svc_del']=array();
			if(!(in_array('E-00200',$errorMessage['svc_del']))){
				$errorMessage['svc_del'] = array('E-00200');
				$this->set('errorMessage', $errorMessage);
			}
		}
		$this->svclist($this->data['Group']['group']);
		$this->render('svclist');
		exit();
	}
	/*
	************************* grpalt_list **************************************

	*/
	function grpalt_list($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=7 ";
		$grpalt = $this->Grpalt->findAll($condition);
		return $grpalt;

	}
	function _getemail($group_id){
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		return $data_email;

	}
	/**
     *  上位グループの設定 
     * 
     * */
	function index_add_sun($group_id){
		$this->layout='ajax';
		$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,7);
		$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		//上位グループの設定を引き継ぐ
		if(@$this->data["Grpaltsvc"]["svcalt_flag"] != 1) {
			if($grpalt_f == 1){  
				$grpalt_r = $this->grpalt_list($group_id);
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				$this->data['Grpalt']['receive'] = ($grpalt_r[0]['Grpalt']['receive']==0?1:0);
				//sunhy start 2009/03/30 modify for JLN-001
				//$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:0;
				//sunhy end 2009/03/30 modify for JLN-001
				$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
				$this->set('mail_notice_time_c',$mail_notice_time_c);
			}else{ 

				$this->data['Grpalt']['mail_notice'] = 1;
				//sunhy start 2009/03/30 modify for JLN-001
				//$this->data['Grpalt']['popup'] = 2;
				$this->data['Grpalt']['popup'] = 0;
				//sunhy end 2009/03/30 modify for JLN-001
				$mail_notice_time_c = '00';
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$up_cast_flag = 1;
				$this->data['Grpalt']['receive']=0;

				//sunhy     start      2009/07/15   modify for YBR-41
				//$this->add_grpalt($group_id,1);
				//sunhy     end      2009/07/15   modify for YBR-41
			}
			/*  件名管理情報,エラー情報  */
			//sunhy start 2009/05/21 modify for YB-32
			//if($getUserGroup == 1){
			//$title =$this->title_list();
			//$this->data['Title']['title_flg'] = ($title==0?1:0);
			$titleflg=$this->title_list($group_id);
			if($titleflg== 2){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = ($titleflg == 1) ? 0 : 1;
			}
			//sunhy start 2009/05/21 modify for YB-32
			//$altmsg_list =$this->altmsg_list();
			$altmsg_list =$this->altmsg_list($group_id);
			if($altmsg_list==2){
				$this->data['Altmsg']['message']=__('E0005',$return = true);
			}else{
				$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			}
			//$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			//yuanxiaojun end  20090209
				//sunhy start 2009/03/25 modify for JLN-001
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
				
				//sunhy start 2009 /06/26 modify for YBR-35
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?0:1;
				$msg = $this->MailPopupController->getAltMsg('E0005', $group_id);
				if($msg['Altmsg']['detail_flg']== 0){
					$this->data['Altmsg']['detail_flg'] = 0;
				}
				else {
					$this->data['Altmsg']['detail_flg'] = 1;
				}
				if($msg['Altmsg']['detail_flg']== ""){
					$this->data['Altmsg']['detail_flg'] = 1;
				}
				//sunhy end 2009 /06/26 modify for YBR-35
				//sunhy end 2009/03/25 modify for JLN-001
				//sunhy start 2009/05/21 delete for YB-32
			//$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			//sunhy end 2009/05/21 delete for YB-32
			//sunhy start 2009/05/21 modify for YB-32
			//}
			//sunhy end 2009/05/21 modify for YB-32
		}

		$group_email = $this->_getemail($group_id);
		//sunhy start 2009/03/30 modify for JLN-001
		//$this->set('group_email',$group_email);
		$this->set('email',$group_email);
		//sunhy end 2009/03/30 modify for JLN-001
		/* 追加　*/
		if(@$this->data["Grpaltsvc"]["svcalt_flag"] == 1) {
				$getUserGroup = $this->_getUserGroup();
				//sunhy start 2009/05/21 delete for YB-32
				//if($getUserGroup == 1){
				//sunhy start 2009/05/21 delete for YB-32
					@$Grpaltcontent = $this->data["Altmsg"]["message"];
					@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');
					if(!count($result_content) == 0){
						$errorMessage =$result_content;
						if(!empty($result_content)){
							$this->set('errorMessage',$errorMessage);
						}
						//sunhy start 2009/05/21 modify for YB-32
						//$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
						isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c='00';
						//sunhy end 2009/05/21 modify for YB-32
						$this->set('mail_notice_time_c',$mail_notice_time_c);
					}
				//sunhy start 2009/05/21 delete for YB-32
				//}
				//sunhy end 2009/05/21 delete for YB-32
			if(!empty($errorMessage)){					
					//sunhy start 2009/05/21 modify for YB-32
					//$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
					isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c='00';
					//sunhy end 2009/05/21 modify for YB-32
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				//sunhy start 2009/03/30 modify for JLN-001
				//$this->render('svc_alert_set');
				$this->render('alert_set');
				//sunhy end 2009/03/30 modify for JLN-001
				exit();
			}
			if(empty($errorMessage)){
				if(isset($this->data['Grpalt']['mail_notice_time_hour'])){
					$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
				}else{
					$mail_notice_time_c ='00';
				}
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->add_grpalt($group_id,1);
				$this->index();
				$this->render('index');
				exit();
			}
		}
	}
	/* 件名管理情報  start*/
	//sunhy start 2009/05/21 modify for YB-32
	//function title_flag(){
	function title_flag($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Title.group_id=$group_id";
		//$condition =" Title.type=7 ";
		$condition[] =" Title.type=7 ";
		//sunhy end 2009/05/21 modify for YB-32
		$title = $this->Title->findAll($condition);
		if(count($title) == 1){
			$flag = $title[0]['Title']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	////sunhy start 2009/05/21 modify for YB-32
	function altmsg_flag($group_id=null){
		//function altmsg_flag(){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Altmsg.group_id=$group_id";
		//$condition =" Altmsg.message_id='E0005' ";
		$condition[] =" Altmsg.message_id='E0005' ";
		////sunhy end 2009/05/21 modify for YB-32
		$altmsg = $this->Altmsg->findAll($condition);
		if(count($altmsg) == 1){
			$flag = $altmsg[0]['Altmsg']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	////sunhy start 2009/05/21 modify for YB-32
	//function title_list(){
	function title_list($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Title.group_id=$group_id";
		//$condition =" Title.type=7 ";
		$condition[] =" Title.type=7 ";
		////sunhy end 2009/05/21 modify for YB-32
		$title = $this->Title->findAll($condition);
		if(count($title) == 1){
			$flag = $title[0]['Title']['title_flg'];
		}else{
			$flag =2;
		}
		return $flag;
	}
	//sunhy start 2009/05/21 modify for YB-32
	//function altmsg_list(){
	function altmsg_list($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] =" Altmsg.group_id=$group_id";
		//$condition =" Altmsg.message_id='E0005' ";
		$condition[] =" Altmsg.message_id='E0005' ";
		//sunhy end 2009/05/21 modify for YB-32
		$altmsg = $this->Altmsg->findAll($condition);
		if(count($altmsg) == 1){
			$array = $altmsg;
		}else{
			//sunhy start 2009/05/21 modify for YB-32
			//$array = 0;
			$array = 2;
			//sunhy end 2009/05/21 modify for YB-32
		}
		return $array;
	}
	function grpalt_list_id($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=7 ";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalt"]["id"];
		}else{
			$id =0;
		}
		return $id;
	}
	/*  編集グループ共通 */
	function edit_grpalt($group_id,$checkbox_flag){
		$grpalt_id = $this->grpalt_list_id($group_id);
		if($checkbox_flag == 1) {
			if($this->data["Grpalt"]["popup"] == 1){
				$popup = 1;
			}else{
				$popup = 0;
			}
			if($this->data["Grpalt"]["mail_notice"] == 2){
				$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
			}else{
				$mail_notice_time = '00:00:00';
			}
			if(isset($this->data["Grpalt"]["mail_notice"])){
				//echo "hsh";
				//sunhy start 2009/03/25 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'id' => $grpalt_id,
				'group_id' => $group_id,
				'mail_notice' => $this->data["Grpalt"]["mail_notice"],
				'mail_notice_time' => @$mail_notice_time,
				'popup' =>$popup,
				'receive'=>($this->data['Grpalt']['receive']==1?0:1),
				'type'=>7,
				'up_cast' => 1,
				));
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, $popup, 1, $this->data['Grpalt']['receive']==1?0:1, 7, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001
				//sunhy start 2009/05/21 modify for YB-32
				//				if($getUserGroup == 1){
				//					$re_title =$this->title_flag();
				//					$this->editTitle($re_title);
				//					$re_msg =$this->altmsg_flag();
				//					$this->editAltmsg($re_msg);
				//				}
				$re_title =$this->title_flag($group_id);
				if($re_title == 0){
					$this->addTitle($group_id);
				}else{
					$this->editTitle($re_title,$group_id);
				}
				$re_msg =$this->altmsg_flag($group_id);
				if($re_msg == 0){
					$this->addAltmsg($group_id);
				}else{
					$this->editAltmsg($re_msg,$group_id);
				}
				//sunhy end 2009/05/21 modify for YB-32
				//sunhy start 2009/05/21 modify for YB-32
				//$this->GenerateFiles->hook_by_ps(0, array("service", "popup"));
				$this->GenerateFiles->hook_by_group($group_id, array("service", "popup"));
				//sunhy end 2009/05/21 modify for YB-32
				$getUserGroup = $this->_getUserGroup();
			}
		}
	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/21 modify for YB-32
	//function addTitle(){
	function addTitle($group_id=null){
		if(empty($group_id)){
			$group_id=1;
		}
		//sunhy end 2009/05/21 modify for YB-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'title_flg' => $title_flg,
		'type' => 7,
		//sunhy start 2009/05/21 modify for YB-32
		'group_id'=>$group_id,
		//sunhy end 2009/05/21 modify for YB-32
		));
		$this->Title->save($inserttitle);
		//sunhy start 2009/05/21 modify for YB-32
		//$this->GenerateFiles->hook_by_ps(0, array("service", "popup"));
		//sunhy end 2009/05/21 modify for YB-32
	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/21 modify for YB-32
	//function editTitle($id){
	function editTitle($id,$group_id=null){
		if(empty($group_id)){
			$group_id=1;
		}
		//sunhy end 2009/05/21 modify for YB-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'id'=>$id,
		'title_flg' => $title_flg,
		'type' => 7,
		//sunhy start 2009/05/21 modify for YB-32
		'group_id'=>$group_id,
		//sunhy end 2009/05/21 modify for YB-32
		));
		$this->Title->save($inserttitle);
		//sunhy start 2009/05/21 modify for YB-32
		//$this->GenerateFiles->hook_by_ps(0, array("service", "popup"));
		//sunhy end 2009/05/21 modify for YB-32	
	}
	/*
	*エラー情報変更
	*/
	//sunhy start 2009/05/21 modify for YB-32
	//function addAltmsg(){
	function addAltmsg($group_id=null){
		if(empty($group_id)){
			$group_id=1;
		}
		//sunhy end 2009/05/21 modify for YB-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/30 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'message_id' => 'E0005',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0005', $message, $detail_flg, null);
		$this->MailPopupController->setAltMsg('E0005', $message, $detail_flg, null, $group_id);
		//sunhy end 2009/05/21 modify for YBR-32
	//sunhy end 2009/03/30 modify for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("service", "popup"));
		//$this->GenerateFiles->hook_by_group($group_id, array("service", "popup"));	
		//sunhy end 2009/05/21 modify for YBR-32		
	}
	/*
	*エラー情報変更
	*/
	//sunhy start 2009/05/21 modify for YBR-32
	//function editAltmsg($id){
	function editAltmsg($id,$group_id=null){
		if(empty($group_id)){
			$group_id=1;
		}
		//sunhy end 2009/05/21 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/30 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'id'=>$id,
		'message_id' => 'E0005',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->MailPopupController->setAltMsg('E0005', $message, $detail_flg, $id);
		$this->MailPopupController->setAltMsg('E0005', $message, $detail_flg, $id, $group_id);
		//sunhy end 2009/05/21 modify for YBR-32
		//sunhy end 2009/03/30 modify for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("service", "popup"));
		//$this->GenerateFiles->hook_by_group($group_id, array("service", "popup"));	
		//sunhy end 2009/05/21 modify for YBR-32		
	}
	/* グループ共通設定テーブルのデータ */
	function add_grpalt($group_id,$checkbox_flag){
		//echo "add_grpalt<br>";
		$getUserGroup = $this->_getUserGroup();
		$grpalt=$this->Grpalt->grpalt_list_flag($group_id,7);
		if($grpalt == 1){
			$this->edit_grpalt($group_id,1);
		}
		else{
			if($checkbox_flag == 1) {
				//sunhy start 2009/03/25 modify for JLN-001
				//$insertgrpalt=Array(
				//xinw start 20090203
				//modify for ASP4-031
				/*'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' =>1,
				'mail_notice_time' => '00',
				'popup' =>0,
				'up_cast' =>1,
				'receive'=>1,
				'type' =>7,
				)*/
				/*'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' =>$this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => '00',
				'popup' =>($this->data["Grpalt"]["popup"] == 1)?1:0,
				'up_cast' =>1,
				'receive'=>($this->data["Grpalt"]["receive"] == 1)?0:1,
				'type' =>7,
				)
				
				//xinw end 20090203
				);*/
				//$this->Grpalt->save($insertgrpalt);
				$this->MailPopupController->setMailPop(null, $group_id, $this->data['Grpalt']['mail_notice'], '00', ($this->data["Grpalt"]["popup"] == 1)?1:0, 1, ($this->data["Grpalt"]["receive"] == 1)?0:1, 7, 'Grpalt');
				//sunhy end 2009/03/25 modify for JLN-001	
				//modify for ASP4-031
				//sunhy start 2009/05/21 modify for YBR-32
				//$re_msg =$this->altmsg_flag();
				//$this->editAltmsg($re_msg);
				$re_title =$this->title_flag($group_id);
				if($re_title == 0){
					$this->addTitle($group_id);
				}else{
					$this->editTitle($re_title,$group_id);
				}
				$re_msg =$this->altmsg_flag($group_id);
				if($re_msg == 0){
					$this->addAltmsg($group_id);
				}else{
					$this->editAltmsg($re_msg,$group_id);
				}
				//sunhy end 2009/05/21 modify for YBR-32
				//xinw end 20090203
				//sunhy start 2009/05/21 modify for YBR-32
				//$this->GenerateFiles->hook_by_ps(0, array("service", "popup"));	
				$this->GenerateFiles->hook_by_group($group_id, array("service", "popup"));	
				//sunhy end 2009/05/21 modify for YBR-32			
			}
		}
	}
	
	//sunhy start 2009/03/30 modify for JLN-001
	
	 function altmsg_list_detail($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		//sunhy start 2009/05/21 added for YBR-32
		$condition[]=" Altmsg.group_id=$group_id";
		//sunhy end 2009/05/21 added for YBR-32
		$condition[] =" Altmsg.message_id='E0005' ";
		
		$altmsg = $this->Altmsg->findAll($condition);
	
		if(count($altmsg) == 1){
			$array = $altmsg[0]["Altmsg"]["detail_flg"];
		}else{
			$array = 2;
		}
		return $array;
	}
//sunhy start 2009/03/30 modify for JLN-001
}

