<?php
/*********************************************************************
*@filename system_grpset_apps_controller
*@description
*@note
*@histories  rivision	author		date		 comment
*               2.0        sunhy        2009/05/05     modify for YBR-33
*            2.0        yaozl        2009/09/21   modify for JL-0040
********************************************************************/
class SystemGrpsetAppsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Rltgrpapp', 'Grpapp','Installation', 'Configure','Grpauth','Validation','Astsfw','Host','Rlthstgrp');
	var $layout='system';
	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);

		if(isset($_POST['forHideVar1']))
		{
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar']))
		{
			$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	function _getUserGroup_id(){
		//return 2;
	   return $this->_getUserGroup();
	}
	function index($f=null)
	{
		$title = __('title',$return = true); 	 	 
    	$this->pageTitle = $title;
		if($f==1)
	    {
		$this->layout='ajax';
	    }
	    $lists= $this->requestAction('/system_grpset_apps/lists',array('return'));
		$this->set('lists',$lists);
	}
	function lists($do=null)
	{
		$this->layout='ajax';
		$group_id = $this->_getUserGroup_id();
		
		if($do=='del')
		{
			if(isset($this->data['Grpapp']['id']))
			{
				$word_id  = $this->data['Grpapp']['id'];
				foreach ($word_id as $check)
				{
					$this->Grpapp->del($check);
				}
			}
			else
		    	{
		    		$err[]=__('point list',$return = true)."　".__('E-00200',$return = true);
		    		empty($err) ? null : $this->set('err',$err); 
		    	}
		}
		
		$criteria[]="1=1";
	    $glist = $this->Grpauth->getChildrenByParent($group_id);    
		$condition="";
		foreach($glist as $key => $value){
		    $condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		$asso = array(
		'Rltgrpapp : rltgrpapps' => array(
		'Grpapp.id = Rltgrpapp.app_id'),
		'Group : groups' => array('Group.id = Grpapp.group_id'),
		);
		$data=$this->Grpapp->findByAsso($criteria, array(
		'distinct(Grpapp.id) as Grpapp__id','Grpapp.group_id','Group.id', 'Group.group_name', 'Grpapp.app_name'), 'Grpapp.id DESC', null, 1, $asso);
		$this->set('data',$data);
	}
	function detail($id=null,$grp=null)
	{
		//var_dump(mb_convert_encoding($app, "UTF-8"));
		$this->layout='ajax';
		$criteria[]="Grpapp.id=".$id;
		$gr_app=$this->Grpapp->findAll($criteria);
		$asso = array(
		'Installation : installations' => array('Grpapp.id = Installation.app_id'),
		);
		$data=$this->Grpapp->findByAsso($criteria, array(
		'Grpapp.id','Grpapp.group_id', 'Grpapp.app_name','Installation.disp_name', 'Installation.program_name', 'Installation.version','Installation.vendor'), 'Grpapp.id DESC', null, 1, $asso);
		$grpnm=$this->Group->findAll(array('Group.id' => $grp));
		$app =$gr_app[0]['Grpapp']['app_name'];
		$this->set('data',$data);
		$this->set('id',$id);
		$this->set('grp_name',$grpnm[0]['Group']['group_name']);
		$this->set('app',$app);
		$this->set('grp',$grp);
	}
	//$outs['Grpapp']['id']."/".$outs['Group']['id']."/".$outs['Grpapp']['app_name']
	//function edit($depand=null,$id=null,$grp=null,$app=null)
	function edit($depand=null,$id=null,$grp=null)
	{

		$this->layout='ajax';
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup_id());
		ksort($glist);
		if($id != 0){
				$criteria_app[]="Grpapp.id=".$id;
				$grp_app=$this->Grpapp->findAll($criteria_app);
				$app =$grp_app[0]['Grpapp']['app_name'];
		}
		//echo "app=".$app."<br>";
		$this->set('show',0);
		if($depand=='1')
		{//echo "update<br>";
			/*  変更する */
			if(isset($this->data['Installation']['id']))
			{
				$word_id  = $this->data['Installation']['id'];
				foreach ($word_id as $check)
				{
					$app_id=$this->data['Installation']['app_id'];
					$updid=$this->data['Installation']['id'];
					$upddisp_name=$this->data['Installation']['disp_name_'.$check];
					$updprogram_name=$this->data['Installation']['program_name_'.$check];
					$updversion=$this->data['Installation']['version_'.$check];
					$updvendor=$this->data['Installation']['vendor_'.$check];

					//チェック表示名				
					if(isset($upddisp_name))
						{	
						    if(!$this->Validation->maxLength($upddisp_name,256))
						    	{
						    		$err[]=__('view name',$return = true)."　".__('E-00300',$return = true);
						    	}
						}
					$err_disp_name = $this->Lv->is_empty($upddisp_name);
					if($err_disp_name)
				    {
					    	$err[]=__('view name',$return = true)."　".__('E-00100',$return = true); 
					    	
				    }
				    
				    //チェックアプリケーション名						
			    	if(isset($updprogram_name))
			    	{
						if(!$this->Validation->maxLength($updprogram_name,256))
				            {
				                $err[]=__('application_name',$return = true)."　".__('E-00300',$return = true); 		            	
				            }
				            //xinw start 20080709
				        /*if(!$this->Check->checkAllHalf($updprogram_name))
				            {
				                $err[]=__('application_name',$return = true)."　".__('E-00400',$return = true); 		            	
				            }*/
				            //xinw end 20080709
				    }
					
				    $err_program_name = $this->Lv->is_empty($updprogram_name);
				    if($err_program_name)
				    {
					    	$err[]=__('application_name',$return = true)."　".__('E-00100',$return = true); 
					}

			    	if(isset($updversion))
			    	{
						if(!$this->Validation->maxLength($updversion,256))
				            {
				                $err[]=__('version name',$return = true)."　".__('E-00300',$return = true); 		            	
				            }
				        if(!$this->Check->checkAllHalf($updversion))
				            {
				                $err[]=__('version name',$return = true)."　".__('E-00400',$return = true); 		            	
				            }
				    }
				    
				    $err_version = $this->Lv->is_empty($updversion);	
				    if($err_version)
				    {
				    	$err[]=__('version name',$return = true)."　".__('E-00100',$return = true); 
				    }
				    
				    //チェックベンダー名      
			    	if(isset($updvendor))
			    	{
						if(!$this->Validation->maxLength($updvendor,256))
				            {
				                $err[]=__('vendor name',$return = true)."　".__('E-00300',$return = true); 		            	
				            }
				    }
				    $err_vendor = $this->Lv->is_empty($updvendor);
				    if($err_vendor)
				    {
				    	$err[]=__('vendor name',$return = true)."　".__('E-00100',$return = true); 
				    }
				    $con = "Installation.program_name ='".$this->Lv->spec_char_dbm($updprogram_name)."' and Installation.version ='".$this->Lv->spec_char_dbm($updversion)."' and Installation.vendor ='".$this->Lv->spec_char_dbm($updvendor)."' and Installation.id !=".$check;
				    $re = $this->Installation->findAll($con);
				    if(count($re) >0 ){
				    	$err[]=__('application_name',$return = true)."、".__('version name',$return = true)."、".__('vendor name',$return = true)."　".__('E-01900',$return = true);
				    }
				}
				
				
				$flag_return=0;
				foreach ($word_id as $check){
					$updprogram_name=$this->data['Installation']['program_name_'.$check];
					$updversion=$this->data['Installation']['version_'.$check];
					$updvendor=$this->data['Installation']['vendor_'.$check];
				     $flag=0;
					    foreach ($word_id as $new_id){					
					     if(($check != $new_id) and ($flag ==0) ) {       
						      if ($updprogram_name == $this->data['Installation']['program_name_'.$new_id] and ($updversion==$this->data['Installation']['version_'.$new_id]) and ($updvendor==$this->data['Installation']['vendor_'.$new_id])){
						       $flag=1;
						      }
					     }
					    }
				    if($flag==1){
				    	$flag_return=1;
				    	break;
				    }
				}
				if($flag_return == 1){
					$err[]=__('application_name',$return = true)."、".__('version name',$return = true)."、".__('vendor name',$return = true)."　".__('E-01900',$return = true);
				}
				
				if(empty($err)){
						foreach ($word_id as $check)
						{
							$app_id=$this->data['Installation']['app_id'];
							$updid=$this->data['Installation']['id'];
							$upddisp_name=$this->Lv->spec_char_dbm($this->data['Installation']['disp_name_'.$check]);
							$updprogram_name=$this->Lv->spec_char_dbm($this->data['Installation']['program_name_'.$check]);
							$updversion=$this->Lv->spec_char_dbm($this->data['Installation']['version_'.$check]);
							$updvendor=$this->Lv->spec_char_dbm($this->data['Installation']['vendor_'.$check]);	
							if(!(empty($upddisp_name)&&empty($updprogram_name)&&empty($updversion)&&empty($updvendor)))
							{
								$insertdate=Array(
								'Installation' => Array(
								'id' =>$check,
								'disp_name' =>$upddisp_name,
								'program_name' => $updprogram_name,
								'version' =>$updversion ,
								'vendor' => $updvendor
								)
								);
								$this->Installation->save($insertdate);
							}
							$this->set('checkbox_edit',1);										
						}
				}
			}
			else
		    	{
		    		$err[]=__('point list',$return = true)."　".__('E-00200',$return = true);		    		
		    	}
		}
		elseif($depand=='2')
		{//echo "delete<br>";
			/*  削除する  */
			if(isset($this->data['Installation']['id']))
			{
				$word_id  = $this->data['Installation']['id'];
				foreach ($word_id as $check)
				{
					$this->Installation->del($check);
				}
			}
			else
		    	{
		    		$err[]=__('point list',$return = true)."　".__('E-00200',$return = true);		    		
		    	}
		}
		elseif($depand=='4' || $depand=='')
		{//echo "add edit<br>";
			//$this->set('fg',$app);
			/*  設定する */
			$set_group=isset($this->data['Grpapp']['group'])?$this->data['Grpapp']['group']:null;
			$set_app_name=isset($this->data['Grpapp']['app_name'])?$this->data['Grpapp']['app_name']:null;
/*			if($id != 0){
				$con = "Grpapp.id =".$id;
			}*/
			$con = "Grpapp.group_id =".$this->data['Grpapp']['group']." and Grpapp.app_name ='".$this->Lv->spec_char_dbm($this->data['Grpapp']['app_name'])."' and Grpapp.id !=".$id;
			$result_con = $this->Grpapp->findAll($con);
			if(count($result_con) > 0){
				$idGrpapp = $result_con[0]['Grpapp']['id'];
			}else{
				$idGrpapp = 0;
			}
			if($depand == '4'){

					if(isset($this->data['Grpapp']['app_name']))
						{		 
				            if($this->Validation->blank($this->data['Grpapp']['app_name']))
					    	{
					    		   $err[]=__('app point name',$return = true)."　".__('E-00100',$return = true);
					    	}
						}
					//$re_app_name =$this->Lv->is_empty($set_app_name);
					if($set_app_name != '')
					{
						if(!$this->Validation->maxLength($this->data['Grpapp']['app_name'],256))
				    	{
				    		$err[]=__('app point name',$return = true)."　".__('E-00300',$return = true);
				    	}
				    	if($idGrpapp != 0){
				    		$err[]=__('app point name',$return = true)."　".__('E-01900',$return = true);
				    	}
					    if(empty($err))	
						{//echo "111<br>";
							if($id == 0){
								//echo "add<br>";
									$insertdate=Array(
									'Grpapp' => Array(
									//'id'=>$id,
									'group_id'=>$set_group,
									'app_name' => $this->Lv->spec_char_dbm($set_app_name),
									)
									);	
									$this->Grpapp->save($insertdate);
									$alertId = $this->Grpapp->getLastInsertID();
									$id =$alertId;
									$grp = $set_group;
									$app = $set_app_name;
									$glist_child = $this->Grpauth->getChildrenByParent($set_group);
									ksort($glist_child);
									foreach ($glist_child as $key=>$value) {
										$rltgrpapps=Array(
										'Rltgrpapp' => Array(
										'group_id'=>$key,
										'app_id' =>$alertId,
										'org_grp_id' =>$set_group,
										)
										);
										//debug($rltgrpapps);
										$this->Rltgrpapp->save($rltgrpapps);										
									}
									//echo  __('set_save',$return = true);
							}else{
									//echo "edit<br>";
									$insertdate=Array(
									'Grpapp' => Array(
									'id'=>$id,
									'group_id'=>$set_group,
									'app_name' =>$this->Lv->spec_char_dbm($set_app_name),
									)
									);	
									$this->Grpapp->save($insertdate);
									$grp = $set_group;
									$app = $set_app_name;	
									//echo  __('set_save',$return = true);					
							}
						}
					}
			}			
		 }
		if($depand=='3')
		{//echo "add installation<br>";
			/*  追加する */
			isset($this->data['Installation']['app_id']) ? $app_id=$this->data['Installation']['app_id'] : null;
			$adddisp_name=$this->data['Installation']['add_disp_name'];
			$addprogram_name=$this->data['Installation']['add_program_name'];
			$addversion=$this->data['Installation']['add_version'];
			$addvendor=$this->data['Installation']['add_vendor'];
					$re_add_disp_name =$this->Lv->is_empty($this->data['Installation']['add_disp_name']);
					if($re_add_disp_name)
				    {
					    	$err[]=__('view name',$return = true)."　".__('E-00100',$return = true); 
					    	
				    }			
					if(isset($this->data['Installation']['add_disp_name']))
						{	
						    if(!$this->Validation->maxLength($this->data['Installation']['add_disp_name'],256))
						    	{
						    		$err[]=__('view name',$return = true)."　".__('E-00300',$return = true);
						    	}
						}						
			    	if(isset($this->data['Installation']['add_program_name']))
			    	{
						if(!$this->Validation->maxLength($this->data['Installation']['add_program_name'],256))
				            {
				                $err[]=__('application_name',$return = true)."　".__('E-00300',$return = true); 		            	
				            }
				            //xinw start 20080709
				        /*if(!$this->Check->checkAllHalf($this->data['Installation']['add_program_name']))
				            {
				                $err[]=__('application_name',$return = true)."　".__('E-00400',$return = true); 		            	
				            }*/
				            //xinw end 20080709
				    }
				    $re_add_program_name =$this->Lv->is_empty($this->data['Installation']['add_program_name']);
				    if($re_add_program_name)
				    {
					    	$err[]=__('application_name',$return = true)."　".__('E-00100',$return = true); 
					    	
				    }		    
			    	if(isset($this->data['Installation']['add_version']))
			    	{
						if(!$this->Validation->maxLength($this->data['Installation']['add_version'],256))
				            {
				                $err[]=__('version name',$return = true)."　".__('E-00300',$return = true); 		            	
				            }
				        if(!$this->Check->checkAllHalf($this->data['Installation']['add_version']))
				            {
				                $err[]=__('version name',$return = true)."　".__('E-00400',$return = true); 		            	
				            }
				    }
				    $re_add_version =$this->Lv->is_empty($this->data['Installation']['add_version']);
				    if($re_add_version)
				    {
				    	$err[]=__('version name',$return = true)."　".__('E-00100',$return = true); 
				    }		    
			    	if(isset($this->data['Installation']['add_vendor']))
			    	{
						if(!$this->Validation->maxLength($this->data['Installation']['add_vendor'],256))
				            {
				                $err[]=__('vendor name',$return = true)."　".__('E-00300',$return = true); 		            	
				            }
				    }
				    $re_add_vendor =$this->Lv->is_empty($this->data['Installation']['add_vendor']);
				    if($re_add_vendor)
				    {
				    	$err[]=__('vendor name',$return = true)."　".__('E-00100',$return = true); 
				    }
				    $con = "Installation.program_name ='".$this->Lv->spec_char_dbm($addprogram_name)."' and Installation.version ='".$this->Lv->spec_char_dbm($addversion)."' and Installation.vendor ='".$this->Lv->spec_char_dbm($addvendor)."' and Installation.app_id =".$id;
				    $re = $this->Installation->findAll($con);
				    if(count($re) >0 ){
				    	$err[]=__('application_name',$return = true)."、".__('version name',$return = true)."、".__('vendor name',$return = true)."　".__('E-01900',$return = true);
				    }				    
					if(empty($err))	
					{
						if(($addprogram_name != '')&&($addversion != '')&&($addvendor != '')&&($adddisp_name != '')&&(!empty($id)))
						{
							$insertdate=Array(
							'Installation' => Array(
							'app_id'=>$id,
							'disp_name' =>$this->Lv->spec_char_dbm($adddisp_name),
							'program_name' => $this->Lv->spec_char_dbm($addprogram_name),
							'version' =>$this->Lv->spec_char_dbm($addversion) ,
							'vendor' => $this->Lv->spec_char_dbm($addvendor)
							)
							);
							$this->Installation->save($insertdate);
							$this->data['Installation']['add_disp_name'] = '';
							$this->data['Installation']['add_program_name'] ='';
							$this->data['Installation']['add_version'] ='';
							$this->data['Installation']['add_vendor'] ='';
						}
					}
		}
		if(!empty($id)&&($id != 0)){

				$criteria[]="Grpapp.id=$id";
				$asso = array(
				'Installation : installations' => array(
				'Grpapp.id = Installation.app_id'),
				);
				$data=$this->Grpapp->findByAsso($criteria, array(
				'Grpapp.id', 'Grpapp.app_name','Installation.id','Installation.app_id','Installation.disp_name', 'Installation.program_name', 'Installation.version','Installation.vendor'), 'Installation.id DESC', null, 1, $asso);
				$this->set('data',$data);
				$this->set('show',1);
				if($depand == '3'){
					$this->set('origin',1);
				}else{
					if(!isset($this->data['Installation']['flag'])){
						$this->set('origin',1);
					}elseif((isset($this->data['Installation']['flag']))&&($this->data['Installation']['flag'] == 1)){
						$this->set('origin',2);
					}
				}
		}
		//echo "id=".$id."<br>";
		$this->set('glist',$glist);
		empty($err) ? null : $this->set('err',$err);
	
		$this->set('id',$id);
		$this->set('grp',$grp);
		//yaozl start 2009/09/21 added for JL-0040
		/*if(!isset($this->data['Installation']['flag'])){
			$this->set('grp_group',$grp);
		}else{*/
			//sunhy start 2009/05/05 modify for YBR-33
			//$this->set('grp_group',$this->data['Grpapp']['group']);
			//$this->set('grp_group',null);
			//sunhy end 2009/05/05 modify for YBR-33
		//}
		if(!empty($grp)&&($grp != 0)){
			$this->set('group_id',$grp);
		}else{
			$this->set('group_id',$this->_getUserGroup_id());
		}
		//yaozl end 2009/09/21 added for JL-0040
		if($id != 0){
			if(!isset($this->data['Installation']['flag'])){
				$this->set('app',$app);
			}else{
				$this->set('app',$this->data['Grpapp']['app_name']);
			}
		}else{
			$this->set('app','');	
		}
		$this->render('edit');
	}
	function common($id=null,$grp=null)
	{	//echo "common<br>";
		$this->layout = 'ajax';	
		$criteria_app[]="Grpapp.id=".$id;
		$grp_app=$this->Grpapp->findAll($criteria_app);
		$app =$grp_app[0]['Grpapp']['app_name'];
		$word_programname='';
		$word_version='';
		$word_vendor='';
		$condition[] = "1=1";		
		if(isset($this->data['Astsfw']['software_name']))
		{
			$word_programname = $this->data['Astsfw']['software_name'];
			//echo "word_programname=".$word_programname."<br>";
			$this->set('word_programname',$word_programname);	
		}	
		if(isset($this->data['Astsfw']['version']))
		{
			$word_version = $this->data['Astsfw']['version'];
			$this->set('word_version',$word_version);
		}
		if(isset($this->data['Astsfw']['maker']))
		{
			$word_vendor = $this->data['Astsfw']['maker'];
			$this->set('word_vendor',$word_vendor);
		}
		$re_programname =$this->Lv->is_empty($word_programname);
		$re_version =$this->Lv->is_empty($word_version);
		$re_vendor =$this->Lv->is_empty($word_vendor);
		if ($re_programname &&($re_version) &&($re_vendor)){
			$criteria[] = "1=1";
		}else{
			if(!$re_programname)
			{
				//xinw start 20080512
				$criteria[] = "lower(Astsfw.software_name) like '%".strtolower(trim($this->Lv->spec_char_like($word_programname)))."%'  ";
				//xinw end 20080512
			}
			if((!$re_version)&&($word_version !='*'))
			{
				$criteria[] = "Astsfw.version like '%".trim($this->Lv->spec_char_like($word_version))."%'  ";
			}
			if((!$re_vendor)&&($word_vendor != '*'))
			{
				//xinw start 20080512
				$criteria[] = "lower(Astsfw.maker) like '%".strtolower(trim($this->Lv->spec_char_like($word_vendor)))."%'  ";
				//xinw end 20080512
			}
			$result = array();
		}
			/* 
			 * アプリケーション運用情報の捜索
			 */
		    $glist = $this->Grpauth->getChildrenByParent($grp);    
			$condition="";
			foreach($glist as $key => $value){
			    $condition.=$key.",";
			}
			$condition = substr($condition,0,-1);
			$criteria[]=" Group.id in (".$condition.") ";
			$criteria[] = "Astsfw.software_name not in (select Installation.program_name from installations as Installation where Installation.program_name = Astsfw.software_name and Installation.version = Astsfw.version and Installation.vendor = Astsfw.maker and Installation.app_id =".$id.")";
			$criteria['GROUP BY']="Astsfw.software_name,Astsfw.version,Astsfw.maker";
			$asso_app = array('Host : hosts' => array('Astsfw.host_id = Host.id'), 
					     'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
					    'Group : groups' => array('Group.id = Rlthstgrp.group_id'), 
												);
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'list','url'=>"/system_grpset_apps/entry/{$id}/{$grp}/2", 'modelClass'=>'Astsfw','queryType' => array('function' => 'findByAsso','asso'=>$asso_app),'sortBy' => $this->Lv->sortBy('Astsfw.software_name'), 'ajaxFormId'=>'form1'));
			$data_app = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','Astsfw.version','Astsfw.maker'),$order,$limit,$page,$asso_app);
			$data_app_c = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','Astsfw.version','Astsfw.maker'),'Astsfw.software_name',$limit=null,$page=null,$asso_app);
			$count_data_app_c = count($data_app_c);
			//debug($data_app);
			$this->set('data_app',$data_app);
			$this->set('count_data_app_c',$count_data_app_c);
			$this->set('flag',2);
/*		echo "id=".$id."<br>";
		echo "grp=".$grp."<br>";
		echo "app=".$app."<br>";		
		$this->render('entry');*/
	}
	function entry($id=null,$grp=null,$add=null)
	{
		$this->layout='ajax';
		$criteria_app[]="Grpapp.id=".$id;
		$grp_app=$this->Grpapp->findAll($criteria_app);
		$app =$grp_app[0]['Grpapp']['app_name'];
		$this->set('id',$id);	
		$grpnm1=$this->Group->findAll(array('Group.id' => $grp));
		$this->set('grp1',$grpnm1[0]['Group']['group_name']);
		if(isset($this->data['Installation']['ps_grp1']))
		{
			$this->set('grp1', $this->data['Installation']['ps_grp1']);
		}
        $this->set('grp',$grp);
		$this->set('app',$app);
		if(isset($this->data['Installation']['ps_app']))
		{
			$this->set('app', $this->data['Installation']['ps_app']);
		}

		
		if(isset($this->data['Astsfw']['flag'])&&(!empty($this->data['Astsfw']['flag']))){
			$this->set('flag',$this->data['Astsfw']['flag']);
			if($this->data['Astsfw']['flag'] == 2){
				$page =2;
			}elseif($this->data['Astsfw']['flag'] == 1){
				$page =1;
			}
		}else{
			$this->set('flag',1);
			$page =1;
		}
		if($add !='2')
		{ //echo "jingjing";
			/* 
			 * アプリケーション運用情報の捜索
			 */
			if($page ==1){//echo "11111111111111111111111111111111111111111<br>";
			    $glist = $this->Grpauth->getChildrenByParent($grp);    
				$condition="";
				foreach($glist as $key => $value){
				    $condition.=$key.",";
				}
				$condition = substr($condition,0,-1);
				$criteria[]=" Group.id in (".$condition.") ";
				$criteria[] = "Astsfw.software_name not in (select Installation.program_name from installations as Installation where  Installation.program_name = Astsfw.software_name and Installation.version = Astsfw.version and Installation.vendor = Astsfw.maker and Installation.app_id =".$id.")";
				$criteria['GROUP BY']="Astsfw.software_name,Astsfw.version,Astsfw.maker";
				$asso_app = array('Host : hosts' => array('Astsfw.host_id = Host.id'), 
						     'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
						    'Group : groups' => array('Group.id = Rlthstgrp.group_id'), 
													);
				list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'list','url'=>"/system_grpset_apps/entry/{$id}/{$grp}", 'modelClass'=>'Astsfw','queryType' => array('function' => 'findByAsso','asso'=>$asso_app),'sortBy' => $this->Lv->sortBy('Astsfw.software_name'), 'ajaxFormId'=>'form1'));
				$data_app = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','Astsfw.version','Astsfw.maker'),$order,$limit,$page,$asso_app);
				$data_app_c = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','Astsfw.version','Astsfw.maker'),'Astsfw.software_name',$limit=null,$page=null,$asso_app);
				$count_data_app_c = count($data_app_c);
				$this->set('data_app',$data_app);
				$this->set('count_data_app_c',$count_data_app_c);
			}else{
				$this->common($id,$grp);				
			}
			
			/*  追加　*/
			if ($add ==1)
			{//echo "1111";
				if(isset($this->data['Installation']['id']))
				{//echo "111<br>";
					$word_id  = $this->data['Installation']['id'];
					//debug($word_id);
					$count = count($word_id);
					$i =1;
					foreach ($word_id as $check)
					{
						$disp_name_add = "disp_name_".$check;
						$dispname=$this->Lv->spec_char_dbm($this->data['Installation'][$disp_name_add]);
						$program_name_add = "software_name_".$check;
						$programname=$this->Lv->spec_char_dbm($this->data['Installation'][$program_name_add]);
						$version_add = "version_".$check;
						$version=$this->Lv->spec_char_dbm($this->data['Installation'][$version_add]);
						$version_n="(".$version.")";
						$vendor_add = "maker_".$check;
						$vendor=$this->Lv->spec_char_dbm($this->data['Installation'][$vendor_add]);
						if(empty($version)){//echo "jingjing<br>";
							$version=" ";
							$version_n='';
						}
						if(empty($vendor)){//echo "yangyang <br>";
							$vendor=" ";
						}
						if(empty($dispname))
						{
							$dispname = $programname.$version_n;
						}
					
					    if(!$this->Validation->maxLength($dispname,256)){
					    		$err[]=__('view name',$return = true)."　".__('E-00300',$return = true);
					    }
						if (!empty($dispname)&&(empty($err)))
						{
							$insertdate=Array(
							'Installation' => Array(
							'app_id'=>$id,
							'disp_name' =>$dispname,
							'program_name' => $programname,
							'version' =>$version,
							'vendor' => $vendor
							)
							);
							//debug($insertdate);
							$this->Installation->save($insertdate);
							$this->data['Grpapp']['group'] = $grp;
							$this->data['Grpapp']['app_name'] = $app;

						}
						$i++;
					}
					//echo "i=".$i."<br>";
					if($i>$count){//echo "haha<br>";
							$this->edit(null,$id,$grp);
							exit();	
					}			
				}
				else
		    	{
		    		$err[]=__('app point list',$return = true)."　".__('E-00200',$return = true);		    		 
		    	}   
		    		    
			}
			empty($err) ? null : $this->set('err',$err);

		}
		elseif($add =='2')
		{ 
					if(!$this->Validation->maxLength($this->data['Astsfw']['software_name'],256))
			            {
			                $err[]=__('application_name',$return = true)."　".__('E-00300',$return = true); 		            	
			            }
			        if(!$this->Check->checkAllHalf($this->data['Astsfw']['software_name']))
			            {
			                $err[]=__('application_name',$return = true)."　".__('E-00400',$return = true); 		            	
			            }
					if(!$this->Validation->maxLength($this->data['Astsfw']['version'],256))
			            {
			                $err[]=__('version name',$return = true)."　".__('E-00300',$return = true); 		            	
			            }
			        if(!$this->Check->checkAllHalf($this->data['Astsfw']['version']))
			            {
			                $err[]=__('version name',$return = true)."　".__('E-00400',$return = true); 		            	
			            }
					if(!$this->Validation->maxLength($this->data['Astsfw']['maker'],256))
			            {
			                $err[]=__('vendor name',$return = true)."　".__('E-00300',$return = true); 		            	
			            }	    
			if(empty($err))	
		    {
				$this->common($id,$grp);
				$this->render('entry');
				exit();	
			}
			else 
			{
				$this->set('err',$err);
			}
			$this->set('flag',2);
	  }
	}
}
?>