<?php
/*********************************************************************
*@filename system_grpset_assets_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            1.0        xinw        2008/11/21   modify for LV20R1-167
*            2.0        chenbotao   2009/04/20   modify for LogvillageChinese
*            2.0        yaozl        2009/09/21   modify for JL-0041
*            2.0        yaozl        2009/09/21   modify for JL-0042
********************************************************************/
class SystemGrpsetAssetsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Group', 'Host','Configure','Grpauth','Rlthstgrp','Hstadt','Addition','Validation');
	var $layout='system';
	function beforeFilter(){
		parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index(){
		$this->pageTitle = __('title',$return = true);
		$search= $this->requestAction('/system_grpset_assets/search/',array('return'));
		$this->set('search',$search);
	}
	function search($depand = null){
		$this->layout='ajax';
		$data =$this->Addition->findAll(null,null,'id ASC','0',null,null);
		$this->set('data', $data);
		$this->_setGlist();
		$criteria=array("1=1");
		if(isset($this->data['Addition']['total'])){
			if(!$this->Lv->is_empty($this->data['Host']['host_name'])){
				if(!$this->Validation->maxLength($this->data['Host']['host_name'],127)){
					$errorMessage['client pc'][]  = 'E-00300';
				}else{
					//wangs start 20080202
					//$criteria[]="Host.host_name like '%".$this->data['Host']['host_name']."%'";
					$criteria[]="lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like($this->data['Host']['host_name']))."%'";
					//wangs end 20080202
				}
			}
			for($k=1;$k<=$this->data['Addition']['total'];$k++){
				if(!$this->Lv->is_empty($this->data['Addition']['option'.$k])){
					if(!$this->Validation->maxLength($this->data['Addition']['option'.$k],200)){
						$addition_name = 'option'.$k;
						$col = $this->Addition->find("Addition.addition_name = '".$addition_name."'");
						$errorMessage[$col['Addition']['addition_content']][]  = 'E-00300';
					}else{
						//$criteria[]="Hstadt.option".$k." like '%".strtolower($this->data['Addition']['option'.$k])."%'";
						//xinw start 20080204
						//$criteria[]="lower(Hstadt.option".$k.")='".strtolower($this->data['Addition']['option'.$k])."'";
						$criteria[]="lower(Hstadt.option".$k.") like '%".strtolower($this->Lv->spec_char_like($this->data['Addition']['option'.$k]))."%'";
						//xinw end 20080204
					}
				}
			}
		}
		if (isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);
		}
		$asso = array(
		'Hstadt : hstadts:left' =>array('Host.id = Hstadt.host_id'),
		'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id'),
		'Group : groups' => array('Rlthstgrp.group_id = Group.id'),
		"Grpauth : grpauths" => array('Group.id= Grpauth.group_id'),
		);
		$criteria[]="Grpauth.org_grp_id=".$this->_getEffectGroup();
		$criteria["group by"] = 'Host.host_name,Group.group_name,Host.id,Hstadt.host_id,Hstadt.option1,Hstadt.option2,Hstadt.option3,Hstadt.option4,Hstadt.option5,Hstadt.option6,Hstadt.option7,Hstadt.option8,Hstadt.option9,Hstadt.option10';
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'whole','url'=>'/system_grpset_assets/search', 'modelClass'=>'Host', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Group.group_name')));
		$result = $this->Host->findByAsso($criteria, array('Group.group_name','Host.host_name','Host.id','Hstadt.host_id','Hstadt.option1','Hstadt.option2','Hstadt.option3','Hstadt.option4','Hstadt.option5','Hstadt.option6','Hstadt.option7','Hstadt.option8','Hstadt.option9','Hstadt.option10'), $order, $limit, $page, $asso);
		$this->set('result', $result);
		if($depand=='csv'){
			$all_data = $this->Host->findByAsso($criteria, array('Group.group_name','Host.host_name','Host.id','Hstadt.host_id','Hstadt.option1','Hstadt.option2','Hstadt.option3','Hstadt.option4','Hstadt.option5','Hstadt.option6','Hstadt.option7','Hstadt.option8','Hstadt.option9','Hstadt.option10'), $order, null, null, $asso);
			$this->csvdown($all_data,$data);exit;
		}
	}
	function _setGlist(){
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//ksort($glist);
		$this->set('glist', $glist);
	}
	function _getEffectGroup(){
		if(!$this->Lv->is_empty($this->data['Group']['id'])){
			$effectGroup =$this->data['Group']['id'];
		}
		else {
			$effectGroup = $this->_getUserGroup();
		}
		return $effectGroup;
	}
	function change($depand=null){
		$this->layout='ajax';
		$data =$this->Addition->findAll(null,null,'id ASC','0',null,null);
		$this->set('data', $data);
		if (isset($this->data['Host']['hst_name'])){
			$result = array();
			$allnumber=count($data);
			for($i=0;$i<$allnumber;$i++){
				if(!$this->Validation->maxLength($this->data['Hstadt']['changeoption'.($i+1)],200)){
					$errorMessage[$data[$i]['Addition']['addition_content']][0]  = 'E-00300';
				}
				$this->data['Hstadt']['option'.($i+1)] = $this->data['Hstadt']['changeoption'.($i+1)];
			}
			$this->set('errorMessage', $errorMessage);
			$result[] = $this->data;
		}else{
			$criteria=array("Host.id=".$depand);
			$asso = array(
			'Hstadt : hstadts : left' =>array('Hstadt.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id'),
			'Group : groups' => array('Rlthstgrp.group_id = Group.id'),
			);
			$result = $this->Host->findByAsso($criteria, array('Host.host_name as Host__hst_name', 'Group.group_name as Group__grp_name','Host.id','Hstadt.host_id','Hstadt.option1','Hstadt.option2','Hstadt.option3','Hstadt.option4','Hstadt.option5','Hstadt.option6','Hstadt.option7','Hstadt.option8','Hstadt.option9','Hstadt.option10'), null, null, null, $asso);
		}
		$this->set('result', $result);
	}
	function add($depand = null)
	{
		$this->layout='ajax';
		$depand = $this->data['Host']['id'];
		$criteriaup=array("Hstadt.host_id=".$depand);
		$option=array();
		$result = $this->Hstadt->findAll($criteriaup,null,null,null,null,null);
		for($i=1;$i<=10;$i++){
			if(isset($this->data['Hstadt']['changeoption'.$i])){
				//yaozl start 2009/09/21 modify for JL-0041
				//$option[$i]=$this->data['Hstadt']['changeoption'.$i];
				$this->data['Hstadt']['changeoption'.$i] = trim($this->data['Hstadt']['changeoption'.$i], " ");
				$option[$i]=$this->data['Hstadt']['changeoption'.$i] == NULL ?  NULL : $this->Lv->spec_char_dbm($this->data['Hstadt']['changeoption'.$i]);
				//yaozl end 2009/09/21 modify for JL-0041
			}
			else{
				//yaozl start 2009/09/21 modify for JL-0041
				//$option[$i]="";
				$option[$i]=NULL;
				//yaozl end 2009/09/21 modify for JL-0041
			}
		}
		if(!empty($result)){
			$updatedate=Array(
			'Hstadt' => Array(
			'id'=>$result[0]['Hstadt']['id'],
			'host_id'=>$depand,
			'option1'=>$option[1],
			'option2'=>$option[2],
			'option3'=>$option[3],
			'option4'=>$option[4],
			'option5'=>$option[5],
			'option6'=>$option[6],
			'option7'=>$option[7],
			'option8'=>$option[8],
			'option9'=>$option[9],
			'option10'=>$option[10],
			)
			);
		}
		else{
			$updatedate=Array(
			'Hstadt' => Array(
			'host_id'=>$depand,
			'option1'=>$option[1],
			'option2'=>$option[2],
			'option3'=>$option[3],
			'option4'=>$option[4],
			'option5'=>$option[5],
			'option6'=>$option[6],
			'option7'=>$option[7],
			'option8'=>$option[8],
			'option9'=>$option[9],
			'option10'=>$option[10],
			)
			);
		}
		if($this->Validation->maxLength($option[1] ,200)&&$this->Validation->maxLength($option[2] ,200)&&$this->Validation->maxLength($option[3] ,200)&&
		$this->Validation->maxLength($option[4] ,200)&&$this->Validation->maxLength($option[5] ,200)&&$this->Validation->maxLength($option[6] ,200)&&
		$this->Validation->maxLength($option[7] ,200)&&$this->Validation->maxLength($option[8] ,200)&&$this->Validation->maxLength($option[9] ,200)&&
		$this->Validation->maxLength($option[10] ,200)){
			$this->Hstadt->save($updatedate);
			$this->search();
			$this->render('search');
			exit();
		}
		else{
			$this->change($depand);
			$this->render('change');
			exit();
		}
	}
	function csvdown($all_data = array(),$data = array()){
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("system_grpset_assets");
		$cols = array(
		"Group/group_name"=>__('group_name',$return = true),
		//xinw start 20081125
		//modify for LV20R1-167
		"Host/id"=>__('host_id',$return = true),
		//xinw end 20081125
		"Host/host_name"=>__('client pc',$return = true),
		);
		foreach ($data as $output){
			//yaozl start 2009/09/23 modify for JL-0041
			//$cols['Hstadt/'.$output['Addition']['addition_name']] = $output['Addition']['addition_content'];
			$cols['Hstadt/'.$output['Addition']['addition_name']] = $output['Addition']['addition_content'] == NULL ? "NULL" : $output['Addition']['addition_content'];
			//yaozl start 2009/09/23 modify for JL-0041
		}
		$csv->special_cols = $cols;
		$csv->sendCSVFile($all_data,$this->data,__('asset list',$return = true));
	}
	function do_import()
	{
		require_once("csv_imports_controller.php");
		$hear_num = 1;
		$data = CsvImportsController :: do_import($hear_num);
		$errorMessage = array();
		//xinw start 20081125
		//modify for LV20R1-167
		/*		foreach($data as $v){
		$hst_id = $this->Host->find("Host.host_name = '".$v[1]."'");
		if ($hst_id){
		$host_id = $hst_id['Host']['id'];
		//xinw start 20081121
		//modify for LV20R1-167
		//$is_exist = $this->Hstadt->find("Hstadt.host_id = $host_id");
		$Hstadt_id = $this->Hstadt->find("Hstadt.host_id = $host_id");
		$is_exist=$this->Addition->findAll();
		//xinw end 20081121
		//xinw start 20081121
		//modify for LV20R1-167
		//if (!$is_exist){
		if (count($is_exist)>0){
		//xinw end 20081121
		$col_con = count($v)-2;
		for($i = 1;$i <= $col_con;$i++){
		if(!$this->Validation->maxLength($v[$i+1],200)){
		$addition_name = 'option'.$i;
		$col = $this->Addition->find("Addition.addition_name = '".$addition_name."'");
		$errorMessage[$v[1].$col['Addition']['addition_content']][] = 'E-00300';
		}else{
		//xinw start 20081121
		//modify for LV20R1-167
		$insert['Hstadt']['id'] = $Hstadt_id['Hstadt']['id'];
		//xinw end 20081121
		$insert['Hstadt']['host_id'] = $host_id;
		$insert['Hstadt']['option'.$i] = $v[$i+1];
		}
		}
		}else{
		//xinw start 20081121
		//modify for LV20R1-167
		//$errorMessage[$v[1]][] = 'E-02500';
		$errorMessage[''][] = '';
		break;
		//xinw end 20081121
		}
		}else{
		$errorMessage[$v[1]][] = 'E-02600';
		}
		if (isset($insert)){
		$this->Hstadt->save($insert);
		}
		}*/
		//if (isset($data[0]) && $data[0]=="error_csv") {
		if($data[0]=="error_csv" || $data[0]=="error_format"){
			$errorMessage[''][]='error_format';
		}else {
			$is_exist=$this->Addition->findAll();
			$opt_num=count($is_exist);
			//additionsテーブルは空かどうか判断
			if ($opt_num>0){
				foreach($data as $v){
					$asso = array(
					'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
					'Group : groups' => array("Rlthstgrp.group_id = Group.id and Group.group_name='".$v[0]."'"),
					);
					//該ｐｃがあるかどうか判断
					$hst_id=$this->Host->findByAsso(array("Host.id = ".$v[1]." and Host.host_name='".$v[2]."'"),array('Host.id'), null, null, null, $asso);
					//ある場合
					if (count($hst_id)>0){
						//該ｐｃはログインしているユーザのグループに所属するかどうか判断
						$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
						//属する場合
						if (in_array($v[0],$glist)) {
							$host_id = $hst_id[0]['Host']['id'];
							$Hstadt_id = $this->Hstadt->find("Hstadt.host_id = $host_id");
							//$col_con = count($v)-3;
							$col_con = $opt_num;
							for($i = 1;$i <= $col_con;$i++){
								//拡張項目名の内容の入力文字が多すぎかどうか判断
								if(!$this->Validation->maxLength($v[$i+2],200)){
									$addition_name = 'option'.$i;
									$col = $this->Addition->find("Addition.addition_name = '".$addition_name."'");
									//chenbotao start 2009/04/20 modify for LogvillageChinese
									//$errorMessage['IDは '.$v[1].' である '.$v[2].' の拡張項目名 '.$col['Addition']['addition_content']][] = 'E-00300';
								      $errorMessage[__('error_id',$return = true).$v[1].__('have',$return = true).$v[2].__('error_suffix',$return = true).$col['Addition']['addition_content']][] = 'E-00300';
								    //chenbotao end 2009/04/20 modify for LogvillageChinese
								}else{
									$insert['Hstadt']['id'] = $Hstadt_id['Hstadt']['id'];
									$insert['Hstadt']['host_id'] = $host_id;
									//yaozl start 2009/09/21 modify for JL-0042
									//$insert['Hstadt']['option'.$i] = $v[$i+2];
									$insert['Hstadt']['option'.$i] = ($v[$i+2] == NULL ? NULL : $this->Lv->spec_char_dbm($v[$i+2]));
									//yaozl end 2009/09/21 modify for JL-0042
								}
							}
							if (isset($insert)){
								$this->Hstadt->save($insert);
							}
						}else
						{
							//属しないエラーメッセージ
							//chenbotao start 2009/04/20 modify for LogvillageChinese
							//$errorMessage['IDは '.$v[1].' である '.$v[2]." は"][] = '上位グループ或いは同位グループ所属のため更新されません。';
							//yaozl start 2009/09/21 modify for JL-0041  
							//$errorMessage[__('error_id',$return = true).$v[1].__('have',$return = true).$v[2]][] = __('error_group_noupdate',$return = true);
							$errorMessage[$v[2]][] = __('error_group_noupdate',$return = true);
							//yaozl end 2009/09/21 modify for JL-0041
						    //chenbotao end 2009/04/20 modify for LogvillageChinese
						}
					}else{
						//不存在の時のエラーメッセージ
						//chenbotao start 2009/04/20 modify for LogvillageChinese
						//$errorMessage['グループ名は '.$v[0].' で、'.'IDは '.$v[1].' である'.$v[2]][] = 'E-02600';
						  $errorMessage[__('error_group_name',$return = true).$v[0].__('de',$return = true).__('error_id',$return = true).$v[1].__('have',$return = true).$v[2]][] = 'E-02600';
					    //chenbotao end 2009/04/20 modify for LogvillageChinese
					}
				}
			}else{
				//additionsテーブルは空であるエラーメッセージ
				$errorMessage[''][] = '';
				//break;
			}
		}
		//xinw end 20081125
		$this->set('errorMessage', $errorMessage);
		$this->index();
		$this->layout='system';
		$this->render("index");
		exit();
	}
}
?>