<?php
class SystemGrpsetProcessesController extends AppController {
	var $name = 'SystemGrpsetProcesses';
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Grpproc','Group','Rltgrpproc','Grpauth','Grpsvc', 'Configure', 'Validation','Procapp','Application','Rltgrpsvc','Uselgcproc');
	var $layout='system';

	
    	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('title',$return = true);// 'LVシステム管理／グループ毎の設定／プロセス設定（プロセス稼動時間画面用）';
//		$this->Configure->write('debug', 2);
	}
	function index($flag=null) {
		if($flag==1){
			$this->layout='ajax';
		}
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//$glist[0] =  __('whole',$return = true);
		//ksort($glist);
		$this->set('glist',$glist);

		//$criteria[]=" Group.id=".$this->data['optweb']['group']." ";
		$criteria[]="Grpauth.org_grp_id=".$this->_getUserGroup();
		$asso = array(
		'Group : groups' => array('Grpproc.group_id = Group.id'),
		'Grpauth : grpauths' => array('Grpproc.group_id = Grpauth.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'change', 'url'=>'/system_grpset_processes/index/1', 'modelClass'=>'Grpproc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'sortBy' => $this->Lv->sortBy('Grpproc.group_id'), 'ajaxFormId'=>'form1'));
		$result = $this->Grpproc->findByAsso($criteria, array('Grpproc.process_name', 'Grpproc.id','Grpproc.application_name','Grpproc.disp_name','Group.group_name','Grpproc.group_id'),$order, $limit,$page, $asso);
  //    $result = $this->Grpproc->findByAsso($criteria, array('grpsvcs.process_name', 'grpsvcs.id','grpsvcs.application_name','grpsvcs.disp_name','groups.group_name'),null,null, null, $asso);
	//	$this->set('count',$result1 = $this->Grpproc->findByAsso($criteria, array('count(*) as count'),null,null, null, $asso));
		$this->set("result",$result);
		//$this->set('glist',$glist);
	}
	function control($depand=null,$yesorno=null) {		
		$this->layout='ajax';
		$err=array();
		if($depand=='1'){	////////////変更する/////////////////	
			//debug($this->data);		
			$this->set('yesorno', $yesorno);
			if(isset($this->data['Grpproc']['id'])){
				$word_id  = $this->data['Grpproc']['id'];
				//debug($word_id);
				foreach ($word_id as $check){
					$proc_name=$this->data['Grpproc']['process_name_'.$check];
					$grpid=$this->data['Grpproc']['group_'.$check];
					$flag=0;
					foreach ($word_id as $id){
	
						if(($check != $id) and ($flag ==0) ) {							
							if ($proc_name == $this->data['Grpproc']['process_name_'.$id] and ($grpid==$this->data['Grpproc']['group_'.$id])){
								$flag=1;
							}
						}
					}
					
				if($flag==1){
					if(!(in_array(__('pro_name',$return = true)."　".__('E-01900',$return = true),$err))){
						$err[]=__('pro_name',$return = true)."　".__('E-01900',$return = true);		
										
					}
				}					
					
				if(!$this->Validation->maxLength($this->data['Grpproc']['disp_name_'.$check],200))
				{
					$err[]=__('show_pro_name',$return = true)."　".__('E-00300',$return = true); 
				}
				
				if(!$this->Validation->maxLength($this->data['Grpproc']['process_name_'.$check],260))
				{
					$err[]=__('pro_name',$return = true)."　".__('E-00300',$return = true);
				}
				
				if(!$this->Validation->maxLength($this->data['Grpproc']['application_name_'.$check],256))
				{
					$err[]=__('app_name',$return = true)."　".__('E-00300',$return = true);
				}
				
				if($this->Validation->blank($this->data['Grpproc']['disp_name_'.$check]) )
				{
					$err[]=__('show_pro_name',$return = true)."　".__('E-00100',$return = true);
				}
				if($this->Validation->blank($this->data['Grpproc']['process_name_'.$check]))
				{
					$err[]=__('pro_name',$return = true)."　".__('E-00100',$return = true);
				}
//				if($this->Validation->blank($this->data['Grpproc']['application_name_'.$check]))
//				{
//					$err[]=__('app_name',$return = true)."　".__('E-00100',$return = true);
//				}
				if(!$this->Check->checkAllHalf($this->data['Grpproc']['process_name_'.$check]))
				{ 
					$err[]=__('pro_name',$return = true)."　".__('E-00400',$return = true);
//						echo $this->data['Grpproc']['process_name_'.$check];
				}	
				if(!empty($err)){
					$this->set('seccess',1);					
				}
				if(empty($err))
				{						
					$updid=$this->data['Grpproc']['group_'.$check];
					$upddispname=trim($this->Lv->spec_char_dbm($this->data['Grpproc']['disp_name_'.$check]));
					$updproname=trim($this->Lv->spec_char_dbm($this->data['Grpproc']['process_name_'.$check]));
					$updappname=trim($this->Lv->spec_char_dbm($this->data['Grpproc']['application_name_'.$check]));
					//echo "$updid";
					$condition="process_name='$updproname' and group_id=$updid";
					$result=$this->Grpproc->findAll($condition,null,null,'0',null,null);
					if(count($result)<=1){					
						if(!empty($updid)&&!empty($updproname)){
							$insertdate=Array(
							'Grpproc' => Array(
								'id' => $check,
								'group_id' => $updid,
								'process_name' =>$updproname,
								'application_name'=>$updappname,
								'disp_name'=>$upddispname
							)
						);
						$this->Grpproc->save($insertdate);
						}
					}
					else{
					
						if(!(in_array(__('pro_name',$return = true)."　".__('E-01900',$return = true),$err))){							
								$err[]=__('pro_name',$return = true)."　".__('E-01900',$return = true);	
								$this->set('seccess',1);							
							}
						}
					}										
				}
			}
			else 
			{
				$err[]=__('pro',$return = true)."　".__('E-00200',$return = true);
				$this->set('err', $err);
				$this->set('seccess',1);			
			}		
		}
		elseif($depand=='2'){/////////////// 削除する ////////////////////
			$this->set('yesorno', $yesorno);
			if(isset($this->data['Grpproc']['id'])){			
				$word_id  = $this->data['Grpproc']['id'];
				foreach ($word_id as $check){
	         		$this->Grpproc->del($check);  ///////////////// grpproc テーブル操作　///////////////////////
				}    
			}	
			else 
			{
				$err[]=__('pro',$return = true)."　".__('E-00200',$return = true);
				$this->set('err', $err);
			}				
		}
		elseif($depand=='3'){/////////////////追加する/////////////
			$this->set('yesorno', $yesorno);
			//debug($this->data);
			$addgroupid=$this->data['Grpproc']['add_group_id'];
			$adddispname=$this->Lv->spec_char_dbm($this->data['Grpproc']['add_disp_name']);
			$addprosname=$this->Lv->spec_char_dbm($this->data['Grpproc']['add_pros_name']);
			$addappname=$this->Lv->spec_char_dbm($this->data['Grpproc']['add_appname']);
			

			if((!empty($addgroupid)&&!empty($addprosname))){
				$condition="process_name='$addprosname' and group_id=$addgroupid";
				$result = $this->Grpproc->findAll($condition,null,null,'0',null,null);
				//debug(empty($result));
				if (empty($result)){	
				if(!$this->Validation->maxLength($adddispname,200))
				{
					$err[]=__('show_pro_name',$return = true)."　".__('E-00300',$return = true);	
				}
				if(!$this->Validation->maxLength($addprosname,260))
				{
					$err[]=__('pro_name',$return = true)."　".__('E-00300',$return = true);	
				}
				if(!$this->Validation->maxLength($addappname,256))
				{
					$err[]=__('app_name',$return = true)."　".__('E-00300',$return = true);	
				}
				
				
				
				if($this->Validation->blank($adddispname))
				{
					$err[]=__('show_pro_name',$return = true)."　".__('E-00100',$return = true);	
				}
				if($this->Validation->blank($addprosname))
				{
					$err[]=__('pro_name',$return = true)."　".__('E-00100',$return = true);	
				}
//				if($this->Validation->blank($addappname))
//				{
//					$err[]=__('app_name',$return = true)."　".__('E-00100',$return = true);	
//				}
				
				
				
				if(!$this->Check->checkAllHalf($addprosname))
					{ 
						$err[]=__('pro_name',$return = true)."　".__('E-00400',$return = true);	
					}		
				if(!empty($err)){
					$this->set('seccess',1);								
				}
					
				if(empty($err))
				{
										
					$insertdate=Array(	
						'Grpproc' => Array(
							            'group_id' => $addgroupid,
							            'process_name' =>  $addprosname,
							            'application_name' => $addappname,
							            'disp_name'=>$adddispname
						      	      )
						);
					$this->Grpproc->save($insertdate); 	
					$result = $this->Grpproc->getLastInsertID();//////////////////////// rltgrpsvcs テーブル操作 ////////////
					$glist = $this->Grpauth->getChildrenByParent($addgroupid);
					foreach ($glist as $key=>$value){					
						$insertdate=Array(	
							'Rltgrpsvc' => Array(
								'group_id' => $key,
								'process_id' =>  $result,
								'org_grp_id' => $addgroupid,
							)
						);	
						//debug($insertdate);	
						$this->Rltgrpproc->save($insertdate); 		//////////////////////////////////////////////////////////////////////////			
					}
					
					}
					
					
				}		
				else 
				{
					$err[]=__('pro',$return = true)."　".__('E-01900',$return = true);
					$this->set('seccess',1);					
				}			
			}
			else 
				{
					if(empty($addgroupid))
					{
					$err[]=__('group',$return = true)."　".__('E-00100',$return = true);
					}
					if(empty($addprosname))
					{
					$err[]=__('pro_name',$return = true)."　".__('E-00100',$return = true);
					}
					$this->set('seccess',1);					
				}						
		}
		$this->set('err', $err);
		//$this->search();
		$this->index();
		$this->render('control');
		exit();
		
	}
	function add($add=null){	
		$err=null;	
		$this->layout='ajax';
		if ($add ==1){
			//debug($this->data);
			if(isset($this->data['Grpproc']['add_id']))
			{
				$word_id  = $this->data['Grpproc']['add_id'];
				//debug($word_id );							
				foreach ($word_id as $check){
					 
					$proname=$this->Lv->spec_char_dbm($this->data['Grpproc']['pro_name'.$check]);
					$appname=$this->Lv->spec_char_dbm($this->data['Grpproc']['appname'.$check]);
					$dispname=$this->Lv->spec_char_dbm($this->data['Grpproc']['show_pro_name'.$check]);
					$groupid=$this->data['Grpproc']['groupid'];
//					debug($this->data);
//					if(!empty($proname)){
//88                
	                  $flag=0;   
	                 foreach ($word_id as $id){                  
		                 if(($check != $id) and ($flag !=0)) {       
							 if ($proname == $this->data['Grpproc']['pro_name'.$id]){
							 	$flag=1;        
							 }					        
		                 }
	                 }
	                 if($flag==1){
						if(!(in_array(__('service',$return = true)."　".__('E-01900',$return = true),$err))){
							$err[]=__('service',$return = true)."　".__('E-01900',$return = true);	
							$this->set('seccess',1);								
						}					
					}
					else{
//88
						if(!empty($proname)){
							$condition="process_name = '$proname'  and group_id = $groupid";
							$result = $this->Grpproc->findAll($condition,null,null,'0',null,null);
	//						debug($result);
							if (empty($result))
							{
								if(!$this->Validation->maxLength($dispname,200))
								{
									$err[]=__('show_pro_name',$return = true)."　".__('E-00300',$return = true);	
								}
							}
							else 
							{ 
								$err[]=__('pro',$return = true)."　".__('E-01900',$return = true);
							}
							if(!empty($err))	{
								$this->set('seccess',1);					
							}

							if(empty($err))
								
							{
								empty($dispname)? $dispname=empty($appname)? $proname:$proname."(".$appname.")":null;
								$insertdate=Array(
									'Grpproc' => Array(
											'group_id' => $groupid,
											'process_name' =>$proname,
											'disp_name' => $dispname,
											'application_name' => $appname
			          							  )
									);
	//								debug($insertdate);
								$this->Grpproc->save($insertdate); 	
								$result = $this->Grpproc->getLastInsertID();
								$glist = $this->Grpauth->getChildrenByParent($groupid);
								foreach ($glist as $key=>$value){					
									$insertdate=Array(	
										'Rltgrpsvc' => Array(
											'group_id' => $key,
											'process_id' =>  $result,
											'org_grp_id' => $groupid,
										)
									);	
	//								debug($insertdate);	
									$this->Rltgrpsvc->save($insertdate); 		//////////////////////////////////////////////////////////////////////////			
								}	
	//							$this->Rltgrpsvc->save($insertdate); 
	//							$this->index();
	//							$this->render('index');
								
							}											
						}
					}
				}
                if(empty($err))
				{
					$this->index();$this->render('index');exit();
				}
							
			}	
			else 
			{
				$err[]=__('pro',$return = true)."　".__('E-00200',$return = true);	
				$this->set('err', $err);
				$this->set('seccess',1);					
			}									
		}
		$this->set('err', $err);
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//ksort($glist);
		$this->set('glist',$glist);
		
		$this->search();
	}
	function search(){
		if(isset($this->data['Grpproc']['searchname'])){
			$searchname  = $this->data['Grpproc']['searchname'];  
			$searchapp   = $this->data['Grpproc']['searchspec'];    
		}			
		else{           
			if(isset($this->data['Grpproc']['hsvcname'])){
				$searchname   = $this->data['Grpproc']['hproname'];  
				$searchapp   = $this->data['Grpproc']['happname'];    
			}
			else{
				$searchname='';
				$searchapp='';
			}
		}
		$this->set('hproname', $searchname);
		$this->set('happname', $searchapp);
		         
		$condition = array("1=1");
		if(!empty($searchname)){
			
			if(!$this->Validation->maxLength($searchname,260)  )
			{
				$err[]=__('pro_name',$return = true)."　".__('E-00300',$return = true);	
			}
			if(!$this->Validation->alphaNumeric($searchname))
			{
				$err[]=__('pro_name',$return = true)."　".__('E-00400',$return = true);	
			}
			if($this->Validation->maxLength($searchname,260)&&$this->Validation->alphaNumeric($searchname))
			{
//				$condition = array("Useproc.process_name like '%".$searchname."%'") ;
				//xinw start 20080512
				$condition = array("lower(Uselgcproc.process_name) like '%".strtolower($searchname)."%'") ;
				//xinw end 20080512
			}
		}
		if(!empty($searchapp)){
			if($this->Validation->maxLength($searchapp,256))
			{
			//xinw start 20080512
			$condition = array("lower(Application.application_name) like '%".strtolower($this->Lv->spec_char_like($searchapp))."%'") ;
			//xinw start 20080512
			}
			if(!$this->Validation->maxLength($searchapp,256)  )
			{
				$err[]=__('app_name',$return = true)."　".__('E-00300',$return = true);	
			}
//			if(!$this->Validation->alphaNumeric($searchapp))
//			{
//				$err[]=__('app_name',$return = true)."　".__('E-00400',$return = true);	
//			}
		}
		
		
		$asso = array('Procapp : procapps:left' => array('Uselgcproc.process_name = Procapp.process_name'), 
										'Application : applications:left' => array('Application.id = Procapp.application_id'),
										);
		
	//	list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'change', 'url'=>'/system_grpset_processes/index/1', 'modelClass'=>'Grpproc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'sortBy' => $this->Lv->sortBy('Grpproc.group_id'), 'ajaxFormId'=>'form1'));
		$condition['group by']="Uselgcproc.process_name,Application.application_name";
		list($order,$limit,$page) = $this->Pagination->init($condition,null,array('ajaxDivUpdate'=>'sub_main','url'=>'/system_grpset_processes/add/0', 'modelClass'=>'Uselgcproc', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('UPPER(Uselgcproc.process_name)'),'ajaxFormId'=>'form1'));	
		
		$result = $this->Uselgcproc->findByAsso($condition, array(' Uselgcproc.process_name','Application.application_name'),$order, $limit, $page, $asso);
//		$result = $this->Useproc->findByAsso($condition, array(' Useproc.process_name','Application.application_name'),$order, $limit, $page, $asso);
		//$condition['group by']="Useproc.process_name,Application.application_name";
		//$this->set('count',$result1 = $this->Useproc->findByAsso($condition, array('count(distinct( Useproc.process_name)) as count'),null, null, null, $asso));
//		debug($condition);
		if(isset($err))
		{
		$this->set('err', $err);	
		}		
		$this->set('result', $result);			
		///debug($result);			
	}
}
?>
