<?php
class SystemUserinfosController extends AppController
{
    var $name = 'SystemUserinfos';
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    var $components = array ('Pagination', 'Lv','Check');
    var $uses=array('User','Mail','Validation','Configure');
    var $layout='system';
    
    function beforeFilter()
    {
		parent::beforeFilter();
    }
    
    function index(){
        $this->pageTitle =__('title',$return = true);   //Title::LVシステム管理/個人情報変更
        //$this->Configure->write('debug', 0);
        $user_id=$this->_getUserId(); //Session から
        $condition = "User.id = ".$user_id;
        $condition2 = "Mail.user_id = ".$user_id;
        $users = $this->User->findAll($condition,null,null,'0',null,null);
        $mails = $this->Mail->findAll($condition2,null,null,'0',null,null);          
        $this->set( 'users', $users);
        $this->set( 'mails', $mails);
        $this->render('index');
     }
    
    function edit(){
        $this->layout='ajax';
        //$this->Configure->write('debug', 0);
        $user_id=$this->_getUserId(); //Session から
        $errorMessage = array();     
        $condition = "User.id = ".$user_id;
        $condition2 = "Mail.user_id = ".$user_id;
        $users = $this->User->findAll($condition,null,null,'0',null,null);
        $mails = $this->Mail->findAll($condition2,null,null,'0',null,null);          
        $this->set( 'users', $users);
        $this->set( 'mails', $mails);
		if (empty($this->data))
		{
			$this->User->id = $user_id;
			if($mails!=null){
			$this->Mail->id = $mails[0]['Mail']['id'];
			}
			$this->data = $this->User->read();
			array_push($this->data,$this->Mail->read());
		}   
		else
		{
    	//check the パスワード and the パスワード確認

    	// if(strlen($this->data['User']['password'])==0 || !$this->Validation->maxLength($this->data['User']['password'],200)){    //changed in 20071018
			//if(strlen($this->data['User']['password'])==0){
			//	$errorMessage['password'][] = 'E-00100';
			//	$this->set( 'password_flag1', 1);
			//}
			if(!$this->Validation->maxLength($this->data['User']['password_a'],127)){
				$errorMessage['password'][] = 'E-00300';
			}
			if(!$this->Check->checkAllHalfAndS($this->data['User']['password_a'])){
				$errorMessage['password'][] = 'E-03000';
			}
         // }
     // if(strlen($this->data['User']['password_cfm'])==0 || !$this->Validation->maxLength($this->data['User']['password_cfm'],200)){   //changed in 20071018
			//if(strlen($this->data['User']['password_cfm'])==0){
			//	$errorMessage['password_conform'][] = 'E-00100';
			//	$this->set( 'password_flag', 1);
			//}
			if(!$this->Validation->maxLength($this->data['User']['password_cfm'],127)){
				$errorMessage['password_conform'][] = 'E-00300';			         
			}
//			if(!$this->Check->checkAllHalfAndS($this->data['User']['password_cfm'])){
//				$errorMessage['password_conform'][] = 'E-03000';
//			}
    //  }
			if(strlen($this->data['User']['password_a'])!=0 || strlen($this->data['User']['password_cfm'])!=0){
				if("'".$this->data['User']['password_cfm']."'"!="'".$this->data['User']['password_a']."'"){
					$errorMessage['password'][] = 'E-01400';	
				}
			}
      //check the メールアドレス
			if(!$this->Validation->blank($this->data['Mail']['mail_address']))
			{
				$mail_all = explode(';',$this->data['Mail']['mail_address']);
				if(!$this->Check->checkAllHalf($this->data['Mail']['mail_address']) || !$this->Validation->maxLength($this->data['Mail']['mail_address'],256))
				{				
					if(!$this->Check->checkAllHalf($this->data['Mail']['mail_address'])){
						$errorMessage['mail_address'][] = 'E-00400';		    			
					}
					if(!$this->Validation->maxLength($this->data['Mail']['mail_address'],256)){
						$errorMessage['mail_address'][] = 'E-00300';		    			
					}
				}
				foreach ($mail_all as $value){
					if(!$this->Validation->email($value)){
						$error=1;				
					}			
				}
				if(isset($error)){
					$errorMessage['mail_address'][] = 'E-02200';
				}							
			}
			if($this->Validation->blank($this->data['Mail']['mail_address'])){				
				$this->set( 'mail_flag', 1);
			}
			//check the 備考	
			if(!$this->Validation->blank($this->data['User']['etc'])){
				if(!$this->Validation->maxLength($this->data['User']['etc'],100)){
					$errorMessage['etc'][] = 'E-00300';			
				}				
			}
	//if there is some error	
			if(!empty($errorMessage)){
				$this->set('errorMessage',$errorMessage);
				$this->set( 'password_cfm', $this->data['User']['password_cfm']);
				$this->set( 'password', $this->data['User']['password_a']);
				$this->set( 'mail', $this->data['Mail']['mail_address']);		
			}	
   //if there is not any error,update the User and the Mail
			elseif(empty($errorMessage)){
				if(strlen($this->data['User']['password_a'])==0) //password is not updated  //changed in 20071018
		//if($this->data['User']['password']==substr($users[0]['User']['password'], 0, 10)) //password is not updated
				{
					$adduser = array(
						'User' => array(
							'id' => $users[0]['User']['id'],
							'user_name' => $this->Lv->spec_char_dbm($users[0]['User']['user_name']),						
							'etc' => $this->Lv->spec_char_dbm($this->data['User']['etc'])
						)
					);
					$this->User->save($adduser);
				}
				else //password is updated
				{
					$md5_pwd=md5(($this->data['User']['password_a']));
					$adduser = array(
						'User' => array(
							'id' => $users[0]['User']['id'],
							'user_name' => $this->Lv->spec_char_dbm($users[0]['User']['user_name']),
							'password' =>	$md5_pwd,						
							'etc' => $this->Lv->spec_char_dbm($this->data['User']['etc']),
						)
					); 				
					$this->User->save($adduser);
				}
		//delete the old mails first				
				$mail_id = $this->Mail->findAll("Mail.user_id = ".$users[0]['User']['id'],'Mail.id');					
				foreach ($mail_id as $out){						
					$this->Mail->del($out['Mail']['id']);
				}
		//insert the new mails
				if(!$this->Validation->blank($this->data['Mail']['mail_address'])){
					foreach ($mail_all as $value){	
						$addmail = array(
							'Mail' => array(			
								'user_id' => $users[0]['User']['id'],
								'mail_address' => $this->Lv->spec_char_dbm($value),
							)					
						);  
						$this->Mail->save($addmail);						
					}
				}
				$this->index(); 
			}
		}
	}
}
?>