<?php
class UseAntivirusController extends AppController{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
	var $components = array ('Pagination', 'Lv','RequestHandler','Check');
	var $uses=array('Group', 'Host','Usevir','Rlthstgrp','Astose', 'Configure','Grpauth','Validation','Asthrd','Virus','Antivirusproduct');
	var $layout='use';
	var $exp = array ();

	function beforeFilter(){
		parent::beforeFilter();
			
		if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
		}
	}

	function common(){
        $group = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('group',$group);
	}
		
	function index(){
		$menu_use=__('menu_use',$retrun=true);
        $virus_file=__('virus_file',$retrun=true);
       
   	    $this->pageTitle =$menu_use."/".$virus_file;
		$this->common();
		$this->data['Host']['hostname_all']=1;		
	} 
	
	function contro($type = null) {
	   	$this->layout='ajax';
	   	if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', '0&data%5BGroup%5D%5Bgroupname%5D=1&data%5BHost%5D%5Bhostname_ck%5D=0&data%5BHost%5D%5Bhostname%5D=&data%5BHost%5D%5Bhostname_all%5D=0&data%5BUsevir%5D%5Bdeparttime_ck%5D=0&data%5BUsevir%5D%5Bdeparttime%5D=&btn1=%E5%AE%9F%E8%A1%8C ');
	   	}
	   	if(isset($_POST['forHideVar'])){
	   	$this->set('forHideVar', $_POST['forHideVar']);	   	
	   	}	   
            
	    $this->common();

		if(!isset($this->data['Group']['groupname'])){
		 	if(!isset($this->data['Host']['hostname'])){
		 		$this->data['Host']['hostname']="";
		 	}
//		    $criteria=array("Grpauth.org_grp_id=". $this->_getUserGroup());
		}else{ 	
         	if(!isset($this->data['Host']['hostname'])){
		 		$this->data['Host']['hostname']="";
		 	}
            $groupIndex = $this->data['Group']['groupname'];         		        
	        $hostname_ck = $this->data['Host']['hostname_ck']; 
	        
	        $hostname = $this->data['Host']['hostname'];  
	        $hostname_all = $this->data['Host']['hostname_all'];       	

	        $csv_result1=array();
	        if(!empty($this->data['Group']['groupname'])){
				$group_id = $this->data['Group']['groupname'];
				$groupname_csv=$this->Group->find(array("Group.id=$group_id"),'Group.group_name',null,null,null,-1);
			}
	        !empty($groupname_csv['Group']['group_name'])?$csv_result1['Group']['groupname']=$groupname_csv['Group']['group_name']:$csv_result1['Group']['groupname']=null; 
	        !empty($hostname)?$csv_result1['Host']['hostname']=$hostname:$csv_result1['Host']['hostname']=null; 

            $criteria=array("1=1"); 
                           
		    //$criteria['GROUP BY']="Usevir.create_time,Group.group_name,Host.host_name,TempAstose.os_name,TempAstose.virus_name,Usevir.host_id";	
	        
	        $errorMessage  = array();     	
	        if($hostname_ck==1){	            	
	        	if($this->Lv->is_empty($hostname)){  
		           	$errorMessage['hostname'][] = "E-00100";//未入力	           		
	        	}
	        	if(!$this->Validation->maxLength($hostname,40)){
        	        $errorMessage['hostname'][] = 'E-00300';
        	    } 	            	
	        	if(!$this->Check->checkAllHalf($hostname)){
          	        $errorMessage['hostname'][] = 'E-00400';
        	    }
	        	if(empty($errorMessage)){
		    	    if($hostname_all==1){       		    	 		    	
				        $criteria[]="lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like($hostname))."%' ";       		    	
		    	    }	
		           	else{
		    			$criteria[]="lower(Host.host_name)='".strtolower($this->Lv->spec_char_dbm($hostname))."'";	
                    }
                }
//              echo"aa".debug($errorMessage,true); 
	        }
	        
         	$this->set('errorMessage',$errorMessage);

		} 
		
		$group_id = $this->data['Group']['groupname'];
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[] = "Group.id in (". $group_ids.")";

        $asso=  array(
			'Rlthstgrp :rlthstgrps' => array('Rlthstgrp.host_id = Host.id'), 
			'Group :groups' => array('Rlthstgrp.group_id = Group.id'), 
			'Antivirusproduct :antivirusproducts : left' => array('Antivirusproduct.host_id = Host.id'), 
			);

		$fields = array(
			'Host.id', 
			'Group.group_name', 
			'Host.host_name', 
			'Antivirusproduct.name', 
			'Antivirusproduct.state',
			'Antivirusproduct.timestamp',
		);
		//list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'view', 'url'=>'/use_update_vptns/contro', 'modelClass'=>'Host', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
		//'sortBy' => $this->Lv->sortBy('Group.group_name', 'Host.host_name', 'Antivirusproduct.name')));
		$data = $this->Host->findByAsso($criteria, $fields, null, null, null, $asso);
        
		$feld = "host_id integer,						      
					group_name varchar(128),
				    virus_name varchar(200),
					active integer,
					timestamp datetime";
        $resultOS = $this->Host->query('CREATE TEMPORARY TABLE tempAVs ('.$feld.')');
		
        foreach($data as $n => $d)
		{	
			if(!isset($d['Antivirusproduct']['name'])){
				$data[$n]['Antivirusproduct']['active'] = -1;//なし
			}else{
				$state = $d['Antivirusproduct']['state'];
				if($state == 0)//定義ファイルから
					$data[$n]['Antivirusproduct']['active'] = 2;//不明
				else if($state & (16<<8))
					$data[$n]['Antivirusproduct']['active'] = 1;//稼働
				else
					$data[$n]['Antivirusproduct']['active'] = 0;//停止
			}
			$active = $data[$n]['Antivirusproduct']['active'];//echo $active;
		   //
		   $group_name = $this->Lv->spec_char_dbm($d['Group']['group_name']);
		   $insert = "INSERT INTO tempAVs VALUES(
				{$d['Host']['id']}, 
				'{$group_name}',
				null,-1,null)";
		   if($active != -1){
			   $av_name = $this->Lv->spec_char_dbm($d['Antivirusproduct']['name']);
			   $insert = "INSERT INTO tempAVs VALUES(
				{$d['Host']['id']}, 
				'{$group_name}',
				'{$av_name}',
				{$active},
				'{$d['Antivirusproduct']['timestamp']}')";
		   }
		    $this->Host->query($insert);
		} 
		
		$asso2=  array(
			'TempAV : tempAVs' => array('TempAV.host_id = Host.id'),
		);
		
		$fields2 = array(
			'TempAV.group_name', 
			'Host.host_name', 
			'TempAV.virus_name', 
			'TempAV.active',
			'TempAV.timestamp',
		);
		

		if($type=='csv'){ 
			$data = $this->Host->findByAsso(array("1=1"), $fields2, null, null, null, $asso2);

			$this->csvdown($data,$csv_result1);exit;
        }else{
			list($order,$limit,$page) = $this->Pagination->init(array("1=1"), null, array('ajaxDivUpdate'=>'view', 'url'=>'/use_update_vptns/contro', 'modelClass'=>'Host', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso2), 
			'sortBy' => $this->Lv->sortBy('TempAV.group_name', 'Host.host_name', 'TempAV.virus_name', 'TempAV.active', 'TempAV.timestamp')));
			$data = $this->Host->findByAsso(array("1=1"), $fields2, $order, $limit, $page, $asso2);
		
			$this->set('usevirs',$data);
			$this->render('contro');
		}


	}

	
	function csvdown($usevirs = null,$csv_result1=null)
	{	
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("use_antivirus");       
	    $virus_file=__('virus_file',$retrun=true);  	
	    $csv->sendCSVFile($usevirs,$csv_result1,$virus_file);
	}
   
    
}
?>