<?php
/*********************************************************************
*@filename use_evtlogs_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/02   modify for LV20R1-187
*            2.0        xushanning  2009/04/22   mofify for LogvillageChinese
********************************************************************/
class UseEvtlogsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Useevtlog','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation');
	var $layout='use';

	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index()
	{
		$this->pageTitle =__('menu_use',$retrun=true)."/".__('eventlog',$retrun=true);   //Title::運用管理/イベントログ
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());//グルプリストー   Sessionから
		//ksort($glist);
		$this->set('glist',$glist);
		//          $contro= $this->requestAction('/use_evtlogs/contro',array('return'));
		//	 $this->set('contro',$contro);
	}

	function contro()
	{
		$this->layout='ajax';
		$err = array();
		$dt= date('Y-m-d',time());
		$criteria = array();
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		if(isset($this->data['Host']['host_name']))
		{
			if(!$this->Lv->is_empty($this->data['Host']['host_name']))
			{
				if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
				{
					//xushanning start 2009/04/22   mofify for LogvillageChinese
					//$err['computer'][] = 'E-00400';
					$err['set_computer'][] = 'E-00400';
					//xushanning end 2009/04/22   mofify for LogvillageChinese
				}
				if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
				{
					//xushanning start 2009/04/22   mofify for LogvillageChinese
					//$err['computer'][] = 'E-00300';
					$err['set_computer'][] = 'E-00300';
					//xushanning end 2009/04/22   mofify for LogvillageChinese
				}
			}
		}
		if(isset($this->data['Useevtlog']['account']))
		{
			if(!$this->Lv->is_empty($this->data['Useevtlog']['account']))
			{
				if(!$this->Check->checkAllHalf($this->data['Useevtlog']['account']))
				{
					//xushanning start 2009/04/22   mofify for LogvillageChinese
					//$err['logon account'][] = 'E-00400';
					$err['set_login_account'][] = 'E-00400';
					//xushanning end 2009/04/22   mofify for LogvillageChinese
				}
				if(!$this->Validation->maxLength($this->data['Useevtlog']['account'],127))
				{
					//xushanning start 2009/04/22   mofify for LogvillageChinese
					//$err['logon account'][] = 'E-00300';
					$err['set_login_account'][] = 'E-00300';
					//xushanning end 2009/04/22   mofify for LogvillageChinese
				}
			}
		}
		if(empty($by_dt['error'])){
			if(empty($by_kw['error'])){
				if(empty($err)){
					if(empty($by_dt) && empty($by_kw))
					{
						$criteria[]="datepart(Useevtlog.event_time)= '".$dt."'";
					}
					else
					{
						empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
						empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
					}
					$this->url(null,$criteria,null,null,null);
				}
				else{
					$this->url(null,$criteria,null,null,$err);
				}
			}
			else{
				if(empty($err)){
					$this->url(null,$criteria,null,$by_kw['error'],null);
				}
				else{
					$this->url(null,$criteria,null,$by_kw['error'],$err);
				}
			}
		}
		else{
			if(empty($by_kw['error'])){
				if(empty($err)){
					$this->url(null,$criteria,$by_dt['error'],null,null);
				}
				else{
					$this->url(null,$criteria,$by_dt['error'],null,$err);
				}
			}
			else{
				if(empty($err)){
					$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],null);
				}
				else{
					$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],$err);
				}
			}
		}
	}

	function groupName($group_id)
	{
		$criteria=" Group.id=".$group_id." ";
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;

	}

	function getCatalog($id)
	{
		switch ($id)
		{
			case '3':
				$result=__('application_info',$return = true);
				break;
			case '2':
				$result=__('security',$return = true);
				break;
			case '1':
				$result=__('system',$return = true);
				break;
		}
		return $result;
	}

	function getType($id)
	{
		switch ($id)
		{
			case '1':
				$result=__('error',$return = true);
				break;
			case '2':
				$result=__('warning',$return = true);
				break;
			case '4':
				$result=__('info',$return = true);
				break;
		}
		return $result;
	}

	function csvdown($criteria=array(),$type=null)
	{
		require_once( 'csv/DlFactory.php' );
		if(!isset($this->data["useevtlog"]["group"])||($this->data["useevtlog"]["group"] == 0)){
			$this_groups =$this->_getUserGroup();
		}
		else {
			$this_groups =$this->data["useevtlog"]["group"];
		}
		$this->data["useevtlog"]["group"] = $this->groupName($this_groups);
		$event_catalog="";
		for($i=0;$i<count($this->data['Useevtlog']['event_catalog_ck']);$i++)
		{
			$event_catalog.=$this->getCatalog($this->data['Useevtlog']['event_catalog_ck'][$i])." ";
		}
		$this->data['Useevtlog']['event_catalog_ck']=$event_catalog;
		$event_type="";
		for($i=0;$i<count($this->data['Useevtlog']['event_type_ck']);$i++)
		{
			$event_type.=$this->getType($this->data['Useevtlog']['event_type_ck'][$i])." ";
		}
		$this->data['Useevtlog']['event_type_ck']=$event_type;
		$dt= date('Y-m-d',time());
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		if(empty($by_kw['error']) && empty($by_dt['error']))
		{
			if(empty($by_dt) && empty($by_kw))
			{
				$criteria[]="datepart(Useevtlog.event_time)= '".$dt."'";
			}
			else
			{
				empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
				empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
			}
		}
		$asso = array('Host : hosts' => array('Useevtlog.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Useevtlog.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		$data = $this->Useevtlog->findByAsso($criteria, array('Useevtlog.event_time', 'Group.group_name','Host.host_name', 'Useevtlog.account', 'Useevtlog.event_catalog','Useevtlog.event_type','Useevtlog.event_id','Useevtlog.source','Useevtlog.specification'), 'Useevtlog.event_time,Group.group_name,Host.host_name,Useevtlog.account,Useevtlog.event_catalog,Useevtlog.event_type,Useevtlog.event_id,Useevtlog.source,Useevtlog.specification', 100000, 1, $asso);
		//$i=0;
		//                 foreach ($data as $result){
		//                 	$data[$i]['Useevtlog']['event_time']='"'.$data[$i]['Useevtlog']['event_time'].'"';
		//                  	$data[$i]['Group']['group_name']='"'.$data[$i]['Group']['group_name'].'"';
		//                  	$data[$i]['Host']['host_name']='"'.$data[$i]['Host']['host_name'].'"';
		//                  	$data[$i]['Useevtlog']['account']='"'.$data[$i]['Useevtlog']['account'].'"';
		//                   	$data[$i]['Useevtlog']['event_id']='"'.$data[$i]['Useevtlog']['event_id'].'"';
		//                   	$data[$i]['Useevtlog']['source']='"'.$data[$i]['Useevtlog']['source'].'"';
		//                    	$data[$i]['Useevtlog']['specification']='"'.$data[$i]['Useevtlog']['specification'].'"';
		//                    	$i++;
		//  }
		if($type=='csv'){
			$csv = DlFactory::create("use_evtlogs");
			$csv->sendCSVFile($data,$this->data,__('eventlog',$return = true));
		}
		elseif($type=='xml')
		{
			$xml = DlFactory::createxml("use_evtlogs");
			$xml->sendXMLFile($data,$this->data,__('eventlog',$return = true));exit;
		}
	}

	function url($type=null,& $criteria=array(),$err1=null,$err2=null,$err3=null)
	{
		$this->layout='ajax';
		$errorMessage = array();
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', '0&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Useevtlog-event_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Buseevtlog%5D%5Bgroup%5D=1&data%5BUseevtlog%5D%5Bevent_catalog%5D=0&data%5BUseevtlog%5D%5Bevent_type%5D=0&data%5BUseevtlog%5D%5Bevent_id%5D=0&data%5BUseevtlog%5D%5Bevent_id_ck%5D=-1&data%5BUseevtlog%5D%5Bsource%5D=0&data%5BUseevtlog%5D%5Bsource_ck%5D=-1&data%5BUseevtlog%5D%5Bspecification%5D=0&btn1=%E5%AE%9F%E8%A1%8C
');
		}
		//search by event_catalog
		if(isset($this->data['Useevtlog']['event_catalog']))
		{
			if($this->data['Useevtlog']['event_catalog']==1){
				if(isset($this->data['Useevtlog']['event_catalog_ck'])){
					$event_catalog_ck = array();
					foreach($this->data['Useevtlog']['event_catalog_ck'] as $v){
						$event_catalog_ck[] = "Useevtlog.event_catalog = $v";
					}
					$criteria[] = "(".implode(' or ', $event_catalog_ck).")";
				}
				else {
					$errorMessage['check_event_catalog'][] = 'E-00200';
				}
			}
		}
		//search by event_type
		if(isset($this->data['Useevtlog']['event_type']))
		{
			if($this->data['Useevtlog']['event_type']==1){
				if(isset($this->data['Useevtlog']['event_type_ck'])){
					$event_type_ck = array();
					foreach($this->data['Useevtlog']['event_type_ck'] as $v){
						$event_type_ck[] = "Useevtlog.event_type = $v";
					}
					$criteria[] = "(".implode(' or ', $event_type_ck).")";
				}
				else {
					$errorMessage['check_event_type'][] = 'E-00200';
				}
			}
		}
		//search by event_id
		if(isset($this->data['Useevtlog']['event_id']))
		{
			if($this->data['Useevtlog']['event_id']==1){
				if(isset($this->data['Useevtlog']['event_id_t']))
				{
					if(!$this->Lv->is_empty($this->data['Useevtlog']['event_id_t'])){
						if(!$this->Check->checkAllHalf($this->data['Useevtlog']['event_id_t']) || !$this->Validation->maxLength($this->data['Useevtlog']['event_id_t'],5)){
							if(!$this->Check->checkAllHalf($this->data['Useevtlog']['event_id_t'])){
								//xushanning start 2009/04/22   mofify for LogvillageChinese
								//$errorMessage['event_id'][] = 'E-00400';
								$errorMessage['set_event_id'][] = 'E-00400';
								//xushanning end 2009/04/22   mofify for LogvillageChinese
							}
							if(!$this->Validation->maxLength($this->data['Useevtlog']['event_id_t'],5)){
								//xushanning start 2009/04/22   mofify for LogvillageChinese
								//$errorMessage['event_id'][] = 'E-00300';
								$errorMessage['set_event_id'][] = 'E-00300';
								//xushanning end 2009/04/22   mofify for LogvillageChinese
							}
						}
						else{
							if($this->data['Useevtlog']['event_id_ck']==0){
								//wangs start 20080202
								//$criteria[]=" Useevtlog.event_id like '%".$this->data['Useevtlog']['event_id_t']."%' ";
								$criteria[]=" lower(Useevtlog.event_id) like '%".strtolower($this->Lv->spec_char_like($this->data['Useevtlog']['event_id_t']))."%' ";
								//wangs end 20080202
							}
							else{
								//wangs start 20080202
								//$criteria[]=" Useevtlog.event_id='".$this->data['Useevtlog']['event_id_t']."' ";
								$criteria[]=" lower(Useevtlog.event_id)='".strtolower($this->Lv->spec_char_dbm($this->data['Useevtlog']['event_id_t']))."' ";
								//wangs end 20080202
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Useevtlog']['event_id_t'])){
						//xushanning start 2009/04/22   mofify for LogvillageChinese
						//$errorMessage['event_id'][] = 'E-00100';
						$errorMessage['set_event_id'][] = 'E-00100';
						//xushanning end 2009/04/22   mofify for LogvillageChinese
					}
				}
			}
		}
		//search by source
		if(isset($this->data['Useevtlog']['source']))
		{
			if($this->data['Useevtlog']['source']==1){
				if(isset($this->data['Useevtlog']['source_t']))
				{
					if(!$this->Lv->is_empty($this->data['Useevtlog']['source_t'])){
						if(!$this->Check->checkAllHalf($this->data['Useevtlog']['source_t']) || !$this->Validation->maxLength($this->data['Useevtlog']['source_t'],127)){
							if(!$this->Check->checkAllHalf($this->data['Useevtlog']['source_t'])){
								$errorMessage['check_event_source'][] = 'E-00400';
							}
							if(!$this->Validation->maxLength($this->data['Useevtlog']['source_t'],127)){
								$errorMessage['check_event_source'][] = 'E-00300';
							}
						}
						else{
							if($this->data['Useevtlog']['source_ck']==0){
								//wangs start 20080202
								//$criteria[]=" Useevtlog.source like '%".$this->data['Useevtlog']['source_t']."%' ";
								$criteria[]=" lower(Useevtlog.source) like '%".strtolower($this->Lv->spec_char_like($this->data['Useevtlog']['source_t']))."%' ";
								//wangs end 20080202
							}
							else{
								//wangs start 20080202
								//$criteria[]=" Useevtlog.source='".$this->data['Useevtlog']['source_t']."' ";
								$criteria[]=" lower(Useevtlog.source)='".strtolower($this->Lv->spec_char_dbm($this->data['Useevtlog']['source_t']))."' ";
								//wangs end 20080202
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Useevtlog']['source_t'])){
						$errorMessage['check_event_source'][] = 'E-00100';
					}
				}
			}
		}
		//search by specification
		if(isset($this->data['Useevtlog']['specification']))
		{
			if($this->data['Useevtlog']['specification']==1){
				if(isset($this->data['Useevtlog']['specification_t']))
				{
					if(!$this->Lv->is_empty($this->data['Useevtlog']['specification_t'])){
						if(!$this->Validation->maxLength($this->data['Useevtlog']['specification_t'],2000)){
							$errorMessage['check_event_specification'][] = 'E-00300';
						}
						else{
							//wangs start 20080202
							//$criteria[]=" Useevtlog.specification like '%".$this->data['Useevtlog']['specification_t']."%' ";
							$criteria[]=" lower(Useevtlog.specification) like '%".strtolower($this->Lv->spec_char_like($this->data['Useevtlog']['specification_t']))."%' ";
							//wangs end 20080202
						}
					}
					elseif($this->Lv->is_empty($this->data['Useevtlog']['specification_t'])){
						$errorMessage['check_event_specification'][] = 'E-00100';
					}
				}
			}
		}
		//search by group
		if($this->data['useevtlog']['group']=='0' || empty($this->data['useevtlog']['group']))
		{
			$this->data['useevtlog']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['useevtlog']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		if(!empty($errorMessage) || !empty($err1) || !empty($err2) || !empty($err3)){
			$this->set('errorMessage',$errorMessage);
			$this->set('err1',$err1);
			$this->set('err2',$err2);
			$this->set('err3',$err3);
			$criteria[]="1=2";
		}
		$criteria[]="1=1";
		if($type=='csv'||$type=='xml')
		{
			$this->csvdown($criteria,$type);exit;
		}
		$asso = array('Host : hosts' => array('Useevtlog.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Useevtlog.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/use_evtlogs/contro', 'modelClass'=>'Useevtlog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Useevtlog.event_time, Group.group_name, Host.host_name, Useevtlog.account, Useevtlog.event_catalog, Useevtlog.event_type, Useevtlog.event_id, Useevtlog.source, Useevtlog.specification')));
		$data = $this->Useevtlog->findByAsso($criteria, array('Useevtlog.event_time', 'Group.group_name','Host.host_name', 'Useevtlog.account', 'Useevtlog.event_catalog','Useevtlog.event_type','Useevtlog.event_id','Useevtlog.source','Useevtlog.specification'), $order, $limit, $page, $asso);
		//xinw start 20081202
		//modify for LV20R1-187
		//$log_count=$this->Useevtlog->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso);
		$log_count = $this->Pagination->paging['total'];
		$dir=LOG_LIMIT;
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_event'])) {
			if ($log_count >= $ini_array['LogLimit']['Log_event']) {
				$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_event'].__("E-03900-1",true));
			}
		}
		//xinw end 20081202
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->render('url');
	}
}
?>