<?php
/*********************************************************************
*@filename use_processs_controller.php
*@description UseProcesssController プロセス稼動時間 
*@note 
*@histories  rivision	author		date		comment
*             2.0         yzl     2009/05/05   modify for LV20R1-255
*            2.0        xushanning  2009/04/22  modify for LogvillageChinese
********************************************************************/  
class UseProcesssController extends AppController
{

    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
    var $components = array ('Pagination', 'Lv','Check');
    var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Grpproc','Configure','Validation','Grpapp',
                        'Usehorproc','Usedayproc',
                        );
    var $layout='use';
    //2007/11/14 仕様変更�?�?ーブル追�? begin
    var $modelProc;
    var $modelProcName;
	var $bydate;
    
    //2007/11/14 仕様変更�?�?ーブル追�? end

    function beforeFilter()
    {
        parent::beforeFilter();
        //$this->Host->query("set dump plan on;");

        if(isset($_POST['forHideVar'])){
            $this->set('forHideVar', $_POST['forHideVar']);
        }
        else if(isset($_POST['forHideVar1'])){

            $this->set('forHideVar', $_POST['forHideVar1']);
        }
    }
    function application()
    {

        $this->layout='ajax';
        if($this->data['Useproc']['group']!=1)
        {
            $criteria="Grpproc.group_id=".$this->data['Useproc']['group'];
        }else{
            $criteria="Grpproc.disp_name!=''";
        }
        $rows=$this->Grpproc->findAll($criteria, 'Grpproc.disp_name', 'Grpproc.id');

        $slist=array();
        $count_row=count($rows);
        for($i=0;$i<$count_row;$i++)
        {
            $key=$rows[$i]['Grpproc']['disp_name'];
            $slist[$key]=$key;
        }
        $this->set('slist',$slist);
    }

    function index()
    {
        $this->pageTitle =  __('menu_use',$return = true)."/". __('process',$return = true);
        $slist=array();
        $rows=$this->Grpproc->findAll(array("Grpproc.disp_name!=''"), 'DISTINCT(Grpproc.disp_name),Grpproc.id', 'Grpproc.id');
        $count_row=count($rows);
        for($i=0;$i<$count_row;$i++)
        {
            $key=$rows[$i][0]['disp_name'];
            $slist[$key]=$key;
        }
        $usergroup = $this->getCurrentGroup();///////////////////Session????
        //        $usergroup=1;
        $glist = $this->Group->getChildrenByParent($usergroup);

        //	 $glist[0] =  __('whole',$return = true); // '?????'

        //ksort($glist);
        //?\???????f?[?^???


        $this->set('slist',$slist);
        $this->set('glist',$glist);
        //        $contro= $this->requestAction('/use_processs/contro',array('return'));
        $contro="";
        $this->set('contro',$contro);
    }

    //////////////////////////////////////////?S???O???t?\????R?????????/////////////////////////////////////////////////////////////////

    function contro($type="",$time="",$day="")
    {

        //
        $this->layout='ajax';
        //xuwc 2007/06/01 9:41  begin
        $dt= date('Y-m-d',time());
        //   	$dt="2007-06-07";
        //xuwc 2007/06/01 9:42  end
        $criteria = array();
        $by_kw = $this->Lv->operSearch();
        $by_dt = $this->Lv->optionsDatetime();
        if(!empty($this->data['Host']['host_name']))
        {
            if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
            {
				//xushanning start 2009/04/22  modify for LogvillageChinese
                //$hostname_error[]=__('E-00400',$return = true);
				$hostname_error[]=__('errAllHalf',$return = true);
                //xushanning end 2009/04/22  modify for LogvillageChinese
            }
            if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
            {
				//xushanning start 2009/04/22  modify for LogvillageChinese
                //$hostname_error[]=__('E-00300',$return = true);
				$hostname_error[]=__('errMaxLength',$return = true);
                //xushanning end 2009/04/22  modify for LogvillageChinese
            }
        }
        if(empty($this->data['Useproc']['disp_name']) && !empty($this->data))
        {
            $data_error[]=__('data_error',$return = true);
        }

        if(!empty($by_kw['error']) || !empty($by_dt['error']) || !empty($hostname_error)|| !empty($data_error))
        {
            empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
            empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
            empty($hostname_error) ? null : $this->set('hostname_error',$hostname_error);
            empty($data_error) ? null : $this->set('data_error',$data_error);
            $this->render();
            exit();
        }
        //2007/11/14 仕様変更�?�?ーブル追�? begin
//        echo "<pre>";
//        var_dump($this->data);exit;
        if(strlen($this->data['dt_check']['start_day'])==0)
        {
            $start_time=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-01 00:00:00";
            $end_time=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".date("t",strtotime($this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']))." 23:59:59";
        }else{
            $start_time=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day']." 00:00:00";
            if(isset($this->data['dt_check']['end_year']))
            {
                $end_time=$this->data['dt_check']['end_year']."-".$this->data['dt_check']['end_month']."-".$this->data['dt_check']['end_day']." 23:59:59";
            }else{
                $end_time=$start_time;
            }
        }
//        echo $start_time."@@".$end_time;exit;
        $this->set_model_name($start_time,$end_time,$day);
        //2007/11/14 仕様変更�?�?ーブル追�? end

        if(empty($by_dt) && empty($by_kw))
        {
            $criteria[]="datepart(".$this->modelProcName.".polling_time)= '".$dt."'";
        }
        else
        {
            empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
            empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
        }

        if(empty($this->data['Useproc']['disp_name']))
        {
            $rows=$this->Grpproc->findAll(array("Grpproc.disp_name!=''"), 'DISTINCT(Grpproc.disp_name),Grpproc.id', 'Grpproc.id');
            $criteria[]="Grpproc.disp_name = '".$rows[0][0]['disp_name']."'";
            $this->set("processname",$rows[0][0]['disp_name']);
        }else{

            $where[]="Grpproc.disp_name='".$this->Lv->spec_char_dbm($this->data['Useproc']['disp_name'])."'";
            $pronames=$this->Grpproc->findAll($where,"Grpproc.process_name");
            //	     echo "<pre>";
            //	    var_dump($pronames);exit;
            $criteria[]=$this->modelProcName.".process_name = '".$this->Lv->spec_char_dbm($pronames[0]['Grpproc']['process_name'])."'";
            $this->set("processname",$this->data['Useproc']['disp_name']);
        }
        if(empty($this->data['Useproc']['group']))
        {
            $groupid = $this->getCurrentGroup();

            //	    $criteria[]=" Group.id=".$groupid." ";
            $criteria[]=" Grpauth.org_grp_id=".$groupid." ";
        }else{
            //$criteria[]=" Group.id=".$this->data['Useproc']['group']." ";
            $criteria[]=" Grpauth.org_grp_id=".$this->data['Useproc']['group']." ";
        }
        //xuwc 2007/06/20 10:32
        //	empty($_POST['csvhidden']) ? $csvhidden=null : $csvhidden=$_POST['csvhidden'];
        //	echo $csvhidden."##".$_REQUEST['csvhidden']."@@";
//        if($type=='csv'||$type=='xml')
//        {
//            $this->csvdown($criteria,$time,$type);exit;
//        }
        //xuwc 2007/06/20 10:32
        //echo $type;
        ////2007/11/14 仕様変更�?�?ーブル追�? begin
        
	foreach ($criteria as $key=>$value)
        {
            if(preg_match('/Useproc/',$value))
            {
                $criteria[$key]=preg_replace('/Useproc/',$this->modelProcName, $value);
            }
           
        }
        
	////2007/11/14 仕様変更�?�?ーブル追�? end
        if((strlen($type)==0||$type=="date")&&empty($this->data['time_type']))
        {
            $this->init($criteria,$time,$day);
        }
        //else if($type=="time" || $this->data['time_type']=="time")
        else
        {
            if($type=="time")
            {
                $this->set('forHideVar', $_POST['forHideVar']."&data%5Btime_type%5D=time&data%5Btime%5D=$time");
            }
            if(!empty($this->data['time']))
            {
                $time=$this->data['time'];
            }
            $this->time_list($criteria,$time,$type);
        }

    }
    function csvdown($type,$rows)
    {
//                    echo "<pre>";
//            var_dump($rows);exit;
    
        require_once( 'csv/DlFactory.php' );
        if($type=='time_list')
        {

//            for($i=0;$i<count($rows);$i++)
//            {
//                $data[$i]['Useproc']['polling_time']=$rows[$i]['time'];
//                $data[$i]['Group']['group_name']=$rows[$i]['group_name'];
//                $data[$i]['Host']['host_name']=$rows[$i]['hostname'];
//                $data[$i]['Useproc']['process_name']=$rows[$i]['process_name'];
//                if($rows[$i]['status']==0)
//                {
//                    $data[$i]['Useproc']['status']="�?";
//                }else{
//                    $data[$i]['Useproc']['status'] ="�?";
//                }
//                //$data[$i]['Useproc']['status']=$rows[$i]['status'];
//                
//            }
            $csv = DlFactory::create("use_processs");
            $csv->special_cols=array(
                                                "Host/host_name"=>__('hostname',$return=true),
                                                $this->modelProcName."/process_name"=>__('process_name',$return=true),
                                                $this->modelProcName."/polling_time"=>__('polling time',$return=true),
        			                 $this->modelProcName."/min_time"=>__('polling min time',$return=true),
                                                $this->modelProcName."/max_time"=>__('polling max time',$return=true),
                                                $this->modelProcName."/num"=>__('polling num',$return=true),
                                                $this->modelProcName."/usage"=>__('AVG CPU',$return=true),
                                            );
//            echo "<pre>";
//            var_dump($rows);exit;

            $csv->sendCSVFile($rows,$this->data,__('process',$return=true));
//            }elseif($type=='xml')
//            {
//                $xml = DlFactory::createxml("use_processs");
//
//                $xml->sendXMLFile($rows,$this->data,__('process',$return=true)); exit;
//
//            }

        }


        exit;


    }


    //================================????????O==========================================================
    function time_list(& $criteria,$time,$link_type)
    {
//        echo "<pre>";
//        var_dump($criteria);exit;
        $this->layout='ajax';
        $this->set('criteria',$criteria);

        //	$criteria['GROUP BY']=' Useproc.host_id ';

        //	if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
        //		$this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5D=Useproc-polling_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5BUseproc%5D%5Bgroup%5D=0&data%5BUseproc%5D%5Bdomain%5D=-1&data%5BUseproc%5D%5Bdomain%5D=0&data%5BHost%5D%5Bpc_name%5D=&data%5Btype%5D%5Bpc_name%5D=0&data%5BUseproc%5D%5Baccount%5D=&data%5Btype%5D%5Baccount%5D=0&data%5BUseproc%5D%5Bsearch_%5D=&data%5Btype%5D%5Bsearch%5D=0&btn1=%E5%AE%9F%E8%A1%8C&data%5Btime_type%5D=time&data%5Btime%5D='.$time);
        //	}


        //xuwc 2007/06/07 13:47 end
        if(empty($this->data['dt_check']['start_year']))
        {
            $dt=date("Y-m-d");
            //                $dt="2007-06-07";
        }else{
            $dt=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day'];
            //                $dt="2007-06-07";
        }
        //echo $time."@@";exit;
        if($time!='timelist')
        {
            list($year,$month, $day,$hour,$min)=explode("-",$time);
            //            list($year,$month, $day)=explode("-",$dt);
            $tomorrow  = mktime($hour, $min, 0, $month  , $day, $year);
            $dates_start=date("Y-m-d H:i:s",$tomorrow);
            $this->set("dates_start",$dates_start);
            $tomorrowend  = mktime($hour+1, $min, 0, $month  , $day, $year);
            $dates_end=date("Y-m-d H:i:s",$tomorrowend);
            $this->set("dates_end",$dates_end);
            $criteria[]=$this->modelProcName.".polling_time>='".$dates_start."'";
            $criteria[]=$this->modelProcName.".polling_time<'".$dates_end."'";
        }
        $criteriaData=$criteria;
//        unset($criteria[1]);
        //            echo "<pre>";
        //            var_dump($criteria);
        $asso = array('Host : hosts' => array($this->modelProcName.'.host_id = Host.id'),
        'Rlthstgrp : rlthstgrps' => array($this->modelProcName.'.host_id = Rlthstgrp.host_id'),
        'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
        'Grpproc:grpprocs'=>array('Grpproc.process_name = '.$this->modelProcName.'.process_name'),
        'Grpauth : grpauths' => array('Grpauth.group_id = Group.id'),
        );
        //            list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/use_processs/contro', 'modelClass'=>'Useproc', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Useproc.polling_time')));
//        foreach ($criteria as $key=>$value)
//        {
//            if(preg_match('/process_name/',$value))
//            {
//                $criteria[$key]=$this->modelProcName.".process_name = 'System'";
//            }
//           
//        }
//        echo "<pre>";
//        var_dump($criteriaData);
//        echo "<pre>";
//        var_dump($criteria);exit;
        //$dates = $this->modelProc->findByAsso($criteria, array('Useproc.polling_time','Useproc.host_id','Useproc.id'), null,null,null,$asso);
        //$dates = $this->modelProc->findByAsso($criteria, array($this->modelProcName.'.polling_time',$this->modelProcName.'.host_id','Group.group_name'), $this->modelProcName.".polling_time",null,null,$asso);
        $cols=array($this->modelProcName.'.polling_time','Host.host_name',$this->modelProcName.'.process_name'
                        ,$this->modelProcName.'.min_time',$this->modelProcName.'.max_time',$this->modelProcName.'.num'
                        ,$this->modelProcName.'.cpu_system',$this->modelProcName.'.cpu_user');
        $dates = $this->modelProc->findByAsso($criteria,$cols , $this->modelProcName.".polling_time",null,null,$asso);
//        echo "<pre>";
//         var_dump($criteria);
//         echo "<pre>";
//         var_dump($dates);exit;
        $count_date=count($dates);
        for($i=0;$i<$count_date;$i++)
        {
//            $criteriaData[]=$this->modelProcName.".polling_time='".$dates[$i][$this->modelProcName]['polling_time']."'";
//            $criteriaData[]=$this->modelProcName.".host_id=".$dates[$i][$this->modelProcName]['host_id']."";
//            $status=$this->modelProc->findByAsso($criteriaData, array($this->modelProcName.'.host_id'), null,null,null,$asso);
////            echo "<pre>";
////            var_dump($criteriaData);
////            exit;
//
//            $hostname=$this->getHostName($dates[$i][$this->modelProcName]['host_id']);
//            if(count($status)>0)
//            {
//                //                    $data[$i]['status']="�?";
//                $data[$i]['status']=0;
//            }else{
//                //                    $data[$i]['status']="�?";
//                $data[$i]['status']=1;
//            }
//            $data[$i]['useproc_id']=$dates[$i][$this->modelProcName]['host_id'];
//            $data[$i]['hostname']=$hostname;
//            $data[$i]['time']=$dates[$i][$this->modelProcName]['polling_time'];
//            //
//            $data[$i]['process_name']=$this->data['Useproc']['disp_name'];
//            $data[$i]['group_name']=$dates[$i]['Group']['group_name'];
//            //
//            array_pop($criteriaData);
//            array_pop($criteriaData);
            $dates[$i][$this->modelProcName]['usage']=($dates[$i][$this->modelProcName]['cpu_system']+$dates[$i][$this->modelProcName]['cpu_user'])/2;
        }
        if($link_type=='csv')
        {
//            echo "<pre>";
//            var_dump($data);exit;
            $this->csvdown('time_list',$dates);exit;
        }
//        echo "<pre>";
//        var_dump($data);exit;
        //xuwc 2007/08/08 10:24  begin
        $result = $this->modelProc->query('CREATE TEMPORARY TABLE tempuseprocs (id serial, useproc_id integer,status integer, hostname varchar(40),time timestamp )');

        if($result === false){
            debug("CREATE TEMPORARY TABLE failed!", true);
        }
        //�?ータの追�?
        empty($data)?$data=array():$data;
        $count_data=count($data);
        for($i=0;$i<$count_data;$i++)
        {
            $this->modelProc->query("INSERT INTO tempuseprocs VALUES(null,".$data[$i]['useproc_id'].",".$data[$i]['status'].",'".$data[$i]['hostname']."','".$data[$i]['time']."');");
        }
        $asso = array('Host : hosts' => array($this->modelProcName.'.host_id = Host.id'),
        'Rlthstgrp : rlthstgrps' => array($this->modelProcName.'.host_id = Rlthstgrp.host_id'),
        'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
        'Grpproc:grpprocs'=>array('Grpproc.process_name = '.$this->modelProcName.'.process_name'),
        'Grpauth : grpauths' => array('Grpauth.group_id = Group.id'),
        'Tempuseproc : tempuseprocs' => array($this->modelProcName.'.host_id = Tempuseproc.useproc_id'),
        );
        list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/use_processs/contro', 'modelClass'=>$this->modelProcName, 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Tempuseproc.time')));
        $data = $this->modelProc->findByAsso($criteria, array('Tempuseproc.time','Tempuseproc.hostname','Tempuseproc.status'), $order,$limit,$page,$asso);
//        echo "<pre>";
//        var_dump($criteria);exit;
        $count_data=count($data);
        for($i=0;$i<$count_data;$i++)

        {
            if($data[$i]['Tempuseproc']['status']==0)

            {
			//xinw start 20080217
                $data[$i]['Tempuseproc']['status']="○";
            }else{
                $data[$i]['Tempuseproc']['status'] ="×";
            }
            //xinw end 20080217
        }

        $datac = $this->modelProc->findByAsso($criteria, array('Tempuseproc.time','Tempuseproc.hostname','Tempuseproc.status'), "Tempuseproc.time,Tempuseproc.hostname,Tempuseproc.status",null,null,$asso);
        //         $data = $this->modelProc->query("select * from tempuseprocs;");
        //xuwc 2007/08/08 10:24  end
//                echo "<pre>";
//                var_dump($data);exit;

        empty($data)? $data=array():$data;

        $this->set('data',$data);
        $this->set('datac',$datac);
        //         $th
        //         $this->set('th',$th);

        //	$this->Session->write('data', $data);

        $this->render('timelist');


    }
    function uniqueArray($array)

    {

        // Get unique elts as keys in assoc. array

        for ($i=0,$n=count($array, 1);$i<$n;$i++)

        $u_array[$array[$i]] = 1;

        // Copy keys only into another array

        reset($u_array);

        for ($i=0,$n=count($u_array, 1);$i<$n;$i++) {

            $unduplicated_array[] = key($u_array);

            next($u_array);

        }

        return $unduplicated_array;

    }

    //================================???????O???t?\???i?S???O???t?\???j==========================================================
    function init(& $criteria,$time="",$day="")
    {
        if(strlen($time)==0)
        {
            if(!empty($this->data['dt_check']['start_year']))
            {
                $this->set("time_list_date",$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day']);
            }else{
                $this->set("time_list_date",date("Y-m-d"));
            }
        }else{
            $this->set("time_list_date",$time);
        }
        $this->layout='ajax';
        $this->set('criteria',$criteria);
        //xuwc 2007/7/17 begin
        if(empty($this->data['Useproc']['disp_name']))
        {
            $rows=$this->Grpproc->findAll(array("Grpproc.disp_name!=''"), 'DISTINCT(Grpproc.disp_name),Grpproc.id', 'Grpproc.id');
            $disp_name=$rows[0][0]['disp_name'];
        }else{
            $disp_name=$this->data['Useproc']['disp_name'];
        }
        //xuwc 2007/7/17 end
        //	$criteria['GROUP BY']=' Useproc.host_id ';

        if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
            $this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5D=Useproc-polling_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5BUseproc%5D%5Bdisp_name%5D='.$disp_name.'&data%5BUseproc%5D%5Bgroup%5D=0&data%5BUseproc%5D%5Bdomain%5D=-1&data%5BUseproc%5D%5Bdomain%5D=0&data%5BHost%5D%5Bpc_name%5D=&data%5Btype%5D%5Bpc_name%5D=0&data%5BUseproc%5D%5Baccount%5D=&data%5Btype%5D%5Baccount%5D=0&data%5BUseproc%5D%5Bsearch_%5D=&data%5Btype%5D%5Bsearch%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
        }


        if(isset($_POST['blue2']))
        {
            $blue=$_POST['blue2'];
            $yellow=$_POST['yellow2'];

        }else{
            $blue=70;
            $yellow=40;
        }
        $this->set("blue",$blue);
        $this->set("yellow",$yellow);
        //	    echo $_POST['blue2'];
        //xuwc 2007/06/07 13:47 begin
        //            $criteria[]="Useproc.disp_name like '%c%'";

        //xuwc 2007/06/07 13:47 end
        $criteria['GROUP BY']=$this->modelProcName.'.host_id ';


        $asso = array('Host : hosts' => array($this->modelProcName.'.host_id = Host.id'),
        'Rlthstgrp : rlthstgrps' => array($this->modelProcName.'.host_id = Rlthstgrp.host_id'),
        'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
        //										'Grpproc:grpprocs'=>array('Grpproc.process_name = Useproc.process_name'),
        'Grpauth : grpauths' => array('Grpauth.group_id = Group.id'),
        );
        list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/use_processs/contro', 'modelClass'=>$this->modelProcName, 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
        //            echo $order."@@".$limit."##".$page;
        //host_id??擾
        $hosts = $this->modelProc->findByAsso($criteria, array($this->modelProcName.'.host_id'), $this->modelProcName.".host_id",$limit,$page,$asso);
//        echo "<pre>";
//        var_dump($criteria);exit;
        //$hostsc = $this->modelProc->findByAsso($criteria, array('Useproc.host_id'), "Useproc.host_id",null,null,$asso);
        $this->set("hosts",$hosts);
        //$this->set("hostsc",$hostsc);
        if(!empty($this->data) && count($hosts)==0)
        {
            $hostname_error[]= __('data_error',$return = true);
            empty($hostname_error) ? null : $this->set('data_error',$hostname_error);
            $this->render('contro');
            exit();
        }

        //?????擾
        if(empty($this->data['dt_check']['start_year']))
        {
            $dt=date("Y-m-d");
            //                $dt="2007-06-07";
        }else{
            $dt=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day'];
            $this->set("dt",$dt);
            if(isset($this->data['dt_check']['end_year']))
            {
                $dt_end=$this->data['dt_check']['end_year']."-".$this->data['dt_check']['end_month']."-".$this->data['dt_check']['end_day'];

                $this->set("dt_end",$dt_end);
            }
        }
        //            echo "<pre>";
        //            var_dump($this->data);
        //?I????I???????
        if(((empty($this->data['dt_check']['end_year'])||($this->data['dt_check']['start_year'].$this->data['dt_check']['start_month'].$this->data['dt_check']['start_day']==$this->data['dt_check']['end_year'].$this->data['dt_check']['end_month'].$this->data['dt_check']['end_day']))&&(isset($this->data['dt_check']['start_day']) && strlen($this->data['dt_check']['start_day'])>0))||$day=="day" )
        {

            if($day=="day")
            {
                //                    echo $time."##";
                $dates=$this->getDates($time);
            }else{
                $dates=$this->getDates($dt);
            }

            //?^?C?g????擾
            $count_date=count($dates)-1;
            for($i=0;$i<$count_date;$i++)
            {
                $str=strtotime($dates[$i]);
                $time=date("H:i",$str);
                $th[]=$time;
            }
            unset($criteria['GROUP BY']);
            $count_hosts=count($hosts);

            for($i=0;$i<$count_hosts;$i++)
            {
                $host_id=$hosts[$i][$this->modelProcName]['host_id'];
                $hostname=$this->getHostName($host_id);
                $key=$hostname."##".$host_id;
                //                     $str=strtotime($dates[$j]);
                //                     $time=date("H:i",$str);
                $criteria[]=$this->modelProcName.".host_id=".$hosts[$i][$this->modelProcName]['host_id']."";
                List($result,$systems,$pstimes)=$this->getGroupViewData($criteria);
                $result=set::extract($result,"{n}.".$this->modelProcName.".polling_time");
//                 echo "<pre>";
//                  var_dump($result);exit;
                $count_dates=count($dates)-1;
                for($j=0;$j<$count_dates;$j++)
                {
                    
                    $count_result=count($result);
                    $count_pstime=count($pstimes);
                    $count_systems=count($systems);
                    $index=0;
                    //process
                    for($k=0;$k<$count_pstime;$k++)
                    {
                        $usage_system=array();

                        if($pstimes[$k][$this->modelProcName]['polling_time']>=$dates[$j] && $pstimes[$k][$this->modelProcName]['polling_time']<$dates[$j+1] && in_array($pstimes[$k][$this->modelProcName]['polling_time'],$result))
                        {
                            $index=$pstimes[$k][$this->modelProcName]['num'];
                        }
                        
                    }
                    //system 
                    $system_index=-1;
                    for($k=0;$k<$count_systems;$k++)
                    {
                        $usage_system=array();

                        if($systems[$k][$this->modelProcName]['polling_time']>=$dates[$j] && $systems[$k][$this->modelProcName]['polling_time']<$dates[$j+1] )
                        {
                            $system_index=$systems[$k][$this->modelProcName]['num'];
                        }
                        
                    }

//                    echo $index."@@".$system_index."<br>";
                    if($system_index==-1)
                    {
                        $data[$key][]['count']=-1;
                    }else{
                        $data[$key][]['count']=($index/$system_index)*100;
                    }
                    //$data[$key][]['count']=($index/$system_index)*100;

                }
                
                array_pop($criteria);
            }
//                            echo "<pre>";
//                            var_dump($data);exit;
            //                $this->set("datetimeflag","time");
        }else{
            //?I????I??????A??????J?n??????????邱???
            if(strlen($time)==0)
            {
                if(isset($this->data['startDate']))
                {
                    $time=$this->data['startDate'];
                }
            }
            if(strlen($time)>0)
            {
                $this->set('forHideVar', $_POST['forHideVar']."&data%5BstartDate%5D=$time");
                list($year1,$month1,$day1)=explode("-",$time);
                list($th,$dates)=$this->getDetailDate($year1,$month1,$day1,$this->data['dt_check']['end_year'],$this->data['dt_check']['end_month'],$this->data['dt_check']['end_day']);
            }else{
                //xuwc 2007/07/30 16:20  begin
                if(strlen($this->data['dt_check']['start_day'])==0)

                {
                    $end_day= date("t",strtotime($this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']));
                    $this->set("showflag",1);
                    list($th,$dates)=$this->getDetailDate($this->data['dt_check']['start_year'],$this->data['dt_check']['start_month'],01,$this->data['dt_check']['start_year'],$this->data['dt_check']['start_month'],$end_day);
                }else{
                    list($th,$dates)=$this->getDetailDate($this->data['dt_check']['start_year'],$this->data['dt_check']['start_month'],$this->data['dt_check']['start_day'],$this->data['dt_check']['end_year'],$this->data['dt_check']['end_month'],$this->data['dt_check']['end_day']);
                }
                //xuwc 2007/07/30 16:20  end

            }
            //                echo "<pre>";
            //
            //                 var_dump($th);exit;
            unset($criteria['GROUP BY']);
            //                echo "<pre>";
            //                var_dump($dates);exit;
            $count_hosts=count($hosts);
            for($i=0;$i<$count_hosts;$i++)
            {
                $host_id=$hosts[$i][$this->modelProcName]['host_id'];
                $hostname=$this->getHostName($host_id);
                $key=$hostname."##".$host_id;
                //                     $str=strtotime($dates[$j]);
                //                     $time=date("H:i",$str);
                $criteria[]=$this->modelProcName.".host_id=".$hosts[$i][$this->modelProcName]['host_id']."";
                List($result,$systems,$pstimes)=$this->getGroupViewData($criteria);
                $result=set::extract($result,"{n}.".$this->modelProcName.".polling_time");
//                echo "<pre>";
//                var_dump($pstimes);exit;

                $count_dates=count($dates);
                for($j=0;$j<$count_dates;$j++)
                {
                    
                    $count_result=count($result);
                    $count_pstime=count($pstimes);
                    $count_systems=count($systems);
                    //process
                    $index=0;
                    for($k=0;$k<$count_pstime;$k++)
                    {
                        $usage_system=array();
						$date = $pstimes[$k][$this->modelProcName]['polling_time'];
						if (strpos($date, " ") === TRUE)
							list($date,$time)=explode(" ",$date);
                        if($date==$dates[$j] && in_array($pstimes[$k][$this->modelProcName]['polling_time'],$result))
                        {
                            $index=$pstimes[$k][$this->modelProcName]['num'];
                        }
                        
                    }
                    //system 
                    $system_index=-1;
                    for($k=0;$k<$count_systems;$k++)
                    {
                        $usage_system=array();
						$date = $systems[$k][$this->modelProcName]['polling_time'];
						if (strpos($date, " ") === TRUE)
							list($date,$time)=explode(" ",$date);

                        if($date==$dates[$j] )
                        {
                            $system_index=$systems[$k][$this->modelProcName]['num'];
                        }
                        
                    }

//                    echo $index."@@".$system_index."##"."<br>";
//                    var_dump($index,$count_systems);
                    if($system_index==-1)
                    {
                        $data[$key][]['count']=-1;
                    }else{
                        $data[$key][]['count']=($index/$system_index)*100;
                    }
//                    echo 10/58;
                    //$data[$key][]['count']=($index / $system_index)*100;

                }
                array_pop($criteria);
            }
            empty($data)? $data=array():$data;

//                            echo "<pre>";
//                            var_dump($data);
            $this->set("last_date",$dates[0]);
            list($year2,$month2,$day2)=explode("-",$dates[0]);
            $tomorrow  = mktime(0, 0, 0, $month2-1  , $day2, $year2);
            $last_start_date=date("Y-m-d",$tomorrow);
            $this->set("last_start_date",$last_start_date);
            $this->set("next_date",$dates[count($dates)-1]);
            list($year,$month,$day)=explode("-",$dates[count($dates)-1]);
            $tomorrow  = mktime(0, 0, 0, $month  , $day+1, $year);
            $startDate=date("Y-m-d",$tomorrow);
            $this->set("startDate",$startDate);

            $this->set('data',$data);
            $this->set('dates',$dates);
            $this->set('th',$th);

            $this->render('dates');
            exit;
        }
        //


        empty($data)? $data=array():$data;
        //       echo "1111";
        //       echo "<pre>";
        //        var_dump($data);exit;
        //       empty($th)? $th=array():$th;

        $this->set('data',$data);
        //         echo "<pre>";
        //         var_dump($th);
        $this->set('th',$th);

        $this->render('init');


    }
    function getDetailDate($syear,$smonth,$sday,$eyear,$emonth,$eday)
    {
        $start=mktime(0,0,0,$smonth ,$sday,$syear);
        $start_to=mktime(0,0,0,$smonth+1 ,$sday,$syear);
        $end=mktime(0,0,0,$emonth ,$eday,$eyear);
        if($start_to <=$end)
        {
            $days=$this->day($syear,$smonth,$sday,$syear,$smonth+1,$sday);
        }else{
            $days=$this->day($syear,$smonth,$sday,$eyear,$emonth,$eday);
            //xuwc 2007/08/08 9:49  begin
            if($smonth==$emonth)

            {

                $days=$days+1;
            }
            //xuwc 2007/08/08 9:49  end
        }
        for($i=0;$i< $days;$i++)
        {
            $tomorrow  = mktime(0, 0, 0, $smonth  , $sday+$i, $syear);
            $dates[]=date("Y-m-d",$tomorrow);
            $th[]=date("m/d",$tomorrow);
        }
        $array=array($th,$dates);
        //        echo $days."@@";
        //        echo "<pre>";
        //        var_dump($dates);
        return $array;
    }
    function day($syear,$smonth,$sday,$eyear,$emonth,$eday)
    {
        $start=mktime(0,0,0,$smonth ,$sday,$syear);
        $end=mktime(0,0,0,$emonth ,$eday,$eyear);

        $days=round(($end-$start)/3600/24);
        return $days;
    }


    function getDates($date)
    {
        list($year,$month,$day)=explode("-",$date);
        //for($i=0;$i< 24;$i++)
        for($i=-1;$i< 24;$i++)
        {
            $tomorrow  = mktime(1+$i, 0, 0, $month  , $day, $year);
            $dates[]=date("Y-m-d H:i:s",$tomorrow);


        }
        //            echo "<pre>";
        //            var_dump($dates);
        return $dates;
    }


    function getGroupViewData($crit)
    {
		$criteria = $crit;
		if($this->bydate){
			$criteria['GROUP BY']= "date(".$this->modelProcName.'.polling_time) ';
		}//debug($criteria);
        $asso = array('Host : hosts' => array($this->modelProcName.'.host_id = Host.id'),
        'Rlthstgrp : rlthstgrps' => array($this->modelProcName.'.host_id = Rlthstgrp.host_id'),
        'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
        //										'Grpproc:grpprocs'=>array('Grpproc.process_name = Useproc.process_name'),
        'Grpauth : grpauths' => array('Grpauth.group_id = Group.id'),
        );
        //        list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/use_processs/contro', 'modelClass'=>'Useproc', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
        //        $rows = $this->modelProc->findByAsso($criteria, array('count(*) as count','sum(Useproc.cpu_system) as cpu_system'), 'count',null,null,$asso);
        if($this->bydate){
		$cols=array(
			$this->modelProcName.'.process_name',
			'date('.$this->modelProcName.'.polling_time)'.' as '.$this->modelProcName.'__polling_time',
			'sum('.$this->modelProcName.'.cpu_system*'.$this->modelProcName.'.num)'.'/sum('.$this->modelProcName.'.num)'.' as '.$this->modelProcName.'__cpu_system',
			'sum('.$this->modelProcName.'.cpu_user*'.$this->modelProcName.'.num)'.'/sum('.$this->modelProcName.'.num)'.' as '.$this->modelProcName.'__cpu_user',
			'sum('.$this->modelProcName.'.num)'.' as '.$this->modelProcName.'__num');
		}else{
		$cols=array(
			$this->modelProcName.'.process_name',
			$this->modelProcName.'.polling_time',
			$this->modelProcName.'.cpu_system',
			$this->modelProcName.'.cpu_user',
			$this->modelProcName.'.num');
		}
        $rows = $this->modelProc->findByAsso($criteria, $cols, null,null,null,$asso);
        
        //xuwc 2007/08/29 begin
        //$criteria[1]="Useproc.process_name = 'System'";
        $criteria_pltimes=$criteria;
        foreach ($criteria as $key=>$value)
        {
            if(preg_match('/process_name/',$value))
            {
            	// chenhao start 20080129
                // $criteria[$key]=$this->modelProcName.".process_name = 'System'";
                // yzl start 2009/05/05 modify for LV20R1-255
                // $criteria[$key]=$this->modelProcName.".process_name = 'SYSTEM'";
                $criteria[$key]= "UPPER(".$this->modelProcName.".process_name".") = 'SYSTEM'";
                // yzl end 2009/05/05 modify for LV20R1-255
                // chenhao end 20080129
            }
           
        }
        $systems = $this->modelProc->findByAsso($criteria, $cols, null,null,null,$asso);
//         echo "<pre>";
//               var_dump($criteria);exit;

        //unset($criteria[1]);
//        foreach ($criteria as $key=>$value)
//        {
//            if(preg_match('/process_name/',$value))
//            {
//                unset($criteria[$key]);
//            }
//           
//        }
//        echo "<pre>";
//        var_dump($criteria);exit;
        //$criteria["GROUP BY"]=$this->modelProcName.".polling_time";
		if($this->bydate){
		$col2s=array(
		"date(".$this->modelProcName.".polling_time) as ".$this->modelProcName."__polling_time",
		"sum(".$this->modelProcName.".num) as ".$this->modelProcName."__num"
		);
		}else{
		$col2s=array(
		$this->modelProcName.".polling_time",
		$this->modelProcName.'.num'
		);
		}
        $pltimes=$this->modelProc->findByAsso($criteria_pltimes,$col2s,$this->modelProcName.".polling_time",null,null,$asso);
        //xuwc 2007/08/29 end
               

        //        if(count($rows)>0)
        //        {
        //            $percent=$rows[0][0]['count']*100;
        //            if($percent==0)
        //            {
        //                $percent=1;
        //            }
        //            $data['count']=ceil($rows[0][0]['cpu_system']/$percent);
        //        }else{
        //            $data['count']=0;
        //        }
//                echo "<pre>";
//                var_dump($rows);exit;
        return array($rows,$systems,$pltimes);

    }

    function getHostName($hostid)

    {

        $criteria[]="Host.id=".$hostid;
        $result=$this->Host->findAll("Host.id=".$hostid, 'Host.host_name');
        //        echo "<pre>";
        //        var_dump($result);
        if(count($result)>0)

        {
            return $result[0]['Host']['host_name'];
        }
        return "";
    }
    function getCurrentGroup()
    {
        $groupid=$this->_getUserGroup();
        return $groupid;
    }
    function   DateDiff($date1,$date2)
    {
        $time=strtotime($date1)-strtotime($date2);
        return round($time/60);
    }
    function set_model_name($start_time,$end_time,$day)
    {
        if($day=='day')
        {
            $units=1;
        }else{
    	   $units=$this->Lv->get_units_proc($start_time,$end_time);
        }
    	if($units==1)//時間単�?


    	{
            $this->modelProc= $this->Usehorproc;
            $this->modelProcName="Usehorproc";
            $this->bydate = false;
			
    	}else if($units==2)//日単�?


    	{
    	    $this->modelProc= $this->Usehorproc;
            $this->modelProcName="Usehorproc";
			$this->bydate = true;
    	}
	
    }
}
?>