<?php
/*********************************************************************
*@filename system_mng_sfws_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0          zhangs     2008/12/04    modify for timeout
*            2.0         yzl        2009/05/05    modify for LV20R1-256
*            2.0         kitazume        2010/04/27    ライセンス超過
********************************************************************/
class UseUpdateProgramsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Updateprogram','Grpauth','Host','Rlthstgrp','Group');
	var $layout='use';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('title',$return = true);// 'LVシステム管理／全体設定／センサー';
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($lk=null,$sc=null,$hid=null,$errorMessage=null)
	{
		if(!empty($lk)&&!empty($sc))
		{
			$this->set('lk',$lk);
			$this->set('sc',$sc);
			$this->set('hid',$hid);
		}
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	function lists($link=null,$search=null,$group_id=null,$version=null,$maker=null,$pag=null)
	{
		$this->layout="ajax";
		if(isset($search))
		{
			$search=$this->Lv->url_param_decode2($search);
		}
		if(isset($maker))
		{//debug($this->params);
			$maker=$this->Lv->url_param_decode2($maker);
		}
		if(isset($version))
		{
			$version=$this->Lv->url_param_decode2($version);
		}
		$err=null;
		$searchE=rawurlencode(rawurlencode($search));
		$makerE=rawurlencode(rawurlencode($maker));
		$versionE=rawurlencode(rawurlencode($version));	
		if($link=="hs"||$link=="hm")
		{
			!empty($search)? $this->set('forHideVar', $_POST['forHideVar1']."&data%5BUpdateprogram%5D%5Bsearc%5D=$searchE&data%5BUpdateprogram%5D%5Bgroup_name%5D=$group_id&data%5BUpdateprogram%5D%5Bversion%5D=$versionE&data%5BUpdateprogram%5D%5Bmaker%5D=$makerE&data%5BUpdateprogram%5D%5Blink%5D=$link")  : null;
		}
		elseif($link!="hs"&&$link!="hm")
		{
			!empty($search)&&$this->data['Updateprogram']['searc']!=$search? $this->set('forHideVar',  $_POST['forHideVar']."&data%5BUpdateprogram%5D%5Bsearc%5D=$searchE&data%5BUpdateprogram%5D%5Bgroup_name%5D=$group_id&data%5BUpdateprogram%5D%5Bversion%5D=$versionE&data%5BUpdateprogram%5D%5Bmaker%5D=$makerE&data%5BUpdateprogram%5D%5Blink%5D=$link")  : null;
			if($link=="pg")
			{
				$this->set('forHideVar',  $_POST['forHideVar']."&data%5BUpdateprogram%5D%5Bsearc%5D=&data%5BUpdateprogram%5D%5Bgroup_name%5D=&data%5BUpdateprogram%5D%5Bversion%5D=$versionE&data%5BUpdateprogram%5D%5Bmaker%5D=$makerE&data%5BUpdateprogram%5D%5Blink%5D=$link");
			}	
				
		}
		if(empty($search)&&!empty($link))
		{
		}
		if(!empty($this->data['Updateprogram']['group_name'] )&&!empty($this->data['Updateprogram']['version'])&&!empty($this->data['Updateprogram']['maker'])&&!empty($this->data['Updateprogram']['link']))
		{			
			if(empty($search)){
				empty($this->data['Updateprogram']['searc'])?   $search= $this->data['Updateprogram']['sinput'] : $search= $this->data['Updateprogram']['searc'];
			}
			empty($group_id)? $group_id=$this->data['Updateprogram']['group_name']  : null;
			empty($version)? $version=$this->data['Updateprogram']['version']  : null;
			empty($maker)? $maker=$this->data['Updateprogram']['maker'] : null;
			empty($link)? $link=$this->data['Updateprogram']['link'] : null;
		}
		if(!empty($this->data['Updateprogram']['group_name'] ))
		{
			empty($group_id)? $group_id=$this->data['Updateprogram']['group_name']  : null;
		}
		if(!empty($this->data['Updateprogram']['version']))
		{
			empty($version)? $version=$this->data['Updateprogram']['version']  : null;
		}
		if(!empty($this->data['Updateprogram']['maker']))
		{
			empty($maker)? $maker=$this->data['Updateprogram']['maker'] : null;
		}
		if(!empty($this->data['Updateprogram']['link']))
		{
			empty($link)? $link=$this->data['Updateprogram']['link'] : null;
		}
		if(!empty($this->data['Updateprogram']['searc']))
		{
			empty($search)?   $search= $this->data['Updateprogram']['searc'] : null;
		}
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);
		$this->set('search','');
		$this->set('search_h','');
		$conditions=array('1=1');
		
		if(isset($search)&&($link=='hm'))
		{
			$conditions[]=" lower(Updateprogram.maker) = '".strtolower($this->Lv->spec_char_dbm($search))."'";
		}
		if(isset($search)&&($link=='hs'))
		{
			$conditions[]=" lower(Updateprogram.name) = '".strtolower($this->Lv->spec_char_dbm($search))."' and  Updateprogram.host_id= ".$group_id."";
		}
		if(!empty($this->data['Updateprogram']['sinput']))
		{
			$sinput=$this->data['Updateprogram']['sinput'];
			$conditions[]="lower(Updateprogram.name) like '%".strtolower($this->Lv->spec_char_like($sinput))."%'";
			$this->set('search',__('key left',true).$sinput.__('key right',true));
			$this->set('search_h',$sinput);
		}
		if(isset($search)&&($link=='1'||$link=='csv'))
		{//メーカー名をクリック
			$this->set('search_h',$search);
			$conditions[]=" lower(Updateprogram.maker) = '".strtolower($this->Lv->spec_char_dbm($search))."'  ";
			$this->set('search',__('make right',true).$search.__('key right',true));
		}
		elseif (isset($search) && ($link=='2'||$link=='csv1'))
		{//名前をクリック$link=='2'
			if($version=="null")
			{
				$version=null;
			}else if($version=="empty")
				$version="";
			if($maker=="null")
			{
				$maker="";
			}
			if($search == null){
				$conditions[] = '1=1';
			}else{
				$conditions[] = "lower(Updateprogram.name) = '".strtolower($this->Lv->spec_char_dbm($search))."'";
			}
			if(is_null($version)){
				$conditions[] = '1=1';
			}else{//echo "<br>".$version;
				$conditions[] = "Updateprogram.version = '".$this->Lv->spec_char_dbm($version)."'";
			}
			if($maker == null){
				$conditions[] = '1=1';
			}else{
				$conditions[] = "lower(Updateprogram.maker) = '".strtolower($this->Lv->spec_char_dbm($maker))."'";
			}
			if(!empty($this->data['Updateprogram']['sinput']))
			{
				$this->set('sfname',$this->data['Updateprogram']['sinput']);
			}
			else
			{
				$this->set('sfname',$search);
			}
		}
		elseif (isset($search)&&$link=='1_maker')
		{
			$this->set('search_h',$search);
			$conditions[]=" lower(Updateprogram.maker) = '".strtolower($this->Lv->spec_char_dbm($search))."'  ";
			$this->set('search',__('make right',true).$search.__('key right',true));
		}

		$asso = array( 
		'Rlthstgrp : rlthstgrps' => array('Updateprogram.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
		);
		
			$asso_timeout = array(
		'Rlthstgrp : rlthstgrps' => array('Updateprogram.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		'Host : hosts' => array('Host.id = Rlthstgrp.host_id')
		);
		if(!empty($group_id))
		{
			$grp_in=$group_id;
		}
		elseif(!empty($this->data['Group']['group_name']))
		{
			$grp_in=$this->data['Group']['group_name'];
		}
		else
		{
			$grp_in=$this->_getUserGroup();
		}
		$grpin=$this->Grpauth->getChildrenByParent($grp_in);
		$grp_condition="";
		foreach($grpin as $key => $value){
			$grp_condition.=$key.",";
		}
		$grp_condition = substr($grp_condition,0,-1);
		if(isset($grp_condition))
			$conditions[] = "Group.id in (".$grp_condition.")";

		
		$conditions_lis=array_merge($conditions,array('GROUP BY'=>'Updateprogram.name,Updateprogram.maker,Updateprogram.version'));
		$field_lis = array(
			'Updateprogram.name',
			'Updateprogram.maker',
			'Updateprogram.version',
			'count(distinct(Updateprogram.host_id)) as Updateprogram__host_ids');
			
		$hcount= $conditions ;
		$data_p_conditons = array_merge($conditions,array('GROUP BY'=>'Updateprogram.name,Updateprogram.maker,Updateprogram.version '));
		
		//PC台数
		$asso_pccount = array( 
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id')
		);
		$data1 = $this->Host->findByAsso(array('Rlthstgrp.group_id in ('.$grp_condition.')',"Host.status!= 1", "Host.ostype = 1"), array('Host.id'), null, null, null, $asso_pccount);
		
	//	$data1 = $this->Updateprogram->findByAsso($hcount, array('distinct(Updateprogram.host_id) as Updateprogram__host_ids'), null, null, null, $asso);
		$counthost=0;
		foreach ($data1 as $da)
		{
			$counthost++;
		}
		if(!empty($counthost))
		{
			$data_all = $this->Host->findAll(array("Host.status!= 1", "Host.ostype = 1"), array(' Host.id'), null, null, null);
		
			$this->set('data_all',count($data_all));
			$this->set('data1',$counthost);
		}
		else
		{
			$this->set('data1','0');
		}
		
		$conditions=array_merge($conditions,array('GROUP BY'=>'Updateprogram.name,Updateprogram.maker,Updateprogram.version'));
		$get = array(
			"CASE WHEN dataflag = 1 THEN Updateprogram.name 
				WHEN dataflag = 2 THEN Updateprogram.name 
				WHEN dataflag = 3 THEN Updateprogram.name 
				WHEN dataflag = 4 AND parent_name = 'Update' AND name like '%_Microsoft-Windows-CameraCodec-Package' THEN 'Microsoft Camera Codec Pack' 
				WHEN dataflag = 4 AND parent_name = 'Update' THEN concat('Microsoft Windows (', name, ') の 更新プログラム') 
				WHEN dataflag = 4 AND parent_name = 'Security Update' THEN concat('Microsoft Windows (', name, ') の セキュリティ更新プログラム') 
				WHEN dataflag = 4 AND parent_name = 'Hotfix' THEN concat('Microsoft Windows (', name, ') の 修正プログラム') 
				END as Updateprogram__dispname",
			'Updateprogram.name',
			"CASE WHEN dataflag = 4 THEN 'Microsoft Corporaion' 
				ELSE Updateprogram.maker
				END as Updateprogram__dispmaker",
			'Updateprogram.maker',
			'Updateprogram.version',
			"CASE WHEN dataflag = 4 THEN 'Microsoft Windows' 
				ELSE Updateprogram.parent_name
				END as Updateprogram__parent_dispname",
			'Updateprogram.parent_name',
			'count(distinct(Updateprogram.host_id)) as Updateprogram__host_ids',
			'count(distinct(Updateprogram.host_id)) = '.$counthost.' as Updateprogram__host_all');
		
		$csvcondition = $conditions;
		list($order,$limit,$page) = $this->Pagination->init($csvcondition, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/use_update_programs/lists', 'modelClass'=>'Updateprogram', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),  'style' => 'ajax','sortBy' => $this->Lv->sortBy('Updateprogram__parent_dispname, Updateprogram__dispname')));
		if($link=='csv'){
			$data = $this->Updateprogram->findByAsso($csvcondition, $get, $order, null, null, $asso);
		}else{
			$data = $this->Updateprogram->findByAsso($csvcondition, $get, $order, $limit, $page, $asso);
		}

		$version_check_ok = 'version_check_ok';
		$this->set('version_check_ok',$version_check_ok);
		

		$i='0';

		$x='0';
		
		
		if (isset($search)&&($link=='2' ||$link=='csv1'))  //==ライセンス情報
		{//名前をクリック
			$asso1 = array(
			'Rlthstgrp : rlthstgrps' => array('Updateprogram.host_id = Rlthstgrp.host_id'),
			'Host : hosts' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups : LEFT' => array('Group.id = Rlthstgrp.group_id'),
			);

			if(isset($cond))
				$conditions_lis[]="Group.id in(".$cond.")";
			$data_lis = $this->Updateprogram->findByAsso($conditions_lis, $field_lis, null, null, null, $asso1);

		
			$data_csv1 = $this->Updateprogram->findByAsso($data_p_conditons, array('Updateprogram.name','Updateprogram.maker','Updateprogram.version','count(distinct(Updateprogram.host_id)) as Updateprogram__host_ids'), $order, $limit, $page, $asso);
			$m = 0;
			foreach ($data_csv1 as $datafor_csv1)
			{
				foreach ($data_lis as $datafor_list)
				{
					if($datafor_csv1['Updateprogram']['name']==$datafor_list['Updateprogram']['name']
					&&$datafor_csv1['Updateprogram']['maker']==$datafor_list['Updateprogram']['maker']
					&&$datafor_csv1['Updateprogram']['version']==$datafor_list['Updateprogram']['version']
					)
					{
						$data_csv1[$m]['Updateprogram']['licens']=$datafor_list['Updateprogram']['ids'];
					}
				}
				$m++;
			}
			if(!empty($search) && $search!=null){
				$search_con = "lower(Updateprogram.name) = '".strtolower($this->Lv->spec_char_dbm($search))."'";
			}else{
				$search_con = "1=1";
			}
			
			if(!is_null($version)){
				$version_con = "Updateprogram.version = '".$this->Lv->spec_char_dbm($version)."'";
			}else{
				$version_con = "10=10";
			}
			
			if(!empty($maker) && $maker!=null){
				$maker_con = "lower(Updateprogram.maker) = '".strtolower($this->Lv->spec_char_dbm($maker))."'";
			}else{
				$maker_con = "1=1";
			}
			if(!empty($cond) && $cond!=null){
				$cond_con = "Group.id in (".$cond.")";
			}else{
				$cond_con = "1=1";
			}
			
			$j=0;
			$data_detail_csv1=null;
			$datail_con = $conditions;

			$datail_con['GROUP BY'] = "Updateprogram.name,Updateprogram.maker,Updateprogram.version";
			$data = $this->Updateprogram->findByAsso($datail_con, array('distinct Updateprogram.name as Updateprogram__name','Updateprogram.parent_name','Updateprogram.maker','Updateprogram.version','count(distinct(Updateprogram.host_id)) as Updateprogram__host_ids'), $order, $limit, $page, $asso_timeout);
			        
			foreach ($data as $output)
			{
				if(empty($output['Updateprogram']['licens']))
				{
					$untrue="0";
					$lic_count='0';
				}
				else
				{
					$untrue="0";
					$lic_count=$code['Updateprogram']['host_ids'];
				}

				$data_detail[$j]['Updateprogram']['name']=$output['Updateprogram']['name'];
				$data_detail[$j]['Updateprogram']['parent_name']=$output['Updateprogram']['parent_name'];
				if(isset($output['Updateprogram']['version'])){
					$data_detail[$j]['Updateprogram']['version']=$output['Updateprogram']['version'];
				}
				if(empty($output['Updateprogram']['maker'])){
					$data_detail[$j]['Updateprogram']['maker'] = "---";
				}else{
					$data_detail[$j]['Updateprogram']['maker']=$output['Updateprogram']['maker'];
				}
				$data_detail[$j]['Updateprogram']['licence_code'] = "---";
				
				$data_detail[$j]['Updateprogram']['host_ids']=$output['Updateprogram']['host_ids']==0 ? '---' :$output['Updateprogram']['host_ids'];
				$data_detail[$j]['Updateprogram']['untrue']=$untrue==0 ? '---' : $untrue;
				$data_detail[$j]['Updateprogram']['lay']=count($this->Grpauth->getParentsByChild($group_id));
				$li_un=$li_un+$lic_count;
				$j++;
			}
			$c = 0;
			$this->set('flag', 1);//$this->data['version']['check']
			$this->set('data_detail',$data_detail);
			if($link=='csv1')
			{
				$this->csvdown1($data_detail);exit;
			}
		}
		if($link=='csv')
		{
			if($this->data['version']['check']==1){
				$data_csv = $this->Updateprogram->findByAsso($conditions, array('Updateprogram.name','Updateprogram.maker','Updateprogram.version','count(distinct(Updateprogram.host_id)) as Updateprogram__host_ids',"sum(case when licence_code ='' then 0 else 1 end) as Updateprogram__licens"), $order, null, null, $asso_timeout);
				$flag = 1;
			}
			{
				$data_csv = $data;
				$flag = 3;
			}
			$this->csvdown($data_csv,$flag);exit;
		}
		//
		$this->set('err',$err);
		$this->set('data',$data);
		$this->set('version',$version);
		$this->set('maker',$maker);
		$this->set('group_id',$grp_in);
		$this->set('limit',$limit);
		$this->set('page',$pag);
		if((isset($search)&&$link==1)||$link=='pg')
		{
			$this->render('lists');
		}
		elseif (isset($search)&&$link==2)
		{
			$this->render('detail');
		}
	}
	
	
	function detail($id)
	{
		$this->layout="ajax";
	}
	
	function csvdown1($data=nul)
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("assets_mng_sfws");
		$array = array("Updateprogram/name"=>__('software', $return = true),//"ソフトウェア名",
		"Updateprogram/maker"=>__('maker', $return = true),//"メーカー",
		"Updateprogram/setlicence_number"=>__('setlicence_number', $return = true),//"保有ライセンス数",
		"Updateprogram/host_ids"=>__('inter', $return = true),//"導入数",
		"Updateprogram/untrue"=>__('untrue', $return = true),//"差異",
		);
		$csv->special_cols=$array;
		$csv->sendCSVFile($data,$this->data,__('sfwdetail',$return=true));
	}
	//

	function checkin_arr($arr,$data){
		$check = -1;
		foreach ($arr as $key=>$value){
			if($value['Updateprogram']['name'] == $data && $value['Updateprogram']['name']){
				$check = $key;
				break;
			}else{
				$check = -1;
			}
		}
		return $check;
	}
	
	function checkin_arr2($arr,$arr2){
		$check = -1;
		foreach ($arr as $key=>$value){
			if($value['Updateprogram']['name'] == $arr2['Updateprogram']['name'] && $value['Updateprogram']['name']){
				if($value['Updateprogram']['maker'] == $arr2['Updateprogram']['maker'] && $value['Updateprogram']['maker']){
					$check = $key;
					break;
				}else 
					$check = -1;
			}else{
				$check = -1;
			}
		}
		return $check;
	}
}
?>