<?php
/*
 * usage:
 *
 */
/*********************************************************************
*@filename Csvoptfiles.php
*@note
*@histories  rivision	author		date		comment
*            1.0        xht        2009/04/24  modify for LogvillageChinese
********************************************************************/
require_once( 'csv/CsvBase.php' );

class csv_opt_files extends CsvBase{
	//xht start 2009/04/27 modify for LogvillageChinese
//    public $special_cols = array("Optfile/status_time"=>"日付",
//                                        "Group/group_name"=>"グループ名",
//                                        "Host/host_name"=>"コンピュータ名",
//                                        "Optfile/account"=>"ログオンアカウント名",
//                                        "Optfile/operation_type"=>"ステータス",
//                                        "Optfile/file_name"=>"ファイル名",
//                                        "Optfile/size"=>"サイズ",
//                                        "Optfile/directory"=>"フォルダ名",
//	       
//			       ); 
//     public $special_search_title = array(
//                                    "dt_check/start_year start_month start_day"=>"開始日", 
//                                    "dt_check/end_year end_month end_day"=>"終了日", 
//                                    "dt_check/start_hour start_min end_hour end_min"=>"一日毎の時間指定", 
//                                    "dt_check/week"=>"曜日指定", 
//                                    "optfile/group"=>"グループ名を指定",
//                                    "Host/hostname_t"=>"コンピュータ名を指定",  
//                                    //"Optuser/account"=>"ログオンアカウント名を指定",
//                                    "Optfile/operation_type_ck"=>"ステータスを指定",
//                                    "Optfile/extend_ck"=>"拡張子指定",
//                                    "Optfile/file_size_t1"=>"ファイルサイズ指定",
//                                    "Optfile/filename_t"=>"ファイル名を指定",   
//                                    "Optfile/directory_text"=>"フォルダ指定",			       
//			       ); 

//  public $special= array("REGISTTIME"=>"REGISTTIME",
//			 "VIPTYPE"=>"VIPTYPE",
//			 "VIPCATEGORY"=>"VIPCATEGORY",
//			 "NAME"=>"NAME",
//			 "COMPANYNAME"=>"COMPANYNAME",
//			 "COMPANYNAMEKANA"=>"COMPANYNAMEKANA",
//			 "DEPARTMENT"=>"DEPARTMENT",
//			 "TITLE"=>"TITLE",
//			 "ZIP"=>"ZIP",
//			 "COUNTRY"=>"COUNTRY",
//			 "STATE"=>"STATE",
//			 "ADDRESS1"=>"ADDRESS1",
//			 "ADDRESS2"=>"ADDRESS2",
//			 "ADDRESS3"=>"ADDRESS3",
//			 "TEL"=>"TEL",
//			 "FAX"=>"FAX",
//			 "EMAIL"=>"EMAIL",
//			 ); 
//  public function getSql($type=0)
//  {    
//    $sql=$this->sql;
//    return $sql;
//  }
	public function getCsvTitle(){
		
		$this->special_cols['Optfile/status_time']=__('dating',$retrun=true);
		$this->special_cols['Optfile/file_create']=__('create_time',$retrun=true);
		$this->special_cols['Optfile/file_modify']=__('update_time',$retrun=true);
		$this->special_cols['Group/group_name']=__('groupname',$retrun=true);
		$this->special_cols['Host/host_name']=__('Host/host_name',$retrun=true);
		//$this->special_cols['Optfile/account']=__('Useevtlog/account',$retrun=true);
		//$this->special_cols['Optfile/operation_type']=__('status',$retrun=true);
		$this->special_cols['Optfile/file_name']=__('file_name',$retrun=true);
		$this->special_cols['Optfile/size']=__('size',$retrun=true);
		$this->special_cols['Optfile/directory']=__('folder_name',$retrun=true);
		
		return parent::getCsvTitle();
	}
	
	public  function getSearchTitle(){
			$this->common_search_title1[0]=__('',$retrun=true);
			$this->common_search_title1[1]=__('report',$retrun=true);
			
			$this->special_search_title['dt_check/start_year start_month start_day']=__('start_time',$retrun=true);
			$this->special_search_title['dt_check/end_year end_month end_day']=__('end_time',$retrun=true);
			$this->special_search_title['dt_check/start_hour start_min end_hour end_min']=__('date_time_appoint',$retrun=true);
			$this->special_search_title['dt_check/week']=__('week',$retrun=true);
			$this->special_search_title['optfile/group']=__('groupname',$retrun=true);
			$this->special_search_title['Host/hostname_t']=__('Host/host_name',$retrun=true);
			//$this->special_search_title['Optfile/operation_type_ck']=__('set_status',$retrun=true);
			$this->special_search_title['Optfile/time_type']=__('set_timetype',$retrun=true);
			$this->special_search_title['Optfile/extend_ck']=__('set_extension_name',$retrun=true);
			$this->special_search_title['Optfile/file_size_t1']=__('set_file_size',$retrun=true);
			$this->special_search_title['Optfile/filename_t']=__('set_file_name',$retrun=true);
			$this->special_search_title['Optfile/directory_text']=__('set_folder_path',$retrun=true);
			
			
			
			return parent::getSearchTitle();
	}
	//xht end 2009/04/20 modify for LogvillageChinese

  public function doSpeci($colname,$row){
   //echo "=================================================";
   
   //print_r($row);
    if($colname=="Optfile/operation_type")
    {
    	//print_r($colname);
        $keys=explode("/",$colname);  
        if($row[$keys[0]][$keys[1]]==6)
        {
            $row[$keys[0]][$keys[1]]=__('filetype_delete',$return = true);
        }  
        if($row[$keys[0]][$keys[1]]==5)
        {
            $row[$keys[0]][$keys[1]]=__('filetype_rename',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==4)
        {
            $row[$keys[0]][$keys[1]]=__('filetype_update',$return = true);
        }   
        if($row[$keys[0]][$keys[1]]==3)
        {
            $row[$keys[0]][$keys[1]]=__('filetype_move',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==2)
        {
            $row[$keys[0]][$keys[1]]=__('filetype_copy',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==1)
        {
            $row[$keys[0]][$keys[1]]=__('filetype_complete',$return = true);
        }  
    }
    if($colname=="Optfile/account")
    {
        $keys=explode("/",$colname);   
        $row[$keys[0]][$keys[1]]=explode("|",$row[$keys[0]][$keys[1]]);  
		$row[$keys[0]][$keys[1]]=implode("  ",$row[$keys[0]][$keys[1]]);
    }
    return parent::doSpeci($colname,$row);
  }
}
?>