<?php
/*********************************************************************
*@filename Csvuseevtlogs.php
*@description
*@note
*@histories  rivision	author		date		comment
*            2.0        xushanning  2009/04/24  modify for LogvillageChinese
********************************************************************/
/*
 * usage:
 *
 */
require_once( 'csv/CsvBase.php' );

class csv_use_evtlogs extends CsvBase{
	//xushanning start 2009/04/24  modify for LogvillageChinese
    /*public $special_cols = array("Useevtlog/event_time"=>"日付",
                                        "Group/group_name"=>"グループ名",
                                        "Host/host_name"=>"コンピュータ名",
                                        "Useevtlog/account"=>"ログオンアカウント名",
                                        "Useevtlog/event_catalog"=>"種別",
                                        "Useevtlog/event_type"=>"種類",
                                        "Useevtlog/event_id"=>"イベントID",
                                        "Useevtlog/source"=>"ソース",
                                        "Useevtlog/specification"=>"説明",
			       
			       ); 
     public $special_search_title = array(
                                    "dt_check/start_year start_month start_day"=>"開始日", 
                                    "dt_check/end_year end_month end_day"=>"終了日", 
                                    "dt_check/start_hour start_min end_hour end_min"=>"一日毎の時間指定", 
                                    "dt_check/week"=>"曜日指定", 
                                    "useevtlog/group"=>"グループ名を指定",
                                    "Host/host_name"=>"コンピュータ名を指定",  
                                    "Useevtlog/account"=>"ログオンアカウント名を指定",
                                   "Useevtlog/event_catalog_ck"=>"イベントの種別を指定",
                                        "Useevtlog/event_type_ck"=>"イベントの種類を指定",
                                        "Useevtlog/event_id_t"=>"イベントIDを指定",
                                        "Useevtlog/source_t"=>"イベントのソースを指定",
                                        "Useevtlog/specification_t"=>"イベントの説明のキーワードを指定",			       
			       ); */
    public function getCsvTitle(){
    	$this->special_cols['Useevtlog/event_time']=__('dating',$retrun=true);
    	$this->special_cols['Group/group_name']=__('groupName',$retrun=true);
    	$this->special_cols['Host/host_name']=__('computername',$retrun=true);
    	$this->special_cols['Useevtlog/account']=__('logon account',$retrun=true);
    	$this->special_cols['Useevtlog/event_catalog']=__('event_catalog',$retrun=true);
    	$this->special_cols['Useevtlog/event_type']=__('event_type',$retrun=true);
    	$this->special_cols['Useevtlog/event_id']=__('event_id',$retrun=true);
    	$this->special_cols['Useevtlog/source']=__('event_source',$retrun=true);
    	$this->special_cols['Useevtlog/specification']=__('event_specification',$retrun=true);
    	return parent::getCsvTitle();
    }
    
    public  function getSearchTitle(){
			$this->special_search_title['dt_check/start_year start_month start_day']=__('start_time',$retrun=true);
			$this->special_search_title['dt_check/end_year end_month end_day']=__('end_time',$retrun=true);
			$this->special_search_title['dt_check/start_hour start_min end_hour end_min']=__('date_time_appoint',$retrun=true);
			$this->special_search_title['dt_check/week']=__('week',$retrun=true);
			$this->special_search_title['useevtlog/group']=__('designateGroup',$retrun=true);
			$this->special_search_title['Host/host_name']=__('set_computer',$retrun=true);
			$this->special_search_title['Useevtlog/account']=__('set_login_account',$retrun=true);
			$this->special_search_title['Useevtlog/event_catalog_ck']=__('set_event_catalog',$retrun=true);
			$this->special_search_title['Useevtlog/event_type_ck']=__('set_event_type',$retrun=true);
			$this->special_search_title['Useevtlog/event_id_t']=__('set_event_id',$retrun=true);
			$this->special_search_title['Useevtlog/source_t']=__('set_event_source',$retrun=true);
			$this->special_search_title['Useevtlog/specification_t']=__('set_event_specification',$retrun=true);
			
			return parent::getSearchTitle();
	}
	//xushanning end 2009/04/24  modify for LogvillageChinese

//  public $special= array("REGISTTIME"=>"REGISTTIME",
//			 "VIPTYPE"=>"VIPTYPE",
//			 "VIPCATEGORY"=>"VIPCATEGORY",
//			 "NAME"=>"NAME",
//			 "COMPANYNAME"=>"COMPANYNAME",
//			 "COMPANYNAMEKANA"=>"COMPANYNAMEKANA",
//			 "DEPARTMENT"=>"DEPARTMENT",
//			 "TITLE"=>"TITLE",
//			 "ZIP"=>"ZIP",
//			 "COUNTRY"=>"COUNTRY",
//			 "STATE"=>"STATE",
//			 "ADDRESS1"=>"ADDRESS1",
//			 "ADDRESS2"=>"ADDRESS2",
//			 "ADDRESS3"=>"ADDRESS3",
//			 "TEL"=>"TEL",
//			 "FAX"=>"FAX",
//			 "EMAIL"=>"EMAIL",
//			 ); 
//  public function getSql($type=0)
//  {    
//    $sql=$this->sql;
//    return $sql;
//  }

  public function doSpeci($colname,$row){
   
    if($colname=="Useevtlog/event_catalog")
    {
        $keys=explode("/",$colname);        
        if($row[$keys[0]][$keys[1]]==3)
        {
            $row[$keys[0]][$keys[1]]=__('application_info',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==2)
        {
            $row[$keys[0]][$keys[1]]=__('security',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==1)
        {
            $row[$keys[0]][$keys[1]]=__('system',$return = true);
        }  
    }
    if($colname=="Useevtlog/event_type")
    {
        $keys=explode("/",$colname);        
        if($row[$keys[0]][$keys[1]]==1)
        {
            $row[$keys[0]][$keys[1]]=__('error',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==2)
        {
            $row[$keys[0]][$keys[1]]=__('warning',$return = true);
        }
        if($row[$keys[0]][$keys[1]]==4)
        {
            $row[$keys[0]][$keys[1]]=__('info',$return = true);
        }     
    }
    return parent::doSpeci($colname,$row);
  }
}
?>