<?php
class Rltgrpshd extends AppModel{
	var $name = "Rltgrpshd";
	var $primaryKey = "id";
	var $useTable = "rltgrpshds";
	
	var $belongsTo = array(
			'Child' =>
				array('className'    => 'Group',
										    'conditions'   => '',
										    'order'        => '',
										    'dependent'    => true,
										    'foreignKey'   => 'group_id'
				)
			
	);
	

	/**
	 *  Generate List of the children Groups by One parent Group id
	 *
	 * @param int $parentId
	 * @return array id => Group.group_name
	 */
	function getChildrenByParent($parentId)
	{
    	$groups = $this->findAll("Rltgrpshd.org_grp_id = $parentId", 'Child.id, Child.group_name', 'Child.id, Child.group_name', null, null, 1);
    	if(!empty($groups)){
    	    $keys = Set::extract($groups, '{n}.Child.id');
			$vals = Set::extract($groups, '{n}.Child.group_name');
			$groups = array_combine($keys, $vals);
			return $groups;
    	}
    	else {
    		return array();
    	}
    	
	}
	

}
?>