<?php 
class TreeHelper extends Helper
{
	var $tab = "  ";
	var $helpers = Array("Html", 'Ajax');
	var $checks;
	var $rootGroup;
	var $currentParent = NULL;
	var $layerStack = array(1);
//  function show($name, $data)
//  {
//    list($modelName, $fieldName) = explode('/', $name);
//    $output = $this->list_element($data, $modelName, $fieldName, 0);
//    
//    return $this->output($output);
//  }
//  
//  function list_element($data, $modelName, $fieldName, $level)
//  {
//    $tabs = "\n" . str_repeat($this->tab, $level * 2);
//    $li_tabs = $tabs . $this->tab;
//    
//    $output = $tabs. "<ul>";
//    foreach ($data as $key=>$val)
//    {
//      $output .= $li_tabs . "<li>".$val[$modelName][$fieldName];
//      if(isset($val['children'][0]))
//      {
//        $output .= $this->list_element($val['children'], $modelName, $fieldName, $level+1);
//        $output .= $li_tabs . "</li>";
//      }
//      else
//      {
//        $output .= "</li>";
//      }
//    }
//    $output .= $tabs . "</ul>";
//    
//    return $output;
//  }
  
  function show($name, $data, $checks, $rootGroup)
  {
  	$this->checks = $checks;
  	$this->rootGroup = $rootGroup;
    list($modelName, $fieldName) = explode('/', $name);
    $output = $this->list_element($data, $modelName, $fieldName, 0);
    
    return $this->output($output);
  }
  
  function list_element($data, $modelName, $fieldName, $level)
  {
    $tabs = "\n" . str_repeat($this->tab, $level * 2);
    $li_tabs = $tabs . $this->tab;
    
    $currentLayerNum = count($data);
    $output = $tabs. "<ul id=\"ul_{$this->currentParent}\">";
    foreach ($data as $key=>$val)
    {
//    	if(in_array($val[$modelName]['id'], $this->showGroups)){
    	///////権限で見できます。


		//check box
    	if(is_array($this->checks)){
    		$checked = in_array($val[$modelName]['id'], $this->checks) ? 'checked' : '';
    	}
    	else $checked = NULL;
    	if($this->rootGroup != $val[$modelName]['id']){
    		$checkbox = '<input type="checkbox" name="data[' . $modelName . '][id][]" value="' . $val[$modelName]['id'] . '" ' . $checked . ' />';
    	}
    	else {
    		$checkbox = NULL;
    	}
    	//link to edit
    	$link = $this->Ajax->link(htmlspecialchars($val[$modelName][$fieldName]), "/system_all_groups/edit/".$val[$modelName]['id'], 
    						array(
    								'update' => 'index',
							        'loading'  => "Element.show('loading')",
							        'complete' => "Element.hide('loading')"
    							), 
    						
    						null, false);
//    	debug($val, true);
		
    	//onclick
		if($key == $currentLayerNum - 1){
			$addBottom = 'bottom';
		}
		else {
			$addBottom = NULL;
		}
    	$this->currentParent = $currentId = $val[$modelName]['id'];	
    	$onclick = "$('ul_{$currentId}').toggle();";
    	$img1 = 'group_img' . $currentId . '_+';
    	$img2 = 'group_img' . $currentId . '_-';
    	$img_click = "$('$img1').toggle();$('$img2').toggle();";
	    	
	      if(isset($val['children'][0]))
	      {
	      	//childrenあり
	      	$click_item = $this->Html->image('tree/plus' . $addBottom . '.gif', array('id' => $img1, 'style' => "display:none;", 'onclick' => $img_click . $onclick)) . 
	      				$this->Html->image('tree/minus' . $addBottom . '.gif', array('id' => $img2, 'onclick' => $img_click . $onclick));
	      	$output .= $li_tabs . "<li class='branch" . $addBottom . "'>" . $click_item . $checkbox . $link;
	        $output .= $this->list_element($val['children'], $modelName, $fieldName, $level+1);
	        $output .= $li_tabs . "</li>";
	      }
	      else
	      {
	      	//childrenなし


	      	$output .= $li_tabs . "<li class='branch" . $addBottom . "'>" . $this->Html->image('tree/branch' . $addBottom . '.gif', array('id' => $img2, 'onclick' => $img_click . $onclick)) . $checkbox . $link;
	        $output .= "</li>";
	      }
//    	}
//    	else {
//    		continue;
//    	}
    }
//    if($val['Parentgroup']['id'] != NULL)$output .=  $li_tabs . "<li class='a'>  " . $this->link_addgrp($val['Parentgroup']['id']) . " </li>";
    $output .= $tabs . "</ul>";
    
    return $output;
  }
  
  // zhangs start 20080203
		function list_element3($data, $modelName, $fieldName, $level)
	{
		$tabs = "\n" . str_repeat($this->tab, $level * 2);
		$li_tabs = $tabs . $this->tab;

		$currentLayerNum = count($data);
		$output = $tabs. "<ul id=\"ul_{$this->currentParent}\">";
		foreach ($data as $key=>$val)
		{
			//    	if(in_array($val[$modelName]['id'], $this->showGroups)){
			///////権限で見できます。



			//check box
			if(is_array($this->checks)){
				$checked = in_array($val[$modelName]['id'], $this->checks) ? 'checked' : '';
			}
			else $checked = NULL;
			if($this->rootGroup != $val[$modelName]['id']){
				$checkbox = '<input type="checkbox" name="data[' . $modelName . '][id][]" value="' . $val[$modelName]['id'] . '" ' . $checked . ' />';
			}
			else {
				$checkbox = NULL;
			}
			//link to edit
//			$link = $this->Ajax->link($val[$modelName][$fieldName], "/system_all_groups/edit/".$val[$modelName]['id'],
//			array(
//			'update' => 'index',
//			'loading'  => "Element.show('loading')",
//			'complete' => "Element.hide('loading')"
//			),
//
//			null, false);
			//    	debug($val, true);

			//onclick
			if($key == $currentLayerNum - 1){
				$addBottom = 'bottom';
			}
			else {
				$addBottom = NULL;
			}
			$this->currentParent = $currentId = $val[$modelName]['id'];
			$onclick = "$('ul_{$currentId}').toggle();";
			$img1 = 'group_img' . $currentId . '_+';
			$img2 = 'group_img' . $currentId . '_-';
			$img_click = "$('$img1').toggle();$('$img2').toggle();";

			if(isset($val['children'][0]))
			{
				//childrenあり
				$click_item = $this->Html->image('tree/plus' . $addBottom . '.gif', array('id' => $img1, 'style' => "display:none;", 'onclick' => $img_click . $onclick)) .
				$this->Html->image('tree/minus' . $addBottom . '.gif', array('id' => $img2, 'onclick' => $img_click . $onclick));
				$output .= $li_tabs . "<li style='margin-left:24px' class='branch" . $addBottom . "'>" . $click_item . $checkbox ;
				$output .= $this->list_element($val['children'], $modelName, $fieldName, $level+1);
				$output .= $li_tabs . "</li>";
			}
			else
			{
				//childrenなし



				$output .= $li_tabs . "<li style='margin-left:24px' class='branch" . $addBottom . "'>" . $this->Html->image('tree/branch' . $addBottom . '.gif', array('id' => $img2, 'onclick' => $img_click . $onclick)) . $checkbox ;
				$output .= "</li>";
			}
			//    	}
			//    	else {
			//    		continue;
			//    	}
		}
		//    if($val['Parentgroup']['id'] != NULL)$output .=  $li_tabs . "<li class='a'>  " . $this->link_addgrp($val['Parentgroup']['id']) . " </li>";
		$output .= $tabs . "</ul>";

		return $output;
	}
	// zhangs end 20080203
  
//  function link_addgrp($parentid)
//  {
//  	$options = array(
//							        'update' => 'data',
//							    ); 
//		return $this->Ajax->link("追加する", "/system_all_groups/add/".$parentid, $options, null, false);
//  }
  
}
?>