<?php
class AgentConfController extends AppController
{   
	var $helpers = array('Html','Xml');
	var $uses=array('Group','Configure', 'Validation','License',
		"Grpshd", "Rltshdmod",'Agentstatus','Hostkey');
	var $components = array();
	var $layout='system';
		
	function beforeFilter()
	{

	}
	
	function getParentschedule($groupid)
	{
		$default = $this->Grpshd->find(array("group_id" => $groupid),
			array('Grpshd.id','Grpshd.group_id',
				'Grpshd.start_date','Grpshd.end_date','Grpshd.start_time','Grpshd.end_time',
				'Grpshd.weekday','Grpshd.onlogon',
				'timediff(end_time,start_time) as Grpshd__time_diff',
				'time_to_sec(timediff(end_time,start_time)) as Grpshd__second_diff'));
		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getParentschedule($parent);
		}
		return $default;
	}
	
	function getschedule($group_id)
	{
		require_once( '../csv/xml.php' );
		$xml = new xml(); 
		$xml->setSpace(true); 
		
		$d = &$xml->addDeclare('?xml'); 
        $d->setAttrib("version","1.0");
        $d->setAttrib("encoding","Shift_JIS");
		
		$version = 100;

		$conf = $this->getParentschedule($group_id);
		$xml1 = &$xml->addElement("Schedule"); 
		
		if(!empty($conf)){
			//ライセンスの確認
			$license_endtime=$this->License->findAll(array("1=1"),array("License.end_time"));
			//取得期間が無期限の場合、現在からライセンスの期限までとする 
			if(($conf['Grpshd']['start_date']==$conf['Grpshd']['end_date'])&&($conf['Grpshd']['end_date']=="2038-01-01"))
			{
				$conf['Grpshd']['start_date'] = date("Y-m-d");
				$conf['Grpshd']['end_date'] = substr($license_endtime[0]['License']['end_time'],0,10);
			}
			
			$xml2 = $xml1->addElement("Item", ""); 

			$names = array('id', 'group_id',
				'start_date','end_date','start_time','end_time',
				'weekday','onlogon','time_diff','second_diff');
			foreach($conf['Grpshd'] as $key=>$value)
			{
				if(in_array($key, $names))
					$xml2->setAttrib($key, $value); 
			}
			$sch_id = $conf['Grpshd']['id'];
			$agent = $this->Rltshdmod->find(array("Rltshdmod.sch_id" => $sch_id, "Rltshdmod.module_id" => 18));

			if(isset($agent['Rltshdmod']['inter_time']))
				$xml2->setAttrib("agenttime", $agent['Rltshdmod']['inter_time']); 
			else
				$xml2->setAttrib("agenttime", SCHEDULE_AGENT); 
		}
		$rec = $xml->toString();
		
		echo $rec;exit;
	}
	//UUIDからhostid
	function gethostid($keystr)
    {
		$criteria[] = "Hostkey.keystr = '".$keystr."'";
		$host = $this->Hostkey->find($criteria);
		if(empty($host)){
			echo "0";
			exit;
		}
		
		echo $host['Hostkey']['host_id'];
		exit;
    }
	
//アップデータからDB上のPSバージョン情報を更新
    function updater($hostid, $version)
    {
		//$this->layout='ajax';
		if(is_numeric($hostid) || $hostid > 0){
			$agent = array(
			'Agentstatus' => array(
					'host_id' => $hostid,
					'update_status' => 0,
					'update_time' => date("Y/m/d H:i:s"),
					'version' => $version,
				)
			); 							
			$this->Agentstatus->save($agent);			
			
			echo "ok";
			exit;
		}
		echo "0";
		exit;
    }
	
	function uplog($hostid = 0)
	{
		//$this->layout='ajax';
		set_time_limit(0);

		if($hostid == 0 || !is_numeric($hostid))
			exit;
		
		/*$criteria[] = "Host.id = ".$hostid;
		$host = $this->Host->find($criteria);
		if(empty($host))
			exit;*/
			
		//		debug($_FILES, true);
		//アップロードされたファイルのパス
		$filename = $_FILES['impfile']['tmp_name'];
		if(!empty($filename)){
			//一時フォルダから移動
			//$tmp = str_replace("\\","/", TMP);// lv/app/tmp/
			$tmp =str_replace("\\","/", RESTORE_FILE_PATH);
			//$uploadfile = $dir . basename($filename);
			$logdir = $tmp . "/../Agentlogs";
			if(!file_exists($logdir)){
				mkdir($logdir);
			}
			$uploadfile = $logdir. "/" . $hostid ."_".date("YmdHis"). ".txt";
			move_uploaded_file($filename, $uploadfile);
			
			//$my_file = file_get_contents($uploadfile, false, NULL, 0, 60000);
			//unlink($uploadfile);
			
			echo "1";
			//echo $filename."&&&".$uploadfile;
		}
		exit;
	}
}
?>