<?php
/*********************************************************************
*@filename assets_printer_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment

********************************************************************/
class AssetsFilescanController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Exefile','Grpauth','Hstloghead','Host','Rlthstgrp','Group','Targetext');
	var $layout='assets';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('prt title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		//		debug($_POST, true);
		//================================yin c=======================

	}

	function index($errorMessage = null)
	{
		//    	$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		//		$glist[0] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist',$glist);
		
		$elist = array('' => __('no_select', true));
		$extstr = $this->getTargetExtention($this->_getUserGroup());
		$exts = explode("＆", $extstr['Targetext']['extentions']);//＆
		foreach($exts as $ext){
			$elist[$ext] = $ext;
		}
		$this->set('elist',$elist);
		
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}
	}
	
	function getTargetExtention($groupid)
	{
		$cond = "Targetext.group_id = {$groupid} group by Targetext.group_id";
		$default = $this->Targetext->find($cond, "GROUP_CONCAT(Targetext.extention order by Targetext.number separator '＆') as Targetext__extentions");

		if(empty($default))
		{
			$parent = $this->Group->group_father_id($groupid);
			if(!empty($parent))
				$default = $this->getTargetExtention($parent);
		}
		return $default;
	}
	function getExtentions(){
		$this->layout = 'ajax';
		$acclist = array('' => __('no_select', true));
		if(isset($this->data['Group']['group_name']))
		{
			$extstr = $this->getTargetExtention($this->data['Group']['group_name']);
			$exts = explode("＆", $extstr['Targetext']['extentions']);//＆
			foreach($exts as $ext){
				$acclist[$ext] = $ext;
			}
		}
		$this->set('elist', $acclist);
		$this->render("select");
	}
	function listdriver($csv = null)
	{
		$this->layout="ajax";
		
		$criteria[]="1=1";
		//入力データ取得
		$group = $this->_getUserGroup();
		if(isset($this->data['Group']['group_name']))
			$group = $this->data['Group']['group_name'];		
		
		$count = $this->data['Netscan']['count'];
		if(!is_numeric($count))
			$count = 20;
		
		if(!empty($this->data['Host']['host_name']))
			if(!empty($this->data['Host']['part']))
				$criteria[]="Host.host_name like '%".$this->Lv->spec_char_dbm($this->data['Host']['host_name'])."%'";
			else
				$criteria[]="Host.host_name = '".$this->Lv->spec_char_dbm($this->data['Host']['host_name'])."'";
		
		if(!empty($this->data['Exefile']['file_name']))
			if(!empty($this->data['Exefile']['part']))
				$criteria[]="Exefile.file_name like '%".$this->Lv->spec_char_dbm($this->data['Exefile']['file_name'])."%'";
			else
				$criteria[]="Exefile.file_name = '".$this->Lv->spec_char_dbm($this->data['Exefile']['file_name'])."'";
		
		if(!empty($this->data['Exefile']['extention']))
			$criteria[]="Exefile.extention = '".$this->Lv->spec_char_dbm($this->data['Exefile']['extention'])."'";

		
		$group_ids = "";
		$glist = $this->Grpauth->getChildrenByParent($group);
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		$criteria[]="Rlthstgrp.group_id in (".$group_ids.")";
		
//var_dump($this->data);
//var_dump($criteria);
		//取得条件設定
		$asso = array(
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			'Exefile : exefiles' => array('Exefile.host_id = Host.id'),
			) ;
		
		$fields = array(
		'Group.group_name',
		'Host.host_name',
		'Exefile.file_name',
		'Exefile.extention',
		'Exefile.size',
		'Exefile.directory',
		'Exefile.file_modify',
		'Exefile.polling_time',
		);
	
		//$criteria["GROUP BY"]="Netscan.ip_address";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Host->findByAsso($criteria, $fields, 'Group.group_name, Host.host_name, Exefile.file_name, Exefile.directory', null, null, $asso);
		
			$this->csvdown($Hrdprts,1);exit;
		}else{
			$this->Pagination->show = $count;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_filescan/listdriver', 'modelClass'=>'Host', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 
			'sortBy' => $this->Lv->sortBy(
				'Group.group_name, Host.host_name, Exefile.file_name, Exefile.directory')));
			$Hrdprts = $this->Host->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
			$Hrdprts2 = $this->Host->findByAsso($criteria, $fields, null, null, null, $asso);
		}
		
//debug($Hrdprts);

		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($Hrdprts2));
		$this->set('countperpage',$count);	
		$this->set('group_id',$group);	
		$this->render('drivers');
	}

	function csvdown($data,$flag)
	{
		//$parent = $this->data['Selector']['parent_group'];
		$group = $this->data['Group']['group_name'];
		
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group));
		$group_n= $this->Group->findAll($criteria);
		$parent = $group_n[0]["Group"]["parent_id"];
		
		$this->data['Csv']['group'] = $this->groupName($group);
		
		$this->data['Csv']['host'] = $this->data['Host']['host_name'];
		$this->data['Csv']['file'] = $this->data['Exefile']['file_name'];
		$this->data['Csv']['ext'] = $this->data['Exefile']['extention'];
		
		if(!empty($this->data['Host']['part']))
			$this->data['Csv']['host'] .= "(".__('part_conform', $return = true).")";
		if(!empty($this->data['Exefile']['part']))
			$this->data['Csv']['file'] .= "(".__('part_conform', $return = true).")";
		

		require_once( 'csv/DlFactory.php' );
		
		$filename="";


		$csv = DlFactory::create("assets_filescan");
		if($flag == 1){
			$array = array(
				'Group/group_name'=>__('group_name', $return = true),
				'Host/host_name'=>__('host_name', $return = true),
				'Exefile/file_name'=>__('file_name', $return = true),
				'Exefile/extention'=>__('extention', $return = true),
				'Exefile/size'=>__('size', $return = true),
				'Exefile/directory'=>__('directory', $return = true),
				'Exefile/file_modify'=>__('file_modify', $return = true),
				'Exefile/polling_time'=>__('polling_time', $return = true),
			);
			
			$filename=__('csv_file1',$return=true);
		}

		$csv->special_cols=$array;
		//debug($data);
		$csv->sendCSVFile($data,$this->data, $filename);

		exit;
	}
	
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
}
?>