<?php
class NetmetrixesImportController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
    	var $components = array ('Pagination', 'Lv','Check','Netmetrix');
    	var $uses=array('Host','Group','Rlthstgrp','Validation');
    	var $layout='alert';
    	var $replacedName = "system_all_netmetrixes";			//add by wzy at 20071119 for Authority
    	function beforeFilter()
    	{
		parent::beforeFilter();
		$this->pageTitle = __('NETMETRIX COMMON IMPORT',$return = true);
    	}   	
     	function index()
    	{
		$this->layout='ajax';
		$this->pageTitle = __('NETMETRIX COMMON IMPORT',$return = true);
    	} 
        function do_import()
        {
		require_once("csv_imports_controller.php");
		$errorMessages=array();
		//csvファイルから対象のコンピュータ名などの情報を読み取る
		$hear_num =1;
		$data = CsvImportsController :: do_import($hear_num);
		//NETMETRIXデータの取得


//		$db=$this->Netmetrix->init();
//		$rs = $db->Execute('lv_get_nodes');
//		$net_data = $this->Netmetrix->GetRows($rs);

		//対象以外の場合判断
		if(count($data)==0)
		{
			$eMessages[]=__('E-03100',$return = true);
			$errorMessages[]=$eMessages;
		}
		//LogVillageへデータを追加し


		if(count($errorMessages)==0)
		{
			foreach($data as $key => $value)
			{
				//データのチェック
				$eMessage=$this->dataCheck($value);			
//lv_get_nodesの結果セットの中からCSVファイルの中のホスト名とMACアドレスを検索する
//				for($i=0;$i<count($net_data);$i++)
//				{
//					$host_flag=array_search($value[0],$net_data[$i]);
//					$mac_flag=array_search($value[3],$net_data[$i]);
//					if($host_flag!=false && $mac_flag!=false)
//					{
//						//error_level=1またはerror_level=2の場合、lv_accept_alertにてそのコンピュータを登録する。

//						//if($net_data[$i][7]==1 ||$net_data[$i][7]==2)
//						if($net_data[$i]['error_level']==1 ||$net_data[$i]['error_level']==2)
//						{
//							//NETMETRIXへ追加処理

//							$this->netmetrixAddData($net_data[$i]);
//						}
//					}
//				}
				//LogVillageへデータの追加
				if(count($eMessage)==0)
				{
					$this->addData($value);
				}else{
					$errorMessages[]=$eMessage;
				}
			}
			if(count($errorMessages)==0)
			{
				$this->redirect("/netmetrixes/");
			}else{
				$this->set('errorMessages',$errorMessages);
				$this->render('index');
				exit;
			}
		}else{
			$this->set('errorMessages',$errorMessages);
			$this->render('index');
			exit;
		}
	}
	function addData($value)
	{
		//ホスト名
		empty($value[0])?$hostname=null:$hostname=$value[0];
		//グループ	
		empty($value[3])?$group="ALL":$group=$value[3];
		//OS
		empty($value[4])?$os=null:$os=$value[4];
		//MAC アドレス
		empty($value[5])?$mac=null:$mac=$value[5];
		//アカウント名
		empty($value[1])?$username=null:$username=$value[1];
		//パスワード

		debug($value[2],true);
		if(isset($value[2]))
		{
			$pswd=substr($value[2],0,2);
			if($pswd=="$$")
			{
				$password=substr($value[2],2);
			}else{
				$password=$this->Lv->save_encode($value[2]);
			}
		}else{
			$password=null;
		}
		$adddate=Array(
			'Host' => Array(
			'host_name'=>$hostname,
			'username'=>$username,
			'password'=>$password,
			'poll_id'=>0,
			'poll_type'=>0,
			'update_time'=>date('Y-m-d H:i:s',time()),
			'status' =>1,
			//                    'etc' =>$this->data['Host']['detailetc'],	
			)
		);
		//ホストの追加
		$this->Host->save($adddate);
		//ホストIDの取得	
		$data= $this->Host->findAll(null,null,'id DESC',1,null,null);
		//グループIDの取得	
		$groups=$this->Group->findAll("Group.group_name='".$group."'");
		//グループ関連の追加
		$addgroupdate=Array(
			'Rlthstgrp' => Array(
			'host_id' => $data[0]['Host']['id'],
			'group_id' =>$groups[0]['Group']['id'],
			)
		);
		$this->Rlthstgrp->save($addgroupdate);
	}
	function dataCheck($value)
	{
		$eMessage=array();
		//ホスト名が入力されない

		if(strlen($value[0])==0)
		{
			$eMessage[]=__('computer',$return = true).":".__('E-03100',$return = true);
		}
		//ホスト名が重複されている
		$condition="host_name ='".$value[0]."'";
		$result =$this->Host->findAll($condition,null,null,'0',null,null);
		if(count($result)>0)
		{
			$eMessage[]=__('computer',$return = true).":".$value[0].__('E-02500',$return = true);
		}
		//ホスト名の長さ

		if(!$this->Validation->maxLength($value[0],40)){
			$eMessage[]=__('computer',$return = true).":".$value[0].__('E-00300',$return = true);
		}
		//半角英数記号
		if(!$this->Check->checkAllHalf($value[0])){
			$eMessage[]=__('computer',$return = true).":".$value[0].__('E-00400',$return = true);
		}
		//グループの存在判断
		if(strlen($value[3])==0)
		{
			$value[3]="ALL";
		}
		$criteriaGroup=array();
		$criteriaGroup[]="Group.group_name='".$value[3]."'";
		$rows=$this->Group->findAll($criteriaGroup);
		$errorMsgGroup="";
		if(count($rows)==0)
		{
			$eMessage=$value[0].__('group name',$return = true)."「".$value[3]."」".__('E-02600',$return = true);
		}
		//アカウント名半角英数記号
		if(!$this->Check->checkAllHalf($value[1])){
			$eMessage[]=$value[0].__('user name',$return = true).":".$value[1].__('E-00400',$return = true);
		}
		//アカウント名の長さ

		if(!$this->Validation->maxLength($value[1],127)){
			$eMessage[]=$value[0].__('user name',$return = true).":".$value[1].__('E-00300',$return = true);
		}
		//パスワードが入力されない

		if($value[2]==""){
			$eMessage[]=$value[0].__('password',$return = true).":".$value[2].__('E-00100',$return = true);
		}
		//xuwc 2007/10/18 パスワードルール begin
		if(!$this->Check->checkAllHalfAndS($value[2]))
		{
			$eMessage[]=$value[0].__('password',$return = true).":".$value[2].__('E-03000',$return = true);
		}
		//xuwc 2007/10/18 パスワードルール end
		//パスワードの長さ

		if(!$this->Validation->maxLength($value[2],200)){
			$eMessage[]=$value[0].__('password',$return = true).":".$value[2].__('E-03000',$return = true);
		}
		return $eMessage;
	}

}
?>