<?php
class OperDevicesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','Testcookie');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation','Optdaydvc','Opthordvc');
	var $layout='oper';
	
	var $modelDvc;
        var $modelDvcName;
        var $tableDvcName;
    
    
	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar']))
		{
			//debug($_POST['forHideVar'],true);
			$this->set('forHideVar', $_POST['forHideVar']);
			//echo $_POST['forHideVar'];
		}
		else if(isset($_POST['forHideVar1']))
		{
			//debug($_POST['forHideVar1'],true);
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function _getUserGroup_id(){
   		return $this->_getUserGroup();
	} 
	function index()
	{
		$title = __('menu_oper',$return = true)."/".__('device',$return = true);   	 
    	$this->pageTitle = $title;
    	$group_id = $this->_getUserGroup_id();
		$glist = $this->Group->getChildrenByParent($group_id);
		//ksort($glist);
		$this->set('glist',$glist);
		//$contro= $this->requestAction('/oper_devices/contro',array('return'));
		$contro= "";
		$this->set('contro',$contro);
	}
	 

	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
			
	}  
	///////////////////////CONTROLLER    device and detail/////////////////////////////////////////////////////////////////
	function contro($detail=null,$device=null,$type=null)
	{
		//$this->Testcookie->operSetCookie();
	    //xuwc begin
	    $device=preg_replace('/@/','/', $device);
//	    echo $device."************";
	    //xuwc end
	    $device = str_replace(array("__plus__"), array("+"), $device);
		$this->layout='ajax';
		$dt= date('Y-m-d',time());
		$criteria = array();
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		
        if(isset($this->data['Host']['host_name']))
    	{
    	if(!$this->Lv->is_empty($this->data['Host']['host_name']))
        {
		
//		if(!empty($this->data['Host']['host_name']))
//        {
            if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
            {
                 $hostname_error[]=__('E-00400',$return = true);
            }
             if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
            {
                 $hostname_error[]=__('E-00300',$return = true);
            }
        }
    	}
        if(isset($this->data['Optdvc']['device_name']))
    	{
        if(!$this->Lv->is_empty($this->data['Optdvc']['device_name']))
        {
    	
//        if(!empty($this->data['Optdvc']['device_name']))
//        {
            if(!$this->Check->checkAllHalf($this->data['Optdvc']['device_name']))
            {
                 $devicename_error[]=__('E-00400',$return = true);
            }
             if(!$this->Validation->maxLength($this->data['Optdvc']['device_name'],64))
            {
                 $devicename_error[]=__('E-00300',$return = true);
            }
        }
    	}

       if(!empty($by_kw['error']) || !empty($by_dt['error']) || !empty($hostname_error) || !empty($devicename_error))
    	{
      		empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
      		empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
      		empty($hostname_error) ? null : $this->set('hostname_error',$hostname_error);
      		empty($devicename_error) ? null : $this->set('devicename_error',$devicename_error);
      		$this->render();
      		exit();
    	}   
        
//   
//		if($type=='csv')
//			{
//			    $this->csvdown($criteria,$time,$type);
//			    exit;
//			}



//debug($this->data);

    	//2007/11/14 仕様変更??ーブル追? begin
//        echo "<pre>";
//        var_dump($this->data);exit;
        if(strlen($this->data['dt_check']['start_day'])==0)
        {
            $start_time=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-01 00:00:00";
            $end_time=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".date("t",strtotime($this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']))." 23:59:59";
        }else{
            $start_time=$this->data['dt_check']['start_year']."-".$this->data['dt_check']['start_month']."-".$this->data['dt_check']['start_day']." 00:00:00";
            if(isset($this->data['dt_check']['end_year']))
            {
                $end_time=$this->data['dt_check']['end_year']."-".$this->data['dt_check']['end_month']."-".$this->data['dt_check']['end_day']." 23:59:59";
            }else{
                $end_time=$start_time;
            }
        }
//        echo $start_time."@@".$end_time;exit;
        $this->set_model_name($start_time,$end_time);
        //2007/11/14 仕様変更??ーブル追? end
        
//        echo $this->modelDvcName;
        
		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(".$this->modelDvcName.".polling_time)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}
		
		////2007/11/14 仕様変更??ーブル追? begin
	        
		foreach ($criteria as $key=>$value)
	        {
	            if(preg_match('/Optdvc/',$value))
	            {
	                $criteria[$key]=preg_replace('/Optdvc/',$this->modelDvcName, $value);
	            }
	           
	        }
	        
		////2007/11/14 仕様変更??ーブル追? end		
		if(((isset($this->data['optdvc']['device']))&& ($detail!='1')&&(empty($this->data['Optdvc']['detail1']))&&(!isset($this->data['Optdvc']['detail1'])))||(empty($_POST['notFirstVisit'])&& ($detail!='1')&&(!isset($this->data['Optdvc']['detail1']))))
		//if(isset($this->data['optdvc']['device'])&& ($detail!='1'))
		{
			$this->device($criteria,$type);
		}
		else
		{
			//wangs start 20080202
	    	//$detail=='1'? $criteria[]=$this->modelDvcName.".device_name='".$device."' " : null;
	    	$detail=='1'? $criteria[]=" lower(" . $this->modelDvcName.".device_name)='".strtolower($device)."' " : null;
        	//wangs end 20080202	
			$detail=='1'? $this->set('forHideVar', $_POST['forHideVar']."&data%5BOptdvc%5D%5Bdevice_name1%5D=$device&data%5BOptdvc%5D%5Bdetail1%5D=1")  : null;
			if(!empty($this->data['Optdvc']['device_name1'])) {
				//wangs start 20080202
	    		//$criteria[]=$this->modelDvcName.".device_name='".$this->data['Optdvc']['device_name1']."' ";
	    		$criteria[]=" lower(". $this->modelDvcName.".device_name)='".strtolower($this->data['Optdvc']['device_name1'])."' ";
        		//wangs end 20080202	
			}
			$this->detail($criteria,$type);
		}
		

	}
	//================================CSVDOWN==========================================================
	function csvdown($criteria,$type,$data)
    {
        require_once( 'csv/DlFactory.php' );   
        $csv = DlFactory::create("oper_devices_twos");   
       	if($type == 1) {
       		$csv->special_cols =array(
       		                               $this->modelDvcName."/device_name"=>__('device name',$return=true),
                                                $this->modelDvcName."/con"=>__('count',$return=true),
       		                               );
       			if(!isset($this->data["optdvc"]["group"])||($this->data["optdvc"]["group"] == 0)){
					$this_groups ='1';
				}else {
					$this_groups =$this->data["optdvc"]["group"];
				}
				$this->data["optdvc"]["group"] = $this->groupName($this_groups);
       		

//		        $csv = DlFactory::create("oper_devices");
//		        echo "<pre>";
//		        var_dump($data);exit;
		        $csv->sendCSVFile($data,$this->data,__('device_log',$return = true));        
        }elseif($type == 2){
            $this->modelDvcName="Temp";
            $csv->special_cols =array(
       		                               $this->modelDvcName."/polling_time"=>__('dating',$return=true),
   								 $this->modelDvcName."/group_name"=>__('groupName',$return=true),
                                 $this->modelDvcName."/host_name"=>__('clentpc',$return=true),
			       				 $this->modelDvcName."/device_name"=>__('device name',$return=true),
			       				$this->modelDvcName."/total_time"=>__('linktime',$return=true),        
       		                               );
            //xuwc 2007/10/08 begin
            for($i=0;$i<count($data);$i++)
            {
                $data[$i][$this->modelDvcName]['total_time']=$data[$i][$this->modelDvcName]['total_time'].__('count_time',$return = true);
            }
            //xuwc 2007/10/08 end
            		$this_groups =$this->data["optdvc"]["group"];
            		$this->data["optdvc"]["group"] = $this->groupName($this_groups);
//            		echo "<pre>";
//            		var_dump($data);exit;
		        $csv->sendCSVFile($data,$this->data,__('device_log',$return = true)); 

        }        
        exit;   
	 }
	
	//================================ドメインごとの表示==========================================================
	function device(& $criteria,$type=null)
	{
		$this->layout='ajax';
		$this->set('criteria',$criteria);
		$criteria['GROUP BY']=$this->modelDvcName.'.device_name';
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar']))
		//if(empty($_POST['forHideVar1']))
		{
			//&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optweb-access_time&data%5Bdt_check%5D%5Bstart_year%5D=
			$this->set('forHideVar','&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optdvc-polling_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptdvc%5D%5Bgroup%5D=1&data%5Boptdvc%5D%5Bdevice%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
		}
		//data%5Bdt_check%5D%5Bname%5D=Optdvc-polling_time&data%5Bdt_check%5D%5Bstart_year%5D=
		// ?属するグループと下位?グルー?


		$this_groups =0;
		//if($this->data['optdvc']['group']=='0' || empty($this->data['optdvc']['group']))
		//{
		//list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search','url'=>'/oper_devices/contro', 'modelClass'=>'Optdvc'));
		//var_dump($page);
		//
		//$data = $this->Optdvc->findAll($criteria, "Optdvc.device_name,count(Optdvc.id) as Optdvc__con", 'Optdvc.device_name',$limit,$page); //}
		//else
		//{
		//$criteria[]="Group.id=".$this->data['optdvc']['group']." ";
		if(!isset($this->data["optdvc"]["group"])||($this->data["optdvc"]["group"] == 0))
		{
			$this_groups =1;
		}else
		{
			$this_groups =$this->data["optdvc"]["group"];
		}
		$glist = $this->Grpauth->getChildrenByParent($this_groups);
		$condition="";
		foreach($glist as $key => $value)
		{
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		
		$asso = array('Host : hosts' => array($this->modelDvcName.'.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array($this->modelDvcName.'.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_devices/contro', 'modelClass'=>$this->modelDvcName, 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy($this->modelDvcName.'.device_name,'.$this->modelDvcName.'__con')));
		$data = $this->modelDvc->findByAsso($criteria,
		array($this->modelDvcName.'.device_name', 'count('.$this->modelDvcName.'.host_id) as '.$this->modelDvcName.'__con'), 
		$order, 
		$limit, 
		$page, 
		$asso);
		
		empty($data)? $data=array():$data;
		//xuwc 2007/09/09 begin
		$criteriaData=$criteria;
		unset($criteriaData['GROUP BY']);
		$resultData = $this->modelDvc->findByAsso($criteriaData, array($this->modelDvcName.'.polling_time','Host.host_name',$this->modelDvcName.'.device_name'), $this->modelDvcName.".polling_time",null,null,$asso);
		//xuwc 2007/09/09 end
//		echo "<pre>";
//		var_dump($result);exit;
		//xuwc begin
		for($i=0;$i<count($data);$i++)
		{
		    $criterNew=$criteria;
		    //wangs start 20080202
	    	//$criterNew[]=$this->modelDvcName.".device_name='".$data[$i][$this->modelDvcName]['device_name']."'";
	    	$criterNew[]=" lower(".$this->modelDvcName.".device_name)='".strtolower($data[$i][$this->modelDvcName]['device_name'])."'";
        	//wangs end 20080202
		    unset($criterNew['GROUP BY']);
		    //$newData=$this->get_data($criterNew,$resultData);
		    $newData=$this->get_new_data($criterNew);
		    $data[$i][$this->modelDvcName]['con']=count($newData);
//		    echo "<pre>";
//		    var_dump($data);exit;
		    array_pop($criterNew);
		}
		//xuwc end
//		$newData=$this->get_data($criteria);
//		echo "<pre>";
//		var_dump($newData);exit;
		//}
//		$datac = 
//		$this->Optdvc->findByAsso($criteria, 
//        array('Optdvc.device_name', 'count(Optdvc.id) as Optdvc__con'), 
//		$order,
//		null, 
//		null, 
//		$asso
//		);
		//xuwc begin
		
		if($type=='csv1')
		{
//		    $data = $this->Optdvc->findByAsso($criteria,
//                        array('Optdvc.device_name', 'count(Optdvc.id) as Optdvc__con'), 
//                        null, 
//                        null, 
//                        null, 
//                        $asso);
//                        empty($data)? $data=array():$data;
////                        		echo "<pre>";
//		var_dump($data);exit;
		      $this->csvdown($criteria,1,$data);exit();
		} 
//		echo "<pre>";
//		var_dump($data);exit;
		//xuwc end
//		$this->set('datac',$datac);
		$this->set('data',$data);
		$this->render('device');
	}
	//================================URLの表示==============================================================
	function detail(& $criteria,$type=null)
	{
		$this->layout='ajax';
		//xuwc 2007/12/03 begin
		$this->set('modnm','Temp');
		//xuwc 2007/12/03 end
		//if($this->data['optdvc']['group']=='0' || empty($this->data['optdvc']['group']))
		//{
		//list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/oper_devices/contro', 'modelClass'=>'Optdvc'));
		//$data = $this->Optdvc->findAll($criteria, NULL, $order,$limit,$page,5); // Extra parameters added
		//}
		//else
		//{
		//$criteria[]="Group.id=".$this->data['optdvc']['group']." ";
		$this_groups =0;
		if(!isset($this->data["optdvc"]["group"])||($this->data["optdvc"]["group"] == 0))
		{
			$this_groups =1;
		}else
		{
			$this_groups =$this->data["optdvc"]["group"];
		}
		$glist = $this->Grpauth->getChildrenByParent($this_groups);
		$condition="";
		foreach($glist as $key => $value)
		{
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		//xuwc 2007/09/09 begin
		$asso = array('Host : hosts' => array($this->modelDvcName.'.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array($this->modelDvcName.'.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		
		);
		$criteriaData=$criteria;
		
		$newArray=$this->get_new_data($criteriaData);
//		echo "<pre>";
//		var_dump($resultData);exit;
		//xuwc 2007/12/03 end
		//xuwc 2007/09/09 end
		//echo "11111111111";
		//$newArray=$this->get_data($criteria,$resultData);
                        
//                    echo "<pre>";
//                    var_dump($newArray);exit;
                    $result = $this->modelDvc->query('CREATE TEMPORARY TABLE tempoptdevices (id serial, polling_time TIMESTAMP, group_name VARCHAR(200) ,host_name VARCHAR(40),device_name VARCHAR(260),total_time INTEGER)');
//                    echo "<pre>";
//                    var_dump($result);exit;
                    if($result === false){
                        debug("CREATE TEMPORARY TABLE failed!", true);
                    }
                    //?ータの追?
                    empty($newArray)?$newArray=array():$newArray;
                    for($i=0;$i<count($newArray);$i++)
                    {
                        $this->modelDvc->query("INSERT INTO tempoptdevices VALUES(null,'".$newArray[$i][$this->modelDvcName]['polling_time']."','".$this->Lv->spec_char_dbm($newArray[$i]['Group']['group_name'])."','".$newArray[$i]['Host']['host_name']."','".$newArray[$i][$this->modelDvcName]['device_name']."',".$newArray[$i][0]['total_time'].");");
                    }
//                    $rows=$this->Optdvc->query("select * from tempoptdevices ;");
//                    echo "<pre>";
//                    var_dump($rows);exit;

		//xuwc 2007/08/02 end
		
		$asso = array(
//		'Host : hosts' => array($this->modelDvcName.'.host_id = Host.id'),
//		'Rlthstgrp : rlthstgrps' => array($this->modelDvcName.'.host_id = Rlthstgrp.host_id'),
//		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
//		'Tempoptdevice : tempoptdevices' => array('Tempoptdevice.'.$this->modelDvcName.'_id = '.$this->modelDvcName.'.id'),
		);
	        $this->addModel("Temp");
                $this->Temp->useTable = "tempoptdevices";
		list($order,$limit,$page) = $this->Pagination->init(array('1=1'),null,array(
		'ajaxDivUpdate'=>'search','url'=>'/oper_devices/contro', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Temp.polling_time')));
		$clos=array("Temp.polling_time","Temp.group_name","Temp.host_name","Temp.device_name","Temp.total_time");
		$data = $this->Temp->findByAsso(array('1=1'), 
		$clos, 
		$order,
		$limit,
		$page,
		$asso
		);
		empty($data)? $data=array():$data;
		
//		echo "<pre>";
//		var_dump($data);exit;

		
		  if($type=='csv2')
		{
		    $datac = 
                        $this->Temp->findByAsso(array('1=1'), 
                        $clos, 
                        $order,
                        null,
                        null,
                        $asso
                        );
                       
		  $this->csvdown($criteria,2,$datac);exit();
		}
		//$this->set('datac',$datac);
		$this->set('data',$data);
		$this->render('detail');
	}
            function   DateDiff($date1,$date2)
            {
                $time=strtotime($date1)-strtotime($date2);
//                echo $date1."##".$date2."<br>";
//                echo round($time/60);exit;
                $row=ceil($time/60);
 
                 
                return $row;
            }  
            function get_data($criteria,$resultData)
            {
//                echo "<pre>";
//                var_dump($resultData);exit;
                $asso = array(
		'Host : hosts' => array($this->modelDvcName.'.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array($this->modelDvcName.'.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		$datas = $this->modelDvc->findByAsso($criteria, 
		array($this->modelDvcName.'.id', $this->modelDvcName.'.polling_time', 'Group.group_name','Host.host_name',$this->modelDvcName.'.host_id', $this->modelDvcName.'.device_name'), 
		$this->modelDvcName.".polling_time",
		null,
		null,
		$asso
		);
//		echo "<pre>";
//		var_dump($datas);exit;

		//xuwc 2007/08/02 begin
		$criteriaTime=$criteria;
		foreach ($criteriaTime as $key=>$value)
                {
                    if(preg_match('/device_name/',$value))
                    {
                        unset($criteriaTime[$key]);
                    }
                    if(preg_match('/Group/',$value))
                    {
                        unset($criteriaTime[$key]);
                    }
                   
                }
                   
                    $criteriaTime['GROUP BY']=$this->modelDvcName.".polling_time";
                    $times=array();
                    $id=0;
                    $newArray=array();
// echo "<pre>";
//                        var_dump($datas);exit;                    
                    for($i=0;$i<count($datas);$i++)
                    {
//                        echo $i."**";
                        $id=0;
                        $hostid=$datas[$i][$this->modelDvcName]['host_id'];
//                        if($i==3)
//                        {
////                            unset($times[8][12]);
////                            unset($times[8][4]);
////                            unset($times[8][7]);
////                            unset($times[8][10]);
////                            unset($times[8][14]);
//                            echo "<pre>";
//                            var_dump($times);
//                        }
                        //
                        if(!(@in_array($datas[$i][$this->modelDvcName]['polling_time'],$times[$hostid]) && in_array($datas[$i]['Host']['host_name'],$times[$hostid]) && in_array($datas[$i][$this->modelDvcName]['device_name'],$times[$hostid])))
                        
                        {
//                            if($i==7)
//                            {
//                                echo "******************************";
//                            }
                            $criteriaTime[]=$this->modelDvcName.".polling_time >='".$datas[$i][$this->modelDvcName]['polling_time']."'";
                            //xuwc 2007/09/03 begin
                            $criteriaTime[]=$this->modelDvcName.".host_id =".$datas[$i][$this->modelDvcName]['host_id'];
                            //xuwc 2007/09/03 end
                            ;
                            $dates = $this->modelDvc->findAll($criteriaTime,  $this->modelDvcName.'.polling_time', $this->modelDvcName.".polling_time");
//                            echo "<pre>";
//                            var_dump($dates);exit;
                            array_pop($criteriaTime);
                            array_pop($criteriaTime);
                           
                            //$criteria1=array();
                            $time="";
//                            if($i==2)
//                            {
//                                echo "<pre>";
//                                var_dump($dates);exit;
//                            }
                            for($j=0;$j<count($dates);$j++)
                            {
//                                $criteria1[]="Host.host_name='".$datas[$i]['Host']['host_name']."'";
//                                $criteria1[]="Optdvc.device_name='".$datas[$i]['Optdvc']['device_name']."'";
                                //次の時間点の?ータがな?
                                if(!empty($dates[$j+1][$this->modelDvcName]['polling_time']))
                                {
//                                    echo $time."************";
                                        //$criteria1[]="Optdvc.polling_time='".$dates[$j+1]['Optdvc']['polling_time']."'";
//                                        echo "<pre>";
//                                        var_dump($criteria1);
                                        //$result = $this->Optdvc->findByAsso($criteria1, array('Optdvc.id'), "Optdvc.id",null,null,$asso);
                                        $result=0;
//                                        if($j==2)
//                                        {
//                                            echo $dates[$j+1][$this->modelDvcName]['polling_time'];
//                                        }
//                                        echo "<pre>";
//                                        var_dump($resultData);exit;
                                        for($k=0;$k<count($resultData);$k++)
                                        {
                                            if($resultData[$k]['Host']['host_name']==$datas[$i]['Host']['host_name'] && $resultData[$k][$this->modelDvcName]['device_name']==$datas[$i][$this->modelDvcName]['device_name']
                                             && $resultData[$k][$this->modelDvcName]['polling_time']==$dates[$j+1][$this->modelDvcName]['polling_time'])
                                             {
                                                 $result++;
                                             }
                                        }
//                                        if($i==2)
//                                        {
//                                            echo $result."@@".$j."##<br>";
//                                        }
//                                        echo $result."@@";exit;
                                        if($result==0)
                                        {
//                                            echo "@@<br>";
                                            if(strlen($time)==0)
                                            {
                                                $time=$dates[$j][$this->modelDvcName]['polling_time'];
//                                                echo $time."####";
                                            }
                                            if($id==0)
                                            {
                                                $id=$datas[$i][$this->modelDvcName]['id'];
                                            }
//                                           echo $id."$$";
//                                            echo $dates[$j+1]['Optdvc']['polling_time']."@@".$time;
//                                            echo "<pre>";
//                                            var_dump($newArray);
//echo $id."%%";
//                                            echo $dates[$j+1][$this->modelDvcName]['polling_time']."@@".$time."@@<br>";
                                            $count=$this->DateDiff($dates[$j+1][$this->modelDvcName]['polling_time'],$time);
 //                                           $newArray[]=array('id'=>$id,'connect_time'=>$count);
                                            $dtype=0;
//                                            echo "<pre>";
//                                            var_dump($newArray);
                                            for($m=0;$m<count($newArray);$m++)
                                            {
                                                if($id==$newArray[$m]['id'])
                                                {
                                                    $dtype=1;
                                                }
                                            }
                                            if($dtype==0)
                                            {
//                                                if($i==2)
//                                                {
//                                                        echo "<pre>%%%%%%%%%%%%%%%".$j;
//                                                        var_dump($times);
//                                                }
                                                $newArray[]=array('id'=>$id,'connect_time'=>$count);
                                                break;
//                                                echo "<pre>";
//                                                var_dump($newArray);
                                            }
//                                            else{
//                                                echo $id."***********";
//                                                $newArray[]=array('id'=>$id,'connect_time'=>-1);
//                                            }
//                                             echo "@@<br>";
                                            $time="";
                                            
//                                            
                                            $id = 0;
                                            $j++;
                                            
                                            
                                        }else{
//                                            
                                            if(strlen($time==0))
                                            {
                                                $time=$dates[$j][$this->modelDvcName]['polling_time'];
                                            }
//                                            if($j==2)
//                                            {
//                                                echo $datas[$i][$this->modelDvcName]['id']."##";
//                                            }
                                            if($id==0)
                                            {
                                                $id=$datas[$i][$this->modelDvcName]['id'];
                                            }
//                                            if($j==2)
//                                            {
//                                                echo $time."@@".$id."@@";
//                                            }
//                                            echo $id."&&";exit;
                                                $times[$hostid][]=$dates[$j+1][$this->modelDvcName]['polling_time'];
                                                $times[$hostid][]=$datas[$i]['Host']['host_name'];
                                                $times[$hostid][]=$datas[$i][$this->modelDvcName]['device_name'];
//                                            if(!in_array($dates[$j+1][$this->modelDvcName]['polling_time'],$times[$hostid]))
//                                            {
//                                                $times[$hostid][]=$dates[$j+1][$this->modelDvcName]['polling_time'];
//                                            }
//                                            if(!in_array($datas[$i]['Host']['host_name'],$times[$hostid]))
//                                            {
//                                                $times[$hostid][]=$datas[$i]['Host']['host_name'];
//                                            }
//                                            if(!in_array($datas[$i][$this->modelDvcName]['device_name'],$times[$hostid]))
//                                            {
//                                                $times[$hostid][]=$datas[$i][$this->modelDvcName]['device_name'];
//                                            }
//                                            if($i==2)
//                                            {
//                                                //unset($times[8][14]);
//                                                echo "<pre>#################";
//                                                var_dump($times);
//                                            }
//                                            echo "<pre>";
//                                            var_dump($times);
    //                                    $newArray[]=array('id'=>$datas[$i]['Optdvc']['id'],'connect_time'=>__('connect',$return = true));
    //                                    $newArray[]=array('id'=>$datas[$i]['Optdvc']['id'],'connect_time'=>-1);
    //                                        continue;
                                        }
                                        
//                                        array_pop($criteria1);
//                                        array_pop($criteria1);
//                                        array_pop($criteria1);
//                                        break;
                                    
                                  }else{
//                                        $newArray[]=array('id'=>$datas[$i][$this->modelDvcName]['id'],'connect_time'=>__('connect',$return = true));
                                        
//                                        if($id==8)
//                                        {
//                                            echo $time."**";
//                                        }
                                        
//                                        echo $datas[$i][$this->modelDvcName]['id']."##8888888888888888888888";
                                        if($id==0)
                                        {
//                                            echo "999999999999999999999999";
                                            $id=$datas[$i][$this->modelDvcName]['id'];
                                        }
//                                        echo $id."@@";
//                                        echo "<pre>";
//                                        var_dump($newArray);
										//echo $time_tmp;
                                        $dtype=0;
//                                        if($i==2)
//                                        {
//                                            echo $id;
//                                            echo "********************";
//                                            echo "<pre>";
//                                            var_dump($newArray);
//                                        }
                                        if(count($newArray)>0)
                                        {
                                            for($m=0;$m<count($newArray);$m++)
                                            {
                                                if($id==$newArray[$m]['id'])
                                                {
                                                    $dtype=1;
                                                }
                                            }
//                                            echo "333333333333333";
                                            if($dtype==0)
                                            {
//                                                echo "1111111111111";
                                                $newArray[]=array('id'=>$id,'connect_time'=>-1);
                                            }
                                        }else{
//                                            echo "2222222222222222";
                                            $newArray[]=array('id'=>$id,'connect_time'=>-1);
                                        }
        //                                $times[]=$datas[$i]['Optdvc']['polling_time'];
        //                                var_dump(in_array($datas[$i]['Optdvc']['polling_time'],$times));exit;
//                                        array_pop($criteria1);
//                                        array_pop($criteria1);
                                    }
                                    
                                }
                            
                            }

                        }
//                        echo "<pre>";
//                        var_dump($newArray);
                    return $newArray;
            }
            
  function set_model_name($start_time,$end_time)
    {
    	$units=$this->Lv->get_units($start_time,$end_time);
    	if($units==1)//時間単?

    	{
//            $this->modelProc= $this->Usehorproc;
//            $this->modelProcName="Usehorproc";
            //
            $this->modelDvc= $this->Opthordvc;
            $this->modelDvcName="Opthordvc";
            $this->tableDvcName="opthordvcs";
            $this->set('modnm','Opthordvc');
            //$this->set('modnm','Temp');
            
    	}else if($units==2)//日単?

    	{
//    	    $this->modelProc= $this->Usedayproc;
//            $this->modelProcName="Usedayproc";
            
            $this->modelDvc= $this->Optdaydvc;
            $this->modelDvcName="Optdaydvc";
            $this->tableDvcName="optdaydvcs";
             $this->set('modnm','Optdaydvc');
             //$this->set('modnm','Temp');
    	}
	
    }
    function get_new_data($criteriaData)
    {
        //xuwc 2007/12/03 begin
	unset($criteriaData['GROUP BY']);
	//$resultData = $this->modelDvc->findByAsso($criteriaData, array($this->modelDvcName.'.polling_time','Host.host_name',$this->modelDvcName.'.device_name'), $this->modelDvcName.".polling_time",null,null,$asso);
	
	$sql="SELECT ".$this->modelDvcName.".max_time as ".$this->modelDvcName."__polling_time, ";
	$sql.="Group.group_name AS Group__group_name, ";
	$sql.="Host.host_name AS Host__host_name, ";
	$sql.=$this->modelDvcName.".host_id AS ".$this->modelDvcName."__host_id, ";
	$sql.=$this->modelDvcName.".device_name AS ".$this->modelDvcName."__device_name, ";
	$sql.="(".$this->modelDvcName.".total_num * rltshdmods.inter_time/60 ) as total_time ";
	$sql.="FROM( SELECT host_id,device_name,max(max_time) as max_time,sum(num) as total_num FROM ".$this->tableDvcName." WHERE ";
	$sqlWhere="";
	$hstWhere="";
//	echo "<pre>";
//	var_dump($criteriaData);exit;
	foreach($criteriaData as $key=>$value)
	{
	    if(preg_match('/'.$this->modelDvcName.'/',$value))
            {
                $value=preg_replace('/'.$this->modelDvcName.'./','', $value);
            }
            if(preg_match('/Group.id/',$value))
            {
                $grpWhere=$value;
            }elseif(preg_match('/Host.host_name/',$value))
            {
                $hstWhere=$value;
            }
            else{
                if(strlen($sqlWhere)==0)
                {
                    $sqlWhere=$value;
                }else{
                    $sqlWhere.=" and ".$value;
                }
            }
	}
	$sql.=$sqlWhere;
	$sql.=" GROUP BY host_id,device_name) AS ".$this->modelDvcName." ";
	if(strlen($hstWhere)>0)
	{
	    $sql.=" INNER JOIN hosts AS Host ON ".$this->modelDvcName.".host_id = Host.id and ".$hstWhere;
	}else{
	   $sql.=" INNER JOIN hosts AS Host ON ".$this->modelDvcName.".host_id = Host.id";
	}
	$sql.=" INNER JOIN rlthstgrps AS Rlthstgrp ON ".$this->modelDvcName.".host_id = Rlthstgrp.host_id ";
	$sql.=" INNER JOIN groups AS Group ON Group.id = Rlthstgrp.group_id ";
	$sql.=" INNER JOIN rltgrpshds as Rltgrpshds ON Rltgrpshds.group_id = Group.id  and ".$grpWhere;
	$sql.=" INNER JOIN rltshdmods as Rltshdmods ON Rltshdmods.sch_id = Rltgrpshds.sch_id and Rltshdmods.module_id = 7 ";
	$sql.=" ORDER BY ".$this->modelDvcName.".max_time ASC ";
	//echo $sql."@@";exit;
	
	$resultData = $this->modelDvc->queryLV($sql);
	return $resultData;
    }
    
}
?>