<?php
class OperFilesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','Testcookie');
	var $uses=array('Optfile','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation');
	var $layout='oper';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar']))
		{
			$this->set('forHideVar', $_POST['forHideVar']);
			//echo $_POST['forHideVar'];
		}
		else if(isset($_POST['forHideVar1']))
		{       			//echo $_POST['forHideVar1'];
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
//	     function csvdown($criteria=null)
//    {
//        require_once( 'csv/DlFactory.php' );
//        
//		$clos=array('Optfile.id', 'Optfile.file_time', 'Group.group_name','Host.host_name', 'Optfile.operation_type','Optfile.file_name','Optfile.size','Optfile.directory');
//		$asso = array(
//		'Host : hosts' => array('Optfile.host_id = Host.id'),
//		'Rlthstgrp : rlthstgrps' => array('Optfile.host_id = Rlthstgrp.host_id'),
//		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
//		);		
//		$rows = $this->Optfile->findByAsso($criteria,$clos,null,'Group.id', 100000,1,$asso);	
//
//        $csv = DlFactory::create("oper_files");
//        
//        
//        
//        
//        $csv->sendCSVFile($rows,$this->data,"ファイル"); 
//
//       
//        
//        exit;
//       
//
//    }
	
	function  index()
	{
		
		$title = __('menu_oper',$return = true)."/".__('file',$return = true);   	 
    	$this->pageTitle = $title;
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		//	 $glist = array_merge($glist, $this->Group->generateList(null, null, null, '{n}.Group.id', '{n}.Group.group_name'));
		$this->set('glist',$glist);
		//		$flist =  $this->Optfile->generateList(null, null, null, '{n}.Optfile.size_unit', '{n}.Optfile.size_unit');
		//		foreach ($flist as $sizeunitlist)
		//		{
		//			$sizeunitlist==1 ? $f_list[]="KB" : null;
		//			$sizeunitlist==2 ? $f_list[]="MB" : null;
		//			$sizeunitlist==3 ? $f_list[]="GB" : null;
		//		}
		//		$this->set('f_list',$f_list);
		$contro= $this->requestAction('/Oper_files/contro',array('return'));
		$this->set('contro',$contro);
	}
	//////////////////////////////////////////CONTROLLER  url/////////////////////////////////////////////////////////////////
	function contro($url=null)
	{
		$this->layout='ajax';
			//	$this->Testcookie->operSetCookie();
			//	debug($_COOKIE);
		$dt= date('Y-m-d',time());
		$criteria = array();
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
//		if($type=='csv')
//		{
//		    $this->csvdown($criteria,$time,$type);
//		    exit;
//		}
        if(!empty($this->data['Host']['host_name']))
        {
            if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
            {
                 $hostname_error[]=__('E-00400',$return = true);
            }
             if(!$this->Validation->maxLength($this->data['Host']['host_name'],2000))
            {
                 $hostname_error[]=__('E-00300',$return = true);
            }
        }   
        

        $word_status = $this->data['Optfile']['status'];
        $word_status_ck1 = $this->data['Optfile']['status_ck1'];
		$word_status_ck2 = $this->data['Optfile']['status_ck2'];
		$word_status_ck3 = $this->data['Optfile']['status_ck3'];
		$word_status_ck4 = $this->data['Optfile']['status_ck4'];
		$word_status_ck5 = $this->data['Optfile']['status_ck5'];
		$word_status_ck6 = $this->data['Optfile']['status_ck6'];
        if($word_status==1)
         {
			if(empty($word_status_ck1) && empty($word_status_ck2) && empty($word_status_ck3) && empty($word_status_ck4) && empty($word_status_ck5) && empty($word_status_ck6))
			{
			$status_error[] = __('E-00200',$return = true);    
            }
         }
        
        
        $word_filename = $this->data['Optfile']['filename'];
        if($word_filename==1)
         {
	         if(!empty($this->data['Optfile']['filename_t']))
	         {
			     if(!$this->Validation->maxLength($this->data['Optfile']['filename_t'],2000))
				     {		
				     	 $filename_error[]= __('E-00300',$return = true);  					         
				     }
	         }
	         elseif(empty($this->data['Optfile']['filename_t']))
		           {
		         	  $filename_error[]= __('E-00100',$return = true);       	
		           }
          }
                   

        
        $word_extension = $this->data['Optfile']['extension'];
        if($word_extension==1)
         {
	         if(!empty($this->data['Optfile']['extension_t']))
	         {
			     if(!$this->Check->checkAllHalf($this->data['Optfile']['extension_t']))
		            {
		                 $extension_error[]=__('E-00400',$return = true);
		            }
	         	
			     if(!$this->Validation->maxLength($this->data['Optfile']['extension_t'],2000))
				     {		
				       $extension_error[]= __('E-00300',$return = true);  					         
				     }
	         }
	         elseif(empty($this->data['Optfile']['extension_t']))
		             {
		         	   $extension_error[]= __('E-00100',$return = true);       	
		             }
          }
          
          
       	$word_filesize = $this->data['Optfile']['filesize'];
        if($word_filesize==1)
         {
	         if(!empty($this->data['Optfile']['filesize_t']))
	         {
         	
			     if(!$this->Validation->maxLength($this->data['Optfile']['filesize_t'],2000))
				     {		
				       $size_error[]= __('E-00300',$return = true);  					         
				     }
	         }
	         elseif(empty($this->data['Optfile']['filesize_t']))
		             {
		         	   $size_error[]= __('E-00100',$return = true);        	
		             }
          }
          
          
               
		if(!empty($by_kw['error']) || !empty($by_dt['error'])|| !empty($hostname_error)|| !empty($status_error)|| !empty($filename_error)|| !empty($size_error)|| !empty($extension_error))
		{
			empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
			empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
			empty($hostname_error) ? null : $this->set('hostname_error',$hostname_error);
			empty($status_error) ? null : $this->set('status_error',$status_error);
			empty($filename_error) ? null : $this->set('filename_error',$filename_error);
			empty($size_error) ? null : $this->set('size_error',$size_error);
			empty($extension_error) ? null : $this->set('extension_error',$extension_error);
			$this->render();
			exit();
		}
		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(Optfile.file_time)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}
		$this->url($criteria);
	}
	//================================URLの表示==============================================================
	function url(& $criteria)
	{
		$this->layout='ajax';
		$word_status = $this->data['Optfile']['status'];
		$word_status_ck1 = $this->data['Optfile']['status_ck1'];
		$word_status_ck2 = $this->data['Optfile']['status_ck2'];
		$word_status_ck3 = $this->data['Optfile']['status_ck3'];
		$word_status_ck4 = $this->data['Optfile']['status_ck4'];
		$word_status_ck5 = $this->data['Optfile']['status_ck5'];
		$word_status_ck6 = $this->data['Optfile']['status_ck6'];
		$word_filename = $this->data['Optfile']['filename'];
		$word_filename_ck = $this->data['Optfile']['filename_ck'];
		$word_filesize = $this->data['Optfile']['filesize'];
		$word_extension = $this->data['Optfile']['extension'];
		isset($this->data['Optfile']['filesize_t']) ? $KB=$this->data['Optfile']['filesize_t']: $KB=null;
		$MB=$KB*1024;
		$GB=$MB*1024;
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar']))
		{
			$this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5B=Optfile-file_time&data%5Bdt_check%5D%5Bstart_year%5B=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptfile%5D%5Bgroup%5D=1&data%5BOptfile%5D%5Bstatus%5D=0&data%5BOptfile%5D%5Bstatus_ck1%5D=0&data%5BOptfile%5D%5Bstatus_ck2%5D=0&data%5BOptfile%5D%5Bstatus_ck3%5D=0&data%5BOptfile%5D%5Bstatus_ck4%5D=0&data%5BOptfile%5D%5Bstatus_ck5%5D=0&data%5BOptfile%5D%5Bstatus_ck6%5D=0&data%5BOptfile%5D%5Bfilename%5D=0&data%5BOptfile%5D%5Bfilename_ck%5D=-1&data%5BOptfile%5D%5Bfilesize%5D=0&data%5BOptfile%5D%5Bfilesize_s%5D=0&data%5BOptfile%5D%5Bfilesize_r%5D=0&data%5BOptfile%5D%5Bextension%5D=0&btn1=%E5%AE%9F%E8%A1%8C ');

			//$this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5D=Optfile-file_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptfile%5D%5Bgroup%5D=1&data%5BOptfile%5D%5Bstatus%5D=0&data%5BOptfile%5D%5Bstatus_ck1%5D=0&data%5BOptfile%5D%5Bstatus_ck2%5D=0&data%5BOptfile%5D%5Bstatus_ck3%5D=0&data%5BOptfile%5D%5Bstatus_ck4%5D=0&data%5BOptfile%5D%5Bstatus_ck5%5D=0&data%5BOptfile%5D%5Bstatus_ck6%5D=0&data%5BOptfile%5D%5Bfilename%5D=0&data%5BOptfile%5D%5Bfilename_ck%5D=-1&data%5BOptfile%5D%5Bfilesize%5D=0&data%5BOptfile%5D%5Bextension%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
		}
		

		
		$condition = "(";
		if($word_status==1)
		{
			if($word_status_ck1==1)
			{
				$condition = $condition."Optfile.operation_type = ".$word_status_ck1." OR ";
			}
			if($word_status_ck2==2)
			{
				$condition = $condition."Optfile.operation_type = ".$word_status_ck2." OR ";
			}
			if($word_status_ck3==3)
			{
				$condition = $condition."Optfile.operation_type = ".$word_status_ck3." OR ";
			}
			if($word_status_ck4==4)
			{
				$condition = $condition."Optfile.operation_type = ".$word_status_ck4." OR ";
			}
			if($word_status_ck5==5)
			{
				$condition = $condition."Optfile.operation_type = ".$word_status_ck5." OR ";
			}
			if($word_status_ck6==6)
			{
				$condition = $condition."Optfile.operation_type = ".$word_status_ck6." OR ";
			}
			if(!empty($condition))
			{
				$condition = substr($condition, 0, strlen($condition)-3);
				$condition = $condition.")";
				$criteria[]=$condition." ";
			}
		}


		if($word_filename==1)
         {
				if($word_filename_ck==0)
				{
					//wangs start 20080202
					//$criteria[]=" Optfile.file_name like '%".$this->data['Optfile']['filename_t']."%' ";
					$criteria[]=" lower(Optfile.file_name) like '%".strtolower($this->data['Optfile']['filename_t'])."%' ";
					//wangs end 20080202		
				}
				else
				{
					//wangs start 20080202
					//$criteria[]=" Optfile.file_name='".$this->data['Optfile']['filename_t']."' ";
					$criteria[]=" lower(Optfile.file_name)='".strtolower($this->data['Optfile']['filename_t'])."' ";
					//wangs start 20080202	
				}

          }		
		
		//              	$criteria[]="              Optfile.size*{1024的$this->data['Optfile']['filesize_s']-Optfile.size_unit次方  }                      >='".$this->data['Optfile']['filesize_t']."'  and Optfile.size_unit>='".$this->data['Optfile']['filesize_s']."' ";
		if($word_filesize == 1)
		{
			if($this->data['Optfile']['filesize_t']  != null)
			{
				if( $this->data['Optfile']['filesize_r'] == 0 )
				{
					if( $this->data['Optfile']['filesize_s'] == 0 )
					{
						$criteria[]=" Optfile.size >=".$KB." ";
					}
					elseif( $this->data['Optfile']['filesize_s'] == 1)
					{
						$criteria[]=" Optfile.size >=".$MB." ";
					}
					else
					{
						$criteria[]=" Optfile.size >=".$GB." ";
					}
				}
				if( $this->data['Optfile']['filesize_r'] == 1 )
				{
					if( $this->data['Optfile']['filesize_s'] == 0 )
					{
						$criteria[]=" Optfile.size<=".$KB." ";
					}
					elseif( $this->data['Optfile']['filesize_s'] == 1)
					{
						$criteria[]=" Optfile.size <=".$MB." ";
					}
					else
					{
						$criteria[]=" Optfile.size <=".$GB." ";
					}
				}
				if( $this->data['Optfile']['filesize_r'] == 2)
				{
					if( $this->data['Optfile']['filesize_s'] == 0 )
					{
						$criteria[]=" Optfile.size=".$KB." ";
					}
					elseif( $this->data['Optfile']['filesize_s'] == 1)
					{

						$criteria[]=" Optfile.size =".$MB." ";
					}
					else
					{
						$criteria[]=" Optfile.size =".$GB." ";
					}
				}
			}
			else{
				$criteria[]=" Optfile.size =";

			}
		}
		if($word_extension==1)
		{
			if($this->data['Optfile']['extension_t']  != null)
			{
//					if(!$this->Validation->alphaNumeric($this->data['Optfile']['extension_t']))
//						{
//						   $extension_error[] = __('E-00400',$return = true);			    			
//						}
//					if(!$this->Validation->maxLength($this->data['Optfile']['extension_t'],2000))
//						{
//				           $extension_error[]= __('E-00300',$return = true);	
//			            }
				     
				$sid=null;
				$fndata=$this->Optfile->findAll();
				foreach ($fndata as $fndatas)
				{
					$namec = explode(".",$fndatas['Optfile']['file_name']);
					if($namec[count($namec)-1]==$this->data['Optfile']['extension_t'])
					{
						$sid[]=$fndatas['Optfile']['id'];
					}
				}
				if($sid==null)
				{
					$criteria[]="Optfile.id in () ";
				}
				else{
					$criteria[]="Optfile.id in (".implode(",",$sid).")  ";
				}
			}
			else
			{
				$criteria[]="Optfile.id in () ";
				//$extension_error[]= __('E-00100',$return = true);  
			}
		}
//		  $this->set('extension_error',$extension_error);	
		  
		  


		
		
		
		/*if($this->data['optfile']['group']=='0' || empty($this->data['optfile']['group']))
		{
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/oper_files/contro', 'modelClass'=>'Optfile'));
		$data = $this->Optfile->findAll($criteria, NULL, $order,$limit,$page,5); // Extra parameters added
		}
		else
		{*/
		//$this_groups =0;

		if(!isset($this->data["Optfile"]["group"])||($this->data["Optfile"]["group"] == 0)){
			$this_groups =1;
		}else {
			$this_groups =$this->data["Optfile"]["group"];
		}
		$glist = $this->Grpauth->getChildrenByParent($this_groups);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		//print_r($criteria);
		//			$criteria[]=" Group.id = ".$this->data['optfile']['group']." ";
		$asso = array('Host : hosts' => array('Optfile.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optfile.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/oper_files/contro', 'modelClass'=>'Optfile', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Optfile.file_time','Group.group_name','Host.host_name', 'Optfile.operation_type','Optfile.file_name','Optfile.size','Optfile.directory')));
		$data = $this->Optfile->findByAsso($criteria,
		array('Optfile.id', 'Optfile.file_time', 'Group.group_name','Host.host_name', 'Optfile.operation_type','Optfile.file_name','Optfile.size','Optfile.directory'), 
		$order,
		$limit, 
		$page,
		$asso);
		//$data = $this->Optfile->findByAsso($criteria, array('Optfile.id', 'Optfile.file_time', 'Group.group_name','Host.host_name', 'Optfile.account', 'Optfile.operation_type','Optfile.file_name','Optfile.size','Optfile.size_unit','Optfile.directory'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		//	}
		$datac = 
		$this->Optfile->findByAsso($criteria, 
        array('Optfile.id', 'Optfile.file_time', 'Group.group_name','Host.host_name', 'Optfile.operation_type','Optfile.file_name','Optfile.size','Optfile.directory'), 
		$order,
		null, 
		null, 
		$asso
		  );
		$this->set('datac',$datac);		
		$this->set('data',$data);
		$this->render('url');
	}
}
?>