<?php
/*********************************************************************
*@filename   oper_prints_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/02   modify for LV20R1-187
********************************************************************/
class OperPrintsController extends AppController {
	//var $name='Operprints';
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Optprt','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation' );
	var $layout='oper';
	function beforeFilter()
	{
		//var_dump($_POST['forHideVar1']);
		parent::beforeFilter();
		//$this->Configure->write('debug', 2);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index()
	{
		$this->pageTitle =  __('oper_prints_title',$return = true);

		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());

		//$glist[0] =  __('whole',$return = true);
		//ksort($glist);
		$this->set('glist',$glist);
		//$contro= $this->requestAction('/oper_prints/contro',array('return'));
		//$this->set('contro',$contro);
	}

	//////////////////////////////////////////CONTROLLER    domain and url/////////////////////////////////////////////////////////////////
	function contro($url=null,$printer=null,$type=null)
	{
		$this->layout='ajax';
		$dt= date('Y-m-d',time());
		$criteria = array();
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();

		$err['Host/host_name']=array();
		$err['Optprt/account']=array();


		if(isset($this->data['Host']['host_name'])){
			if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
			{
				$err['Host/host_name'][]=__('E-00400',$return = true);
			}
			if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
			{
				$err['Host/host_name'][]=__('E-00300',$return = true);
			}
		}
		if(isset($this->data['Optprt']['account'])){
			if(!$this->Check->checkAllHalf($this->data['Optprt']['account']))
			{
				$err['Optprt/account'][]=__('E-00400',$return = true);
			}
			if(!$this->Validation->maxLength($this->data['Optprt']['account'],127))
			{
				$err['Optprt/account'][]=__('E-00300',$return = true);
			}
		}
		if(isset($this->data['Optprt']['print_file'])){
			if(!$this->Check->checkAllHalf($this->data['Optprt']['print_file']))
			{
				$err['Optprt/print_file'][]=__('E-00400',$return = true);
			}
			if(!$this->Validation->maxLength($this->data['Optprt']['print_file'],1024))
			{
				$err['Optprt/print_file'][]=__('E-00300',$return = true);
			}
		}


		if(!empty($by_kw['error']) || !empty($by_dt['error'])||!empty($err['Host/host_name'])||! empty($err['Optprt/account']))
		{

			empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
			empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
			empty($err['Host/host_name']) ? null : $this->set('err',$err);
			empty($err['Optprt/account']) ? null : $this->set('err',$err);

			$this->render();
			exit();
		}

		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(Optprt.print_time)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}


		if((isset($this->data['Optprt']['printer']) && $url!='1' && empty($this->data['Optprt']['domain1']))|| (empty($_POST['notFirstVisit'])&& empty($this->data['Optprt']['domain1'])&& $url!='1'))

		{
			//xinw start 20081202
			//modify for LV20R1-187
			$glist = $this->Grpauth->getChildrenByParent($this->data['Optprt']['group']);
			$condition="";
			foreach($glist as $key => $value){
				$condition.=$key.",";
			}
			$condition = substr($condition,0,-1);
			$criteria[]=" Group.id in (".$condition.") ";
			$asso_prt = array('Host : hosts' => array('Host.id = Optprt.host_id'),
			'Rlthstgrp : rlthstgrps' => array('Optprt.host_id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$log_count=$this->Optprt->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_print'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_print']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_print'].__("E-03900-1",true));
					$this->render();
					exit();
				}
			}
			//xinw end 20081202
			$this->domain($criteria,$type);
		}
		else
		{
			//wangs start 20080202
			//$url=='1'? $criteria[]="Optprt.printer='".$printer."' " : null;
			$printer = $this->Lv->url_param_decode2($printer);
			$url=='1'? $criteria[]="lower(Optprt.printer)='".strtolower($this->Lv->spec_char_dbm($printer))."' " : null;
			//wangs end 20080202

			$url=='1'? $this->set('forHideVar', $_POST['forHideVar']."&data%5BOptprt%5D%5Bdomain1%5D=$printer")  : null;
			if(!empty($this->data['Optprt']['domain1']))
			{
				//wangs start 20080202
				// $url=='1'? null : $criteria[]="Optprt.printer='".$this->data['Optprt']['domain1']."' ";
				$url=='1'? null : $criteria[]="lower(Optprt.printer)='".strtolower($this->data['Optprt']['domain1'])."' ";
				//wangs end 20080202
			}
			//xinw start 20081202
			//modify for LV20R1-187
			$glist = $this->Grpauth->getChildrenByParent($this->data['Optprt']['group']);
			$condition="";
			foreach($glist as $key => $value){
				$condition.=$key.",";
			}
			$condition = substr($condition,0,-1);
			$criteria[]=" Group.id in (".$condition.") ";
			$asso_prt = array('Host : hosts' => array('Host.id = Optprt.host_id'),
			'Rlthstgrp : rlthstgrps' => array('Optprt.host_id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$log_count=$this->Optprt->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_print'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_print']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_print'].__("E-03900-1",true));
					$this->render();
					exit();
				}
			}
			//xinw end 20081202
			$this->detail($criteria,$type);
		}
	}

	//================================ドメインごとの表示==========================================================
	function domain(& $criteria,$type=null)
	{
		$this->layout='ajax';
		$this->set('criteria',$criteria);
		$criteria['GROUP BY']='Optprt.printer';

		//		if((empty($_POST['forHideVar1']))&&(empty($_POST['forHideVar']))){
		//			$this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5D=Optprt-print_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptprt%5D%5Bgroup%5D=0&data%5Boptprt%5D%5Bprinter%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
		//		}
		if($type=='csv1')
		{
			$this->csvdown($criteria,1);exit();
		}
		if($this->data['Optprt']['group']=='0' || empty($this->data['Optprt']['group']))
		{
			$this->data['Optprt']['group']='1';
		}

		$glist = $this->Grpauth->getChildrenByParent($this->data['Optprt']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		$asso = array('Host : hosts' => array('Host.id = Optprt.host_id'),
		'Rlthstgrp : rlthstgrps' => array('Optprt.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		//list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_prints/contro', 'modelClass'=>'Optprt','sortBy' => $this->Lv->sortBy('Optprt.printer'), 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_prints/contro', 'modelClass'=>'Optprt','sortBy' => $this->Lv->sortBy('Optprt.printer'), 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		//$data = $this->Optprt->findByAsso($criteria, array('Optprt.printer', 'count(Optprt.id) as Optprt__con'), 'Optprt.printer', $limit, $page, $asso);
		$data = $this->Optprt->findByAsso($criteria, array('Optprt.printer', 'sum(Optprt.papers) as Optprt__con'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		//	$this->set('count',count($count=$this->Optprt->findByAsso($criteria, array('count(Optprt.printer) as count'), null, null, null, $asso)));
		$this->set('data',$data);
		$this->render('domain');
	}
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;

	}
	function csvdown($criteria,$type)
	{
		require_once( 'csv/DlFactory.php' );
		if($type == 1) {
			if(!isset($this->data["Optprt"]["group"])||($this->data["Optprt"]["group"] == 0)){
				$this_groups =$this->_getUserGroup_id();
			}else {
				$this_groups =$this->data["Optprt"]["group"];
			}
			$this->data["Optprt"]["group"] = $this->groupName($this_groups);
			$url="";

			if(isset($this->data['Optprt-search'])){

				if((($this->data['Optprt-search'][0]=='Optprt-print_file')&&($this->data['Optprt-search'][1]=='Optprt-printer'))||(($this->data['Optprt-search'][0]=='Optprt-print_file')&&($this->data['Optprt-search'][1]=='Optprt-printer'))){
					$url.=__('title_url',$return = true);
				}
				elseif($this->data['Optprt-search'][0]=='Optprt-print_file'){
					$url.=__('title_print',$return = true);
				}
				elseif($this->data['Optprt-search'][0]=='Optprt-printer'){
					$url.=__('url_print',$return = true);
				}
				//$url.="タイトル URL : ";
				$url.=$this->data['Optprt']['search_'];
				$this->data["Optprt"]["search1"] = $url;
			}
			$asso = array(
			'Host : hosts' => array('Optprt.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$data = $this->Optprt->findByAsso($criteria, array('Optprt.printer','sum(Optprt.papers) as Optprt__con'), 'Optprt.printer',100000, 1, $asso);
			//var_dump($data);
			$csv = DlFactory::create("opt_prts");
			$csv->sendCSVFile($data,$this->data,__('optprt_log',$return = true));
		}elseif($type == 2){
			$asso = array('Host : hosts' => array('Optprt.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$data = $this->Optprt->findByAsso($criteria, array('Optprt.id','Optprt.account','Optprt.print_file', 'Optprt.print_time', 'Group.group_name','Host.host_name','Optprt.printer','Optprt.papers'), 'Optprt.print_time', 100000, 1, $asso);
			$this_groups =$this->data["Optprt"]["group"];
			$this->data["Optprt"]["group"] = $this->groupName($this_groups);
			$url="";

			if(isset($this->data['Optprt-search'])){

				if((($this->data['Optprt-search'][0]=='Optprt-print_file')&&($this->data['Optprt-search'][1]=='Optprt-printer'))||(($this->data['Optprt-search'][0]=='Optprt-print_file')&&($this->data['Optprt-search'][1]=='Optprt-printer'))){
					$url.=__('print_file_name_print_name',$return = true);
				}
				elseif($this->data['Optprt-search'][0]=='Optprt-print_file'){
					$url.=__('print_file_name',$return = true);
				}
				elseif($this->data['Optprt-search'][0]=='Optprt-printer'){
					$url.=__('print_name',$return = true);
				}
				//$url.="タイトル URL : ";
				$url.=$this->data['Optprt']['search_'];
				$this->data["Optprt"]["search1"] = $url;
			}
			$csv = DlFactory::create("opt_prt_twos");
			$csv->sendCSVFile($data,$this->data, __('record_csv',$return = true));
		}

		exit;
	}

	//================================URLの表示==============================================================
	function detail(& $criteria,$type=null)
	{
		$this->layout='ajax';
		if($this->data['Optprt']['group']=='0' || empty($this->data['Optprt']['group']))
		{
			$this->data['Optprt']['group']='1';
		}
		if($type=='csv2')
		{
			$this->csvdown($criteria,2);exit();
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['Optprt']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		$asso = array('Host : hosts' => array('Host.id = Optprt.host_id'),
		'Rlthstgrp : rlthstgrps' => array('Optprt.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);

		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/oper_prints/contro', 'modelClass'=>'Optprt','sortBy' => $this->Lv->sortBy('Optprt.print_time'), 'queryType' => array('function' => 'findByAsso', 'asso' => $asso)));
		$data = $this->Optprt->findByAsso($criteria, array('Optprt.id', 'Optprt.print_time', 'Group.group_name','Host.host_name', 'Optprt.account', 'Optprt.print_file','Optprt.printer','Optprt.papers'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		//	$this->set('count',$count=$this->Optprt->findByAsso($criteria, array('count(*) as count'), null, null, null, $asso));
		//var_dump($data);
		$this->set('data',$data);
		$this->render('detail');
	}
}
?>
