<?php
class OperUsbfilesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','Testcookie');
	var $uses=array('Fileop','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation');
	var $layout='oper';
	function beforeFilter()
	{
		//parent::beforeFilter();
		//$this->Configure->write('debug', 2);
		if(isset($_POST['forHideVar']))
		{
			$this->set('forHideVar', $_POST['forHideVar']);
			//echo $_POST['forHideVar'];
		}
		else if(isset($_POST['forHideVar1']))
		{       			//echo $_POST['forHideVar1'];
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function csvdown(& $criteria=null)
	{
		require_once( 'csv/DlFactory.php' );
		
		$clos= array('Fileop.status_time', 'Group.group_name','Host.host_name', 'Fileop.operation_type','Fileop.filepath','Fileop.account');
		$asso = array(
		'Host : hosts' => array('Fileop.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Fileop.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);		
		$rows = $this->Fileop->findByAsso($criteria,$clos,'Group.id', 100000,1,$asso);	
	
		$csv = DlFactory::create("oper_usbfiles");
		
		$csv->sendCSVFile($rows, $this->data,"ファイル"); 

		exit;
	}	
	function  index()
	{
		$title = __('menu_oper',$return = true)."/".__('file',$return = true);   	 
    	$this->pageTitle = $title;
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist',$glist);

	//	$contro= $this->requestAction('/Oper_usbfiles/contro',array('return'));
	//	$this->set('contro',$contro);
	}
	
	function contro($url=null)
	{
		$this->layout='ajax';

		$dt= date('Y-m-d',time());
		$criteria = array();
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();

        if(!empty($this->data['Host']['host_name']))
        {
            if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
            {
                 $hostname_error[]=__('E-00400',$return = true);
            }
             if(!$this->Validation->maxLength($this->data['Host']['host_name'],2000))
            {
                 $hostname_error[]=__('E-00300',$return = true);
            }
        }   
        

        $word_status = $this->data['Fileop']['status'];
        $word_status_ck1 = $this->data['Fileop']['status_ck1'];
		$word_status_ck2 = $this->data['Fileop']['status_ck2'];
		$word_status_ck3 = $this->data['Fileop']['status_ck3'];
		$word_status_ck4 = $this->data['Fileop']['status_ck4'];
		$word_status_ck5 = $this->data['Fileop']['status_ck5'];
		$word_status_ck6 = $this->data['Fileop']['status_ck6'];
        if($word_status==1)
         {
			if(empty($word_status_ck1) && empty($word_status_ck2) && empty($word_status_ck3) && empty($word_status_ck4) && empty($word_status_ck5) && empty($word_status_ck6))
			{
			$status_error[] = __('E-00200',$return = true);    
            }
         }
        
        
        $word_filename = $this->data['Fileop']['filename'];
        if($word_filename==1)
         {
	         if(!empty($this->data['Fileop']['filename_t']))
	         {
			     if(!$this->Validation->maxLength($this->data['Fileop']['filename_t'],2000))
				     {		
				     	 $filename_error[]= __('E-00300',$return = true);  					         
				     }
	         }
	         elseif(empty($this->data['Fileop']['filename_t']))
		           {
		         	  $filename_error[]= __('E-00100',$return = true);       	
		           }
          }
                   

        
        $word_extension = $this->data['Fileop']['extension'];
        if($word_extension==1)
         {
	         if(!empty($this->data['Fileop']['extension_t']))
	         {
			     if(!$this->Check->checkAllHalf($this->data['Fileop']['extension_t']))
		            {
		                 $extension_error[]=__('E-00400',$return = true);
		            }
	         	
			     if(!$this->Validation->maxLength($this->data['Fileop']['extension_t'],2000))
				     {		
				       $extension_error[]= __('E-00300',$return = true);  					         
				     }
	         }
	         elseif(empty($this->data['Fileop']['extension_t']))
		             {
		         	   $extension_error[]= __('E-00100',$return = true);       	
		             }
          }
          
          
       	$word_filesize = $this->data['Fileop']['filesize'];
        if($word_filesize==1)
         {
	         if(!empty($this->data['Fileop']['filesize_t']))
	         {
         	
			     if(!$this->Validation->maxLength($this->data['Fileop']['filesize_t'],2000))
				     {		
				       $size_error[]= __('E-00300',$return = true);  					         
				     }
	         }
	         elseif(empty($this->data['Fileop']['filesize_t']))
		             {
		         	   $size_error[]= __('E-00100',$return = true);        	
		             }
          }
          
          
               
		if(!empty($by_kw['error']) || !empty($by_dt['error'])|| !empty($hostname_error)|| !empty($status_error)|| !empty($filename_error)|| !empty($size_error)|| !empty($extension_error))
		{
			empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
			empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
			empty($hostname_error) ? null : $this->set('hostname_error',$hostname_error);
			empty($status_error) ? null : $this->set('status_error',$status_error);
			empty($filename_error) ? null : $this->set('filename_error',$filename_error);
			empty($size_error) ? null : $this->set('size_error',$size_error);
			empty($extension_error) ? null : $this->set('extension_error',$extension_error);
			$this->render();
			exit();
		}
		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(Fileop.status_time)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}
		if($url=='csv')
		{
		    $this->csvdown($criteria);
		    exit;
		}else
			$this->url($criteria);
		
	}
	//================================URLの表示==============================================================
	function url(& $criteria)
	{
		$this->layout='ajax';
		$word_status = $this->data['Fileop']['status'];
		$word_status_ck1 = $this->data['Fileop']['status_ck1'];
		$word_status_ck2 = $this->data['Fileop']['status_ck2'];
		$word_status_ck3 = $this->data['Fileop']['status_ck3'];
		$word_status_ck4 = $this->data['Fileop']['status_ck4'];
		$word_status_ck5 = $this->data['Fileop']['status_ck5'];
		$word_status_ck6 = $this->data['Fileop']['status_ck6'];
		$word_filename = $this->data['Fileop']['filename'];
		$word_filename_ck = $this->data['Fileop']['filename_ck'];
		$word_filesize = $this->data['Fileop']['filesize'];
		$word_extension = $this->data['Fileop']['extension'];
		isset($this->data['Fileop']['filesize_t']) ? $KB=$this->data['Fileop']['filesize_t']: $KB=null;
		$MB=$KB*1024;
		$GB=$MB*1024;
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar']))
		{
			$this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5B=Fileop-status_time&data%5Bdt_check%5D%5Bstart_year%5B=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5BFileop%5D%5Bgroup%5D=1&data%5BFileop%5D%5Bstatus%5D=0&data%5BFileop%5D%5Bstatus_ck1%5D=0&data%5BFileop%5D%5Bstatus_ck2%5D=0&data%5BFileop%5D%5Bstatus_ck3%5D=0&data%5BFileop%5D%5Bstatus_ck4%5D=0&data%5BFileop%5D%5Bstatus_ck5%5D=0&data%5BFileop%5D%5Bstatus_ck6%5D=0&data%5BFileop%5D%5Bfilename%5D=0&data%5BFileop%5D%5Bfilename_ck%5D=-1&data%5BFileop%5D%5Bfilesize%5D=0&data%5BFileop%5D%5Bfilesize_s%5D=0&data%5BFileop%5D%5Bfilesize_r%5D=0&data%5BFileop%5D%5Bextension%5D=0&btn1=%E5%AE%9F%E8%A1%8C ');
		}
		
		$condition = "(";
		if($word_status==1)
		{
			if(!empty($word_status_ck1))
			{
				$condition = $condition."Fileop.operation_type = ".$word_status_ck1." OR ";
			}
			if(!empty($word_status_ck2))
			{
				$condition = $condition."Fileop.operation_type = ".$word_status_ck2." OR ";
			}
			if(!empty($word_status_ck3))
			{
				$condition = $condition."Fileop.operation_type = ".$word_status_ck3." OR ";
			}
			if(!empty($word_status_ck4))
			{
				$condition = $condition."Fileop.operation_type = ".$word_status_ck4." OR ";
			}
			if(!empty($word_status_ck5))
			{
				$condition = $condition."Fileop.operation_type = ".$word_status_ck5." OR ";
			}
			if(!empty($word_status_ck6))
			{
				$condition = $condition."Fileop.operation_type = ".$word_status_ck6." OR ";
			}
			if(!empty($condition))
			{
				$condition = substr($condition, 0, strlen($condition)-3);
				$condition = $condition.")";
				$criteria[]=$condition." ";
			}
		}


		if($word_filename==1)
         {
				if($word_filename_ck==0)
				{
					$criteria[]=" lower(Fileop.filepath) like '%".strtolower($this->data['Fileop']['filename_t'])."%' ";	
				}
				else
				{
					$criteria[]=" lower(Fileop.filepath)='".strtolower($this->data['Fileop']['filename_t'])."' ";
				}

          }		
		/*
		if($word_filesize == 1)
		{
			if($this->data['Fileop']['filesize_t']  != null)
			{
				if( $this->data['Fileop']['filesize_r'] == 0 )
				{
					if( $this->data['Fileop']['filesize_s'] == 0 )
					{
						$criteria[]=" Fileop.size >=".$KB." ";
					}
					elseif( $this->data['Fileop']['filesize_s'] == 1)
					{
						$criteria[]=" Fileop.size >=".$MB." ";
					}
					else
					{
						$criteria[]=" Fileop.size >=".$GB." ";
					}
				}
				if( $this->data['Fileop']['filesize_r'] == 1 )
				{
					if( $this->data['Fileop']['filesize_s'] == 0 )
					{
						$criteria[]=" Fileop.size<=".$KB." ";
					}
					elseif( $this->data['Fileop']['filesize_s'] == 1)
					{
						$criteria[]=" Fileop.size <=".$MB." ";
					}
					else
					{
						$criteria[]=" Fileop.size <=".$GB." ";
					}
				}
				if( $this->data['Fileop']['filesize_r'] == 2)
				{
					if( $this->data['Fileop']['filesize_s'] == 0 )
					{
						$criteria[]=" Fileop.size=".$KB." ";
					}
					elseif( $this->data['Fileop']['filesize_s'] == 1)
					{

						$criteria[]=" Fileop.size =".$MB." ";
					}
					else
					{
						$criteria[]=" Fileop.size =".$GB." ";
					}
				}
			}
			else{
				$criteria[]=" Fileop.size =";

			}
		}*/
		if($word_extension==1)
		{
			if($this->data['Fileop']['extension_t']  != null)
			{     
				$criteria[]=" lower(Fileop.filepath) like '%".strtolower($this->data['Fileop']['extension_t'])."' ";	
			}
		}

		if(!isset($this->data["Fileop"]["group"])||($this->data["Fileop"]["group"] == 0)){
			$this_groups =1;
		}else {
			$this_groups =$this->data["Fileop"]["group"];
		}
		$glist = $this->Grpauth->getChildrenByParent($this_groups);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";

		$asso = array('Host : hosts' => array('Fileop.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Fileop.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/oper_usbfiles/contro', 'modelClass'=>'Fileop', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Fileop.status_time','Group.group_name','Host.host_name', 'Fileop.operation_type','Fileop.filepath','Fileop.account')));
		$data = $this->Fileop->findByAsso($criteria,
		array('Fileop.status_time', 'Group.group_name','Host.host_name', 'Fileop.operation_type','Fileop.filepath','Fileop.account'), 
		$order,
		$limit, 
		$page,
		$asso);
		
		empty($data)? $data=array():$data;
		$datac = $this->Fileop->findByAsso($criteria, 
			array('Fileop.status_time', 'Group.group_name','Host.host_name', 'Fileop.operation_type','Fileop.filepath','Fileop.account'), 
			$order,
			null, 
			null, 
			$asso);
		$this->set('datac',$datac);		
		$this->set('data',$data);
		$this->render('url');
	}
}
?>