<?php
/*********************************************************************
*@filename oper_webs_controller.php
*@description OperWebsController
*@note
*@histories  rivision	  author		date		       comment
*                2.0      zhangs       2008/10/18     modify for LV20R1-169
*                2.0       xinw        2008/12/02     modify for LV20R1-187
*                2.0       xinw        2009/01/09     modify for LV20R1-204
*                2.0      xushanning   2009/04/22     modify for LogvillageChinese
********************************************************************/
class OperWebsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Optweb','Group', 'Host','Rlthstgrp','Grpauth', 'Validation','Configure');
	var $layout='oper';

	//	var $cacheAction = array(
	//	    'index'  => 21600,
	//	);

	function beforeFilter()
	{//debug($_POST, true);
		parent::beforeFilter();
		$this->pageTitle =__('menu_oper',$retrun=true)."/".__('web_operation',$retrun=true); // '操作管??Web操?';
		//          	$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index()
	{
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());//グルプリスト?   Sessionから
		//ksort($glist);
		$this->set('glist',$glist);
		//		$contro= $this->requestAction('/oper_webs/contro',array('return'));
		//	         $this->set('contro',$contro);
	}
	//////////////////////////////////////////CONTROLLER    domain and url/////////////////////////////////////////////////////////////////
	//zhangs start 20081018
	//modify for LV20R1-169
	//function contro($url=null,$domain=null)
	function contro($url=null,$domain=null,$count_data=null)
	//zhangs end 20081018
	{	
		if(isset($this->data['mode']['report']))
			$this->set('reportmode',$this->data['mode']['report']);
		$this->layout='ajax';
		$dt= date('Y-m-d',time());
		$criteria = array();
		$err=array();
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		if(isset($this->data['Host']['host_name']))
		{
			if(!$this->Lv->is_empty($this->data['Host']['host_name']))
			{
				if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
				{
					//xushanning  start 2009/04/22     add for LogvillageChinese
					//$err['computer'][] = 'E-00400';
					$err['set_computer'][] = 'E-00400';
					//xushanning  end 2009/04/22     add for LogvillageChinese
				}
				if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
				{
					//xushanning  start 2009/04/22     add for LogvillageChinese
					//$err['computer'][] = 'E-00300';
					$err['set_computer'][] = 'E-00300';
					//xushanning  end 2009/04/22     add for LogvillageChinese
				}
			}
		}
		if(isset($this->data['Optweb']['account']))
		{
			if(!$this->Lv->is_empty($this->data['Optweb']['account']))
			{
				if(!$this->Check->checkAllHalf($this->data['Optweb']['account']))
				{
					//xushanning  start 2009/04/22     add for LogvillageChinese
					//$err['logon account'][] = 'E-00400';
					$err['set_login_account'][] = 'E-00400';
					//xushanning  end 2009/04/22     add for LogvillageChinese
				}
				if(!$this->Validation->maxLength($this->data['Optweb']['account'],127))
				{
					//xushanning  start 2009/04/22     add for LogvillageChinese
					//$err['logon account'][] = 'E-00300';
					$err['set_login_account'][] = 'E-00300';
					//xushanning  end 2009/04/22     add for LogvillageChinese
				}
			}
		}
		if(isset($this->data['Optweb-search']) && (!$this->Lv->is_empty($this->data['Optweb']['search_'])))
		{
			if($this->data['Optweb-search'][0]=="Optweb-url_title"){
				if(!$this->Validation->maxLength($this->data['Optweb']['search_'],1000))
				{
					//xushanning  start 2009/04/22     add for LogvillageChinese
					//$err['check_search'][] = 'E-00300';
					$err['set_search'][] = 'E-00300';
					//xushanning  end 2009/04/22     add for LogvillageChinese
				}
			}
			elseif($this->data['Optweb-search'][0]=="Optweb-url"){
				if(!$this->Validation->maxLength($this->data['Optweb']['search_'],2083))
				{
					//xushanning  start 2009/04/22     add for LogvillageChinese
					//$err['check_search'][] = 'E-00300';
					$err['set_search'][] = 'E-00300';
					//xushanning  end 2009/04/22     add for LogvillageChinese
				}
			}
		}
		// if((isset($this->data['Optweb']['search']) && isset($this->data['Optweb']['url_title'])) ||  (isset($this->data['Optweb']['search']) && isset($this->data['Optweb']['url'])))
		// {
		//     if(!$this->Validation->maxLength($this->data['Optweb']['account'],2000))
		//    {
		//        $err['logon account'][] = 'E-00300';
		//   }
		//   }
		if(!empty($by_kw['error']) || !empty($by_dt['error']) || !empty($err))
		{
			empty($err) ? null : $this->set('err',$err);
			empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
			empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
			$this->render();
			//$criteria = array();
			exit();
		}

		if(empty($by_dt) && empty($by_kw))
		{
			$criteria[]="datepart(Optweb.access_time)= '".$dt."'";
		}
		else
		{
			empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
			empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}
		if((isset($this->data['optweb']['domain']) && $url!='1' && empty($this->data['Optweb']['domain1']))|| (empty($_POST['notFirstVisit'])&& empty($this->data['Optweb']['domain1'])&& $url!='1'))
		{
			//xinw start 20081202
			//modify for LV20R1-187
			$glist = $this->Grpauth->getChildrenByParent($this->data['optweb']['group']);
			$condition="";
			foreach($glist as $key => $value){
				$condition.=$key.",";
			}
			$condition = substr($condition,0,-1);
			$criteria[]=" Group.id in (".$condition.") ";
			$asso_prt = array('Host : hosts' => array('Optweb.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Optweb.host_id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$log_count=$this->Optweb->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_web_access'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_web_access']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_web_access'].__("E-03900-1",true));
					$this->render();
					exit();
				}
			}
			//xinw end 20081202
			$this->domain(null,$criteria);
		}
		else
		{
			//wangs start 20080202
			//$url=='1'? $criteria[]="Optweb.domain='".$domain."' " : null;
			$url=='1'? $criteria[]="lower(Optweb.domain)='".strtolower($domain)."' " : null;
			//wangs end 20080202

			//zhangs start 20081018
			//modify for LV20R1-169
			if($url=='1'){
				$_SESSION['urlcsvcon'] = "lower(Optweb.domain)='".strtolower($domain)."' ";
			}
			//zhangs end 20081018


			$url=='1'? $this->set('forHideVar', $_POST['forHideVar']."&data%5BOptweb%5D%5Bdomain1%5D=$domain")  : null;
			if(!empty($this->data['Optweb']['domain1']))
			{
				//wangs start 20080202
				// $url=='1'? null : $criteria[]="Optweb.domain='".$this->data['Optweb']['domain1']."' ";
				$url=='1'? null : $criteria[]="lower(Optweb.domain)='".strtolower($this->data['Optweb']['domain1'])."' ";
				//wangs end 20080202
			}
			//zhangs start 20081018
			//modify for LV20R1-169
			//$this->url(null,$criteria);
			//xinw start 20081202
			//modify for LV20R1-187
			$glist = $this->Grpauth->getChildrenByParent($this->data['optweb']['group']);
			$condition="";
			foreach($glist as $key => $value){
				$condition.=$key.",";
			}
			$condition = substr($condition,0,-1);
			$criteria[]=" Group.id in (".$condition.") ";
			$asso_prt = array('Host : hosts' => array('Optweb.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Optweb.host_id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$log_count=$this->Optweb->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_web_access'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_web_access']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_web_access'].__("E-03900-1",true));
					$this->render();
					exit();
				}
			}
			//xinw end 20081202
			//xinw start 20090109
			//modify for LV20R1-204
			//$this->url(null,$criteria,$count_data);
			$this->url($url,$criteria,$count_data);
			//xinw end 20090109
			//zhangs end 20081018
		}

	}
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
	//================================ドメインごとの表示==========================================================
	//zhangs start 20081018
	//modify for LV20R1-169
	//function csvdown($criteria=array(),$type=null)
	function csvdown($criteria=array(),$csv_cond,$type=null)
	//zhangs end 20081018
	{
		require_once( 'csv/DlFactory.php' );

		if(!isset($this->data["optweb"]["group"])||($this->data["optweb"]["group"] == 0)){
			$this_groups ='1';
		}else {
			$this_groups =$this->data["optweb"]["group"];
		}
		$this->data["optweb"]["group"] = $this->groupName($this_groups);
		$url="";
		if(isset($this->data['Optweb-search'])){


			//if((($this->data['Optweb-search'][0]=='Optweb-url_title')&&($this->data['Optweb-search'][1]=='Optweb-url'))||(($this->data['Optweb-search'][0]=='Optweb-url')&&($this->data['Optweb-search'][1]=='Optweb-url_title'))){
			//	$url.="タイトル URL : ";
			//}
			if($this->data['Optweb-search'][0]=='Optweb-url_title'){
				$url.=__('title',$retrun=true)." : ";
			}
			elseif($this->data['Optweb-search'][0]=='Optweb-url'){
				//xushanning start  2009/04/22     modify for LogvillageChinese
				//$url.=__('URL_all',$retrun=true)." : ";
				$url.="URL_all : ";
				//xushanning end  2009/04/22     modify for LogvillageChinese
			}
			//$url.="タイトル URL : ";
			$url.=$this->data['Optweb']['search_'];
			$this->data["Optweb"]["search1"] = $url;
		}
		$dt= date('Y-m-d',time());
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		if(empty($by_kw['error']) && empty($by_dt['error']))
		{
			if(empty($by_dt) && empty($by_kw))
			{
				$criteria[]="datepart(Optweb.access_time)= '".$dt."'";
			}
			else
			{
				empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
				empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
			}
		}
		//zhangs start 20081018
		//modify for LV20R1-169
		$criteria[]= $csv_cond;
		//zhangs end 20081018
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optweb.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		if($type == 1) {
			$data = $this->Optweb->findByAsso($criteria, array('Optweb.domain', 'count(Optweb.id) as Optweb__con'), 'Optweb.domain,Optweb__con', 100000, 1, $asso);
			//$i=0;
			// foreach ($data as $result){
			// 	$data[$i]['Optweb']['domain']='"'.$data[$i]['Optweb']['domain'].'"';
			// 	$data[$i]['Optweb']['con']='"'.$data[$i]['Optweb']['con'].'"';
			//  $i++;
			// }
			//var_dump($data);
			$csv = DlFactory::create("oper_webs");
			$csv->sendCSVFile($data,$this->data,__('web_operation',$return = true));
		}
		elseif($type == 2){
			debug($criteria);
			$data = $this->Optweb->findByAsso($criteria, array('Optweb.id', 'Optweb.access_time', 'Group.group_name','Host.host_name', 'Optweb.account', 'Optweb.url_title','Optweb.url','Optweb.domain'), 'Optweb.access_time, Group.group_name, Host.host_name, Optweb.account, Optweb.url_title, Optweb.url', 100000, 1, $asso);
			//$i=0;

			//foreach ($data as $result){
			//        	$data[$i]['Optweb']['access_time']='"'.$data[$i]['Optweb']['access_time'].'"';
			//        	$data[$i]['Group']['group_name']='"'.$data[$i]['Group']['group_name'].'"';
			//        	$data[$i]['Host']['host_name']='"'.$data[$i]['Host']['host_name'].'"';
			//        	$data[$i]['Optweb']['account']='"'.$data[$i]['Optweb']['account'].'"';
			//        	$data[$i]['Optweb']['url_title']='"'.$data[$i]['Optweb']['url_title'].'"';
			//        	$data[$i]['Optweb']['url']='"'.$data[$i]['Optweb']['url'].'"';
			//        	$i++;
			//        }
			$csv = DlFactory::create("oper_webs_twos");
			$csv->sendCSVFile($data,$this->data,__('web_operation',$return = true));
		}
	}
	function domain($type=null,& $criteria=array())
	{
		$this->layout='ajax';
		//debug($this->data);
		//$url="";
		//if(isset($this->data['Optweb-search'])){
		//	if($this->data['Optweb-search'][0]=='Optweb-url_title'){

		//	}

		//}
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar','&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optweb-access_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptweb%5D%5Bgroup%5D=1&data%5Boptweb%5D%5Bdomain%5D=0&submitToSearch=%E5%AE%9F%E8%A1%8C');
		}
		$this->set('criteria',$criteria);
		$criteria['GROUP BY']='Optweb.domain';

		if($this->data['optweb']['group']=='0' || empty($this->data['optweb']['group']))
		{
			$this->data['optweb']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['optweb']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		//zhangs start 20081018
		//modify for LV20R1-169
		//$criteria[]=" Group.id in (".$condition.") ";
		$csv_cond = " Group.id in (".$condition.") ";

		if($type=='csv'){
			//$this->csvdown($criteria,1);exit;
			$this->csvdown($criteria,$csv_cond,1);exit;
		}
		$criteria[]=" Group.id in (".$condition.") ";
		//zhangs end 20081018
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optweb.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search', 'url'=>'/oper_webs/contro', 'modelClass'=>'Optweb', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Optweb.domain, Optweb__con')));
		$data = $this->Optweb->findByAsso($criteria, array('Optweb.domain', 'count(Optweb.id) as Optweb__con'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->render('domain');
	}

	//================================URLの表示==============================================================
	//zhangs start 20081018
	//modify for LV20R1-169
	//function url($type=null,& $criteria=array())
	function url($type=null,& $criteria=array(),$count_data=null)
	//zhangs end 20081018
	{
		//xinw start 20090109
		//modify for LV20R1-204
		$this->set('domain1',$this->data['Optweb']['domain1']);
		$this->set('type',$type);
		//xinw end 20090109
		$this->layout='ajax';
		//debug($this->data);
		//echo "=========". $this->data['Optweb-search'] ."===========";
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar','&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optweb-access_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptweb%5D%5Bgroup%5D=1&data%5Boptweb%5D%5Bdomain%5D=0&submitToSearch=%E5%AE%9F%E8%A1%8C');
		}
		if($this->data['optweb']['group']=='0' || empty($this->data['optweb']['group']))
		{
			$this->data['optweb']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['optweb']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		//zhangs start 20081018
		//modify for LV20R1-169
		//$criteria[]=" Group.id in (".$condition.") ";
		$csv_cond = " Group.id in (".$condition.") ";

		if($type=='csv'){
			//$this->csvdown($criteria,2);exit;
			if($_SESSION['urlcsvcon']&&!empty($_SESSION['urlcsvcon'])){
				$criteria[] = $_SESSION['urlcsvcon'];
				unset($_SESSION['urlcsvcon']);
			}
			$this->csvdown($criteria,$csv_cond,2);exit;
		}

		$criteria[]=" Group.id in (".$condition.") ";
		//zhangs end 20081018
		$asso = array('Host : hosts' => array('Optweb.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Optweb.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);

		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/oper_webs/contro', 'modelClass'=>'Optweb', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Optweb.access_time, Group.group_name, Host.host_name, Optweb.account, Optweb.url_title, Optweb.url'))); //debug($order);
		$data = $this->Optweb->findByAsso($criteria, array('Optweb.id', 'Optweb.access_time', 'Group.group_name','Host.host_name', 'Optweb.account', 'Optweb.url_title','Optweb.url','Optweb.domain'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		//zhangs start 20081018
		//modify for LV20R1-169
		$this->set('count_data',$count_data);
		//zhangs end 20081018
		$this->render('url');
	}
}
?>