<?php
/*********************************************************************
*@filename      opt_files_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/03   modify for LV20R1-187
*            2.0        xushanning  2009/04/09   modify for LogvillageChinese
********************************************************************/
class OptFilesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Optfile','Group', 'Host','Rlthstgrp','Grpauth','Configure','Validation','Optuser','Grpdrt','Hstdrt','Grpshd');
	var $layout='opt';

	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index()
	{
		$this->pageTitle =__('menu_opt',$retrun=true)."/".__('fileupdate',$retrun=true);   //Title::運用管理/イベントログ
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());//グループリスト   Sessionから
		//ksort($glist);
		$this->set('glist',$glist);


		//$glist1=$this->Grpauth->getChildren2($this->_getUserGroup());
		//debug($glist1,true);

		//debug($temp,true);
		//          $contro= $this->requestAction('/use_evtlogs/contro',array('return'));
		//	 $this->set('contro',$contro);
	}

	function contro($link=null,$search=null,$about_sess=null)
	{
		//$temp=$this->get_directory($this->data['optfile']['group']);
		//debug($temp,true);

		$this->layout='ajax';
		$err = array();
		$dt= date('Y-m-d',time());
		$criteria = array();
		//$by_kw = $this->Lv->operSearch();
		$time_type = $this->data['Optfile']['time_type'];
		switch( $time_type ){
		case 0:
			//$by_dt = $this->Lv->optionsDatetime3("Optfile-status_time","Optfile-polling_time");
			$by_dt = $this->Lv->optionsDatetime3("Optfile-polling_time");
			break;
		case 1:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_create");
			break;
		case 2:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_modify");
			break;
		case 3:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_create");
			$by_dt2 = $this->Lv->optionsDatetime2("Optfile-file_modify");
			break;
		case 4:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_create");
			$by_dt3 = $this->Lv->optionsDatetime2("Optfile-file_modify");
			break;
		}

		//$by_dt = $this->Lv->optionsDatetime();

		//$criteria=$by_dt;
		$search=$this->Lv->url_param_decode2($search);
		//debug($by_dt,true);
		//		echo "=======================================";
		//		echo empty($path)?"nonononono":count($path);
		//		echo $path[0];
		/*if ($link=="wholedisplay") {
		(!empty($link))?$_SESSION['temp1']=$link:"";
		}*/

		//echo $_SESSION['temp1']."8888888888888888888888888888888888888";
		//		echo $_SESSION['20_resultsPerPage']."11111111111111111111111111";
		//		echo $_SESSION['50_resultsPerPage']."22222222222222222222222222";
		//		echo $_SESSION['100_resultsPerPage']."3333333333333333333333333";
		if ($about_sess=="destroy_PerPagesession"){
			//(!empty($_SESSION['temp_wholedisplay']))?session_unregister('temp_wholedisplay'):"";
			(!empty($_SESSION['20_resultsPerPage']))?session_unregister('20_resultsPerPage'):"";
			(!empty($_SESSION['50_resultsPerPage']))?session_unregister('50_resultsPerPage'):"";
			(!empty($_SESSION['100_resultsPerPage']))?session_unregister('100_resultsPerPage'):"";
		}

		if ($about_sess=="destroy_allsession"){
		(!empty($_SESSION['temp_wholedisplay']))?session_unregister('temp_wholedisplay'):"";
		(!empty($_SESSION['20_resultsPerPage']))?session_unregister('20_resultsPerPage'):"";
		(!empty($_SESSION['50_resultsPerPage']))?session_unregister('50_resultsPerPage'):"";
		(!empty($_SESSION['100_resultsPerPage']))?session_unregister('100_resultsPerPage'):"";
		(!empty($_SESSION['col']))?session_unregister('col'):"";
		(!empty($_SESSION['search']))?session_unregister('search'):"";
		}

		if ($about_sess=="destroy_extractsession"){
		(!empty($_SESSION['col']))?session_unregister('col'):"";
		(!empty($_SESSION['search']))?session_unregister('search'):"";
		}

		if(isset($this->data['Host']['host_name']))
		{
			if(!$this->Lv->is_empty($this->data['Host']['host_name']))
			{
				if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
				{
					$err['computer'][] = 'E-00400';
				}
				if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
				{
					$err['computer'][] = 'E-00300';
				}
			}
		}

		if ($link=='col2' || (isset($_SESSION['col']) && $_SESSION['col']=='col2'))
		{
			$criteria=$by_dt;
			//echo $link."=========================";
			//echo $search."==============================";
			//$this->set('search_h',$search);
			//echo "***************************************************".$_SESSION['col'];
			//echo "---------------------------------------------------".$_SESSION['search'];

			//			if ($link=='col2') {
			//				$criteria[]=" Host.host_name = '".$search."'";
			//			}elseif ($_SESSION['col']=='col2')
			//			{
			//				$criteria[]=" Host.host_name = '".$_SESSION['search']."'";
			//			}

			(empty($search))?$criteria[]=" Host.host_name = '".$this->Lv->spec_char_dbm($_SESSION['search'])."'":$criteria[]=" Host.host_name = '".$this->Lv->spec_char_dbm($search)."'";
			//xushanning start 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "コンピュータ名: 「".(empty($search)?$_SESSION['search']:$search)."」 で絞込み";
			$mess_pc = __('computerName',$return = true).(empty($search)?$_SESSION['search']:$search).__('conditions',$return = true);
			//xushanning end 2009/04/10 modify for LogvillageChinese
			$this->set("mess_pc",$mess_pc);
			$this->url(null,$criteria,null,null,null,$link,$search);
			//$this->set('search',__('make right',true).$search.__('key right',true));
		}elseif ($link=='col1' || (isset($_SESSION['col']) && $_SESSION['col']=='col1') ){
			$criteria=$by_dt;
			//$criteria[]=" Group.group_name = '".$search."'";

			(empty($search))?$criteria[]=" Group.group_name = '".$this->Lv->spec_char_dbm($_SESSION['search'])."'":$criteria[]=" Group.group_name = '".$this->Lv->spec_char_dbm($search)."'";

			//xushanning start 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "グループ名: 「".(empty($search)?$_SESSION['search']:$search)."」 で絞込み";
			$mess_pc = __('group_Name',$return = true).(empty($search)?$_SESSION['search']:$search).__('conditions',$return = true);
			//xushanning end 2009/04/10 modify for LogvillageChinese
			$this->set("mess_pc",$mess_pc);
			$this->url(null,$criteria,null,null,null,$link,$search);
		}elseif ($link=='col3' || (isset($_SESSION['col']) && $_SESSION['col']=='col3') ){
			$criteria=$by_dt;
			//$criteria[]=" Optfile.operation_type =".$search;

			(empty($search))?$criteria[]=" Optfile.operation_type = ".$_SESSION['search']:$criteria[]=" Optfile.operation_type = ".$search;

			if($search==6 || $_SESSION['search']==6){
				$file_type =  __('filetype_delete',$return = true);
				//$_SESSION['search']=__('filetype_delete',$return = true);
			}
			elseif($search==5 || $_SESSION['search']==5){
				$file_type = __('filetype_rename',$return = true);
				//$_SESSION['search']=__('filetype_rename',$return = true);
			}
			elseif($search==4 || $_SESSION['search']==4){
				$file_type = __('filetype_update',$return = true);
				//$old_filename ="(" .$ajax->link(__('oldfilename',$return = true), "/Optfiles/View/{$output['Optuser']['account']}").")";
				//$old_filename="(" .$html->link(__('oldfilename',$return = true), "#",array("onclick" => "window.showModalDialog('oldfilenameshow.html','{$directory}'  ,'dialogWidth=200px;dialogHeight=200px;status=no;help=no');")).")";
				//$_SESSION['search']=__('filetype_update',$return = true);
			}
			elseif($search==3 || $_SESSION['search']==3){
				$file_type = __('filetype_move',$return = true);
				//$originstatus= "(" .$ajax->link(__('originmove',$return = true), "/Optfiles/View/{$output['Optuser']['account']}").")";
				//$originstatus= "(" .$html->link(__('originmove',$return = true), "#",array("onclick" => "window.showModalDialog('showdirectory.html','{$output['Optfile']['directory']}'  ,'dialogWidth=200px;dialogHeight=200px;status=no;help=no');")).")";
				//$_SESSION['search']=__('filetype_move',$return = true);
			}
			elseif($search==2 || $_SESSION['search']==2){
				$file_type = __('filetype_copy',$return = true);
				//$originstatus ="(" .$ajax->link(__('origincopy',$return = true), "/Optfiles/View/{$output['Optuser']['account']}").")";
				//$_SESSION['search']=__('filetype_copy',$return = true);
			}
			elseif($search==1 || $_SESSION['search']==1){
				$file_type = __('filetype_complete',$return = true);
				//$_SESSION['search']=__('filetype_complete',$return = true);
			}
			else{
				$file_type="";
				//$_SESSION['search']="";
			}
			//xushanning start 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "ステータス: 「".(empty($file_type)?$_SESSION['search']:$file_type)."」 で絞込み";
			$mess_pc = __('starts_Name',$return = true).(empty($file_type)?$_SESSION['search']:$file_type).__('conditions',$return = true);
			//xushanning end 2009/04/10 modify for LogvillageChinese
			$this->set("mess_pc",$mess_pc);
			$this->url(null,$criteria,null,null,null,$link,$search);
		}elseif ($link=='col4' || (isset($_SESSION['col']) && $_SESSION['col']=='col4') ){
			$criteria=$by_dt;
			//$criteria[]=" Optfile.file_name = '".$search."'";

			(empty($search))?$criteria[]=" Optfile.file_name = '".$this->Lv->spec_char_dbm($_SESSION['search'])."'":$criteria[]=" Optfile.file_name = '".$this->Lv->spec_char_dbm($search)."'";
			//xushanning start 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "ファイル名: 「".(empty($search)?$_SESSION['search']:$search)."」 で絞込み";
			$mess_pc = __('file_Name',$return = true).(empty($search)?$_SESSION['search']:$search).__('conditions',$return = true);
			//xushanning end 2009/04/10 modify for LogvillageChinese
			$this->set("mess_pc",$mess_pc);
			$this->url(null,$criteria,null,null,null,$link,$search);
		}elseif ($link=='col5' || (isset($_SESSION['col']) && $_SESSION['col']=='col5') ){
			$criteria=$by_dt;
			//$criteria[]=" Optfile.size = ".$search;


			if ($_SESSION['search']=='zero' || $search=='zero')
			{
				$criteria[]=" Optfile.size =0 ";
			}
			else
			{
			(empty($search))?$criteria[]=" Optfile.size = ".$_SESSION['search']:$criteria[]=" Optfile.size = ".$search;
			}



			//(empty($search))?$criteria[]=" Optfile.size = ".$_SESSION['search']:$criteria[]=" Optfile.size = ".$search;
			//xushanning start 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "ファイルサイズ: 「".(empty($search)?(($_SESSION['search']=='zero')?'0':$_SESSION['search']):(($search=='zero')?'0':$search))."B」 で絞込み";
			$mess_pc = __('file_Size',$return = true).(empty($search)?(($_SESSION['search']=='zero')?'0':$_SESSION['search']):(($search=='zero')?'0':$search)).__('bconditions',$return = true);
			//xushanning end 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "ファイルサイズ: 「".(empty($search)?$_SESSION['search']:$search)."B」 で絞込み";
			$this->set("mess_pc",$mess_pc);
			$this->url(null,$criteria,null,null,null,$link,$search);
		}elseif (/*isset($search)&&$link==16*/$link=='col6' || (isset($_SESSION['col']) && $_SESSION['col']=='col6') ){
			$criteria=$by_dt;
			//$criteria[]=" Optfile.directory = '".$search."'";
			//			if ($link=='col6') {
			//				$criteria[]=" Optfile.directory  like '%".$search."'";
			//			}elseif ($_SESSION['col']=='col6')
			//			{
			//				$criteria[]=" Optfile.directory like '%".$_SESSION['search']."'";
			//			}

			(empty($search))?$criteria[]=" Optfile.directory like '%".$this->Lv->spec_char_like($_SESSION['search'])."'":$criteria[]=" Optfile.directory  like '%".$this->Lv->spec_char_like($search)."'";
			//(empty($search))?$criteria[]=" Optfile.directory = ".$_SESSION['search']:$criteria[]=" Optfile.directory = ".$search;
			//xushanning start 2009/04/10 modify for LogvillageChinese
			//$mess_pc = "フォルダ名: 「".(empty($search)?$_SESSION['search']:$search)."」 で絞込み";
			$mess_pc = __('fold_Name',$return = true).(empty($search)?$_SESSION['search']:$search).__('conditions',$return = true);
			//xushanning end 2009/04/10 modify for LogvillageChinese
			$this->set("mess_pc",$mess_pc);
			$this->url(null,$criteria,null,null,null,$link,$search);
		}
		else{

			if(empty($by_dt['error'])){
				if(empty($by_kw['error'])){
					if(empty($err)){
						if(empty($by_dt) && empty($by_kw))
						{
							//							echo "+++++++++++++++++++++++";
							//$criteria[]="datepart(Optfile.status_time)= '".$dt."'";
						}
						else
						{
							if(!empty($by_kw))
								$criteria[] = implode(' and ', $by_kw);
							if(!empty($by_dt))
							{
								if(!empty($by_dt2))
								{
									$criteria[] = "(".implode(' and ', $by_dt)." or ".implode(' and ', $by_dt2).")";
								}elseif(!empty($by_dt3))
								{
									$criteria[] = implode(' and ', $by_dt)." and ".implode(' and ', $by_dt3);
								}else{
									$criteria[] = implode(' and ', $by_dt);
								}
							}
						}
						$this->url(null,$criteria,null,null,null,$link,$search,$time_type);
					}
					else{
						$this->url(null,$criteria,null,null,$err,$link,$search,$time_type);
					}
				}
				else{
					if(empty($err)){
						$this->url(null,$criteria,null,$by_kw['error'],null,$link,$search,$time_type);
					}
					else{
						$this->url(null,$criteria,null,$by_kw['error'],$err,$link,$search,$time_type);
					}
				}
			}
			else{
				if(empty($by_kw['error'])){
					if(empty($err)){
						$this->url(null,$criteria,$by_dt['error'],null,null,$link,$search,$time_type);
					}
					else{
						$this->url(null,$criteria,$by_dt['error'],null,$err,$link,$search,$time_type);
					}
				}
				else{
					if(empty($err)){
						$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],null,$link,$search,$time_type);
					}
					else{
						$this->url(null,$criteria,$by_dt['error'],$by_kw['error'],$err,$link,$search,$time_type);
					}
				}
			}
		}
	}

	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;

	}

	function getOperation($id)
	{
		switch ($id)
		{
			case '6':
				$result=__('filetype_delete',$return = true);
				break;
			case '5':
				$result=__('filetype_rename',$return = true);
				break;
			case '4':
				$result=__('filetype_update',$return = true);
				break;
			case '3':
				$result=__('filetype_move',$return = true);
				break;
			case '2':
				$result=__('filetype_copy',$return = true);
				break;
			case '1':
				$result=__('filetype_complete',$return = true);
				break;
		}
		return $result;
	}


	function csvdown($criteria=array(),$type=null,$time_type=null)
	{
		require_once( 'csv/DlFactory.php' );
		if(!isset($this->data["optfile"]["group"])||($this->data["optfile"]["group"] == 0)){
			$this_groups =$this->_getUserGroup();
		}
		else {
			$this_groups =$this->data["optfile"]["group"];
		}
		$this->data["optfile"]["group"] = $this->groupName($this_groups);
		/*$event_catalog="";
		for($i=0;$i<count($this->data['Optfile']['operation_type_ck']);$i++)
		{
			$event_catalog.=$this->getOperation($this->data['Optfile']['operation_type_ck'][$i])." ";
		}
		$this->data['Optfile']['operation_type_ck']=$event_catalog;
		*/

		$extend_temp="";
		if (isset($this->data["Optfile"]["extend_ck"])){
			if ($this->data["Optfile"]["extend_ck"]==0) {
				$extend_temp=$this->data['Optfile']['extendfromselect'];
				$this->data["Optfile"]["extend_ck"]=$extend_temp;
			}elseif ($this->data["Optfile"]["extend_ck"]==2){
				$extend_temp=$this->data['Optfile']['extend_ck_t'];
				$this->data["Optfile"]["extend_ck"]=$extend_temp;
			}

		}

		$size_temp="";
		if (isset($this->data["Optfile"]["size"])){

			$size_down=$this->get_size($this->data['Optfile']['sizefromselect_1'],$this->data['Optfile']['file_size_t1']);
			if ($this->data['Optfile']['conditionfromselect_1']==1 && !empty($this->data['Optfile']['file_size_t2']))
			{
				$size_up=$this->get_size($this->data['Optfile']['sizefromselect_2'],$this->data['Optfile']['file_size_t2']);
				$size_temp=$size_down."B<= size <=".$size_up."B";
				$this->data['Optfile']['file_size_t1']=$size_temp;
			}elseif($this->data['Optfile']['conditionfromselect_1']==1 && empty($this->data['Optfile']['file_size_t2']))
			{
				$size_temp="size >=".$size_down."B";
				$this->data['Optfile']['file_size_t1']=$size_temp;
			}
			elseif ($this->data['Optfile']['conditionfromselect_1']==3)
			{
				$size_temp="size <=".$size_down."B";
				$this->data['Optfile']['file_size_t1']=$size_temp;
			}elseif ($this->data['Optfile']['conditionfromselect_1']==2)
			{
				$size_temp="size=".$size_down."B";
				$this->data['Optfile']['file_size_t1']=$size_temp;
			}
		}

		$folder_path="";
		if (isset($this->data["Optfile"]["directory_ck"]) && empty($this->data['Optfile']['directory_text']))
		{
			$this->data['Optfile']['directory_text']=$this->data['Optfile']['device'].$this->data['Optfile']['folder'];
		}elseif (!empty($this->data['Optfile']['directory_text']))
		{
			$this->data['Optfile']['directory_text']=$this->data['Optfile']['device'].$this->data['Optfile']['directory_text'];
		}



		//$criteria[]=" Optfile.size = ".$_SESSION['search'];
		if($_SESSION['col']=='col2')
		{
			$criteria[]=" Host.host_name = '".$_SESSION['search']."'";
		}elseif ($_SESSION['col']=='col1')
		{
			$criteria[]=" Group.group_name = '".$_SESSION['search']."'";
		}elseif ($_SESSION['col']=='col3')
		{
			$criteria[]=" Optfile.operation_type = ".$_SESSION['search'];
		}elseif ($_SESSION['col']=='col4')
		{
			$criteria[]=" Optfile.file_name = '".$_SESSION['search']."'";
		}elseif ($_SESSION['col']=='col5')
		{
		($_SESSION['search']=="zero")?($criteria[]=" Optfile.size =0"):($criteria[]=" Optfile.size = ".$_SESSION['search']);
		}elseif ($_SESSION['col']=='col6')
		{
			$criteria[]=" Optfile.directory like '%".$this->Lv->spec_char_like($_SESSION['search'])."'";
		}

		/*$event_type="";
		for($i=0;$i<count($this->data['Optfile']['operation_type_ck']);$i++)
		{
		$event_type.=$this->getType($this->data['Optfile']['operation_type_ck'][$i])." ";
		}
		$this->data['Optfile']['operation_type_ck']=$event_type;*/
		$dt= date('Y-m-d',time());
		$by_kw = $this->Lv->operSearch();
		//$by_dt = $this->Lv->optionsDatetime();
		
		$time_type = $this->data['Optfile']['time_type'];
		switch( $time_type ){
		case 0:
			$by_dt = $this->Lv->optionsDatetime3("Optfile-polling_time");
			//$by_dt = $this->Lv->optionsDatetime2("Optfile-polling_time");
			break;
		case 1:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_create");
			break;
		case 2:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_modify");
			break;
		case 3:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_create");
			$by_dt2 = $this->Lv->optionsDatetime2("Optfile-file_modify");
			break;
		case 4:
			$by_dt = $this->Lv->optionsDatetime2("Optfile-file_create");
			$by_dt3 = $this->Lv->optionsDatetime2("Optfile-file_modify");
			break;
		}

		if(empty($by_kw['error']) && empty($by_dt['error']))
		{
			if(empty($by_dt) && empty($by_kw))
			{
				$criteria[]="datepart(Optfile.polling_time)= '".$dt."'";
			}
			else
			{
				if(!empty($by_kw))
					$criteria[] = implode(' and ', $by_kw);
				if(!empty($by_dt))
				{
					if(!empty($by_dt2))
					{
						$criteria[] = implode(' and ', $by_dt)." or ".implode(' and ', $by_dt2);
					}elseif(!empty($by_dt3))
					{
						$criteria[] = implode(' and ', $by_dt)." and ".implode(' and ', $by_dt3);
					}else{
						$criteria[] = implode(' and ', $by_dt);
					}
				}
			}
		}
		///////////
		
		$asso = array(
		//'Hstdrt:hstdrts'=>array('Optfile.host_id=Hstdrt.host_id'),
		'Host : hosts' => array('Optfile.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Rlthstgrp.group_id = Group.id'),
		//'Optuser: optusers' => array('Host.id = Optuser.host_id'),
		//'Optfolder:optfolders'=>array('Optfolder.host_id=Optfile.host_id')
		);
		
		if($time_type == 0){//収集日で検索
			$crit = $criteria;
			$crit['GROUP by'] = "Optfile.host_id, Optfile.volume_name";
			$host_maxpoll = $this->Optfile->findByAsso($crit, array('Optfile.host_id','max(Optfile.polling_time) as `Optfile__maxpoll`','Optfile.volume_name'), null,null,null, $asso);
			//debug($host_maxpoll);
			
			$maxpollcri = "(1=2 ";
			foreach ($host_maxpoll as $value)
			{
				$h_=$value['Optfile']['host_id'];
				$p_=$value['Optfile']['maxpoll'];
				$v_=$value['Optfile']['volume_name'];
				$maxpollcri .= "or (Optfile.host_id=$h_ and Optfile.polling_time='$p_' and Optfile.volume_name='$v_') ";
			}
			$maxpollcri .= ") ";
			$criteria[]=$maxpollcri;
		}else
			$criteria['GROUP by'] = "Optfile.host_id,Optfile.file_name,Optfile.directory";

		//$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Group.group_name','Host.host_name', 'Optfile.operation_type','Optfile.file_name','Optfile.size','Optfile.directory','Optfile.host_id','Optfile.old_directory'), 'Optfile.status_time,Group.group_name,Host.host_name,Optfile.operation_type,Optfile.file_name,Optfile.size,Optfile.directory', 100000, 1, $asso);
		//$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id','Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'), 'Optfile.status_time,Group.group_name,Host.host_name,Optfile.operation_type,Optfile.file_name,Optfile.size,Optfile.directory', 100000, 1, $asso);
		$order = 'Optfile.status_time,Group.group_name,Host.host_name,Optfile.operation_type,Optfile.file_name,Optfile.size,Optfile.directory';
		if($time_type == 0)//収集日で検索
			$data = $this->Optfile->findByAsso($criteria, array('distinct Optfile.polling_time as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id','Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'), $order, 100000, 1, $asso);
		else
			$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id','Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'), $order, 100000, 1, $asso);

		//$data=$this->get_account($data);
		//$i=0;
		//                 foreach ($data as $result){
		//                 	$data[$i]['Useevtlog']['event_time']='"'.$data[$i]['Useevtlog']['event_time'].'"';
		//                  	$data[$i]['Group']['group_name']='"'.$data[$i]['Group']['group_name'].'"';
		//                  	$data[$i]['Host']['host_name']='"'.$data[$i]['Host']['host_name'].'"';
		//                  	$data[$i]['Useevtlog']['account']='"'.$data[$i]['Useevtlog']['account'].'"';
		//                   	$data[$i]['Useevtlog']['event_id']='"'.$data[$i]['Useevtlog']['event_id'].'"';
		//                   	$data[$i]['Useevtlog']['source']='"'.$data[$i]['Useevtlog']['source'].'"';
		//                    	$data[$i]['Useevtlog']['specification']='"'.$data[$i]['Useevtlog']['specification'].'"';
		//                    	$i++;
		//  }
		if($type=='csv'){
			$csv = DlFactory::create("opt_files");
			//print_r($data)."+++++++++++++++++++++++++++++++++";
			$csv->sendCSVFile($data,$this->data,__('detailslog',$return = true));
		}
		elseif($type=='xml')
		{
			$xml = DlFactory::createxml("opt_files");
			$xml->sendXMLFile($data,$this->data,__('detailslog',$return = true));exit;
		}
	}







	function url($type=null,& $criteria=array(),$err1=null,$err2=null,$err3=null,$link=null,$search=null,$time_type=null)
	{
		$this->layout='ajax';
		$errorMessage = array();
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			//			$this->set('forHideVar', '0&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Useevtlog-event_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Buseevtlog%5D%5Bgroup%5D=1&data%5BUseevtlog%5D%5Bevent_catalog%5D=0&data%5BUseevtlog%5D%5Bevent_type%5D=0&data%5BUseevtlog%5D%5Bevent_id%5D=0&data%5BUseevtlog%5D%5Bevent_id_ck%5D=-1&data%5BUseevtlog%5D%5Bsource%5D=0&data%5BUseevtlog%5D%5Bsource_ck%5D=-1&data%5BUseevtlog%5D%5Bspecification%5D=0&btn1=%E5%AE%9F%E8%A1%8C
			//			$this->set('forHideVar', '0&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optfile-status_time&data%5Bdt_check%5D%5Bstart_year%5D=' . '1998' . '&data%5Bdt_check%5D%5Bstart_month%5D=' . '01' . '&data%5Bdt_check%5D%5Bstart_day%5D=' . '01' . '&data%5Bdt_check%5D%5B0%5D=date&data%5Bdt_check%5D%5Bend_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bend_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bend_day%5D=' . date('d') . '&data%5Boptfile%5D%5Bgroup%5D=1&data%5BOptfile%5D%5Bevent_catalog%5D=0&data%5BOptfile%5D%5Bevent_type%5D=0&data%5BOptfile%5D%5Bevent_id%5D=0&data%5BOptfile%5D%5Bevent_id_ck%5D=-1&data%5BOptfile%5D%5Bsource%5D=0&data%5BOptfile%5D%5Bsource_ck%5D=-1&data%5BOptfile%5D%5Bdirectory%5D=0&btn1=%E5%AE%9F%E8%A1%8C
			//			$this->set('forHideVar', '0&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optfile-status_time&data%5Bdt_check%5D%5Bstart_year%5D=' . '1998' . '&data%5Bdt_check%5D%5Bstart_month%5D=' . '01' . '&data%5Bdt_check%5D%5Bstart_day%5D=' . '01' . '&data%5Bdt_check%5D%5B0%5D=date&data%5Bdt_check%5D%5Bend_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bend_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bend_day%5D=' . date('d') . '&data%5Boptfile%5D%5Bgroup%5D=1&data%5BOptfile%5D%5Boperation_type_ck%5D=0&data%5BOptfile%5D%5Bfile_name%5D=0&data%5BOptfile%5D%5Bfilename_ck%5D=0&data%5BOptfile%5D%5Bsize%5D=0&data%5BOptfile%5D%5operation_type_ck%5D=-1&data%5BOptfile%5D%5Bsource%5D=0&data%5BOptfile%5D%5Bsource_ck%5D=-1&data%5BOptfile%5D%5Bdirectory%5D=0&btn1=%E5%AE%9F%E8%A1%8C
			$this->set('forHideVar', '0&data%5BsortBy%5D=0&data%5Bdt_check%5D%5Bname%5D=Optfile-status_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Boptfile%5D%5Bgroup%5D=1&data%5BHost%5D%5Bhost_name%5D=0&data%5BOptfile%5D%5Bextend_ck_t%5D=0&data%5BOptfile%5D%5Bfilename_t%5D=0&data%5BOptfile%5D%5Bfilename_ck%5D=0&data%5BUseevtlog%5D%5Bsource%5D=0&data%5BUseevtlog%5D%5Bsource_ck%5D=-1&data%5BUseevtlog%5D%5Bspecification%5D=0&btn1=%E5%AE%9F%E8%A1%8C');								  
		}
		//echo "+++++++++++++++++++++++++++++++++++++".$link;
		//$this->set('temp1',$link);
		($link=="wholedisplay")?$_SESSION['temp_wholedisplay']=$link:null;
		($link=="20_resultsPerPage")?$_SESSION['20_resultsPerPage']=$link:null;
		($link=="50_resultsPerPage")?$_SESSION['50_resultsPerPage']=$link:null;
		($link=="100_resultsPerPage")?$_SESSION['100_resultsPerPage']=$link:null;

		($link=="col2")?$_SESSION['col']=$link:null;
		($link=="col1")?$_SESSION['col']=$link:null;
		($link=="col3")?$_SESSION['col']=$link:null;
		($link=="col4")?$_SESSION['col']=$link:null;
		($link=="col5")?$_SESSION['col']=$link:null;
		($link=="col6")?$_SESSION['col']=$link:null;

		(!empty($search))?$_SESSION['search']=$search:"";
		//$this->set('temp1',$link);
		//$this->set('temp1',$link);
		//echo "*************************************".$_SESSION['temp1'];

		//search by host_name
		if(isset($this->data['Host']['host_name']))
		{
			if($this->data['Host']['host_name']==1){
				if(isset($this->data['Host']['hostname_t']))
				{
					if(!$this->Lv->is_empty($this->data['Host']['hostname_t'])){
						if(!$this->Check->checkAllHalf($this->data['Host']['hostname_t']) || !$this->Validation->maxLength($this->data['Host']['hostname_t'],127)){
							if(!$this->Check->checkAllHalf($this->data['Host']['hostname_t'])){
								$errorMessage['check_host_name'][] = 'E-00400';
							}
							if(!$this->Validation->maxLength($this->data['Host']['hostname_t'],127)){
								$errorMessage['check_host_name'][] = 'E-00300';
							}
						}
						else{

							//$this->data['Host']['hostname_t']=$this->Lv->spec_char_dbm($this->Lv->url_param_decode2($this->data['Host']['hostname_t']));
							if($this->data['Host']['hostname_ck']==0){
								//$criteria[]= " (lower(Host.host_name)='".strtolower($this->data['Host']['hostname_t'])."') ";
								$criteria[]= " (lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like($this->data['Host']['hostname_t']))."%') ";
							}
							else{
								//$criteria[]= " (lower(Host.host_name) like '%".strtolower($this->data['Host']['hostname_t'])."%') ";
								$criteria[]= " (lower(Host.host_name)='".strtolower($this->Lv->spec_char_dbm($this->data['Host']['hostname_t']))."') ";
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Host']['hostname_t'])){
						$errorMessage['check_host_name'][] = 'E-00100';
					}
				}
			}
		}
		// search by host_name


		//search by extend
		if(isset($this->data['Optfile']['extend']))
		{
			if($this->data['Optfile']['extend']==1){
				if(isset($this->data['Optfile']['extend_ck']) && $this->data['Optfile']['extend_ck']==2)
				{
					if(!$this->Lv->is_empty($this->data['Optfile']['extend_ck_t'])){
						if(!$this->Check->checkAllHalf($this->data['Optfile']['extend_ck_t']) || !$this->Validation->maxLength($this->data['Optfile']['extend_ck_t'],127)){
							if(!$this->Check->checkAllHalf($this->data['Optfile']['extend_ck_t'])){
								$errorMessage['check_extend_type'][] = 'E-00400';
							}
							if(!$this->Validation->maxLength($this->data['Optfile']['extend_ck_t'],127)){
								$errorMessage['check_extend_type'][] = 'E-00300';
							}
						}else{
							//			     	   if (!empty($data['Optfile']['extendfromselect']))
							//			     	   {
							//			     	   	echo __("----");
							//			     	   }
							$this->data['Optfile']['extend_ck_t']=$this->Lv->spec_char_dbm($this->data['Optfile']['extend_ck_t']);
							$criteria[]= " lower(Optfile.extend)='.".strtolower($this->data['Optfile']['extend_ck_t'])."' ";
						}
					}
					else {
						$errorMessage['check_extend_type'][] = 'E-00100';
					}
				}
				elseif(isset($this->data['Optfile']['extend_ck']) && $this->data['Optfile']['extend_ck']==0){
					$criteria[]= " Optfile.extend='.".$this->data['Optfile']['extendfromselect']."' ";
				}
			}

		}

		// search by extend


		//search by filesize
		if(isset($this->data['Optfile']['conditionfromselect_1'])){
			if ($this->data['Optfile']['conditionfromselect_1']==1)
			{
				$sign=">=";
			}elseif ($this->data['Optfile']['conditionfromselect_1']==2)
			{
				$sign="=";
			}
			elseif ($this->data['Optfile']['conditionfromselect_1']==3)
			{
				$sign="<=";
			}
		}

		if(isset($this->data['Optfile']['size']))
		{
			if($this->data['Optfile']['size']==1){
				if(isset($this->data['Optfile']['file_size_t1']))
				{
					if(!$this->Lv->is_empty($this->data['Optfile']['file_size_t1'])){
						if(!is_numeric($this->data['Optfile']['file_size_t1']) || !$this->Validation->maxLength($this->data['Optfile']['file_size_t1'],127)){
							if(!is_numeric($this->data['Optfile']['file_size_t1'])){
								$errorMessage['check_file_size'][] = 'E-02200';			//入力が不正
							}
							if(!$this->Validation->maxLength($this->data['Optfile']['file_size_t1'],127)){
								$errorMessage['check_file_size'][] = 'E-00300';
							}
						}elseif(!$this->Lv->is_empty($this->data['Optfile']['file_size_t2'])){
							//[file_size_t2]textは選択した場合

							if (!is_numeric($this->data['Optfile']['file_size_t2'])) {
								$errorMessage['check_file_size'][] = 'E-02200';			//入力が不正
							}
							elseif ($this->data['Optfile']['file_size_t1']>$this->data['Optfile']['file_size_t2'])
							{
								$errorMessage['check_file_size'][] = 'E-03400';
							}
							else
							{
								$size1=$this->get_size($this->data['Optfile']['sizefromselect_1'],$this->data['Optfile']['file_size_t1']);
								$size2=$this->get_size($this->data['Optfile']['sizefromselect_2'],$this->data['Optfile']['file_size_t2']);
								$criteria[]=" Optfile.size".$sign.$size1." and Optfile.size".$this->data['Optfile']['conditionfromselect_2']."=".$size2;
							}
							//[file_size_t2]textは選択した場合






						}else {
							//[file_size_t2]textは選択しない場合






							$size1=$this->get_size($this->data['Optfile']['sizefromselect_1'],$this->data['Optfile']['file_size_t1']);
							$criteria[]=" Optfile.size".$sign.$size1;
							//											if ($this->data['Optfile']['sizefromselect_1']==1)
							//											{
							//												$float = (float)($this->data['Optfile']['file_size_t1']);
							//												$criteria[]= " Optfile.size".$this->data['Optfile']['conditionfromselect_1'].$float ;
							//											}
							//											elseif ($this->data['Optfile']['sizefromselect_1']==2)
							//											{
							//												$float = (float)($this->data['Optfile']['file_size_t1']);
							//												$this->data['Optfile']['file_size_t1']=$this->data['Optfile']['file_size_t1']*1024;
							//												$criteria[]= " Optfile.size".$this->data['Optfile']['conditionfromselect_1'].$float ;
							//											}
							//											elseif ($this->data['Optfile']['sizefromselect_1']==3)
							//											{
							//												$float = (float)($this->data['Optfile']['file_size_t1']);
							//												$this->data['Optfile']['file_size_t1']=$this->data['Optfile']['file_size_t1']*1048576;
							//												$criteria[]= " Optfile.size".$this->data['Optfile']['conditionfromselect_1'].$float ;
							//											}
							//											elseif ($this->data['Optfile']['sizefromselect_1']==4)
							//											{
							//												$float = (float)($this->data['Optfile']['file_size_t1']);
							//												$this->data['Optfile']['file_size_t1']=$this->data['Optfile']['file_size_t1']*1073741824;
							//												$criteria[]= " Optfile.size".$this->data['Optfile']['conditionfromselect_1'].$float ;
							//											}
							//[file_size_t2]textは選択しない場合






						}
					}

					else {
						$errorMessage['check_file_size'][] = 'E-00100';
					}
				}
			}

		}

		// search by filesize




		//search by file_name
		if(isset($this->data['Optfile']['file_name']))
		{
			if($this->data['Optfile']['file_name']==1){
				if(isset($this->data['Optfile']['filename_t']))
				{
					if(!$this->Lv->is_empty($this->data['Optfile']['filename_t'])){
						if(!$this->Validation->maxLength($this->data['Optfile']['filename_t'],127)){
							//							if(!$this->Check->checkAllHalf($this->data['Optfile']['filename_t'])){
							//								$errorMessage['check_file_name'][] = 'E-00400';
							//							}
							if(!$this->Validation->maxLength($this->data['Optfile']['filename_t'],127)){
								$errorMessage['check_file_name'][] = 'E-00300';
							}
						}
						else{
							$this->data['Optfile']['filename_t']=$this->Lv->spec_char_dbm($this->Lv->url_param_decode2($this->data['Optfile']['filename_t']));
							if($this->data['Optfile']['filename_ck']==0){
								//$criteria[]= " (lower(Optfile.file_name)='".strtolower($this->data['Optfile']['filename_t'])."') ";
								$criteria[]= " (lower(Optfile.file_name) like '%".strtolower($this->Lv->spec_char_like($this->data['Optfile']['filename_t']))."%') ";
							}
							else{
								//$criteria[]= " (lower(Optfile.file_name) like '%".strtolower($this->data['Optfile']['filename_t'])."%') ";
								$criteria[]= " (lower(Optfile.file_name)='".strtolower($this->Lv->spec_char_dbm($this->data['Optfile']['filename_t']))."') ";
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Optfile']['filename_t'])){
						$errorMessage['check_file_name'][] = 'E-00100';
					}
				}
			}
		}
		// search by file_name

		//search by directory
		if(isset($this->data['Optfile']['directory_ck']))
		{
			if($this->data['Optfile']['directory_ck']==1){
				if(isset($this->data['Optfile']['directory_text']))
				{
					if(!$this->Lv->is_empty($this->data['Optfile']['directory_text'])){
						if( !$this->Validation->maxLength($this->data['Optfile']['directory_text'],127)){
							//							if(!$this->Check->checkAllHalf($this->data['Optfile']['directory_text'])){
							//								$errorMessage['check_directory'][] = 'E-00400';
							//							}
							if(!$this->Validation->maxLength($this->data['Optfile']['directory_text'],127)){
								$errorMessage['check_directory'][] = 'E-00300';
							}
						}else {
							$this->data['Optfile']['directory_text']=$this->Lv->url_param_decode2($this->data['Optfile']['directory_text']);
							(substr($this->data['Optfile']['directory_text'],0,1)=="\\")?($path=strtolower($this->data['Optfile']['directory_text'])):($path='\\'.strtolower($this->data['Optfile']['directory_text']));
							//xinw start 20080514
							$path = $this->Lv->spec_char_like($path);
							$criteria[]= " lower(Optfile.directory) like '".strtolower($this->data['Optfile']['device']).$path."%'";
							//xinw end 20080514
						}

					}else {
						$criteria[]= " lower(Optfile.directory)='".strtolower($this->data['Optfile']['device']).strtolower($this->Lv->spec_char_dbm($this->data['Optfile']['folder']))."'";
					}
				}
			}
		}
		//search by directory

		//search by operation_type
		if(isset($this->data['Optfile']['operation_type']) )
		{
			if($this->data['Optfile']['operation_type']==1 ){
				if(isset($this->data['Optfile']['operation_type_ck']) ){
					$file_type_ck = array();
					foreach($this->data['Optfile']['operation_type_ck'] as $v){
						$file_type_ck[] = "Optfile.operation_type = $v";
					}
					$criteria[] = "(".implode(' or ', $file_type_ck).")";
				}
				//				elseif(isset($this->data['Optfile']['type_notchange'])) {
				//					$errorMessage['check_file_status'][] = 'E-00200';
				//					//$errorMessage['nothing'][] = '';
				//				}
				//				elseif ($this->data['Optfile']['type_notchange']==1){
				//					//echo "++++++++++++++++++++++++++++++++++++++";
				//					$criteria[] ="Optfile.operation_type = 110";
				//				}
				else
				{
					//echo "<br> -----------------+-";
					$errorMessage['check_file_status'][] = 'E-00200';
				}
			}
		}



		//$dir_arr=$this->get_directory($this->data['optfile']['group']);
		//debug($dir_arr,true);
		//$i=0;
		//$arr=explode('\\',$directory['Hstdrt']['directory']);
		/*
		if (count($dir_arr)>0) {
		foreach ($dir_arr as $directory)
		{
		//				if (ereg("^([A-Za-z]:((\\\[^\"\:\.\*\?</>\|\\]([^\"\:\*\?</>\|\\]*))*).[A-Za-z])$",$directory['Hstdrt']['directory'])==true && strpos('.',$arr[count($arr)-1])) {
		//
		//
		//					for ($j=0;$j<count($arr)-1;$j++){
		//						$str_arr[$j]=$arr[$j];
		//					}
		//					$str=implode('\\',$str_arr);
		//					$directory1[$i]=" lower(Optfile.directory) like '".strtolower($str)."%' ";
		//				}else {
		$directory1[$i]=" lower(Optfile.directory) like '".strtolower($directory['Hstdrt']['directory'])."%' ";
		//				}
		$i++;
		}
		}

		//debug($directory1,true);
		if (count($directory1)>1) {
		$criteria[] = "(".implode(' or ', $directory1).")";
		}
		*/
		//		$str=$this->get_directory($this->data['optfile']['group']);
		//		if (!empty($str))
		//		{
		//			$criteria[]=$str;
		//		}

		//				$dir_arr=$this->get_directory($this->data['optfile']['group']);
		//				for ($i=0;$i<count($dir_arr);$i++)
		//				{
		//					$criteria[]=$dir_arr[$i];
		//				}


		if($this->data['optfile']['group']=='0' || empty($this->data['optfile']['group']))
		{
			$this->data['optfile']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['optfile']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		if(!empty($errorMessage) || !empty($err1) || !empty($err2) || !empty($err3)){
			$this->set('errorMessage',$errorMessage);
			$this->set('err1',$err1);
			$this->set('err2',$err2);
			$this->set('err3',$err3);
			$criteria[]="1=2";
		}
		//xinw start 20081203
		//modify for LV20R1-187
/*		elseif (empty($errorMessage) && empty($err1) && empty($err2) && empty($err3)) {
			$asso_prt = array(
			'Host : hosts' => array('Optfile.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Rlthstgrp.group_id = Group.id'),
			);
			$log_count=$this->Optfile->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_file'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_file']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_file'].__("E-03900-1",true));
				}
			}
		}
		//xinw end 20081203
		
		if($type=='csv'||$type=='xml')
		{
			$this->csvdown($criteria,$type);exit;
		}*/
		$criteria[]="1=1";
		$asso = array(
		//'Hstdrt:hstdrts'=>array('Optfile.host_id=Hstdrt.host_id'),
		'Host : hosts' => array('Optfile.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
		'Group : groups' => array('Rlthstgrp.group_id = Group.id'),
		//'Optuser: optusers' => array('Host.id = Optuser.host_id'),
		//'Optfolder:optfolders'=>array('Optfolder.host_id=Optfile.host_id')
		);
		if($time_type == 0){//収集日で検索
			$crit = $criteria;
			$crit['GROUP by'] = "Optfile.host_id, Optfile.volume_name";
			$host_maxpoll = $this->Optfile->findByAsso($crit, array('Optfile.host_id','Optfile.volume_name','max(Optfile.polling_time) as `Optfile__maxpoll`'), null,null,null, $asso);
			//debug($host_maxpoll);
			
			$maxpollcri = "(1=2 ";
			foreach ($host_maxpoll as $value)
			{
				$h_=$value['Optfile']['host_id'];
				$p_=$value['Optfile']['maxpoll'];
				$v_=$value['Optfile']['volume_name'];
				$maxpollcri .= "or (Optfile.host_id=$h_ and Optfile.polling_time='$p_' and Optfile.volume_name='$v_') ";
			}
			$maxpollcri .= ") ";
			$criteria[]=$maxpollcri;
		}else
			$criteria['GROUP by'] = "Optfile.host_id,Optfile.file_name,Optfile.directory";
		//aa start
		//list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/opt_files/contro', 'modelClass'=>'Optfile', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Optfile.status_time, Group.group_name, Host.host_name, Optuser.account, Optfile.operation_type, Optfile.file_name, Optfile.size, Optfile.directory')));
		if(empty($numperpage)&&empty($_SESSION['20_resultsPerPage'])&&empty($_SESSION['50_resultsPerPage'])&&empty($_SESSION['100_resultsPerPage'])){
			$numperpage = 50;
		}elseif(isset($_SESSION['20_resultsPerPage']) && $_SESSION['20_resultsPerPage']=='20_resultsPerPage'){
			//echo 'yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy';
			$numperpage = 20;
		}elseif(isset($_SESSION['50_resultsPerPage']) && $_SESSION['50_resultsPerPage']=='50_resultsPerPage'){
			//echo 'yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy';
			$numperpage = 50;
		}elseif(isset($_SESSION['100_resultsPerPage']) && $_SESSION['100_resultsPerPage']=='100_resultsPerPage'){
			//echo 'yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy';
			$numperpage = 100;
		}
		//xinw start 20080229
		list($order,$limit,$page,$total) = $this->Pagination->init_opt_files($numperpage,$criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/opt_files/contro', 'modelClass'=>'Optfile', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Optfile.polling_time, Group.group_name, Host.host_name, Optfile.file_name, Optfile.size, Optfile.directory')));
		//xinw end 20080229
//echo $total."-".$limit."-".$page;
		$dir=LOG_LIMIT;
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_file'])) {
			if ($total>=$ini_array['LogLimit']['Log_file']) {
				$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_file'].__("E-03900-1",true));
			}
		}

		if($type=='csv'||$type=='xml')
		{
			$this->csvdown($criteria,$type,$time_type);exit;
		}
		//$data = $this->Useevtlog->findByAsso($criteria, array('Useevtlog.event_time', 'Group.group_name','Host.host_name', 'Useevtlog.account', 'Useevtlog.event_catalog','Useevtlog.event_type','Useevtlog.event_id','Useevtlog.source','Useevtlog.specification'), $order, $limit, $page, $asso);
//		if (/*$type=='20_resultsPerPage'*/isset($_SESSION['20_resultsPerPage']) && $_SESSION['20_resultsPerPage']=="20_resultsPerPage"){
//			//$this->set('20_r',$type);
//			//$limit='20';
//			$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id', /*'Optuser.account', 'Optfile.operation_type',*/'Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'/*,'Optfile.old_name','Optfile.old_directory'*/), $order, '20', $page, $asso);
//			$data_new=$this->get_account($data);
//		}elseif(/*$type=='50_resultsPerPage'*/isset($_SESSION['50_resultsPerPage']) &&$_SESSION['50_resultsPerPage']=="50_resultsPerPage") {
//			$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id',/*'Optuser.account', 'Optfile.operation_type',*/'Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'/*,'Optfile.old_name','Optfile.old_directory'*/), $order, '50', $page, $asso);
//			$data_new=$this->get_account($data);
//		}elseif(/*$type=='100_resultsPerPage'*/isset($_SESSION['100_resultsPerPage']) &&$_SESSION['100_resultsPerPage']=="100_resultsPerPage"){
//			$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id',/*'Optuser.account', 'Optfile.operation_type',*/'Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'/*,'Optfile.old_name','Optfile.old_directory'*/), $order, '100', $page, $asso);
//			$data_new=$this->get_account($data);
//		}else {
//			$data = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id',/*'Optuser.account', 'Optfile.operation_type',*/'Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'/*,'Optfile.old_name','Optfile.old_directory'*/), $order, '50', $page, $asso);
//			$data_new=$this->get_account($data);
//		}
		if($time_type == 0)//収集日で検索
			$data_new = $this->Optfile->findByAsso($criteria, array('distinct Optfile.polling_time as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id',/*'Optuser.account', 'Optfile.operation_type',*/'Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'/*,'Optfile.old_name','Optfile.old_directory'*/), $order, $numperpage, $page, $asso);
		else
			$data_new = $this->Optfile->findByAsso($criteria, array('max(Optfile.polling_time) as `Optfile__status_time`', 'Optfile.file_create','Optfile.file_modify','Group.group_name','Host.host_name','Optfile.host_id',/*'Optuser.account', 'Optfile.operation_type',*/'Optfile.file_name','Optfile.size','Optfile.device_name','Optfile.directory'/*,'Optfile.old_name','Optfile.old_directory'*/), $order, $numperpage, $page, $asso);
		//var_dump($data);
		//debug($data_new,true);
		//empty($data)? $data=array():$data;
		//session_unregister('temp1');
		//echo $_SESSION['temp1']."9999999999999999999999999999999999";
		$this->set('numperpage',$numperpage);
		$this->set('search',$_SESSION['search']);
		$this->set('data_new',$data_new);
		$this->set('criteria',$criteria);
		$this->render('url');
	}


	function get_size($unit,$value){
		if ($unit==1){
			$size=$value;
		}elseif ($unit==2){
			$size=$value*1024;
		}elseif ($unit==3){
			$size=$value*1048576;
		}elseif ($unit==4){
			$size=$value*1073741824;
		}
		return $size;
	}
	function des_session(){
	(!empty($_SESSION['col']))?session_unregister('col'):"";
	(!empty($_SESSION['search']))?session_unregister('search'):"";
	$this->url();
	//$this->contro($link,$search,$about_sess);
	}
	function get_account($array){
		//		$asso1 = array(
		//		'Optuser: optusers' => array('Optfile.host_id = Optuser.host_id'),
		//		);
		for ($i=0;$i<count($array);$i++){
			$opt_hostid=$array[$i]['Optfile']['host_id'];
			//$data1 = $this->Optuser->findByAsso(array('Optuser.host_id='.$opt_hostid), array('Optuser.account'), null, null, null, $asso1);
			$criteria = array();
			$criteria[] = 'Optuser.log_status=1';
			$criteria[] = 'Optuser.host_id='.$opt_hostid;
			//$criteria['group by'] =  'Optuser.account';
			
			//$data1= $this->Optuser->findAll($criteria ,array('Optuser.account'),null,null,null,null);
			$data1 = $this->Optuser->findByAsso($criteria, array('distinct Optuser.account as `Optuser__account`'), null,null,null);
			
			//debug($data1,true);
			if (empty($data1[0]['Optuser']['account']) || $data1[0]['Optuser']['account']=="") {
				$data1[0]['Optuser']['account']="No user";
			}
			$array[$i]['Optfile']['account']="";
			foreach ($data1 as $value)
			{
				//debug($value,true);
				$array[$i]['Optfile']['account'].='|'.$value['Optuser']['account'];
			}
		}
		//debug($array,true);
		return $array;
	}

}
?>