<?php
/*********************************************************************
*@filename oper_evtusers_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            1.0        xinw        2008/10/24   modify for LV20R1-182-2
*            2.0        yaozl          2009/08/18       modify for JL-0038
********************************************************************/
class RemoteAuthorityController extends AppController
{

	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv', 'GenerateFiles','Check');
	//bih start 20080508
	var $uses=array('Poll','Group', 'Host','Mailserver','Module','Grpauth','Configure', 'Validation','Pollog','License','Hstaltsvc','Grpalt','User','Mail','Mailaddress'
		,'Remotemac');
	//bih end 20080508
	var $layout='system';



	function beforeFilter()
	{
		parent::beforeFilter();

		$this->pageTitle =__('poll title',$return = true);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
			//	    		debug($_POST['forHideVar'], true);
			//	    		echo "forHideVar";
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			//	    		debug($_POST['forHideVar1']);
			//	    		echo "forHideVar1";
		}
		
		$s_list = array(
			'100'=>__('All',$return = true),
			'-1'=>__('undefined',$return = true),
			'0'=>__('deny',$return = true),
			'1'=>__('allow',$return = true)
		);
		$this->set('s_list',$s_list);
	}

	function index()
	{
		$search= $this->requestAction('/remote_authority/search/',array('return'));
		$this->set('search',$search);
	}

	function gethidevars()
	{

	}

	function search($do=null,$page=null)
	{
		$this->layout="ajax";
		if($do!='first')
		{
			$where= array("2=2");
			if( $this->Validation->maxLength($this->data['Remotemac']['hostname'],256) )
			{
				//if($do!=1)
				{
					if($this->data['Remotemac']['status']==100)
					{
						$statu="-1,0,1";
					}
					else
					{
						$statu=$this->data['Remotemac']['status'];
					}

					empty($this->data['Remotemac']['hostname']) ? null : $where[]= "lower(Remotemac.hostname) like '%".strtolower($this->Lv->spec_char_like($this->data['Remotemac']['hostname']))."%'  ";
					is_null($this->data['Remotemac']['status']) ?  null : $where[]="Remotemac.status in (".$statu.")  " ;


					empty($this->data['Remotemac']['hostname']) ? null : $this->set('hostname',$this->data['Remotemac']['hostname']);
					//$this->data['Remotemac']['status']==0 ?  null : 
					$this->set('status',$this->data['Remotemac']['status']);
				}
				/*else
				{
					empty($_POST['hostname']) ? null : $where[]= "lower(Remotemac.hostname) like '%".strtolower($this->Lv->spec_char_like($_POST['hostname']))."%'  ";
					$_POST['status']==0 ?  null : $where[]="Remotemac.status=".$_POST['status']." " ;

					empty($_POST['hostname']) ? null : $this->set('hostname',$_POST['hostname']);
					$_POST['status']==0 ?  null : $this->set('status',$_POST['status']);
				}*/
			}
			else
			{
				if(!$this->Validation->maxLength($this->data['Remotemac']['hostname'],256))
				{
					$err[]=__('poll name',$return = true)."　".__('E-00300',$return = true);
				}
			}
			
			$asso = array();
			$join=$asso;

			isset($page)?$_GET['page']=$page : null;
			list($order,$limit,$page) = $this->Pagination->init($where,null,array('ajaxDivUpdate'=>'select','url'=>'/remote_authority/search', 'modelClass'=>'Remotemac', 'queryType' => array('function' => 'findByAsso', 'asso' => $join),'sortBy' => $this->Lv->sortBy('Remotemac.hostname')));
			$fields = array(
				'Remotemac.macaddr',
				'Remotemac.hostname',
				'Remotemac.ipaddr',
				'Remotemac.status',
				'Remotemac.access_time',
				);

			$data = $this->Remotemac->findByAsso($where, $fields, $order, $limit, $page, $asso);

			if(!empty($err))
			{
				$this->set('err',$err);
			}
			$this->set('page',$page);
			$this->set('data',$data);


			if(!empty($_SESSION['detail_condition']) && $_SESSION['detail_condition'] && $_SESSION['do_import'] == 1){

				$this->detail($_SESSION['detail_condition'][0],$_SESSION['detail_condition'][1],$_SESSION['detail_condition'][2]);
				session_unregister('do_import');
				$errupload = $_SESSION['errupload'];
				session_unregister('errupload');
				$this->set('errupload',$errupload);
				$this->render('detail');
			}else{
				$this->render('search');
			}
		}

	}
	
	function edit($page=null,$status=null,$fg=null)
	{
		$this->layout='ajax';
		//echo $this->data['Remotemac']['status'];
		if(isset($this->params['form']['cbid']) )
		{
			foreach($this->params['form']['cbid'] as $mac_addr){
				$ps_status=$this->Remotemac->findAll(array("Remotemac.macaddr" => $this->Lv->spec_char_dbm($mac_addr)),array("Remotemac.status"));
				if($ps_status[0]['Remotemac']['status']==$status)//飛ばす
					continue;
				
				//========================0811
				$sensor['macaddr']=$mac_addr;
				$sensor['status']=$status;
				$this->Remotemac->save($sensor);
				//=========================				
			}
		}
		else
		{
			$err[]=__('macerr',$return = true)."　".__('E-00200',$return = true);
			$this->set('err',$err);
		}
		$this->set('status',$status);
		$this->set('fg',$fg);
		$this->search($do=1,$page);
		//    	$this->render('search');
	}
	
	function del($page=null)
	{
		$this->layout='ajax';
		if(isset($this->params['form']['cbid']))
		{	//debug($this->params['form']['cbid']);
			foreach ($this->params['form']['cbid'] as $mac_addr)
			{
				$this->Remotemac->del($mac_addr);
			}
		}
		else
		{
			$err[]=__('macerr',$return = true)."　".__('E-00200',$return = true);
			$this->set('err',$err);
		}
		//	var_dump(array($this->params['form']['cbid']));
		$this->search($do=1,$page);
		//	$this->render('search');
	}
	
}
?>