<?php
/*********************************************************************
*@filename      alerts_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2008/12/03   modify for LV20R1-187
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
********************************************************************/
class ReportController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Group', 'Host','Rlthstgrp','Grpauth','Hstalt','Authority','Rltuserauth','User','Configure','Validation');
	var $layout='report';
	function beforeFilter()
	{
		//parent::beforeFilter();
		$this->pageTitle =__('menu_phantosys',$retrun=true);    //アラート通知履歴
		//$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($group_id=null,$alert_id=null,$starttime=null,$endtime=null)
	{
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());//グループリスト  Sessionから
		//ksort($glist);
		$this->set('glist',$glist);
	}

	function contro()
	{
		//define('DEBUG', 0);
		$this->layout="ajax";
		$url = $this->data["Url"]["url"];
		//echo $url;
		
		//var_dump($this->data);
		
	//	$param = array('mode' => array('report' => 1));

		$this->requestAction($url);
	}
	
	function newtab()
	{
		$this->layout="portal";
	}
	
	function groupName($group_id)
	{
		$criteria=array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}

	function csvdown($criteria=array(),$type=null)
	{
		require_once( 'csv/DlFactory.php' );
		if(!isset($this->data["hstalt"]["group"])||($this->data["hstalt"]["group"] == 0)){
			$this_groups =$this->_getUserGroup();
		}
		else {
			$this_groups =$this->data["hstalt"]["group"];
		}
		$this->data["hstalt"]["group"] = $this->groupName($this_groups);
		$alert_type="";
		for($i=0;$i<count($this->data['Hstalt']['alert_type_ck']);$i++)
		{
			$alert_type.=$this->getType($this->data['Hstalt']['alert_type_ck'][$i])." ";
		}
		$this->data['Hstalt']['alert_type_ck']=$alert_type;
		$dt= date('Y-m-d',time());
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();
		if(empty($by_kw['error']) && empty($by_dt['error']))
		{
			if(empty($by_dt) && empty($by_kw))
			{
				//$criteria[]="datepart(Hstalt.alert_time)= '".$dt."'";
				$criteria[]="Hstalt.alert_time BETWEEN '$dt' AND '$dt' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			}
			else
			{
				empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
				empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
			}
		}
		$asso = array('Host : hosts' => array('Hstalt.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		);
		$data = $this->Hstalt->findByAsso($criteria, array('Hstalt.alert_time', 'Group.group_name','Host.host_name','Hstalt.alert_type_id','Hstalt.alert_content'), 'Hstalt.alert_time,Group.group_name,Host.host_name,Hstalt.alert_type_id,Hstalt.alert_content', 100000, 1, $asso);
		//  $i=0;
		//                          foreach ($data as $result){
		//                          	$data[$i]['Hstalt']['alert_time']='"'.$data[$i]['Hstalt']['alert_time'].'"';
		//                          	$data[$i]['Group']['group_name']='"'.$data[$i]['Group']['group_name'].'"';
		//                          	$data[$i]['Host']['host_name']='"'.$data[$i]['Host']['host_name'].'"';
		//$data[$i]['Hstalt']['account']='"'.$data[$i]['Hstalt']['account'].'"';
		//                          	$data[$i]['Hstalt']['alert_content']='"'.$data[$i]['Hstalt']['alert_content'].'"';
		//                         	$i++;
		//     }
		if($type=='csv'){
			$csv = DlFactory::create("alerts");
			$csv->sendCSVFile($data,$this->data,__('menu_alert',$return = true));
		}
		elseif($type=='xml')
		{
			$xml = DlFactory::createxml("alerts");
			$xml->sendXMLFile($data,$this->data,__('menu_alert',$return = true));exit;
		}
	}
	function url($type=null,& $criteria=array(),$err1=null,$err2=null,$err3=null,$group_id=null,$alert_id=null,$starttime=null,$endtime=null)
	{
		$this->layout='ajax';
		if($group_id!=null){
			$this->data['dt_check']['name']='Hstalt-alert_time';
			$this->data['dt_check']['start_year']=substr($starttime, 0, 4);
			$this->data['dt_check']['start_month']=substr($starttime, 5, 2);
			$this->data['dt_check']['start_day']=substr($starttime, 8, 2);
			$this->data['dt_check'][0]='date';
			$this->data['dt_check']['end_year']=substr($endtime, 0, 4);
			$this->data['dt_check']['end_month']=substr($endtime, 5, 2);
			$this->data['dt_check']['end_day']=substr($endtime, 8, 2);
			$this->data['hstalt']['group']=$group_id;
			$this->data['Hstalt']['alert_type']=1;
			$this->data['Hstalt']['alert_type_ck'][0]=$alert_id;
			$this->set('group_id',$group_id);
			$this->set('alert_id',$alert_id);
		}
		$by_kw = $this->Lv->operSearch();
		$by_dt = $this->Lv->optionsDatetime();

		$errorMessage = array();
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			if($group_id!=null){
				$this->set('forHideVar', '&data%5Bdt_check%5D%5Bname%5D=Hstalt-alert_time&data%5Bdt_check%5D%5Bstart_year%5D=' . substr($starttime, 0, 4) . '&data%5Bdt_check%5D%5Bstart_month%5D=' . substr($starttime, 5, 2) . '&data%5Bdt_check%5D%5Bstart_day%5D=' . substr($starttime, 8, 2) . '&data%5Bdt_check%5D%5B%5D=date&data%5Bdt_check%5D%5Bend_year%5D=' . substr($endtime, 0, 4) . '&data%5Bdt_check%5D%5Bend_month%5D=' . substr($endtime, 5, 2) . '&data%5Bdt_check%5D%5Bend_day%5D=' . substr($endtime, 8, 2) . '&data%5Bhstalt%5D%5Bgroup%5D=' . $group_id . '&data%5BHstalt%5D%5Balert_type%5D=0&data%5BHstalt%5D%5Balert_type%5D=1&data%5BHstalt%5D%5Balert_type_ck%5D%5B%5D=' . $alert_id . '&data%5BHstalt%5D%5Balert_content%5D=0&data%5BHstalt%5D%5Balert_content_ck%5D=-1&btn1=%E5%AE%9F%E8%A1%8C');
			}
			else{
				$this->set('forHideVar', '&data%5Bdt_check%5D%5Bname%5D=Hstalt-alert_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m') . '&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') . '&data%5Bhstalt%5D%5Bgroup%5D=1&data%5BHstalt%5D%5Balert_type%5D=0&data%5BHstalt%5D%5Balert_content%5D=0&data%5BHstalt%5D%5Balert_content_ck%5D=-1&btn1=%E5%AE%9F%E8%A1%8C');
			}
		}
		//search by alert_type
		if($this->data['Hstalt']['alert_type']==1){
			if(isset($this->data['Hstalt']['alert_type_ck']))
			{
				$alert_type_ck = array();
				foreach($this->data['Hstalt']['alert_type_ck'] as $v){
					$alert_type_ck[] = "Hstalt.alert_type_id = $v";
				}
				$criteria[] = "(".implode(' or ', $alert_type_ck).")";
			}
			else{
				$errorMessage['check_alert_type'][] = 'E-00200';
			}
			//if(isset($this->data['Hstalt']['alert_type_ck1'])){
			//if($this->data['Hstalt']['alert_type_ck1']==1){
			//     $condition = $condition."Hstalt.alert_type_id = ". 1 ." OR ";
			//} }
			// if(!empty($condition)){
			// $condition1 =  $condition1.substr($condition, 0, strlen($condition)-3);
			//$condition1 = $condition1.")";
			// $criteria[]=$condition1." ";
			// }
		}
		/////////search by alert_content////////////////////////////////////////////////////
		if(isset($this->data['Hstalt']['alert_content']))
		{
			if($this->data['Hstalt']['alert_content']==1)
			{
				if(isset($this->data['Hstalt']['alert_content_t']))
				{
					if(!$this->Lv->is_empty($this->data['Hstalt']['alert_content_t']))
					{
						if(!$this->Validation->maxLength($this->data['Hstalt']['alert_content_t'],600))
						{
							//xushanning start 2009/04/22   modify for LogvillageChinese
							//$errorMessage['check_alert_content'][] = 'E-00300';
							$errorMessage['set_alert_content'][] = 'E-00300';
							//xushanning end 2009/04/22   modify for LogvillageChinese
						}
						else{
							if($this->data['Hstalt']['alert_content_ck']==0){
								//wangs start 20080202
								//$criteria[]=" Hstalt.alert_content like '%".$this->data['Hstalt']['alert_content_t']."%' ";
								$criteria[]=" lower(Hstalt.alert_content) like '%".strtolower($this->Lv->spec_char_like($this->data['Hstalt']['alert_content_t']))."%' ";
								//wangs end 20080202
							}
							else{
								//wangs start 20080202
								//$criteria[]=" Hstalt.alert_content='".$this->data['Hstalt']['alert_content_t']."' ";
								$criteria[]=" lower(Hstalt.alert_content)='".strtolower($this->Lv->spec_char_dbm($this->data['Hstalt']['alert_content_t']))."' ";
								//wangs end 20080202
							}
						}
					}
					elseif($this->Lv->is_empty($this->data['Hstalt']['alert_content_t'])){
						//xushanning start 2009/04/22   modify for LogvillageChinese
						//$errorMessage['check_alert_content'][] = 'E-00100';
						$errorMessage['set_alert_content'][] = 'E-00100';
						//xushanning end 2009/04/22   modify for LogvillageChinese
					}
				}
			}
		}
		//////////////////search by group///////////////////////////////////////////////
		if($this->data['hstalt']['group']=='0' || empty($this->data['hstalt']['group']))
		{
			$this->data['hstalt']['group']='1';
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['hstalt']['group']);
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";
		//////////////////alert_type_id///////////////////////////////////
		$criteria2[] =" User.id = ".$this->_getUserId() ;//Sessionから
		$criteria2[]=" Authority.controller_name like '%alerts_%' ";
		//	 $criteria2[]=" Authority.controller_name != 'alerts_perfs' ";///quoted for release ////unquoted for quoting alerts_perfs
		//$criteria2[]=" Authority.controller_name != 'alerts_evtusers' ";///quoted for release	////unquoted for quoting alerts_evtusers
		//$criteria2[]=" Authority.controller_name != 'alerts_evtlogs' ";///quoted for release	////unquoted for quoting alerts_evtlogs
		//$criteria2[]=" Authority.controller_name != 'alerts_devices' ";///quoted for release	////unquoted for quoting alerts_devices
		//$criteria2[]=" Authority.controller_name != 'alerts_vptns' ";///quoted for release	////unquoted for quoting alerts_vptns
		// $criteria2[]=" Authority.controller_name != 'alerts_apps' ";///quoted for release	////unquoted for quoting alerts_apps
		$asso2 = array('Rltuserauth : rltuserauths' => array('Rltuserauth.authority_id = Authority.id'),
		'User : users' => array('User.id = Rltuserauth.user_id'),
		);
		$data2 = $this->Authority->findByAsso($criteria2, array('Authority.id','Authority.authority_name','Authority.controller_name'), 'Authority.id', null, null, $asso2);
		empty($data2)? $data2=array():$data2;
		$alert_type="";
		foreach ($data2 as $output){
						//sunhy start 2009/04/01 modfiy for JLN-001
//			if($output['Authority']['controller_name']=='alerts_webs'){
//				$alert_type.= 3 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_prints'){
//				$alert_type.= 6 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_evtusers'){
//				$alert_type.= 10 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_devices'){
//				$alert_type.= 2 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_files'){
//				$alert_type.= 7 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_evtlogs'){
//				$alert_type.= 9 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_services'){
//				$alert_type.= 5 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_processes'){
//				$alert_type.= 4 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_vptns'){
//				$alert_type.= 8 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_apps'){
//				$alert_type.= 1 .",";
//			}
//			if($output['Authority']['controller_name']=='alerts_perfs'){
//				$alert_type.= 11 .",";
//			}
//			//xinw start 20080523
//			if($output['Authority']['controller_name']=='alerts_urlaccess'){
//				$alert_type.= 12 .",";
//			}
			//xinw end 20080523
			if($output['Authority']['controller_name']=='alerts_webs'){
				$alert_type.= 1 .",";
			}
			if($output['Authority']['controller_name']=='alerts_prints'){
				$alert_type.= 2 .",";
			}
			if($output['Authority']['controller_name']=='alerts_evtusers'){
				$alert_type.= 3 .",";
			}
			if($output['Authority']['controller_name']=='alerts_devices'){
				$alert_type.= 4 .",";
			}
			if($output['Authority']['controller_name']=='alerts_files'){
				$alert_type.= 5 .",";
			}
			if($output['Authority']['controller_name']=='alerts_evtlogs'){
				$alert_type.= 6 .",";
			}
			if($output['Authority']['controller_name']=='alerts_services'){
				$alert_type.= 7 .",";
			}
			if($output['Authority']['controller_name']=='alerts_processes'){
				$alert_type.= 8 .",";
			}
			if($output['Authority']['controller_name']=='alerts_vptns'){
				$alert_type.= 9 .",";
			}
			if($output['Authority']['controller_name']=='alerts_apps'){
				$alert_type.= 10 .",";
			}
			if($output['Authority']['controller_name']=='alerts_perfs'){
				$alert_type.= 11 .",";
			}
			/*if($output['Authority']['controller_name']=='alerts_urlaccess'){
				$alert_type.= 12 .",";
			}
			if($output['Authority']['controller_name']=='alerts_apps'){
				$alert_type.= 18 .",";
			}
			if($output['Authority']['controller_name']=='alerts_apps'){
				$alert_type.= 19 .",";
			}*/
			//sunhy end 2009/04/01 modfiy for JLN-001
		}
		$alert_type = substr($alert_type,0,-1);
		$criteria[]=" Hstalt.alert_type_id in (".$alert_type.") ";
		//////////////////user_id from Session
		if(!empty($errorMessage) || !empty($err1) || !empty($err2) || !empty($err3)){
			empty($err1) ? null : $this->set('err1',$err1);
			empty($err2) ? null : $this->set('err2',$err2);
			empty($err3) ? null : $this->set('err3',$err3);
			empty($errorMessage) ? null : $this->set('errorMessage',$errorMessage);
			$criteria[]="1=2";
		}
		//xinw start 20081202
		//modify for LV20R1-187
		elseif (empty($errorMessage) && empty($err1) && empty($err2) && empty($err3)) {
			$asso_prt = array('Host : hosts' => array('Hstalt.host_id = Host.id'),
			'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			);
			$log_count=$this->Hstalt->findByAsso($criteria,array('count(*) as count'),null,null,null,$asso_prt);
			$dir=LOG_LIMIT;
			$ini_array = parse_ini_file($dir,true);
			if (!empty($ini_array) && ereg("^[0-9]{1,}$",$ini_array['LogLimit']['Log_alert'])) {
				if ($log_count[0][0]['count']>=$ini_array['LogLimit']['Log_alert']) {
					$this->set('count_err',__("E-03900",true).$ini_array['LogLimit']['Log_alert'].__("E-03900-1",true));
				}
			}
		}
		//xinw end 20081202
		$criteria[]="1=1";
		if($type=='csv'||$type=='xml')
		{
			$this->csvdown($criteria,$type);exit;
		}
		$asso = array('Host : hosts' => array('Hstalt.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
		//'Authority : authorities' => array('Hstalt.alert_type_id = Authority.id-15'),
		//'Rltuserauth : rltuserauths' => array('Rltuserauth.authority_id = Authority.id'),
		//'User : users' => array('User.id = Rltuserauth.user_id'),
		);
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/alerts/contro', 'modelClass'=>'Hstalt', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Hstalt.alert_time, Group.group_name, Host.host_name, Hstalt.alert_type_id, Hstalt.alert_content')));
		$data = $this->Hstalt->findByAsso($criteria, array('Hstalt.alert_time', 'Group.group_name','Host.host_name', 'Hstalt.alert_type_id','Hstalt.alert_content'), $order, $limit, $page, $asso);
		empty($data)? $data=array():$data;
		$this->set('data',$data);
		$this->render('url');
	}
}
?>