<?php
class SecuritiesController extends AppController{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv','Form');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Hstalt','Authority','Rltuserauth','Grpauth','Configure');
	var $layout='alert';
	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);
	}
	function index($f=null)
	{ 
		if($f==1)
	    {
		$this->layout='ajax';
	    }
		$title = __('security_summary',$return = true);   	 
    	$this->pageTitle = $title;	
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		$lists= $this->requestAction('/securities/lists',array('return'));
		$this->set('lists',$lists);
	}
	function lists()
	{
		$this->layout='ajax';
		
		
		if(!isset($this->data['Hstalt']['group']))
		{
			$this->data['Hstalt']['group']=$this->_getUserGroup();
		}
		$this->set('group_id',$this->data['Hstalt']['group']);
		if(!isset($this->data['Hstalt']['Yearselect_year']))
		{
			$this->data['Hstalt']['Yearselect_year']=date('Y');
		}
		if(!isset($this->data['Hstalt']['Nowmonth_month']))
		{
			$this->data['Hstalt']['Nowmonth_month']=date('m');
		}
		if(!isset($this->data['Hstalt']['Month_month']))
		{
			$this->data['Hstalt']['Month_month']='1';
		}
		
		$criteria0[]="Rltuserauth.user_id=".$this->_getUserId();
//		$criteria0[]=" Authority.controller_name != 'alerts_perfs' ";///quoted for release     //modify by zhuhongjuan 20070929
		//$criteria0[]=" Authority.controller_name != 'alerts_evtusers' "; ///quoted for release    //modify by zhuhongjuan 20070929
		//$criteria0[]=" Authority.controller_name != 'alerts_evtlogs' ";  ///quoted for release    //modify by zhuhongjuan 20070929
		//$criteria0[]=" Authority.controller_name != 'alerts_devices' "; ///quoted for release    //modify by zhuhongjuan 20070929
		//$criteria0[]=" Authority.controller_name != 'alerts_vptns' ";  ///quoted for release    //modify by zhuhongjuan 20070929
		//$criteria0[]=" Authority.controller_name != 'alerts_apps' "; ///quoted for release    //modify by zhuhongjuan 20070929
				
		$criteria1['GROUP BY']='Hstalt.alert_type_id';
		$criteria2['GROUP BY']='Hstalt.alert_type_id';
		
		
		$glist = $this->Grpauth->getChildrenByParent($this->data['Hstalt']['group']);
		$condition="";
		foreach($glist as $key => $value)
		{
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		
		
		$criteria1[]=" Group.id in (".$condition.") ";
		$criteria2[]=" Group.id in (".$condition.") ";
		
		$starttime1=date("Y-m-d",
			mktime(0,0,0,$this->data['Hstalt']['Nowmonth_month'],'01',$this->data['Hstalt']['Yearselect_year']));
		
		$endtime1=date("Y-m-d",
			mktime(0,0,0,$this->data['Hstalt']['Nowmonth_month']+$this->data['Hstalt']['Month_month'] ,0,$this->data['Hstalt']['Yearselect_year']));
		
		$criteria1[]="alert_time BETWEEN '$starttime1' and '$endtime1' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
		
		

		
		$this->set('starttime1',$starttime1);
		
		$this->set('endtime1',$endtime1);
		
		$starttime2=date("Y-m-d",
			mktime(0,0,0,$this->data['Hstalt']['Nowmonth_month']-$this->data['Hstalt']['Month_month'] ,'01',$this->data['Hstalt']['Yearselect_year']));
		$endtime2=date("Y-m-d",
			mktime(0,0,0,$this->data['Hstalt']['Nowmonth_month'] ,0,$this->data['Hstalt']['Yearselect_year']));
		
		
//		$criteria2[]="DATEPART(alert_time)<='".
//		date("Y-m-d",
//		mktime(0,0,0,$this->data['Hstalt']['Nowmonth_month']+$this->data['Hstalt']['Month_month']-$this->data['Hstalt']['Month_month'] ,0,$this->data['Hstalt']['Yearselect_year']))."'
//and DATEPART(alert_time)>='".
//		date("Y-m-d",mktime(0,0,0,$this->data['Hstalt']['Nowmonth_month']-$this->data['Hstalt']['Month_month'] ,'01',$this->data['Hstalt']['Yearselect_year']))."' ";
		$criteria2[]="alert_time BETWEEN '$starttime2' and '$endtime2' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
		
		

		$this->set('starttime2',$starttime2);
		
		$this->set('endtime2',$endtime2);
		
		
		$asso = array(
		'Host : hosts' => array('Hstalt.host_id = Host.id'),
		'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
        //'Rltuserauth : rltuserauths' => array('Authority.id = Rltuserauth.authority_id'),
		);
		
		$asso0= array(
        'Rltuserauth : rltuserauths' => array('Authority.id = Rltuserauth.authority_id'),
		);

		$Hstalts= $this->Hstalt->findAll(null,array('distinct(Hstalt.alert_type_id) as Hstalt__alert_type_id'),'Hstalt.alert_type_id',null,null,null);
		
		
//		$Hstalts= $this->Hstalt->findByAsso(
//		$criteria1,
//		array('distinct(Hstalt.alert_type_id) as Hstalt__alert_type_id','Hstalt.alert_type_id'),
//		'Hstalt.alert_type_id',
//		null,
//		null,
//		$asso
//		);
    	$this->set('Hstalt',$Hstalts);
		
		$Hstalts0= $this->Authority->findByAsso(
		$criteria0,
		array('Authority.authority_name','Authority.controller_name'),
		null,
		null,
		null,
		$asso0
		);
		$this->set('Hstalt0',$Hstalts0);

		
		$Hstalts1 = $this->Hstalt->findByAsso(
		$criteria1,
		array('distinct(Hstalt.alert_type_id) as Hstalt__alert_type_id','count(Hstalt.alert_type_id) as Hstalt__con'),
		'Hstalt.alert_type_id',
		null,
		null,
		$asso
		);			
		$this->set('Hstalt1',$Hstalts1);
		
		
		
		$Hstalts2 = $this->Hstalt->findByAsso(
		$criteria2,
		array('distinct(Hstalt.alert_type_id) as Hstalt__alert_type_id','count(Hstalt.alert_type_id) as Hstalt__con'),
		'Hstalt.alert_type_id',
		null,
		null,
		$asso
		);
		$this->set('Hstalt2',$Hstalts2);
	}
//	function count($group_id,$alert_type_id,$starttime,$endtime)
//	{
//		$this->layout='ajax';
//		$choosetime="datepart(alert_time)>='$starttime' and datepart(alert_time)<='$endtime'";
//		$this->set('choosetime',$choosetime);
//		$this->set('starttime',$starttime);
//		$this->set('endtime',$endtime);
//		if(!isset($this->data['Hstalt']['group']))
//		{
//			$this->data['Hstalt']['group']=$group_id;
//		}
//		$this->set('group_id',$this->data['Hstalt']['group']);
//		$glist = $this->Grpauth->getChildrenByParent($group_id);
//		$condition="";
//		foreach($glist as $key => $value)
//		{
//			$condition.=$key.",";
//		}
//		$condition = substr($condition,0,-1);
//		$criteria=array("Group.id in (".$condition.") and Hstalt.alert_type_id=".$alert_type_id." and $choosetime",
//		'GROUP BY'=>'Group.group_name,Host.id,Host.host_name,Hstalt.alert_type_id');
//		$asso = array(
//		'Host : hosts' => array('Hstalt.host_id = Host.id'),
//		'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
//		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
//		);
//		$Hstalts = $this->Hstalt->findByAsso(
//		$criteria,
//		array('Group.group_name','Host.id','Host.host_name','Hstalt.alert_type_id','count(Hstalt.alert_type_id) as Hstalt__con'),
//		'Hstalt__con desc',
//		10,
//		0,
//		$asso
//		);
//		$this->set('Hstalt',$Hstalts);
//	}
//	function detail($group_id,$host_id,$alert_type_id,$starttime,$endtime)
//	{   
//		$this->layout='ajax';
//		$this->set('starttime',$starttime);
//		$this->set('endtime',$endtime);
//		$choosetime="datepart(alert_time)>='$starttime' and datepart(alert_time)<='$endtime'";
//		$this->set('choosetime',$choosetime);
//
//		$glist = $this->Grpauth->getChildrenByParent($group_id);
//		$condition="";
//		foreach($glist as $key => $value)
//		{
//			$condition.=$key.",";
//		}
//		$condition = substr($condition,0,-1);
//		$criteria=array("Group.id in (".$condition.") and Host.id=".$host_id." and Hstalt.alert_type_id=".$alert_type_id." and $choosetime");
//		$asso = array(
//		'Host : hosts' => array('Hstalt.host_id = Host.id'),
//		'Rlthstgrp : rlthstgrps' => array('Hstalt.host_id = Rlthstgrp.host_id'),
//		'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
//		);
//		list($order,$limit,$page) = $this->Pagination->init(
//		$criteria,
//		null,
//		array(
//		'ajaxDivUpdate'=>'all',
//		'url'=>"/securities/detail/{$group_id}/{$host_id}/{$alert_type_id}/{$starttime}/{$endtime}",
//		'modelClass'=>'Hstalt',
//		'ajaxFormId'=>NULL,
//		'queryType' => array('function' => 'findByAsso', 'asso' => $asso),
//		'sortBy' => $this->Lv->sortBy('Hstalt.alert_time')
//		)
//		);
//		$Hstalts = $this->Hstalt->findByAsso(
//		$criteria,
//		array('Hstalt.id','Hstalt.alert_time','Hstalt.account','Group.id','Group.group_name','Host.id','Host.host_name', 'Hstalt.alert_type_id', 'Hstalt.alert_content'),
//		$order,
//		$limit,
//		$page,
//		$asso
//		);
//		$datac = 
//		$this->Hstalt->findByAsso($criteria, 
//        array('Hstalt.id','Hstalt.alert_time','Hstalt.account','Group.id','Group.group_name','Host.id','Host.host_name', 'Hstalt.alert_type_id', 'Hstalt.alert_content'),
//		$order,
//		null, 
//		null, 
//		$asso
//		  );
//		$this->set('datac',$datac);
//		$this->set('Hstalt',$Hstalts);
//		$this->set('group_id',$group_id);
//		$this->set('alert_type_id',$alert_type_id);
//	}
}
?>