<?php
/*********************************************************************
*@filename system_grpset_alert_perfs_controller.php
*@description SystemGrpsetAlertPerfsController PCリソースのしきい値超過
*@note
*@histories  rivision	author		date		comment
********************************************************************/
class SystemAllAlertNetscanController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'Check','MailPopupController','AlertPcController');

	var $uses=array('Group','Poll','Grpauth','Configure','Grpaltnetscan','Rltgrpaltnetscan',
	'Grpaltcpu','Rltgrpaltcpu',
	'Altmsg','Validation','Grpalt','Title','User','Mail');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug',0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}

	function index(){
		$this->pageTitle = __('title',$return = true);   
		
		$polllistnone = $this->Poll->generateList(null, null, null, '{n}.Poll.id', '{n}.Poll.poll_name', null);
		unset($polllistnone[0]);//var_dump($polllistnone);
		ksort($polllistnone);
		$this->set('plist',$polllistnone);
	

		$array_res = array();
		foreach ($polllistnone as $gid =>$v){
			$tmp = $this->selectGrpalt($gid, "Grpaltnetscan");
			if(isset($tmp[0])){
				$group_name = $this->pollName($gid);
				$tmp[0]['Grpaltnetscan']['group_name'] = $group_name;
				$array_res[] = $tmp[0];
			}
		}
		//var_dump($array_res);
		$this->set('group_only',1);
		$this->set('array_res',$array_res);
	}


	/*   control  */
	function control($flag=null,$group_id=null){
		$this->layout='ajax';
		$group_id = $this->data["Grpaltcpu"]["poll_id_select"];
		
		$re = $this->existAlert($group_id);
		
		if($re){
			$this->index_edit($group_id);
			exit();
		}else{
			$this->index_add($group_id);
			exit();
		}

	}

	/*   新規登録  */
	function index_add($group_id){
		//echo "index_add<br>";
		$this->layout='ajax';
		$groupName = $this->pollName($group_id);
		$this->set('group_name',$groupName);
		$this->set('group_id',$group_id);

		$all = empty($this->data['Grpaltnetscan']['all']) ? 0: 127;
		$mon = empty($this->data['Grpaltnetscan']['mon']) ? 0: 2;
		$tue = empty($this->data['Grpaltnetscan']['tue']) ? 0: 4;
		$wed = empty($this->data['Grpaltnetscan']['wed']) ? 0: 8;
		$thu = empty($this->data['Grpaltnetscan']['thu']) ? 0: 16;
		$fri = empty($this->data['Grpaltnetscan']['fri']) ? 0: 32;
		$sat = empty($this->data['Grpaltnetscan']['sat']) ? 0: 64;
		$sun = empty($this->data['Grpaltnetscan']['sun']) ? 0: 1;
		$week_day = $mon+$tue+$wed+$thu+$fri+$sat+$sun;
		if($week_day < $all)
			$week_day = $all;
		$this->data["Grpaltnetscan"]["weekday"] = $week_day;//echo $week_day;
		@$GAP_weekday = $this->data["Grpaltnetscan"]["weekday"];
		@$GAP_start_time = $this->data["Grpaltnetscan"]["start_time"];
		
		@$GAP_new_node = $this->data["Grpaltnetscan"]["new_node"];
		@$GAP_not_found = $this->data["Grpaltnetscan"]["not_found"];
		@$GAP_title = __('default_mailtitle', true);//$this->data["Grpaltnetscan"]["title"];
		@$GAP_mail = $this->data["Grpaltnetscan"]["mail_address"];
		
		@$Grpaltcontent = $this->data["Altmsg"]["message"];
		//debug($Grpaltcontent);

		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)))
		{
			$error = array();

			if(!$this->Validation->maxLength($GAP_mail,256) || !$this->Check->checkAllHalf($GAP_mail)){
				if(!$this->Validation->maxLength($GAP_mail,256)){
					$error['send_email'][] = 'E-00300';
				}
				if(!$this->Check->checkAllHalf($GAP_mail)){
					$error['send_email'][] = 'E-00400';
				}			
			}
			
			//全部空
			if(count($error) == 0){
				$errorMessage = array();
			}else{
				$errorMessage = array();
				if(!count($error) == 0){
					$errorMessage =array_merge($errorMessage,$error);
				}
			}
			$count =count($errorMessage);
			$this->set('errorMessage_alert', $errorMessage);

			/* 追加　*/
			if(($count == 0)&&(empty($errorMessage))) {
				//echo "right<BR>";
				$this->deleteGrpalt($group_id,'Grpaltnetscan');

				$this->addGrpalt($group_id,'Grpaltnetscan','Rltgrpaltnetscan');

				$this->index();
				$this->render('index');
				exit();

			}
		}
		/*　ページの保存　*/
		$this->set('GAP_weekday', @$GAP_weekday);
		$this->set('GAP_start_time', @$GAP_start_time);
		
		$this->set('GAP_new_node', @$GAP_new_node);
		$this->set('GAP_not_found', @$GAP_not_found);
		$this->set('GAP_title', @$GAP_title);
		$this->set('GAP_mail', @$GAP_mail);

		$this->set('flg',1);
		//debug($this->data);
		if(!empty($errorMessage)){
			$this->render('index_add');
			exit();
		}
		$this->render('index_add');
	}

	/*   編集  */
	function index_edit($poll_id){

		//echo "index_edit<br>";
		$this->layout='ajax';
		$groupName = $this->pollName($poll_id);
		$this->set('group_name',$groupName);
		$this->set('group_id',$poll_id);

		if(!isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"]))
		{
			$condition = array("Grpaltnetscan.poll_id" => $this->Lv->spec_char_dbm($poll_id));
			$grpalt = $this->Grpaltnetscan->findAll($condition);
			
			foreach($grpalt as $v){
				foreach($v as $k =>$va){
					$GAP_weekday = $va["weekday"];
					$GAP_start_time = $va["start_time"];
					
					$GAP_new_node = $va["new_node"];
					$GAP_not_found = $va["not_found"];
					$GAP_title = $va["title"];
					$GAP_mail = $va["mail_address"];
				}
			}
			
		}

		if((isset($this->data["Grpaltcpu"]["Grpaltcpu_flag"])&&($this->data["Grpaltcpu"]["Grpaltcpu_flag"] == 1)))
		{
			$all = empty($this->data['Grpaltnetscan']['all']) ? 0: 127;
			$mon = empty($this->data['Grpaltnetscan']['mon']) ? 0: 2;
			$tue = empty($this->data['Grpaltnetscan']['tue']) ? 0: 4;
			$wed = empty($this->data['Grpaltnetscan']['wed']) ? 0: 8;
			$thu = empty($this->data['Grpaltnetscan']['thu']) ? 0: 16;
			$fri = empty($this->data['Grpaltnetscan']['fri']) ? 0: 32;
			$sat = empty($this->data['Grpaltnetscan']['sat']) ? 0: 64;
			$sun = empty($this->data['Grpaltnetscan']['sun']) ? 0: 1;
			$week_day = $mon+$tue+$wed+$thu+$fri+$sat+$sun;
			if($week_day < $all)
				$week_day = $all;
			$this->data["Grpaltnetscan"]["weekday"] = $week_day;//echo $week_day;
			@$GAP_weekday = $this->data["Grpaltnetscan"]["weekday"];
			@$GAP_start_time = $this->data["Grpaltnetscan"]["start_time"];
			
			@$GAP_new_node = $this->data["Grpaltnetscan"]["new_node"];
			@$GAP_not_found = $this->data["Grpaltnetscan"]["not_found"];
			@$GAP_title = $this->data["Grpaltnetscan"]["title"];
			@$GAP_mail = $this->data["Grpaltnetscan"]["mail_address"];
		
			$error = array();

			if(!$this->Validation->maxLength($GAP_mail,256) || !$this->Check->checkAllHalf($GAP_mail)){
				if(!$this->Validation->maxLength($GAP_mail,256)){
					$error['send_email'][] = 'E-00300';
				}
				if(!$this->Check->checkAllHalf($GAP_mail)){
					$error['send_email'][] = 'E-00400';
				}			
			}
			
			$count =count($error);
			$this->set('errorMessage_alert', $error);

			/* 追加　*/
			if(($count == 0)&&(empty($error)))
			{
				if($this->selectGrpaltFlag($poll_id,'Grpaltnetscan') ==1){
					$this->editGrpalt($poll_id,'Grpaltnetscan');
				}else{
					$this->deleteGrpalt($poll_id,'Grpaltnetscan');
					$this->addGrpalt($poll_id,'Grpaltnetscan','Rltgrpaltnetscan');
				}
				
				$this->index();
				$this->render('index');
				exit();
			}
		}

		/*　ページの保存　*/
		$this->set('GAP_weekday', @$GAP_weekday);
		$this->set('GAP_start_time', @$GAP_start_time);
		
		$this->set('GAP_new_node', @$GAP_new_node);
		$this->set('GAP_not_found', @$GAP_not_found);
		$this->set('GAP_title', @$GAP_title);
		$this->set('GAP_mail', @$GAP_mail);
		
		$this->set('flg',2);

		$this->render('index_add');

	}
	
	/**
	 *
	 * 新規登録
	 */
	/* 新規追加CPU,ディスクIO */
	function addGrpalt($poll_id,$table_name,$link_name){
		
		$weekday = $this->data[$table_name]["weekday"];
		$start_time = $this->data[$table_name]["start_time"];
		
		$new_node = $this->data[$table_name]["new_node"];
		$not_found = $this->data[$table_name]["not_found"];
		$title = $this->data[$table_name]["title"];
		$mail = $this->data[$table_name]["mail_address"];
		
		$insert=Array(
		$table_name => Array(
		'weekday'  => $weekday ,
		'start_time'  => $start_time ,
		
		'new_node'  => $new_node ,
		'not_found' => $not_found,
		'poll_id' =>  $poll_id,
		'title' =>  $title,
		'mail_address' =>  $mail,
		)
		);
		$this->$table_name->save($insert);
	}
	


	/**
	 *
	 * 変更する
	 */
	function editGrpalt($poll_id,$table_name){
		$weekday = $this->data[$table_name]["weekday"];
		$start_time = $this->data[$table_name]["start_time"];
		
		$new_node = $this->data[$table_name]["new_node"];
		$not_found = $this->data[$table_name]["not_found"];
		$title = $this->data[$table_name]["title"];
		
		$mail = $this->data[$table_name]["mail_address"];
		
		$grpalt = $this->selectGrpalt($poll_id,$table_name);
		$grpalt_id = $grpalt[0][$table_name]['id'];
		$insert=Array(
			$table_name => Array(
			'id' => $grpalt_id,
			'weekday'  => $weekday ,
			'start_time'  => $start_time ,
			'new_node'  => $new_node ,
			'not_found' => $not_found,
			'poll_id' =>  $poll_id,
			'title' =>  $title,
			'mail_address' =>  $mail,
			)
		);
		$this->$table_name->save($insert);

	}

	
	/**
	 *
	 * 下位グループの設定の解除
	 */   

	function deleteGrpalt($poll_id,$table_name){
		$condition = $table_name.".poll_id =".$poll_id." ";
		//echo  $condition;
		$grpalt = $this->$table_name->findAll($condition);
		//debug($grpalt);
		if(count($grpalt) == 1){
			$grpalt_id = $grpalt[0]["$table_name"]["id"];
			$this->$table_name->del($grpalt_id);
		}

	}

	/*目前のグループの削除*/

	function delete(){

		$this->layout='ajax';
		$g_new = array();
		if(isset($this->data['Grpaltcpu']['del'])){
			$word_id=$this->data["Grpaltcpu"]["del"];
			//debug($word_id);
			foreach ($word_id as $value){
				$del_grpalt = $this->grpalt_list_id($value);
				$this->Grpaltnetscan->del($del_grpalt);
				
				$this->Rltgrpaltnetscan->deleteAll(Array("Rltgrpaltnetscan.org_grp_id =".$value));

			}

		}else{//未選択
			$error =__('E-00200',$return = true);
			$errorMessage['entry'] = $error;
			$this->set('errorMessage', $errorMessage);
		}
		$this->index();
		$this->render('index');
		exit();
	}

	/* グループ名の取得 */
	function pollName($group_id){

		$condition=array("Poll.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Poll->findAll($condition);
		$group_name = $group_n[0]["Poll"]["poll_name"];
		return $group_name;

	}

	/* アラート設定の取得 */
	function selectGrpalt($poll_id,$table_name){

		$condition =array($table_name.".poll_id" => $this->Lv->spec_char_dbm($poll_id));
		$grpalt = $this->$table_name->findAll($condition);
		return $grpalt;

	}

	function selectGrpaltFlag($poll_id,$table_name){

		$condition =array($table_name.".poll_id" => $this->Lv->spec_char_dbm($poll_id));
		$grpalt = $this->$table_name->findAll($condition);
		if(count($grpalt) ==1){
			$flag =1;
		}else{
			$flag =0;
		}
		return $flag;

	}
	
	function existAlert($poll_id){

		$condition =array("Grpaltnetscan.poll_id" => $this->Lv->spec_char_dbm($poll_id));
		$grpalt = $this->Grpaltnetscan->findAll($condition);

		if(count($grpalt) > 0){
			return true;
		}
		return false;
	}

	function grpalt_list($poll_id){
		$condition =array("Grpaltnetscan.poll_id" => $this->Lv->spec_char_dbm($poll_id));
		$grpalt = $this->Grpaltnetscan->findAll($condition);
		return $grpalt;

	}
	function grpalt_list_id($poll_id){
		$condition =array("Grpaltnetscan.poll_id" => $this->Lv->spec_char_dbm($poll_id));
		$grpalt = $this->Grpaltnetscan->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpaltnetscan"]["id"];
		}else{
			$id =0;
		}
		return $id;

	}
	
	function reset(){
		$this->layout='ajax';
		$this->index();
		$this->render('index');

	}

}