<?php
class SystemAllEvtfilsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','RequestHandler','Check');
	var $uses=array('Evtfil','Useevtlog','Configure','Validation');
	var $layout='system';
	function beforeFilter()
	{  	$this->Configure->write('debug',2);
	parent::beforeFilter();
	//================================yin c=======================
	if(isset($_POST['forHideVar'])){ //var_dump($_POST['forHideVar']);
		$this->set('forHideVar', $_POST['forHideVar']);

	}
	else if(isset($_POST['forHideVar1'])){
		$this->set('forHideVar', $_POST['forHideVar1']);
	}

	$application_info =__('application_info',$return=true);
	$security =__('security',$return=true);
	$system =__('system',$return=true);
	$error =__('error',$return=true);
	$warning =__('warning',$return=true);
	$whole =__('whole',$return=true);

	$s_list1 = array('0'=>"",'1'=>$application_info,'2'=>$security,'3'=>$system);
	$s_list2 = array('0'=>"",'1'=>$error,'2'=>$warning,'4'=>$whole);

	$this->set('s_list1',$s_list1);
	$this->set('s_list2',$s_list2);
	}
	//================================yin c=======================
	function index($f=null){

		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', 'forHideVar1=0&data%5BsortBy%5D=0');
		}
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		if($f==1){
			$this->layout='ajax'; }
			$lv_system_manage=__('lv_system_set',$retrun=true);
			$all_setting=__('all_setting',$retrun=true);
			$eventlog=__('eventlog_filter',$retrun=true);
			$this->pageTitle =$lv_system_manage."/".$all_setting."/".$eventlog;

			list($order,$limit,$page) = $this->Pagination->init(array("1=1"),null,array('ajaxDivUpdate'=>'vv','url'=>'/system_all_evtfils/index', 'modelClass'=>'Evtfil', 'queryType' => array('function' => 'findAll'), 'sortBy' => $this->Lv->sortBy('Evtfil.id'), 'ajaxFormId'=>'hidevars'));

			$evtfils= $this->Evtfil->findAll(array("1=1"), array('Evtfil.id', 'Evtfil.event_type','Evtfil.event_catalog','Evtfil.source','Evtfil.specification','Evtfil.event_id','Evtfil.event_id_type','Evtfil.source_type'),$order,$limit,$page,null);
			$evtfil_pg= $this->Evtfil->findAll(array("1=1"), array('Evtfil.id', 'Evtfil.event_type','Evtfil.event_catalog','Evtfil.source','Evtfil.specification','Evtfil.event_id','Evtfil.event_id_type','Evtfil.source_type'),null,null,null,null);
			$pg_num= count($evtfil_pg) ;
			$this->set( 'pg_num', $pg_num);
			$this->set( 'evtfils', $evtfils);

			$this->render('index');
	}

	function edit($id = null){
		$this->layout='ajax';
		if (empty($this->data))
		{
			$this->Evtfil->id = $id;

			$this->data = $this->Evtfil->read();

		}
		else
		{
			$errorMessage=array();

			$event_id = "";
			$source = "";
			$specification = "";
			
			$event_type = $this->data['Evtfil']['event_type'];
            $event_catalog = $this->data['Evtfil']['event_catalog'];

			$event_id = $this->data['Evtfil']['event_id'];
			$source = $this->data['Evtfil']['source'];
			$specification = $this->data['Evtfil']['specification'];
	
			$condition =array("1=1");
		
								$condition[]="event_type = ".$event_type."";
				
								$condition[]="event_catalog = ".$event_catalog."";
					            if(!empty($event_id)){
								$condition[]="event_id = '".$event_id."'";}
								else{$condition[]="event_id is NULL or event_id = ''";}
					            if(!empty($source)){
								$condition[]="source = '".$source."'";}
								else{$condition[]="source is NULL or source = ''";}
					            if(!empty($specification)){
								$condition[]= "specification  ='".$specification."'";}
								else{$condition[]="specification is NULL or specification = ''";}

							    $condition['group by']="Evtfil.event_type,Evtfil.event_catalog,Evtfil.source,Evtfil.specification,Evtfil.event_id";
			
			$fields = "Evtfil.event_type,Evtfil.event_catalog,Evtfil.source,Evtfil.specification,Evtfil.event_id";
			$results_useevtlog = $this->Evtfil->findAll($condition,$fields,'Evtfil.event_id',null,null,null);

		    if(!empty($results_useevtlog)){
		        $errorMessage['checkbox_content'][0] = "E-01900";
		        $this->set('errorMessage',$errorMessage);
		   		    }

			if(!$this->Validation->maxLength($event_id,5)){
				$errorMessage['event_id'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			if(!$this->Validation->maxLength($source,127)){
				$errorMessage['event_source'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			if(!$this->Validation->maxLength($specification,2000)){
				$errorMessage['event_specification'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			if(empty($this->data['Evtfil']['event_catalog'])){
				$errorMessage['event_catalog'][] = "E-00100";//未入力

				$this->set('errorMessage',$errorMessage);
			}
			if(empty($this->data['Evtfil']['event_type'])){
				$errorMessage['event_type'][] = "E-00100";//未入力

				$this->set('errorMessage',$errorMessage);
			}

			if(empty($errorMessage)){
				$this->Evtfil->save($this->data['Evtfil']);

				$this->index();
			}
		}
	}

	function del($depand=null){

		$this->layout='ajax';
		$errorMessage=array();
		if($depand!=1){
			if(empty($this->params['form']['cbid'])){//未選択

				$errorMessage['checkbox'][0] = "E-00200";
				$this->set('errorMessage',$errorMessage);
			}
			else {
				$this->Evtfil->del(array($this->params['form']['cbid']));
			}
		}
		$this->requestAction('/system_all_evtfils/index/',array('return'));
		$this->index('index');
	}
	function manual_login(){
//    debug($this->data,true);
		$this->layout='ajax';

		if (!empty($this->data)) {

			$errorMessage=array();

			$event_id = "";
			$source = "";
			$specification = "";
			
			$event_type = $this->data['Evtfil']['event_type'];
            $event_catalog = $this->data['Evtfil']['event_catalog'];
			$event_id = $this->data['Evtfil']['event_id'];
			$source = $this->data['Evtfil']['source'];
			$specification = $this->data['Evtfil']['specification'];
			
     		$condition =array("1=1");
				
								$condition[]="event_type = ".$event_type."";
								$condition[]="event_catalog = ".$event_catalog."";						
								if(!empty($event_id)){
								$condition[]="event_id = '".$event_id."'";}
								else{$condition[]="event_id is NULL or event_id = ''";}
					            if(!empty($source)){
								$condition[]="source = '".$source."'";}
								else{$condition[]="source is NULL or source = ''";}
					            if(!empty($specification)){
								$condition[]= "specification  ='".$specification."'";}
								else{$condition[]="specification is NULL or specification =''";}
							    $condition['group by']="Evtfil.event_type,Evtfil.event_catalog,Evtfil.source,Evtfil.specification,Evtfil.event_id";

			
			$fields = "Evtfil.event_type,Evtfil.event_catalog,Evtfil.source,Evtfil.specification,Evtfil.event_id";
			$results_useevtlog = $this->Evtfil->findAll($condition,$fields,'Evtfil.event_id',null,null,null);
			
					
		    if(!empty($results_useevtlog)){
		        $errorMessage['checkbox_content'][0] = "E-01900";
		        $this->set('errorMessage',$errorMessage);
		    }

			if(!$this->Validation->maxLength($event_id,5)){
				$errorMessage['event_id'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			if(!$this->Validation->maxLength($source,127)){
				$errorMessage['event_source'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			if(!$this->Validation->maxLength($specification,2000)){
				$errorMessage['event_specification'][] = 'E-00300';
				$this->set('errorMessage',$errorMessage);
			}
			if(empty($this->data['Evtfil']['event_catalog'])){
				$errorMessage['event_catalog'][] = "E-00200";//未入力

				$this->set('errorMessage',$errorMessage);
			}
			if(empty($this->data['Evtfil']['event_type'])){
				$errorMessage['event_type'][] = "E-00200";//未入力

				$this->set('errorMessage',$errorMessage);
			}

			if(empty($errorMessage)){

					$add = array(
					'Evtfil' => array(				
					'event_catalog' =>$this->data['Evtfil']['event_catalog'],
					'event_type' =>$this->data['Evtfil']['event_type'],
					'event_id' =>$this->data['Evtfil']['event_id'],					
					'source' =>$this->data['Evtfil']['source'],
					'specification' =>$this->data['Evtfil']['specification'],
					'event_id_type' =>$this->data['Evtfil']['event_id_type'],
					'source_type' =>$this->data['Evtfil']['source_type'],
					)
			   );

				$this->Evtfil->save($add);
				$this->index();
			}

		}
	}
	function list_login($a=null){

		$this->layout='ajax';
		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', 'forHideVar1=0&data%5BsortBy%5D=0');
		}
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		if($a==0){
			$condition =array("1=1");
			$condition['group by']="Useevtlog.event_type,Useevtlog.event_catalog,Useevtlog.source,Useevtlog.specification,Useevtlog.event_id";
			list($order,$limit,$page) = $this->Pagination->init($condition,null,array('ajaxDivUpdate'=>'v4','url'=>'/system_all_evtfils/list_login', 'modelClass'=>'Useevtlog', 'queryType' => array('function' => 'findAll'),'sortBy'=>'Useevtlog.event_id','ajaxFormId'=>'hidevars'));
			$useevtlogs = $this->Useevtlog->findAll($condition,array( 'Useevtlog.event_type','Useevtlog.event_catalog','Useevtlog.source','Useevtlog.specification','Useevtlog.event_id'),'Useevtlog.event_id',$limit,$page,null);
			$useevtlog_pg = $this->Useevtlog->findAll($condition,array( 'Useevtlog.event_type','Useevtlog.event_catalog','Useevtlog.source','Useevtlog.specification','Useevtlog.event_id'),null,null,null,null);
			$u_pg = count($useevtlog_pg);
			$this->set('u_pg', $u_pg);
			$this->set('useevtlogs', $useevtlogs);
		}
		if($a==1){
			$this->search_result();
		}
		if($a==2){

			$this->layout='ajax';

			if(!isset($this->params['form']['cbid'])){

				$errorMessage['checkbox'][0] = "E-00200";//未選択

				$this->set('errorMessage',$errorMessage);

				$type =$this->data['Useevtlog']['event_type'];
				$catalog =$this->data['Useevtlog']['event_catalog'];
				$event_id = $this->data['Useevtlog']['event_id'];
				$source = $this->data['Useevtlog'] ['source'];
				$specification = $this->data['Useevtlog'] ['specification'];

				if($type== 0 && $catalog== 0){ 
					$condition = array("1=1");
				}
				$condition =array("1=1");
				if(!empty($type)){
					$condition[]="Useevtlog.event_type = ".$type."";

				}
				if(!empty($catalog)){
					$condition[]="Useevtlog.event_catalog = ".$catalog."";
				}
				if(!empty($event_id)){
					$condition[]="Useevtlog.event_id = '".$event_id."'";
				}
				if(!empty($source)){
					$condition[]="Useevtlog.source = '".$source."'";
				}
				if(!empty($specification)){
					$condition[] = "Useevtlog.specification = '".$specification."'";
				}
                $condition['group by']="Useevtlog.event_type,Useevtlog.event_catalog,Useevtlog.source,Useevtlog.specification,Useevtlog.event_id";
				$fields  = "Useevtlog.event_catalog,Useevtlog.event_type,Useevtlog.event_id,Useevtlog.source,Useevtlog.specification";

				list($order,$limit,$page) = $this->Pagination->init($condition,null,array('ajaxDivUpdate'=>'v4','url'=>'/system_all_evtfils/list_login', 'modelClass'=>'Useevtlog', 'queryType' => array('function' => 'findAll'),'sortBy'=>'Useevtlog.event_id','ajaxFormId'=>'hidevars'));

				$useevtlogs = $this->Useevtlog->findAll($condition,$fields,'Useevtlog.event_id',$limit,$page,null);
				$useevtlog_pg = $this->Useevtlog->findAll($condition,$fields,null,null,null,null);
				$u_pg = count($useevtlog_pg);
				$this->set('u_pg', $u_pg);
				$this->set('useevtlogs', $useevtlogs);
			}

			if (isset($this->params['form']['cbid']))
			{
			
				$word_id  = $this->params['form']['cbid'];
           
				foreach ($word_id as $check){
					$event_catalog_0 = $this->data['Useevtlog']['event_catalog_'.$check];				
					$event_type_0 = $this->data['Useevtlog']['event_type_'.$check];
					$event_id_0 = $this->data['Useevtlog']['event_id_'.$check];
					$source_0 = $this->data['Useevtlog']['source_'.$check];
					$specification_0 = $this->data['Useevtlog']['specification_'.$check];
					
					$flag=0;
					foreach ($word_id as $id){
						
						if(($check != $id) && ($flag ==0)) {
						
							if (($event_catalog_0 == $this->data['Useevtlog']['event_catalog_'.$id])&&($event_type_0 == $this->data['Useevtlog']['event_type_'.$id])&&($event_id_0 == $this->data['Useevtlog']['event_id_'.$id])&&($source_0== $this->data['Useevtlog']['source_'.$id])&&($specification_0 == $this->data['Useevtlog']['specification_'.$id])){
								$flag=1;
							}
						}
					}
					
					if($flag==1){
						
							$errorMessage['checkbox_content'][0] = "E-01900";
							$this->set('errorMessage',$errorMessage);
					}
							$condition =array("1=1");
						
								$condition[]="event_type = ".$event_type_0."";
						
						
								$condition[]="event_catalog = ".$event_catalog_0."";
						        if(!empty($event_id_0)){
								$condition[]="event_id = '".$event_id_0."'";
						        }
								else{
								$condition[]="event_id is NULL or event_id = ''";
								}
							
					            if(!empty($source_0)){
								$condition[]="source = '".$source_0."'";
					            }
						        else{
						        $condition[]="source is NULL or source =''";
			                    }
					            if(!empty($specification_0)){
								$condition[]= "specification ='".$specification_0."'";
					            }
						        else{
						        $condition[]="specification is NULL or specification = ''";
						        }
							 $condition['group by']="Evtfil.event_type,Evtfil.event_catalog,Evtfil.source,Evtfil.specification,Evtfil.event_id";
					$fields = "Evtfil.event_type,Evtfil.event_catalog,Evtfil.source,Evtfil.specification,Evtfil.event_id";
					$results_useevtlog = $this->Evtfil->findAll($condition,$fields,'Evtfil.event_id',null,null,null);	
					
					if(!empty($results_useevtlog)){
				    $errorMessage['checkbox_content'][0] = "E-01900";
				    $this->set('errorMessage',$errorMessage);
				    $a=1;
				    $this->list_login($a);
				    }
					
				}
				  
				    
				    
				if(empty($errorMessage)){
			
				$checked_ids = $this->params['form']['cbid'] ;

				foreach ($checked_ids as $checked_id){
                   	$add = array(
					'Evtfil' => array(				
					'event_catalog' =>$this->data['Useevtlog']['event_catalog_'.$checked_id],
					'event_type' =>$this->data['Useevtlog']['event_type_'.$checked_id],
					'event_id' =>$this->data['Useevtlog']['event_id_'.$checked_id],
					
					'source' =>$this->data['Useevtlog']['source_'.$checked_id],
					'specification' =>$this->data['Useevtlog']['specification_'.$checked_id],
					)
			   );
				
					$this->Evtfil->save($add);
				 }
				 $this->index();
				
				}
				
				 

			}
		}
	}

	function search_result() {

		$this->layout='ajax';
		$event_type = $this->data['Useevtlog']['event_type'];
		$event_catalog = $this->data['Useevtlog']['event_catalog'];
		$event_id = $this->data['Useevtlog']['event_id'];
		$source = $this->data['Useevtlog']['source'];
		$specification = $this->data['Useevtlog']['specification'];
		$this->layout = 'ajax';
		$condition =array("1=1");
		if(!empty($event_type)){

			$condition[]="event_type = ".$event_type."";
		}
		if(!empty($event_catalog)){

			$condition[]="event_catalog = ".$event_catalog."";
		}
		if(!empty($event_id)){

			$condition[]="event_id = '".$event_id."'";
		}
		if(!empty($source)){

			$condition[]="source = '".$source."'";
		}
		if(!empty($specification)){

			$condition[]= "specification like  '%".$specification."%'";
		}
		$condition['group by']="Useevtlog.event_type,Useevtlog.event_catalog,Useevtlog.source,Useevtlog.specification,Useevtlog.event_id";
		list($order,$limit,$page) = $this->Pagination->init($condition,null,array('ajaxDivUpdate'=>'v4','url'=>'/system_all_evtfils/list_login/1', 'modelClass'=>'Useevtlog', 'queryType' => array('function' => 'findAll'),'ajaxFormId'=>'hidevars'));
		$useevtlogs = $this->Useevtlog->findAll($condition,array('Useevtlog.event_type','Useevtlog.event_catalog','Useevtlog.source','Useevtlog.specification','Useevtlog.event_id'),'Useevtlog.event_id',$limit,$page,null);
		$useevtlog_pg = $this->Useevtlog->findAll($condition,array('Useevtlog.event_type','Useevtlog.event_catalog','Useevtlog.source','Useevtlog.specification','Useevtlog.event_id'),null,null,null,null);
		$u_pg = count($useevtlog_pg);
		$this->set('u_pg', $u_pg);
		$this->set('useevtlogs', $useevtlogs);
		$this->set('useevtlogs', $useevtlogs);
	}

}

?>    	

