<?php
/*********************************************************************
*@filename system_all_groups_controller.php
*@description SystemAllGroupsController グループの設定
*@note 
*@histories  rivision	           author		date		      comment
*               2.0                  sunhy                  2009/06/16         modify for LV20R1-263
********************************************************************/  
class SystemAllGroupsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv', 'Tree');
	var $components = array ('Pagination', 'Lv', 'RequestHandler', 'GenerateFiles');
	var $uses=array('Group', 'Host', 'Grpauth', 'Rlthstgrp', 'Configure', 'Mail',
	"Grpaltdvc",
	"Rltgrpaltdvc", //To delete Inherited rule.
	"Grpaltdvctyp",
	"Rltgrpaltdvctyp",
	"Hstaltdvc",
	"Poll",

	//////////////////testだけ




	"Grpshd","Module","Rltshdmod",			//schedule
	"Grpaltapp", "Hstaltapp", "Grpalt",		//APPLI

	//authority
	//	'Someauth',
	);
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		//		$this->authByLic();
		//		$this->authByUser();
		//		    	$this->Configure->write('debug', 3);
		//		if($this->RequestHandler->accepts('ajax')){
		//			$this->layout = "ajax";
		//		}

	}
	//	function beforeRender()
	//	{
	//		parent::beforeRender();
	//	}
	function index()
	{
		$this->pageTitle = __('title',$return = true);
		//		$this->pageTitle = __('group pageTitle', true);	//LVシステム管理/グループ毎の設定/グループ




		//		print md5(02255);print "<br>"; print md5(03255);print "<br>"; print md5(04255);
		//		print "<br>" . md5('applicationtail');
		//		    	$this->GenerateFiles->hook_by_group(2, array('group', 'host'));
		//    	$this->GenerateFiles->hook_by_group(2, array('schedule'));
		//    	$this->GenerateFiles->hook_by_host(4, array('group', 'host'));
		//				$this->GenerateFiles->hook_by_ps(array(1,26,27,28,31,30), array('group'));
		//    	$this->group();
		//tree set
		$this->Group->unbindModel(array('hasMany' => array('Grpauth')));
		$data = $this->Group->findAllThreaded(null, null, 'Group.group_name', $this->_getUserGroup());
		//add root group
		$temp = $this->Group->findAllById($this->_getUserGroup());
		$temp[0]['Parentgroup'] = array('id' => NULL, 'parent_id' => NULL, 'group_name' => NULL);
		$temp[0]['children'] = $data;
		$data = $temp;

		$this->set('data', $data);

		//When another view check it checked
		if(!empty($this->data['Group']['id'])){
			$this->set('checked', $this->data['Group']['id']);
		}
		else {
			$this->set('checked', array());
		}
		$this->set('rootGroup', $this->_getUserGroup());
	}

	function add()
	{
		//addから
		if(!empty($this->data)){
			//    		$parentid = $this->data['Parent']['id'];
			//validate判断
			$errorMessage = $this->_getGroupValidate();
			//ERRORでFallback
			if(!empty($errorMessage)){
				$this->set('errorMessage', $errorMessage);
				if(empty($this->data['Group']['id'])){	//追加
					$this->_generalList();
					$this->render();
				}
				else {
					$this->edit($this->data['Group']['id']);
				}
				exit();
			}

			//save data
			else {
				if(!empty($this->data["Group"]['id'])){
					$parent = $this->Group->find(array("Group.id" => $this->Lv->spec_char_dbm($this->data["Group"]['id'])), array("Group.parent_id"));//, null, -1
					$parent = $parent['Group']['parent_id'];
				}
				else {
					$parent = null;
				}
				if(isset($this->data['Parent']['id']) && $this->data['Parent']['id'] != $parent){	//上位グループ修正した場合とグループ追加場合




					$parents_cf = true;
					$this->data['Group']['parent_id'] = $this->data['Parent']['id'];
				}
				else {														//グループ名修正だけ




					unset($this->data['Group']['parent_id']);
					$parents_cf = false;
				}

				if(empty($this->data['Group']['id'])){	//追加
				//debug($this->data['Group']);
					$newgroup=Array(
						'Group' => Array(
							'id' => $this->data["Group"]['id'],
							'group_name' => $this->Lv->spec_char_dbm($this->data['Group']['group_name']),
							'parent_id'=>$this->data['Group']['parent_id'],
							)
						);
					$this->Group->save($newgroup);
					//$this->Group->save($this->data['Group']);
					$this->data['Group']['id'] = $this->Group->getLastInsertID();

					$parents = $this->Grpauth->getParentsByChild($this->data['Group']['parent_id']);
					$this->Grpauth->joinChild2Parents($this->data['Group']['id'], $parents);
					$this->Grpauth->setInheritByGroupId($this->data['Group']['id'], $this, $this->_getRltToInherit());
				}
				else {//修正
					if($parents_cf == true){
						//チェック
						$errorMessage = $this->_checkGroupDel(array($this->data['Group']['id']));
						if(!empty($errorMessage)){
							$this->data['Group']['parent_id'] = $parent;
							$this->set("errorMessage", $errorMessage);
							$this->edit($this->data['Group']['id']);
						}
						//to change
						$newgroup=Array(
						'Group' => Array(
							'id' => $this->data['Group']['id'],
							'group_name' => $this->Lv->spec_char_dbm($this->data['Group']['group_name']),
							'parent_id'=>$this->data['Group']['parent_id'],
							)
						);
						$this->Group->save($newgroup);
						//$this->Group->save($this->data['Group']);
						$this->Grpauth->deleteAlertByParentId($this->data['Group']['id'], $this, $this->_getAlertToDel());
						$parents = $this->Grpauth->getParentsByChild($this->data['Group']['parent_id']);
						$this->Grpauth->joinChild2Parents($this->data['Group']['id'], $parents);
						$this->Grpauth->setInheritByGroupId($this->data['Group']['id'], $this, $this->_getRltToInherit());
					}
					else {//echo "eeeeeeeeeeeeee";
						$this->Group->save($this->data['Group']);
						//$this->Group->query("UPDATE groups set group_name='".$this->Lv->spec_char_dbm($this->data['Group']['group_name'])."' where id =".$this->data['Group']['id']);
					}
				}
				//追加成功
				//xinw start 20080508
				$Grpshd=$this->Grpshd->findAll(array('Grpshd.group_id' => $this->Lv->spec_char_dbm($this->data['Group']['id'])),null,null,null,null,-1);
				if (!empty($Grpshd)) {
					//xinw start 20080804
					$this->redirect('/system_grpset_schedules/add/'.$Grpshd[0]['Grpshd']['id'].'/index/null/'.$this->data['Group']['id']);
					//xinw end 20080804
				}else {
					$this->redirect('/system_grpset_schedules/add/null/null/'.$this->data['Group']['id']);
				}
				/*$this->index();
				$this->render('index');*/
				//xinw start 20080508
				exit();
			}
		}
		//indexから
		else{
			//    		$parentid = $this->getUserGroup();				//current user のグループID
			$this->_generalList();
		}
	}

	function edit($groupId)
	{
		$this->layout = "ajax";
		if(!empty($groupId)){
			$data = $this->Group->findAllById($groupId);
			if(empty($this->data)){
				$this->data = $data[0];
			}
			if($groupId != $this->_getUserGroup())
			{
				$this->_generalList($groupId);
			}
			else {

			}
			$this->set('hosts', $this->Rlthstgrp->getHostsByGroup($groupId));
			$this->render('add');
			exit();
		}
	}

	function delete()
	{
		if(!empty($this->data['Group']['id'])){
			$errorMessage = $this->_checkGroupDel($this->data['Group']['id']);
			if(empty($errorMessage)){
				if(!empty($this->data['Group']['id'])){
					//    					$this->flash("デリート成功！", "/system_all_groups/", 0);
					//						$this->render('delete');
					//    					exit();
					//sunhy start 2009/06/16 modify for LV20R1-263
					$this->Group->query("delete from grpshds where group_id not in (select id from groups)");
					//sunhy end 2009/06/16 modify for LV20R1-263
					foreach($this->data['Group']['id'] as $v){
						//sunhy start 2009/06/16 modify for LV20R1-263
						$this->Group->query("delete from grpapps where group_id = " . $v);
						$this->Group->query("delete from grpprocs where group_id = " . $v);
						$this->Group->query("delete from userlocks where group_id = " . $v);
						$this->Group->query("delete from grpsvcs where group_id = " . $v);
						$this->Group->query("delete from grpshds where group_id = " . $v);
						$this->Group->query("delete from grpdrts where group_id = " . $v);
						$this->Group->query("delete from grpaltapps where group_id = " . $v);
						$this->Group->query("delete from grpaltcpus where group_id = " . $v);
						$this->Group->query("delete from grpaltdsks where group_id = " . $v);
						$this->Group->query("delete from grpaltdvcs where group_id = " . $v);
						$this->Group->query("delete from grpaltdvctyps where group_id = " . $v);
						$this->Group->query("delete from grpaltevtlogs where group_id = " . $v);
						$this->Group->query("delete from grpalthdds where group_id = " . $v);
						$this->Group->query("delete from grpaltmems where group_id = " . $v);
						$this->Group->query("delete from grpaltnets where group_id = " . $v);
						$this->Group->query("delete from grpaltprocs where group_id = " . $v);
						$this->Group->query("delete from grpaltprtcnts where group_id = " . $v);
						$this->Group->query("delete from grpaltprtexts where group_id = " . $v);
						$this->Group->query("delete from grpaltprtfiles where group_id = " . $v);
						$this->Group->query("delete from grpaltsvcs where group_id = " . $v);
						$this->Group->query("delete from grpaltusers where group_id = " . $v);
						$this->Group->query("delete from grpaltvirs where group_id = " . $v);
						$this->Group->query("delete from grpaltwebtils where group_id = " . $v);
						$this->Group->query("delete from grpaltweburls where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltcpus where group_id = " . $v);
						$this->Group->query("delete from rlthstgrps where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltmems where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltnets where group_id = " . $v);
						$this->Group->query("delete from rltgrpalthdds where group_id = " . $v);
						$this->Group->query("delete from rltastsfws where group_id = " . $v);
						$this->Group->query("delete from rltgrpshds where group_id = " . $v);
						$this->Group->query("delete from rltgrpapps where group_id = " . $v);
						$this->Group->query("delete from rltgrpsvcs where group_id = " . $v);
						$this->Group->query("delete from rltgrpprocs where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltwebtils where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltweburls where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltusers where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltdvctyps where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltdvcs where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltevtlogs where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltsvcs where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltdsks where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltprocs where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltapps where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltvirs where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltprtfiles where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltprtexts where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltprtcnts where group_id = " . $v);
						$this->Group->query("delete from rltgrpdrts where group_id = " . $v);
						$this->Group->query("delete from rltgrpaltfiles where group_id = " . $v);
						$this->Group->query("delete from altmsgs where group_id = " . $v);
						$this->Group->query("delete from titles where group_id = " . $v);
						$this->Group->query("delete from grpalts where group_id = " . $v);
						$this->Group->query("delete from grpauths where group_id = " . $v);
						//sunhy end 2009/06/16 modify for LV20R1-263
						$this->Group->deleteAll(array('id = '.$v));
					}
				}
			}
			else {
				//エラーあり->fallback
			}
		}
		else {
			$errorMessage = array( __("group", true) . "　" . __('E-00200', true));
			//fallback
		}
		$this->set('errorMessage', $errorMessage);
		$this->index();
		$this->render('index');
		exit();
	}

	//	function _getUserGroup()
	//	{
	//		$usergroup = 1;///////////////////Sessionから
	//		return $usergroup;
	//	}
	function _generalList($groupId = NULL)
	{
		if(empty($groupId)){
			$children = $this->Group->getChildrenByParent($this->_getUserGroup());
			$this->set('grouplist', $children);
		}
		else {
			//$children = $this->Grpauth->getChildrenByParent($this->_getUserGroup(), array(" Grpauth.group_id NOT IN (SELECT G.group_id from grpauths as G WHERE G.org_grp_id = " . $groupId . ")") );
			$children = $this->Group->getChildrenByParent($this->_getUserGroup(), $groupId );
			$this->set('grouplist', $children);
		}
		//	    	$this->set('parentid', $parentid);
	}
	function _getGroupValidate()
	{
		$errorMessage = array();
		//    		if(!isset($this->data['Group']['id'])){
		//    			$errorMessage[] = "E-00200";
		//    		}
		if($this->Lv->is_empty($this->data['Group']['group_name'])){
			$errorMessage[] = __("groupName", true) . "　" . __("E-00100", true);//未入力




		}
		if(strlen($this->data['Group']['group_name']) >= 200){
			$errorMessage[] = __("groupName", true) . "　" . __("E-00300", true);//入力文字数>=200バイト




		}
		//zhangs start 20080325
		if(substr($this->data['Group']['group_name'],0,1)=='"'){
			$errorMessage[] = __("groupName", true) . "" . __("E-03500", true);//入力「"」できません
		}else{
			if(strpos($this->data['Group']['group_name'],'"')!=false){
				$errorMessage[] = __("groupName", true) . "" . __("E-03500", true);//入力「"」できません
			}
		}
		//zhangs end 20080325
		$data = $this->Group->find(array("Group.group_name" => $this->Lv->spec_char_dbm($this->data['Group']['group_name'])));
		if( !empty($data) && ($data['Group']['id'] != $this->data['Group']['id'])){
			$errorMessage[] = __("groupName", true) . "　" . __("E-00521", true);//グループ名があり



		}

		return $errorMessage;
	}

	function _getAlertToDel()
	{
		return array(
		//RLT :To delete Inherited rule.
		//			"Grpaltdvc", "Rltgrpaltdvc", "Grpaltdvctyp", "Rltgrpaltdvctyp", "Hstaltdvc",
		'Grpsvc',
		'Grpproc',

		"Grpalt",		//grpalts
		//rltgrpaltwebtils,grpaltwebtils,rltgrpaltweburls, grpaltweburls,
		"Grpaltprtcnt", "Rltgrpaltprtcnt", //grpaltprtcnts, rltgrpaltprtcnts, grpprts, grpaltprtfiles, grpaltprtexts, rltgrpaltprtfiles, rltgrpaltprtexts,
		//grpalts ????????????
		//rltgrpaltusers, grpaltusers,
		//rltgrpaltfiles, grpaltfiles,
		"Grpaltevtlog",  				//grpaltevtlogs, rltgrpaltevtlogs,
		"Rltgrpaltevtlog",
		"Grpaltsvc", "Hstaltsvc",		//grpaltsvcs, rltgrpaltsvcs, hstaltsvcs,
		//				"Rltgrpaltsvc",
		//"Hstaltproc"//hstaltprocs, rltgrpaltprocs, grpaltprocs,
		"Grpaltvir",					//rltgrpaltvirs, grpaltvirs,
		//				"Rltgrpaltvir",
		"Grpaltapp", "Hstaltapp",		//rltgrpaltapps, grpaltapps, hstaltapps,
		//				"Rltgrpaltapp",
		"Grpaltcpu", "Grpaltmem", "Grpaltnet", "Grpalthdd", "Grpaltdsk",
		//				"Rltgrpaltcpu", "Rltgrpaltmem","Rltgrpaltnet",  "Rltgrpalthdd", "Rltgrpaltdsk", 													//grpaltcpus, grpaltmems, grpaltnets, grpalthdds, grpaltdsks, rltgrpaltcpus, rltgrpaltmems, rltgrpaltnets, rltgrpalthdds, rltgrpaltdsks

		);
	}

	function _getRltToInherit()
	{
		return array(
		"Rltgrpaltdvc",
		"Rltgrpaltdvctyp",
		'Rltgrpsvc',
		'Rltgrpproc',

		'Rltgrpaltevtlog',
		'Rltgrpaltsvc',
		'Rltgrpaltproc',
		'Rltgrpaltvir',
		'Rltgrpaltapp',

		'Rltgrpaltcpu',
		'Rltgrpaltmem',
		'Rltgrpaltnet',
		'Rltgrpalthdd',
		'Rltgrpaltdsk',

		);
	}

	function _checkGroupDel($groups)
	{
		$errorMessage = array();
		foreach($groups as $v)
		{
			//下位グループチェック
			$children = $this->Grpauth->getChildrenByParent($v);
			if(!empty($children)){
				$children = array_keys($children);
				$toDel = array_intersect($children, $groups);
				$notDel = array_diff($children, $toDel);
				if(!empty($notDel)){
					//////あるグループ取得




					//	    			$data = $this->Group->findAll(array("Group.id IN「IN使用できない、修正して」 (" . implode(',',$notDel) . ")"));
					//	    			debug($data, true);
					//	    			if(!empty($data)){
					//		    			$groupName = set::extract($data,"{n}.Group.group_name");
					//		    			foreach($groupName as $vl){
					//		    				$errorMessage[$vl] = "E-01600";			//グループがあり
					//		    			}
					//	    			}
					if(!in_array(__('E-01600', true), $errorMessage)){
						$errorMessage[] = __('E-01600', true);			//グループがあり
					}
				}
			}
			//クライアントPCチェック
			$hosts = $this->Rlthstgrp->getHostsByGroup($v);
			if(!empty($hosts)){
				///////////////////////////////あるホスト取得




				//    			$hosts = array_keys($hosts);
				//    			$data = $this->Host->findAll(array("Host.id IN 「IN使用できない、修正して」(" . implode(',',$hosts) . ")"));
				//    			if(!empty($data)){
				//	    			$hostName = set::extract($data,"{n}.Host.host_name");
				//	    			foreach($hostName as $vl){
				//	    				$errorMessage[$vl] = "E-01600";			//クライアントPCがあり




				//	    			}
				//    			}
				if(!in_array(__('E-01700', true), $errorMessage)){
					$errorMessage[] = __('E-01700', true);			//クライアントPCがあり




				}
			}
		}
		return $errorMessage;
	}
}
?>