<?php
/*********************************************************************
*@filename 		system_grpset_alert_devices_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhy        2009/03/28    modify for JLN-001
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy        2009/05/21    modify for YBR-32
*            2.0        sunhy        2009/07/01   modify for YBR-34再
*            2.0        yzl        2009/07/06    modify for JL-0032
*            2.0        sunhy           2009/07/15   modify for YBR-41
*            2.0        yzl      2009/07/24    modify for JL-0035
*            2.0        sunhy      2009/07/31    modify for JL-0036
*            2.0        sawaki       2009/11/13   modify for ポップアップを表示させない。
********************************************************************/
class SystemGrpsetAlertDevicesController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv', 'Form');//, 'Cache'
	
	//sunhy start 2009/03/28 modify for JLN-001
	//var $components = array ('Pagination', 'Lv', 'RequestHandler', 'GenerateFiles');
	var $components = array ('Pagination', 'Lv', 'RequestHandler', 'GenerateFiles','Check','MailPopupController','AlertPcController');
	//sunhy end 2009/03/28 modify for JLN-001
	var $uses=array(
					'Optlgcdvc', 'Devicetype', 
					'Grpaltdvc', 'Rltgrpaltdvc', 			//list_by_name
					'Rltgrpaltdvctyp', 'Grpaltdvctyp', 		//list_by_type
					'Hstaltdvc', 'Hstaltatodvc', 							//list_by_host			
					'Group', 'Host','Rlthstgrp', 			//groupとhostなどの関連
					'Grpauth', 
//					'User',									//alert_group
					'Grpalt',
					'Configure',							//Cakeシステム
					// yzl start 2009/07/24 add for JL-0035
					'Altmsg','Title',
					// yzl end 2009/07/24 add for JL-0035
					);
	var $layout='system';
//	var $cacheAction = "+1 hour"; 
//	var $cacheAction = array(
//	    'index'  => 21600,
//	    '/alert_list'  => 21600,
//	    '/alert_group/1' => 21600,
//	    '/alert_group/10' => 21600,
//	    'alert_group_list'  => 21600,
//	    'alert_group_set'  => 21600,
//	    'search_by_host'  => 21600,
//	    'search_by_name'  => 21600,
//	    'search_by_type'  => 21600,
//	    'list_bygroup'  => 21600,
//	);
	
	function beforeFilter()
	{
		parent::beforeFilter();
//		var_dump($_POST);
		
//		$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
	    	$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		$this->pageTitle = __('title',$return = true);
	}
	
	function index()
	{
//		$this->GenerateFiles->test_enc_cstring();
		
		$this->alert_list();
		$this->render('alert_list');
	}
	
	////////////////////////////////////デバイス種類で処理


	//////////////
	
//	function list_by_type()
//	{
//		//グループリスト取得


//		$this->_setGlist();
////		$dataaera = $this->requestAction('/SystemGrpsetAlertDevices/search_by_type', array('return'));
////		$this->set('dataaera', $dataaera);
//	}
	
	function list_bygroup($type, $groupId)
	{
		$this->data['Group']['id'] = $groupId;
		
		$func = "search_by_" . $type;
		$this->$func();
		$this->render($func);
		exit;
	}
	
	function search_by_type()
	{
		$this->layout = 'ajax';
		
		$group = $this->Group->findById($this->_getEffectGroup());
		$this->set('groupname', $group['Group']['group_name']);
		
		//各種類件数取得


		$field = array('Devicetype.device_type_name', 'Devicetype.id', 'COUNT(Optlgcdvc.host_id) AS Optlgcdvc__count');
//		$field = array('Devicetype.device_type_name', 'Devicetype.id', 'COUNT(distinct Optlgcdvc.host_id) AS Optlgcdvc__count');
		
		//条件設定


		$criteria = array(	
			//デバイス種類で選択


			"(Optlgcdvc.device_type_id NOT IN (
								SELECT Grpaltdvctyp.device_type_id FROM grpaltdvctyps AS Grpaltdvctyp INNER JOIN rltgrpaltdvctyps as Rltgrpaltdvctyp ON (Rltgrpaltdvctyp.alert_id = Grpaltdvctyp.id) WHERE Rltgrpaltdvctyp.group_id = " . $this->_getEffectGroup() . " 
								)
					)",
			'GROUP BY' => 'Devicetype.device_type_name, Devicetype.id',
		);
		//選択グループ以下


		$criteria[] = "(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $this->_getEffectGroup() . "))";
		
		//関連設定


		$asso = array(
			//バイス種類で関連	Optlgcdvc -> Devicetype
			"Devicetype : devicetypes" => array("Optlgcdvc.device_type_id = Devicetype.id"),
			//グループで関連	Optlgcdvc -> Host -> Rlthstgrp -> Group
			"Host : hosts" => array("Optlgcdvc.host_id = Host.id"),
			"Rlthstgrp : rlthstgrps" => array("Rlthstgrp.host_id = Host.id"),
			"Group : groups" => array("Rlthstgrp.group_id = Group.id"),
		);
		
		$data = $this->Optlgcdvc->findByAsso($criteria, $field, 'UPPER(Devicetype.device_type_name)', null, null, $asso);
//		var_dump($this->Optlgcdvc);
		$this->set('data', $data);
	}
	
	function add_rule_type()
	{
		@$selTypeId = $this->data['Devicetype']['id'];
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => @$this->data['Devicetype']['id'], 'head' => 'device type'),
									"addGrpaltdvctyp" => array('head' => ' '),
							));
		if(!$hasError){//保存処理


			//グループ対象取得


			$groups = $this->_getGroupsToSet();
			$userGroup = $this->_getUserGroup();
			
			foreach($selTypeId as $v){
					$v = rawurldecode(rawurldecode($v));
					$toSaveTypeAlert = array(
						'id' => NULL,
//						'group_id' => $this->_getUserGroup(),
						'group_id' => $this->_getEffectGroup(),
						'device_type_id' => $v,
						'device_status' => $this->data['Grpaltdvctyp']['device_status'][$v],
					);
					$optlgcdvcs = $this->Optlgcdvc->findAll(array("Optlgcdvc.device_type_id" => $v), "DISTINCT(Optlgcdvc.device_name) AS Optlgcdvc__device_name");
					$optlgcdvcs = set :: extract($optlgcdvcs, "{n}.Optlgcdvc.device_name");
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT host_id FROM rlthstgrps AS Rlthstgrp WHERE Rlthstgrp.group_id IN( " . implode(",", $groups) . "))", 
													"Hstaltatodvc.device_name IN ('" . implode("', '", $optlgcdvcs) . "')"), array("del_flg" => 1));
					$this->Grpaltdvctyp->save($toSaveTypeAlert);
					$alertId = $this->Grpaltdvctyp->find(null, 'MAX(Grpaltdvctyp.id) AS id', null, 0);
					$alertId = $alertId[0]['id'];
						////
//						$this->Grpaltdvc->deleteAll(array("Grpaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc INNER JOIN hosts AS Host ON Optlgcdvc.host_id = Host.id INNER JOIN rlthstgrps AS Rlthstgrp ON Rlthstgrp.host_id = Host.id WHERE Rlthstgrp.group_id = " . $toSaveTypeAlert['group_id'] . " AND Optlgcdvc.device_type_id = " . $toSaveTypeAlert['device_type_id'] . ")"));			//deleted by wzy at 20071104
						////
					foreach($groups as $vl){
						$toSaveTypeAlertRlt = array(
							'id' => NULL,
							'group_id' => $vl,
							'alert_id' => $alertId,
							'org_grp_id' => $userGroup,
						); 
						$this->Rltgrpaltdvctyp->save($toSaveTypeAlertRlt);
					}
			}
			//sunhy start 2009/07/31 added for  JL-0036
			$this->alert_group_init();
			//sunhy end 2009/07/31 added for  JL-0036
		}
		else {
			isset($this->data['Devicetype']['id']) ? $this->set("devicetypes", $this->data['Devicetype']['id']) : $this->set("devicetypes", array());
		}
		
		//sunhy start 2009/03/28 added for JLN-001
		//sunhy start 2009/07/31 delete for JL-0036
		//$this->alert_group_init();
		//sunhy end 2009/07/31 delete for JL-0036
		//sunhy end 2009/03/28 added for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_group($this->_getEffectGroup(), array("device"));
		$this->GenerateFiles->hook_by_group($this->data['Group']['id'], array("device"));
		//sunhy end 2009/05/21 modify for YBR-32
		//ビューデータ更新
		$this->search_by_type();
		$this->render('search_by_type');
		exit();	
	}
	
	function del_rule_type()
	{
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => @$this->data['Devicetype']['id'], 'head' => 'device type')));
		if(!$hasError){
			//データ更新
		}
		$this->search_by_type();
		$this->render('search_by_type');
		exit();	
	}
	
	////////////////////////////////////デバイス名で処理


	//////////////
	
	function list_by_name()
	{
		//グループリスト取得


		$this->_setGlist();
//		$dataaera = $this->requestAction('/SystemGrpsetAlertDevices/search_by_name', array('return'));
	}
	
	function search_by_name()
	{
		$this->layout = 'ajax';
		
		$group = $this->Group->findById($this->_getEffectGroup());
		$this->set('groupname', $group['Group']['group_name']);
		
		//各種類件数取得


//		$field = array('Optlgcdvc.device_name','Devicetype.device_type_name', 'Devicetype.id', 'COUNT(distinct Optlgcdvc.host_id) AS Optlgcdvc__count');
		$field = array('Optlgcdvc.device_name','Devicetype.device_type_name', 'Devicetype.id', 'COUNT(Optlgcdvc.host_id) AS Optlgcdvc__count');
		
		//条件設定


		$criteria = array(	
			//デバイス種類で選択


			"(Optlgcdvc.device_type_id NOT IN (
						SELECT Grpaltdvctyp.device_type_id FROM grpaltdvctyps AS Grpaltdvctyp INNER JOIN rltgrpaltdvctyps as Rltgrpaltdvctyp ON (Rltgrpaltdvctyp.alert_id = Grpaltdvctyp.id) WHERE Rltgrpaltdvctyp.group_id = " . $this->_getEffectGroup() . " 
						)
					)",
			//デバイス名で選択


			"(Optlgcdvc.device_name NOT IN (
						SELECT Grpaltdvc.device_name FROM grpaltdvcs AS Grpaltdvc INNER JOIN rltgrpaltdvcs as Rltgrpaltdvc ON (Rltgrpaltdvc.alert_id = Grpaltdvc.id) WHERE Rltgrpaltdvc.group_id = " . $this->_getEffectGroup() . " 
						)
					)",	
			
			//sunhy start 2009/07/01 modify for YBR-34再
			//"(Optlgcdvc.device_name NOT IN (
						//SELECT Hstaltdvc.device_name FROM hstaltdvcs AS Hstaltdvc)
					//)",
			"(Optlgcdvc.device_name NOT IN (SELECT Hstaltdvc.device_name FROM hstaltdvcs AS Hstaltdvc where Hstaltdvc.host_id = Optlgcdvc.host_id)
					)",
			//sunhy end 2009/07/01 modify for YBR-34再
			//選択グループ以下


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $this->_getEffectGroup() . "))",
			//COUNT(Optlgcdvc.id) のために
			'GROUP BY' => 'Optlgcdvc.device_name, Devicetype.device_type_name, Devicetype.id',
		);
		
		//絞込みで検索
		if(isset($this->data['Bak'])){
//				if(is_array($this->data['Optlgcdvc']['device_name'])){
//					$this->data['Optlgcdvc']['device_name'] = $this->data['Bak']['Optlgcdvc_device_name'];
//					$this->data['Optlgcdvc']['device_type_id'] = $this->data['Bak']['Optlgcdvc_device_type_id'];
//				}
				$hasError = $this->_setEmsg(array("maxStr" => array('data' => $this->data['Bak']['SearchByOptlgcdvc_device_name'], 
							"max" => 512, 'head' => 'device name'),
							));
				if(!$hasError){
					if(!empty($this->data['Bak'])){
						($this->data['Bak']['SearchByOptlgcdvc_device_name'] == '') ? null 
						//xinw start 20080221
							: ($criteria[] = "lower(Optlgcdvc.device_name) LIKE '%" .strtolower($this->Lv->spec_char_like($this->data['Bak']['SearchByOptlgcdvc_device_name'])) . "%'");
						//xinw end 20080221
						($this->data['Bak']['SearchByOptlgcdvc_device_type_id'] == '') ? null 
							: ($criteria[] = "Optlgcdvc.device_type_id =" . $this->data['Bak']['SearchByOptlgcdvc_device_type_id'] . "");
					}
				}
		}
		
		//関連設定


		$asso = array(
			//バイス種類で関連	Optlgcdvc -> Devicetype
			"Devicetype : devicetypes" => array("Optlgcdvc.device_type_id = Devicetype.id"),
			//グループで関連	Optlgcdvc -> Host -> Rlthstgrp -> Group
			"Host : hosts" => array("Optlgcdvc.host_id = Host.id"),
			"Rlthstgrp : rlthstgrps" => array("Rlthstgrp.host_id = Host.id"),
			"Group : groups" => array("Rlthstgrp.group_id = Group.id"),
		);
		
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'index', 'url'=>'/system_grpset_alert_devices/search_by_name', 'modelClass'=>'Optlgcdvc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'ajaxFormId'=>'aera'));
		$data = $this->Optlgcdvc->findByAsso($criteria, $field, 'UPPER(Devicetype.device_type_name) ASC, UPPER(Optlgcdvc.device_name) ASC', $limit, $page, $asso);
		$this->set('data', $data);
		$this->_setTypelist();
	}
	
	function add_rule_name()
	{
//		if(isset($this->data['Optlgcdvc']['device_name'])){
//			foreach ($this->data['Optlgcdvc']['device_name'] as & $v){
//				$v = urldecode(urldecode($v));
//			}
//		}
		@$selDeviceName = $this->data['Optlgcdvc']['device_name'];
				
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => $selDeviceName, 'head' => 'device name'),
									"addGrpaltdvc" => array('head' => ' '),
								));
		if(!$hasError){//保存処理


			//グループ対象取得


			$groups = $this->_getGroupsToSet();
			$userGroup = $this->_getUserGroup();
			
			foreach($selDeviceName as $v){
				$v = rawurldecode(rawurldecode($v));
				//sunhy start 2009/07/02 added for YBR-34再
				list($device, $typName) = explode('-quote-', $v);
				//sunhy end 2009/07/02 added for YBR-34再
				$toSaveNameAlert = array(
					'id' => NULL,
//						'group_id' => $this->_getUserGroup(),
					'group_id' => $this->_getEffectGroup(),
					//sunhy start 2009/07/03 added for YBR-34再
					//'device_name' => $v,
					'device_name' => ereg_replace("&quot;","\"" ,$device),
					//sunhy end 2009/07/03 added for YBR-34再
					'device_status' => $this->data['Grpaltdvc']['device_status'][$v],
				);
				//sunhy start 2009/07/03 modify for YBR-34再
				//$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp WHERE Rlthstgrp.group_id IN( " . implode(",", $groups) . "))", 
																//"Hstaltatodvc.device_name = '$v'")
													//, array("del_flg" => 1));
				$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp WHERE Rlthstgrp.group_id IN( " . implode(",", $groups) . "))", "Hstaltatodvc.device_name = '$device'"), array("del_flg" => 1));
				//sunhy end 2009/07/03 modify for YBR-34再
				//sunhy start 2009/07/02 added for YBR-34再
				$grpaltdvc = $this->Grpaltdvc->findAll(array("Grpaltdvc.group_id = " . $this->_getEffectGroup(), "Grpaltdvc.device_name = '$device'"));
				if(count($grpaltdvc) == 0)
				//sunhy end 2009/07/02 added for YBR-34再
					$this->Grpaltdvc->save($toSaveNameAlert);
				//sunhy start 2009/07/02 added for YBR-34再
				$grpaltdvc = $this->Grpaltdvc->findAll(array("Grpaltdvc.group_id = " . $this->_getEffectGroup(), "Grpaltdvc.device_name = '$device'"));
				if(count($grpaltdvc) == 1 && $this->data['Grpaltdvc']['device_status'][$v] == 1){
					$toSaveNameAlert = array(
						'id' => $grpaltdvc[0]['Grpaltdvc']['id'],
						'group_id' => $this->_getEffectGroup(),
						'device_name' => ereg_replace("&quot;","\"" ,$device),
						'device_status' => $this->data['Grpaltdvc']['device_status'][$v],
					);
					$this->Grpaltdvc->save($toSaveNameAlert);
				}
				//sunhy end 2009/07/02 added for YBR-34再
				$alertId = $this->Grpaltdvc->getLastInsertID();
				foreach($groups as $vl){
					$toSaveAlertRlt = array(
						'id' => NULL,
						'group_id' => $vl,
						'alert_id' => $alertId,
						'org_grp_id' => $userGroup,
					);
					$this->Rltgrpaltdvc->save($toSaveAlertRlt);
				}
			}
			//sunhy start 2009/07/31 added for  JL-0036
			$this->alert_group_init();
			//sunhy end 2009/07/31 added for  JL-0036
		}
		else {
			$this->set("devicenames",  !empty($this->data['Optlgcdvc']['device_name']) ? $this->data['Optlgcdvc']['device_name'] : array());
		}
		//sunhy start 2009/04/27 added for JLN-001
		//sunhy start 2009/07/31 delete for JL-0036
		//$this->alert_group_init();
		//sunhy end 2009/07/31 delete for JL-0036
		//sunhy end 2009/04/27 added for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_group($this->_getEffectGroup(), array("device"));
		$this->GenerateFiles->hook_by_group($this->data['Group']['id'], array("device"));
		//sunhy end 2009/05/21 modify for YBR-32
		//ビューデータ更新
		$this->search_by_name();
		$this->render('search_by_name');
		exit();	
	}
	
	function del_rule_name()
	{
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => @$this->data['Optlgcdvc']['device_name'], 'head' => 'device name')));
		if(!$hasError){
			//データ更新
		}
		$this->search_by_name();
		$this->render('search_by_name');
		exit();	
	}
	
	function add_rule_input()
	{
		$hasError = $this->_setEmsg(array(
							"emptyStr2" => array('data' => @$this->data['Optlgcdvc']['input_device_name'], 'head' => 'device name'),
							"empty" => array('data' => @$this->data['Optlgcdvc']['input_input'], 'head' => 'device name'),
							"addGrpaltdvc2" => array('head' => ' '),
								), 'errorMessage2');
								
		if(!$hasError){//保存処理
			$input_device_name = $this->Lv->spec_char_dbm($this->data['Optlgcdvc']['input_device_name']);
			$check_device_name = $this->data['Optlgcdvc']['check_device_name'];
			//$input_device_type = $this->data['Optlgcdvc']['input_device_type'];
			$input_device_status = $this->data['Optlgcdvc']['input_device_status'];
//var_dump($this->data['Optlgcdvc']['check_device_name']);
			//グループ対象取得
			$groups = $this->_getGroupsToSet();
			$userGroup = $this->_getUserGroup();
			
			$toSaveNameAlert = array(
				'id' => NULL,
				'group_id' => $this->_getEffectGroup(),
				'device_name' => $input_device_name,
				'device_status' => $input_device_status,
				'match_type' => $check_device_name
			);
			if($check_device_name == 1)
				$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp WHERE Rlthstgrp.group_id IN( " . implode(",", $groups) . "))", "Hstaltatodvc.device_name like '%$input_device_name%'"), 
					array("del_flg" => 1, 'refcount' => 'refcount+1'));
			else
				$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp WHERE Rlthstgrp.group_id IN( " . implode(",", $groups) . "))", "Hstaltatodvc.device_name = '$input_device_name'"), array("del_flg" => 1));
			$grpaltdvc = $this->Grpaltdvc->findAll(array("Grpaltdvc.group_id = " . $this->_getEffectGroup(), "Grpaltdvc.device_name = '$input_device_name'"));
			if(count($grpaltdvc) == 0)
				$this->Grpaltdvc->save($toSaveNameAlert);
			$grpaltdvc = $this->Grpaltdvc->findAll(array("Grpaltdvc.group_id = " . $this->_getEffectGroup(), "Grpaltdvc.device_name = '$input_device_name'"));
			if(count($grpaltdvc) == 1 && $input_device_status == 1){
				$toSaveNameAlert = array(
					'id' => $grpaltdvc[0]['Grpaltdvc']['id'],
					'group_id' => $this->_getEffectGroup(),
					'device_name' => $input_device_name,
					'device_status' => $input_device_status,
					'match_type' => $check_device_name
				);
				$this->Grpaltdvc->save($toSaveNameAlert);
			}
			$alertId = $this->Grpaltdvc->getLastInsertID();
			foreach($groups as $vl){
				$toSaveAlertRlt = array(
					'id' => NULL,
					'group_id' => $vl,
					'alert_id' => $alertId,
					'org_grp_id' => $userGroup,
				);
				$this->Rltgrpaltdvc->save($toSaveAlertRlt);
			}
			$this->alert_group_init();
			$this->GenerateFiles->hook_by_group($this->data['Group']['id'], array("device"));
		}
		else {
			//$this->set("devicenames",  !empty($this->data['Optlgcdvc']['device_name']) ? $this->data['Optlgcdvc']['device_name'] : array());
		}
		//ビューデータ更新
		$this->search_by_name();
		$this->render('search_by_name');
		exit();	
	}
	////////////////////////////////////ホストで処理


	//////////////
	
	function list_by_host()
	{
		//グループリスト取得


		$this->_setGlist();
//		$dataaera = $this->requestAction('/SystemGrpsetAlertDevices/search_by_host', array('return'));
	}
	
	function search_by_host()
	{
		$this->layout = 'ajax';
		
		//sunhy start 2009/03/28 modify for JLN-001
		//$group = $this->Group->findById($this->_getEffectGroup());
		//sunhy start 2009/05/21 modify for YBR-32
		//$group = $this->AlertPcController->get_group($this->_getEffectGroup());
		$group = $this->AlertPcController->get_group($this->data['Group']['id']);
		//sunhy end 2009/05/21 modify for YBR-32
		//sunhy end 2009/03/28 modify for JLN-001
		$this->set('groupname', $group['Group']['group_name']);
		
		$hosts = $this->Rlthstgrp->getHostsByGroup($this->_getEffectGroup());
		$this->set('hosts', $hosts);
		//各種類件数取得


//		$field = array('Host.host_name', 'Host.id', 'Optlgcdvc.device_name', 'Devicetype.device_type_name', 'Devicetype.id', 'COUNT(distinct Optlgcdvc.host_id) AS Optlgcdvc__count');
		$field = array('Host.host_name', 'Host.id', 'Optlgcdvc.device_name', 'Devicetype.device_type_name', 'Devicetype.id', 'COUNT(Optlgcdvc.host_id) AS Optlgcdvc__count');
		
		//条件設定


		$criteria = array(	
			//デバイス種類で選択


			"(Optlgcdvc.device_type_id NOT IN (
								SELECT Grpaltdvctyp.device_type_id FROM grpaltdvctyps AS Grpaltdvctyp INNER JOIN rltgrpaltdvctyps as Rltgrpaltdvctyp ON (Rltgrpaltdvctyp.alert_id = Grpaltdvctyp.id) WHERE Rltgrpaltdvctyp.group_id = " . $this->_getEffectGroup() . " 
								)
					)",
			//デバイス名で選択


			"(Optlgcdvc.device_name NOT IN (
								SELECT Grpaltdvc.device_name FROM grpaltdvcs AS Grpaltdvc INNER JOIN rltgrpaltdvcs as Rltgrpaltdvc ON (Rltgrpaltdvc.alert_id = Grpaltdvc.id) WHERE Rltgrpaltdvc.group_id = " . $this->_getEffectGroup() . " 
								)
					)",
			//sunhy start 2009/07/01 modify for YBR-34再
			"(Optlgcdvc.device_name NOT IN (SELECT Hstaltdvc.device_name FROM hstaltdvcs AS Hstaltdvc where Hstaltdvc.host_id = Optlgcdvc.host_id)
					)",
			//sunhy end 2009/07/01 modify for YBR-34再
			//ホストセットで選択


			"(NOT EXISTS(SELECT Hstaltdvc.id FROM hstaltdvcs AS Hstaltdvc WHERE Hstaltdvc.host_id = Optlgcdvc.host_id AND Hstaltdvc.device_name = Optlgcdvc.device_name))",		

			//ホスト検索範囲
			//選択グループ以下


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $this->_getEffectGroup() . "))",////グループ下位の全部ホスト


//			"(Group.id = " . $this->_getEffectGroup() . ")",//このグループだけ


			//COUNT(Optlgcdvc.id) のために
			'GROUP BY' => ' Host.host_name, Host.id, Devicetype.device_type_name, Devicetype.id, Optlgcdvc.device_name',
		);
		
		//絞込みで検索
		$hasError = $this->_setEmsg(array("maxStr" => array('data' => isset($this->data['SearchByHost']['host_name']) ? $this->data['SearchByHost']['host_name'] : null, 
		"max" => 40, 'head' => 'host name'),
			"maxStr.1" => array('data' => isset($this->data['Bak']['SearchByOptlgcdvc_device_name']) ? $this->data['Bak']['SearchByOptlgcdvc_device_name'] : null, 
		"max" => 512, 'head' => 'device name'),
		));
		if(! $hasError){						
//			$this->data['SearchByHost']['host_name'] = $this->data['Bak']['SearchByHost_host_name'];
//			$this->data['SearchByOptlgcdvc']['device_name'] = $this->data['Bak']['SearchByOptlgcdvc_device_name'];
//			$this->data['SearchByOptlgcdvc']['device_type_id'] = $this->data['Bak']['SearchByOptlgcdvc_device_type_id'];
			//sunhy start 2009/07/03 modify for YBR-34再
			if(!empty($this->data['Bak'])){
				//sunhy start 2009/03/28 modify for JLN-001
				($this->data['Bak']['SearchByHost_host_name'] == '') ? null 
				//xinw start 20080221
					: ($criteria[] = "lower(Host.host_name) LIKE '%" . strtolower($this->Lv->spec_char_like($this->data['Bak']['SearchByHost_host_name'])) . "%'");
				//xinw end 20080221
				($this->data['Bak']['SearchByOptlgcdvc_device_name'] == '') ? null 
				//xinw start 20080221
					: ($criteria[] = "lower(Optlgcdvc.device_name) LIKE '%" .strtolower($this->Lv->spec_char_like($this->data['Bak']['SearchByOptlgcdvc_device_name'])) . "%'");
				//xinw end 20080221
				($this->data['Bak']['SearchByOptlgcdvc_device_type_id'] == '') ? null 
					: ($criteria[] = "Optlgcdvc.device_type_id =" . $this->data['Bak']['SearchByOptlgcdvc_device_type_id'] . "");
				
				/*($this->data['Bak']['SearchByHost_host_name'] == '') ? null : ($criteria = $this->AlertPcController->search_judge("Host", "host_name", strtolower($this->Lv->spec_char_change($this->data['Bak']['SearchByHost_host_name'])), $criteria));
				($this->data['Bak']['SearchByOptlgcdvc_device_name'] == '') ? null : ($criteria = $this->AlertPcController->search_judge("Optlgcdvc", "device_name", strtolower($this->Lv->spec_char_change($this->data['Bak']['SearchByOptlgcdvc_device_name'])), $criteria));
				($this->data['Bak']['SearchByOptlgcdvc_device_type_id'] == '') ? null : ($criteria = $this->AlertPcController->search_judge("Optlgcdvc", "device_type_id", $this->data['Bak']['SearchByOptlgcdvc_device_type_id'], $criteria));*/
				//sunhy end 2009/07/03 modify for YBR-34再
				//sunhy end 2009/03/28 modify for JLN-001
			}
		}
		
		//関連設定


		$asso = array(
			//バイス種類で関連	Optlgcdvc -> Devicetype
			"Devicetype : devicetypes" => array("Optlgcdvc.device_type_id = Devicetype.id"),
			//グループで関連	Optlgcdvc -> Host -> Rlthstgrp -> Group
			"Host : hosts" => array("Optlgcdvc.host_id = Host.id"),
			"Rlthstgrp : rlthstgrps" => array("Rlthstgrp.host_id = Host.id"),
			"Group : groups" => array("Rlthstgrp.group_id = Group.id"),
			
			//ホストセットで選択


//			"Hstaltdvc : hstaltdvcs : left" => array("Hstaltdvc.host_id = Host.id", "Hstaltdvc.device_name = Optlgcdvc.device_name"),
		);
		
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'index', 'url'=>'/system_grpset_alert_devices/search_by_host', 'modelClass'=>'Optlgcdvc', 'queryType' => array('function' => 'findByAsso','asso'=>$asso), 'ajaxFormId'=>'aera'));
		$data = $this->Optlgcdvc->findByAsso($criteria, $field, 'UPPER(Host.host_name) ASC, UPPER(Devicetype.device_type_name) ASC, UPPER(Optlgcdvc.device_name) ASC', $limit, $page, $asso);
		$this->set('data', $data);
		$this->_setTypelist();
	}
	
	function add_rule_host()
	{
		@$selDeviceName = $this->data['Optlgcdvc']['host_id2device_name'];
		//sunhy start 2009/07/01 modify for YBR-34再
		//$hasError = $this->_setEmsg(array("notSelected" => array('data' => $selDeviceName, 'head' => 'client pc')));
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => $selDeviceName, 'head' => 'device name'),
									"addHstaltdvc" => array('head' => ' '),
								));
		//sunhy end 2009/07/01 modify for YBR-34再
		if(!$hasError){//保存処理


			$temp = array();
			foreach($selDeviceName as $v){
				$v = rawurldecode(rawurldecode($v));
				//sunhy start 2009/07/01 modify for YBR-34再
				//list($host, $device) = explode('-quote-', $v);
				list($host, $device, $status) = explode('-quote-', $v, 3);
				//sunhy end 2009/07/01 modify for YBR-34再
				$toSaveHostAlert = array(
					'id' => NULL,
					'host_id' => $host,
					//sunhy start 2009/07/01 modify for YBR-34再
					//'device_name' => $device,
					'device_name' => ereg_replace("&quot;","\"" ,$device),
					//sunhy end 2009/07/01 modify for YBR-34再
					'device_status' => $this->data['Hstaltdvc']['device_status'][$v],
				);
				$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id = $host", "Hstaltatodvc.device_name = '$device'"), array("del_flg" => 1));
				//sunhy start 2009/07/02 added for YBR-34再
				$hstaltdvc = $this->Hstaltdvc->findAll(array("Hstaltdvc.host_id = $host", "Hstaltdvc.device_name = '$device'"));
				if(count($hstaltdvc) == 0)
				//sunhy end 2009/07/02 added for YBR-34再
					$this->Hstaltdvc->save($toSaveHostAlert);
				//sunhy start 2009/07/02 added for YBR-34再
				$hstaltdvc = $this->Hstaltdvc->findAll(array("Hstaltdvc.host_id = $host", "Hstaltdvc.device_name = '$device'"));
				if(count($hstaltdvc) == 1 && $this->data['Hstaltdvc']['device_status'][$v] == 1){
					$toSaveHostAlert = array(
						'id' => $hstaltdvc[0]['Hstaltdvc']['id'],
						'host_id' => $host,
						'device_name' => ereg_replace("&quot;","\"" ,$device),
						'device_status' => $this->data['Hstaltdvc']['device_status'][$v],
					);
					$this->Hstaltdvc->save($toSaveHostAlert);
				}
				//sunhy end 2009/07/02 added for YBR-34再
				if(!in_array($host, $temp)){
					$temp[] = $host;
				}
			}
			$groups = $this->Rlthstgrp->findAll("Rlthstgrp.host_id IN (" . implode(",", $temp) . ")", "DISTINCT(Rlthstgrp.group_id) as Rlthstgrp__group_id");
			$groups = set :: extract($groups, "{n}.Rlthstgrp.group_id");
			$temp_group_id = $this->data['Group']['id'];
			foreach($groups as $v){
				if(false === $this->alert_group_isexist(array($v))){
					$this->data['Group']['id'] = $v;
					$this->alert_group_init();
				}
			}
			$this->data['Group']['id'] = $temp_group_id;
			//sunhy start 2009/05/20 modify for YBR-32
			//$this->GenerateFiles->hook_by_host($temp, array("device"));
			$this->GenerateFiles->hook_by_host($temp, array("device"), $this->data['Group']['id']);
			//sunhy end 2009/05/20 modify for YBR-32
		}
		
		//ビューデータ更新
		$this->search_by_host();
		$this->render('search_by_host');
		exit();	
	}
	
	function del_rule_host()
	{
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => @$this->data['Optlgcdvc']['host_id2device_name'], 'head' => 'client pc')));
		if(!$hasError){
			//データ更新
		}
		$this->search_by_host();
		$this->render('search_by_host');
		exit();	
	}
	
	
	function add_rule_input_host()
	{
		$hasError = $this->_setEmsg(array(
				"emptyStr2" => array('data' => @$this->data['Hstaltatodvc']['input_device_name'], 'head' => 'device name'),
				"empty" => array('data' => @$this->data['Hstaltatodvc']['input_input'], 'head' => 'device name'),
									"addHstaltdvc2" => array('head' => ' '),
								), 'errorMessage2');
		if(!$hasError){//保存処理
			$host = $this->data['Hstaltatodvc']['host_id'];
			$input_device_name = $this->Lv->spec_char_dbm($this->data['Hstaltatodvc']['input_device_name']);
			$check_device_name = $this->data['Hstaltatodvc']['check_device_name'];
			//$input_device_type = $this->data['Hstaltatodvc']['input_device_type'];
			$input_device_status = $this->data['Hstaltatodvc']['input_device_status'];
			//var_dump($this->data['Hstaltatodvc']['check_device_name']);
			$temp = array();
			$toSaveHostAlert = array(
				'id' => NULL,
				'host_id' => $host,
				'device_name' => $input_device_name,
				'device_status' => $input_device_status,
				'match_type' => $check_device_name,
			);
			if($check_device_name == 1)//部分一致
				$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id = $host", "Hstaltatodvc.device_name like '%$input_device_name%'"), 
						array("del_flg" => 1, 'refcount' => 'refcount+1'));
			else
				$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id = $host", "Hstaltatodvc.device_name = '$input_device_name'"), array("del_flg" => 1));
			
			$hstaltdvc = $this->Hstaltdvc->findAll(array("Hstaltdvc.host_id = $host", "Hstaltdvc.device_name = '$input_device_name'"));
			if(count($hstaltdvc) == 0)
				$this->Hstaltdvc->save($toSaveHostAlert);
			$hstaltdvc = $this->Hstaltdvc->findAll(array("Hstaltdvc.host_id = $host", "Hstaltdvc.device_name = '$input_device_name'"));
			if(count($hstaltdvc) == 1 && $input_device_status == 1){
				$toSaveHostAlert = array(
					'id' => $hstaltdvc[0]['Hstaltdvc']['id'],
					'host_id' => $host,
					'device_name' => $input_device_name,
					'device_status' => $input_device_status,
					'match_type' => $check_device_name,
				);
				$this->Hstaltdvc->save($toSaveHostAlert);
			}
			if(!in_array($host, $temp)){
				$temp[] = $host;
			}

			$groups = $this->Rlthstgrp->findAll("Rlthstgrp.host_id IN (" . implode(",", $temp) . ")", "DISTINCT(Rlthstgrp.group_id) as Rlthstgrp__group_id");
			$groups = set :: extract($groups, "{n}.Rlthstgrp.group_id");
			$temp_group_id = $this->data['Group']['id'];
			foreach($groups as $v){
				if(false === $this->alert_group_isexist(array($v))){
					$this->data['Group']['id'] = $v;
					$this->alert_group_init();
				}
			}
			$this->data['Group']['id'] = $temp_group_id;
			$this->GenerateFiles->hook_by_host($temp, array("device"), $this->data['Group']['id']);
		}
		
		//ビューデータ更新
		$this->search_by_host();
		$this->render('search_by_host');
		exit();	
	}
	////////////////////////////////////アラートに関する処理


	//////////////
	
	function alert_list()
	{
//		$this->_setGlist();
//		if($this->RequestHandler->isAjax()){
////			$this->layout = 'ajax';
//		}
		$alertList = $this->requestAction('/system_grpset_alert_devices/alert_search', array('return'));
		$this->set('alertList', $alertList);
	}
	
	function alert_seted()
	{
		$this->layout = 'ajax';
		$this->alert_list();
		$this->render('alert_list');
		exit;
	}
	
	function alert_search()
	{
		$this->layout = 'ajax';
		//sunhy start 2009/05/27 added modify for YBR-32
		$this->data['Group']['id']=$this->_getUserGroup();
		//sunhy end 2009/05/27 added modify for YBR-32
		$this->set("glist", $this->Group->getChildrenByParent($this->_getUserGroup()));
    	$this->_setEffectGlist();
		$this->_setParents();
		$this->_setedAlttypes();
		$this->_setedAltdevices();
		$this->_setedAlthosts();
    	$this->_setedGrpalt(array("mail_notice", "popup", "mail_notice_time"));	//$grpalts_mail_notice,//$grpalts_popup,//$grpalts_popup
	}
	
	function del_alert_by_group()
	{
		$this->layout = 'ajax';
		$hasError = $this->_setEmsg(array("notSelected" => array('data' => $this->data['Group']['id'], 'head' => 'Group'),
										"delGrpaltInherit" => array('head' => 'Group'),));
		if(!$hasError){
			foreach($this->data['Group']['id'] as $v){
				
				$types = $this->Grpaltdvctyp->findAll(array("Grpaltdvctyp.group_id = " . $v));
				if(!empty($types)){
					$types = set :: extract($types, "{n}.Grpaltdvctyp.id");
					$this->reset_atohst_typ($types);
				}
				$this->Grpaltdvctyp->deleteAll(array("group_id = " . $v));
				
				$devices = $this->Grpaltdvc->findAll(array("Grpaltdvc.group_id = " . $v));
				if(!empty($devices)){
					$devices = set :: extract($devices, "{n}.Grpaltdvc.id");
					$this->reset_atohst_dvc($devices);
				}
				$this->Grpaltdvc->deleteAll(array("group_id = " . $v));
				
				$hstdvcs = $this->Hstaltdvc->findAll(array("Hstaltdvc.host_id IN (SELECT Host.id FROM hosts as Host INNER JOIN rlthstgrps AS Rlthstgrp ON Rlthstgrp.host_id = Host.id WHERE Rlthstgrp.group_id = " . $v . ")"));
				if(!empty($hstdvcs)){
					$hstdvcs = set :: extract($hstdvcs, "{n}.Hstaltdvc.id");
					$this->reset_atohst_hstdvc($hstdvcs);
				}
				//$this->Hstaltdvc->deleteAll(array("host_id IN (SELECT Host.id FROM hosts as Host INNER JOIN rlthstgrps AS Rlthstgrp ON Rlthstgrp.host_id = Host.id WHERE Rlthstgrp.group_id = " . $v . ")"));	
				$delhstdvcs = $this->Hstaltdvc->findAll(array("Hstaltdvc.host_id IN (SELECT Host.id FROM hosts as Host INNER JOIN rlthstgrps AS Rlthstgrp ON Rlthstgrp.host_id = Host.id WHERE Rlthstgrp.group_id = " . $v . ")"));
				//debug($delhstdvcs);
				if(!empty($delhstdvcs)){
					foreach($delhstdvcs as $delid){
						$this->Hstaltdvc->del($delid['Hstaltdvc']['id']);
					}
				}
				$this->Grpalt->deleteAll(array("type = 4 AND group_id = " . $v));
				//sunhy start 2009/05/21 modify for YBR-32
				// yzl start 2009/07/24 modify for JL-0035
				//$this->GenerateFiles->hook_by_group($v, "device");
				$this->MailPopupController->delAltMsg("E0004",$v);
				$this->MailPopupController->delAltTit("4",$v);
				$this->GenerateFiles->hook_by_group($v, array("device","popup"));
				// yzl end 2009/07/24 modify for JL-0035
				//sunhy end 2009/05/21 modify for YBR-32
			}
			//sunhy start 2009/05/21 modify for YBR-32
			//$this->GenerateFiles->hook_by_group($this->data['Group']['id'], "device");
			//sunhy end 2009/05/21 modify for YBR-32
		}
		
		$this->set("groups", $this->data['Group']['id']);
		
		$this->data = NULL;
		$this->alert_search();
		$this->render('alert_search');
		exit();
	}
	
	//xinw start 20090203
	//modify for ASP4-031
	//function alert_group($groupId = null)
	function alert_group($groupId = null,$do=null)
	//xinw end 20090203
	{
		$this->layout = 'ajax';
		$group_list = $this->requestAction("/system_grpset_alert_devices/alert_group_list/$groupId", array('return'));
		$this->set("group_list", $group_list);
		//xinw start 20090203
		//modify for ASP4-031
		//$group_set = $this->requestAction("/system_grpset_alert_devices/alert_group_set/$groupId", array('return'));
		$group_set = $this->requestAction("/system_grpset_alert_devices/alert_group_set/$groupId/$do", array('return'));
		//xinw end 20090203
		$this->set("group_set", $group_set);
	}
	//xinw start 20090203
	//modify for ASP4-031
	//function alert_group_add()
	function alert_group_add($do=null)
	//xinw end 20090203
	{
		//xinw start 20090203
		//modify for ASP4-031
		//$this->alert_group($this->data['Group']['id']);
		$this->alert_group($this->data['Group']['id'],$do);
		//xinw end 20090203
		$this->render('alert_group');
		exit;
	}
	
	function alert_group_list($groupId = null)
	{
		$this->layout = 'ajax';
		if(empty($groupId) && empty($this->data['Group']['id'])){
			$this->alert_search();
			$this->render('alert_search');
			exit();
		}
		empty($groupId) ? null : $this->data['Group']['id'] = $groupId;		//alert_listからセット
		$group = $this->Group->findById($this->data['Group']['id']);
		$this->set('groupname', $group['Group']['group_name']);
		
		$this->_setEffectGlist(true);
		$this->_setParents(false, false);
		$this->_setedTypesInherit();
		$this->_setedDevicesInherit();
		$this->_setedHosts();
	}
	
	function alert_set()
	{
		
	}
	
	//グループごとの画面で削除
	function alert_group_del()
	{
		if(empty($this->data)){//異常処理


			$this->alert_group_list();
		}
		else {
			$hasError = $this->_setEmsg(array(
											"notSelected" => array('data' => array(
																		$this->data['Grpaltdvctyp'],
																		$this->data['Grpaltdvc'],
																		$this->data['Hstaltdvc'],
																				), 
																	'head' => 'alert set'),
											));
			if(!empty($this->data['Grpaltdvctyp']['id'])){
				$this->reset_atohst_typ($this->data['Grpaltdvctyp']['id']);
				foreach($this->data['Grpaltdvctyp']['id'] as $v){
					//デバイス種類アラート削除
					$this->Grpaltdvctyp->del($v);
				}
			}
			if(!empty($this->data['Grpaltdvc']['id'])){
				$this->reset_atohst_dvc($this->data['Grpaltdvc']['id']);
				foreach($this->data['Grpaltdvc']['id'] as $v){
					$this->Grpaltdvc->del($v);
				}
			}
			if(!empty($this->data['Hstaltdvc']['id'])){
				$this->reset_atohst_hstdvc($this->data['Hstaltdvc']['id']);
				foreach($this->data['Hstaltdvc']['id'] as $v){
					$this->Hstaltdvc->del($v);
				}
			}
			$this->GenerateFiles->hook_by_group($this->data['Group']['id'], "device");
			$this->alert_group_list();
			$this->render('alert_group_list');
			exit();
		}
	}
	
	/**
	 * //自動のホストアラートを復元処理


	 *
	 * @param unknown_type $typs
	 */
	function reset_atohst_typ($grpaltdvctyps)
	{
		foreach($grpaltdvctyps as $v){
			$optlgcdvcs = $this->Optlgcdvc->findAll("Optlgcdvc.device_type_id IN (
														SELECT Grpaltdvctyp.device_type_id FROM grpaltdvctyps AS Grpaltdvctyp WHERE Grpaltdvctyp.id = $v
													)", "DISTINCT(Optlgcdvc.device_name) AS Optlgcdvc__device_name");
			$optlgcdvcs = set :: extract($optlgcdvcs, "{n}.Optlgcdvc.device_name");
			$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT host_id FROM rlthstgrps AS Rlthstgrp INNER JOIN grpauths AS Grpauth ON Grpauth.group_id = Rlthstgrp.group_id WHERE Grpauth.org_grp_id IN( SELECT Grpaltdvctyp.group_id FROM grpaltdvctyps AS Grpaltdvctyp WHERE Grpaltdvctyp.id = $v))", 
											"Hstaltatodvc.device_name IN ('" . implode("', '", $optlgcdvcs) . "')"), array("del_flg" => 0));
		}
		return true;
	}
	
	/**
	 * //自動のホストアラートを復元処理


	 *
	 * @param unknown_type $typs
	 */
	function reset_atohst_dvc($grpaltdvcs)
	{
		/*
		foreach($grpaltdvcs as $v){
			$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp INNER JOIN grpauths AS Grpauth ON Grpauth.group_id = Rlthstgrp.group_id WHERE Grpauth.org_grp_id IN(SELECT Grpaltdvc.group_id FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v))", 
														"Hstaltatodvc.device_name IN(SELECT Grpaltdvc.device_name FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v)")
											, array("del_flg" => 0));
		}*/
		foreach($grpaltdvcs as $v){
			$devices = $this->Grpaltdvc->findAll(array("Grpaltdvc.id = " . $v));
			foreach($devices as $vl){
				if($vl["Grpaltdvc"]["match_type"] != 1)
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp INNER JOIN grpauths AS Grpauth ON Grpauth.group_id = Rlthstgrp.group_id WHERE Grpauth.org_grp_id IN(SELECT Grpaltdvc.group_id FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v))", 
														"Hstaltatodvc.device_name IN(SELECT Grpaltdvc.device_name FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v)")
											, array("del_flg" => 0));
				else{
					//デバイス名が複数の設定によってdel_flag=1になった場合
					//refcountを減らし0になればdelflgを0にする
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp INNER JOIN grpauths AS Grpauth ON Grpauth.group_id = Rlthstgrp.group_id WHERE Grpauth.org_grp_id IN(SELECT Grpaltdvc.group_id FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v))", 
														"Hstaltatodvc.device_name like(SELECT concat('%',Grpaltdvc.device_name,'%') FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v)")
											, array('refcount' => 'refcount-1'));
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id IN(SELECT Rlthstgrp.host_id FROM rlthstgrps AS Rlthstgrp INNER JOIN grpauths AS Grpauth ON Grpauth.group_id = Rlthstgrp.group_id WHERE Grpauth.org_grp_id IN(SELECT Grpaltdvc.group_id FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v))", 
														"Hstaltatodvc.device_name like(SELECT concat('%',Grpaltdvc.device_name,'%') FROM grpaltdvcs AS Grpaltdvc WHERE Grpaltdvc.id = $v)",
														"Hstaltatodvc.refcount < 1")
											, array("del_flg" => 0, 'refcount' => 0));							
												
				}
			}
		}
		
		return true;
	}
	
	/**
	 * //自動のホストアラートを復元処理


	 *
	 * @param unknown_type $typs
	 */
	function reset_atohst_hstdvc($hstaltdvcs)
	{
		foreach($hstaltdvcs as $v){
			$hstalts = $this->Hstaltdvc->findAll("id = $v");
			foreach($hstalts as $vl){
				if($vl["Hstaltdvc"]['match_type'] != 1)
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id = " . $vl["Hstaltdvc"]["host_id"], 
							"Hstaltatodvc.device_name = '" . $vl["Hstaltdvc"]["device_name"] . "'"), 
							array("del_flg" => 0));
							
				else{
					//デバイス名が複数の設定によってdel_flag=1になった場合
					//refcountを減らし0になればdelflgを0にする
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id = " . $vl["Hstaltdvc"]["host_id"], 
							"Hstaltatodvc.device_name like '%" . $vl["Hstaltdvc"]["device_name"] . "%'"), 
							array('refcount' => 'refcount-1'));
					$this->Hstaltatodvc->updateAll(array("Hstaltatodvc.host_id = " . $vl["Hstaltdvc"]["host_id"], 
							"Hstaltatodvc.device_name like '%" . $vl["Hstaltdvc"]["device_name"] . "%'", 
							"Hstaltatodvc.refcount < 1"), 
							array("del_flg" => 0, 'refcount' => 0));							
												
				}
			}
		}
		return true;
	}
	/**
	 * アラートメール／ポップアップ設定


	 *
	 */
	//xinw start 20090203
	//modify for ASP4-031
	//function alert_group_set($groupId = null)
	function alert_group_set($groupId = null,$do=null)
	//xinw end 20090203
	{
		empty($groupId) ? null : $this->data['Group']['id'] = $groupId;
		$usergroup = $this->_getEffectGroup();
		$this->addModel("Mail", "Title", "Altmsg");
		//メールアドレース取得


		//sunhy start 2009/03/28 added for JLN-001
		$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/28 added for JLN-001
		
		//sunhy start 2009/05/21 modify for YBR-32
		//$mail = $this->Mail->findByAsso(array('User.group_id = ' . $usergroup), array('Mail.mail_address'), 'Mail.mail_address', null, null, 
		$mail = $this->Mail->findByAsso(array('User.group_id = ' . $groupId), array('Mail.mail_address'), 'Mail.mail_address', null, null, 
		//sunhy end 2009/05/21 modify for YBR-32
											array(
												"User : users" => array("User.id = Mail.user_id"),
											));
		if(!empty($mail)){
			$mail = set :: extract($mail, '{n}.Mail.mail_address');
		}
		$this->set('mail', $mail);
		
		
		//sunhy start 2009/05/21 modify for YBR-32
		//$criteria = array('Grpalt.group_id = ' . $usergroup, 'Grpalt.type = 4');
		$criteria = array('Grpalt.group_id = ' . $groupId, 'Grpalt.type = 4');
		//sunhy end 2009/05/21 modify for YBR-32
		$grpalts = $this->Grpalt->find($criteria);
		//xinw start 20090203
		//modify for ASP4-031
		/*if(empty($grpalts)){
			$this->alert_group_init();
			$grpalts = $this->Grpalt->find($criteria);
		}*/
		if (empty($grpalts) && $do=='nodo') {
		}else 
		{
			//sunhy     start      2009/07/15   modify for YBR-41
			//$this->alert_group_init();
			//sunhy     end      2009/07/15   modify for YBR-41
			//sunhy start 2009/03/28 modify for JLN-001
			//$grpalts = $this->Grpalt->find($criteria);
			$grpalts = $this->MailPopupController->getMailPop('Grpalt', $criteria);
			//sunhy end 2009/03/28 modify for JLN-001
		}
		//xinw end 20090203
		//sunhy start 2009/05/21 modify for YBR-32
		//$mailtitle = $this->Title->find("Title.type = 4");
		$mailtitle = $this->Title->find("Title.type = 4 and group_id=".$groupId);
		//sunhy end 2009/05/21 modify for YBR-32
		
		//sunhy start 2009/03/28 modify for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		if($mailtitle['Title']['title_flg'] == 0){
			$this->data['Title']['title_flg'] = 1;
		}
		else {
			$this->data['Title']['title_flg'] = 0;
		}
		//sunhy end 2009/05/21 modify for YBR-32
		//$altmsg = $this->Altmsg->find("Altmsg.message_id = 'E0004'");
		//sunhy start 2009/05/21 modify for YBR-32
		//$altmsg = $this->MailPopupController->getAltMsg('E0004');
		$altmsg = $this->MailPopupController->getAltMsg('E0004', $groupId);
		if($altmsg['Altmsg']['detail_flg']== 0){
			$this->data['Altmsg']['detail_flg'] = 0;
		}
		else {
			$this->data['Altmsg']['detail_flg'] = 1;
		}
		if($altmsg['Altmsg']['detail_flg']== ""){
			$this->data['Altmsg']['detail_flg'] = 1;
		}
		$this->data['Altmsg']['message'] = empty($altmsg['Altmsg']['message']) ? __('E0004',$return = true) : $altmsg['Altmsg']['message'];
		//sunhy end 2009/05/21 modify for YBR-32
		//sunhy end 2009/03/28 modify for JLN-001
//		debug($grpalts, true);
		$this->set('grpalts', $grpalts);
		$this->set('mailtitle', $mailtitle);
		$this->set('altmsg', $altmsg);
		$this->isAdmin();
	}
	
	function alert_group_update()
	{
		$this->layout = 'ajax';
		$tocheck = array(
//										"grpaltInherit" => array('head' => 'same to the parent'),
										"maxStr" => array('head' => 'popup', 'max' => 2000, 'data' => @$this->data['Altmsg']['message'] ),
										"emptyStr" => array('head' => 'popup', 'data' => @$this->data['Altmsg']['message'] ),

						);
		if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
			$tocheck["notSelected"] = array('head' => 'hour', 'data' => @$this->data['Grpalt']['mail_notice_time_hour']);
		}
		$hasError = $this->_setEmsg($tocheck);
		if($hasError){
			$this->alert_group($this->data['Grpalt']['group_id']);
			$this->render("alert_group");
			exit;
		}
//		$this->data['Grpalt']['up_cast'] =intval(! $this->data['Grpalt']['up_cast']);
		$this->data['Grpalt']['receive'] =intval(! $this->data['Grpalt']['receive']);
		@ $hour = $this->data['Grpalt']['mail_notice_time_hour'];
		empty($hour) ? null : $this->data['Grpalt']['mail_notice_time'] = "" . $hour . ":00" . ":00";
		$this->data['Grpalt']['type'] = 4;
		
		if(isset($this->data['Title']['title_flg'])){
			$this->data['Title']['title_flg'] =intval(! $this->data['Title']['title_flg']);
		}
		$this->data['Title']['type'] = 4;
		//sunhy start 2009/05/21 added for YBR-32
		$this->data['Title']['group_id'] = $this->data['Grpalt']['group_id'];
		//sunhy end 2009/05/21 added for YBR-32
		
		//sunhy start 2009/0328 modify for JLN-001
		/*if(isset($this->data['Altmsg']['detail_flg'])){
			$this->data['Altmsg']['detail_flg'] =intval(! $this->data['Altmsg']['detail_flg']);
		}*/
		//sunhy start 2009/05/22 modify for YBR-32
		//$this->data['Altmsg']['detail_flg'] == 1 ? 0:1;
		$this->data['Altmsg']['detail_flg'] = $this->data['Altmsg']['detail_flg'] == 1 ? 0:1;
		//sunhy end 2009/05/22 modify for YBR-32
		//sunhy end 2009/0328 modify for JLN-001
		$this->data['Altmsg']['message_id'] = "E0004";
		//sunhy start 2009/05/21 added for YBR-32
		$this->data['Altmsg']['group_id'] = $this->data['Grpalt']['group_id'];
		//sunhy end 2009/05/21 added for YBR-32
		
		$this->addModel("Mail", "Title", "Altmsg");
		$this->Grpalt->save($this->data['Grpalt']);
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->Title->save($this->data['Title']);
		$condition =" Title.type=4 and Title.id !=0 and group_id=".$this->data['Grpalt']['group_id'];
		$title = $this->Title->findAll($condition);
		if(count($title) == 1){
			$flag = $title[0]['Title']['id'];
		}else{
			$flag =2;
		}
		if ($flag==2) {
			$inserttitle=Array(
			'Title' => Array(
			'title_flg' => $this->data['Title']['title_flg'],
			'type' => 4,
			'group_id'=> $this->data['Title']['group_id'],
			));
			$this->Title->save($inserttitle);
		}else
		{
			$inserttitle=Array(
			'Title' => Array(
			'id'=>$flag,
			'title_flg' => $this->data['Title']['title_flg'],
			'type' => 4,
			'group_id'=> $this->data['Title']['group_id'],
			));
			$this->Title->save($inserttitle);
		}
		
		//$this->Altmsg->save($this->data['Altmsg']);
		$altmsg = $this->MailPopupController->getAltMsg('E0004', $this->data['Grpalt']['group_id']);
		if(count($altmsg) == 1){
			$flag_msg = $altmsg["Altmsg"]["id"];
		}else{
			$flag_msg = 2;
		}
		if ($flag_msg==2) {
			$this->MailPopupController->setAltMsg('E0004', $this->data['Altmsg']['message'], $this->data['Altmsg']['detail_flg'], null, $this->data['Altmsg']['group_id']);
		}else
		{
			$this->MailPopupController->setAltMsg('E0004', $this->data['Altmsg']['message'], $this->data['Altmsg']['detail_flg'], $flag_msg, $this->data['Altmsg']['group_id']);
		}
		//sunhy end 2009/05/21 modify for YBR-32
		
//		$this->GenerateFiles->hook_by_group($this->data['Grpalt']['group_id'], array("device"));///changed by wzy at 20071026
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("device", "popup"));
		$this->GenerateFiles->hook_by_group($this->data['Grpalt']['group_id'], array("device", "popup"));
		//sunhy end 2009/05/21 modify for YBR-32
		$this->alert_list();
		$this->render('alert_list');
	}
	
	/**
	 * アラート送信方法存在かどうかをチェック
	 *
	 * @param array $groups
	 */
	function alert_group_isexist($groups)
	{
		if(!is_array($groups)){
			return;
		}
		$criteria = array('Grpalt.group_id in (' . implode(",", $groups) . ')' , 'Grpalt.type = 4');
		//sunhy start 2009/03/05 modify for JLN-001
		//$grpalts = $this->Grpalt->find($criteria);
		$grpalts = $this->MailPopupController->getMailPop('Grpalt', $criteria);
		//sunhy end 2009/03/05 modify for JLN-001
		if(empty($grpalts)){
			return false;
		}
		else {
			return true;
		}
	}
	/**
	 * グループ送信方式の初期化


	 *
	 */
	function alert_group_init()
	{
		
		//sunhy start 2009/03/28 modify for JLN-001
		/*$data = array();
		$data['Grpalt']['group_id'] = $this->data['Group']['id'];
		$data['Grpalt']['mail_notice_time'] = NULL;
		$data['Grpalt']['popup'] = 0;
		$data['Grpalt']['mail_notice'] = 1;
		$data['Grpalt']['receive'] = 1;
		$data['Grpalt']['up_cast'] = 1;
		$data['Grpalt']['type'] = 4;
		$this->Grpalt->save($data['Grpalt']);
		
		//		$this->GenerateFiles->hook_by_group(1, "popup");///////changed by wzy at 20071026*/
		
		if(empty($this->data['Group']['id'])){
			$this->MailPopupController->setMailPop(null, $this->data['Group']['id'], 1, '00:00:00', 0, 1, 1, 4, 'Grpalt');
		}
		else{
			$grpalt_id = $this->grpalt_list_id($this->data['Group']['id']);
			$this->MailPopupController->setMailPop($grpalt_id, $this->data['Group']['id'], 1, '00:00:00', 0, 1, 1, 4, 'Grpalt');
		}
		
		//sunhy end 2009/03/28 modify for JLN-001
		//sunhy start 2009/05/21 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("device", "popup"));
		// yzl start 2009/07/06 modify for JL-0032
		//$this->GenerateFiles->hook_by_group($this->data['Group']['id'], array("device", "popup"));
		// yzl end 2009/07/06 modify for JL-0032
		//sunhy end 2009/05/21 modify for YBR-32
		
		return ;
	}
	
	//sunhy start 2009/03/28 added for JLN-001
	function grpalt_list_id($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=4";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalt"]["id"];
		}else{
			$id =null;
		}
		return $id;
	}
	//sunhy end 2009/03/28 added for JLN-001

/////////////////////////////////////////////////////////////////////////////////////////////////////////
////共通方法


/////////////////////////////////////////////////////////////////////////////////////////////////////////   
	/**
	 *登録ユーザ属するグループ取得


	 *
	 * @return ユーザのグループID　Group.id
	 */
//    function _getUserGroup()
//    {
//    	$usergroup = 1;///////////////////Sessionから
//    	return $usergroup;
//    }
    
    /**
     * グループリスト取得


     *Viewの$glist=array(Group.id=>Group.group_name)
     */
    function _setGlist()
    {
    	$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
//		$glist[NULL] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist', $glist);
    }
    
    function _setParents($withSelf = false, $forUser = true)
    {
    	$parents = $this->Grpauth->getParentsByChild($this->_getEffectGroup($forUser)); ///////拡張機能
//		$parents = $this->Grpauth->getParentsByChild($this->_getUserGroup());
		if(!$withSelf){
			unset($parents[$this->_getEffectGroup()]);
//			unset($parents[$this->_getUserGroup()]);
		}
		if(!empty($parents)){
			$parents = array_keys($parents);
			$this->set('parents', $parents);
		}
    }
    
    function _setEffectGlist($noChildren = false)
    {
		//$glist_p = $this->Grpauth->getParentsByChild($this->_getEffectGroup());	///////拡張機能
//    	$glist = $this->Grpauth->getParentsByChild($this->_getUserGroup());
		$glist = $this->Grpauth->getParentsByChild($this->_getEffectGroup());
	    if(!$noChildren){
//	    	$glist_c = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
	    	$glist_c = $this->Grpauth->getChildrenByParent($this->_getEffectGroup());
	    	unset($glist_c[$this->_getEffectGroup()]);
	    		$glist = $glist + $glist_c;
	    }
		$this->set('effectGlist', $effectGlist = $glist);
    }
    
    function _setTypelist()
    {
    	$typelist = $this->Devicetype->generateList(null, null, null, '{n}.Devicetype.id', "{n}.Devicetype.device_type_name", null);
    	$this->set('typelist', $typelist);
    }
    
    function _setByExtract($to, $from, $groupby1, $groupby2)
    {
    	if(empty($from) || empty($to) || empty($groupby1) || empty($groupby2)){
    		return false;
    	}
		
    	$this->set('num_' . $to, count($from));
    	
		$keys = set :: extract($from, $groupby2);
		$vals = $from;

			$out = array();
				$group = Set::extract($from, $groupby1);
				if (!empty($group)) {
					$c = count($keys);
					for ($i = 0; $i < $c; $i++) {
						if(!isset($group[$i])) {
							$group[$i] = 0;
						}
						if (!isset($out[$group[$i]])) {
							$out[$group[$i]] = array();
						}
						$out[$group[$i]][$keys[$i]] = $vals[$i];
					}
				}
				else {
					return false;
				}
		$this->set($to, $out);
		return true;
    }
    
    function _getEffectGroup($useLogin = false)
    {
    	if(!empty($this->data['Group']['id']) && !$useLogin){
			$effectGroup =$this->data['Group']['id'];
		}
		else {
			$effectGroup = $this->_getUserGroup();
		}
		return $effectGroup;
    }
    
    function _getGroupsToSet()
    {
    	if(empty($this->data['Group']['id'])){
			$groups = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
			$groups = array_keys($groups);
		}
		else {
			$groups = $this->Grpauth->getChildrenByParent($this->data['Group']['id']);
			$groups = array_keys($groups);
		}
		return $groups;
    }

/////////////////////////////////////////////////////////////////////////////////////////////////////////
////ERROR Handler
/////////////////////////////////////////////////////////////////////////////////////////////////////////     
    function _setEmsg($func, $target = null)
    {
    	$hasError = false;
    	$errorMessage = array();
    	if(empty($func) || !is_array($func)){
    		return false;
    	}
    	else {
    		foreach ($func as $k => $v){
    			if(strpos($k, ".")){
    				list($k) = explode(".", $k);
    			}
    			$toexec = "_getEmsg_" . $k; 
    			$eMsg = $this->$toexec($v);
    			if(!empty($eMsg)){
    				$hasError = true;
    				$errorMessage[] = "<p>" . $eMsg . "</p>";
    			}
    		}
    	}
    	if(!empty($errorMessage)){
			if(is_null($target))
				$this->set('errorMessage', $errorMessage);
			else
				$this->set($target, $errorMessage);
    	}
    	return $hasError;
    }

    function _getEmsg_notSelected($check)
    {
    	$errorId = "E-00200";
    	if(is_array($check['data'])){
    		foreach($check['data'] as $v){
    			if(!empty($v)){
    				return ;
    			}
    		}
    		return __($check['head'], true) . "　" . __($errorId, true);
    	}
    	else if(empty($check['data'])){
    		//xushanning start 2009/04/22   modify for LogvillageChinese
    		//return __($check['head'], true) . "　" . __($errorId, true);
    		return __('entry', true) . "　" . __($errorId, true);
    		//xushanning end 2009/04/22   modify for LogvillageChinese
    	}
    	else return;
    }
    
    function _getEmsg_maxStr($check)
    {
    	$errorId = "E-00300";
    	if(strlen($check['data']) > $check['max'])
    	{
    		return __($check['head'], true) . "　" . __($errorId, true);
    	}
    	else return ;
    }
    
    function _getEmsg_emptyStr($check)
    {
    	$errorId = "E-00100";
    	if(empty($check['data']))
    	{
//start sawaki 20091113 modify for ポップアップを表示させない。
    		//return __($check['head'], true) . "　" . __($errorId, true);
		return;
//end sawaki 20091113 modify for ポップアップを表示させない。
    	}
    	else return ;
    }
    
	function _getEmsg_emptyStr2($check)
    {
    	$errorId = "E-00100";
    	if(empty($check['data']))
    	{
    		return __($check['head'], true) . "　" . __($errorId, true);
    	}
    	else return ;
    }
	
	function _getEmsg_empty($check)
    {
    	$errorId = "E-00100";
    	if(empty($check['data']))
    	{
    		return __($check['head'], true) . "　" . __($errorId, true);
    	}
    	else return ;
    }
	
//    function _getEmsg_grpaltInherit($check)
//    {
//    	$errorId = "parent alerts not seted";
//    	
//    	if($this->data['Grpalt']['up_cast'] == 1){
//	    	$canInherit = $this->Group->getFatherSet($this->data['Grpalt']['group_id'],$this->Grpalt,4);
//	    	if($canInherit == 0){
//	    		return __($check['head'], true) . "　" . __($errorId, true);
//	    	}
//    	}
//    	return ;
//    }
    
    function _getEmsg_delGrpaltInherit($check)
    {
    	$errorId = "Have inherited alerts. Please delete them.";
    	
    	if(is_array($this->data['Group']['id'])){
    		foreach($this->data['Group']['id'] as $v){
    			$grpalts = $this->Grpalt->findByAsso(array("Grpalt.type = 4", "Grpalt.up_cast = 0", "Group.parent_id = " . $v , "Group.id NOT IN (" . implode(",", $this->data['Group']['id']) . ") "), array("Grpalt.id"), null,null,null, array("Group : groups" => array("Group.id = Grpalt.group_id")));
    			
    			if( !empty($grpalts)){
    				return __($check['head'], true) . "　" . __($errorId, true);
    			}
    		}
    	}
    	return ;
    }
    
    function _getEmsg_addGrpaltdvctyp($check)
    {
    	//alert check 1
    	$errorId = "Child groups have the same alert seted, please delete the alerts first.";
    	
    	if(!isset($this->data['Devicetype']['id']) || !is_array($this->data['Devicetype']['id'])){
    		return ;
    	}
    	
		$effectGroup = $this->_getEffectGroup();
		$field = array('Grpaltdvctyp.id',);
		$criteria = array(	
			"Devicetype.id IN ( " . implode(",", $this->data['Devicetype']['id']) . " )",
			//選択グループ下位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定


		$asso = array("Group : groups" => array("Group.id = Grpaltdvctyp.group_id"), "Devicetype : devicetypes" => array("Devicetype.id = Grpaltdvctyp.device_type_id"), );
		$data = $this->Grpaltdvctyp->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		
		//alert check 2
		$errorId = "Have same alerts. Please delete them.";
		$field = array('Grpaltdvc.id',);
		$criteria = array(
			"Grpaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc 
				INNER JOIN hosts AS Host ON Optlgcdvc.host_id = Host.id 
				INNER JOIN rlthstgrps AS Rlthstgrp ON Rlthstgrp.host_id = Host.id 
				WHERE Rlthstgrp.group_id = Group.id AND Optlgcdvc.device_type_id IN (" . implode(",", $this->data['Devicetype']['id']) . "))",
			//選択グループ下位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定


		$asso = array("Group : groups" => array("Group.id = Grpaltdvc.group_id"),
				);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		
		
		//alert check 3
		$errorId = "Have same alerts. Please delete them.";
		$field = array('Hstaltdvc.id',);
		$criteria = array(	
			"Hstaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc 
				WHERE Optlgcdvc.device_type_id IN (" . implode(",", $this->data['Devicetype']['id']) . ") 
						AND Optlgcdvc.host_id = Hstaltdvc.host_id)",
			//選択グループ下位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定


		$asso = array(
						"Rlthstgrp : rlthstgrps" => array("Hstaltdvc.host_id = Rlthstgrp.host_id"),
						"Group : groups" => array("Group.id = Rlthstgrp.group_id"),
						);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		return ;
    }
    
    function _getEmsg_addGrpaltdvc($check)
    {
    	//alert check1
    	$errorId = "Child groups have the same alert seted, please delete the alerts first.";
    	
    	if(!isset($this->data['Optlgcdvc']['device_name']) || !is_array($this->data['Optlgcdvc']['device_name'])){
    		return ;
    	}
	//sunhy end 2009/07/01 modify for YBR-34再
    	foreach($this->data['Optlgcdvc']['device_name'] as $v){
		$v = rawurldecode(rawurldecode($v));
		list($deviceTmp, $type_name) = explode('-quote-', $v);
		$deviceName[] = $deviceTmp;
		}
	//sunhy start 2009/07/01 modify for YBR-34再
		$effectGroup = $this->_getEffectGroup();
		$field = array('Grpaltdvc.id',);
		
		foreach($deviceName as $dev)
			$devicecrits[] = "(Grpaltdvc.match_type = 1 and INSTR('{$dev}',Grpaltdvc.device_name) and Grpaltdvc.device_name != '{$dev}')";

		$criteria = array(	
			//sunhy start 2009/07/31 modify for JL-0036
			//"Grpaltdvc.device_name IN ( '" . implode("', '", $this->data['Optlgcdvc']['device_name']) . "' )",
			//"Grpaltdvc.device_name IN ( '" . implode("', '", $deviceName) . "' )",
			"(Grpaltdvc.device_name IN ( '" . implode("', '", $deviceName) . "' )
			or ". implode(" or ", $devicecrits) .")",
			//sunhy end 2009/07/31 modify for JL-0036
			//選択グループ下位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定


		$asso = array("Group : groups" => array("Group.id = Grpaltdvc.group_id"),);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		//alert check 2
		$errorId = "Have same alerts. Please delete them.";
		$field = array('Hstaltdvc.id',);
		
		$devicecrits = array();
		foreach($deviceName as $dev)
			$devicecrits[] = "(Hstaltdvc.match_type = 1 and INSTR('{$dev}',Hstaltdvc.device_name) and Hstaltdvc.device_name != '{$dev}')";
		
		$criteria = array(	
			//sunhy start 2009/07/31 modify for JL-0036
			/*"Hstaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc 
							WHERE
						Optlgcdvc.device_name IN ('" . implode("', '", $this->data['Optlgcdvc']['device_name']) . "') 
						AND Optlgcdvc.host_id = Hstaltdvc.host_id)",*/
			/*"Hstaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc 
							WHERE
						Optlgcdvc.device_name IN ('" . implode("', '", $deviceName) . "') 
						AND Optlgcdvc.host_id = Hstaltdvc.host_id)",*/
			"(Hstaltdvc.device_name IN ( '" . implode("', '", $deviceName) . "' )
			or ". implode(" or ", $devicecrits) .")",
			//sunhy end 2009/07/31 modify for JL-0036
			//選択グループ下位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定


		$asso = array(
						"Rlthstgrp : rlthstgrps" => array("Hstaltdvc.host_id = Rlthstgrp.host_id"),
						"Group : groups" => array("Group.id = Rlthstgrp.group_id"),);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		return ;
    }
	
	function _getEmsg_addGrpaltdvc2($check)
    {
    	//alert check1
    	$errorId = "Child groups have the same alert seted, please delete the alerts first.";	
    	if(!isset($this->data['Optlgcdvc']['input_device_name'])){
    		return "";
    	}

		$deviceName = $this->Lv->spec_char_dbm($this->data['Optlgcdvc']['input_device_name']);
		$check_device_name = $this->data['Optlgcdvc']['check_device_name'];
		$input_device_status = $this->data['Optlgcdvc']['input_device_status'];
			
		$effectGroup = $this->_getEffectGroup();
		$field = array('Grpaltdvc.id',);
		$criteria = array(	
			"(
			({$check_device_name} = 1 and 
				(
					(Grpaltdvc.device_name like '%{$deviceName}%' and Grpaltdvc.device_name != '{$deviceName}' and Grpaltdvc.device_status != {$input_device_status })
					or
					(Grpaltdvc.device_name = '{$deviceName}' and (
						(Grpaltdvc.match_type = 0 and Grpaltdvc.device_status != {$input_device_status} )
						or
						(Grpaltdvc.match_type = 1)
						)
					)
				)
			) 
			or ({$check_device_name} = 0 and Grpaltdvc.device_name = '{$deviceName}')
			or (Grpaltdvc.match_type = 1 and INSTR('{$deviceName}',Grpaltdvc.device_name) and Grpaltdvc.device_name != '{$deviceName}')
			)",
			//選択グループ下位
			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定
		$asso = array("Group : groups" => array("Group.id = Grpaltdvc.group_id"),);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		//alert check 2
		$errorId = "Have same alerts. Please delete them.";
		$field = array('Hstaltdvc.id',);
		$criteria = array(	
			"(
			({$check_device_name} = 1 and 
				(
					(Hstaltdvc.device_name like '%{$deviceName}%' and Hstaltdvc.device_name != '{$deviceName}' and Hstaltdvc.device_status != {$input_device_status })
					or
					(Hstaltdvc.device_name = '{$deviceName}' and (
						(Hstaltdvc.match_type = 0 and Hstaltdvc.device_status != {$input_device_status} )
						or
						(Hstaltdvc.match_type = 1)
						)
					)
				)
			) 
			or ({$check_device_name} = 0 and Hstaltdvc.device_name = '{$deviceName}')
			or (Hstaltdvc.match_type = 1 and INSTR('{$deviceName}',Hstaltdvc.device_name) and Hstaltdvc.device_name != '{$deviceName}')
			)",
			
			//選択グループ下位
			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定
		$asso = array(
						"Rlthstgrp : rlthstgrps" => array("Hstaltdvc.host_id = Rlthstgrp.host_id"),
						"Group : groups" => array("Group.id = Rlthstgrp.group_id"),);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		return ;
    }
    //sunhy start 2009/07/01 modify for YBR-34再
    function _getEmsg_addHstaltdvc($check)
    {
    	//alert check1
    	$errorId = "Child groups have the same alert seted, please delete the alerts first.";
    	if(!isset($this->data['Optlgcdvc']['host_id2device_name']) || !is_array($this->data['Optlgcdvc']['host_id2device_name'])){
    		return ;
    	}
    	foreach($this->data['Optlgcdvc']['host_id2device_name'] as $v){
		$v = rawurldecode(rawurldecode($v));
		list($host_id, $deviceTmp) = explode('-quote-', $v);
		$deviceName[] = $deviceTmp;
	}
    	$effectGroup = $this->_getEffectGroup();
		$field = array('Grpaltdvc.id',);
		
		foreach($deviceName as $dev)
			$devicecrits[] = "(Grpaltdvc.match_type = 1 and INSTR('{$dev}',Grpaltdvc.device_name) and Grpaltdvc.device_name != '{$dev}')";
		$criteria = array(	
			//"Grpaltdvc.device_name IN ( '" . implode("', '", $deviceName) . "' )",
			"(Grpaltdvc.device_name IN ( '" . implode("', '", $deviceName) . "' )
			or ". implode(" or ", $devicecrits) .")",
			//選択グループ下位
			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",
			);
		//関連設定

		//debug($criteria);
		$asso = array("Group : groups" => array("Group.id = Grpaltdvc.group_id"),);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, null, null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		//alert check 2
		$errorId = "Have same alerts. Please delete them.";
		$field = array('Hstaltdvc.id',);
		
		$devicecrits = array();
		foreach($deviceName as $dev)
			$devicecrits[] = "(Hstaltdvc.match_type = 1 and INSTR('{$dev}',Hstaltdvc.device_name) and Hstaltdvc.device_name != '{$dev}')";
		
		$criteria = array(	
			//sunhy start 2009/07/31 modify for JL-0036
			/*"Hstaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc 
							WHERE
						Optlgcdvc.device_name IN ('" . implode("', '", $this->data['Optlgcdvc']['host_id2device_name']) . "') 
						AND Optlgcdvc.host_id = Hstaltdvc.host_id)",*/
			/*"Hstaltdvc.device_name IN (SELECT Optlgcdvc.device_name FROM optlgcdvcs AS Optlgcdvc 
							WHERE
						Optlgcdvc.device_name IN ('" . implode("', '", $deviceName) . "') 
						AND Optlgcdvc.host_id = Hstaltdvc.host_id)",*/
			"(Hstaltdvc.device_name IN ( '" . implode("', '", $deviceName) . "' )
			or ". implode(" or ", $devicecrits) .")",
		
			//sunhy end 2009/07/31 modify for JL-0036
			//選択グループ下位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定


		$asso = array(
						"Rlthstgrp : rlthstgrps" => array("Hstaltdvc.host_id = Rlthstgrp.host_id"),
						"Group : groups" => array("Group.id = Rlthstgrp.group_id"),);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		//return ;
    }
    //sunhy end 2009/07/01 modify for YBR-34再
	function _getEmsg_addHstaltdvc2($check)
    {
		//alert check1
    	$errorId = "Child groups have the same alert seted, please delete the alerts first.";
    	if(!isset($this->data['Hstaltatodvc']['input_device_name'])){
    		return ;
    	}

		$deviceName = $this->Lv->spec_char_dbm($this->data['Hstaltatodvc']['input_device_name']);
		$check_device_name = $this->data['Hstaltatodvc']['check_device_name'];
		$input_device_status = $this->data['Hstaltatodvc']['input_device_status'];
		
    	$effectGroup = $this->_getEffectGroup();
		$field = array('Grpaltdvc.id',);
		$criteria = array(	
			"(
			({$check_device_name} = 1 and 
				(
					(Grpaltdvc.device_name like '%{$deviceName}%' and Grpaltdvc.device_name != '{$deviceName}' and Grpaltdvc.device_status != {$input_device_status })
					or
					(Grpaltdvc.device_name = '{$deviceName}' and (
						(Grpaltdvc.match_type = 0 and Grpaltdvc.device_status != {$input_device_status} )
						or
						(Grpaltdvc.match_type = 1)
						)
					)
				)
			) 
			or ({$check_device_name} = 0 and Grpaltdvc.device_name = '{$deviceName}')
			or (Grpaltdvc.match_type = 1 and INSTR('{$deviceName}',Grpaltdvc.device_name) and Grpaltdvc.device_name != '{$deviceName}')
			)",
			//選択グループ下位
			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",
			);
		//関連設定

		//debug($criteria);
		$asso = array("Group : groups" => array("Group.id = Grpaltdvc.group_id"),);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, null, null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		//alert check 2
		$errorId = "Have same alerts. Please delete them.";
		$field = array('Hstaltdvc.id',);
		$criteria = array(	
			"(
			({$check_device_name} = 1 and 
				(
					(Hstaltdvc.device_name like '%{$deviceName}%' and Hstaltdvc.device_name != '{$deviceName}' and Hstaltdvc.device_status != {$input_device_status })
					or
					(Hstaltdvc.device_name = '{$deviceName}' and (
						(Hstaltdvc.match_type = 0 and Hstaltdvc.device_status != {$input_device_status} )
						or
						(Hstaltdvc.match_type = 1)
						)
					)
				)
			) 
			or ({$check_device_name} = 0 and Hstaltdvc.device_name = '{$deviceName}')
			or (Hstaltdvc.match_type = 1 and INSTR('{$deviceName}',Hstaltdvc.device_name) and Hstaltdvc.device_name != '{$deviceName}')
			)",
			//選択グループ下位
			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ))",);
		//関連設定
		$asso = array(
						"Rlthstgrp : rlthstgrps" => array("Hstaltdvc.host_id = Rlthstgrp.host_id"),
						"Group : groups" => array("Group.id = Rlthstgrp.group_id"),);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		if(!empty($data)){
			return __($check['head'], true) . "　" . __($errorId, true);
		}
		//return ;
    }
/////////////////////////////////////////////////////////////////////////////////////////////////////////
////登録したユーザのグループで上位下位のアラートデータ取得


/////////////////////////////////////////////////////////////////////////////////////////////////////////    
	/**
	 * デバイス種類アラート取得


	 *
	 */
    function _setedAlttypes()
    {
		//$effectGroup = $this->_getEffectGroup();
    	$effectGroup = $this->_getUserGroup();
		$field = array(
					'Group.id', 'Group.group_name', 
					'Grpaltdvctyp.id', 
					'Devicetype.device_type_name', 'Grpaltdvctyp.device_status', 
		);
		
		$criteria = array(	
			//選択グループ下位と上位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ) OR Group.id IN (SELECT Grpauth.org_grp_id FROM grpauths AS Grpauth WHERE Grpauth.group_id = " . $effectGroup . " ))",
			//COUNT(Optlgcdvc.id) のために
			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連	Optlgcdvc -> Host -> Rlthstgrp -> Group
			"Group : groups" => array("Group.id = Grpaltdvctyp.group_id"), 
			//デバイスクラス
			"Devicetype : devicetypes" => array("Devicetype.id = Grpaltdvctyp.device_type_id"), 
		);
		$data = $this->Grpaltdvctyp->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('alttypes', $data, "{n}.Group.group_name", "{n}.Grpaltdvctyp.id");
    }
    /**
     * デバイス名アラート取得


     *
     */
    function _setedAltdevices()
    {
		//$effectGroup = $this->_getEffectGroup();
    	$effectGroup = $this->_getUserGroup();
		$field = array(
					'Group.id', 'Group.group_name', 
					'Grpaltdvc.id', 
					'Grpaltdvc.device_name', 'Grpaltdvc.device_status', 
					'Grpaltdvc.match_type', 
		);
		
		$criteria = array(	
			//選択グループ下位と上位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ) OR Group.id IN (SELECT Grpauth.org_grp_id FROM grpauths AS Grpauth WHERE Grpauth.group_id = " . $effectGroup . " ))",
			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連
			"Group : groups" => array("Group.id = Grpaltdvc.group_id"), 
		);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('altdevices', $data, "{n}.Group.group_name", "{n}.Grpaltdvc.id");
    }
    /**
     * デバイスのホストでアラート取得


     *
     */
    function _setedAlthosts()
    {
		//$effectGroup = $this->_getEffectGroup();
    	$effectGroup = $this->_getUserGroup();
		$field = array(
					'Group.id', 'Group.group_name', 
					'Hstaltdvc.device_name', 
					'Host.host_name', 
					'Hstaltdvc.device_status', 
					'Hstaltdvc.id', 
					'Hstaltdvc.match_type', 
		);
		
		$criteria = array( 
			//選択グループ下位と上位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . " ) 
				OR Group.id IN (SELECT Grpauth.org_grp_id FROM grpauths AS Grpauth WHERE Grpauth.group_id = " . $effectGroup . " ))", 
			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連
			"Host : hosts" => array("Host.id = Hstaltdvc.host_id"), 
			"Rlthstgrp : rlthstgrps" => array("Rlthstgrp.host_id = Host.id"), 
			"Group : groups" => array("Group.id = Rlthstgrp.group_id"), 
		);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('althosts', $data, "{n}.Group.group_name", "{n}.Hstaltdvc.id");
    }
    
    function _setedGrpalt($to)
    {
    	//$effectGroup = $this->_getEffectGroup();
    	$effectGroup = $this->_getUserGroup();
    	if(!is_array($to)){
    		$to = array($to);
    	}
    
		$field = array(
					'Group.id',
					'Group.group_name',
					'Grpalt.up_cast'
		);
		foreach($to as $v){
					$field[] = 'Grpalt.' . $v;
		}
		
		$criteria = array( 
			//選択グループ下位と上位


			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $effectGroup . ") 
			OR Group.id IN (SELECT Grpauth.org_grp_id FROM grpauths AS Grpauth WHERE Grpauth.group_id = " . $effectGroup . " ))", 
			"Grpalt.type = 4",
			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連
			"Group : groups" => array("Group.id = Grpalt.group_id"), 
		);
		$data = $this->Grpalt->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		
		$data = $this->trans_g($data);
//		$this->_setByExtract('grpalts_' . $to, $data, "{n}.Group.group_name", "{n}.Grpalt.{$to}");
		$keys = set :: extract($data, "{n}.Group.group_name");
		foreach ($to as $v){
			if(!empty($data)){
				$values = set :: extract($data, "{n}.Grpalt.{$v}");
				$this->set('grpalts_' . $v, array_combine($keys, $values));
			}
			else {
				$this->set('grpalts_' . $v, array());
			}
		}
    }
    
    /**
     * copyed from system_grpset_alert_service add by Sy
     * changed by wzy
     *
     * @param unknown_type $rs
     * @return unknown
     */
    function trans_g($rs){
		foreach ($rs as $key=>$value){
			//debug($rs);
			if($value['Grpalt']['up_cast']==0){
				$g_id=$this->Group->getFatherSet($value['Group']['id'],$this->Grpalt,4);
				$condition="Grpalt.group_id=$g_id and Grpalt.type=4";
				$rs_u=$this->Grpalt->findAll($condition);
				if(!empty($rs_u)){
					foreach ($rs_u as $rs_t){
						$rs[$key]['Grpalt']['mail_notice_time']=$rs_t['Grpalt']['mail_notice_time'];
						$rs[$key]['Grpalt']['popup'] =$rs_t['Grpalt']['popup'];
						$rs[$key]['Grpalt']['mail_notice'] =$rs_t['Grpalt']['mail_notice'];
						$rs[$key]['Grpalt']['receive'] =$rs_t['Grpalt']['receive'];
					}
				}
			}
		}
		return	$rs;
	}
    
/////////////////////////////////////////////////////////////////////////////////////////////////////////
////単グループでアラートデータ<上位から継承(Inheritance)とグループ自身セット>取得、


/////////////////////////////////////////////////////////////////////////////////////////////////////////
    /**
     * デバイス種類アラート


     *
     */
	function _setedTypesInherit()
    {
		$field = array(
					'Group.id', 'Group.group_name', 
					'Rltgrpaltdvctyp.org_grp_id ', 
					'Grpaltdvctyp.group_id', 
					'Grpaltdvctyp.id', 
					'Devicetype.device_type_name', 'Grpaltdvctyp.device_status', 
		);
		
		$criteria = array( 
			//選択グループ以下 
//			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $this->_getEffectGroup() . "))", 
			"(Group.id  = " . $this->_getEffectGroup() . ")", 
			//COUNT(Optlgcdvc.id) のために 
			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連Grpaltdvctyp->Rlt->Group
			"Rltgrpaltdvctyp : rltgrpaltdvctyps" => array("Rltgrpaltdvctyp.alert_id = Grpaltdvctyp.id"), 
			"Group : groups" => array("Group.id = Rltgrpaltdvctyp.group_id"), 
			//デバイスクラス
			"Devicetype : devicetypes" => array("Devicetype.id = Grpaltdvctyp.device_type_id"), 
		);
		$data = $this->Grpaltdvctyp->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('grpalttypes', $data, "{n}.Grpaltdvctyp.group_id", "{n}.Grpaltdvctyp.id");
    }
    /**
     * デバイス名アラート


     *
     */
    function _setedDevicesInherit()
    {
		$field = array(
					'Group.id', 'Group.group_name', 
					'Rltgrpaltdvc.org_grp_id ', 
					'Grpaltdvc.group_id', 
					'Grpaltdvc.id', 
					'Grpaltdvc.device_name', 'Grpaltdvc.device_status', 
					'Grpaltdvc.match_type', 
		);
		
		$criteria = array( 
			//選択グループ以下 
//			"(Group.id IN (SELECT Grpauth.group_id FROM grpauths AS Grpauth WHERE Grpauth.org_grp_id = " . $this->_getEffectGroup() . "))", 
			"(Group.id  = " . $this->_getEffectGroup() . ")", 
			//COUNT(Optlgcdvc.id) のために 
			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連Grpaltdvc->Rlt->Group
			"Rltgrpaltdvc : rltgrpaltdvcs" => array("Rltgrpaltdvc.alert_id = Grpaltdvc.id"), 
			"Group : groups" => array("Group.id = Rltgrpaltdvc.group_id"), 
		);
		$data = $this->Grpaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso); 
		$this->_setByExtract('grpaltdevices', $data, "{n}.Grpaltdvc.group_id", "{n}.Grpaltdvc.id"); 
    }
    
    /**
     * ホストでセットアラート


     *
     */
    function _setedHosts()
    {
		$field = array(
					'Group.id', 'Group.group_name', 
					'Hstaltdvc.device_name', 
					'Host.host_name', 
					'Hstaltdvc.device_status', 
					'Hstaltdvc.id', 
					'Hstaltdvc.match_type', 
		);
		
		$criteria = array( 
		
			//選択グループと上位


			"(Group.id IN (SELECT Grpauth.org_grp_id FROM grpauths AS Grpauth WHERE Grpauth.group_id = " . $this->_getEffectGroup() . "))",////グループ下位の全部ホスト


//			"(Group.id = " . $this->_getEffectGroup() . ")",//このグループだけ



			'GROUP BY' => implode(', ', $field), 
		);
		//関連設定


		$asso = array(
			//グループで関連Hstaltdvc->Host->Rlt->Group
			"Host : hosts" => array("Host.id = Hstaltdvc.host_id"), 
			"Rlthstgrp : rlthstgrps" => array("Rlthstgrp.host_id = Host.id"), 
			"Group : groups" => array("Group.id = Rlthstgrp.group_id"), 
		);
		$data = $this->Hstaltdvc->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('althosts', $data, "{n}.Group.id", "{n}.Hstaltdvc.id");
    }
}
?>