<?php
/*********************************************************************
*@filename 		system_grpset_alert_evtusers_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*            2.0        xinw        2009/02/03   modify for ASP4-031
*            2.0        sunhy             2009/03/28   modify for JLN-001
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy           2009/05/15   modify for YBR-32
*            2.0        yzl        2009/07/06    modify for JL-0032
*            2.0        sunhy           2009/07/15   modify for YBR-41
*            2.0        yzl      2009/07/24    modify for JL-0035
********************************************************************/
class SystemGrpsetAlertEvtusersController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	//sunhy start 2009/03/25 modify for JLN-001
	//var $components = array ('Pagination', 'Lv', 'GenerateFiles');
	var $components = array ('Pagination', 'Lv','GenerateFiles','MailPopupController','AlertPcController');
	//sunhy end 2009/03/25 modify for JLN-001
	var $uses=array('Group', 'Grpauth','Grpalt','Grpaltuser','Rltgrpaltuser','Mail','Title','Altmsg','User','Validation','Poll','Configure');
	var $layout='system';
	function beforeFilter()
	{
		parent::beforeFilter();
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($group = null,$account_name = null)
	{
		$this->pageTitle = __('title',$return = true);
		$own_group_id = $this->_getUserGroup();
		$glist = $this->Group->getChildrenByParent($own_group_id);
		$this->set('glist',$glist);
		$plist = $this->Grpauth->getParentsByChild($own_group_id);
		$flist = array();
		foreach ($plist as $group_id=>$group_name){
			if($group_id <> $own_group_id){
				$flist[$group_id] = $group_name;
			}
		}
		if (!empty($group)){
			$glist = $this->Grpauth->getChildrenByParent($group);
			$flist = array();
		}
		foreach ($flist as $key=>$value){
			$criteria = " Grpalt.type = 3 AND Group.id = $key";
			$grp_alt = $this->Grpalt->findAll($criteria,'Grpalt.mail_notice,Grpalt.mail_notice_time,Grpalt.popup');
			$criteria_user = "Rltgrpaltuser.group_id = $key AND Rltgrpaltuser.org_grp_id = $key";
			$user_alt = $this->Grpaltuser->findAll($criteria_user,'Grpaltuser.account_name');
			$count = count($user_alt);
			if ($count==0){
				$count=1;
			}
			if(!empty($grp_alt)){
				if(empty($user_alt)){
					$undata[$key]['Grpalt']['count'] = $count;
					$undata[$key]['Group']['group_name'] = $value;
					$undata[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
					if($grp_alt[0]['Grpalt']['mail_notice']==2){
						$undata[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
					}
					$undata[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
					$undata[$key]['Grpaltuser'][] = array();
				}
				else{
					foreach ($user_alt as $rule){
						$undata[$key]['Grpalt']['count'] = $count;
						$undata[$key]['Group']['group_name'] = $value;
						$undata[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice']==2){
							$undata[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$undata[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
						$undata[$key]['Grpaltuser'][] = $rule['Grpaltuser'];
					}
				}
			}
		}
		foreach ($glist as $key=>$value){
			$criteria = " Grpalt.type = 3 AND Group.id = $key";
			$grp_alt = $this->Grpalt->findAll($criteria,'Grpalt.mail_notice,Grpalt.mail_notice_time,Grpalt.popup');
			//wangs start 20080202
			//$criteria_user = "Rltgrpaltuser.group_id = $key AND Rltgrpaltuser.org_grp_id = $key AND Grpaltuser.account_name like '%".$account_name."%'";
			$criteria_user = "Rltgrpaltuser.group_id = $key AND Rltgrpaltuser.org_grp_id = $key AND lower(Grpaltuser.account_name) like '%".strtolower($this->Lv->spec_char_like($account_name))."%'";
			//wangs end 20080202
			$user_alt = $this->Grpaltuser->findAll($criteria_user,'Grpaltuser.account_name');
			$count = count($user_alt);
			if ($count==0){
				$count=1;
			}
			if(!empty($grp_alt)){
				if(empty($user_alt)){
					if (empty($account_name)){
						$data[$key]['Grpalt']['count'] = $count;
						$data[$key]['Group']['group_name'] = $value;
						$data[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice']==2){
							$data[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$data[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
						$data[$key]['Grpaltuser'][] = array();
					}
				}
				else{
					foreach ($user_alt as $rule){
						$data[$key]['Grpalt']['count'] = $count;
						$data[$key]['Group']['group_name'] = $value;
						$data[$key]['Grpalt']['mail_notice'] = $grp_alt[0]['Grpalt']['mail_notice'];
						if($grp_alt[0]['Grpalt']['mail_notice']==2){
							$data[$key]['Grpalt']['mail_notice_time'] = $grp_alt[0]['Grpalt']['mail_notice_time'];
						}
						$data[$key]['Grpalt']['popup'] = $grp_alt[0]['Grpalt']['popup'];
						$data[$key]['Grpaltuser'][] = $rule['Grpaltuser'];
					}
				}
			}
		}

		empty($undata)? $undata=array():$undata;
		empty($data)? $data=array():$data;
		$this->set('undata',$undata);
		$this->set('data',$data);
	}
	function delete($jude = null)
	{
		$this->layout = 'ajax';
		if($jude == 1){
			if (empty($_POST['forHideVar'])){
				$hidden_groupid = $this->data['Group']['group'];
				$hidden_account = $this->data['Grpaltuser']['account_name'];
				$hidden = "0&data%5BGroup%5D%5Bgroup%5D=$hidden_groupid&data%5BGrpaltuser%5D%5Baccount_name%5D=$hidden_account&submitToSearch=%E7%B5%9E%E8%BE%BC%E3%81%BF&submitToDelete=%E5%89%8A%E9%99%A4%E3%81%99%E3%82%8B";
				$this->set('forHideVar', $hidden);
			}
			if(isset($this->data['Grpalt']['group_id'])){
				foreach ($this->data['Grpalt']['group_id'] as $group_id){
					$account_name = urldecode($this->data['Grpaltuser']['account_name']);//
					
					//wangs start 20080202
					//$condition_grp = "Rltgrpaltuser.group_id = $group_id AND Rltgrpaltuser.org_grp_id = $group_id AND Grpaltuser.account_name like '%".$account_name."%'";
					$condition_grp = "Rltgrpaltuser.group_id = $group_id AND Rltgrpaltuser.org_grp_id = $group_id AND lower(Grpaltuser.account_name) like '%".strtolower($this->Lv->spec_char_like($account_name))."%'";
					//wangs end 20080202
					$grpapp_id = $this->Grpaltuser->findAll($condition_grp,'Grpaltuser.id');

					$condition_grp_judg = "Rltgrpaltuser.group_id = $group_id AND Rltgrpaltuser.org_grp_id = $group_id";
					$grpapp_id_judg = $this->Grpaltuser->findAll($condition_grp_judg,'Grpaltuser.id');
					foreach ($grpapp_id as $output){
						//$grpapp_del[] = $output['Grpaltuser']['id'];
						$this->Grpaltuser->del($output['Grpaltuser']['id']);
					}
					if ($grpapp_id == $grpapp_id_judg){
						$condition_alt = "Grpalt.group_id = $group_id AND Grpalt.type = 3";
						$grpalt_id = $this->Grpalt->findAll($condition_alt,'Grpalt.id');
						foreach ($grpalt_id as $output){
							//$grpalt_del[] = $output['Grpalt']['id'];
							$this->Grpalt->del($output['Grpalt']['id']);
						}
					}
					
				//sunhy start 2009/05/15 added for YBR-32
				//empty($grpalt_del)?null:$this->Grpalt->del(array($grpalt_del));
				//empty($grpapp_del)?null:$this->Grpaltuser->del(array($grpapp_del));
				// yzl start 2009/07/24 modify for JL-0035
				//$this->GenerateFiles->hook_by_group($group_id, array('account'));
				$this->MailPopupController->delAltMsg("E0003",$group_id);
				$this->MailPopupController->delAltTit("3",$group_id);
				$this->GenerateFiles->hook_by_group($group_id, array('account','popup'));
				// yzl end 2009/07/24 modify for JL-0035
				//sunhy end 2009/05/15 added for YBR-32
				}
				
				//sunhy start 2009/05/15 delete for YBR-32
				//empty($grpalt_del)?null:$this->Grpalt->del(array($grpalt_del));
				//empty($grpapp_del)?null:$this->Grpaltuser->del(array($grpapp_del));
				//$this->GenerateFiles->hook_by_group($this->data['Grpalt']['group_id'], array('account'));
				//sunhy end 2009/05/15 delete for YBR-32
			}
			else{
				//xushanning start 2009/04/22   modify for LogvillageChinese
				//$errorMessage['Group'][] = 'E-00200';
				$errorMessage['entry'][] = 'E-00200';
				//xushanning end 2009/04/22   modify for LogvillageChinese
				$this->set('errorMessage',$errorMessage);
			}
			$this->data['Grpaltuser']['account_name'] = "";
			$this->index($this->data['Group']['group'],$this->data['Grpaltuser']['account_name']);
			$this->render('index');
		}
		if($jude == 2){
			if(isset($this->data['Grpaltuser']['id'])){
				$group_id = $this->data['Group']['group_id'];
				foreach($this->data['Grpaltuser']['id'] as $delid){
					$this->Grpaltuser->del($delid);
				}
				//$this->Grpaltuser->del(array($this->data['Grpaltuser']['id']));
				empty($group_id)?null:$this->GenerateFiles->hook_by_group($group_id, array('account'));
			}
			else{
				$errorMessage_middle['logon_account'][] = 'E-00200';
				$this->set('errorMessage_middle',$errorMessage_middle);
			}
			//xinw start 20090203
			//modify for ASP4-031
			//$this->set_alert();
			if (array_key_exists('logon_account',$errorMessage_middle)) {
				$this->set_alert(null,'nodo1');
			}else
			{
				$this->set_alert();
			}
			//xinw end 20090203
			$this->render('set_alert');
		}
	}
	function set_alert($group_id = null,$judg = null)
	{
		//xinw start 20090203
		//modify for ASP4-031
		if ($group_id=='null') {
			$group_id=null;
		}
		//xinw end 20090203
		$this->layout = 'ajax';
		if (empty($_POST['forHideVar'])&&empty($_POST['forHideVar1'])){
			$hidden_groupid = $this->data['Group']['group'];
			$hidden_account = $this->data['Grpaltuser']['account_name'];
			$hidden = "0&data%5BGroup%5D%5Bgroup%5D=$hidden_groupid&data%5BGrpaltuser%5D%5Baccount_name%5D=$hidden_account&submitToSearch=%E7%B5%9E%E8%BE%BC%E3%81%BF&submitToDelete=%E5%89%8A%E9%99%A4%E3%81%99%E3%82%8B";
			$this->set('forHideVar', $hidden);
		}
		if(empty($group_id)){
			$group_id = $this->data['Group']['group_id'];
		}
		$own_group_id = $this->_getUserGroup();
		$this->set('own_group_id',$own_group_id);
		$condition = "Group.id = $group_id";
		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
		$this->set('group',$group);
		
		//sunhy start 2009/03/28 added for JLN-001
		$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}
		//sunhy end 2009/03/28 added for JLN-001

		$plist = $this->Grpauth->getParentsByChild($group_id);
		$data=array();
		foreach ($plist as $key=>$value){
			$condition = "Rltgrpaltuser.group_id = $key AND Rltgrpaltuser.org_grp_id = $key";
			$grp_act = $this->Grpaltuser->findAll($condition,'Grpaltuser.id,Grpaltuser.account_name,Grpaltuser.consistence','Grpaltuser.id');
			if(!empty($grp_act)){
				if(!isset($this->data['Grpaltuser']['part'])){
					$data[$key] = $grp_act;
					$this->data['Grpaltuser']['part'] = 1;
				}
				else{
					$pass_data = array();
					foreach ($grp_act as $output){
						if (isset($this->data['Grpaltuser']['account_name'.$output['Grpaltuser']['id']])){
							$pass['Grpaltuser']['id'] = $output['Grpaltuser']['id'];
							$pass['Grpaltuser']['account_name'] = $this->data['Grpaltuser']['account_name'.$output['Grpaltuser']['id']];
							$pass['Grpaltuser']['consistence'] = empty($this->data['Grpaltuser']['consistence'.$output['Grpaltuser']['id']])?1:0;
						}else {
							$pass['Grpaltuser']['id'] = $output['Grpaltuser']['id'];
							$pass['Grpaltuser']['account_name'] = $output['Grpaltuser']['account_name'];
							$pass['Grpaltuser']['consistence'] = $output['Grpaltuser']['consistence'];
							if ($judg == 1){
								$this->data['Grpaltuser']['account'] = null;
								$this->data['Grpaltuser']['part'] = 1;
							}
						}
						$pass_data[] = $pass;
					}
					$data[$key] =$pass_data;
				}
			}else{
				$this->data['Grpaltuser']['part'] = 1;
			}
		}
		$this->set('data',$data);

		//sunhy start 2009/05/15 modify for YBR-32
		//$title= $this->Title->find("Title.type = 3");
		$title= $this->Title->find("Title.type = 3 and Title.group_id = ".$group_id);
		//$title= $this->Title->find("Title.type = 3 and Title.group_id = ".$this->_getUserGroup());
		if($title && !empty($title)){
		//sunhy end 2009/05/15 modify for YBR-32
		if (!isset($this->data['Title']['id'])){
			if($title['Title']['title_flg'] == 0){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = 0;
			}
		}
		$this->data['Title']['id'] = $title['Title']['id'];
		//sunhy start 2009/05/15 modify for YBR-32
		}else{
			$this->data['Title']['title_flg'] = 1;
			$maxtitid = $this->Title->findAll(null,array('max(id) as Title__maxid'));
			$this->data['Title']['id'] = $maxtitid[0]['Title']['maxid'] + 1;
		}
		//sunhy end 2009/05/15 modify for YBR-32
		//sunhy start 2009/05/15 modify for YBR-32
		//$msg= $this->Altmsg->find("Altmsg.message_id = 'E0003'");
		$msg= $this->Altmsg->find("Altmsg.message_id = 'E0003' and Altmsg.group_id = ".$group_id);
		if($msg && !empty($msg)){
		//sunhy end 2009/05/15 modify for YBR-32
		if (!isset($this->data['Altmsg']['id'])){
			//sunhy start 2009/03/28 modify for JLN-001
			/*if($msg['Altmsg']['detail_flg'] == 0){
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			else {
				$this->data['Altmsg']['detail_flg'] = 0;
			}*/
			if($msg['Altmsg']['detail_flg'] == 0){
				$this->data['Altmsg']['detail_flg'] = 0;
			}else{
				$this->data['Altmsg']['detail_flg'] = 1;
			}
			//sunhy end 2009/03/28 modify for JLN-001
			$this->data['Altmsg']['message'] = $msg['Altmsg']['message'];
		}
		$this->data['Altmsg']['id'] = $msg['Altmsg']['id'];
		//sunhy start 2009/05/15 modify for YBR-32
		}else{
			$this->data['Altmsg']['detail_flg'] = 1;
			$this->data['Altmsg']['message'] = __('E0003',$return = true);
			$maxmsgid = $this->Altmsg->findAll(null,array('max(id) as Altmsg__maxid'));
			$this->data['Altmsg']['id'] = $maxmsgid[0]['Altmsg']['maxid'] + 1;
		}
		//sunhy end 2009/05/15 modify for YBR-32
		$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 3";
		$value = $this->Grpalt->find($condition);
		if($value){
			if (!isset($this->data['Grpalt']['id'])){
				$this->data['Grpalt']['mail_notice'] = $value['Grpalt']['mail_notice'];
				$this->data['Grpalt']['mail_notice_time'] = $value['Grpalt']['mail_notice_time'];
				$this->data['Grpalt']['popup'] = $value['Grpalt']['popup'];
				if($value['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}
			}
			$this->data['Grpalt']['id'] = $value['Grpalt']['id'];
		}
		else{
			//sunhy start 2009/03/28 modify for JLN-001
			/*$add = array(
			'Grpalt' => array(
			'group_id' => $group_id,
			'mail_notice' => 1,
			'mail_notice_time' => '00:00:00',
			'receive' => 1,
			'popup' => 0,
			'type' => 3,
			)
			);*/
			//sunhy end 2009/03/28 modify for JLN-001
			//xinw start 20090203
			//modify for ASP4-031
			//$this->Grpalt->save($add);
			$judge=$this->Grpalt->findAll(array('Grpalt.group_id='.$group_id,'Grpalt.type=3'));
			if (empty($judge) && ($judg=='nodo' || $judg=='nodo1')) {
				$this->data['Grpalt']['mail_notice']=1;
			}else
			{
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->Grpalt->save($add);
				
				//sunhy start 2009/07/17 modify for YBR-41
				if(!$this->Validation->maxLength($this->data['Altmsg']['message'],2000)){
						$errorMessage['popup_info'][] = 'E-00300';
				}
				if(isset($errorMessage)){
					
				}
				else{
					$this->MailPopupController->setMailPop(null, $group_id, 1, '00:00:00', 0, null, 1, 3, 'Grpalt');
				}
				//sunhy end 2009/07/17 modify for YBR-41
				//sunhy end 2009/03/28 modify for JLN-001
			}
			//xinw end 20090203
			$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 3";
			$value_1 = $this->Grpalt->find($condition);
			if($value_1){
				$this->data['Grpalt']['id'] = $value_1['Grpalt']['id'];
				$this->data['Grpalt']['mail_notice'] = $value_1['Grpalt']['mail_notice'];
				$this->data['Grpalt']['mail_notice_time'] = $value_1['Grpalt']['mail_notice_time'];
				$this->data['Grpalt']['popup'] = $value_1['Grpalt']['popup'];
				if($value_1['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}
			}
		}
		$condition = "User.group_id = $group_id";
		$mail = $this->User->findAll($condition,'Mail.mail_address');
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->set('mail',$mail);
		$this->set('email',$mail);
		//sunhy end 2009/03/28 modify for JLN-001
		if(!$value){
			$group_array[]=$group_id;
			//			$this->GenerateFiles->hook_by_group($group_array, array('account'));
			//			$this->GenerateFiles->hook_by_group(1, array('popup'));
			//sunhy start 2009/05/15 modify for YBR-32
			//$this->GenerateFiles->hook_by_ps(0, array("account", "popup"));
			// yzl start 2009/07/06 modify for JL-0032
			//$this->GenerateFiles->hook_by_group($group_id, array("account", "popup"));
			if ($judg != "nodo") {
				$this->GenerateFiles->hook_by_group($group_id, array("account", "popup"));
			}
			// yzl end 2009/07/06 modify for JL-0032
			//sunhy end 2009/05/15 modify for YBR-32
		}
	}
	function none()
	{
		$this->layout = 'ajax';
		$this->index($this->data['Group']['group'],$this->data['Grpaltuser']['account_name']);
		$this->render('index');
	}
	function add_alert()
	{
		$this->layout = 'ajax';
		$own_group_id = $this->_getUserGroup();
		//sunhy start 2009/05/15 modify for YBR-32
		$group_id = $this->data['Group']['group_id'];
		//if($own_group_id == 1){
		//sunhy end 2009/05/15 modify for YBR-32
			if($this->Lv->is_empty($this->data['Altmsg']['message']) || !$this->Validation->maxLength($this->data['Altmsg']['message'],2000)){
				if($this->Lv->is_empty($this->data['Altmsg']['message'])){
					$errorMessage['popup_info'][] = 'E-00100';
				}
				if(!$this->Validation->maxLength($this->data['Altmsg']['message'],2000)){
					$errorMessage['popup_info'][] = 'E-00300';
				}
			}
			if(isset($errorMessage)){
				$this->set('errorMessage',$errorMessage);
				$this->set_alert();
				$this->render('set_alert');
				exit();
			}
			else{
				if($this->data['Grpalt']['mail_notice'] == 2){
					//sunhy start 2009/03/28 modify for JLN-001
					/*$add = array(
					'Grpalt' => array(
					'id' => $this->data['Grpalt']['id'],
					'group_id' => $this->data['Group']['group_id'],
					'mail_notice' => $this->data['Grpalt']['mail_notice'],
					'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
					'receive' => $this->data['Grpalt']['receive']==1?0:1,
					'popup' => $this->data['Grpalt']['popup'],
					'type' => 3,
					)
					);*/
					$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'], $this->data['Grpalt']['mail_notice_time_hour'], $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 3, 'Grpalt');
					//sunhy end 2009/03/28 modify for JLN-001
					$add_title = array(
					'Title' => array(
					'id' => $this->data['Title']['id'],
					'title_flg' => $this->data['Title']['title_flg']==1?0:1,
					'type' => 3,
					//sunhy start 2009/05/15 modify for YBR-32
					'group_id' => $group_id,
					//sunhy end 2009/05/15 modify for YBR-32
					)
					);
					//sunhy start 2009/03/28 modify for JLN-001
					/*$add = array(
					'Grpalt' => array(
					'id' => $this->data['Grpalt']['id'],
					'group_id' => $this->data['Group']['group_id'],
					'mail_notice' => $this->data['Grpalt']['mail_notice'],
					'mail_notice_time' => '00:00:00',
					'receive' => $this->data['Grpalt']['receive']==1?0:1,
					'popup' => $this->data['Grpalt']['popup'],
					'type' => 3,
					)
					);*/
					$detail_flg = $this->data['Altmsg']['detail_flg']==1?0:1;
					//sunhy start 2009/05/15 modify for YBR-32
					//$this->MailPopupController->setAltMsg('E0003', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id']);
					$this->MailPopupController->setAltMsg('E0003', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id'], $group_id);
					//sunhy end 2009/05/15 modify for YBR-32
					//sunhy end 2009/03/28 modify for JLN-001
				}
				else {
					//sunhy start 2009/03/28 modify for JLN-001
					/*$add = array(
					'Grpalt' => array(
					'id' => $this->data['Grpalt']['id'],
					'group_id' => $this->data['Group']['group_id'],
					'mail_notice' => $this->data['Grpalt']['mail_notice'],
					'mail_notice_time' => '00:00:00',
					'receive' => $this->data['Grpalt']['receive']==1?0:1,
					'popup' => $this->data['Grpalt']['popup'],
					'type' => 3,
					)
					);*/
					$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'], '00:00:00', $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 3, 'Grpalt');
					//sunhy end 2009/03/28 modify for JLN-001
					$add_title = array(
					'Title' => array(
					'id' => $this->data['Title']['id'],
					'title_flg' => $this->data['Title']['title_flg']==1?0:1,
					'type' => 3,
					//sunhy start 2009/05/15 modify for YBR-32
					'group_id' => $group_id,
					//sunhy end 2009/05/15 modify for YBR-32
					)
					);
					//sunhy start 2009/03/28 modify for JLN-001
					/*$add_msg = array(
					'Altmsg' => array(
					'id' => $this->data['Altmsg']['id'],
					'message_id' => 'E0003',
					'message' => $this->data['Altmsg']['message'],
					'detail_flg' => $this->data['Altmsg']['detail_flg']==1?0:1,
					)
					);*/
					$detail_flg = $this->data['Altmsg']['detail_flg']==1?0:1;
					//sunhy start 2009/05/15 modify for YBR-32
					//$this->MailPopupController->setAltMsg('E0003', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id']);
					$this->MailPopupController->setAltMsg('E0003', $this->data['Altmsg']['message'], $detail_flg, $this->data['Altmsg']['id'], $group_id);
					//sunhy end 2009/05/15 modify for YBR-32
					//sunhy end 2009/03/28 modify for JLN-001
				}
			}
		//sunhy start 2009/05/15 modify for YBR-32
		//}
		//else{
		//	if($this->data['Grpalt']['mail_notice'] == 2){
				//sunhy start 2009/03/28 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Group']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
				'receive' => $this->data['Grpalt']['receive']==1?0:1,
				'popup' => $this->data['Grpalt']['popup'],
				'type' => 3,
				)
				);*/
				//		$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'],$this->data['Grpalt']['mail_notice_time_hour'], $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 3, 'Grpalt');
				//sunhy end 2009/03/28 modify for JLN-001
		//	}
		//	else {
				//sunhy start 2009/03/28 modify for JLN-001
				/*$add = array(
				'Grpalt' => array(
				'id' => $this->data['Grpalt']['id'],
				'group_id' => $this->data['Group']['group_id'],
				'mail_notice' => $this->data['Grpalt']['mail_notice'],
				'mail_notice_time' => '00:00:00',
				'receive' => $this->data['Grpalt']['receive']==1?0:1,
				'popup' => $this->data['Grpalt']['popup'],
				'type' => 3,
				)
				);*/
				//		$this->MailPopupController->setMailPop($this->data['Grpalt']['id'], $this->data['Group']['group_id'], $this->data['Grpalt']['mail_notice'],'00:00:00', $this->data['Grpalt']['popup'], null, $this->data['Grpalt']['receive']==1?0:1, 3, 'Grpalt');
				//sunhy end 2009/03/28 modify for JLN-001
		//	}
		//}
		//sunhy end 2009/05/15 modify for YBR-32
		//sunhy start 2009/03/28 modify for JLN-001
		//$this->Grpalt->save($add);
		//sunhy end 2009/03/28 modify for JLN-001
		empty($add_title)?null:$this->Title->save($add_title);
		//sunhy start 2009/03/28 modify for JLN-001
		//empty($add_msg)?null:$this->Altmsg->save($add_msg);
		//sunhy end 2009/03/28 modify for JLN-001
		$group = $this->data['Group']['group_id'];
		//    		if ($group <> 1){
		//    			$group_array[]=$group;
		//     			$this->GenerateFiles->hook_by_group($group_array, array('account'));
		//    			$this->GenerateFiles->hook_by_group(1, array('popup'));
		//    		}else{
		//       			$this->GenerateFiles->hook_by_group($group, array('account'));
		//    			$this->GenerateFiles->hook_by_group(1, array('popup'));
		//    		}
		//sunhy start 2009/05/15 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("account", "popup"));
		$this->GenerateFiles->hook_by_group($group_id, array("account", "popup"));
		//sunhy end 2009/05/15 modify for YBR-32
		$this->index($this->data['Group']['group'],$this->data['Grpaltuser']['account_name']);
		$this->render('index');
		exit();
	}
	//xinw start 20090209
	//modify for ASP4-031
	//function account_add()
	function account_add($do=null)
	//xinw end 20090209
	{
		$this->layout = 'ajax';
		$account = $this->data['Grpaltuser']['account'];
		$group_id = $this->data['Group']['group_id'];
		if ($this->Lv->is_empty($account)){
			$errorMessage_middle['logon_account'][] = 'E-00100';
		}
		else{
			$same_name = $this->Grpaltuser->findAll("Grpaltuser.account_name = '".$this->Lv->spec_char_dbm($account)."' and Grpaltuser.group_id = $group_id");
			if (!empty($same_name)){
				$errorMessage_middle['logon_account'][] = 'E-01900';
			}
		}
		if(isset($errorMessage_middle)){
			$this->set('errorMessage_middle',$errorMessage_middle);
			//xinw start 20090209
			//modify for ASP4-031
			//$this->set_alert();
			$this->set_alert(null,$do);
			//xinw end 20090209
			$this->render('set_alert');
		}
		else{
			$add = array(
			'Grpaltuser' => array(
			'group_id' => $group_id,
			'account_name' => $this->Lv->spec_char_dbm($account),
			'consistence' => empty($this->data['Grpaltuser']['part'])?1:0,
			)
			);
			$this->Grpaltuser->save($add);
			$last_id = $this->Grpaltuser->getLastInsertID();
			$children = $this->Grpauth->getChildrenByParent($this->data['Group']['group_id']);
			foreach ($children as $group=>$group_name){
				$rlt_add = array(
				'Rltgrpaltuser' =>array(
				'group_id' => $group,
				'alert_id' => $last_id,
				'org_grp_id' => $group_id,
				)
				);
				$this->Rltgrpaltuser->save($rlt_add);
			}
			$this->GenerateFiles->hook_by_group($group_id, array('account'));
			$this->set_alert($group_id,1);
			$this->render('set_alert');
		}
	}
	function update()
	{
		$this->layout = 'ajax';
		$group_id = $this->data['Group']['group_id'];
		if (!isset($this->data['Grpaltuser']['id'])){
			$errorMessage_middle['logon_account'][] = 'E-00200';
		}
		else{
			$array_id=$this->data['Grpaltuser']['id'];
			foreach ($array_id as $id_first){
				$account_name = $this->data['Grpaltuser']['account_name'.$id_first];
				if ($this->Lv->is_empty($account_name)){
					$error_no=1;
				}
				else {
					$error = array();
					foreach ($array_id as $id_last){
						if ($account_name == $this->data['Grpaltuser']['account_name'.$id_last]){
							$error[]=1;
						}
					}
					$same_name = $this->Grpaltuser->findAll("Grpaltuser.account_name = '".$this->Lv->spec_char_dbm($account_name)."' and Grpaltuser.group_id = $group_id and Grpaltuser.id <> $id_first");
					if (!empty($same_name)){
						$error_same=1;
					}
					if (count($error)>1){
						$error_same=1;
					}
				}
			}
			if(isset($error_no)){
				$errorMessage_middle['logon_account'][] = 'E-00100';
			}
			if(isset($error_same)){
				$errorMessage_middle['logon_account'][] = 'E-01900';
			}
		}
		if (isset($errorMessage_middle)){
			$this->set('errorMessage_middle',$errorMessage_middle);
		}
		else{
			foreach ($array_id as $id){
				$account_name = $this->data['Grpaltuser']['account_name'.$id];
				$add = array(
				'Grpaltuser' => array(
				'id' => $id,
				'group_id' => $group_id,
				'account_name' => $this->Lv->spec_char_dbm($account_name),
				'consistence' => empty($this->data['Grpaltuser']['consistence'.$id])?1:0,
				)
				);
				$this->Grpaltuser->save($add);
			}
			$this->GenerateFiles->hook_by_group($group_id, array('account'));
		}
		//xinw start 20090203
		//modify for ASP4-031
		//$this->set_alert();
		if (array_key_exists('logon_account',$errorMessage_middle)) {
			$this->set_alert(null,'nodo1');
		}else
		{
			$this->set_alert();
		}
		//xinw end 20090203
		$this->render('set_alert');
	}
	function search()
	{
		$this->layout = 'ajax';
		$group_id = $this->data['Group']['group'];
		$account_name = $this->data['Grpaltuser']['account_name'];
		if(!$this->Validation->maxLength($account_name,128)){
			$errorMessage['logon_account'][] = 'E-00300';
		}
		if (isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);
			$this->index();
			$this->render('index');
		}
		else{
			$this->index($group_id,$account_name);
			$this->render('index');
		}
	}
	function findTitleid($title_id = null)
	{
		$title= $this->Title->find("Title.type = 3");
		return $title['Title']['id'];
	}
	function findMsgid($msg_id = null)
	{
		$msg= $this->Altmsg->find("Altmsg.message_id = 'E0003'");
		return $msg['Altmsg']['id'];
	}
}
?>