<?php
class SystemGrpsetAlertFilesController extends AppController
{
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    var $components = array ('Pagination', 'Lv');
    var $uses=array('Grpaltfile','Rltgrpaltfile','Configure','Group','Grpalt','Grpauth','User','Validation','Title');
    var $layout='system'; 
	function beforeFilter()
	{
		//parent::beforeFilter();
		$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
  
    function index(){
    	
    	 
    	 $user_id=$this->_getUserId(); ////////Session から
        $group_id=$this->_getUserGroup(); ///////////Session から
    	  	
    	 $glist = $this->_setEffectGlist();
	 $this->_setParents();		
	 $this->pageTitle =__('title',$return = true); 
	 
	 
	 $glist1 = $this->Grpauth->getChildrenByParent($group_id);
	// $glist2 = $this->Grpauth->getParentsByChild($group_id);
	 ksort($glist1);
	// ksort($glist2);
	 $this->set('glist1',$glist1);
	// $this->set('glist2',$glist2); 
	 $this->set('glist',$glist); 
	 //条件設定	
	$grpalt_type=5;
	$condition="";
		foreach($glist as $key => $value){
		    $condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Grpaltfile.group_id in (".$condition.") ";
		$criteria[]=" Grpalt.group_id in (".$condition.") ";
		$criteria[]=" Grpalt.type = ".$grpalt_type." ";

		
			
	 $this->_setedRuletypes($criteria);
	  $this->_setedRulenames($criteria);	
	$this->_setedRulecontents($criteria);		
		
	
	
	
	$asso= array(
			    'Group : groups' => array('Group.id = Grpaltfile.group_id'),
			    'Grpalt : grpalts' => array('Group.id = Grpalt.group_id'),
										);			    
	$grpaltfiles = $this->Grpaltfile->findByAsso($criteria, array('Group.group_name','Grpaltfile.id','Grpaltfile.group_id','Grpaltfile.rule_name','Grpaltfile.rule_type','Grpaltfile.file_name','Grpaltfile.consistence','Grpaltfile.operation_type','Grpaltfile.extend','Grpaltfile.size','Grpalt.mail_notice'), 'Grpaltfile.group_id', null, null, $asso);		
	empty($grpaltfiles)? $grpaltfiles=array():$grpaltfiles;  	
	$this->set('grpaltfiles',$grpaltfiles);
        $this->set('group_id',$group_id);
      }
   
      
  //////////////////////////////////////////////////////////////////////////////////////////////////////  
    function _setGlist()
    {
    	$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		ksort($glist);
		$this->set('glist', $glist);
    }
     
    function _getEffectGroup()
    {
    	if(!empty($this->data['Group']['id'])){
			$effectGroup =$this->data['Group']['id'];
		}
		else {
			$effectGroup = $this->_getUserGroup();
		}
		return $effectGroup;
    }
    function _setParents($withSelf = false)
    {
		$parents = $this->Grpauth->getParentsByChild($this->_getEffectGroup()); ///////拡張機能
		if(!$withSelf){
			unset($parents[$this->_getEffectGroup()]);
		}
		if(!empty($parents)){
			$parents = array_keys($parents);
			$this->set('parents', $parents);
		}
    }    
    function _setEffectGlist($noChildren = false)
    {
		$glist = $this->Grpauth->getParentsByChild($this->_getEffectGroup());
	    if(!$noChildren){
	    	$glist_c = $this->Grpauth->getChildrenByParent($this->_getEffectGroup());
	    	unset($glist_c[$this->_getEffectGroup()]);
	    		$glist = $glist + $glist_c;
	    }
		$this->set('effectGlist', $effectGlist = $glist);
		return $glist;
    }
    function _setByExtract($to, $from, $groupby1, $groupby2)
    {
    	if(empty($from) || empty($to) || empty($groupby1) || empty($groupby2)){
    		return false;
    	}
		
    	$this->set('num_' . $to, count($from));
    	
		$keys = set :: extract($from, $groupby2);
		$vals = $from;

			$out = array();
				$group = Set::extract($from, $groupby1);
				if (!empty($group)) {
					$c = count($keys);
					for ($i = 0; $i < $c; $i++) {
						if(!isset($group[$i])) {
							$group[$i] = 0;
						}
						if (!isset($out[$group[$i]])) {
							$out[$group[$i]] = array();
						}
						$out[$group[$i]][$keys[$i]][] = $vals[$i];
					}
				}
				else {
					return false;
				}
		$this->set($to, $out);
		return true;
    }    
    function _getGroupsToSet()
    {
    	if(empty($this->data['Group']['id'])){
			$groups = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
			$groups = array_keys($groups);
		}
		else {
			$groups = $this->Grpauth->getChildrenByParent($this->data['Group']['id']);
			$groups = array_keys($groups);
		}
		return $groups;
    }
    

/////////////////////////////////////////////////////////////////////////////////////////////////////////
////登録したユーザのグループで上位下位のアラートデータ取得///////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////    

    function _setedRuletypes($criteria)
    {
    	       	$field = array(
					'Group.id', 'Group.group_name',
					'Grpaltfile.id',					
		);
		$criteria['group by'] = implode(',', $field);
		//関連設定

		$asso = array(
			"Group : groups" => array("Group.id = Grpaltfile.group_id"),
			"Grpalt : grpalts" => array("Group.id = Grpalt.group_id"),
		);
		$data = $this->Grpaltfile->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		//debug($data);
		$this->_setByExtract('ruletypes', $data, "{n}.Group.group_name", "{n}.Grpaltfile.id");
    }
     function _setedRulecontents($criteria)
    {
    	        
		$field = array(
					'Group.id', 'Group.group_name',
					'Grpaltfile.id',
					'Grpaltfile.file_name', 'Grpaltfile.consistence', 'Grpaltfile.extend', 'Grpaltfile.size', 'Grpaltfile.operation_type', 'Grpaltfile.rule_name',
		);
		$criteria['group by'] = implode(',', $field);
		//関連設定

		$asso = array(
			"Group : groups" => array("Group.id = Grpaltfile.group_id"),
			"Grpalt : grpalts" => array("Group.id = Grpalt.group_id"),
		);
		$data = $this->Grpaltfile->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('rulecontents', $data, "{n}.Grpaltfile.rule_name", "{n}.Grpaltfile.id");
    }
     function _setedRulenames($criteria)
    {
		$field = array(
					'Group.id', 'Group.group_name',
					'Grpaltfile.id',
					'Grpaltfile.file_name', 'Grpaltfile.consistence', 'Grpaltfile.extend', 'Grpaltfile.size', 'Grpaltfile.operation_type', 'Grpaltfile.rule_type', 'Grpaltfile.rule_name', 'Grpalt.mail_notice', 'Grpalt.mail_notice_time'
		);
    	        $criteria['group by'] = implode(',', $field);
		//関連設定

		$asso = array(
			"Group : groups" => array("Group.id = Grpaltfile.group_id"),
			"Grpalt : grpalts" => array("Group.id = Grpalt.group_id"),
		);
		$data = $this->Grpaltfile->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->_setByExtract('rulenames', $data, "{n}.Group.group_name", "{n}.Grpaltfile.rule_name");
    }
   function set_alert($group_id = null)
    	{	
    		$this->layout = 'ajax';  		
    		///////////////////////$group_id from the selectTag
    		if(empty($group_id)){
    			$group_id = $this->data['Grpaltfile']['group_id'];
    		}  
    		$own_group_id = $this->_getUserGroup();	
    		$this->set('own_group_id',$own_group_id);
    		$condition = "Group.id = $group_id";
    		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
    		$this->set('group',$group);      
    		if($group_id!=null){    					  	
 		   $criteria[]=" Grpaltfile.group_id = ".$group_id." ";
		   $criteria[]=" Grpalt.group_id = ".$group_id." ";
		   $criteria[]=" Grpalt.type = 5 ";	
	            $this->_setedRuletypes($criteria);
	            $this->_setedRulenames($criteria);	
	            $this->_setedRulecontents($criteria);	 
    		}
    		else{
 	  	 if($this->data["Grpaltfile"]["group_id"]!=null){
 		    $criteria[]=" Grpaltfile.group_id = ".$this->data["Grpaltfile"]["group_id"];
		    $criteria[]=" Grpalt.group_id = ".$this->data["Grpaltfile"]["group_id"];
		    $criteria[]=" Grpalt.type = 5 ";
	             $this->_setedRuletypes($criteria);
	             $this->_setedRulenames($criteria);	
	             $this->_setedRulecontents($criteria); 		
 	  	}
 	        }
    		
    		
		$title= $this->Title->find("Title.type = 5");   	
    		if($title){   
    			$this->data['Title']['id'] = $title['Title']['id'];			
 			if($title['Title']['title_flg'] == 0){
				$this->data['Title']['title_flg'] = 1;
			}
			else {
				$this->data['Title']['title_flg'] = 0;
			}   		
    		}     
    		else {
			$add_title = array(
				'Title' => array(
					'title_flg' => 0,
					'type' => 5,
				)					
			);  
			$this->Title->save($add_title);
			$title_1= $this->Title->find("Title.type = 5");   	
	    		if($title_1){   
	    			$this->data['Title']['id'] = $title_1['Title']['id'];			
	 			if($title_1['Title']['title_flg'] == 0){
					$this->data['Title']['title_flg'] = 1;
				}
				else {
					$this->data['Title']['title_flg'] = 0;
				}   		
	    		} 			
    		}    					
    		$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 5";
    		$value = $this->Grpalt->find($condition);
    		if($value){
    			$this->data['Grpalt']['id'] = $value['Grpalt']['id'];
    			$this->data['Grpalt']['mail_notice'] = $value['Grpalt']['mail_notice'];
    			$this->data['Grpalt']['mail_notice_time'] = $value['Grpalt']['mail_notice_time'];
			if($value['Grpalt']['up_cast'] == 0){
				$this->data['Grpalt']['up_cast'] = 1;												
			}
			else {
				$this->data['Grpalt']['up_cast'] = 0;				
			}  		
			if($value['Grpalt']['receive'] == 0){
				$this->data['Grpalt']['receive'] = 1;
			}
			else {
				$this->data['Grpalt']['receive'] = 0;
			}  								
    		}
    		else{   			
			$add = array(
				'Grpalt' => array(
					'group_id' => $group_id,
					'mail_notice' => 3,
					'mail_notice_time' => 'NULL',
					'receive' => 1,
					'popup' => NULL,
					'up_cast' => 1,
					'type' => 5,
				)					
			);  
			$this->Grpalt->save($add); 	
	    		$condition = "Grpalt.group_id = $group_id AND Grpalt.type = 5";
	    		$value_1 = $this->Grpalt->find($condition);    			
	    		if($value_1){    			
	    			$this->data['Grpalt']['id'] = $value_1['Grpalt']['id'];
	    			$this->data['Grpalt']['mail_notice'] = $value_1['Grpalt']['mail_notice'];
	    			$this->data['Grpalt']['mail_notice_time'] = $value_1['Grpalt']['mail_notice_time'];
				if($value_1['Grpalt']['up_cast'] == 0){
					$this->data['Grpalt']['up_cast'] = 1;												
				}
				else {
					$this->data['Grpalt']['up_cast'] = 0;				
				}  		
				if($value_1['Grpalt']['receive'] == 0){
					$this->data['Grpalt']['receive'] = 1;
				}
				else {
					$this->data['Grpalt']['receive'] = 0;
				}  											
	    		}			
    		}     		
		$condition = "User.group_id = $group_id";   
		$mail = $this->User->findAll($condition,'Mail.mail_address');	
		$this->set('mail',$mail);  
		$this->render('set_alert');     		 
    	}
    	function add_alert()
    	{	
    		$this->layout = 'ajax'; 
     		if($this->data['Grpalt']['up_cast']==0){
    			if($this->data['Grpalt']['mail_notice'] == 2){
    				if(isset($this->data['Title']['title_flg'])){
					$add = array(
						'Grpalt' => array(
							'id' => $this->data['Grpalt']['id'],
							'group_id' => $this->data['Grpaltfile']['group_id'],
							'mail_notice' => $this->data['Grpalt']['mail_notice'],
							'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
							'receive' => $this->data['Grpalt']['receive']==1?0:1,
							'up_cast' => 1,
							'type' => 5,
						)					
					);   
					$add_title = array(
						'Title' => array(
							'id' => $this->data['Title']['id'],
							'title_flg' => $this->data['Title']['title_flg']==1?0:1,
							'type' => 5,
						)					
					);  											
    				}
    				else{
					$add = array(
						'Grpalt' => array(
							'id' => $this->data['Grpalt']['id'],
							'group_id' => $this->data['Grpaltfile']['group_id'],
							'mail_notice' => $this->data['Grpalt']['mail_notice'],
							'mail_notice_time' => $this->data['Grpalt']['mail_notice_time_hour'],
							'receive' => $this->data['Grpalt']['receive']==1?0:1,
							'up_cast' => 1,
							'type' => 5,
						)					
					);   	    					
    				}											
    			}
    			else{
    				if(isset($this->data['Title']['title_flg'])){
	 				$add = array(
						'Grpalt' => array(
							'id' => $this->data['Grpalt']['id'],
							'group_id' => $this->data['Grpaltfile']['group_id'],
							'mail_notice' => $this->data['Grpalt']['mail_notice'],
							'mail_notice_time' => 'NULL',
							'receive' => $this->data['Grpalt']['receive']==1?0:1,
							'up_cast' => 1,
							'type' => 5,
						)					
					); 
					$add_title = array(
						'Title' => array(
							'id' => $this->data['Title']['id'],
							'title_flg' => $this->data['Title']['title_flg']==1?0:1,
							'type' => 5,
						)					
					); 						  	    					
    				}
    				else{
	 				$add = array(
						'Grpalt' => array(
							'id' => $this->data['Grpalt']['id'],
							'group_id' => $this->data['Grpaltfile']['group_id'],
							'mail_notice' => $this->data['Grpalt']['mail_notice'],
							'mail_notice_time' => 'NULL',
							'receive' => $this->data['Grpalt']['receive']==1?0:1,
							'up_cast' => 1,
							'type' => 5,
						)					
					);  	    					
    				}  						  	    									
    			}	    			
    		}
    		else{
    			$parent_id =  $this->_getFatherSet($this->data['Grpaltfile']['group_id']);
    			$grpalt = $this->Grpalt->find("Grpalt.group_id = $parent_id AND Grpalt.type = 5");
    			if($grpalt){
				$add = array(
					'Grpalt' => array(
						'id' => $this->data['Grpalt']['id'],
						'up_cast' => 0,
					)					
				);  	    				
    			}
    			else{
    				$errorMessage['father_rule'][] = "E-01800";
				$this->set('errorMessage',$errorMessage); 
				$this->set_alert();
				exit();  	    				
    			}
    		}   
    		$this->Grpalt->save($add); 	
    		empty($add_title)?null:$this->Title->save($add_title);
    		$this->index();
    		$this->render('index'); 
    		exit(); 	    				
    	}
    	function none()
   	{
   		$this->layout = 'ajax';
   		$this->data = array();
   		$this->index();
   		$this->render('index');  
   	}
   	function set_rule($grpid = null,$rulename = null)
    	{	
    		$this->layout = 'ajax';
    		
      	  //set group_name
      	  if($grpid!=null){	  	
 	        $condition = "Group.id = $grpid";		
 		$group = $this->Group->find($condition,'Group.id,Group.group_name,Group.parent_id');
    		$this->set('group',$group);      
 	   }
 	   //set rule_name
 	   if($rulename==null){	   	
 	   	$rulename =  $this->data["Grpaltfile"]["rule_name"]; 
 	   }      	  	
 	   $this->set('rule_name',$rulename);	  
 	 $criteria[]=" Grpaltfile.group_id = ".$grpid." ";
 	 $criteria[]=" Grpaltfile.rule_name = '".$rulename."' ";
		$criteria[]=" Grpalt.group_id = ".$grpid." ";
		$criteria[]=" Grpalt.type = 5 ";
		$field = array(
					'Group.id', 'Group.group_name',
					'Grpaltfile.id',
					'Grpaltfile.file_name', 'Grpaltfile.consistence', 'Grpaltfile.extend', 'Grpaltfile.size', 'Grpaltfile.operation_type', 'Grpaltfile.rule_type', 'Grpaltfile.rule_name', 'Grpalt.mail_notice', 'Grpalt.mail_notice_time'
		);
    	        $criteria['group by'] = implode(',', $field);
		//関連設定

		$asso = array(
			"Group : groups" => array("Group.id = Grpaltfile.group_id"),
			"Grpalt : grpalts" => array("Group.id = Grpalt.group_id"),
		);
		$data = $this->Grpaltfile->findByAsso($criteria, $field, implode(', ', $field), null, null, $asso);
		$this->set('data',$data);	
	$this->render('set_rule');	  
    	}      		
        function add_rule()
	{
		$this->layout = 'ajax';	
		//echo "===========";
		//echo $this->data['Grpaltfile']['rule'];
		if(empty($this->data['Grpaltfile']['rule_name']) || !$this->Validation->maxLength($this->data['Grpaltfile']['rule_name'],200)){
			if(empty($this->data['Grpaltfile']['rule_name'])){
				$errorMessage['rule_name'][] = 'E-00100';
			}
			if(!$this->Validation->maxLength($this->data['Grpaltfile']['rule_name'],200)){
				$errorMessage['rule_name'][] = 'E-00300';
			}						
		}	
		if(isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);  
		}				
		else{				
			if($this->data['Grpaltfile']['rule']==0){
				$add = array(
					'Grpaltfile' => array(
						'group_id' => $this->data['Grpaltfile']['group_id'],
						'rule_name' => $this->data['Grpaltfile']['update_rule'],
						'file_name' => $this->data['Grpaltfile']['file_name_t'],
						'consistence' => empty($this->data['Grpaltfile']['consistence'])?1:0,
						'rule_type' => 1,
					)					
				);
			}
			if($this->data['Grpaltfile']['rule']==1){
				
			}
			if($this->data['Grpaltfile']['rule']==2){
				
			}
			if($this->data['Grpaltfile']['rule']==3){
				
			}
				$this->Grpaltfile->save($add); 						
				$alert_id = $this->Grpaltfile->getLastInsertID();
				$children = $this->Grpauth->getChildrenByParent($this->data['Grpaltfile']['group_id']);
				foreach ($children as $group_id=>$group_name){
					$rlt_add = array(
						'Rltgrpaltfile' =>array(
							'group_id' => $group_id,
							'alert_id' => $alert_id,
							'org_grp_id' => $this->data['Grpaltfile']['group_id']
						)
					);
					$this->Rltgrpaltfile->save($rlt_add); 	
				}				
			
			if($this->data['Grpaltfile']['rule_name'] <> $this->data['Grpaltfile']['update_rule']){
				$group_id = $this->data['Grpaltfile']['group_id'];
				$condition = "Grpaltfile.rule_name = '".$this->data['Grpaltfile']['update_rule']."' AND Grpaltfile.group_id = $group_id";
				$id = $this->Grpaltfile->findAll($condition,'Grpaltfile.id');	
				foreach ($id as $id){
					$add = array(
						'Grpaltfile' => array(
							'id' => $id['Grpaltfile']['id'],
							'rule_name' => $this->data['Grpaltfile']['rule_name'],
						)					
					);
					$this->Grpaltfile->save($add); 						
				}			
			}			
		}    
		$this->set_rule($this->data['Grpaltfile']['group_id']);
		exit();   		
	}
	function update_rule()
	{
		$this->layout = 'ajax';
		if(empty($this->data['Grpaltfile']['rule_name']) || !$this->Validation->maxLength($this->data['Grpaltfile']['rule_name'],200)){
			if(empty($this->data['Grpaltfile']['rule_name'])){
				$errorMessage['rule_name'][] = 'E-00100';
			}
			if(!$this->Validation->maxLength($this->data['Grpaltfile']['rule_name'],200)){
				$errorMessage['rule_name'][] = 'E-00300';
			}						
		}		
		if(isset($errorMessage)){
			$this->set('errorMessage',$errorMessage);  
			$this->set_rule();
			exit();  			
		}				
		else{	
			if($this->data['Grpaltfile']['rule_name'] <> $this->data['Grpaltfile']['update_rule']){
				$group_id = $this->data['Grpaltfile']['group_id'];
				$condition = "Grpaltfile.rule_name = '".$this->data['Grpaltfile']['update_rule']."' AND Grpaltfile.group_id = $group_id";
				$id = $this->Grpaltfile->findAll($condition,'Grpaltfile.id');	
				foreach ($id as $id){
					$add = array(
						'Grpaltfile' => array(
							'id' => $id['Grpaltfile']['id'],
							'rule_name' => $this->data['Grpaltfile']['rule_name'],
						)					
					);
					$this->Grpaltfile->save($add); 						
				}			
			}
			$this->set_alert();
			exit();   			
		}			
	}
      
      
      
      
      
      //////////////////////////////////////////////////////////////////////////////////////////////
      function findTitleid($title_id = null)
	{
		$title= $this->Title->find("Title.type = 5");
		return $title['Title']['id'];  
	}
	function  _getFatherSet($group_id)
	{				
		 if($group_id !=1){
			$group_father_i = $this->group_father_id($group_id);
			$grpalt_list_flag=$this->grpalt_list_flag($group_father_i);
			if($grpalt_list_flag == 1) {
				$checkbox_flag =$this->getGrpalt_up_cast($group_father_i);
				if($checkbox_flag == 1) {					
					return $group_father_i;					
				}else{
					$result = $this->_getFatherSet($group_father_i);
					return $result;
				}				
			}else{
				$result = $this->_getFatherSet($group_father_i);
				return $result;
			}
		 }else{
			 $id =0;
			 return $id;  		 	
		 }
	}
	function grpalt_list_flag($group_id)
	{
		$condition =" Grpalt.group_id =".$group_id." and type=6 ";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$flag = 1;
		}else{
			$flag = 0;
		}
		return $flag;			
	}	
	function group_father_id($group_id)
	{
			$criteria=" Group.id=".$group_id." ";
			$group_i= $this->Group->findAll($criteria);
			$group_father_i = $group_i[0]["Group"]["parent_id"];
			return $group_father_i;			
	}	
	function getGrpalt_up_cast($group_id)
	{
			$condition =" Grpalt.group_id =".$group_id." and type=6 ";
			$data_group_c =$this->Grpalt->findAll($condition);
			$checkbox_flag =$data_group_c[0]["Grpalt"]["up_cast"];
			return  $checkbox_flag;	
	}	
	function _findOneSun($group_id)
	{
		$criteria=" Group.parent_id=".$group_id." ";
		$son= $this->Group->findAll($criteria);
		if(!empty($son)){
			foreach ($son as $value){
				$id =$value['Group']['id'];
				$grpalt =$this->grpalt_list_flag($id);
				if($grpalt == 1){
					$checkbox_flag =$this->getGrpalt_up_cast($id);
					if($checkbox_flag == 1){
						$array = 1;
					}else {
						$array = 2;
						return $array;
					}
				}else{
					$array = 1;
				}			
			}			
		}
		else {
			$array = 1;
		}
		return $array;  			
	} 
        
  }   
?>