<?php
/*********************************************************************
*@filename system_grpset_alert_vptns_controller.php
*@description SystemGrpsetAlertVptnsController ウィルス対策ソフトの定義ファイル未更新  
*@note 
*@histories  rivision	author		date		comment
*            2.0        sunhy    	  2009/03/24   modify for JLN-001
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*            2.0        sunhy    	  2009/05/22   modify for YBR-32
*            2.0        yzl        2009/07/06    modify for JL-0032
********************************************************************/  
class SystemGrpsetAlertVptnsController extends AppController
{
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    
    //sunhy start 2009/03/04 modify for JLN-001
	//var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $components = array ('Pagination', 'Lv','GenerateFiles' ,'Check','MailPopupController','AlertPcController');
	//sunhy end 2009/03/04 modify for JLN-001
    var $uses=array('Group','Rlthstgrp','Rltgrpapp','Grpapp','Grpauth','Configure','Grpaltvir','Rltgrpaltvir','User','Grpalt','Mail','Validation','Rlthstgrp','Host','Title');
    var $layout='system';
   
	function beforeFilter()
	{
		parent::beforeFilter();
		//$this->Configure->write('debug', 0);
		//$this->Configure->write('debug', 0);
		if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	
	/**
	 *登録ユーザ属するグループ取得

	 *
	 * @return ユーザのグループID　Group.id
	 */    
	function _getUserGroup_id(){
	   return $this->_getUserGroup();
	}	
	
    function index() { 
    	//echo "index<br>"; 
	$this->pageTitle = __('title',$return = true);   
    	$group_id= $this->_getUserGroup_id();
    	//echo "group_id=".$group_id;
		$glist = $this->Group->getChildrenByParent($group_id);
	 	//ksort($glist);
	 	$this->set('glist',$glist);
	 	
	 	/*  条件設定  */
		$criteria[]=" Rltgrpaltvir.group_id =".$group_id." ";

		/*  上位グループのアラート捜索	*/
	  	$data = $this->Rltgrpaltvir->findAll($criteria);
	  	$count = count($data);
	  	if($count == 1) {
	  		
			if(($data[0]["Rltgrpaltvir"]["group_id"] == $data[0]["Rltgrpaltvir"]["org_grp_id"])){
				$group_id = $data[0]["Rltgrpaltvir"]["group_id"];
		  		$this->set('group_only',1);		  	
			}elseif($data[0]["Rltgrpaltvir"]["group_id"] !=$data[0]["Rltgrpaltvir"]["org_grp_id"]){
				$group_id = $data[0]["Rltgrpaltvir"]["org_grp_id"];	 			
		  		$this->set('group_only',3);		  		
			}
			$group_name = $this->groupName($group_id);
			$grpalt_data=$this->grpalt_list($group_id);
			//$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($group_id,9);			
			/*  上位グループの設定を引き継ぐ  */
			/*	 if($checkbox_flag == '0'){
					$group_father_i = $this->group_father_id($group_id);
					$data_father_group_c=$this->grpalt_list($group_father_i);
					if(count($data_father_group_c) ==1){
						$grpalt_data[0]["Grpalt"]["mail_notice"]= $data_father_group_c[0]["Grpalt"]["mail_notice"];
						$grpalt_data[0]["Grpalt"]["mail_notice_time"]= $data_father_group_c[0]["Grpalt"]["mail_notice_time"];
					}				 	
			 }*/
			 				
 			$condition2=" Grpaltvir.group_id =".$group_id." ";
 			$grpaltvir_data = $this->Grpaltvir->findAll($condition2);			
			$this->set('grpalt_data',$grpalt_data);
			$this->set('group_name',$group_name);
			$this->set('grpaltvir_data',$grpaltvir_data);
	  	}elseif ($count == 0){
				foreach($glist as $key => $value){
					$criteria=" Grpaltvir.group_id =".$key." ";
					$data_group_i =$this->Grpaltvir->findAll($criteria);
					//$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($key,9);
						if(count($data_group_i) ==1) {
							$data_group[$key]["Grpaltvir"]= $data_group_i;
							/* 上位グループの引き継ぐ */
/*								if($checkbox_flag == 0){
									$group_father_i = $this->group_father_id($key);
									$data_father_group_c=$this->grpalt_list($group_father_i);
									if(count($data_father_group_c) ==1){
										$data_group[$key]["Grpalt"]= $data_father_group_c;
										$data_group[$key]["Grpalt"][0]["Group"]["group_name"] =$this->groupName($key);
									}else{
										$data_group_c=$this->grpalt_list($key);
										$data_group[$key]["Grpalt"]= $data_group_c;
									}
								}elseif($checkbox_flag == 1){*/
									$data_group_c=$this->grpalt_list($key);
									if(count($data_group_c) ==1){
										$data_group[$key]["Grpalt"]= $data_group_c;
									}
								//}
						}
				}
			empty($data_group) ? null : $this->set('data_group',$data_group);  
	  		$this->set('group_only',2);
	  	}
	  	$this->set('count',$count);
	  	$this->set('group_id',$group_id);	  	
    }
/*    function getGrpalt_up_cast($group_id){
			$condition =" Grpalt.group_id =".$group_id." and type=9 ";
			$data_group_c =$this->Grpalt->findAll($condition);
			$checkbox_flag =$data_group_c[0]["Grpalt"]["up_cast"];
			return  $checkbox_flag;	
    }*/
    function group_father_id($group_id){
    		$criteria=" Group.id=".$group_id." ";
    		$group_i= $this->Group->findAll($criteria);
    		$group_father_i = $group_i[0]["Group"]["parent_id"];
    		return $group_father_i;
    		
    }

    function groupName($group_id){
 			$criteria=" Group.id=".$group_id." ";
			$group_n= $this->Group->findAll($criteria);
			$group_name = $group_n[0]["Group"]["group_name"];
			return $group_name;
			
    }
    function control($depand=null,$father_group){
    		$this->layout='ajax';  		
    		
    		$select_group =$this->data["Grpaltvir"]["group"];
    		
    		//グループ共通設定

			$grpalt=$this->grpalt_list($select_group);
			$this->set('grpalt',$grpalt);
					
/*			$grpalt_up_cast = @$grpalt[0]["Grpalt"]["up_cast"];		
			if($grpalt_up_cast == '1') {
				$up_cast_flag = 1;
			}elseif($grpalt_up_cast == '0'){
				$up_cast_flag = 0;
			}
			$this->set('up_cast_flag',@$up_cast_flag);*/			
			
 		  	$condition =" Rltgrpaltvir.group_id =".$select_group." ";
 		  	$rlt_group = $this->Rltgrpaltvir->findAll($condition);
 		  	
 		  	//設定の場合

 		  	if(count($rlt_group) == 1) {
 		  		//上位グループを設定する

 		  		if($rlt_group[0]["Rltgrpaltvir"]["group_id"] !=$rlt_group[0]["Rltgrpaltvir"]["org_grp_id"]){
					$this->add_list($rlt_group[0]["Rltgrpaltvir"]["org_grp_id"],$rlt_group[0]["Rltgrpaltvir"]["group_id"]);
 		  		    $this->render('add_list');
 		  		    exit();
 		  		//自己グループを設定する(目前グループ)
 		  		}elseif($rlt_group[0]["Rltgrpaltvir"]["group_id"] ==$rlt_group[0]["Rltgrpaltvir"]["org_grp_id"]){
		  			$this->edit($select_group,1);
 		  		}
 		  	}elseif(count($rlt_group) == 0) {
 		  		// 上位グループの設定

 		  		$this->add($select_group,2);
 		  	}
    	
    }
    
    /*
    * 新規登録画面
    */
    function add($father_group=null,$flag=null)
   {   // echo "add<br>";	
   		$group_id = $father_group;
   	    $this->layout='ajax';  
   		$condition =" Group.id =".$father_group." ";  
   		$data_group_name = $this->Group->findAll($condition);
  		$this->set('data_group_name',$data_group_name);
 		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);
		 				
/*		if((isset($this->data["dt_check"]))&&($this->data["dt_check"][0] == '1')){
				/*  上位グループの設定を引き継ぐ  */
			/*$checkbox_flag ='0';
		}else{
			$checkbox_flag ='1';
		}*/
		//2007-08-11 15:21
		$checkbox_flag ='1';
		//2007-08-11 15:21
		$getUserGroup = $this->_getUserGroup_id();
 		if($getUserGroup == 1){
 			$this->set('getUserGroup_flag',0);
 		}elseif	($getUserGroup != 1){
 			$this->set('getUserGroup_flag',1);
 		}
 		
 		$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,9);	  			
		/*  上位グループの設定を引き継ぐ  */			
		if(!isset($this->data["Grpaltvir"]["flag_name"])){			
		 		if($grpalt_f == 1){
		 			$grpalt_r = $this->grpalt_list($group_id);			 			
	 				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
	        		($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';
	    	        $this->set('mail_notice_time_c',$mail_notice_time_c);
	    	        //$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;				 				
		 		}else{
		 			$this->data['Grpalt']['mail_notice'] = 1;
		 			$this->set('mail_notice_time_c','');
		 			//$up_cast_flag = 1;
		 		}
		 				 		
		 		/*  件名管理情報,エラー情報  */
	 			if($getUserGroup == 1){
	 				$title =$this->title_list();
	 				$this->data['Title']['title_flg'] = ($title!=1)?1:0;
	 			}
		}
/*	 	if(!isset($up_cast_flag)){
 			$up_cast_flag = 1;
 		}
		$this->set('up_cast_flag',$up_cast_flag);*/
				
				
  		//新規追加
 		if((isset($this->data["Grpaltvir"]["flag_name"]))&&($this->data["Grpaltvir"]["flag_name"] == 1))
 		{
				$upd_seg = $this->data["Grpaltvir"]["upd_seg"];
				$res = ($this->Validation->numeric($upd_seg))?1:0;
				$res1 = ($this->Validation->maxLength($upd_seg,3))?1:0;
				if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
					($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
				}else{
					$res_hour=1;
				}
/*				if($checkbox_flag == 0) {
			 				$flag =	$this->Group->getFatherSet($father_group,$this->Grpalt,9);
							if($flag ==0){
								$res2 =0;
							}else{
								$res2 =1;
							}
				}else{
							$res2 =1;
				}*/
	 			//if((!empty($upd_seg))&&($res == 1)&&($res1 == 1)&&($res2 ==1))
	 			if(($upd_seg != '')&&($res == 1)&&($res1 == 1)&&($res_hour == 1))
	 			{   
	 				/*  下位グループの設定の解除  */
	 				$glist_group = $this->Grpauth->getChildrenByParent($father_group);
				 	ksort($glist_group);
				 	
					foreach($glist_group as $key => $value){
		   				$condition3 =" Grpaltvir.group_id =".$key." ";
		 				$grpaltvir_id_group= $this->Grpaltvir->findAll($condition3);
		 				if(count($grpaltvir_id_group) ==1){
		 					//echo "下位グループの設定を解除してください";
			 				$grpaltvir_i =$grpaltvir_id_group[0]["Grpaltvir"]["id"];
		 				    $this->Grpaltvir->del($grpaltvir_i);
		 				}		 				
					}
											
					/* 新規グループ共通の追加 */
					//$this->addGrpalt($father_group,$checkbox_flag);
					$this->addGrpalt($father_group,'1');				
	 				
	 				/* 新規追加グループパターンファイルのアラート設定 */
	  				$glist_group = $this->Grpauth->getChildrenByParent($father_group);
				 	ksort($glist_group);			
		 			$insertupd=Array(	
						'Grpaltvir' => Array(
							            'group_id' => $father_group,
							            'upd_seg' =>  $upd_seg,
						      	      )
							);
					$this->Grpaltvir->save($insertupd);	
					$grpaltvir_id = $this->Grpaltvir->getLastInsertID();
				 	foreach ($glist_group as $key=>$value) {
				 		
				 		$insertrltg=Array(	
						'Rltgrpaltvir' => Array(
								            'group_id' => $key,
								            'alert_id' => $grpaltvir_id,
								            'org_grp_id' =>  $father_group,
							      	      )
										);
						$this->Rltgrpaltvir->save($insertrltg);
					}
					// yzl start 2009/07/06 modify for JL-0032
					$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirus','popup'));
					$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirusalert','popup'));
					// yzl end 2009/07/06 modify for JL-0032
				 	$this->index();
					$this->render('index');
					exit();
			 	
 				}else{
 					$re1 =$this->Lv->is_empty($upd_seg);
 					if($re1){
		  				$error =__('E-00100',$return = true);
		  				$update_time =__('update_time',$return = true);
						$errorMessage[$update_time] = $error;
						$this->set('errorMessage', $errorMessage);
						$upd_seg = '';
 					}else{
	 					if($res == 0){
			  				$error =__('E-00600',$return = true);
			  				$update_time =__('update_time',$return = true);
							$errorMessage[$update_time] = $error;
							$this->set('errorMessage', $errorMessage);
	 						
	 					}
 					}
 					if($res1 == 0){
		  				$error =__('E-00300',$return = true);
		  				$update_time =__('update_time_error',$return = true);
						$errorMessage[$update_time] = $error;
						$this->set('errorMessage', $errorMessage);
						
 					}
 					if($res_hour == 0){
		  				$error =__('E-00100',$return = true);
		  				$time=__('time',$return=true);
						$errorMessage_grpalt[$time] = $error;
						$this->set('errorMessage_grpalt', $errorMessage_grpalt);						
 					}
/* 					if($res2 == 0){
		  				$error =__('father_group_set_no',$return = true);
		  				$update_time =__('father_group_alert_inherit',$return = true);
						$errorMessage[$update_time] = $error;
						$this->set('errorMessage', $errorMessage);
					
 					}*/
 										
 				}				
 		}
		$this->set('flg',2);
 		
        if((isset($this->data["Grpaltvir"]["flag_name"]))&&($this->data["Grpaltvir"]["flag_name"] == 1)){
		    	if(!empty($errorMessage)||(!empty($errorMessage_grpalt))){
/*					if($checkbox_flag == 0){
							//echo "33<br>";
			 				$title =$this->title_list();
			 				$this->data['Title']['title_flg'] = ($title==0)?1:0;
							if($grpalt_f == 1){
								$grpalt_r = $this->grpalt_list($group_id);
				        		$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				        		$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
							}else{
								$this->data['Grpalt']['mail_notice'] =3;
								$mail_notice_time_c = '00';
								$this->data['Title']['title_flg'] = 1;
							}
							$this->set('up_cast_flag',0);
					}else{
							$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
							//$this->set('up_cast_flag',1);
		 													
					//}*/
					isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
					$this->set('mail_notice_time_c',$mail_notice_time_c);
					$this->render('add');
					exit();  
		    	}	        	
   	  }
			//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/22 modify for YB-32
			//$this->GenerateFiles->hook_by_ps(0, array('antivirus','popup'));
			//$this->GenerateFiles->hook_by_ps(0, array('antivirusalert','popup'));
			// yzl start 2009/07/06 modify for JL-0032
			//$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirus','popup'));
			//$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirusalert','popup'));
			// yzl end 2009/07/06 modify for JL-0032
			//sunhy end 2009/05/22 modify for YB-32
			//sunhy end 2009/03/30 added for JLN-001
	$this->render('add');
	
	    		    		
   }    
    /*
    	*編集画面
    */
    function edit($father_group=null,$flag=null)
    {//echo "edit<br>";
	    	$this->layout='ajax';
	    	$condition =" Group.id =".$father_group." ";
	   		$data_group_name = $this->Group->findAll($condition);
			$email = $this->_getemail($father_group);
			//debug($email);
			$this->set('email',$email);
			
	 		$this->set('data_group_name',$data_group_name);
	 		$getUserGroup = $this->_getUserGroup_id();
	 		if($getUserGroup == 1){
	 			$this->set('getUserGroup_flag',0);
	 		}elseif	($getUserGroup != 1){
	 			$this->set('getUserGroup_flag',1);
	 		}
  				if($flag == 1)
  				{		
//  						if((isset($this->data["dt_check"]))&&($this->data["dt_check"][0] == '1')){
//  							/*  上位グループの設定を引き継ぐ  */
//							$checkbox_flag ='0';
//						}else{
//							$checkbox_flag ='1';
//						}
		   				$condition1 =" Grpaltvir.group_id =".$father_group." ";
		 				$grpaltvir = $this->Grpaltvir->findAll($condition1);
		 				$grpaltvir_id = $grpaltvir[0]["Grpaltvir"]["id"];

		 								
		 				$grpalt_f=$this->Grpalt->grpalt_list_flag($father_group,9);
		 				
			 			if(!isset($this->data['Grpaltvir']['flag_name'])){
		 						$this->data['Grpaltvir']['upd_seg'] = $grpaltvir[0]["Grpaltvir"]["upd_seg"];		 					
						 		if($grpalt_f == 1){  //echo "111<br>";
						 			$grpalt_r = $this->grpalt_list($father_group);			 			
					 				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
					 				($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';			 			
					    	        $this->set('mail_notice_time_c',$mail_notice_time_c);
					    	        //$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;				 				
						 		}
			 					
						 		/*  件名管理情報,エラー情報  */
					 			if($getUserGroup == 1){
						 				$title =$this->title_list();
						 				$this->data['Title']['title_flg'] = ($title!=1)?1:0;
					 			}		 					
		 				}
/*					 	if(!isset($up_cast_flag)){
				 			$up_cast_flag = 1;
				 		}
						$this->set('up_cast_flag',$up_cast_flag);*/
		 				//echo "group_id=".$father_group."<br>";
/*		 				if($checkbox_flag == 0) {	 					
				 				$flag = $this->Group->getFatherSet($father_group,$this->Grpalt,9);
								if($flag ==0){
									$res2 =0;
								}else{
									$res2 =1;
								}
						}else{
									$res2 =1;
						}*/
		 				if((isset($this->data["Grpaltvir"]["flag_name"]))&&($this->data["Grpaltvir"]["flag_name"] == 1))
		 				{
							$upd_seg = $this->data["Grpaltvir"]["upd_seg"];
							$res = ($this->Validation->numeric($upd_seg))?1:0;
							$res1 = ($this->Validation->maxLength($upd_seg,3))?1:0;
							if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
								($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
							}else{
								$res_hour=1;
							}
				
				  				//if((!empty($upd_seg))&&($res == 1)&&($res1 == 1)&&($res2 == 1))
				  				if(($upd_seg != '')&&($res == 1)&&($res1 == 1)&&($res_hour == 1))
				  				{	
						 			$insertupd=Array(	
										'Grpaltvir' => Array(
														'id' => $grpaltvir_id,
											            'group_id' => $father_group,
											            'upd_seg' =>  $upd_seg,
										      	      )
											);
									$this->Grpaltvir->save($insertupd);
									
					  				//$this->edit_grpalt($father_group,$checkbox_flag);
					 				$this->edit_grpalt($father_group,'1');
					 				// yzl start 2009/07/06 modify for JL-0032
					 				$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirus','popup'));
									$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirusalert','popup'));								
									// yzl end 2009/07/06 modify for JL-0032
									$this->index();
									$this->render('index');
									exit();
				 				}else{
				 					$re1 =$this->Lv->is_empty($upd_seg);
				 					if($re1){
						  				$error =__('E-00100',$return = true);
						  			 	$update_time=__('update_time',$return=true);
										$errorMessage[$update_time] = $error;
										$this->set('errorMessage', $errorMessage);
	
				 					}else{
					 					if($res == 0){				 				
							  				$error =__('E-00600',$return = true);
							  				$update_time =__('update_time',$return = true);
											$errorMessage[$update_time] = $error;
											$this->set('errorMessage', $errorMessage);
					 						
					 					}
					 					if($res1 == 0){
							  				$error =__('E-00300',$return = true);
							  				$update_time =__('update_time_error',$return = true);
											$errorMessage[$update_time] = $error;
											$this->set('errorMessage', $errorMessage);
	 						
					 					}				
				 					}
			 					 	if($res_hour == 0){
						  				$error =__('E-00100',$return = true);
						  				$time=__('time',$return=true);
										$errorMessage_grpalt[$time] = $error;
										$this->set('errorMessage_grpalt', $errorMessage_grpalt);						
				 					}
				 				}
			 				
		 				}
		 				$this->set('flg',1);
 				
 			} 
 			
 		  if((isset($this->data["Grpaltvir"]["flag_name"]))&&($this->data["Grpaltvir"]["flag_name"] == 1)){
			    	if(!empty($errorMessage)||(!empty($errorMessage_grpalt))){
						/*if($checkbox_flag == 0){
				 				$title =$this->title_list();
				 				$this->data['Title']['title_flg'] = ($title==0)?1:0;
								if($grpalt_f == 1){
									$grpalt_r = $this->grpalt_list($father_group);
					        		$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
					        		$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
								}else{
									$this->data['Grpalt']['mail_notice'] =3;
									$mail_notice_time_c = '00';
								}
								$this->set('up_cast_flag',0);
						}else{
								$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
								$this->set('up_cast_flag',1);
			 													
						}*/
						isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
						$this->set('mail_notice_time_c',$mail_notice_time_c);
						$this->render('add');
						exit();  
			    	}	        	
   	  	} 
   	  	//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/22 modify for YB-32
			//$this->GenerateFiles->hook_by_ps(0, array('antivirus','popup'));
			//$this->GenerateFiles->hook_by_ps(0, array('antivirusalert','popup'));
			// yzl start 2009/07/06 modify for JL-0032
			//$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirus','popup'));
			//$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirusalert','popup'));
			// yzl end 2009/07/06 modify for JL-0032
			//sunhy end 2009/05/22 modify for YB-32
			//sunhy end 2009/03/30 added for JLN-001
   	  $this->render('add'); 	
    }
    
    
    /*
    	*追加下位グループ画面
    */
       function add_sun($group_id,$flag)
    { 	//echo "add_sun<br>";
   	    $this->layout='ajax';
  		/*  新規追加  */
 		if($flag == 2) 
 		{	
/*			if((isset($this->data["dt_check"]))&&($this->data["dt_check"][0] == '1')){
					/*  上位グループの設定を引き継ぐ  */
				/*$checkbox_flag ='0';
			}else{
				$checkbox_flag ='1';
			} */											
			/*  新規グループ共通の追加  */
			//$this->addGrpalt($group_id,$checkbox_flag);
			$this->addGrpalt($group_id,'1');		
		 	$this->index();
			$this->render('index');
			exit();			
 		}

    }   

    /*
    	*編集下位グループ画面
    */
      function edit_sun($group_id,$flag)
    { 	//echo "edit_sun<br>";
    	$this->layout='ajax';
		if($flag == 1)
		{		
/*			if((isset($this->data["dt_check"]))&&($this->data["dt_check"][0] == '1')){
			/*  上位グループの設定を引き継ぐ  */
				/*$checkbox_flag ='0';
			}else{
				$checkbox_flag ='1';
			}*/

		  	//$this->edit_grpalt($group_id,$checkbox_flag);
		  	$this->edit_grpalt($group_id,'1');
			$this->index();
			$this->render('index');
			exit();
 											
		}
    }  

    /*
    	*上位グループ

    */
    function add_list($father_id,$group_id){
    	
		    	//echo "add_list<br>";
		    	$this->layout='ajax';
		    	$this->set('father_id',$father_id);
		    	$this->set('group_id',$group_id);
		 		$condition=" Grpaltvir.group_id =".$father_id." ";
				$grpaltvir_group = $this->Grpaltvir->findAll($condition);
				$this->set('grpaltvir_group',$grpaltvir_group);
				$grpaltvir_id = $grpaltvir_group[0]["Grpaltvir"]["id"];
			    
		   		//$data_group_name = $this->groupName($father_id);
		   		$data_group_name = $this->groupName($group_id);
		 		$this->set('data_group_name',$data_group_name);
		 		
				$email = $this->_getemail($group_id);
				$this->set('email',$email);			
		 		
		 		$getUserGroup = $this->_getUserGroup_id();
		 		if($getUserGroup == 1){
		 			$this->set('getUserGroup_flag',0);
		 		}elseif	($getUserGroup != 1){
		 			$this->set('getUserGroup_flag',1);
		 		}
			
/*				if((isset($this->data["dt_check"]))&&($this->data["dt_check"][0] == '1')){
						  上位グループの設定を引き継ぐ  */
					/*$checkbox_flag ='0';
				}else{
					$checkbox_flag ='1';
				}*/
									
 				$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,9);
 				
	 			if(!isset($this->data['Grpaltvir']['flag_name'])){		 					
				 		if($grpalt_f == 1){
				 			$grpalt_r = $this->grpalt_list($group_id);			 			
			 				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
			        		($grpalt_r[0]['Grpalt']['mail_notice'] ==2)?$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2):$mail_notice_time_c='';
			    	        $this->set('mail_notice_time_c',$mail_notice_time_c);
			    	        //$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;
			    	        $this->set('flg',1);	//edit		 				
				 		}else{
				 			$this->data['Grpalt']['mail_notice'] = 1;
				 			$this->set('mail_notice_time_c','');
				 			$this->set('flg',2);	//add
				 		}
				 		/*  件名管理情報,エラー情報  */
			 			if($getUserGroup == 1){
				 				$title =$this->title_list();
				 				$this->data['Title']['title_flg'] = ($title!=1)?1:0;
			 			}
 					
 				}
/*			 	if(!isset($up_cast_flag)){
		 			$up_cast_flag = 1;
		 		}
				$this->set('up_cast_flag',$up_cast_flag);*/

 				if((isset($this->data["Grpaltvir"]["flag_name"]))&&($this->data["Grpaltvir"]["flag_name"] == 1))
 				{	
/* 					if($checkbox_flag == 0) {
						$flag = $this->Group->getFatherSet($group_id,$this->Grpalt,9);
						if($flag ==0){
				  				$error =__('father_group_set_no',$return = true);
				  				$update_time =__('father_group_alert_inherit',$return = true);
								$errorMessage[$update_time] = $error;
								$this->set('errorMessage', $errorMessage);	
							
						}
	 				}*/
/*	 				if(empty($errorMessage)){
				  				//$this->addGrpalt($group_id,$checkbox_flag);
				 				$this->addGrpalt($group_id,'1');								
								$this->index();
								$this->render('index');
								exit();							
					}*/
					if(isset($this->data['Grpalt']['mail_notice']) && ($this->data['Grpalt']['mail_notice'] == 2)){
						($this->data['Grpalt']['mail_notice_time_hour']=='')?$res_hour=0:$res_hour=1;
					}else{
						$res_hour=1;
					}
					if($res_hour==1){
		 				$this->addGrpalt($group_id,'1');								
						$this->index();
						$this->render('index');
						exit();
					}else{
		  				$error =__('E-00100',$return = true);
		  				$time=__('time',$return=true);
						$errorMessage_grpalt[$time] = $error;
						$this->set('errorMessage_grpalt', $errorMessage_grpalt);						
					}
					if(!empty($errorMessage_grpalt)){
						isset($this->data['Grpalt']['mail_notice_time_hour'])?$mail_notice_time_c=$this->data['Grpalt']['mail_notice_time_hour']:$mail_notice_time_c=null;
						$this->set('mail_notice_time_c',$mail_notice_time_c);
						$this->render('add_list');
						exit();  						
					}
/*			    	if(!empty($errorMessage)){
			    		$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
						if($checkbox_flag == 0){
								//echo "grpalt_f=".$grpalt_f."<br>";
				 				$title =$this->title_list();
				 				$this->data['Title']['title_flg'] = ($title==0)?1:0;
								if($grpalt_f == 1){
									//wei ce
									$grpalt_r = $this->grpalt_list($group_id);
					        		$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
					        		$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
								}else{
									$this->data['Grpalt']['mail_notice'] =3;
									$mail_notice_time_c = '00';
								}
								$this->set('up_cast_flag',0);
						}else{
								//echo "44<br>";
								$mail_notice_time_c = $this->data['Grpalt']['mail_notice_time_hour'];
								$this->set('up_cast_flag',1);
			 													
						}
						$this->set('mail_notice_time_c',$mail_notice_time_c);
						$this->render('add_list');
						exit();  
			    	}*/	        	
	   	  	}  

}
    

	/*
		*グループ共通設定テーブルのデータ
	*/
	function addGrpalt($group_id,$checkbox_flag){
		//echo "addGrpalt<br>";
		$grpalt=$this->Grpalt->grpalt_list_flag($group_id,9);
		if($grpalt == 1){
			//$this->edit_grpalt($group_id,$checkbox_flag);
			$this->edit_grpalt($group_id,'1');
		}else{
				if($checkbox_flag == '1') {
					//echo "addGrpalt=1<br>";
					if(isset($this->data["Grpalt"]["mail_notice"]))
					{  
						$mail_notice = $this->data["Grpalt"]["mail_notice"];
						if(!empty($mail_notice)){		
								if($mail_notice != '2') {
									$mail_notice_time = '00:00:00';
								}else{
									$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
								}
								
								//sunhy start 2009/03/25 modify for JLN-001
								/*$insertgrpalt=Array(	
									'Grpalt' => Array(
									'group_id' => $group_id,
									'mail_notice' => $mail_notice,
									'mail_notice_time' => $mail_notice_time,
									'type' => 9,
									//'up_cast' => 1,
								));
								$this->Grpalt->save($insertgrpalt);*/
								$this->MailPopupController->setMailPop(null, $group_id, $mail_notice, $mail_notice_time, null, null, null, 9, 'Grpalt');
								//sunhy end 2009/03/25 modify for JLN-001
								/* 件名管理情報  */
								$getUserGroup = $this->_getUserGroup_id();
								if($getUserGroup == 1){
									$re_title =$this->title_flag();
										 if($re_title == 0){
												$this->addTitle();
										 }else{
										 		$this->editTitle($re_title);
										 }
								}
						}					
					}
				}elseif($checkbox_flag == '0') {
					//echo "addGrpalt=0<br>";
							
							//sunhy start 2009/03/25 modify for JLN-001
							/*$insertgrpalt=Array(	
								'Grpalt' => Array(
								'group_id' => $group_id,
								'mail_notice' => 3,
								'mail_notice_time' =>'00:00:00',
								'type' => 9,
								//'up_cast' => 0,
							));
							$this->Grpalt->save($insertgrpalt);*/
							$this->MailPopupController->setMailPop(null, $group_id, 3, '00:00:00', null, null,null, 9, 'Grpalt');
							//sunhy end 2009/03/25 modify for JLN-001
				}
		}
	}
	
   /*
   		*編集グループ共通

   	*/
   function edit_grpalt($group_id,$checkbox_flag){
   	//echo "edit_grpalt<br>";
			$condition1 =" Grpalt.group_id =".$group_id." and type=9 ";
			$grpalt = $this->Grpalt->findAll($condition1);
			$grpalt_id = $grpalt[0]["Grpalt"]["id"];
			if($checkbox_flag == '1') {				
				if($this->data["Grpalt"]["mail_notice"] != '2') {
					$mail_notice_time = '00:00:00';
				}else{
					$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
				}
				if((isset($_POST['notFirstVisit']))&&($_POST['notFirstVisit'] == '1')){
					//sunhy end 2009/03/25 modify for JLN-001
					/*$insertgrpalt=Array(
						'Grpalt' => Array(
						'id' => $grpalt_id,	
						'group_id' => $group_id,
						'mail_notice' => $this->data["Grpalt"]["mail_notice"],
						'mail_notice_time' => $mail_notice_time,
						'type' => 9,
						//'up_cast' => 1,
					));	
					$this->Grpalt->save($insertgrpalt);*/
					$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, null, null, null, 9, 'Grpalt');
					//sunhy end 2009/03/25 modify for JLN-001
					//debug($insertgrpalt);
					$getUserGroup = $this->_getUserGroup_id();
					if($getUserGroup == 1){
							$re_title =$this->title_flag();
							$this->editTitle($re_title);
					}
				}
			}elseif($checkbox_flag == '0') {
				//echo "checkbox=0<br>";
						//sunhy start 2009/03/25 modify for JLN-001
						/*$insertgrpalt=Array(	
							'Grpalt' => Array(
							'id' => $grpalt_id,	
							'group_id' => $group_id,
							'type' => 9,
							//'up_cast' => 0,
						));
						$this->Grpalt->save($insertgrpalt);*/
						$this->MailPopupController->setMailPop($grpalt_id, $group_id, null, null, null, null, null, 9, 'Grpalt');
						//sunhy end 2009/03/25 modify for JLN-001
			}
			
	
   }
   
  /* 
    *件名管理情報追加 
   */ 
   
  function addTitle(){
			if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
				$title_flg = 0;
			}else{
				$title_flg = 1;
			}								
			$inserttitle=Array(
				'Title' => Array(
				'title_flg' => $title_flg,
				'type' => 9,
			));	
			$this->Title->save($inserttitle);
													
  }
    /* 
    *件名管理情報追加 
   */ 
    function editTitle($id){
			if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
				$title_flg = 0;
			}else{
				$title_flg = 1;
			}								
			$inserttitle=Array(
				'Title' => Array(
				'id'=>$id,
				'title_flg' => $title_flg,
				'type' => 9,
			));	
			$this->Title->save($inserttitle);
													
  }	
  
   /*
   		*削除する
   */
   function delete(){
   			$this->layout='ajax';
 			if(isset($this->data['Grpaltvir']['id'])){		
					$word_id  = $this->data['Grpaltvir']['id'];
					foreach ($word_id as $check){	
						
							/*  上位グループの設定を引き継ぐ   start*/				
							/*
							$onesun =$this->_findOneSun($check);
							$i=0;
							if($onesun !=2){					
								foreach ($onesun as $key => $v){
										if($v == 0) {
											$i++;
										}
								}
							}
							
							if($i > 0) {
							//echo "error!";
									$error =__('delete_list_group_error',$return = true);
									$errorMessage['delete_list_group'] =$error; 
									$this->set('errorMessage',$errorMessage);
								
							}else{  //echo "right!";
							/*  上位グループの設定を引き継ぐ   end*/	
								$delete_list =$this->data['Grpalt']['del_id'];
								$delete = $delete_list[$check];
								$this->Grpaltvir->del($delete);
								$del_grpalt = $this->grpalt_list($check);								
								$id = $del_grpalt[0]['Grpalt']['id'];
								$this->Grpalt->del($id);
								
								$con = "Grpalt.type=9 ";
								$grpalt = $this->Grpalt->findAll($con);
								if(count($grpalt) == 0){
									$title_id =$this-> title_flag();
									if($title_id != 0){
										$this->Title->del($title_id);
									}								
								}
							//}			
						
					}
					// yzl start 2009/07/06 modify for JL-0032
					$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirus','popup'));
					$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirusalert','popup'));
					// yzl end 2009/07/06 modify for JL-0032
 			}else{
 					/* 未選択 */
	 				$error =__('E-00200',$return = true);
					//xushanning start 2009/04/22   modify for LogvillageChinese
					//$errorMessage['list'] = $error;
					$errorMessage['entry'] = $error;
					//xushanning end 2009/04/22   modify for LogvillageChinese
					$this->set('errorMessage', $errorMessage);

			}
			//sunhy start 2009/03/30 added for JLN-001
			//sunhy start 2009/05/22 modify for YB-32
			//$this->GenerateFiles->hook_by_ps(0, array('antivirus','popup'));
			//$this->GenerateFiles->hook_by_ps(0, array('antivirusalert','popup'));
			// yzl start 2009/07/06 modify for JL-0032
			//$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirus','popup'));
			//$this->GenerateFiles->hook_by_group($this->_getUserGroup(), array('antivirusalert','popup'));
			// yzl end 2009/07/06 modify for JL-0032
			//sunhy end 2009/05/22 modify for YB-32
			//sunhy end 2009/03/30 added for JLN-001
			$this->index();
			$this->render('index');
			exit();
   	
   }
   
   function grpalt_list($group_id){
 			$condition =" Grpalt.group_id =".$group_id." and type=9 ";
			$grpalt = $this->Grpalt->findAll($condition);
			return $grpalt;
				
   }
   
/*  function grpalt_list_flag($group_id){
			$condition =" Grpalt.group_id =".$group_id." and type=9 ";
			$grpalt = $this->Grpalt->findAll($condition);
			//debug($grpalt);
			if(count($grpalt) == 1){
				$flag = 1;
			}else{
				$flag = 0;
			}
			return $flag;
			
  }*/
    /* 件名管理情報  start*/ 
   function title_flag(){
 			$condition =" Title.type=9 ";
			$title = $this->Title->findAll($condition);
			//debug($grpalt);
			if(count($title) == 1){
				$flag = $title[0]['Title']['id'];
			}else{
				$flag = 0;
			}
			return $flag;   	
   }

     function title_list(){
 			$condition =" Title.type=9 ";
			$title = $this->Title->findAll($condition);
			//debug($grpalt);
			if(count($title) == 1){
				$flag = $title[0]['Title']['title_flg'];
			}else{
				$flag =2;
			}
			return $flag;   	
   }
   
   /*  end */    
/*  function _findOneSun($group_id){
 		$criteria=" Group.parent_id=".$group_id." ";
		$parent= $this->Group->findAll($criteria);
		if(count($parent) != 0){
				foreach ($parent as $value){
					$id =$value['Group']['id'];
					//debug($id);
					$grpalt =$this->grpalt_list($id);
					if(count($grpalt) == 1){
						$grpalt_up_cast = $grpalt[0]['Grpalt']['up_cast'];
						$array[$id] =$grpalt_up_cast;
						return $array;
						exit();
					}else{
						return 2;
					}
					
				}
		}else{
			return 2;
		}   	
   }*/ 
 	function _getemail($group_id){
		//$group_id= $this->_getUserGroup();
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		//debug($data_email);
		return $data_email;

	} 

	function reset(){
		$this->layout='ajax';
		$this ->index();
		$this->render('index');

	}
/*   function  _getFatherSet($group_id){
   			
   		 if($group_id !=1){
				$group_father_i = $this->group_father_id($group_id);
				$grpalt_list_flag=$this->Grpalt->grpalt_list_flag($group_father_i,9);
				if($grpalt_list_flag ==1) {
					$checkbox_flag =$this->Grpalt->getGrpalt_up_cast($group_father_i,9);
					if($checkbox_flag == 1) {
						return $group_father_i;					
					}else{ //echo "1<br>";
						$result = $this->_getFatherSet($group_father_i);
						return $result;
					}
					
				}else{
					$id =0;
					return $id;
				}
   		 }else{
			 $id =0;
			 return $id;  		 	
   		 }
   }*/
   


}
?>