<?php
/*********************************************************************
*@filename 		system_grpset_alert_webs_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment
*               2.0        xinw        2009/01/20   modify for ASP4-030
*               2.0        xinw        2009/02/03   modify for ASP4-031
*               2.0        sunhy      2009/03/27    modify for JLN-001
*            2.0        xushanning  2009/04/22   modify for LogvillageChinese
*               2.0        sunhy      2009/05/11    modify for YBR-32
*               2.0        yzl      2009/07/24    modify for JL-0035
********************************************************************/
class SystemGrpsetAlertWebsController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	//sunhy start 2009/03/27 modify for JLN-001
	//var $components = array ('Pagination', 'Lv','GenerateFiles');
	var $components = array ('Pagination', 'Lv','GenerateFiles', 'MailPopupController', 'AlertPcController');
	//sunhy end 2009/03/27 modify for JLN-001
	var $uses=array(
					'Hstaltdvc', 							//list_by_host			
					'Group', 'Host','Rlthstgrp','User', 			//groupとhostなどの関連
					'Grpauth', 'Grpaltwebtil',
					'Configure','Validation',							//Cakeシステム
					'Grpaltwebtil','Rltgrpaltwebtil','Grpaltweburl','Grpalt',
					'Title','Altmsg'
					);
	var $layout='system';
//	var $pageTitle = 'LVシステム管理／グループ毎の設定／アラート／Web操作';
	
	function beforeFilter()
	{
		$this->pageTitle = __('titles',$return = true);   
		parent::beforeFilter();
//		$this->Configure->write('debug', 2);
		if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	
	function index()
	{
//		$this->GenerateFiles->hook_by_group(array("1"), array('web'));
		$alert_list= $this->requestAction('/system_grpset_alert_webs/alert_list',array('return'));
		$this->set('alert_list',$alert_list);
		

		
	}
	
	function alert_list($do=null)
	{
		$this->layout='ajax';
		$err=null; 
		//		$this->alert_list();
//		$this->render('alert_list');
//		$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Group->getChildrenByParent($this->_getUserGroup());
		
//		$glist[0] =  __('whole',$return = true);
		//ksort($glist);
		$this->set('glist',$glist); 
		
		
		//==============================cp

		//==============================cp
		
		
		if($do=='del')
		{
			
			
			
			
			
			
			if(isset($this->data['Grpaltwebtil']['del']))
			{
				
				
				
				
				
				
				
				foreach($this->data['Grpaltwebtil']['del'] as $key => $v)
				{
					$onesun =$this->_findOneSun($v);
						$i=0;
						if($onesun !=2){
							foreach ($onesun as $key => $v1){
								if($v1 == 0) {
									$i++;
								}
							}
						}
		
						if($i > 0) { //echo "wrong<br>";
							$err[] =__('delete_list_group_error',$return = true);
//							$error =__('delete_list_group_error',$return = true);
//							$errorMessage['delete_list_group'] =$error;
//							//debug($errorMessage);
//							$this->set('errorMessage',$errorMessage);
						}
						else 
						{
							$this->Grpaltwebtil->deleteAll(array('group_id = '.$v));
							$this->Grpaltweburl->deleteAll(array('group_id = '.$v));
							$this->Grpalt->deleteAll(array('group_id = '.$v,'type=1'));
							// yzl start 2009/07/24 modify for JL-0035
							$this->MailPopupController->delAltMsg("E0001",$v);
							$this->MailPopupController->delAltTit("1",$v);
							// yzl end 2009/07/24 modify for JL-0035
							//sunhy start 2009/05/11 added for YBR-32
							//$this->GenerateFiles->hook_by_ps(0, array("web"));
							$this->GenerateFiles->hook_by_ps(0, array("web", "popup"), $v);
							//sunhy end 2009/05/11 added for YBR-32
						}
				}
//				$this->GenerateFiles->hook_by_group($this->data['Grpaltwebtil']['del'], array('web'));
				//sunhy start 2009/05/11 delete for YBR-32
				//$this->GenerateFiles->hook_by_ps(0, array("web"));
				//sunhy end 2009/05/11 delete for YBR-32
				
				
				
				
				
				
				
//				$condition="";
//				foreach($this->data['Grpaltwebtil']['del'] as $key => $value){
//				    $condition.=$value.",";
//				}
//				$condition = substr($condition,0,-1);
//				$this->Grpaltwebtil->deleteAll(array('group_id in ('.$condition.')'));
//				$this->Grpaltweburl->deleteAll(array('group_id in ('.$condition.')'));
				
				
				
				
				
				
				
				
				
				
				
				
				
				
				
			}
			else 
			{
				$err[]=__('project',$return = true)."　".__('E-00200',$return = true);
				
			}
			
			
			
			
			
			

		}
		
		$where_t=array('1=1');
		$where_u=array('1=1');
		$where=array('1=1');
		
		//xinw start 20090120
		//modify for ASP4-030
		$glist=array();
		$flist=array();
		if (!isset($this->data['Group']['id'])) {
			$this->data['Group']['id']=$this->_getUserGroup();
		}
		$glist = $this->Grpauth->getChildrenByParent($this->data['Group']['id']);
		$flist = $this->Grpauth->getParentsByChild4($this->data['Group']['id']);
		$glist=$glist+$flist;
		$condition="";
		foreach($glist as $key => $value){
			$condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$where_t[]="Group.id in (".$condition.")";
		$where_u[]="Group.id in (".$condition.")";
		$where[]="Group.id in (".$condition.")";
		//xinw end 20090120
		
		if($do=="seach")
		{
			if(!empty($this->data['Grpaltwebtil']['seach']))
			{
				$searchword = $this->Lv->spec_char_like($this->data['Grpaltwebtil']['seach']);
				$glist = $this->Grpauth->getChildrenByParent($this->data['Group']['id']);    
							$condition="";
							foreach($glist as $key => $value){
							    $condition.=$key.",";
							}
							$condition = substr($condition,0,-1);
				if(!$this->Validation->maxLength($this->data['Grpaltwebtil']['seach'],2083))
				{
					$err[]=__('key word',$return = true)."　".__('E-00300',$return = true);
				}
				if($this->data['Grpaltwebtil']['url']=='1'&&$this->data['Grpaltwebtil']['title']=='1')
				{
//				$where_t[]="Group.id=".$this->data['Group']['id']." and Grpaltwebtil.url_title='".$this->data['Grpaltwebtil']['seach']."' ";
//				$where_u[]="Group.id=".$this->data['Group']['id']." and Grpaltweburl.url='".$this->data['Grpaltwebtil']['seach']."' ";
				$where_t[]="Group.id in (".$condition.")";
				$where_u[]="Group.id in (".$condition.")";
					if(!empty($this->data['Grpaltwebtil']['seach']))
					{
						//wangs start 20080202
						//$where_t[]=" Grpaltwebtil.url_title like '%".$this->data['Grpaltwebtil']['seach']."%' ";
						//$where_u[]=" Grpaltweburl.url like '%".$this->data['Grpaltwebtil']['seach']."%' ";
						$where_t[]=" lower(Grpaltwebtil.url_title) like '%".strtolower($searchword)."%' ";
						$where_u[]=" lower(Grpaltweburl.url) like '%".strtolower($searchword)."%' ";
						//wangs end 20080202
					}
				}
				elseif($this->data['Grpaltwebtil']['url']=='1')
				{
					$where_t[]="1=2";
//					$where_u[]="Group.id=".$this->data['Group']['id']." and Grpaltweburl.url='".$this->data['Grpaltwebtil']['seach']."' ";
					$where_u[]="Group.id in (".$condition.")";
					if(!empty($this->data['Grpaltwebtil']['seach']))
					{
						//wangs start 20080202
						//$where_u[]="Grpaltweburl.url like '%".$this->data['Grpaltwebtil']['seach']."%' ";
						$where_u[]="lower(Grpaltweburl.url) like '%".strtolower($searchword)."%' ";
						//wangs end 20080202
					}
				}
				elseif ($this->data['Grpaltwebtil']['title']=='1')
				{
					$where_u[]="1=2";
//					$where_t[]="Group.id=".$this->data['Group']['id']." and Grpaltwebtil.url_title='".$this->data['Grpaltwebtil']['seach']."' ";
					$where_t[]="Group.id in (".$condition.")";
					if(!empty($this->data['Grpaltwebtil']['seach']))
					{
						//wangs start 20080202
						//$where_t[]=" Grpaltwebtil.url_title like '%".$this->data['Grpaltwebtil']['seach']."%' ";
						$where_t[]=" lower(Grpaltwebtil.url_title) like '%".strtolower($searchword)."%' ";
						//wangs end 20080202
					}
				}
				else 
				{
					$err[]=__('seach all',$return = true)."　".__('E-00200',$return = true);
				}
				//wangs start 20080202
				//$where[]="Group.id=".$this->data['Group']['id']." and (Grpaltweburl.url like '%".$this->data['Grpaltwebtil']['seach']."%'   or  Grpaltwebtil.url_title like '%".$this->data['Grpaltwebtil']['seach']."%')";
				$where[]="Group.id=".$this->data['Group']['id']." and (lower(Grpaltweburl.url) like '%".strtolower($searchword)."%' or lower(Grpaltwebtil.url_title) like '%".strtolower($searchword)."%')";
				//wangs end 20080202
			}
//			else 
//			{
//				$err[]=__('key word',$return = true)."　".__('E-00100',$return = true);
//			}
		}
		
		
			$asso = array(
						'Rltgrpaltwebtil : rltgrpaltwebtils : LEFT' => array('Grpaltwebtil.id = Rltgrpaltwebtil.alert_id'),
//						'Grpaltweburl : grpaltweburls : LEFT' => array('Grpaltwebtil.id = Grpaltweburl.id'),
						'Group : groups : LEFT' => array('Group.id = Grpaltwebtil.group_id'),
							);
											
//		list($order,$limit,$page) = $this->Pagination->init($conditions, null, array('ajaxDivUpdate'=>'select','url'=>'/system_all_polls/search', 'modelClass'=>'Poll','ajaxFormId' => NULL, 'style' => 'ajax'));
		$data = $this->Grpaltwebtil->findByAsso($where_t, array('Grpaltwebtil.id','Group.group_name', 'Grpaltwebtil.url_title'), null, null, null, $asso);

		$asso = array(
						'Rltgrpaltweburl : rltgrpaltweburls : LEFT' => array('Rltgrpaltweburl.alert_id = Grpaltweburl.id'),
						'Group : groups : LEFT' => array('Group.id = Grpaltweburl.group_id'),
							);
		$datau = $this->Grpaltweburl->findByAsso($where_u, array('Grpaltweburl.id','Group.group_name', 'Grpaltweburl.url'), null, null, null, $asso);
		$data=array_merge($data,$datau);
//		debug($data);
		
		$this->set('data',$data);
//		$this->set('datau',$datau);
		$where_c=array_merge($where,array('GROUP BY'=>'Group.id,Group.group_name,Grpalt.mail_notice_time',));
		$where_c[]="Grpalt.type=1";
		$asso = array(
						'Grpaltwebtil : grpaltwebtils : LEFT' => array('Grpaltwebtil.group_id = Group.id'),
						'Grpaltweburl : grpaltweburls : LEFT' => array('Grpaltweburl.group_id = Group.id'),
						'Grpalt : grpalts ' => array('Group.id = Grpalt.group_id'),
							);
		$group_count = $this->Group->findByAsso($where_c, array('Group.id','Group.group_name','Grpalt.mail_notice_time', 'count(Group.group_name) AS Group__group_names'), null, null, null, $asso);
//		debug($group_count);
		foreach ($group_count as $key=>$con)
		{
			$s_title=array('Grpaltwebtil.group_id='.$con['Group']['id']);
			$s_url=array('Grpaltweburl.group_id='.$con['Group']['id']);
			
			if($do=="seach")
			{
				if(!empty($this->data['Grpaltwebtil']['seach']))
				{
					$searchword = $this->Lv->spec_char_like($this->data['Grpaltwebtil']['seach']);
					if($this->data['Grpaltwebtil']['url']=='1'&&$this->data['Grpaltwebtil']['title']=='1')
					{
						//wangs start 20080202
						//$s_title=array("Grpaltwebtil.group_id=".$this->data['Group']['id']." and Grpaltwebtil.url_title like '%".$this->data['Grpaltwebtil']['seach']."%' ");
						//$s_url=array("Grpaltweburl.group_id=".$this->data['Group']['id']." and Grpaltweburl.url like '%".$this->data['Grpaltwebtil']['seach']."%' ");
						$s_title=array("Grpaltwebtil.group_id=".$this->data['Group']['id']." and lower(Grpaltwebtil.url_title) like '%".strtolower($searchword)."%' ");
						$s_url=array("Grpaltweburl.group_id=".$this->data['Group']['id']." and lower(Grpaltweburl.url) like '%".strtolower($searchword)."%' ");
						//wangs end 20080202
					}
					elseif($this->data['Grpaltwebtil']['url']=='1')
					{
						$s_title=array("1=2");
						//wangs start 20080202
						//$s_url=array("Grpaltweburl.group_id=".$this->data['Group']['id']." and Grpaltweburl.url like '%".$this->data['Grpaltwebtil']['seach']."%' ");
						$s_url=array("Grpaltweburl.group_id=".$this->data['Group']['id']." and lower(Grpaltweburl.url) like '%".strtolower($searchword)."%' ");
						//wangs end 20080202
					}
					elseif ($this->data['Grpaltwebtil']['title']=='1')
					{
						$s_url=array("1=2");
						//wangs start 20080202
						//$s_title=array("Grpaltwebtil.group_id=".$this->data['Group']['id']." and Grpaltwebtil.url_title like '%".$this->data['Grpaltwebtil']['seach']."%' ");
						$s_title=array("Grpaltwebtil.group_id=".$this->data['Group']['id']." and lower(Grpaltwebtil.url_title) like '%".strtolower($searchword)."%' ");
						//wangs end 20080202
					}
				}
				else 
				{
					if($this->data['Grpaltwebtil']['url']=='1'&&$this->data['Grpaltwebtil']['title']=='1')
					{
						
					}
					elseif($this->data['Grpaltwebtil']['url']=='1')
					{
						$s_title=array("1=2");
						
					}
					elseif ($this->data['Grpaltwebtil']['title']=='1')
					{
						$s_url=array("1=2");
						
					}
				}
				
				
			}
			
			
			$count_t = $this->Grpaltwebtil->findAll($s_title,"count(*) as Grpaltwebtil__count ");
			$count_u = $this->Grpaltweburl->findAll($s_url,"count(*) as Grpaltweburl__count ");
			$group_count[$key]['Group']['group_names']=$count_t[0]['Grpaltwebtil']['count']+$count_u[0]['Grpaltweburl']['count'];
			
			$alert=$this->Grpalt->findAll(array('Grpalt.group_id='.$con['Group']['id'],'Grpalt.type=1'),"Grpalt.group_id,Grpalt.up_cast,Grpalt.mail_notice,Grpalt.popup");
			if(isset($this->data['Grpaltwebtil']['url']))
			{
			$this->set('ckurl',$this->data['Grpaltwebtil']['url']);
			$this->set('cktitle',$this->data['Grpaltwebtil']['title']);
			}
			
			
			$data_group=$this->grpalt_list($con['Group']['id']);
			if(count($data_group) ==1){
			$checkbox_flag = $this->Grpalt->getGrpalt_up_cast($con['Group']['id'],1);
				if($checkbox_flag == 0){
					$flag = $this->Group->getFatherSet($con['Group']['id'],$this->Grpalt,1);
					$data_group_p=$this->grpalt_list($flag);
					$mail_ntc= $data_group_p[0]["Grpalt"]['mail_notice'];
					$popup= $data_group_p[0]["Grpalt"]['popup'];
				}else{
					$mail_ntc= $data_group[0]["Grpalt"]['mail_notice'];
					$popup= $data_group[0]["Grpalt"]['popup'];
				}
			}
			
			
			
			@ $group_count[$key]['Group']['mail_notice']=$mail_ntc;
			@ $group_count[$key]['Group']['popup']=$popup;
//			$group_count[$key]['Group']['mail_notice']=isset($alert[0]['Grpalt']['mail_notice'])?$alert[0]['Grpalt']['mail_notice']:null;
//			$group_count[$key]['Group']['popup']=isset($alert[0]['Grpalt']['popup'])?$alert[0]['Grpalt']['popup']:null;
			//xinw start 20090120
			//modify for ASP4-030
			//$group_count[$key]['Group']['flag']='1';
			$group_count[$key]['Group']['flag']='0';
			//xinw end 20090120
			foreach ($glist as $key_id=>$grp)
			{
//				echo "====$key_id==============================".$group_count[$key]['Group']['id']."==<br>";
				//xinw start 20090120
				//modify for ASP4-030
				//if($key_id==$group_count[$key]['Group']['id'])
				if($key_id==$group_count[$key]['Group']['id'] && !array_key_exists($key_id,$flist))
				//xinw end 20090120
				{
					$group_count[$key]['Group']['flag']='1';
				}
//				else 
//				{
//					$group_count[$key]['Group']['flag']='0';
//				}
			}
		}
//		debug($glist);
//		debug($group_count);
		$this->set('group_count',$group_count);
		$this->set('err',$err);
		
		$this->render('alert_list');
		

	}
	function web_set($group=null)
	{
		$this->layout="ajax";
		if(isset($this->data['Group']['id']))
		{
			$groupid=$this->data['Group']['id'];
		}
		elseif (isset($group))
		{
			$groupid=$this->$group;
		}
		
		$this->set('group',$groupid);
	}
	function alert_set($group=null,$do=null)
	{
		$this->layout="ajax";
		$err=null;
		if(isset($this->data['Group']['id']))
		{
			$groupid=$this->data['Group']['id'];
		}
		elseif (isset($group))
		{
			$groupid=$group;
		}
		$group = $this->Group->findAll(array("Group.id=".$groupid));
		$this->set('group',$group[0]['Group']['group_name']);
		$this->set('groupid',$groupid);
		
		//sunhy start 2009/03/28 added for JLN-001
		//sunhy start 2009/05/11 delete for YBR-32
		/*$getUserGroup = $this->_getUserGroup();
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}*/
		//sunhy end 2009/05/11 delete for YBR-32
		//sunhy end 2009/03/28 added for JLN-001
		
		if($do=="add")
		{
			
//			if(!empty($this->data['Grpaltwebtil']['key']))
			if(!$this->Validation->blank($this->data['Grpaltwebtil']['key']))
			{
			if($this->data['Grpaltwebtil']['url_radio']=='1')
			{
				$sensor['group_id']=$groupid;
		    		$sensor['url']=$this->Lv->spec_char_dbm($this->data['Grpaltwebtil']['key']);
		    		$this->Grpaltweburl->save($sensor);
			} 
			elseif($this->data['Grpaltwebtil']['url_radio']=='0')
			{
				$sensor['group_id']=$groupid;
		    		$sensor['url_title']= $this->Lv->spec_char_dbm($this->data['Grpaltwebtil']['key']);
		    		$this->Grpaltwebtil->save($sensor);
		    		
			}
			//sunhy start 2009/04/14 delete for JLN-001
			//$this->GenerateFiles->hook_by_group($groupid, array('web'));
			//sunhy end 2009/04/14 delete for JLN-001
			 $alert=$this->Grpalt->findAll(array('Grpalt.group_id='.$groupid,'Grpalt.type=1'),"Grpalt.group_id,Grpalt.mail_notice,Grpalt.popup");
			 if(empty($alert))
			 {
			 	$this->grpalt_set($groupid,1,1);
//			 	$sensor['group_id']=$groupid;
//		    		$sensor['mail_notice']=3;
//		    		$sensor['popup']=1;
//		    		$sensor['type']=1;
//		    		$this->Grpalt->save($sensor);
			 }
			 //sunhy start 2009/04/14 added for JLN-001
			$this->GenerateFiles->hook_by_group($groupid, array('web'));
			//sunhy end 2009/04/14 added for JLN-001
			}
			else 
			{
				$err[]=__('key word',$return = true)."　".__('E-00100',$return = true);
			}
			$this->set('rdo_v',$this->data['Grpaltwebtil']['url_radio']);
		}
		if($do=="edit")
		{
			if(isset($this->data['Grpaltwebtil']['ck']))
			{
				foreach ($this->data['Grpaltwebtil']['ck'] as $key)
				{
					
					
				   if(!$this->Validation->blank($this->data['Grpaltwebtil']['keyword_'.$key]))
				   {
					
					if($this->data['Grpaltwebtil']['list_radio_'.$key]=='1')
					{
						if($this->data['Grpaltwebtil']['oldradio_'.$key]=='1')
						{
							$sensor['id']=$this->data['Grpaltwebtil']['cid_'.$key];
							$sensor['group_id']=$groupid;
					    		$sensor['url']=$this->Lv->spec_char_dbm($this->data['Grpaltwebtil']['keyword_'.$key]);
					    		$this->Grpaltweburl->save($sensor);
						}
						elseif ($this->data['Grpaltwebtil']['oldradio_'.$key]=='0')
						{
							$this->Grpaltwebtil->del($this->data['Grpaltwebtil']['cid_'.$key]);
							$sensor['group_id']=$groupid;
					    		$sensor['url']=$this->Lv->spec_char_dbm($this->data['Grpaltwebtil']['keyword_'.$key]);
					    		$this->Grpaltweburl->save($sensor);
						}
					} 
					elseif($this->data['Grpaltwebtil']['list_radio_'.$key]=='0')
					{
						if($this->data['Grpaltwebtil']['oldradio_'.$key]=='0')
						{
							$sensor['id']=$this->data['Grpaltwebtil']['cid_'.$key];
							$sensor['group_id']=$groupid;
					    		$sensor['url_title']=$this->Lv->spec_char_dbm($this->data['Grpaltwebtil']['keyword_'.$key]);
					    		$this->Grpaltwebtil->save($sensor);
						}
						elseif ($this->data['Grpaltwebtil']['oldradio_'.$key]=='1')
						{
							$this->Grpaltweburl->del($this->data['Grpaltwebtil']['cid_'.$key]);
					    		$sensor['group_id']=$groupid;
					    		$sensor['url_title']=$this->Lv->spec_char_dbm($this->data['Grpaltwebtil']['keyword_'.$key]);
					    		$this->Grpaltwebtil->save($sensor);
						}
					} 
					$this->GenerateFiles->hook_by_group($groupid, array('web'));
				   }
				   else 
				   {
				   	$err[]=__('key word',$return = true)."　".__('E-00100',$return = true);
				   }
					
					
					
				}
			}
			else 
			{
				$err[]=__('alert',$return = true)."　".__('E-00200',$return = true);
			}
		}
		if($do=="del")
		{
			if(isset($this->data['Grpaltwebtil']['ck']))
			{
				foreach ($this->data['Grpaltwebtil']['ck'] as $key)
				{
					if($this->data['Grpaltwebtil']['oldradio_'.$key]=='1')
						{
							$this->Grpaltweburl->del($this->data['Grpaltwebtil']['cid_'.$key]);
						}
					elseif ($this->data['Grpaltwebtil']['oldradio_'.$key]=='0')
						{
							$this->Grpaltwebtil->del($this->data['Grpaltwebtil']['cid_'.$key]);
						}
						
						
//						$this->Grpalt->del($this->data['Grpaltwebtil']['cid_'.$key]);
						
				}
				$this->GenerateFiles->hook_by_group($groupid, array('web'));
			}
			else 
			{
				$err[]=__('alert',$return = true)."　".__('E-00200',$return = true);
			}
		}
//		$alist[] = $this->Grpaltwebtil->findAll(array('Grpaltwebtil.group_id='.$groupid),'Grpaltwebtil.id,Grpaltwebtil.url_title,Grpaltwebtil.group_id');
//		$alist[] = $this->Grpaltweburl->findAll(array('Grpaltweburl.group_id='.$groupid),'Grpaltweburl.id,Grpaltweburl.url,Grpaltweburl.group_id');
		$search=" (SELECT Grpauth.org_grp_id FROM grpauths AS Grpauth WHERE Grpauth.group_id = " . $groupid . ")";
		$alist[] = $this->Grpaltwebtil->findAll(array('Grpaltwebtil.group_id in '.$search,'Grpaltwebtil.group_id!='.$groupid),'Grpaltwebtil.id,Grpaltwebtil.url_title,Grpaltwebtil.group_id');
		$alist[] = $this->Grpaltweburl->findAll(array('Grpaltweburl.group_id in '.$search,'Grpaltweburl.group_id!='.$groupid),'Grpaltweburl.id,Grpaltweburl.url,Grpaltweburl.group_id');
		
		$alist[] = $this->Grpaltwebtil->findAll(array('Grpaltwebtil.group_id='.$groupid),'Grpaltwebtil.id,Grpaltwebtil.url_title,Grpaltwebtil.group_id');
		$alist[] = $this->Grpaltweburl->findAll(array('Grpaltweburl.group_id='.$groupid),'Grpaltweburl.id,Grpaltweburl.url,Grpaltweburl.group_id');
		$alist=array_merge($alist[0],$alist[1],$alist[2],$alist[3]);
//		$result = $this->Grpaltwebtil->query('select * from '.$alist.';');
//		debug($alist);
//		debug($this->data);
		$this->set('groupid',$groupid);
		$this->set('alist',$alist);
		$this->set('err',$err);
		//===========================================cp
		//xinw start 20090203
		//modify for ASP4-031
		$judge=$this->Grpalt->findAll(array('Grpalt.group_id='.$groupid,'Grpalt.type=1'));
		//xinw end 20090203
		//xinw start 20090203
		//modify for ASP4-031
/*		if(!empty($group)&&$do!="reset")
		{
			$this->grpalt_set($groupid);
//		echo "11111111111111=".$groupid;
		}*/
		if(!empty($group) && ($do=="nodo" || $do=='del' || $do=='edit' ||$do=='add') && empty($judge))
		{
			$this->data['Grpalt']['mail_notice']=1;
			//sunhy start 2009/05/11 modify for YBR-32
			//$this->data['Title']['title_flg']=1;
			$titleflg=$this->title_list($groupid);
			$this->data['Title']['title_flg'] = ($titleflg!=1)?1:0;
			//sunhy end 2009/05/11 modify for YBR-32
			//sunhy start 2009/03/28 modify for JLN-001
			//$this->data['Grpalt']['popup']=2;
			$this->data['Grpalt']['popup']=0;
			//sunhy end 2009/03/28 modify for JLN-001
			//sunhy start 2009/05/11 modify for YBR-32
			//$this->data['Altmsg']['detail_flg']=1;
			$altmsg_list_detail =$this->altmsg_list_detail($groupid);
			//$altmsg=$this->Altmsg->findAll(array('id=1'));
			$altmsg=$this->Altmsg->findAll(array("message_id='E0001'","Altmsg.group_id=". $groupid));
			if(empty($altmsg[0]['Altmsg']['detail_flg']) || $altmsg[0]['Altmsg']['detail_flg'] == 1){
			$this->data['Altmsg']['detail_flg']=1;
			}
			//$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			if(!empty($altmsg)){
				$this->data['Altmsg']['message']=$altmsg[0]['Altmsg']['message'];
			}else{
				$this->data['Altmsg']['message']=__('E0001',$return = true);
			}
			//sunhy end 2009/05/11 modify for YBR-32
			$email = $this->_getemail($this->data['Group']['id']);
			$this->set('email',$email);
			$this->set('group_id',$this->data['Group']['id']);
		}else 
		{
			$this->grpalt_set($groupid);
		}
		//xinw end 20090203
		//===========================================cp
	}
	
	
	//=========================================================================cp==========================
	function  getFatherSet($group_id, & $model,$type){
        if($group_id !=null){
			if($group_id !=1){
				$group_father_i = $this->group_father_id($group_id);
				$grpalt_list_flag=$model->grpalt_list_flag($group_father_i,$type);
				if($grpalt_list_flag ==1) {
					$checkbox_flag =$model->getGrpalt_up_cast($group_father_i,$type);
					if($checkbox_flag == 1) {
						return $group_father_i;
					}else{ //echo "1<br>";
						$result = $this->getFatherSet($group_father_i,& $model,$type);
						return $result;
						
					}
				}else{
					$id =0;
					return $id;
				}
			}else{
				$id =0;
				return $id;
			}
        }
	}
	
	function grpalt_set($group_id,$flag=null){
//		echo "grpalt_set<br>";
		$this->layout='ajax';
		$this->set('group_id',$group_id);
		$email = $this->_getemail($group_id);
		//debug($email);
		$this->set('email',$email);
		

		if((isset($this->data['Grpalt']['up_cast']))&&($this->data['Grpalt']['up_cast'] == '1')){
			//上位グループの設定を引き継ぐ
			$checkbox_flag =0;
		}else{
			$checkbox_flag =1;
		}

		$getUserGroup = $this->_getUserGroup();
//		$getUserGroup = 1;
		if($getUserGroup == 1){
			$this->set('getUserGroup_flag',0);
		}elseif	($getUserGroup != 1){
			$this->set('getUserGroup_flag',1);
		}

		//上位グループの設定を引き継ぐ
		//if(@$this->data["Grpalt"]["Grpalt_flag"] != 1){
		if(!isset($this->data["Grpalt"]["Grpalt_flag"])){  //echo "Grpalt_flag<br>";
			$grpalt_f=$this->Grpalt->grpalt_list_flag($group_id,1);
			if($grpalt_f == 1){ //echo "1111<br>";
				$grpalt_r = $this->grpalt_list($group_id);
//				debug($grpalt_r);
				$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
				$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:0;
				//sunhy end 2009/03/28 modify for JLN-001
				$this->data['Grpalt']['receive'] = ($grpalt_r[0]['Grpalt']['receive']==0)?1:0;
				$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
				$up_cast_flag = ($grpalt_r[0]["Grpalt"]["up_cast"] == 1)?1:0;
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->set('flg',2);

			}else{ //echo "Grpalt_flag!=1<br>";
				$this->data['Grpalt']['mail_notice'] = 1;
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->data['Grpalt']['popup'] = 2;
				$this->data['Grpalt']['popup'] = 0;
				//sunhy end 2009/03/28 modify for JLN-001
				$mail_notice_time_c = '00';
				$this->set('mail_notice_time_c',$mail_notice_time_c);
				$this->data['Grpalt']['mail_notice_time_hour'] = '00'; 
				$this->data['Grpalt']['receive'] = 0; 
				$up_cast_flag = 1;
				$this->add_grpalt($group_id,1,2);
				//sunhy start 2009/05/11 modify for YBR-32
				//$this->GenerateFiles->hook_by_ps(0, array("web", "popup"));
				$this->GenerateFiles->hook_by_ps(0, array("web", "popup"), $group_id);
				//sunhy start 2009/05/11 modify for YBR-32
				$this->set('flg',1);
			}
			//sunhy start 2009/05/11 modify for YBR-32
			//if($getUserGroup == 1){ //echo "getUserGroup == 1<br>";
				//sunhy start 2009/05/11 modify for YBR-32
				//$title =$this->title_list();
				$title =$this->title_list($group_id);
				$this->data['Title']['title_flg'] = ($title!=1)?1:0;
				//sunhy end 2009/05/11 modify for YBR-32
				//$altmsg_list =$this->altmsg_list();
				//$altmsg_list_detail =$this->altmsg_list_detail();
				$altmsg_list =$this->altmsg_list($group_id);
				$altmsg_list_detail =$this->altmsg_list_detail($group_id);
//				debug($altmsg_list_detail);
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
				if($altmsg_list_detail == 2 || $altmsg_list_detail == 1){
					$this->data['Altmsg']['detail_flg'] = 1;
				}
				//sunhy end 2009/03/28 modify for JLN-001
				//$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
				if($altmsg_list == 2){
				$this->data['Altmsg']['message']=__('E0001',$return = true);

				}else{
					$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
				}
				//debug($this->data);
			//}
			//sunhy end 2009/05/11 modify for YBR-32
		}
		if(!isset($up_cast_flag)){
			$up_cast_flag = 1;
		}
		$this->set('up_cast_flag',$up_cast_flag);
		/* 追加　*/
		if(isset($this->data["Grpalt"]["Grpalt_flag"])&&($this->data["Grpalt"]["Grpalt_flag"] == 1)){
			if($checkbox_flag == 0) {
				/*** * ***/
				$flag_father = $this->Group->getFatherSet($group_id,$this->Grpalt,1);
				if($flag_father ==0){
					$Message['father_group_alert_inherit'][] = 'father_group_set_no';
					$errorMessage = $Message;
					$this->set('errorMessage',$errorMessage);
					$this->data['Grpalt']['mail_notice'] = 3;
					$this->data['Grpalt']['popup'] = 1;
					$this->set('mail_notice_time_c','00');
					$this->set('up_cast_flag',0);
				}
			}elseif($checkbox_flag == 1){
				$getUserGroup = $this->_getUserGroup();
				if($getUserGroup == 1){
					@$Grpaltcontent = $this->data["Altmsg"]["message"];
					@$result_content = $this->error_judge_grpalt($Grpaltcontent,'popup_set');

					if(!count($result_content) == 0){
						//debug($this->data);
						$errorMessage =$result_content;
						$this->set('errorMessage',$errorMessage);
						$mail_notice_time_c = isset($this->data['Grpalt']['mail_notice_time_hour'])?$this->data['Grpalt']['mail_notice_time_hour']:null;
						$this->set('mail_notice_time_c',$mail_notice_time_c);
					}
				}
			} //echo "========$group_id============";
			if(empty($errorMessage)){

				$this->add_grpalt($group_id,$checkbox_flag,1);
				
				//sunhy start 2009/05/11 modify for YBR-32
				//$this->GenerateFiles->hook_by_ps(0, array("web", "popup"));
				$this->GenerateFiles->hook_by_ps(0, array("web", "popup"), $group_id);
				//sunhy start 2009/05/11 modify for YBR-32
//				$this->index();
//				$this->render('index');
//				exit();
			}
		}

		/*　ページの保存　*/
		if((isset($this->data["Grpalt"]["Grpalt_flag"])&&($this->data["Grpalt"]["Grpalt_flag"] == 1))){
			if(!empty($errorMessage)){
				if($checkbox_flag == 0){
					if($this->grpalt_list_id($group_id)!=0){
						$grpalt_r = $this->grpalt_list($group_id);
						$this->data['Grpalt']['mail_notice'] = $grpalt_r[0]['Grpalt']['mail_notice'];						
						//sunhy start 2009/03/28 modify for JLN-001
						//$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:2;
						$this->data['Grpalt']['popup'] = ($grpalt_r[0]['Grpalt']['popup']==1)?1:0;
						//sunhy end 2009/03/28 modify for JLN-001
						$this->data['Grpalt']['receive'] = ($grpalt_r[0]['Grpalt']['receive']==0)?1:0;
						$mail_notice_time_c = substr($grpalt_r[0]['Grpalt']['mail_notice_time'],0,2);
					}else{
						$mail_notice_time_c='00';
					}
					//sunhy start 2009/05/11 modify for YBR-32
					//$title =$this->title_list();
					$title =$this->title_list($group_id);
					$this->data['Title']['title_flg'] = ($title!=1)?1:0;

					//$altmsg_list =$this->altmsg_list();
					$altmsg_list =$this->altmsg_list($group_id);
					//sunhy end 2009/05/11 modify for YBR-32
					//sunhy start 2009/03/28 modify for JLN-001
					//$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?1:0;
					$this->data['Altmsg']['detail_flg'] = ($altmsg_list[0]['Altmsg']['detail_flg']==0)?0:1;
					//sunhy end 2009/03/28 modify for JLN-001
					$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
					$this->set('up_cast_flag',0);
				}else{
					$mail_notice_time_c = isset($this->data['Grpalt']['mail_notice_time_hour'])?$this->data['Grpalt']['mail_notice_time_hour']:null;

				}
				$this->set('mail_notice_time_c',$mail_notice_time_c);
			}
		}
		return ;
//		$this->render('alert_list');
	}
  
	function grpalt_list($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=1 ";
		$grpalt = $this->Grpalt->findAll($condition);
		return $grpalt;

	}
	
	/* グループ共通設定テーブルのデータ */
	function add_grpalt($group_id,$checkbox_flag,$add_flag){
//		echo "add_grpalt<br>";
		$getUserGroup = $this->_getUserGroup();
//		$getUserGroup = 1;
		$grpalt=$this->Grpalt->grpalt_list_flag($group_id,1);
		if($grpalt == 1){
			$this->edit_grpalt($group_id,$checkbox_flag);
		}else{

			if($checkbox_flag == 1) {
//				echo "add_grpalt :up_cast=1<br>";
				if(isset($this->data["Grpalt"]["mail_notice"]))
				{
					$mail_notice = $this->data["Grpalt"]["mail_notice"];
//					echo $mail_notice;
					if($mail_notice == 2){
						$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
					}else{
						$mail_notice_time = '00:00:00';
					}
					$receive = ($this->data["Grpalt"]["receive"] == 1)?0:1;

					if(!empty($mail_notice)){
						$grpalt=$this->grpalt_list($group_id);
						$popup = ($this->data["Grpalt"]["popup"] == 1)?1:0;
						//sunhy start 2009/03/28 modify for JLN-001
						/*$insertgrpalt=Array(
						'Grpalt' => Array(
						'group_id' => $group_id,
						'mail_notice' => $mail_notice,
						'mail_notice_time' => $mail_notice_time,
						'receive' =>$receive,
						'popup' =>$popup,
						'up_cast' => 1,
						'type' => 1,
						));
//						echo "============1===============";
//var_dump($insertgrpalt,true);
						$this->Grpalt->save($insertgrpalt);*/
						$this->MailPopupController->setMailPop(null, $group_id, $mail_notice, $mail_notice_time, $popup, 1, $receive, 1, 'Grpalt');
						//sunhy end 2009/03/28 modify for JLN-001
						$this->set('mail_notice_time_c',substr($mail_notice_time,0,2));
						if($add_flag == 1){
								//sunhy start 2009/05/11 modify for YBR-32
								//if($getUserGroup == 1){
								//sunhy end 2009/05/11 modify for YBR-32
									//sunhy start 2009/05/11 modify for YBR-32
									//$re_title =$this->title_flag();
									$re_title = $this->title_flag($group_id);
									//sunhy end 2009/05/11 modify for YBR-32
									if($re_title == 0){
										//sunhy start 2009/05/11 modify for YBR-32
										//$this->addTitle();
										$this->addTitle($group_id);
										//sunhy end 2009/05/11 modify for YBR-32
									}else{ 
										//sunhy start 2009/05/11 modify for YBR-32
										//$this->editTitle($re_title);
										$this->editTitle($re_title,$group_id);
										//sunhy end 2009/05/11 modify for YBR-32
									}
									//sunhy start 2009/05/11 modify for YBR-32
									//$re_msg =$this->altmsg_flag();
									$re_msg = $this->altmsg_flag($group_id);
									if($re_msg == 0){
										$this->addAltmsg($group_id);
									}else{
										$this->editAltmsg($re_msg, $group_id);
									}
									//sunhy end 2009/05/11 modify for YBR-32
									//xinw start 20090203
									//modify for ASP4-031
									/*if($re_msg == 0){
										echo "addAltmsg<br>";
										$this->addAltmsg();
									}else{ echo "editAltmsg<br>";
										$this->editAltmsg($re_msg);
									}*/
									$this->alert_list();
									//xinw end 20090203
								//sunhy start 2009/05/11 modify for YBR-32
								//}
								//sunhy end 2009/05/11 modify for YBR-32
						}
					}
				}
			}elseif($checkbox_flag == 0) {
//				echo "add_grpalt :up_cast=0<br>";
				//sunhy start 2009/03/28 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'group_id' => $group_id,
				'mail_notice' => 3,
				'popup' =>1,
				'receive' =>1,
				'mail_notice_time' => '00:00:00',
				'type' => 1,
				'up_cast' => 0,
				));
//				echo "============2===============";
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop(null, $group_id, 3, '00:00:00', 1, 0, 1, 1, 'Grpalt');
				//sunhy end 2009/03/28 modify for JLN-001
				$this->set('mail_notice_time_c','00');
				$this->set('up_cast_flag',0);
				$this->data["Grpalt"]["mail_notice"] = 3;
			 	$this->data["Grpalt"]["popup"] = 1;
				//sunhy start 2009/05/11 modify for YBR-32
				//$title =$this->title_list();
				$title =$this->title_list($group_id);
				//sunhy end 2009/05/11 modify for YBR-32
				$this->data['Title']['title_flg'] = ($title!=1)?1:0;
				//sunhy start 2009/05/11 modify for YBR-32
				//$altmsg_list =$this->altmsg_list();
				//$altmsg_list_detail =$this->altmsg_list_detail();
				$altmsg_list = $this->altmsg_list($group_id);
				$altmsg_list_detail = $this->altmsg_list_detail($group_id);
				//sunhy end 2009/05/11 modify for YBR-32
				//sunhy start 2009/03/28 modify for JLN-001
				//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
				$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
				//sunhy end 2009/03/28 modify for JLN-001
				$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
			}
		}
	}

	/*  編集グループ共通 */
	function edit_grpalt($group_id,$checkbox_flag){
//		echo "edit_grpalt<br>";

		$grpalt_id = $this->grpalt_list_id($group_id);
		if($checkbox_flag == 1) {
//			echo "edit_grpalt :up_cast=1<br>";
			if($this->data["Grpalt"]["mail_notice"] == 2){
				$mail_notice_time = $this->data['Grpalt']['mail_notice_time_hour'].":00:00";
			}else{
				$mail_notice_time = '00:00:00';
			}
			$receive = ($this->data["Grpalt"]["receive"] == 1)?0:1;
			$popup = ($this->data["Grpalt"]["popup"] == 1)?1:0;
			if(isset($this->data["Grpalt"]["mail_notice"])){
				//sunhy start 2009/03/28 modify for JLN-001
				/*$insertgrpalt=Array(
				'Grpalt' => Array(
				'id' => $grpalt_id,
				'group_id' => $group_id,
				'mail_notice' => $this->data["Grpalt"]["mail_notice"],
				'mail_notice_time' => @$mail_notice_time,
				'popup' =>$popup,
				'receive' =>$receive,
				'type'=>1,
				'up_cast' => 1,
				));
				
				$this->Grpalt->save($insertgrpalt);*/
				$this->MailPopupController->setMailPop($grpalt_id, $group_id, $this->data["Grpalt"]["mail_notice"], $mail_notice_time, $popup, 1, $receive, 1, 'Grpalt');
				//sunhy end 2009/03/28 modify for JLN-001
				$getUserGroup = $this->_getUserGroup();
				//sunhy start 2009/05/11 modify for YBR-32
				//if($getUserGroup == 1){
				//sunhy end 2009/05/11 modify for YBR-32
					//sunhy start 2009/05/11 modify for YBR-32
					//$re_title =$this->title_flag();
					$re_title =$this->title_flag($group_id);
					//sunhy start 2009/05/11 modify for YBR-32
					if($re_title !=0){
						//sunhy start 2009/05/11 modify for YBR-32
						//$this->editTitle($re_title);
						$this->editTitle($re_title, $group_id);
						//sunhy end 2009/05/11 modify for YBR-32
					}else{
						//sunhy start 2009/05/11 modify for YBR-32
						//$this->addTitle();
						$this->addTitle($group_id);
						//sunhy end 2009/05/11 modify for YBR-32
					}
					//sunhy start 2009/05/11 modify for YBR-32
					//$re_msg =$this->altmsg_flag();
					$re_msg =$this->altmsg_flag($group_id);
					//sunhy end 2009/05/11 modify for YBR-32
					if($re_msg !=0){
					//debug($re_msg);
						//sunhy start 2009/05/11 modify for YBR-32
						//$this->editAltmsg($re_msg);
						$this->editAltmsg($re_msg,$group_id);
						//sunhy end 2009/05/11 modify for YBR-32
					}else{
						//sunhy start 2009/05/11 modify for YBR-32
						//$this->addAltmsg();
						$this->addAltmsg($group_id);
						//sunhy end 2009/05/11 modify for YBR-32
					}
				//sunhy start 2009/05/11 modify for YBR-32
				//}
				//sunhy end 2009/05/11 modify for YBR-32
				$this->set('mail_notice_time_c',substr($mail_notice_time,0,2));
				//==================================================
//				echo "============3===============";
//				$this->GenerateFiles->hook_by_group($group_id, array('web'));
//				$this->GenerateFiles->hook_by_group(1, array('popup'));
//				$this->GenerateFiles->hook_by_ps(0, array("web"));
// 				$this->GenerateFiles->hook_by_ps(0, array("popup"));
 				//sunhy start 2009/05/11 modify for YBR-32
 				//$this->GenerateFiles->hook_by_ps(0, array("web", "popup"));
 				$this->GenerateFiles->hook_by_ps(0, array("web", "popup"), $group_id);
 				//sunhy end 2009/05/11 modify for YBR-32
				
				$contro= $this->alert_list();
			}
		}elseif($checkbox_flag == 0) {
//			echo "edit_grpalt :up_cast=0<br>";
			//sunhy start 2009/03/28 modify for JLN-001
			/*$insertgrpalt=Array(
			'Grpalt' => Array(
			'id' => $grpalt_id,
			'group_id' => $group_id,
			'type' => 1,
			'up_cast' => 0,
			));
//			echo "============4===============";
			$this->Grpalt->save($insertgrpalt);*/
			$this->MailPopupController->setMailPop($grpalt_id, $group_id, null, null, null, 0, null, 1, 'Grpalt');
			//sunhy end 2009/03/28 modify for JLN-001
			$this->set('mail_notice_time_c','00');
			$this->data["Grpalt"]["mail_notice"] = 3;
			$this->data["Grpalt"]["popup"] = 1;
			$this->set('up_cast_flag',0);
			//sunhy start 2009/05/11 modify for YBR-32
			//$title =$this->title_list();
			$title =$this->title_list($group_id);
			//sunhy end 2009/05/11 modify for YBR-32
			$this->data['Title']['title_flg'] = ($title!=1)?1:0;

			//sunhy start 2009/05/11 modify for YBR-32
			//$altmsg_list =$this->altmsg_list();
			//$altmsg_list_detail =$this->altmsg_list_detail();
			$altmsg_list =$this->altmsg_list($group_id);
			$altmsg_list_detail =$this->altmsg_list_detail($group_id);
			//sunhy end 2009/05/11 modify for YBR-32
			//sunhy start 2009/03/28 modify for JLN-001
			//$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?1:0;
			$this->data['Altmsg']['detail_flg'] = ($altmsg_list_detail!=1)?0:1;
			//sunhy end 2009/03/28 modify for JLN-001
			$this->data['Altmsg']['message'] = $altmsg_list[0]['Altmsg']['message'];
		}
		

	}


	/*
	*件名管理情報追加
	*/

	//sunhy start 2009/05/11 modify for YBR-32
	//function addTitle(){
	function addTitle($group_id=null){
		//echo "addtitleaddadadadadaddddadadadadadadaad<br>";
		if(empty($group_id)){
			$group_id=1;
		}
	//sunhy end 2009/05/11 modify for YBR-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'title_flg' => $title_flg,
		'type' =>1,
		//sunhy start 2009/05/11 added for YBR-32
		'group_id'=>$group_id,
		//sunhy end 2009/05/11 added for YBR-32
		));
		$this->Title->save($inserttitle);

	}
	/*
	*件名管理情報追加
	*/
	//sunhy start 2009/05/11 modify for YBR-32
	//function editTitle($id){
	function editTitle($id,$group_id=null){
		//echo "editediteditediteditediteditediteditediteditedit<br>";
		if(empty($group_id)){
			$group_id=1;
		}
	//sunhy end 2009/05/11 modify for YBR-32
		if(isset($this->data['Title']['title_flg'])&&($this->data['Title']['title_flg'] == 1)){
			$title_flg = 0;
		}else{
			$title_flg = 1;
		}
		$inserttitle=Array(
		'Title' => Array(
		'id'=>$id,
		'title_flg' => $title_flg,
		'type' => 1,
		//sunhy start 2009/05/11 added for YBR-32
		'group_id'=>$group_id,
		//sunhy end 2009/05/11 added for YBR-32
		));
		$this->Title->save($inserttitle);

	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/11 modify for YBR-32
	//function addAltmsg(){
	function addAltmsg($group_id=null){
		if(empty($group_id)){
			$group_id=1;
		}
	//sunhy end 2009/05/11 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message =$this->data['Altmsg']['message'];

		//sunhy start 2009/03/28 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'message_id' => 'E0001',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/11 added for YBR-32
		$this->MailPopupController->setAltMsg('E0001', $message, $detail_flg, null, $group_id);
		//sunhy end 2009/05/11 added for YBR-32
		//sunhy end 2009/03/28 modify for JLN-001
//		$this->GenerateFiles->hook_by_group(1, array('popup'));
//		$this->GenerateFiles->hook_by_ps(0, array("web"));
//		$this->GenerateFiles->hook_by_ps(0, array("popup"));
		//sunhy start 2009/05/11 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("web", "popup"));
		$this->GenerateFiles->hook_by_ps(0, array("web", "popup"), $group_id);
		//sunhy start 2009/05/11 modify for YBR-32
	}
	/*
	*エラー情報変更
	*/

	//sunhy start 2009/05/11 modify for YBR-32
	//function editAltmsg($id){
	function editAltmsg($id,$group_id=null){
		if(empty($group_id)){
			$group_id=1;
		}
	//sunhy end 2009/05/11 modify for YBR-32
		if(isset($this->data['Altmsg']['detail_flg'])&&($this->data['Altmsg']['detail_flg'] == 1)){
			$detail_flg = 0;
		}else{
			$detail_flg = 1;
		}
		$message=null;
		if(isset($this->data['Altmsg']['message']))
		{
		$message =$this->data['Altmsg']['message'];
		}
		//sunhy start 2009/03/28 modify for JLN-001
		/*$insertaltmsg=Array(
		'Altmsg' => Array(
		'id'=>$id,
		'message_id' => 'E0001',
		'message' => $message,
		'detail_flg' => $detail_flg,
		));
		$this->Altmsg->save($insertaltmsg);*/
		//sunhy start 2009/05/11 added for YBR-32
		$this->MailPopupController->setAltMsg('E0001', $message, $detail_flg, $id, $group_id);
		//sunhy end 2009/05/11 added for YBR-32
		//sunhy end 2009/03/28 modify for JLN-001
//		$this->GenerateFiles->hook_by_group(1, array('popup'));
//		$this->GenerateFiles->hook_by_ps(0, array("web"));
//		$this->GenerateFiles->hook_by_ps(0, array("popup"));
		//sunhy start 2009/05/11 modify for YBR-32
		//$this->GenerateFiles->hook_by_ps(0, array("web", "popup"));
		$this->GenerateFiles->hook_by_ps(0, array("web", "popup"), $group_id);
		//sunhy start 2009/05/11 modify for YBR-32
	}

	function _getemail($group_id){
		//$group_id= $this->_getUserGroup();
		$group_id = $group_id;
		$con =  array("User.group_id =".$group_id." ");
		$asso_email= array(
		'Mail : mails' => array('Mail.user_id = User.id')
		);
		$data_email= $this->User->findByAsso($con, array('Mail.mail_address','User.group_id'), $order=null, null, null, $asso_email);
		//debug($data_email);
		return $data_email;

	}
	
	//sunhy start 2009/05/11 modify for YBR-32
	//function title_list(){
	function title_list($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] = " Title.group_id=$group_id";
		//$condition =" Title.type=1 and Title.id !=0";
		$condition []=" Title.type=1 and Title.id !=0";
	//sunhy end 2009/05/11 modify for YBR-32
		$title = $this->Title->findAll($condition);
		//debug($grpalt);
		if(count($title) == 1){
			$flag = $title[0]['Title']['title_flg'];
		}else{
			$flag =2;
		}
		return $flag;
	}
	//sunhy start 2009/05/11 modify for YBR-32
	//function altmsg_list_detail(){
	function altmsg_list_detail($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[]=" Altmsg.group_id = $group_id";
		//$condition =" Altmsg.message_id='E0001' ";
		$condition[] =" Altmsg.message_id = 'E0001' ";
	//sunhy end 2009/05/11 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$array = $altmsg["0"]["Altmsg"]["detail_flg"];
		}else{
			$array = 2;
		}
		return $array;
	}
	//sunhy start 2009/05/11 modify for YBR-32
	//function altmsg_list(){
	function altmsg_list($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[]=" Altmsg.group_id=$group_id";
		$condition[] ="Altmsg.message_id='E0001' ";
		//$condition ="Altmsg.message_id='E0001' ";
	//sunhy end 2009/05/11 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($altmsg,true);
		if(count($altmsg) == 1){
			$array = $altmsg;
		}else{
			$array = 2;
		}
		return $array;
	}
	/* グループ共通の判定 */
	function error_judge_grpalt($content = null,$name2){
		if(empty($content)){
			$errorMessage[$name2][] = 'E-00100';
		}
		if(!empty($content)){
			if(!$this->Validation->maxLength($content,200)){
				$errorMessage[$name2][] = 'E-00300';
			}
		}

		return $errorMessage;
	}
	
	/* 件名管理情報 */
	//sunhy start 2009/05/11 modify for YBR-32
	//function title_flag(){
	function title_flag($group_id=null){
		$condition=array();
		if(!empty($group_id)){
			$condition[]="Title.group_id=$group_id";
		}
		//$condition =" Title.type=1 ";
		$condition[] = " Title.type=1 ";
	//sunhy end 2009/05/11 modify for YBR-32
		$title = $this->Title->findAll($condition);
		//debug($grpalt);
		if(count($title) == 1){
			$flag = $title[0]['Title']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	//sunhy start 2009/05/11 modify for YBR-32
	//function altmsg_flag(){
	function altmsg_flag($group_id=null){
		$condition=array();
		if(empty($group_id)){
			$group_id=1;
		}
		$condition[] ="Altmsg.group_id=$group_id";
		//$condition =" Altmsg.message_id='E0001' ";
		$condition[] =" Altmsg.message_id='E0001' ";
	//sunhy end 2009/05/11 modify for YBR-32
		$altmsg = $this->Altmsg->findAll($condition);
		//debug($grpalt);
		if(count($altmsg) == 1){
			$flag = $altmsg[0]['Altmsg']['id'];
		}else{
			$flag = 0;
		}
		return $flag;
	}
	
	function grpalt_list_id($group_id){
		$condition =" Grpalt.group_id =".$group_id." and type=1 ";
		$grpalt = $this->Grpalt->findAll($condition);
		if(count($grpalt) == 1){
			$id = $grpalt[0]["Grpalt"]["id"];
		}else{
			$id =0;
		}
		return $id;

	}
	
	function _findOneSun($group_id){
		$criteria=" Group.parent_id=".$group_id." ";
		$parent= $this->Group->findAll($criteria);
		//debug($parent);
		if(count($parent) != 0){
			foreach ($parent as $value){
				$id =$value['Group']['id'];
				//debug($id);
				$grpalt =$this->grpalt_list($id);
				if(count($grpalt) == 1){
					$grpalt_up_cast = $grpalt[0]['Grpalt']['up_cast'];
					$array[$id] =$grpalt_up_cast;
					return $array;
					exit();
				}else{
					return 2;
				}

			}
		}else{
			return 2;
		}

	}
	//=========================================================================cp==========================
}
?>