<?php
class SystemMonitorAccesslogsController extends AppController
{
    
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    var $components = array ('Pagination', 'Lv');
    var $uses=array('Accesslog','Setacclog','Group', 'Host','Mailserver','Module', 'Validation','Configure');
    var $layout='system';

    function beforeFilter()
    {
		parent::beforeFilter();
    	$this->pageTitle =__('title',$return = true);// 'LVシステム管理／稼動モニター／アクセスログ';
//	if(isset($_POST['forHideVar1'])){
//    		$this->set('forHideVar', $_POST['forHideVar1']);
//	}
//	else if(isset($_POST['forHideVar'])){
//    		$this->set('forHideVar', $_POST['forHideVar']);
//	}


//================================yin c=======================    	
		if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
//	    		debug($_POST['forHideVar']);
//	    		echo "forHideVar";
		}
		else if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
//	    		debug($_POST['forHideVar1']);
//	    		echo "forHideVar1";
		}
//================================yin c=======================


//		$this->Configure->write('debug',0);
    }
    
    function index()
    {	 

	  $search= $this->requestAction('/system_monitor_accesslogs/search',array('return'));
	  $this->set('search',$search);
    }
    
    function search($do=null,$sta_day=null,$end_day=null)
    {
    	$this->layout="ajax";
		$err=null;
    	$where = array('1=1');
		$asso = array(
//									'Rltpolmod : rltpolmods : LEFT' => array('Poll.id = Rltpolmod.poll_id'),
										'Mailserver : mailservers : LEFT' => array('Poll.id = Mailserver.poll_id'),
										
										);
//		debug($this->params);
		if($this->data&& ($do=='s' ))
//		if($this->data&& ($do=='s' || $do=='csv'))
		{
			
			if($this->data['Accesslog']['check']=='1')
			{
				//$sta_day=$this->data['Accesslog']['start_year']."-".$this->data['Accesslog']['start_month']."-".$this->data['Accesslog']['start_day'];
				$sta_day=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], $this->data['Accesslog']['start_day']);
				//$end_day=$this->data['Accesslog']['end_year']."-".$this->data['Accesslog']['end_month']."-".$this->data['Accesslog']['end_day'];
				$end_day=$this->_dateTrans($this->data['Accesslog']['end_year'], $this->data['Accesslog']['end_month'], $this->data['Accesslog']['end_day']);
    		
    			if($sta_day>$end_day)
    			{
    				$err[]=__('E-01000',$return = true);
    			}
    			if(false == checkdate($this->data['Accesslog']['start_month'],$this->data['Accesslog']['start_day'], $this->data['Accesslog']['start_year']) || false == checkdate($this->data['Accesslog']['end_month'],$this->data['Accesslog']['end_day'], $this->data['Accesslog']['end_year']) )
					{
						$err[]=__('E-01100',$return = true);
					}
					
					
				if(empty($err))
				{
				$where[]="Accesslog.access_time BETWEEN '$sta_day' and '$end_day' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
				//$where[]="DATE(Accesslog.access_time)>='".$this->data['Accesslog']['start_year']."/".$this->data['Accesslog']['start_month']."/".$this->data['Accesslog']['start_day']."' ";
				//$where[]="DATE(Accesslog.access_time)<='".$this->data['Accesslog']['end_year']."/".$this->data['Accesslog']['end_month']."/".$this->data['Accesslog']['end_day']."' ";
				}
				$this->set('s_y',$this->data['Accesslog']['start_year']);
				$this->set('s_m',$this->data['Accesslog']['start_month']);
				$this->set('s_d',$this->data['Accesslog']['start_day']);
				$this->set('e_y',$this->data['Accesslog']['end_year']);
				$this->set('e_m',$this->data['Accesslog']['end_month']);
				$this->set('e_d',$this->data['Accesslog']['end_day']);
    			
			}
			else
			{
				if(!empty($this->data['Accesslog']['start_day']))
				{
					if(false == checkdate($this->data['Accesslog']['start_month'],$this->data['Accesslog']['start_day'], $this->data['Accesslog']['start_year']) )
					{
						$err[]=__('E-01100',$return = true);
					}
					if(empty($err))
					{
					$sta_day=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], $this->data['Accesslog']['start_day']);
					//$sta_day=$this->data['Accesslog']['start_year']."-".$this->data['Accesslog']['start_month']."-".$this->data['Accesslog']['start_day'];
					//$where[]="DATE(Accesslog.access_time)='".$this->data['Accesslog']['start_year']."/".$this->data['Accesslog']['start_month']."/".$this->data['Accesslog']['start_day']."' ";
					$where[]="Accesslog.access_time BETWEEN '$sta_day' and '$sta_day' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
					}
				}
				else 
				{
				$sta_date=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], "01");
					//$where[]="YEAR(Accesslog.access_time)=".$this->data['Accesslog']['start_year']." and MONTH(Accesslog.access_time)=".$this->data['Accesslog']['start_month'];
					$where[]="Accesslog.access_time BETWEEN '$sta_date' and '$sta_date' + INTERVAL 1 MONTH - INTERVAL 1 MICROSECOND";
					
				}
				$this->set('s_y',$this->data['Accesslog']['start_year']);
				$this->set('s_m',$this->data['Accesslog']['start_month']);
				$this->set('s_d',$this->data['Accesslog']['start_day']);
			}

		}
		if($do=='p')
		{
			//ページ使用
			if($end_day==null&& $sta_day!=null)
			{
				//$where[]="DATE(Accesslog.access_time)='$sta_day' ";
				$where[]="Accesslog.access_time BETWEEN '$sta_day' and '$sta_day' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			}
			elseif($end_day!=null && $sta_day!=null)
			{
				//$where[]="DATE(Accesslog.access_time)>='$sta_day' ";
				//$where[]="DATE(Accesslog.access_time)<='$end_day' ";
				$where[]="Accesslog.access_time BETWEEN '$sta_day' and '$end_day' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			}
		}
		//============================csv====================	
    	if($do=='csv')
		{
//			debug($this->params);
//			echo $do;
		if(!empty($this->data['Accesslog']['start_day']))
		{
			if($this->data['Accesslog']['check']=='1')
			{
				$sta_date=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], $this->data['Accesslog']['start_day']);
				$end_date=$this->_dateTrans($this->data['Accesslog']['end_year'], $this->data['Accesslog']['end_month'], $this->data['Accesslog']['end_day']);
				//$where[]="DATE(Accesslog.access_time)>='".$this->data['Accesslog']['start_year']."/".$this->data['Accesslog']['start_month']."/".$this->data['Accesslog']['start_day']."' ";
				//$where[]="DATE(Accesslog.access_time)<='".$this->data['Accesslog']['end_year']."/".$this->data['Accesslog']['end_month']."/".$this->data['Accesslog']['end_day']."' ";
				$where[]="Accesslog.access_time BETWEEN '$sta_date' and '$end_date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			}
			else 
			{
				$sta_date=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], $this->data['Accesslog']['start_day']);
				$where[]="Accesslog.access_time BETWEEN '$sta_date' and '$sta_date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
				//$where[]="DATE(Accesslog.access_time)='".$this->data['Accesslog']['start_year']."/".$this->data['Accesslog']['start_month']."/".$this->data['Accesslog']['start_day']."' ";
			}
		}
		else 
		{
			//日がない
			$sta_date=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], "01");
			$where[]="Accesslog.access_time BETWEEN '$sta_date' and '$sta_date' + INTERVAL 1 MONTH - INTERVAL 1 MICROSECOND";
					
			//$where[]="YEAR(Accesslog.access_time)=".$this->data['Accesslog']['start_year']." and MONTH(Accesslog.access_time)=".$this->data['Accesslog']['start_month'];
		}
//			debug($where);
		    $this->csvdown($where,$do);
		    exit;
		
		}
//		if(isset($this->data)&&empty($err))
		if(empty($err))
		{
		//============================csv====================	
//		list($order,$limit,$page) = $this->Pagination->init($where, null, array('ajaxDivUpdate'=>'list','url'=>"/system_monitor_accesslogs/search/p/{$sta_day}/{$end_day}", 'modelClass'=>'Accesslog','ajaxFormId' => NULL, 'style' => 'ajax','sortBy' => $this->Lv->sortBy('Accesslog.access_time ')));	
		list($order,$limit,$page) = $this->Pagination->init($where, null, array('ajaxDivUpdate'=>'list','url'=>"/system_monitor_accesslogs/search/p/{$sta_day}/{$end_day}", 'modelClass'=>'Accesslog', 'style' => 'ajax','sortBy' => $this->Lv->sortBy('Accesslog.access_time')));
		$data = $this->Accesslog->findByAsso($where, array('Accesslog.access_time', 'Accesslog.user_name','Accesslog.access_set','Accesslog.certification'), $order, $limit, $page, null);
//		$datac = $this->Accesslog->findByAsso($where, array('Accesslog.access_time', 'Accesslog.user_name','Accesslog.access_set','Accesslog.certification'), $order, null, null, null);
		//============================csv====================
		}
		if(isset($this->data['Accesslog']['check']))	
		{
//			debug($this->data);
		$this->set('start_year',$this->data['Accesslog']['start_year']); 
		$this->set('start_month',$this->data['Accesslog']['start_month']); 
		$this->set('start_day',$this->data['Accesslog']['start_day']); 
		if(isset($this->data['Accesslog']['end_year']))
		{
		$this->set('end_year',$this->data['Accesslog']['end_year']); 
		$this->set('end_month',$this->data['Accesslog']['end_month']); 
		$this->set('end_day',$this->data['Accesslog']['end_day']); 
		}
		$this->set('ck',$this->data['Accesslog']['check']); 
		}
		//============================csv====================	
	    $this->set('sday',$sta_day); 
	    $this->set('eday',$end_day); 
//	    if($this->data)
//	    {
	    $this->set('data',$data); 
//	    }
//	    $this->set('datac',$datac); 
	    $this->set('err',$err); 
		$this->render('search');
    }
    
    
    function csvdown($where,$do)
    {
//    	debug($where);
//    	debug($do);
        require_once( 'csv/DlFactory.php' );
        
        $asso = array(
//									'Rltpolmod : rltpolmods : LEFT' => array('Poll.id = Rltpolmod.poll_id'),
									'Mailserver : mailservers : LEFT' => array('Poll.id = Mailserver.poll_id'),
						);
        $data = $this->Accesslog->findByAsso($where, array('Accesslog.access_time', 'Accesslog.user_name','Accesslog.access_set','Accesslog.certification'), null, null, null, null);
//        debug($data);
        if($do=='csv')
 
            {	

                $csv = DlFactory::create("system_monitor_accesslogs");
    
                $csv->sendCSVFile($data,$this->data,__('accesslog', true)); 
            }


        
        exit;
       

    }
    
    
    
    
    

    function del()
    {
    	$this->layout='ajax';
    	$err=null;
    	if($this->data['Accesslog']['delradio']=='0')
    	{
//    		echo date('Y').date('m').date('d');
			$del_d=$this->data['Accesslog']['delday'];
			if(!$this->Validation->blank($del_d))
			{
			if($this->Validation->numeric($del_d))
			{
				if($del_d=='0')
				{
					$conditions[]="1=1";
					$this->Accesslog->deleteAll($conditions);
				}
				else 
				{
	    		$del_day= date("Y/m/d",mktime(0,0,0,date('m'),date('d')-$del_d,date('Y')));
	    		$conditions[]="access_time<'".$del_day."' ";
	    		$this->Accesslog->deleteAll($conditions);
				}
			}
			else 
			{    
				$err[]=__('accesslogdelete',$return = true)."　".__('E-00500',$return = true);
			}
			}
			else 
			{    
				$err[]=__('accesslogdelete',$return = true)."　".__('E-00100',$return = true);
			}
				
    	}
    	elseif($this->data['Accesslog']['delradio']=='1')
    	{
			$sta_day=$this->_dateTrans($this->data['Accesslog']['start_year'], $this->data['Accesslog']['start_month'], $this->data['Accesslog']['start_day']);
			$end_day=$this->_dateTrans($this->data['Accesslog']['end_year'], $this->data['Accesslog']['end_month'], $this->data['Accesslog']['end_day']);
    		//$sta_day=$this->data['Accesslog']['start_year']."/".$this->data['Accesslog']['start_month']."/".$this->data['Accesslog']['start_day'];
    		//$end_day=$this->data['Accesslog']['end_year']."/".$this->data['Accesslog']['end_month']."/".$this->data['Accesslog']['end_day'];
    		if($sta_day>$end_day)
    		{ 
    			$err[]=__('E-01000',$return = true);
    		}
    		if(false == checkdate($this->data['Accesslog']['start_month'],$this->data['Accesslog']['start_day'],$this->data['Accesslog']['start_year']) || false == checkdate($this->data['Accesslog']['end_month'],$this->data['Accesslog']['end_day'],$this->data['Accesslog']['end_year']))
					{
						$err[]=__('E-01100',$return = true);
					}
    		if(empty($err)) 
    		{
    		//$conditions[]="DATE(access_time) >='".$sta_day."' ";
    		//$conditions[]="DATE(access_time) <='".$end_day."' ";
			$conditions[]="access_time BETWEEN '$sta_day' and '$end_day' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
					
    		$this->Accesslog->deleteAll($conditions);
    		}
    		
    		$this->set('s_y',$this->data['Accesslog']['start_year']);
			$this->set('s_m',$this->data['Accesslog']['start_month']);
			$this->set('s_d',$this->data['Accesslog']['start_day']);
			$this->set('e_y',$this->data['Accesslog']['end_year']);
			$this->set('e_m',$this->data['Accesslog']['end_month']);
			$this->set('e_d',$this->data['Accesslog']['end_day']);
    	}
    	
    	
     $this->set('err',$err); 	
//	var_dump(array($this->params['form']['cbid']));
//	$this->search();
	$this->m_set();
//	$this->render('search');
    }
   
   /**
    * 
    *ログオン履歴の取得設定と削除画面
    * 
    */
     function m_set($do=null,$default='1')
    {
		
    	$this->layout='ajax';
    	
    	if($do=='set')
    	{
    		if($this->data['Accesslog']['check1']=='1')
    		{
    			$getlogflg='1';
    		}
    		else 
    		{
    			$getlogflg='0';
    		}
    		$sensor['id']=1;
    		$sensor['getlogflg']=$getlogflg;
	    	$this->Setacclog->save($sensor);
//			echo $this->data['Accesslog']['check1']; 
//echo "======================================";
    	}
    	$ck=$this->Setacclog->findAll();
    	if(isset($ck[0]['Setacclog']['getlogflg']) && $ck[0]['Setacclog']['getlogflg']=='1')
    		{
    			$getlogflgck="1";
    		}
    		else 
    		{
    			$getlogflgck="0";
    		}
    	$this->set('accflg',$getlogflgck);
//    	debug($ck);
//    	echo $getlogflgck;
    	
    
    	
    	
    	
    	$this->render('m_set');
    	
    }
   function _dateTrans($year, $mon, $day)
   {
	return sprintf("%04d-%02d-%02d", $year, $mon, $day);
   }
}
?>