<?php

/*********************************************************************
*@filename system_monitor_databackups_controller.php
*@description SystemMonitorDatabackupsControllerクラスのインプリメンテーション
*@note
*@histories  rivision	author		date		comment
*                2.0      yuanxiaojun     2009/03/30   modify for LV20-YB-004
********************************************************************/
class SystemMonitorDatabackupsController extends AppController
{

	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv','Form');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host','Hstlog','Rlthstgrp','Grpauth','Poll','Pollog','Rltuserauth','User','Configure','Validation','Backupdeletemark','License','Backupdir');
	var $layout='system';

	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('title',$return = true);
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);

		}
		else if(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);

		}
	}

	function index()
	{
		$databackup= $this->requestAction('/system_monitor_databackups/databackup',array('return'));
		$this->set('databackup',$databackup);
	}


	function databackup($id=null,$idreset=null){
		$this->layout="ajax";

		$backup_address=$this->data['Backupdeletemark']['backup_dir'];//バックアップ保存フォルダの設定画面
		$changed=$this->data['Backupdeletemark']['change'];//バックアップ保存フォルダの設定画面
		if(!empty($changed)){
			$this->preservedchange($backup_address);
		}
		$restore_flag=null;//リストアフラグ
		$work_percent=null;
		$flag=null;
		$restore_file=null;
		$err_flag=null;
		if(!empty($this->data['backup']['delete_flage'])){
			$name=$_SESSION['delete_err'];
			$delete_data="DELETE FROM backupdeletemarks WHERE file_name='{$name}'";
			$this->Backupdeletemark->query($delete_data);
		}
		if((id!=12||$id!=13)&&!empty($_SESSION['delete_err'])){
			session_unregister('delete_err');
		}
		if($id==12||$id==13){

			$err_flag=$id;
			$_SESSION['delete_err']=$idreset;

		}
		$this->set('err_flag',$err_flag);
		//ファイルをリセットしています



		if(!empty($_SESSION['file_insert'])){
			$this->resetfile();
			$_SESSION['seterrmessage']=__('restore_over',$return = true);
			session_unregister('restore');
			session_unregister('file_insert');
		}
		if($_SESSION['restore']==5){
			$err_set_message=null;
			$ini_array=null;
			$dir=RESTORE_FILE_PATH;
			//statusの存在をチェックする
			$dir_flag=false;
			while ($dir_flag==false) {
				$dh=opendir($dir);
				while ($file=readdir($dh)) {
					if($file=='status') {
						$file_dir=$dir."\\status";
						$ini_array = parse_ini_file($file_dir."\\status.ini",true);
						if(!empty($ini_array)){
							$dir_flag=true;
						}
					}
				}
				closedir($dh);

			}
			$state=null;
			if(!empty($ini_array)){
				foreach ($ini_array as $key=>$valuesdata){
					foreach ($valuesdata as $key=>$values){
						if(strtolower($key)=='state'){
							$state=strtolower($values);
						}

					}
				}
				if($state==7){//リストアが完成しました
					$_SESSION['file_insert']='file_insert';
					$restore_flag='reload';
					$errmessage=__('file_insert',$return = true);
				}
				if($state==8){//リストアを失敗する
					$err_set_message=__('err_restore',$return = true);
				}
				if($state==9){//バージョンerr
					$err_set_message=__('version_err',$return = true);
				}

				if($state==7||$state==8||$state==9){
					$file_dir=$dir."\\status";
					$dh=opendir($file_dir);
					while ($file=readdir($dh)) {

						if($file!='.'&&$file!='..') {
							unlink($file_dir.'\\'.$file);
						}
					}
					closedir($dh);
					rmdir($file_dir);
				}
				session_unregister('restore');
				if($state==6){
					$dir_flag=false;
					$_SESSION['restore']=5;
				}

			}
			if($dir_flag==false){
				$errmessage=__('restoring',$return = true);
				$restore_flag='reload';
				$this->set('restore_flag',$restore_flag);
			}

			$this->set('seterrmessage',$err_set_message);

		}
		if($id==5){
			$_SESSION['restore']=$id;
			$errmessage=__('restoring',$return = true);
			$restore_flag='reload';
			$this->set('restore_flag',$restore_flag);
		}

		//リストアしない



		if($id!=5&&$_SESSION['restore']!=5){
			if(!empty($id)){
				$flag=$id;
			}
			$countsize=null;
			//バックアップしたの設定情報を検索
			$set_file_search=$this->data_search(2,2,"Backupdeletemark.work_end DESC");
			$this->set('set_file_search',$set_file_search);
			//ファイルサイズの使用量



			if(count($set_file_search)>0){
				foreach ($set_file_search as $rec){
					$filesize=$rec['Backupdeletemark']['file_size'];
					$countsize=$countsize+$filesize;
				}
			}
			$seting_file_flag=array('Backupdeletemark.flag =2 and (Backupdeletemark.state =1 or Backupdeletemark.state =0)');
			$seting_file_search=$this->Backupdeletemark->findAll($seting_file_flag,null,null,null,null,null);

			//ログ情報を検索
			$log_file_search=$this->data_search(3,2,"Backupdeletemark.work_end DESC");
			$this->set('log_file_search',$log_file_search);
			if(count($log_file_search)>0){
				foreach ($log_file_search as $rec){
					$filesize=$rec['Backupdeletemark']['file_size'];
					$countsize=$countsize+$filesize;
				}
			}

			$loging_file_flag=array('Backupdeletemark.flag =3 and (Backupdeletemark.state =1 or Backupdeletemark.state =0)');
			$loging_file_search=$this->Backupdeletemark->findAll($loging_file_flag,null,null,null,null,null);


			$backup_address=__('not_assigned',$return = true);
			$init_dir=$this->Backupdir->findAll(null,null,null,null,null,null);
			if(!empty($init_dir[0]['Backupdir']['backup_dir'])){
				$backup_address=$init_dir[0]['Backupdir']['backup_dir'];
			}
			if($countsize>0){
				$countsize=number_format(ceil($countsize/1024));
			}
			$this->set('countsize',$countsize);
			$this->set('backup_address',$backup_address);
			//ボタンくを押す時に、




			if($id==3||$id==2){
				$address_message=$this->dir_check($backup_address);
				if($address_message=='err_path'){

					$message=__('err_path',$return = true);
					if($id==3)	{
						$this->set('logerrmessage',$message);
					}
					if($id==2)	{
						$this->set('seterrmessage',$message);
					}

					$this->render('databackup');
					exit();
				}
			}

			if(empty($id)&&(!empty( $_SESSION['flag']))){
				$flag= $_SESSION['flag'];
			}
			if(!empty($flag)){
				$_SESSION['flag']=$flag;
			}


			$year=null;
			$month=null;
			$backuptime=null;
			$times_flag=false;
			//
			if($id==3){
				$year=trim($this->data['Backupdeletemark']['set_year']);
				$month=trim($this->data['Backupdeletemark']['set_month']);
				$times_flag= $this->timesCheck($year,$month);
				//日期を入力正しくない



				if($times_flag==true){
					$this->set('logerrmessage',__('input_date',$return = true));
					$this->render('databackup');
					exit();
				}
				$backuptime=$year.'-'.$month.'-'.'01 00:00:00';
			}

			$backup=null;
			$to_backup=null;
			// [バックアップ]ボタンを押す時,同じ操作を検索する
			if(!empty($id)) {
				$backup=$this->data_search($id,0);
				$to_backup=$this->data_search($id,1);
			}

			//同じ操作が存在する時、



			if((!empty($backup)||!empty($to_backup))&&!empty($id)){
				$err_path_message= __('set_backup_err',$return = true);
				if($id==3){
					$this->set('logerrmessage',$err_path_message);
				}
				if($id==2){
					$this->set('seterrmessage',$err_path_message);
				}
				$this->render('databackup');
				exit();
			}
			//DBにstateを設定する



			if($id==3||$id==2){
				$insert ="INSERT INTO backupdeletemarks (flag,work_percent,table_name,set_month,work_start,
   		work_end,set_year,state,backup_dir,file_size,file_name,work_time)
   		VALUES({$flag},0,null,null,null,null,null,0,'{$backup_address}',null,null";
				if(empty($backuptime)){
					$insert=$insert.','.'null)';
				}else{
					$insert=$insert.','."'".$backuptime."')";
				}
				$this->Backupdeletemark->query($insert);

			}
			$backuppercent=null;
			if($flag==3||$flag==2) {
				$flag_Backup=array('Backupdeletemark.flag ='.$flag.' and (Backupdeletemark.state =1 or Backupdeletemark.state =0)');
				$work_percent=$this->Backupdeletemark->findAll($flag_Backup,array('Backupdeletemark.work_percent'),null,null,null,-1);

				$backuppercent=count($work_percent);
			}
			if(empty($backuppercent)){
				session_unregister('flag');
			}
			$refresh=null;
			if(!empty($backuppercent)&&(!empty($flag))){
				if($flag==2){
					$seting_file_search=$work_percent;
				}
				if($flag==3){
					$loging_file_search=$work_percent;
				}
				$refresh='reload';

			}
			if(!empty($seting_file_search)){
				$work_percent=substr($seting_file_search[0]['Backupdeletemark']['work_percent'],2,2);
				$seting_file_search[0]['Backupdeletemark']['work_percent']=$this->percent_check($work_percent);
			}
			if(!empty($loging_file_search)){
				$work_percent=substr($loging_file_search[0]['Backupdeletemark']['work_percent'],2,2);
				$loging_file_search[0]['Backupdeletemark']['work_percent']=$this->percent_check($work_percent);

			}
			$this->set('seting_file_search',$seting_file_search);
			$this->set('loging_file_search',$loging_file_search);
			//ログ情報のバックアップ時に、データーは存在しない。



			$backup_err=array('Backupdeletemark.flag =3 and (Backupdeletemark.state =10)');
			$log_err=$this->Backupdeletemark->findAll($backup_err,null,null,null,null,-1);
			if(!empty($log_err)){
				$err_delete="DELETE FROM backupdeletemarks WHERE flag=3 AND state=10";
				$this->Backupdeletemark->query($err_delete);
				$message=__('backup_err',$return = true);
				$this->set('logerrmessage',$message);
				$restore_flag=null;
				$restore_file=null;
				$refresh=null;
			}


		}
		$this->set('restore_file',$restore_file);
		$this->set('countsize',$countsize);
		$this->set('refresh',$refresh);

		//yuanxiaojun start 2009/03/30 added for added for LV20-YB-004
		$this->set('uplflag',20);
		//yuanxiaojun end 2009/03/30 added for added for LV20-YB-004
		$this->set('restore_flag',$restore_flag);

		$this->set('errmessage',$errmessage);
		$this->render('databackup');
	}

	/**
       * 入力の日期をチェックする
       * yuanxiaojun
       * @param unknown_type $year
       * @param unknown_type $month
       */ 
	function timesCheck($year=null,$month=null){
		$time_check=false;
		$delete_time=null;
		if(empty($year)||empty($month)||!ereg("^[0-9]+$",$year)||!ereg("^[0-9]+$",$month)){
			$time_check=true;
		}
		if($month>12||(strlen($year)!=4)||($month==00)||$year<1900){
			$time_check=true;
		}
		if(strlen($month)==1){
			$month='0'.$month;
		}
		if(!empty($year)&&(!empty($month))){
			$delete_time=$year.'-'.$month.'-'.'01 00:00:00';
		}
		$showtime=date("Y-m-d H:i:s");
		if($delete_time>$showtime){
			$time_check=true;
		}
		return $time_check;
	}

	/**
       * リストア,中止する,削除する
       * yuanxiaojun
       * @param unknown_type $flag
       * @param unknown_type $id
       * @param unknown_type $timedata
       */ 
	function execut($flag=null,$id=null,$timedata=null){
		$this->layout="ajax";
		$time=null;
		$i=2;
		$delete_name=null;
		if(!empty($timedata)){
			$time=$this->component_time($timedata);
		}
		//ログ情報
		if($flag==3){
			if($id=='discont'){
				$flag_Backup=array('Backupdeletemark.flag =3 and (Backupdeletemark.state =1 or Backupdeletemark.state =0)');
				$work_percent=$this->Backupdeletemark->findAll($flag_Backup,array('Backupdeletemark.work_percent'),null,null,null,-1);
				session_unregister('refresh');
				if(count($work_percent)!=0){
					$delete_data="UPDATE backupdeletemarks SET state=3 WHERE (state=1 or state=0) and flag=".$flag;
				}else{
					$errmessage=__('err_discont',$return = true);
					$this->set('logerrmessage',$errmessage);
					$this->databackup();
					exit();
				}
			}
			if($id=='delete'){
				$delete_search=array("Backupdeletemark.state =2","Backupdeletemark.flag =3","Backupdeletemark.work_end='{$time}'");
				$file_name=$this->Backupdeletemark->findAll($delete_search,null,null,null,null,null);
				if(empty($file_name)){
					$errmessage=__('err_file',$return = true);
					$this->set('logerrmessage',$errmessage);
					$this->databackup();
					exit();
				}
				$name=$file_name[0]['Backupdeletemark']['file_name'];
				$delete_data="DELETE FROM backupdeletemarks WHERE flag=".$flag." AND file_name='{$name}'";
				$delete_name=$name;

				$delete_path=$file_name[0]['Backupdeletemark']['backup_dir'];

				$msg=$this->deldir($delete_name,$delete_path);

				if(!empty($msg)){

					if($msg=="unlinkerr"){
						$errmessage=__('err_file',$return = true);
					}if($msg=="patherr"){

						$errmessage=__('err_path',$return = true);
					}
					//$this->Backupdeletemark->query($delete_data);
					//$this->set('logerrmessage',$errmessage);
					$this->databackup(13,$name);
					exit();
				}

			}
			$this->Backupdeletemark->query($delete_data);
		}
		//設定情報
		if($flag==2){
			//リストアボタンを押す
			if($id=='restore'){
				//リストアを行う
				$restoreing= $this->data_search(2,6);
				//リストアも存在する時

				if(!empty($restoreing)){
					$errmessage=__('set_restore_err',$return = true);
					$this->set('seterrmessage',$errmessage);
					$this->databackup();
					exit();
				}
				//保存先を取得する

				$flag_Backup=array("Backupdeletemark.flag =2","Backupdeletemark.work_end ='{$time}'");
				$backup_dir=$this->Backupdeletemark->findAll($flag_Backup,null,null,null,null,-1);
				$path=$backup_dir[0]['Backupdeletemark']['backup_dir'];
				$file_name=$backup_dir[0]['Backupdeletemark']['file_name'];
				$msg=false;
				$dh=opendir($path);
				while ($file=readdir($dh)) {
					$tempname = iconv('shift_jis','utf-8',$file);

					if($tempname==$file_name) {
						$msg=true;
					}
				}
				// $msg=$this->deldir($file_name,$path);
				if($msg==false){
					$this->databackup(12,$file_name);
					exit();
				}
				//リストアの設定

				$restore_data="INSERT INTO backupdeletemarks
     	   		 (flag,work_percent,table_name,set_month,work_start, work_time,set_year,state,backup_dir,file_size,file_name,work_end)
     	   		 VALUES({$flag},0,null,null,null,null,null,5,'{$path}',null,'{$file_name}','{$time}')";
				$this->Backupdeletemark->query($restore_data);
				$this->databackup(5,5);
				exit();

			}
			//中止する時

			if($id=='discont'){
				session_unregister('refresh');
				$flag_Backup=array('Backupdeletemark.flag =2 and (Backupdeletemark.state =1 or Backupdeletemark.state =0)');
				$work_percent=$this->Backupdeletemark->findAll($flag_Backup,array('Backupdeletemark.work_percent'),null,null,null,-1);
				if(count($work_percent)!=0){
					$delete_data="UPDATE backupdeletemarks SET state=3 WHERE (state=1 or state=0) and flag=".$flag;
					$this->Backupdeletemark->query($delete_data);
				}else{
					$errmessage=__('err_discont',$return = true);
					$this->set('seterrmessage',$errmessage);
					$this->databackup();
					exit();
				}
			}
			//削除する時

			if($id=='delete'){

				$flag_Backup=array("Backupdeletemark.flag =2","Backupdeletemark.work_end ='{$time}'");
				$file_name=$this->Backupdeletemark->findAll($flag_Backup,null,null,null,null,null);
				if(empty($file_name)){
					$errmessage=__('err_file',$return = true);
					$this->set('seterrmessage',$errmessage);
					$this->databackup();
					exit();
				}
				$delete_name=$file_name[0]['Backupdeletemark']['file_name'];
				$delete_path=$file_name[0]['Backupdeletemark']['backup_dir'];
				$msg=$this->deldir($delete_name,$delete_path);
				$delete_data="DELETE FROM backupdeletemarks WHERE flag=".$flag." AND work_end='{$time}'";
				//削除を失敗する時
				if(!empty($msg)){
					if($msg=="unlinkerr"){
						$errmessage=__('err_file',$return = true);
					}if($msg=="patherr"){

						$errmessage=__('err_path',$return = true);
					}
					//$this->Backupdeletemark->query($delete_data);
					//$this->set('seterrmessage',$errmessage);
					$this->databackup(12,$delete_name);
					exit();
				}

				$this->Backupdeletemark->query($delete_data);
			}

		}
		//$this->render('databackup');
		$this->databackup();
	}

	//yuanxiaojun start 2009/03/30 added for added for LV20-YB-004
	function index2(){
		$layout='system';
		$this->render('restorepath');
	}
	function execut2(){
		$layout='system';
		$file_path=$this->data['pfile']['path'];
		$f_name=$_FILES['upfile']['name'];
		$flag_value=$this->data['uplflag']['flag'];
		if(empty($file_path)){
			$errmessage=__('set_file',$return = true);
			$this->set('errmessage',$errmessage);
			$this->render('restorepath');
			exit();
		}
		$xxx=substr($f_name,-3);
		if($xxx !='dat'){
			$errmessage=__('err_file_set',$return = true);
			$this->set('errmessage',$errmessage);
			$this->render('restorepath');
			exit();
		}
		
		$pathdata=explode("\\",$file_path);

		$new_path=array();
		for ($i=0;$i<count($pathdata)-1;$i++){
			$new_path[]=$pathdata[$i];
		}
		$file_path=implode("\\",$new_path);
		$restoreing= $this->data_search(2,6);
		//リストアも存在する時
		if(!empty($restoreing)){
			$errmessage=__('set_restore_err',$return = true);
			$this->set('errmessage',$errmessage);
			$this->render('restorepath');
			exit();
		}
		if(!empty($file_path)&&!empty($f_name)&&$flag_value!=30){
			$restore_data="INSERT INTO backupdeletemarks
     	 		 (flag,work_percent,table_name,set_month,work_start, work_time,set_year,state,backup_dir,file_size,file_name,work_end)
     	  		VALUES(2,0,null,null,null,null,null,5,'{$file_path}',null,'{$f_name}',null)";
			$this->Backupdeletemark->query($restore_data);
		}
		$this->set('uplflag',30);
		$this->databackup2(5,5);
		// $this->render('restorepath');
		exit();

	}

	function databackup2($id=null,$idreset=null){

		$restore_flag=null;//リストアフラグ
		$work_percent=null;
		$flag=null;
		$restore_file=null;

		if(!empty($_SESSION['file_insert'])){
			$this->resetfile();
			$_SESSION['seterrmessage']=__('restore_over',$return = true);
			session_unregister('restore');
			session_unregister('file_insert');
			$id=null;
		}
		if($_SESSION['restore']==5){
			$err_set_message=null;
			$ini_array=null;
			$dir=RESTORE_FILE_PATH;
			//statusの存在をチェックする
			$dir_flag=false;
			while ($dir_flag==false) {
				$dh=opendir($dir);
				while ($file=readdir($dh)) {
					if($file=='status') {
						$file_dir=$dir."\\status";
						$ini_array = parse_ini_file($file_dir."\\status.ini",true);
						if(!empty($ini_array)){
							$dir_flag=true;
						}
					}
				}
				closedir($dh);

			}
			$state=null;
			if(!empty($ini_array)){
				foreach ($ini_array as $key=>$valuesdata){
					foreach ($valuesdata as $key=>$values){
						if(strtolower($key)=='state'){
							$state=strtolower($values);
						}

					}
				}
				
				if($state==7){//リストアが完成しました
					$_SESSION['file_insert']='file_insert';
					$restore_flag='reload';
					$errmessage=__('file_insert',$return = true);
				}
				if($state==8){//リストアを失敗する
					$err_set_message=__('err_restore',$return = true);
				}
				if($state==9){//バージョンerr
					$err_set_message=__('version_err',$return = true);
				}

				if($state==7||$state==8||$state==9){
					$file_dir=$dir."\\status";
					$dh=opendir($file_dir);
					while ($file=readdir($dh)) {

						if($file!='.'&&$file!='..') {
							unlink($file_dir.'\\'.$file);
						}
					}
					$id=null;
					closedir($dh);
					rmdir($file_dir);
				}
				session_unregister('restore');
				if($state==6){
					$dir_flag=false;
					$_SESSION['restore']=5;
				}

			}
			if($dir_flag==false){

				$errmessage=__('restoring',$return = true);
				$restore_flag='reload';
				$this->set('restore_flag',$restore_flag);
			}
			$_SESSION['seterrmessage']=$err_set_message;
			//$this->set('seterrmessage',$err_set_message);

		}
		if($id==5){
			$_SESSION['restore']=$id;
			$errmessage=__('restoring',$return = true);
			$restore_flag='reload';
			$this->set('restore_flag',$restore_flag);
		}

		$this->set('restore_flag',$restore_flag);
		$this->set('errmessage',$errmessage);
		if(empty($restore_flag)){
			
			$reset_path_flag='reset';
			$this->set('reset_path_flag',$reset_path_flag);
			
		}else{
			
		}
		$this->render('restorepath');	
		
	}
	//yuanxiaojun end 2009/03/30 added for added for LV20-YB-004
	/**
       * ZIPファイルをダウンロード    
       * yuanxiaojun
       * @param unknown_type $id
       * @param unknown_type $path
       */ 
	function deldir($id=null,$path=null) {
		$delete_name=$id;
		$delete_path=$path;
		$path_check=0;
		$msg=null;
		$dh=opendir($delete_path);
		while ($file=readdir($dh)) {
			$tempname = iconv('shift_jis','utf-8',$file);

			if($tempname==$delete_name) {
				$path_check=1;//ファイルを存在する
				$delete_name=iconv('utf-8','shift_jis',$tempname);
				$fullpath=$delete_path.'\\'.$delete_name;
				if(!unlink($fullpath)){
					$path_check=2;//削除を失敗しました。

				}

			}
		}
		closedir($dh);
		if($path_check==0){
			$msg="patherr";
		}
		if($path_check==2){
			$msg="unlinkerr";
		}
		return $msg;
	}

	/**
           * リセットの設定

           * yuanxiaojun
           */
	function resetfile() {

		$groupid=$this->_getUserGroup();

		$this->GenerateFiles->hook_by_group($groupid, array('account'));
		$this->GenerateFiles->hook_by_group($groupid, array('antivirus'));
		$this->GenerateFiles->hook_by_group($groupid, array('appli'));
		$this->GenerateFiles->hook_by_group($groupid, array('device'));
		$this->GenerateFiles->hook_by_group($groupid, array('filesearch'));
		$this->GenerateFiles->hook_by_group($groupid, array('group'));
		$this->GenerateFiles->hook_by_group($groupid, array('host'));
		$this->GenerateFiles->hook_by_group($groupid, array('mailsrv'));
		$this->GenerateFiles->hook_by_group($groupid, array('perfalert'));
		$this->GenerateFiles->hook_by_group($groupid, array('popup'));
		$this->GenerateFiles->hook_by_group($groupid, array('prints'));
		$this->GenerateFiles->hook_by_group($groupid, array('process'));
		$this->GenerateFiles->hook_by_group($groupid, array('pserver'));
		$this->GenerateFiles->hook_by_group($groupid, array('schedule'));
		$this->GenerateFiles->hook_by_group($groupid, array('service'));
		$this->GenerateFiles->hook_by_group($groupid, array('web'));

	}
	/**
           * ZIPファイルをダウンロード    
           * yuanxiaojun
           * @param unknown_type $p1
           * @param unknown_type $p2
           * @param unknown_type $orderby
           */ 
	function filedown(){
		//$down_file
		$down_file=$this->data['backup']['filename'];

		$file_name=$down_file;
		$loging_file=array("Backupdeletemark.flag =3","Backupdeletemark.file_name ='{$down_file}'");
		$loging_file_find=$this->Backupdeletemark->findAll($loging_file,null,null,null,null,null);
		//ファイル存在のチェック
		if(!empty($loging_file_find)){

			$file_name = $down_file;
			$file_dir = $loging_file_find[0]['Backupdeletemark']['backup_dir'];

			$path_check=true;
			$dh=opendir($file_dir);

			while ($file=readdir($dh)) {
				$tempname = iconv('shift_jis','utf-8',$file);
				if($tempname==$file_name) {
					$path_check=false;
				}
			}
			closedir($dh);
			if ($path_check==true) {
				$flag=null;
				$errmessage=__('err_file',$return = true);
				$this->set('flag',$flag);
				$this->set('backup_address',$backup_address);
				$_SESSION['errmessage']=$errmessage;

				$this->redirect('/system_monitor_databackups');
				exit();
			} //ZIPダウンロード
			else {
				$tempname = iconv('utf-8','shift_jis',$file_name);
				$filesize=filesize($file_dir.'\\'.$tempname);
				$fp = fopen($file_dir.'\\'.$tempname,'r');

				header("Content-type: application/zip");
				header("Accept-Ranges: bytes");
				header("Accept-Length: ".$filesize);
				header("Content-Disposition:   attachment;   filename=".$tempname);
				echo fread($fp,$filesize);
				fclose($fp);
				exit;
			}
		}
		$this->render('databackup');
	}
	/**
           * データを検索
           * yuanxiaojun
           * @param unknown_type $p1
           * @param unknown_type $p2
           * @param unknown_type $orderby
           */
	function data_search($p1=null,$p2=null,$orderby=null){
		//リストアフラグを設定する

		$set_search_flag=array("Backupdeletemark.flag ={$p1}","Backupdeletemark.state ={$p2}");
		//データを検索
		$search=$this->Backupdeletemark->findAll($set_search_flag,null,$orderby,null,null,null);
		return  $search;
	}

	/**
           * 年月日の設定




           * yuanxiaojun
           * @param unknown_type $time
           */
	function  component_time($time=null){
		//年を取得する

		$year=substr($time,0,4);
		//月を取得する
		$month=substr($time,4,2);
		//日を取得する

		$day=substr($time,6,2);
		//時を取得する

		$hour=substr($time,8,2);
		//分を取得する

		$minute=substr($time,10,2);
		//秒を取得する

		$second=substr($time,12,2);
		//完備している時間を構成します

		$time=$year.'-'.$month.'-'.$day.' '.$hour.':'.$minute.':'.$second;
		return  $time;
	}

	/**
           * ファイル保存先のチェック.
           * yuanxiaojun
           * @param unknown_type $address
           */
	function dir_check($address){

		$initaddress=__('not_assigned',$return = true);
		if(empty($address)||$address==$initaddress){
			$check_message='err_path';
		}
		else{
			if(!is_dir($address)){
				$check_message='err_path';
			}
		}
		return $check_message;
	}
	/**
           * 保存先を変更時のチェック.
           * yuanxiaojun
           * @param unknown_type $backup_address
           * @param unknown_type $time
           */
	function preservedchange($backup_address){
		if(empty($backup_address)){
			$this->data['Backupdeletemark']['backup_dir']=null;
			$errmessage=__('err_input',$return = true);
			$_SESSION['message']=$errmessage;
			$this->redirect('/system_monitor_folderchange');
			exit();
		}
		$input_address=split('[:.\]',trim($backup_address));
		foreach ($input_address as $values){
			if(!empty($values)){
				if(!ereg("^[a-zA-Z0-9]+$",$values)){
					$this->data['Backupdeletemark']['backup_dir']=null;
					$errmessage=__('err_input',$return = true);
					$_SESSION['message']=$errmessage;
					$this->redirect('/system_monitor_folderchange');
					exit();
				}
			}
		}
		if(!is_dir($backup_address)){
			$this->data['Backupdeletemark']['backup_dir']=null;
			$errmessage=__('err_path',$return = true);
			$_SESSION['message']=$errmessage;
			$this->redirect('/system_monitor_folderchange');
			exit();
		}else{
			$deletedir="delete from backupdirs";
			$this->Backupdir->query($deletedir);
			$insertdir="Insert into backupdirs(backup_dir)values('{$backup_address}')";
			$this->Backupdir->query($insertdir);
		}
	}

	/**
           * パーセンの表示をチェックする
           * yuanxiaojun
           * @param unknown_type $work_percent
           */
	function percent_check($work_percent=null){
		if($work_percent==00){
			$work_percent=0;
		}
		if($work_percent<10 &&($work_percent!=00)){
			$work_percent=substr($work_percent,1,1);
		}
		return $work_percent;
	}
}
?>