<?php
class SystemMonitorWorksController extends AppController
{    
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv','Form');  
    var $components = array ('Pagination', 'Lv','Check');
    var $uses=array('Group', 'Host','Hstlog','Rlthstgrp','Grpauth','Poll','Pollog','Rltuserauth','User','Configure','Validation');
    var $layout='system';
    function beforeFilter()
    {
    	parent::beforeFilter();
    	//Title::LVシステム管理/稼動モニター/LogVillageの稼動モニター
        $this->pageTitle =__('title',$return = true);
    	//$this->Configure->write('debug', 0);
    	//hide vars
	if(isset($_POST['forHideVar'])){
    		$this->set('forHideVar', $_POST['forHideVar']);
	}
	else if(isset($_POST['forHideVar1'])){
    		$this->set('forHideVar', $_POST['forHideVar1']);
	}
     }
    function index($f=null)
    {		
    	if($f==1){
    		$this->layout='ajax';
    	}
         $contro= $this->requestAction('/system_monitor_works/contro',array('return'));
	$this->set('contro',$contro); 
    }
    function contro()
    {
   	$this->layout='ajax';
   	$dt= date('Y-m-d',time());
         $criteria = array();
         $criteria1 = array();
         $criteria2 = array();
         $by_dt_err = array();    
         $start_date = $this->_dateTrans($this->data[0]['start_year'], $this->data[1]['start_month'], $this->data[2]['start_day']);
         if($start_date=='0000-00-00')  //initianize the $start_date
         {
          	$start_date= date('Y-m-d',time());
         }
    	if(empty($this->data[4]['enddate']))  //if the checkbox of the end date is not selected
    	{
			if(!empty($this->data[0]['start_year']) && !empty($this->data[1]['start_month']) && empty($this->data[2]['start_day']))  //<---monthで選択--->
			{
			$yearmonth = $this->data[0]['start_year']."-".$this->data[1]['start_month']."-01";
			//$criteria1[]="YEAR(Pollog.log_time)=".$this->data[0]['start_year']. " AND MONTH(Pollog.log_time)=".$this->data[1]['start_month']." ";
			//$criteria2[]="YEAR(Hstlog.log_time)=".$this->data[0]['start_year']. " AND MONTH(Hstlog.log_time)=".$this->data[1]['start_month']." ";
			$criteria1[]="Pollog.log_time BETWEEN '$yearmonth' and '$yearmonth' + INTERVAL 1 MONTH - INTERVAL 1 MICROSECOND";
			$criteria2[]="Hstlog.log_time BETWEEN '$yearmonth' and '$yearmonth' + INTERVAL 1 MONTH - INTERVAL 1 MICROSECOND";
			$criteria1['group by'] = 'Pollog__date,Pollog.status';
			$criteria2['group by'] = 'Hstlog__date,Hstlog.status';
			}
			else
			{
				 if(!checkdate( substr($start_date, 5, 2),  substr($start_date, 8, 2),  substr($start_date, 0, 4)))  //check the start date of 31/2 など
				   {
					$by_dt_err[] = __('start_err',$return = true);
				   }
				   else{
					//$criteria1[]="DATE(Pollog.log_time)= '$start_date' ";
					$criteria1[]="Pollog.log_time BETWEEN '$start_date' and '$start_date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
					//$criteria2[]="DATE(Hstlog.log_time)= '$start_date' ";
					$criteria2[]="Hstlog.log_time BETWEEN '$start_date' and '$start_date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
					$criteria1['group by'] = 'Pollog__date,Pollog.status';
					$criteria2['group by'] = 'Hstlog__date,Hstlog.status';
				   }
			 }
    	}
    	else  //if the checkbox of the end date is selected
    	{		
    	if($this->data[4]['enddate']==1){
    	   $end_date = $this->_dateTrans($this->data[5]['end_year'], $this->data[6]['end_month'], $this->data[7]['end_day']);
    	   if(!checkdate( substr($start_date, 5, 2),  substr($start_date, 8, 2),  substr($start_date, 0, 4)) || !checkdate($this->data[6]['end_month'], $this->data[7]['end_day'], $this->data[5]['end_year']) || ($start_date>$end_date))  //check the error message
            {
    	      if(!checkdate( substr($start_date, 5, 2),  substr($start_date, 8, 2),  substr($start_date, 0, 4)))
               {
         	  $by_dt_err[] = __('start_err',$return = true);
               }
    	      if(!checkdate($this->data[6]['end_month'], $this->data[7]['end_day'], $this->data[5]['end_year']))
               {
         	$by_dt_err[] = __('end_err',$return = true);
                }
    	      if($start_date>$end_date){
		   $by_dt_err[] = __('start_time',$return = true). '　＞　'.__('end_time',$return = true);
	       }
    	  }
	   else{  	    
			//$criteria1[]="DATE(Pollog.log_time)>= '$start_date' AND DATE(Pollog.log_time) <= '$end_date' ";
			//$criteria2[]="DATE(Hstlog.log_time)>= '$start_date' AND DATE(Hstlog.log_time) <= '$end_date' ";
			$criteria1[]="Pollog.log_time BETWEEN '$start_date' AND '$end_date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			$criteria2[]="Hstlog.log_time BETWEEN '$start_date' AND '$end_date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
			$criteria1['group by'] = 'Pollog__date,Pollog.status';
			$criteria2['group by'] = 'Hstlog__date,Hstlog.status';
    		}
    	}
	}
	if(!empty($by_dt_err)){ //if there is any error message
		$this->set('by_dt_err',$by_dt_err);
		$this->render('contro');
		exit;
	}
	$pager_criteria = $criteria1;  //$pager_criteria is for pagination
	$pager_criteria['group by'] = 'DATE(Pollog.log_time)';
	list($order,$limit,$page) = $this->Pagination->init($pager_criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/system_monitor_works/contro', 'modelClass'=>'Pollog', 'queryType' => array('function' => 'findAll')));
	$pager_data = $this->Pollog->findAll($pager_criteria,array('DATE(Pollog.log_time) as Pollog__date'), 'Pollog__date', $limit, $page, null);
	if($pager_data!=null){	
		$criteria1[]="DATE(Pollog.log_time)>= '{$pager_data[0]['Pollog']['date']}' AND DATE(Pollog.log_time) <= '{$pager_data[count($pager_data)-1]['Pollog']['date']}' ";
		//$data1 is for pollogs	
		$data1 = $this->Pollog->findAll($criteria1,array('DATE(Pollog.log_time) as Pollog__date' ,'Pollog.status'), 'Pollog__date,Pollog.status', null, null, null);
	}
	empty($data1)? $data1=array():$data1;
         $this->set('data1',$data1);
         //$data2 is for hstlogs      
	$data2 = $this->Hstlog->findAll($criteria2,array('DATE(Hstlog.log_time) as Hstlog__date' ,'Hstlog.status'), "Hstlog__date,Hstlog.status", null, null, null);	
	empty($data2)? $data2=array():$data2;
	 $this->set('data2',$data2);
 }
   function detail($date=null)
   {
	$this->layout='ajax';
	$this->set('date',$date);
	//pollogs info
	$contro1= $this->requestAction('/system_monitor_works/poll_detail/'.null."/".$date,array('return'));
	$this->set('contro1',$contro1);
	//hstlogs info
	$contro2= $this->requestAction('/system_monitor_works/pc_detail/'.null."/".$date,array('return'));
	$this->set('contro2',$contro2);
   }
   function poll_detail($type=null,$date=null)
   {
	$this->layout='ajax';
	$criteria1 = array();	
	//$criteria1[]="DATE(Pollog.log_time)= '$date' ";
	$criteria1[]="Pollog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
	$criteria1['GROUP BY'] = 'Pollog.poll_id,DATE(Pollog.log_time),Poll.poll_name';	
	$asso1 = array('Poll : polls' => array('Poll.id = Pollog.poll_id'));	
	list($order,$limit,$page) = $this->Pagination->init($criteria1,null,array('ajaxDivUpdate'=>'poll','url'=>"/system_monitor_works/poll_detail/0/{$date}", 'modelClass'=>'Pollog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso1),'ajaxFormId' => NULL, 'style' => 'ajax')); 
	$data1 = $this->Pollog->findByAsso($criteria1,array('Pollog.poll_id','DATE(Pollog.log_time) as Pollog__date','Poll.poll_name','max(Pollog.log_time) as Pollog__time'), 'Pollog.poll_id,Pollog__date,Poll.poll_name,Pollog__time', $limit, $page, $asso1);
	empty($data1)? $data1=array():$data1;
	$this->set('data1',$data1);
         //get status:all the pollog status of all the time of the day selected
	$criteria3 =array();
	//$criteria3[]="DATE(Pollog.log_time)= '$date' ";
	$criteria3[]="Pollog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
	$criteria3['GROUP BY'] = 'Pollog__date,Pollog.poll_id,Pollog.status';
	$data3 = $this->Pollog->findAll($criteria3,array('DATE(Pollog.log_time) as Pollog__date','Pollog.poll_id','Pollog.status'), 'Pollog__date,Pollog.poll_id,Pollog.status', null, null, null);
	empty($data3)? $data3=array():$data3;
         $this->set('data3',$data3);
	//get message:pollog messages of the last time of the day selected
	$criteria51 =array();
	//$criteria51[]="DATE(Pollog.log_time)= '$date' ";
	$criteria51[]="Pollog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
	$criteria51[]="Pollog.status != 0 AND Pollog.status != 3 ";
	$criteria51[]="length(trim(Pollog.message)) !=0 ";
	$criteria51['GROUP BY'] = 'Pollog__date,Pollog.poll_id';
	$data51 = $this->Pollog->findAll($criteria51,array('DATE(Pollog.log_time) as Pollog__date','Pollog.poll_id','max(Pollog.log_time) as Pollog__time'), 'Pollog__date,Pollog.poll_id', null, null, null);
	empty($data51)? $data51=array():$data51;	
	$condition52="(";
	$condition50="";
		$criteria52=array();
		$criteria52[]="1=1";
		if($data51!=array()){
		foreach ($data51 as $key => $output){
			$condition50.="( Pollog.poll_id = ".$output['Pollog']['poll_id']." AND ";
			$condition50.="Pollog.log_time = '".$output['Pollog']['time']."') OR ";			
		}
		if(!empty($condition50)){
                                  $condition52.=substr($condition50, 0, strlen($condition50)-3);
                                  $condition52.=")";
                                  $criteria52[]=$condition52;
		   	  }
	  $criteria52[]="Pollog.status != 0 AND Pollog.status != 3 ";
	  $criteria52[]="length(trim(Pollog.message)) !=0 ";
	  $criteria52['GROUP BY'] = 'Pollog__date,Pollog.poll_id,Pollog.message';		   	  
           $data52= $this->Pollog->findAll($criteria52,array('DATE(Pollog.log_time) as Pollog__date','Pollog.poll_id','Pollog.message','max(Pollog.log_time) as Pollog__time'), 'Pollog__date,Pollog.poll_id,Pollog.message', null, null, null);
		}	   	  
	empty($data52)? $data52=array():$data52;
	$this->set('data5',$data52);
	$this->set('date',$date);
	   if($type=='csv'){
	  	$this->csvdown($date,$this->data['Pollog']['poll_id']);exit;
	   }
	$this->render('poll_detail');	
   }
    function csvdown($date=null,$poll_id=null)
    {
        require_once( 'csv/DlFactory.php' );
        $criteria=array();
        //$criteria[]="DATE(Pollog.log_time)= '$date' ";
		$criteria[]="Pollog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";

		
        $criteria[]="Pollog.poll_id= $poll_id ";
        $criteria['GROUP BY'] = 'Poll.poll_name,Pollog.log_time,Pollog.status,Pollog.message';
        $asso = array('Poll : polls' => array('Poll.id = Pollog.poll_id'));
        $data = $this->Pollog->findByAsso($criteria,array('Poll.poll_name','Pollog.log_time','Pollog.status','Pollog.message'), 'Poll.poll_name,Pollog.log_time,Pollog.status,Pollog.message', null, null, $asso);
        //$i=0;
	//                           foreach ($data as $result){
	//                           	$data[$i]['Poll']['poll_name']='"'.$data[$i]['Poll']['poll_name'].'"';
	//                           	$data[$i]['Pollog']['log_time']='"'.$data[$i]['Pollog']['log_time'].'"';	                       
	//                           	$data[$i]['Pollog']['message']='"'.$data[$i]['Pollog']['message'].'"';	            
	//                           	$i++;
        //       }	
        $csv = DlFactory::create("system_monitor_works");
        $csv->sendCSVFile($data,$this->data,__('work_summary',$return = true));
    }
   function pc_detail($type=null,$date=null)
   {
	$this->layout='ajax';
	$criteria1 = array();	
	//$criteria1[]="DATE(Hstlog.log_time)= '$date' ";
	$criteria1[]="Hstlog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";
	$criteria1['GROUP BY'] = 'Hstlog.host_id,DATE(Hstlog.log_time),Host.host_name,Group.group_name';	
	$asso1 = array('Host : hosts' => array('Host.id = Hstlog.host_id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			 );
	list($order,$limit,$page) = $this->Pagination->init($criteria1,null,array('ajaxDivUpdate'=>'pc','url'=>"/system_monitor_works/pc_detail/0/{$date}", 'modelClass'=>'Hstlog', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso1),'ajaxFormId' => NULL, 'style' => 'ajax'));
	$data1 = $this->Hstlog->findByAsso($criteria1,array('Hstlog.host_id','DATE(Hstlog.log_time) as Hstlog__date','Host.host_name','Group.group_name','max(Hstlog.log_time) as Hstlog__time'), 'Hstlog.host_id,Hstlog__date,Host.host_name,Group.group_name,Hstlog__time', $limit, $page, $asso1);
	empty($data1)? $data1=array():$data1;
	$this->set('data1',$data1);
         //get status:all the hstlog status of all the time of all the day
	$criteria3 =array();
	//$criteria3[]="DATE(Hstlog.log_time)= '$date' ";
	$criteria3[]="Hstlog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";

	$criteria3['GROUP BY'] = 'Hstlog__date,Hstlog.host_id,Hstlog.status';
	$data3 = $this->Hstlog->findAll($criteria3,array('DATE(Hstlog.log_time) as Hstlog__date','Hstlog.host_id','Hstlog.status'), 'Hstlog__date,Hstlog.host_id,Hstlog.status', null, null, null);
	empty($data3)? $data3=array():$data3;
         $this->set('data3',$data3);
	//get message:hstlog messages of the last time of every day
	$criteria51 =array();
	//$criteria51[]="DATE(Hstlog.log_time)= '$date' ";
	$criteria51[]="Hstlog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";

	$criteria51[]="Hstlog.status != 0 AND Hstlog.status != 3 ";
	$criteria51[]="length(trim(Hstlog.message)) !=0 ";
	$criteria51['GROUP BY'] = 'Hstlog__date,Hstlog.host_id';
	$data51 = $this->Hstlog->findAll($criteria51,array('DATE(Hstlog.log_time) as Hstlog__date','Hstlog.host_id','max(Hstlog.log_time) as Hstlog__time'), 'Hstlog__date,Hstlog.host_id', null, null, null);
	empty($data51)? $data51=array():$data51;	
	$condition52="(";
	$condition50="";
		$criteria52=array();
		$criteria52[]="1=1";
		if($data51!=array()){
		foreach ($data51 as $key => $output){
			$condition50.="( Hstlog.host_id = ".$output['Hstlog']['host_id']." AND ";
			$condition50.="Hstlog.log_time = '".$output['Hstlog']['time']."') OR ";			
		}
		if(!empty($condition50)){
                                  $condition52.=substr($condition50, 0, strlen($condition50)-3);
                                  $condition52.=")";
                                  $criteria52[]=$condition52;
		   	  }
           $criteria52[]="Hstlog.status != 0 AND Hstlog.status != 3 ";
           $criteria52[]="length(trim(Hstlog.message)) !=0 ";
	  $criteria52['GROUP BY'] = 'Hstlog__date,Hstlog.host_id,Hstlog.message';		   	  
           $data52= $this->Hstlog->findAll($criteria52,array('DATE(Hstlog.log_time) as Hstlog__date','Hstlog.host_id','Hstlog.message','max(Hstlog.log_time) as Hstlog__time'), 'Hstlog__date,Hstlog.host_id,Hstlog.message', null, null, null);
		}	   	  
	empty($data52)? $data52=array():$data52;
	$this->set('data5',$data52);
	$this->set('date',$date);
	   if($type=='csv'){
	  	$this->csvdownpc($date,$this->data['Hstlog']['host_id']);exit;
	   }
	$this->render('pc_detail');	
   }
    function csvdownpc($date=null,$host_id=null)
    {
        require_once( 'csv/DlFactory.php' );
        $criteria=array();
        //$criteria[]="DATE(Hstlog.log_time)= '$date' ";
		$criteria[]="Hstlog.log_time BETWEEN '$date' and '$date' + INTERVAL 1 DAY - INTERVAL 1 MICROSECOND";

        $criteria[]="Hstlog.host_id= $host_id ";
        $criteria['GROUP BY'] = 'Host.host_name,Group.group_name,Hstlog.log_time,Hstlog.status,Hstlog.message';
        $asso = array('Host : hosts' => array('Host.id = Hstlog.host_id'),
			'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
			 );
        $data = $this->Hstlog->findByAsso($criteria,array('Host.host_name','Group.group_name','Hstlog.log_time','Hstlog.status','Hstlog.message'), 'Host.host_name,Group.group_name,Hstlog.log_time,Hstlog.status,Hstlog.message', $limit, $page, $asso);
        //$i=0;
	//                           foreach ($data as $result){
	//                           	$data[$i]['Host']['host_name']='"'.$data[$i]['Host']['host_name'].'"';
	//                           	$data[$i]['Group']['group_name']='"'.$data[$i]['Group']['group_name'].'"';
	//                           	$data[$i]['Hstlog']['log_time']='"'.$data[$i]['Hstlog']['log_time'].'"';	                       
	//                           	$data[$i]['Hstlog']['message']='"'.$data[$i]['Hstlog']['message'].'"';	            
	//                           	$i++;
        //       }	
        $csv = DlFactory::create("system_monitor_works_twos");
        $csv->sendCSVFile($data,$this->data,__('work_summary',$return = true));
    }
   function _dateTrans($year, $mon, $day)
   {
	return sprintf("%04d-%02d-%02d", $year, $mon, $day);
   }
}
 ?> 