<?php
class UseAppsController extends AppController
{
    var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
    var $components = array ('Pagination', 'Lv','Check');
    //var $uses=array('Astsfw','Group', 'Host','Rlthstgrp','Configure','Grpauth','Validation','Astsfw');
    var $uses=array('Group', 'Host','Rlthstgrp','Configure','Grpauth','Validation','Astsfw');
    var $layout='use';

    function beforeFilter()
    {
		parent::beforeFilter();
    	//$this->Configure->write('debug',0);
    	
	 	if(isset($_POST['forHideVar'])){
			//var_dump($_POST['forHideVar']);
	    	$this->set('forHideVar', $_POST['forHideVar']);
		}
		else if(isset($_POST['forHideVar1'])){
			//var_dump($_POST['forHideVar1']);
	    	$this->set('forHideVar', $_POST['forHideVar1']);
		}   

    } 
    
    function _getUserGroup_id(){
   		return $this->_getUserGroup();
	} 
    function index()
    {
    	 $title = __('menu_use',$return = true)."/".__('application_option',$return = true);   	 
    	 $this->pageTitle = $title;
    	 $group_id = $this->_getUserGroup_id();
    	 //echo "group_id =".$group_id ."<br>";
		 $glist = $this->Group->getChildrenByParent($group_id);
		 //ksort($glist);
		 $this->set('glist',$glist); 
		
	     //$contro= $this->requestAction("/use_apps/contro/",array('return'));
	     ///debug($contro);
		// $this->set('contro',$contro); 

    }
    
	function groupName($group_id)
	{
			$criteria=" Group.id=".$group_id." ";
			$group_n= $this->Group->findAll($criteria);
			$group_name = $group_n[0]["Group"]["group_name"];
			return $group_name;
			
	}  
   function contro($url=null,$domain=null,$type=null)
   {
   		$this->layout='ajax';
   		$dt= date('Y-m-d',time());
        $criteria = array();
        $by_kw = $this->Lv->operSearch();
    	$by_dt = $this->Lv->optionsDatetime();
         if(!empty($this->data['Host']['host_name']))
        {
            if(!$this->Check->checkAllHalf($this->data['Host']['host_name']))
            {
                 $hostname_error['Host/host_name']=__('E-00400',$return = true);
            }
             if(!$this->Validation->maxLength($this->data['Host']['host_name'],40))
            {
                 $hostname_error['Host/host_name']=__('E-00300',$return = true);
            }
        } 
         if(!empty($this->data['Astsfw']['software_name']))
        {
            if(!$this->Check->checkAllHalf($this->data['Astsfw']['software_name']))
            {
                 $application_error['Astsfw/software_name']=__('E-00400',$return = true);
            }
             if(!$this->Validation->maxLength($this->data['Astsfw']['software_name'],256))
            {
                 $application_error['Astsfw/software_name']=__('E-00300',$return = true);
            }
        } 
         	
          if(!empty($by_kw['error']) || !empty($by_dt['error'])||!empty($hostname_error['Host/host_name'])||!empty($application_error['Astsfw/software_name']))
    	{

      		empty($by_kw['error']) ? null : $this->set('by_kw_err',$by_kw['error']);
      		empty($by_dt['error']) ? null : $this->set('by_dt_err',$by_dt['error']);
      		empty($hostname_error['Host/host_name']) ? null : $this->set('hostname_error',$hostname_error);
      		empty($application_error['Astsfw/software_name']) ? null : $this->set('application_error',$application_error);
      		$this->render();
      		exit();
    	}

    	if(empty($by_dt) && empty($by_kw))
    	{
// **WQ   		$criteria[]="datepart(Astsfw.install_time)= '".$dt."'"; 
    		$criteria[]="datepart(Astsfw.install_time)= '".$dt."'"; 
    	}
    	else
    	{		
	    		empty($by_kw) ? null : $criteria[] = implode(' and ', $by_kw);
	    		empty($by_dt) ? null : $criteria[] = implode(' and ', $by_dt);
		}

	if(((isset($this->data['Astsfw']['domain']))&& ($url!='1')&&(empty($this->data['Astsfw']['url1']))&&(!isset($this->data['Astsfw']['url1'])))||(empty($_POST['notFirstVisit'])&& ($url!='1')&&(!isset($this->data['Astsfw']['url1']))))
	{ 
	 	$this->domain($criteria,$type);
	}
	else  
	{//echo "domain =".$domain."<br>";
		//wangs start 20080202
	    //$criteria[]=$url=='1'? $criteria[]="Astsfw.software_name='".urldecode($domain)."' " : null;
		$decoded = $this->Lv->url_param_decode2($domain);
	    $url=='1'? $criteria[]="lower(Astsfw.software_name)='".strtolower($this->Lv->spec_char_dbm($decoded))."' " : null;
        //wangs end 20080202
		$url=='1'? $this->set('forHideVar', $_POST['forHideVar']."&data%5BAstsfw%5D%5Bsoftware_name1%5D=$domain&data%5BAstsfw%5D%5Burl1%5D=1")  : null;
		if(!empty($this->data['Astsfw']['software_name1'])) {
			$decoded = $this->Lv->url_param_decode2($this->data['Astsfw']['software_name1']);//echo $decoded;
			//wangs start 20080202
			// $criteria[]="Astsfw.software_name='".$this->data['Astsfw']['software_name1']."' ";
			$criteria[]="lower(Astsfw.software_name)='".strtolower($this->Lv->spec_char_dbm($decoded))."' ";
			//wangs end 20080202
		}
		 //debug($criteria);
		$this->url($criteria,$type);
	}

   } 

 function csvdown($criteria,$type)
    {
        require_once( 'csv/DlFactory.php' );
        if($type == 1) {
			 	if(!isset($this->data["Astsfw"]["group"])||($this->data["Astsfw"]["group"] == 0)){
					$this_groups =$this->_getUserGroup_id();
				}else {
					$this_groups =$this->data["Astsfw"]["group"];
				}
				$this->data["Astsfw"]["group"] = $this->groupName($this_groups);
		 		$asso = array(
							'Host : hosts' => array('Astsfw.host_id = Host.id'), 
							'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
							'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
							 );
				$data = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','count(Astsfw.id) as Astsfw__con'), 'Astsfw.software_name',100000, 1, $asso);
		        //var_dump($data);
		        $csv = DlFactory::create("use_apps");
		        $csv->sendCSVFile($data,$this->data,__('application_view_history',$return = true));        
        }elseif($type == 2){
        		//$criteria["group by"] = "Astsfw.install_time, Group.group_name, Host.host_name, Astsfw.software_name";	
				$asso = array('Host : hosts' => array('Astsfw.host_id = Host.id'), 
												'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
												'Group : groups' => array('Group.id = Rlthstgrp.group_id'), 
												);
//WQ1008				$data = $this->Astsfw->findByAsso($criteria, array('Astsfw.id', 'Astsfw.install_time', 'Group.group_name','Host.host_name','Astsfw.software_name'), 'Astsfw.software_name', 100000, 1, $asso);
				$data = $this->Astsfw->findByAsso($criteria, array('Astsfw.install_time', 'Group.group_name','Host.host_name','Astsfw.software_name'), 'Astsfw.install_time', 100000, 1, $asso);
				$this_groups =$this->data["Astsfw"]["group"];
				$this->data["Astsfw"]["group"] = $this->groupName($this_groups);
		        $csv = DlFactory::create("use_app_twos");
		        $csv->sendCSVFile($data,$this->data, __('web_application_log',$return = true)); 

        }
        
        exit;    

    }
    
    
 function domain(& $criteria,$type=null)
   {
   	$this->layout='ajax';
	$this->set('criteria',$criteria); 
	$criteria['GROUP BY']='Astsfw.software_name';
	if((empty($_POST['forHideVar1']))&&(empty($_POST['forHideVar']))){
		$this->set('forHideVar', 'data%5Bdt_check%5D%5Bname%5D=Astsfw-install_time&data%5Bdt_check%5D%5Bstart_year%5D=' . date('Y') . '&data%5Bdt_check%5D%5Bstart_month%5D=' . date('m').'&data%5Bdt_check%5D%5Bstart_day%5D=' . date('d') .'&data%Astsfw%5D%5Bgroup%5D=0&data%5Bastsfw%5D%5Bdomain%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
	}

	$glist_group_id = $this->_getUserGroup_id();
	//debug($glist_group_id);
	if($this->data['Astsfw']['group']=='0')
	{
		$this->data['Astsfw']['group']=$glist_group_id;
	}
	if(!isset($this->data['Astsfw']['group'])){
		$this->data['Astsfw']['group'] = $glist_group_id;
	}
    $glist = $this->Grpauth->getChildrenByParent($this->data['Astsfw']['group']);
 
	$condition="";
	foreach($glist as $key => $value){
	    $condition.=$key.",";
	}
	$condition = substr($condition,0,-1);
	$criteria[]=" Group.id in (".$condition.") ";
	
	if($type=='csv1')
	{
			    $this->csvdown($criteria,1);exit();
	} 
		$asso = array(
					'Host : hosts' => array('Astsfw.host_id = Host.id'), 
					'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
					'Group : groups' => array('Group.id = Rlthstgrp.group_id'),
					 );
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'search','url'=>'/use_apps/contro', 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Astsfw.software_name')));
//**WQ		$data = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','count(Astsfw.id) as Astsfw__con'), $order, $limit, $page, $asso);
		$data = $this->Astsfw->findByAsso($criteria, array('Astsfw.software_name','count(distinct(Astsfw.host_id)) as Astsfw__con'), $order, $limit, $page, $asso);

		empty($data)? $data=array():$data;
	//}
		$this->set('data',$data);
		$this->render('domain');	    		    		
   }
   
function url(& $criteria,$type=null)
   {
   	$this->layout='ajax'; 
	    $this_groups =0;
	    $glist_group_id = $this->_getUserGroup_id();
		if(!isset($this->data["Astsfw"]["group"])||($this->data["Astsfw"]["group"] == 0)){
			$this_groups =$glist_group_id;
		}else {
			$this_groups =$this->data["Astsfw"]["group"];
		}
	    $glist = $this->Grpauth->getChildrenByParent($this_groups);    
		$condition="";
		foreach($glist as $key => $value){
		    $condition.=$key.",";
		}
		$condition = substr($condition,0,-1);
		$criteria[]=" Group.id in (".$condition.") ";

		$asso = array('Host : hosts' => array('Astsfw.host_id = Host.id'), 
										'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
										'Group : groups' => array('Group.id = Rlthstgrp.group_id'), 
										);
		//added by wzy		
		//?ータ重?のために						
		$criteria["group by"] = "Astsfw.install_time, Group.group_name, Host.host_name, Astsfw.software_name";		
		//end added by wzy
		list($order,$limit,$page) = $this->Pagination->init($criteria,null,array('ajaxDivUpdate'=>'search','url'=>'/use_apps/contro', 'modelClass'=>'Astsfw', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso),'sortBy' => $this->Lv->sortBy('Astsfw.install_time')));
		$data = $this->Astsfw->findByAsso($criteria, array('Astsfw.install_time', 'Group.group_name','Host.host_name','Astsfw.software_name'), $order, $limit, $page, $asso);
			if($type=='csv2')
			{
					    $this->csvdown($criteria,2);exit();
			}		
		empty($data)? $data=array():$data;
	
		$this->set('data',$data);
		$this->render('url');
   }
            
}
?>