<?php
/*********************************************************************
*@filename use_update_hotfixes_controller.php
*@description 
*@note
*@histories  rivision	author		date		comment
*			 1.0		xinw	    2008/11/11  modify for LV20R1-175
*            1.0        xushanning  2009/02/23  modify for LV20R1-231
********************************************************************/
class UseUpdateHotfixesController extends AppController{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');  
	var $components = array ('Pagination', 'Lv','Check');
	var $uses=array('Astose','Group', 'Host','Rlthstgrp','Hotfix','Hotfixtype','Usehfx','Configure','Validation','Grpauth','Asthrd','Temp');
	var $layout='use';
	function beforeFilter(){
		parent::beforeFilter();
	/*	$this->Configure->write('debug', 0);*/
		if(isset($_POST['forHideVar1'])){
	    		$this->set('forHideVar', $_POST['forHideVar1']);
		}
		else if(isset($_POST['forHideVar'])){
	    		$this->set('forHideVar', $_POST['forHideVar']);
		}
	}
	function common(){
		$group = $this->Group->getChildrenByParent($this->_getUserGroup());
		$this->set('group',$group); 
		
		/* add by chenjing 2007-9-10 */
		$hotfixtye = array();
		$hotfixtyenumber = $this->Hotfixtype->findAll(null,null,'Hotfixtype.hotfix_type_name',null,0,null);
		array_push($hotfixtye, __('all_show',true));
		$hotfixtypelen = count($hotfixtyenumber);
		for($i = 0; $i < $hotfixtypelen; $i++){
			array_push($hotfixtye, $hotfixtyenumber[$i]['Hotfixtype']['hotfix_type_name']);
		}
		$this->set('hotfixtype', $hotfixtye);
		/* end by chenjing	*/
		
		$hotfixcode = array();
		array_push($hotfixcode,  __('all_show',true));
		$hotfixcodenumber = $this->Hotfix->findAll(null,'distinct(Hotfix.hotfix_code)','Hotfix.hotfix_code',null,0,null);
		$hotfixcodelen = count($hotfixcodenumber);
		for($i = 0; $i < $hotfixcodelen; $i++){
			array_push($hotfixcode, $hotfixcodenumber[$i][0]['hotfix_code']);
		}
		$this->set('hotfixcode', $hotfixcode);
		
		$hotfixname = array();
		array_push($hotfixname,  __('all_show',true));
		$hotfixnamenumber = $this->Hotfix->findAll(null,'distinct(Hotfix.hotfix_name)','Hotfix.hotfix_name',null,0,null);
		$hotfixnamelen = count($hotfixnamenumber);
		for($i = 0; $i < $hotfixnamelen; $i++){
			array_push($hotfixname, $hotfixnamenumber[$i][0]['hotfix_name']);
		}
		$this->set('hotfixname', $hotfixname);	
	}
	function index(){
		$this->pageTitle =  __('menu_use',$return = true)."/". __('update_option',$return = true)."/". __('hotfix',$return = true);;
		$this->common();
//      $contro= $this->requestAction('/use_update_hotfixes/contro',array('return'));
//		$this->set('contro',$contro);
		$this->data['Host']['hostname_r']=1;

				
	} 
	function contro(){
   		$this->layout='ajax';
   		if(empty($_POST['forHideVar1']) && empty($_POST['forHideVar'])){
			$this->set('forHideVar', '0&data%5BGroup%5D%5Bgroup%5D=0&data%5BWeb%5D%5Burl%5D=0&data%5BWeb%5D%5Burl%5D=0&data%5BWeb%5D%5Burl%5D=0&data%5BWeb%5D%5Burl%5D=0&data%5BWeb%5D%5Burl%5D=0&data%5BWeb%5D%5Burl%5D=0&data%5BWeb%5D%5Bpname%5D=&data%5BHotfixtype%5D%5Bhotfixtype%5D=0&data%5BWeb%5D%5Bgroup%5D=0&data%5BHotfix%5D%5Bhotfixcode%5D=0&data%5BWeb%5D%5Bpaccount_r%5D=0&btn1=%E5%AE%9F%E8%A1%8C');
   		}
   		if(isset($_POST['forHideVar'])){
   			$this->set('forHideVar', $_POST['forHideVar']);
		}
        $this->search();
	}
	function search($depand=null){
		

	 //bulid temptable  
	    $feld="    		 id serial,         
						         host_id integer,						      
						         os_name varchar(128)  ";

        $resultOS = $this->Astose->query('CREATE TEMPORARY TABLE tempAstoses ('.$feld.')');
        
        
		if($resultOS === false){
			debug("CREATE TEMPORARY TABLE failed!", true);
		}            
            		
			$criteria_asso1=array("1=1"); 
            $group_id = $this->data['Group']['groupname'];
            if(isset($this->data['Group']['groupname'])){
//            	$criteria_asso1[]="Grpauth.org_grp_id=".$group_id." and Host.status != 0";
            	$criteria_asso1[]="Grpauth.org_grp_id=".$group_id." and Host.status != 1";
            }else{
//            	$criteria_asso1[]="Grpauth.org_grp_id=1 and Host.status != 0";
            	$criteria_asso1[]="Grpauth.org_grp_id=1 and Host.status != 1";
			}
            $asso1=  array(
            		'Grpauth :grpauths' => array('Rlthstgrp.group_id = Grpauth.group_id'), 
            		'Host : hosts' => array('Host.id = Rlthstgrp.host_id'), 
            		 );                      
            $criteria_asso1['GROUP BY']="Rlthstgrp.host_id";           
            $fields_hostId=array('Rlthstgrp.host_id');
            $Rlthstgrp_hostId = $this->Rlthstgrp->findByAsso($criteria_asso1,$fields_hostId,null, null,null,$asso1);            
/*debug($Rlthstgrp_hostId);*/
            
/*			$criteri_host[]="Group.id =".$group_id." and Host.status != 0";
			$criteria_host_app = array(
				     'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
				    'Group : groups' => array('Group.id = Rlthstgrp.group_id'), 
											);
			$criteria_host_id = $this->Host->findByAsso($criteri_host, array('Host.id'),'Host.id', $limit=null, $page=1, $criteria_host_app);	*/								
/*debug($criteria_host_id);*/
/*			$empty_status_id = array();
			if(count($criteria_host_id) > 0){
				foreach ($criteria_host_id as $v_h){
					$empty_status_id[]=$v_h['Host']['id'];
				}
			}
			debug($empty_status_id);*/
											
            $FULLAsthrdId = '';//OSID_host_id
            $FULLAsthrdIdArray = array();
            for($i=0;$i<count($Rlthstgrp_hostId);$i++)
		 {		
		    $criteria_hostId = array();
		    if(empty($Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id'])){continue;}
//		    $criteria_hostId[] = "Asthrd.host_id=".$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id']."";		    
//		    $log_time = $this->Asthrd->find($criteria_hostId,'MAX(Asthrd.log_time) AS Asthrd__log_time');
//		    if(empty($log_time['Asthrd']['log_time'])){continue;}
//		    
//            $Asthrd_id = $this->Asthrd->find("Asthrd.log_time='".$log_time['Asthrd']['log_time']."' and Asthrd.host_id=".$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id']."",'Asthrd.id');	
            $Asthrd_id = $this->Asthrd->find("Asthrd.host_id=".$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id']."",'Asthrd.id');
            if(empty($Asthrd_id['Asthrd']['id'])){continue;}	
     	    $os_name = $this->Astose->find("Astose.hardware_id=".$Asthrd_id['Asthrd']['id']."",'Astose.os_name');
	    		    
		    $insert = "INSERT INTO tempAstoses VALUES(null,
			    {$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id']}, 
			   '{$os_name['Astose']['os_name']}')";
		    	$this->Host->query($insert);
		    $FULLAsthrdId.=$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id'].",";
		    $FULLAsthrdIdArray[] =$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id'];
		 }
		 $FULLAsthrdId = substr($FULLAsthrdId,0,-1);
/*debug($FULLAsthrdId);
debug($FULLAsthrdIdArray);*/
		   //end bulid temptable 
		   
		  /*　最新情報の集り　$Usehfx_id　*/
		  $EMPTY_host_id ='';
		  $EMPTY_host_idArray = array();
		  for($i=0;$i<count($Rlthstgrp_hostId);$i++)
		 {		
			    $criteria_hostId1 = array();
			    if(empty($Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id'])){continue;}
			    $criteria_hostId1[] = "Usehfx.host_id=".$Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id']."";
			    $criteria_hostId1['GROUP BY'] = "Usehfx.host_id";	
			    	    	     
			    $Usehfx_install_time = $this->Usehfx->find($criteria_hostId1,'MAX(Usehfx.install_time) AS Usehfx__install_time,Usehfx.host_id');
			    
			     if(empty($Usehfx_install_time['Usehfx']['install_time'])){
			     		$EMPTY_host_id.= $Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id'].",";
			     		$EMPTY_host_idArray[] = $Rlthstgrp_hostId[$i]['Rlthstgrp']['host_id'];
			     		continue;
			     }		 
			    $Usehfx_ids[] = $this->Usehfx->find("Usehfx.install_time='".$Usehfx_install_time['Usehfx']['install_time']."' and Usehfx.host_id=".$Usehfx_install_time['Usehfx']['host_id']."");	
		     
		 }
		 $EMPTY_host_id = substr($EMPTY_host_id,0,-1);
/*debug($EMPTY_host_id);
debug($EMPTY_host_idArray);*/
		 $EMPTY_host_idArray_host = '';
		 if(!empty($FULLAsthrdIdArray)){
		 	 if(!empty($EMPTY_host_idArray)){
				 foreach ($FULLAsthrdIdArray as $v){
				 	 if(in_array($v,$EMPTY_host_idArray)){
				 	 	$EMPTY_host_idArray_host.=$v.",";
				 	 }
				 	
				 }
				 $EMPTY_host_idArray_host =  substr($EMPTY_host_idArray_host,0,-1);
		 	 }
		 }
/*debug($EMPTY_host_idArray_host);*/
		 if(!empty($Usehfx_ids)){
	        $Usehfx_id = "";
                          foreach ($Usehfx_ids as $v){ 
				                  $f =$v['Usehfx']['id'];
				                  if(empty($f)){continue;}
				                  		$Usehfx_id =$Usehfx_id.$f.",";
				                  }
				                  $Usehfx_id = substr($Usehfx_id, 0, strlen($Usehfx_id)-1);
		 }
		
		$errorMessage=array();

		$group = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$this->set('group',$group); 
		$hotfixtye = array();
		$hotfixtyenumber = $this->Hotfixtype->findAll(null,null,'Hotfixtype.hotfix_type_name',null,0,null);
		array_push($hotfixtye, __('all_show',true));
		$hotfixtypelen = count($hotfixtyenumber);
		for($i = 0; $i < $hotfixtypelen; $i++){
			array_push($hotfixtye, $hotfixtyenumber[$i]['Hotfixtype']['hotfix_type_name']);
		}
		$this->set('hotfixtype', $hotfixtye);

		$hotfixcode = array();
		array_push($hotfixcode,  __('all_show',true));
		$hotfixcodenumber = $this->Hotfix->findAll(null,'distinct(Hotfix.hotfix_code)','Hotfix.hotfix_code',null,0,null);
		$hotfixcodelen = count($hotfixcodenumber);
		for($i = 0; $i < $hotfixcodelen; $i++){
			array_push($hotfixcode, $hotfixcodenumber[$i][0]['hotfix_code']);
		}
		$this->set('hotfixcode', $hotfixcode);
		
		$hotfixname = array();
		array_push($hotfixname, __('all_show',true));
		$hotfixnamenumber = $this->Hotfix->findAll(null,'distinct(Hotfix.hotfix_name)','Hotfix.hotfix_name',null,0,null);
		$hotfixnamelen = count($hotfixnamenumber);
		for($i = 0; $i < $hotfixnamelen; $i++){
			array_push($hotfixname, $hotfixnamenumber[$i][0]['hotfix_name']);
		}
		$this->set('hotfixname', $hotfixname);
		
	   
         	$criteria=array();
       		$groupIndex   = $this->data['Group']['groupname']; 
 /*      		debug($groupIndex);*/
		    $glist = $this->Grpauth->getChildrenByParent($groupIndex);   
			$condition_g="";
			foreach($glist as $key => $value){
			    $condition_g.=$key.",";
			}
			$condition_g = substr($condition_g,0,-1);
       		if(isset($groupIndex)){
	        		$criteria[]="Group.id in (".$condition_g.")";
	        		$criteriaC[]="Group.id in (".$condition_g.")";	/*インストールしない*/	       			
       		}else{
	        		$criteria[]="Group.id in (".$condition_g.")";
	        		$criteriaC[]="Group.id in (".$condition_g.")";	/*インストールしない*/       			
       		}
       		if(isset($this->data['Host']['hostname'])){ 
        		$hostname   =   $this->data['Host']['hostname']; 
       		}   
        		$hostname_l   =   $this->data['Host']['hostname_l'];  	  
				$hostname_r  =   $this->data['Host']['hostname_r'];    

			$hotfixtype_r  = $this->data['Hotfixtype']['hotfixtype_r'];
						
			/* 内容で検索--WindowsUpdateを選択する */
			
			if(isset($this->data['Hotfix']['radio_type1'])){
				$radio_type1   = $this->data['Hotfix']['radio_type1'];
				$this->set('radio_type1',$radio_type1);
			}
			if(isset($this->data['Hotfix']['newcodename'])){
				$newcodenameIndex   = $this->data['Hotfix']['newcodename'];
			}
			if(isset($this->data['Usehfx']['writecodename_1'])){
				$writecodename_1  = $this->data['Usehfx']['writecodename_1'];
			}
						
			/* 文書番号で検索--WindowsUpdateを選択する */
			
			if(isset($this->data['Hotfix']['radio_type2'])){
				$radio_type2   = $this->data['Hotfix']['radio_type2'];
				$this->set('radio_type2',$radio_type2);
			}
		
			if(isset($this->data['Hotfix']['codename_r'])){
				$codename_r   = $this->data['Hotfix']['codename_r'];
			}
			if(isset($this->data['Usehfx']['writecodename_2'])){
				$writecodename_2  = $this->data['Usehfx']['writecodename_2'];
			}
			if(isset($this->data['Hotfix']['codename'])){
				$codenameIndex   = $this->data['Hotfix']['codename'];
			}
			

	//echo "page_flag =".$page_flag."<br>";		
			
			if(!empty($this->data['Usehfx']['install_r'])){
				$install_r   = $this->data['Usehfx']['install_r'];
			}
			if(isset($this->data['Usehfx']['departtime'])){    
				$departtime =  $this->data['Usehfx']['departtime'];
			}
			$departtime_r =  $this->data['Usehfx']['departtime_r'];
			
			if($hostname_l==1){
						if($hostname!=""&&$this->Check->checkAllHalf($hostname)&&$this->Validation->maxLength($hostname,40)){
							if($hostname_r==1){
									//wangs start 20080202
									//$criteria[]="Host.host_name like '%".$hostname."%'";
									//$criteriaC[] = "Host.host_name like '%".$hostname."%'";     /*インストールしない*/
									$criteria[]="lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like($hostname))."%'";
									$criteriaC[] = "lower(Host.host_name) like '%".strtolower($this->Lv->spec_char_like($hostname))."%'";
									//wangs end 20080202
					        }else{
					        		//wangs start 20080202
				            		//$criteria[]="Host.host_name='".$hostname."'";
				            		//$criteriaC[]="Host.host_name='".$hostname."'";	/*インストールしない*/	
				            		$criteria[]="lower(Host.host_name)='".strtolower($this->Lv->spec_char_dbm($hostname))."'";
				            		$criteriaC[]="lower(Host.host_name)='".strtolower($this->Lv->spec_char_dbm($hostname))."'";
				            		//wangs end 20080202	            		
					        }
						}else{
							if($this->Lv->is_empty($hostname)){
								$errorMessage['computer'][] = 'E-00100';	
							}
							if(!$this->Check->checkAllHalf($hostname)){
								$errorMessage['computer'][] = 'E-00400';	
							}
							if(!$this->Validation->maxLength($hostname,40)){
								$errorMessage['computer'][] = 'E-00300';	
							}
						}	
			}
			
			if(!isset($install_r)||$install_r==1){
				if($hotfixtype_r==1){
							if($codename_r==1){			
									if($radio_type2==1){
									   if($codenameIndex!=0){
									   	//wangs start 20080202
									   //$criteria[]="Usehfx.hotfix_code='". $hotfixcode[$codenameIndex]."'";
									   $criteria[]="lower(Usehfx.hotfix_code)='".strtolower($hotfixcode[$codenameIndex])."'";
									   //wangs end 20080202
									   }
									}
									if($radio_type2==2){						 						
									   if($writecodename_2!="" && $this->Check->checkAllHalf($writecodename_2) && $this->Validation->maxLength($writecodename_2,30)){
												//wangs start 20080202									
												//$criteria[] = "Usehfx.hotfix_code like '%".$writecodename_2."%'"; 
												$criteria[] = "lower(Usehfx.hotfix_code) like '%".strtolower($this->Lv->spec_char_like($writecodename_2))."%'"; 
												//wangs end 20080202     		
											}
											else{
													if($this->Lv->is_empty($writecodename_2)){
														$errorMessage['write'][] = 'E-00100';		
													}
													if(!$this->Check->checkAllHalf($writecodename_2)){
														$errorMessage['write'][] = 'E-00400';		
													}
													if(!$this->Validation->maxLength($writecodename_2,30)){
														$errorMessage['write'][] = 'E-00300';	
													}
								            } 						
									   }					
							}
							if($codename_r==0){					
									if($radio_type1==1){
									   if($newcodenameIndex!=0){
									   	//wangs start 20080202	 
										//$criteria[]="Hotfix.hotfix_name='". $hotfixname[$newcodenameIndex]."'";
										$criteria[]="lower(Hotfix.hotfix_name)='". strtolower($this->Lv->spec_char_dbm($hotfixname[$newcodenameIndex]))."'";
										//wangs end 20080202	
									   }
									}   
									if($radio_type1==2){					
									       if($writecodename_1!=""&&$this->Validation->maxLength($writecodename_1,900)){
												//wangs start 20080202									
												//$criteria[] = "Hotfix.hotfix_name  like '%".$writecodename_1."%'"; 
												$criteria[] = "lower(Hotfix.hotfix_name)  like '%".strtolower($this->Lv->spec_char_like($writecodename_1))."%'"; 
												//wangs end 20080202	    		
											}
											else{
													if($this->Lv->is_empty($writecodename_1)){
														$errorMessage['write'][] = 'E-00100';		
													}
													if(!$this->Validation->maxLength($writecodename_1,900)){
														$errorMessage['write'][] = 'E-00300';	
													}
								            } 						   
								    }					
							}
		
				  }
			}else{
			
					if($hotfixtype_r==1){//echo "111<br>";
							if($codename_r==1){
									$res_type_0y = '';
									if($radio_type2==1){
										  if($codenameIndex!=0){
										   		$criteriay[]="Usehfx.hotfix_code ='". $hotfixcode[$codenameIndex]."'";
										   		$res_type_Y = $this->Usehfx->findByAsso($criteriay,array('DISTINCT(Usehfx.host_id) as Usehfx__host_id'),'Usehfx.host_id', null, null, null);											
/*debug($res_type_Y);*/
												if(!empty($res_type_Y)){
														foreach ($res_type_Y as $vy){
															$res_type_0y.=$vy['Usehfx']['host_id'].",";
														}
														$res_type_0y = substr($res_type_0y,0,-1);	
														$criteria[]="Usehfx.host_id not in (".$res_type_0y.")";													
												}
										  }
									}
									if($radio_type2==2){						 
											if($writecodename_2!=""&&$this->Check->checkAllHalf($writecodename_2)&&$this->Validation->maxLength($writecodename_2,900)){			
														//wangs start 20080202
														//$criteriay[] = "Usehfx.hotfix_code like '%".$writecodename_2."%'"; 
														$criteriay[] = "lower(Usehfx.hotfix_code) like '%".strtolower($this->Lv->spec_char_like($writecodename_2))."%'"; 
												   		//wangs end 20080202
														$res_type_Y = $this->Usehfx->findByAsso($criteriay,array('DISTINCT(Usehfx.host_id) as Usehfx__host_id'),'Usehfx.host_id', null, null, null);											
/*debug($res_type_Y);*/
														if(!empty($res_type_Y)){
																foreach ($res_type_Y as $vy){
																	$res_type_0y.=$vy['Usehfx']['host_id'].",";
																}
																$res_type_0y = substr($res_type_0y,0,-1);
																$criteria[]="Usehfx.host_id not in (".$res_type_0y.")";													
														}
				     		
											}else{ 									
															if($this->Lv->is_empty($writecodename_2)){
																$errorMessage['write'][] = 'E-00100';		
															}
															if(!$this->Check->checkAllHalf($writecodename_2)){
																$errorMessage['write'][] = 'E-00400';		
															}
															if(!$this->Validation->maxLength($writecodename_2,30)){
																$errorMessage['write'][] = 'E-00300';	
															}
										    } 								
									}							
							}
							if($codename_r==0){
									$res_type_0y = '';
									if($radio_type1==1){
									    if($newcodenameIndex!=0){
												$asso_tempUsehfx0 = array(
													'Hotfix : hotfixes' => array('Usehfx.hotfix_code = Hotfix.hotfix_code'),
												);
												//wangs start 20080202
												//$criteriay[]="Hotfix.hotfix_name ='". $hotfixname[$newcodenameIndex]."'";
												$criteriay[]="lower(Hotfix.hotfix_name) ='". strtolower($this->Lv->spec_char_dbm($hotfixname[$newcodenameIndex]))."'";
										   		//wangs end 20080202
												$res_type_Y = $this->Usehfx->findByAsso($criteriay,array('DISTINCT(Usehfx.host_id) as Usehfx__host_id'),'Usehfx.host_id', null, null, $asso_tempUsehfx0);											
/*debug($res_type_Y);*/
												if(!empty($res_type_Y)){
														foreach ($res_type_Y as $vy){
															$res_type_0y.=$vy['Usehfx']['host_id'].",";
														}
														$res_type_0y = substr($res_type_0y,0,-1);
														$criteria[]="Usehfx.host_id not in (".$res_type_0y.")";													
												}
									    }  
									}
									if($radio_type1==2){								
										if($writecodename_1!=""&&$this->Validation->maxLength($writecodename_1,900)){
												$asso_tempUsehfx0 = array(
													'Hotfix : hotfixes' => array('Usehfx.hotfix_code = Hotfix.hotfix_code'),
												);
												//wangs start 20080202
												//$criteriay[]="(Hotfix.hotfix_name like '%".$writecodename_1."%' or Hotfix.hotfix_name is null)";
												$criteriay[]="(lower(Hotfix.hotfix_name) like '%".strtolower($this->Lv->spec_char_like($writecodename_1))."%' or Hotfix.hotfix_name is null)";
												//wangs end 20080202
										   		$res_type_Y = $this->Usehfx->findByAsso($criteriay,array('DISTINCT(Usehfx.host_id) as Usehfx__host_id'),'Usehfx.host_id', null, null, $asso_tempUsehfx0);											
/*debug($res_type_Y);*/
												if(!empty($res_type_Y)){
														foreach ($res_type_Y as $vy){
															$res_type_0y.=$vy['Usehfx']['host_id'].",";
														}
														$res_type_0y = substr($res_type_0y,0,-1);
														$criteria[]="Usehfx.host_id not in (".$res_type_0y.")";													
												}   									
										}else{ 									
												if($this->Lv->is_empty($writecodename_1)){
													$errorMessage['write'][] = 'E-00100';		
												}
												if(!$this->Validation->maxLength($writecodename_1,30)){
													$errorMessage['write'][] = 'E-00300';	
												}
								   		 }
									}		
						  	}
					}
			}
							
			if($departtime_r==1){
		  			if($departtime!=""&&$this->Validation->numeric($departtime)&&$this->Validation->maxLength($departtime,3)){
				  	        	$settime = mktime(date("h"),date("i"),date("s"),date("m"),(date("d")-round($departtime)),date("Y"));
				                  $gettime=date("Y/m/d", $settime);
				                  $criteria[]="DATEPART(Usehfx.install_time)<='".$gettime."'";	  				
		  			}else{ 
							if($this->Lv->is_empty($departtime)){
								$errorMessage['diff'][] = 'E-00100';
							}else if(!$this->Validation->numeric($departtime)){
								$errorMessage['diff'][] = 'E-00600';
							}
							if(!$this->Validation->maxLength($departtime,3)){
								$errorMessage['diff'][] = 'E-00300';
							}		  				
	  				}
			}
			
			/*  add by chenjing 2007-9-10 
			*  WindowsUpdate(HOTFIX)の種別を指定



			*/
			$condition_1 =array();
			if(isset($this->data['Hotfixtype']['newhotfixtype'])){
								
						if(!empty($this->data['Hotfixtype']['newhotfixtype'])){	
						   $condition_1[] = "1=1";
						   $condition_1[]="Hotfixtype.hotfix_type_name='". $hotfixtye[$this->data['Hotfixtype']['newhotfixtype']]."'";
							if(!isset($install_r)||$install_r==1){		
					                 $asso_tempUsehfx = array(
										'Hotfix : hotfixes' => array('Usehfx.hotfix_code = Hotfix.hotfix_code'),
										'Hotfixtype : hotfixtypes : left' => array('Hotfix.hotfix_type_id = Hotfixtype.id'),
									);
									$res_type = $this->Usehfx->findByAsso($condition_1,array('Usehfx.id'),'Usehfx.id', null, null, $asso_tempUsehfx);
									//debug($res_type);
									$res_type_0 = "";
									if(!empty($res_type)){
										foreach ($res_type as $v){
											$res_type_0.=$v['Usehfx']['id'].",";
										}
										$res_type_0 = substr($res_type_0,0,-1);
										$criteria[]="Usehfx.id in (".$res_type_0.")";

									}else{
											$criteria[] = "1=0";
									}
						   }else{ $res_type_0m ='';
					                 $asso_tempUsehfx = array(
										'Hotfix : hotfixes' => array('Usehfx.hotfix_code = Hotfix.hotfix_code'),
										'Hotfixtype : hotfixtypes : left' => array('Hotfix.hotfix_type_id = Hotfixtype.id'),
									);
									$res_type2 = $this->Usehfx->findByAsso($condition_1,array('DISTINCT(Usehfx.host_id) as Usehfx__host_id'),'Usehfx.host_id', null, null, $asso_tempUsehfx);
									if(!empty($res_type2)){
											foreach ($res_type2 as $vm){
												$res_type_0m.=$vm['Usehfx']['host_id'].",";
											}
											$res_type_0m = substr($res_type_0m,0,-1);
											$criteria[]="Usehfx.host_id not in (".$res_type_0m.")";																					
									}
									$condition_1 =array();
						   			$condition_1[] = "1=1";
						   			$condition_1[]="Hotfixtype.hotfix_type_name !='". $hotfixtye[$this->data['Hotfixtype']['newhotfixtype']]."'";							
							}
						}

			}
			/* end by chenjing  */
			
			//----------------------------



	/* すべて  $page_flag == 2 (詳細) ,$page_flag == 3 (最新)　*/	/* add by chenjing 2007-9-14 */		
	$page_flag_num = 0;	/*  適用されているPC場所  */
	$page_flag_num0 = 0;
			if(($this->data['Hotfixtype']['newhotfixtype_flag'] == 0)&&($this->data['Hotfixtype']['hotfixtype_r']==0)){//echo "111<Br>";
				$page_flag = 1;
				$page_flag_num0 = 1;
				$criteria[]="1=1";
			}elseif (($this->data['Hotfixtype']['newhotfixtype_flag'] ==1)&&($this->data['Hotfixtype']['hotfixtype_r'] == 0)){//echo "222<Br>";
				if(isset($install_r)&&$install_r==2){
					if($this->data['Hotfixtype']['newhotfixtype'] == 0){
						$page_flag =1;
						$page_flag_num = 1; 
					}else{
						$page_flag =1;
					}
				}else{
					$page_flag =3;
				}

			}elseif (($this->data['Hotfixtype']['newhotfixtype_flag'] == 0)&&($this->data['Hotfixtype']['hotfixtype_r'] ==1)){//echo "333<Br>";
				if(isset($install_r)&&$install_r==2){
					if(isset($this->data['Hotfix']['codename_r'])&&($this->data['Hotfix']['codename_r'] == 0)){
						if(isset($this->data['Hotfix']['newcodename'])&&($this->data['Hotfix']['newcodename'] == 0)){ //内容で検索
							$page_flag =1;
							$page_flag_num = 1; 
						}else{
							$page_flag =1;
						}
					}elseif(isset($this->data['Hotfix']['codename_r'])&&($this->data['Hotfix']['codename_r'] == 1)){
						if(isset($this->data['Hotfix']['codename'])&&($this->data['Hotfix']['codename'] == 0)){//文書番号で検索
							$page_flag =1;
							$page_flag_num = 1; 
						}else{
							$page_flag =1;
						}						
					}
				}else{
					$page_flag =3;
				}
			}elseif (($this->data['Hotfixtype']['newhotfixtype_flag'] == 1)&&($this->data['Hotfixtype']['hotfixtype_r'] == 1)){//echo "444<Br>";
					if(isset($install_r)&&$install_r==2){
							if($this->data['Hotfix']['codename_r'] == 0){//内容で検索
								if(($this->data['Hotfixtype']['newhotfixtype'] == 0)||(isset($this->data['Hotfix']['newcodename'])&&($this->data['Hotfix']['newcodename'] == 0))){ //内容で検索
									$page_flag =1;
									$page_flag_num = 1;     /*  適用されていないPC場所  */
								}else{
									$page_flag =1;
								}
							}elseif($this->data['Hotfix']['codename_r'] == 1){
								if(($this->data['Hotfixtype']['newhotfixtype'] == 0)||(isset($this->data['Hotfix']['codename'])&&($this->data['Hotfix']['codename'] == 0))){//文書番号で検索
									$page_flag =1;
									$page_flag_num = 1;     /*  適用されていないPC場所  */
								}else{
									$page_flag =1;
								}
							}
					}else{
						$page_flag =3;			
					}
			}
/*echo "page_flag =".$page_flag."<br>";*/


/*  TEMP TABLE START  */
			          $feld="    		 id serial,
			          						 host_id integer,
									         install_time timestamp,
									         group_name varchar(200),
									         host_name varchar(40),
									         os_name varchar(128),	      
									         hotfix_code varchar(30),
									         hotfix_name varchar(900)  ";
			
			        $resultOS = $this->Astose->query('CREATE TEMPORARY TABLE tempUsehfxs ('.$feld.')');
			        
			        
					if($resultOS === false){
						debug("CREATE tempUsehfxs TABLE failed!", true);
					} 
					
/*   TEMP TABLE END  */	/* add by chenjing 2007-9-10 */

					if($page_flag_num == 0){
							if(($page_flag == 1)&&($page_flag_num0 ==1)){
									if(!empty($Usehfx_id)){
										$criteria[]="Usehfx.id in (".$Usehfx_id.")";
									}
		/*$haha = $this->Host->findAll(array("1=1"));*/
							}
/*var_dump($criteria);echo "<BR>";
var_dump($condition_1);echo "<BR>";	*/				
			                $asso = array(
								'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
								'Group : groups' => array('Rlthstgrp.group_id = Group.id'), 
							    'TempAstose : tempAstoses : left' => array('Host.id = TempAstose.host_id'),
							    'Usehfx : usehfxs' => array('Host.id = Usehfx.host_id'),
							    //xushanning start 2009/02/23
								//modify for LV20R1-231
								//'Hotfix : hotfixes : left' => array('Usehfx.hotfix_code = Hotfix.hotfix_code'),
								'Hotfix : hotfixes : left' => array('substring(Usehfx.hotfix_code,1,6) = substring(Hotfix.hotfix_code ,1,6)'),
								//xushanning end 2009/02/23
							);
							if(empty($criteria)){
								$criteria[] = "1=1";
							}
							$criteria["group by"] = 'Host.id,Group.group_name,Host.host_name, TempAstose.os_name,Usehfx.hotfix_code,Hotfix.hotfix_name,Usehfx.install_time';
							$ff=array(
						          'Group.group_name',
						          'Host.host_name',
						          'Host.id',
						          'TempAstose.os_name',
						          'Usehfx.hotfix_code',
						          'Usehfx.install_time',
						          'Hotfix.hotfix_name'
				           );
		/*debug($criteria);*/
						$data = $this->Host->findByAsso($criteria,$ff,"Host.host_name", null, null, $asso);
						if(!empty($data)){
									foreach ($data as $value){
										 $insert = "INSERT INTO tempUsehfxs VALUES(null,
												    {$value['Host']['id']},
												    '{$value['Usehfx']['install_time']}',
												    '{$value['Group']['group_name']}',
												    '{$value['Host']['host_name']}',
												    '{$value['TempAstose']['os_name']}',
												    '{$value['Usehfx']['hotfix_code']}',
												    '{$value['Hotfix']['hotfix_name']}')";
												      $insert =  $this->Usehfx->query($insert);
						                
									}
						}				
				}
				
							
				if($page_flag == 1){
					                $asso_empty = array(
											'Rlthstgrp : rlthstgrps' => array('Host.id = Rlthstgrp.host_id'),
											'Group : groups' => array('Rlthstgrp.group_id = Group.id'), 
										    'TempAstose : tempAstoses : left' => array('Host.id = TempAstose.host_id'),
									);
							
/*							if(!empty($EMPTY_host_idArray_host)){
								$criteriaC[]="Host.id in (".$EMPTY_host_idArray_host.")";
							}else{
								$criteriaC[] = "1=0";
							}*/
							if(!empty($EMPTY_host_id)){
								$criteriaC[]="Host.id in (".$EMPTY_host_id.")";
							}else{
								$criteriaC[] = "1=0";
							}
							$criteriaC["group by"] = 'Host.id,Group.group_name,Host.host_name, TempAstose.os_name';
							$ffC=array(
						          'Group.group_name',
						          'Host.host_name',
						          'Host.id',
						          'TempAstose.os_name',
				           );
							$data_C = $this->Host->findByAsso($criteriaC,$ffC,"Host.host_name", null, null, $asso_empty);
/*debug($data_C);*/
/*var_dump($criteriaC);*/
							if(!empty($data_C)){
									foreach ($data_C as $value){
										 $insert_C = "INSERT INTO tempUsehfxs VALUES(null,
												    {$value['Host']['id']},
												    '2007-09-11 00:00:00',
												    '{$this->Lv->spec_char_dbm($value['Group']['group_name'])}',
												    '{$this->Lv->spec_char_dbm($value['Host']['host_name'])}',
												    '{$value['TempAstose']['os_name']}',
													'','')";
												       $insert =  $this->Usehfx->query($insert_C);
						                
									}							
							}
										
				}

				// temp table
				if(!empty($data)||(!empty($data_C))){
				
					 $this->Temp->useTable ="tempUsehfxs";
/*					 $ff_temp=array(
					  'Temp.install_time',
			          'Temp.group_name',
			          'Temp.host_name',
			          'Temp.os_name',
			          'Temp.hotfix_code',
			          'Temp.hotfix_name'
			          );
					 $Tempgg = $this->Temp->findByAsso(array('1=1'),$ff_temp,null, NULL, NULL, $asso=null);
debug($Tempgg);	*/		
				 	 $criteriaA[]="1=1" ;
				 	 //xinw start 20081111
				 	 //modify for LV20R1-175
				 	 //$criteriaA['GROUP BY']="Temp.host_name" ;
				 	 $criteriaA['GROUP BY']="Temp.host_name,Temp.host_id" ;
				 	 //xinw end 20081111	     
				 	 //xinw start 20081111
				 	 //modify for LV20R1-175    
			         //$cri0=array('MAX(Temp.install_time) AS Temp__install_time,Temp.host_name AS Temp__host_name'); 
			         $cri0=array('MAX(Temp.install_time) AS Temp__install_time,Temp.host_name AS Temp__host_name,Temp.host_id AS Temp__host_id');
			         //xinw end 20081111

					 $log_times_0 = $this->Temp->findByAsso($criteriaA,$cri0,null, NULL, NULL, $asso=null);
/*					 $haha = $this->Temp->findAll(array("1=1"));
					 debug($haha);*/
/*debug($log_times_0);*/
					 
					 if(!empty($log_times_0)){
							 $log_times_id = '';
							 foreach ($log_times_0 as $v){
								$criteriaB =array();
								//xinw start 20081111
				 	 			//modify for LV20R1-175
							 	 //$criteriaB[]="Temp.host_name ='".$v['Temp']['host_name']."' and Temp.install_time ='".$v['Temp']['install_time']."'";
							 	 $criteriaB[]="Temp.host_name ='".$this->Lv->spec_char_dbm($v['Temp']['host_name'])."' and Temp.install_time ='".$v['Temp']['install_time']."' and Temp.host_id =".$v['Temp']['host_id'];
							 	//xinw end 20081111
							 	 $log_times_1 = $this->Temp->findByAsso($criteriaB,array('Temp.id AS Temp__id'),null, NULL, NULL, $asso=null);
							 	 $log_times_id.=$log_times_1[0]['Temp']['id'].",";
								 
							 }
							 $log_times_id =substr($log_times_id,0,-1);
					 }
/*debug($log_times_id);*/				 
				 
					 $ff_temp=array(
					  'Temp.install_time',
			          'Temp.group_name',
			          'Temp.host_name',
			          'Temp.os_name',
			          'Temp.hotfix_code',
			          'Temp.hotfix_name'
			          );
			          
			            $criteriaTemp = array();
			            $criteriaTemp[] ="1=1";
			            if(!empty($log_times_id)){
			            	$criteriaTemp[] = "Temp.id in (".$log_times_id.")";
			            }
						list($order,$limit,$page) = $this->Pagination->init($criteriaTemp,null,array('ajaxDivUpdate'=>'view','url'=>'/use_update_hotfixes/contro', 'modelClass'=>'Temp', 'queryType' => array('function' => 'findByAsso', 'asso' => null), 'sortBy' => $this->Lv->sortBy('Temp.host_name')));
						$dataTemp = $this->Temp->findByAsso($criteriaTemp,$ff_temp,$order, $limit, $page, $asso=null);
						$dataTempCsv = $this->Temp->findByAsso($criteriaTemp,$ff_temp,$order, 10000, 1, $asso=null);
/*debug($dataTemp);*/
						empty($dataTemp)?$this->set('dataTemp',null):$this->set('dataTemp', $dataTemp);
					
			/*	}*/
				
								
				/* add by chenjing 2007-9-10 */
				$array_hotfixtype = array();
				/*debug($dataTemp);*/
				if(!empty($dataTemp)){
						foreach ($dataTemp as $indexdata){
					
							$hotfix_code_0 = $indexdata['Temp']['hotfix_code'];
							$condition_0 = $condition_1;
							//xushanning start 2009/02/23
							//modify for LV20R1-231
							//$condition_0[] = "Hotfix.hotfix_code ='".$hotfix_code_0."' ";
							$condition_0[] = "Hotfix.hotfix_code ='".substr($hotfix_code_0,0,6)."' ";
							//xushanning end 2009/02/23
							
							$asso_hptfix_type = array('Hotfixtype : hotfixtypes' => array('Hotfixtype.id = Hotfix.hotfix_type_id'), 
								);
/*debug($condition_0);*/
							$res_type = $this->Hotfix->findByAsso($condition_0, array('Hotfixtype.hotfix_type_name','Hotfixtype.id'),'Hotfixtype.hotfix_type_name', $limit=null, $page=null, $asso_hptfix_type);
							if(!empty($res_type)){
								foreach ($res_type as $indexdata0){
									//$array_hotfixtype[$indexdata['Temp']['hotfix_code']][$indexdata0['Hotfixtype']['id']] = $indexdata0['Hotfixtype']['hotfix_type_name'];
									$array_hotfixtype[$indexdata['Temp']['host_name']][$indexdata0['Hotfixtype']['id']] = $indexdata0['Hotfixtype']['hotfix_type_name'];
								}
							}else{
								$array_hotfixtype[$indexdata['Temp']['host_name']]['host_name'] = '';
							}
							$condition_0 = array();
						}
/*debug($array_hotfixtype)*/;					
						$this->set('array_hotfixtype',$array_hotfixtype);
				}
				
				
				$array_hotfixtypeCsv = array();
				if(!empty($dataTempCsv)){
						foreach ($dataTempCsv as $indexdata){
					
							$hotfix_code_0 = $indexdata['Temp']['hotfix_code'];
							$condition_0 = $condition_1;
							//xushanning start 2009/02/23
							//modify for LV20R1-231
							//$condition_0[] = "Hotfix.hotfix_code ='".$hotfix_code_0."' ";
							$condition_0[] = "Hotfix.hotfix_code ='".substr($hotfix_code_0,0,6)."' ";
							//xushanning end 2009/02/23
							
							$asso_hptfix_type_csv = array('Hotfixtype : hotfixtypes' => array('Hotfixtype.id = Hotfix.hotfix_type_id'), 
								);
/*debug($condition_0);*/
							$res_type_csv = $this->Hotfix->findByAsso($condition_0, array('Hotfixtype.hotfix_type_name','Hotfixtype.id'),'Hotfixtype.hotfix_type_name', $limit=null, $page=null, $asso_hptfix_type_csv);
							if(!empty($res_type_csv)){
								foreach ($res_type_csv as $indexdata0){
									$array_hotfixtypeCsv[$indexdata['Temp']['host_name']][$indexdata0['Hotfixtype']['id']] = $indexdata0['Hotfixtype']['hotfix_type_name'];
								}
							}else{
								$array_hotfixtypeCsv[$indexdata['Temp']['host_name']]['host_name'] = '';
							}
							$condition_0 = array();
						}
/*debug($array_hotfixtypeCsv)	;	*/			
						$this->set('array_hotfixtypeCsv',$array_hotfixtypeCsv);
				} 
		} 
		/* end  by chenjing */
		
		
		$csv_result=array();
		if(!empty($this->data['Group']['groupname'])){
			$group_id = $this->data['Group']['groupname'];
	        $groupname_csv=$this->Group->find(array("Group.id=$group_id"),'Group.group_name',null,null,null,-1);
		}
      
		!empty($groupname_csv['Group']['group_name'])?$csv_result['Group']['groupname']=$groupname_csv['Group']['group_name']:$csv_result['Group']['groupname']=null;
		if(isset($this->data['Host']['hostname'])){ 
	        $hostname = $this->data['Host']['hostname']; 
			!empty($hostname)?$csv_result['Host']['hostname']=$hostname:$csv_result['Host']['hostname']=null;
		}
		if(isset($this->data['Hotfixtype']['newhotfixtype'])){ 
	        $hosttype = $this->data['Hotfixtype']['newhotfixtype']; 
			isset($hosttype)?$csv_result['Hotfixtype']['newhotfixtype']=$hotfixtye[$this->data['Hotfixtype']['newhotfixtype']]:$csv_result['Hotfixtype']['newhotfixtype']=null;
		}			
		if(isset($this->data['Hotfix']['codename_r'])){
			$codename_r   = $this->data['Hotfix']['codename_r'];
			if($codename_r==0){$codename_t=__('hotfix_name',$return = true);}
			if($codename_r==1){$codename_t=__('hotfix_code',$return = true);}
			!empty($codename_t)?$csv_result['Hotfix']['codename_r']=$codename_t:$csv_result['Hotfix']['codename_r']=null;
		}
		if(isset($this->data['Hotfix']['newcodename'])){
			$newcodenameIndex   = $this->data['Hotfix']['newcodename'];
	
			isset($hotfixname[$newcodenameIndex])?$csv_result['Hotfix']['newcodename']=$hotfixname[$newcodenameIndex]:$csv_result['Hotfix']['newcodename']=null;
		}
		
		if(isset($this->data['Hotfix']['codename'])){
			$codenameIndex   = $this->data['Hotfix']['codename'];
	
			isset($hotfixcode[$codenameIndex])?$csv_result['Hotfix']['codename']=$hotfixcode[$codenameIndex]:$csv_result['Hotfix']['codename']=null;
		}		
		
		!empty($writecodename_1)?$csv_result['Usehfx']['writecodename_1']=$writecodename_1:$csv_result['Usehfx']['writecodename_1']=null;
		!empty($writecodename_2)?$csv_result['Usehfx']['writecodename_2']=$writecodename_2:$csv_result['Usehfx']['writecodename_2']=null;
		if(!empty($install_r)){
		$install_r   = $this->data['Usehfx']['install_r'];
		if($install_r==1){$install_t=__('yespc',$return = true);}
		if($install_r==2){$install_t=__('nopc',$return = true);}}
		!empty($install_r)?$csv_result['Usehfx']['install_r']=$install_t:$csv_result['Usehfx']['install_r']=null;
		!empty($departtime)?$csv_result['Usehfx']['departtime']=$departtime:$csv_result['Usehfx']['departtime']=null;

		
		if($depand=='csv'){
		   	$this->csvdown($dataTempCsv, $codename_r,$csv_result,$array_hotfixtypeCsv);exit;
		}

		empty($data)?$this->set('data',null):$this->set('data', $data);
		empty($getdata)?$this->set('getdata',null):$this->set('getdata', $getdata);	
		$this->set('errorMessage', $errorMessage);
		$this->set('page_flag',$page_flag);
		$this->render('search');
	}	
	function csvdown($us=null,$code=null,$csv_result_0=null,$csv_hotfix_type=null){
	
           require_once( 'csv/DlFactory.php' );
		   $csv = DlFactory::create("use_update_hotfixes");
	       $data=$us;
	       $codename=$code;
	       $csv_result=$csv_result_0;
	       
    	   if(!empty($data)) {
    	   		$i=0;
	    		$j = 0;
	    		//debug($data);
				foreach ($data as $indexdata){
				  $array_hotfixtype_res_0 = '';
				 if(!empty($data)) {
						$year=substr($indexdata['Temp']['install_time'],0,4);
						$month=substr($indexdata['Temp']['install_time'],5,2);
						$day=substr($indexdata['Temp']['install_time'],8,2);
						if(substr($day,0,1)=='0'){
							$day=substr($day,1,1);
						}
						if(substr($month,0,1)=='0'){
							$month=substr($month,1,1);
						}
						$nowtime=mktime(0,0,0,date('m'),date('d'),date('Y'));
						$gettime=mktime(0,0,0,$month,$day,$year);
						$difftime=($nowtime-$gettime)/(60*60*24);
						$data[$i++]['Temp']['diff']=$difftime;
				 }else{	
				 		$data[$i++]['Temp']['diff']=null;	
				 }
				 		/*  add by chenjing 2007-9-10 */
						if($indexdata['Temp']['hotfix_code'] == ''){
							$data[$j]['Temp']['install_time'] = '';
							$data[$j]['Temp']['hotfix_code'] = '';
							$data[$j]['Temp']['hotfix_name'] = '';
							$data[$j]['Temp']['diff'] = '';
						}
						
						
						if(!empty($csv_hotfix_type)){
							$array_hotfixtype_res = $csv_hotfix_type[$indexdata['Temp']['host_name']];				
							foreach ($array_hotfixtype_res as $v){
								$array_hotfixtype_res_0.= $v.";";
							}//echo "haha=".$array_hotfixtype_res_0."<br>";
							$array_hotfixtype_result = substr($array_hotfixtype_res_0,0,-1);
							$data[$j]['Hotfixtype']['hotfix_type_name'] = $array_hotfixtype_result;
						}else{
							$data[$j]['Hotfixtype']['hotfix_type_name'] =null;
						}
						$j++;
						/* end by chenjing  */
				}
		                               
		  }	 
/*debug($data);exit(); */
	 if($codename==0){
            $array_cols=array();	      
		        $array_cols = array(""=>__('search_list',true),//"□ 検索条件",
     									  "Group/groupname"=>__('group',true),//"グループ名を指定",
                                          "Host/hostname"=>__('computer',true), //"コンピュータ名を指定",
                                          "Hotfixtype/newhotfixtype"=>__('hotfix_type',true),//"WindowsUpdate(HOTFIX)の種別を指定",
				                          "Hotfix/codename_r"=>__('WindowsUpdate_search',true),//"WindowsUpdateの内容 or 文書番号で検索",   
                                          "Hotfix/newcodename"=>__('chenge',true),//"WindowsUpdateを選択する", 
                                          "Usehfx/writecodename_1"=>__('key_app',true),//"WindowsUpdateのキーワードを指定する", 
                                          "Usehfx/install_r"=>__('usepc_unusepc',true),//"適用されているPC/適用されていないPC",                                     
                                          "Usehfx/departtime"=>__('date_day',true),//"期間(日)" 
			       ); 
			       
			       			       
	 }	       
			       
	   elseif($codename==1){
	            $array_cols=array();	      
		        $array_cols = array(""=>__('search_list',true),//"□ 検索条件",
     									   "Group/groupname"=>__('group',true),//"グループ名を指定",
                                           "Host/hostname"=>__('computer',true), //"コンピュータ名を指定",
                                           "Hotfixtype/newhotfixtype"=>__('hotfix_type',true),//"WindowsUpdate(HOTFIX)の種別を指定",
				                           "Hotfix/codename_r"=>__('WindowsUpdate_search',true),//"WindowsUpdateの内容 or 文書番号で検索",
                                           "Hotfix/codename"=>__('chenge',true),//"WindowsUpdateを選択する",
                                           "Usehfx/writecodename_2"=>__('key_app',true),//"WindowsUpdateのキーワードを指定する", 
                                           "Usehfx/install_r"=>__('usepc_unusepc',true),//"適用されているPC/適用されていないPC",                                           
                                           "Usehfx/departtime"=>__('date_day',true),//"期間(日)" 
			       ); 
			       
	 }	 
	        $csv->special_search_title=$array_cols;
           	$csvName = __('host_PC_HOTFIX',true);
           	$csv->sendCSVFile($data,$csv_result,$csvName);
		}
          
}	
?>