<?php
/*
 * usage:
 *
 */
require_once( 'csv/CsvBase.php' );

class csv_oper_files extends CsvBase{
    public $special_cols = array("Optfile/file_time"=>"日付",
                                        "Group/group_name"=>"グループ名",
                                        "Host/host_name"=>"クライアントＰＣ",
                                        "Optfile/operation_type"=>"ステータス",
                                        "Optfile/file_name"=>"ファイル名",
                                        "Optfile/size"=>"サイズ",
                                        "Optfile/directory"=>"フォルダ名(すべて表示)",                                    		       
			       ); 
     public $special_search_title = array(
                                    "dt_check/start_year start_month start_day"=>"開始日", 
                                    "dt_check/end_year end_month end_day"=>"終了日", 
                                    "dt_check/start_hour start_min end_hour end_min"=>"一日毎の時間指定", 
                                    "dt_check/week"=>"曜日指定", 
                                    "Group/group_name"=>"グループ名",
                                    "Host/host_name"=>"コンピュータ名",  
                                    "Optfile/status_ck1 status_ck2 status_ck3 status_ck4 status_ck5 status_ck6"=>"ステータス", 
                                    "Optfile/filename_t"=>"ファイル名", 
                                    "Optfile/filesize_t filesize_s filesize_r"=>"ファイルサイズ", 
                                    "Optfile/extension_t"=>"拡張子", 			       
			       ); 
			       
	public $common_search_title1=array(
						"",
					"□ レポート", 
			                          );

  public function doSpeci($colname,$row){
   
  	
  	    if($colname=="Operfile/operation_type")
    {
        $keys=explode("/",$colname);        
        if($row[$keys[0]][$keys[1]]==1)
        {
            $row[$keys[0]][$keys[1]]="アプリケーション";
        }
        if($row[$keys[0]][$keys[1]]==2)
        {
            $row[$keys[0]][$keys[1]]="セキュリティ";
        }
        if($row[$keys[0]][$keys[1]]==3)
        {
            $row[$keys[0]][$keys[1]]="システム";
        }        
    } 		  		  	 	  	 
  	  	
  	
    if($colname=="Hstalt/alert_type_id")
    {
        $keys=explode("/",$colname);     
        
if($output['Optfile']['operation_type']==1)
{
$output['Optfile']['operation_type1'] = "作成 " ;
}
elseif($output['Optfile']['operation_type']==2)
{
$output['Optfile']['operation_type1'] = "更新" ;
}
elseif($output['Optfile']['operation_type']==3)
{
$output['Optfile']['operation_type1'] = "削除 " ;
}
elseif($output['Optfile']['operation_type']==4)
{
$output['Optfile']['operation_type1'] = "コピー" ;
}
elseif($output['Optfile']['operation_type']==5)
{
$output['Optfile']['operation_type1'] = "移動" ;
}
elseif($output['Optfile']['operation_type']==6)
{
$output['Optfile']['operation_type1'] = "リネーム" ;
}
else
{
$output['Optfile']['operation_type1'] = null;
}
           
        if($row[$keys[0]][$keys[1]]==1)
        {
            $row[$keys[0]][$keys[1]]="web操作";
        }
        if($row[$keys[0]][$keys[1]]==2)
        {
            $row[$keys[0]][$keys[1]]="印刷";
        }
        if($row[$keys[0]][$keys[1]]==3)
        {
            $row[$keys[0]][$keys[1]]="ログオンアカウント";
        }
        if($row[$keys[0]][$keys[1]]==4)
        {
            $row[$keys[0]][$keys[1]]="デバイス";
        }
        if($row[$keys[0]][$keys[1]]==5)
        {
            $row[$keys[0]][$keys[1]]="ファイル";
        }
        if($row[$keys[0]][$keys[1]]==6)
        {
            $row[$keys[0]][$keys[1]]="イベントログ";
        }
        if($row[$keys[0]][$keys[1]]==7)
        {
            $row[$keys[0]][$keys[1]]="サービス";
        }
        if($row[$keys[0]][$keys[1]]==8)
        {
            $row[$keys[0]][$keys[1]]="プロセス";
        }
        if($row[$keys[0]][$keys[1]]==9)
        {
            $row[$keys[0]][$keys[1]]="パターンファイル";
        }
        if($row[$keys[0]][$keys[1]]==10)
        {
            $row[$keys[0]][$keys[1]]="アプリケーション";
        }
    }
    return parent::doSpeci($colname,$row);
  }
}
?>