<?php
/*********************************************************************
*@filename .php
*@note
*@histories  rivision	author		date		comment

********************************************************************/
require_once( 'csv/CsvBase.php' );

class csv_uptime_masters extends CsvBase{

	public function getCsvTitle(){
		
		$this->special_cols['Employee/id_name']=__('employee_id',$retrun=true);
		$this->special_cols['Employee/name']=__('name',$retrun=true);
		$this->special_cols['Group/group_name']=__('group',$retrun=true);
		$this->special_cols['Host/host_name0']=__('computer_name',$retrun=true);
		$this->special_cols['Employeeaccount/account0']=__('account_name',$retrun=true);
		$this->special_cols['Host/host_name1']=__('computer_name',$retrun=true);
		$this->special_cols['Employeeaccount/account1']=__('account_name',$retrun=true);
		$this->special_cols['Host/host_name2']=__('computer_name',$retrun=true);
		$this->special_cols['Employeeaccount/account2']=__('account_name',$retrun=true);
		$this->special_cols['Employeeadacc/account']=__('domain_account',$retrun=true);
		$this->special_cols['Employee/enabledstr']=__('enable_column',$retrun=true);
		

		return parent::getCsvTitle();
	}
	
	public  function getSearchTitle(){
			/*$this->common_search_title1[0]=__('',$retrun=true);
			$this->common_search_title1[1]=__('report',$retrun=true);
			
			$this->special_search_title['']=__('search_con',$retrun=true);
			*/
			return parent::getSearchTitle();
	}

	
	public function doSpeci($colname,$row){
		$keys=explode("/",$colname);   
        if(isset($row[$keys[0]][$keys[1]]))
        {
            $row[$keys[0]][$keys[1]]= "\"".$row[$keys[0]][$keys[1]]."\"";
		}
		
		return parent::doSpeci($colname,$row);
	}		

}			       
?>