<?php
$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
//$body=preg_replace('/\\\/','\\\\\\', $csv_folder);
define( 'XML_FOLDER', $csv_folder);
        
//require_once("CsvBaseUtil.php");
class XmlBase {
  //共通コラム
 public $common_cols = array(
//			     "Group/id"=>"グループID",
			     "Group/group_name"=>"グループ名",
//			     "Useproc/host_id"=>"ホストID",
			     "Host/host_name"=>"クライアントPC名",
			     
			     );
 public $common_search_title=array(
                                    "dt_check/start_year start_month start_day"=>"開始日", 
                                    "dt_check/end_year end_month end_day"=>"終了日", 
                                    "dt_check/start_hour start_min end_hour end_min"=>"一日毎の時間指定", 
                                    "dt_check/week"=>"曜日指定", 
                                    
                                    );

// public $common_search_title1=array(array(),array("□ レポート"),
                                   
//                                    );
  public $sql="";

  public function convert($value){
    return mb_convert_encoding($value,"SJIS","UTF-8");
  }
  
  //データ取得

//  public function getData($type = 0){
//    $db = DB_Factory::create("acompany");
//    if(strlen(trim($this->sql))>0){
//      $sql = $this->getSql($this->sql);
//    }else{
//      $sql = $this->getSql($type);
//    }
//    $rows = $db->execute($sql);
//    if(count($this->data)>0)
//      {
//	$rows=$this->data;
//      }
//    
//    if(count($rows)>0)
//      {
//	for($i=0;$i<count($rows);$i++)
//	  {
//	    if(count($rows[$i])>0)
//	      {
//		foreach($rows[$i] as $key=>$value)
//		  {
//		    $rows[$i][$key]=mb_convert_encoding($value,"SJIS","UTF-8");
//		  }
//	      }
//	  }
//      }
//    return $rows;
//  }
  
  //CSVタイトル取得

  public function getCsvTitle(){

    $cols = array_merge($this->common_cols,$this->special_cols);
   
    foreach($cols as $key=>$value){	  
        $title[] = $this->set_str_encoding($value);
 //       $title[]=$value;
    }
       
    return $title;
  }
//検索条件の取得

    public function getSearchTitle()
    {
        $title = array_merge($this->common_search_title,$this->special_search_title);
		
        foreach($title as $key=>$value){	  
            $title[$key] = $this->set_str_encoding($value);
        }
        return $title;
    }
    public function getSearchWhere($info,$rows)
    {
        
        $title=$this->getSearchTitle();
//        return $title;exit;
//        echo "<pre>";
//        var_dump($title);exit;
        foreach ($title as $key=> $value)
        {
            if(strlen($key)==0)
            {
                $data[$key][]=$value;
            }else{
                $data[$key][]=$value;
                list($model,$name)=explode("/",$key);
                $keys=explode(" ",$name);
//                echo "<pre>";
//                var_dump($keys);
                if($keys[0]=="start_year"||$keys[0]=="end_year")
                {
                    $data[$key][]=$info[$model][$keys[0]]."/".$info[$model][$keys[1]]."/".$info[$model][$keys[2]];
                }elseif($keys[0]=="start_hour")
                {
                    $data[$key][]=$info[$model][$keys[0]].":".$info[$model][$keys[1]]."～".$info[$model][$keys[2]].":".$info[$model][$keys[3]];
                }else{
                    if($keys[0]=="group_name")
                    {
                        $data[$key][]=$rows[0]['Group']['group_name'];
                    }elseif($keys[0]=="week"){
//                        echo "<pre>";
//                        var_dump($info[$model]);exit;
                        for($i=0;$i<count($info[$model][$keys[0]]);$i++)
                        {
                            $week.=$this->getWeek($info[$model][$keys[0]][$i]).",";
                        }
                        $data[$key][]=$week;
                    }
                    else{
                        empty($info[$model][$keys[0]])?$data[$key][]="":$data[$key][]=$info[$model][$keys[0]];
                    }
                }
            }
        }
//        foreach($data as $k=>$v)
//        {
//            
//        }
//        echo "<pre>";
//        var_dump($data);exit;
        return $data;
        
    }
    public function getWeek($week)
    {
//        echo $week;exit;
        switch ($week)
        {
            case 'Monday':
                $result="月";
                break;
            case 'Tuesday':
                $result="火";
                break;
            case 'Wednesday':
                $result="水";
                break;
            case 'Thursday':
                $result="木";
                break; 
             case 'weekFriday':
                $result="金";
                break;
             case 'Saturday':
                $result="土";
                break;
             case 'Sunday':
                $result="日";
                break;
        }
        return $result;
    }
  //CSV COL 取得

  public function getCsvCol(){    
    
    foreach($this->common_cols as $key=> $value)
    {
        $colist = split(" ",$key);

        $newkey="";
        for($i=0;$i<count($colist);$i++)
        {
            $newkey.=$colist[$i];
        }
//        $newkey=substr($newkey,0,-1);
        $newarray[$newkey]=$value;

    }
    

    $cols = array_merge($newarray,$this->special_cols);

    foreach($cols as $key=>$value){
    	
        $collist[] = $key;
    }
	

    return $collist;
  }
  
  
 

  //各特別処理

    public function doSpeci($colname,$row){  
                   
        if(count($row)>0)
        {  
            $keys=explode("/",$colname);
            if(count($keys)> 1)
            {
                $key=$keys[0];
                if (array_key_exists($key,$row) && array_key_exists($keys[1],$row[$key])){  
                    
                    //	$str = spec_util($colname,$row[$colname]);
                    $str = $row[$key][$keys[1]];
//                    echo "<pre>";
//                    var_dump($row);exit;
                }else{
                    echo $colname." 処理未実装/Data 存在しない";
                    exit;    
//                    $colist = split(" ",$colname);
//                    //	$str = $colname; 
//                    $str="";
//                    foreach($colist as $col){
//                        if(array_key_exists($col,$row)){
//                        //modify by sunj 2007-1-17 19:41
//                        //	    $str=$str." ".str_replace($col,spec_util($col,$row[$col]),$str);
//                            $str=$str." ".str_replace($col,spec_util($col,$row[$col]),$col);
//                        }else{
//                            if ($col != "FLAG"){
//                              echo $col." 処理未実装/Data 存在しない";
//                              exit;      
//                            }
//                        }
//                    }
                }
          }else{
            $str="";
          }
        }else{
          $str="";
        }
        return $str;
  }

  //XMLファイルダウンロード

  public function sendXMLFile($rows,$info,$name){  
    require_once( 'csv/xml.php' );
    $searchList=$this->getSearchWhere($info,$rows);
//    echo "<pre>";
//    var_dump($searchList);exit;
        //象初始化 
        $xml = new xml(); 
        
        //允出行/ 
        $xml->setSpace(true); 
        
        ///* 置xml声明 */ 
        $d = &$xml->addDeclare('?xml'); 
        $d->setAttrib("version","1.0");
        $d->setAttrib("encoding","Shift_JIS");
        
        ///* 置xml文档 */ 
        $xml1 = &$xml->addElement($this->set_str_encoding("絞り込み条件")); 
        foreach($searchList as $key=>$value)
        {
            $xml1->addElement($value[0],$this->set_str_encoding($value[1])); 
        }
        $cols = $this->getCsvCol();
        
        $title=$this->getCsvTitle();
//        echo "<pre>";
//        var_dump($title);exit;
         foreach($rows as $row){  
            $data=array();    
            foreach($cols as $col){	
                 
    	        $data[] = trim($this->doSpeci($col,$row));	  
            }
            $xml2 = &$xml->addElement($this->set_str_encoding("データ")); 
             for($i=0;$i<count($title);$i++)
             {
                $xml2->addElement($title[$i],$this->set_str_encoding($data[$i]));
             }
        }

        $filename = substr(md5(time().rand(0,1000000)),0,30) . ".xml";
        $xml->tofile($filename); 
 
 
    //ファイルダウンロード BEGIN
    require_once( 'HTTP/Download.php' );
    $dfname = $this->set_str_encoding($name).date("Ymdhis",time()).".xml";
    $dl = &new HTTP_Download();
    $dl->setFile(XML_FOLDER.$filename);
    $dl->setContentDisposition(HTTP_DOWNLOAD_ATTACHMENT, $dfname);
    $dl->setContentType('application/ text/xml');
    $dl->send();
    //ファイルダウンロード END
    
    //一時ファイル削除
    foreach (glob(CSV_FOLDER."/*.*") as $filename)
    {
           unlink($filename);
    }
//    unlink('"'.XML_FOLDER.$filename.'"');
    exit;
  }
  
  
  //DIR 削除
  function remove_directory($dir) {
    if ($handle = opendir("$dir")) {
      while (false !== ($item = readdir($handle))) {
	if ($item != "." && $item != "..") {
	  if (is_dir("$dir/$item")) {
	    remove_directory("$dir/$item");
	  } else {
	    unlink("$dir/$item");
	  }
	}
      }
      closedir($handle);
      rmdir($dir);
    }
  }


  // 全角空白削除 BEGIN
  function removeJPBlank($str){
    $str = trim($str);
    $str = str_replace("　", "\t", $str);
    $str = trim($str,'\t');
    return trim($str);    
  }
   function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,"SJIS","UTF-8"); 
        return $result;
    } 
}

?>