<?php
class Group extends AppModel{
	var $name = "Group";
	var $primaryKey = "id";
	var $useTable = "groups";
	
 var $belongsTo = array(
        'Parentgroup' =>
            array('className' => 'Group',
                  'foreignKey' => 'parent_id',
        ),
     ); 
	var $hasMany = array(
		'Grpauth' => 
			array('className' => 'Grpauth',
				'foreignKey' => 'group_id',
				'dependent' => false,				//Grpauthの関連するデータがGroupと一緒にデリートされる  
				'exclusive' => true,
			),
	);
	
	/**
	 *  Get ForefatherId that the up_cast=0 by One  Group id
	 *
	 * @param int $group_id
	 * @return int  $id
	 **/	
	function  getFatherSet($group_id, & $model,$type){
        if($group_id !=null){
			if($group_id !=1){
				$group_father_i = $this->group_father_id($group_id);
				$grpalt_list_flag=$model->grpalt_list_flag($group_father_i,$type);
				if($grpalt_list_flag ==1) {
					$checkbox_flag =$model->getGrpalt_up_cast($group_father_i,$type);
					if($checkbox_flag == 1) {
						return $group_father_i;
					}else{ //echo "1<br>";
						$result = $this->getFatherSet($group_father_i, $model,$type);
						return $result;
						
					}
				}else{
					$id =0;
					return $id;
				}
			}else{
				$id =0;
				return $id;
			}
        }
	}
	/**
	 *  Get fatherId  by One  Group id
	 *
	 * @param int $group_id
	 * @return int $group_father_i
	 **/	
	function group_father_id($group_id){
		$criteria=" Group.id=".$group_id." ";
		$group_i= $this->findAll($criteria);
		$group_father_i = $group_i[0]["Group"]["parent_id"];
		return $group_father_i;
	}
	
	//$hide　このIDとその子供を表示しない
	function getChildrenByParent($root_id, $hide = null){
		$group = array();
		$root = $this->find("Group.id = " . $root_id, "Group.id, Group.group_name", null, 0);
		//debug($root);
		if(!empty($root)){
			$group[$root_id] = $root['Group']['group_name'];
			$this->aaa2($root_id, 1, $group, $hide);
			//debug($group);
		}
		return $group;
	}
	
	//再帰的に子供を探す
	function aaa2($parent_id, $level, &$grouplist, $hide = null){
		if($parent_id == $hide)
			return;
		$group = $this->findAll("Group.parent_id = " . $parent_id, "Group.id, Group.group_name", null, 0);
		
		if(!empty($group)){
			$p = "";
			for($i = 0; $i < $level; $i++)
				$p .= "　";
				
			$r = array();
			for($i = 0; $i < count($group); $i++){
				$id = $group[$i]['Group']['id'];//echo $group[$i]['Group']['group_name']."<br/>";
				if($id != $hide){
					$grouplist[$id] = $p.$group[$i]['Group']['group_name'];
					$this->aaa2($id, $level+1, $grouplist, $hide);
				}
			}
			
		}
	}

}
?>